#ifndef DOM_BINDINGNAMES_H_
#define DOM_BINDINGNAMES_H_

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioData = 335,
  AudioDecoder = 345,
  AudioDestinationNode = 358,
  AudioEncoder = 379,
  AudioListener = 392,
  AudioNode = 406,
  AudioParam = 416,
  AudioParamMap = 427,
  AudioProcessingEvent = 441,
  AudioScheduledSourceNode = 462,
  AudioTrack = 487,
  AudioTrackList = 498,
  AudioWorklet = 513,
  AudioWorkletGlobalScope = 526,
  AudioWorkletNode = 550,
  AudioWorkletProcessor = 567,
  AuthenticatorAssertionResponse = 589,
  AuthenticatorAttestationResponse = 620,
  AuthenticatorResponse = 653,
  BarProp = 675,
  BaseAudioContext = 683,
  BatteryManager = 700,
  BeforeUnloadEvent = 715,
  BiquadFilterNode = 733,
  Blob = 750,
  BlobEvent = 755,
  BroadcastChannel = 765,
  BrowsingContext = 782,
  BrowsingContextGroup = 798,
  ByteLengthQueuingStrategy = 819,
  CDATASection = 845,
  CSPViolationReportBody = 858,
  CSS = 881,
  CSS2Properties = 885,
  CSSAnimation = 900,
  CSSConditionRule = 913,
  CSSContainerRule = 930,
  CSSCounterStyleRule = 947,
  CSSCustomPropertyRegisteredEvent = 967,
  CSSFontFaceRule = 1000,
  CSSFontFeatureValuesRule = 1016,
  CSSFontPaletteValuesRule = 1041,
  CSSGroupingRule = 1066,
  CSSImportRule = 1082,
  CSSKeyframeRule = 1096,
  CSSKeyframesRule = 1112,
  CSSLayerBlockRule = 1129,
  CSSLayerStatementRule = 1147,
  CSSMarginRule = 1169,
  CSSMediaRule = 1183,
  CSSMozDocumentRule = 1196,
  CSSNamespaceRule = 1215,
  CSSNestedDeclarations = 1232,
  CSSPageDescriptors = 1254,
  CSSPageRule = 1273,
  CSSPositionTryDescriptors = 1285,
  CSSPositionTryRule = 1311,
  CSSPropertyRule = 1330,
  CSSPseudoElement = 1346,
  CSSRule = 1363,
  CSSRuleList = 1371,
  CSSScopeRule = 1383,
  CSSStartingStyleRule = 1396,
  CSSStyleDeclaration = 1417,
  CSSStyleRule = 1437,
  CSSStyleSheet = 1450,
  CSSSupportsRule = 1464,
  CSSTransition = 1480,
  Cache = 1494,
  CacheStorage = 1500,
  CallbackDebuggerNotification = 1513,
  CanonicalBrowsingContext = 1542,
  CanvasCaptureMediaStream = 1567,
  CanvasGradient = 1592,
  CanvasPattern = 1607,
  CanvasRenderingContext2D = 1621,
  CaretPosition = 1646,
  CaretStateChangedEvent = 1660,
  ChannelMergerNode = 1683,
  ChannelSplitterNode = 1701,
  ChannelWrapper = 1721,
  CharacterData = 1736,
  CheckerboardReportService = 1750,
  ChildProcessMessageManager = 1776,
  ChildSHistory = 1803,
  ChromeMessageBroadcaster = 1817,
  ChromeMessageSender = 1842,
  ChromeNodeList = 1862,
  ChromeUtils = 1877,
  ChromeWorker = 1889,
  Client = 1902,
  Clients = 1909,
  Clipboard = 1917,
  ClipboardEvent = 1927,
  ClipboardItem = 1942,
  ClonedErrorHolder = 1956,
  CloseEvent = 1974,
  CloseWatcher = 1985,
  CommandEvent = 1998,
  Comment = 2011,
  CompositionEvent = 2019,
  CompressionStream = 2036,
  ConsoleInstance = 2054,
  ConstantSourceNode = 2070,
  ContentFrameMessageManager = 2089,
  ContentProcessMessageManager = 2116,
  ContentVisibilityAutoStateChangeEvent = 2145,
  ConvolverNode = 2183,
  CookieChangeEvent = 2197,
  CookieStore = 2215,
  CountQueuingStrategy = 2227,
  CreateOfferRequest = 2248,
  Credential = 2267,
  CredentialsContainer = 2278,
  Crypto = 2299,
  CryptoKey = 2306,
  CustomElementRegistry = 2316,
  CustomEvent = 2338,
  CustomStateSet = 2350,
  DOMException = 2365,
  DOMImplementation = 2378,
  DOMLocalization = 2396,
  DOMMatrix = 2412,
  DOMMatrixReadOnly = 2422,
  DOMParser = 2440,
  DOMPoint = 2450,
  DOMPointReadOnly = 2459,
  DOMQuad = 2476,
  DOMRect = 2484,
  DOMRectList = 2492,
  DOMRectReadOnly = 2504,
  DOMStringList = 2520,
  DOMStringMap = 2534,
  DOMTokenList = 2547,
  DataTransfer = 2560,
  DataTransferItem = 2573,
  DataTransferItemList = 2590,
  DebuggerNotification = 2611,
  DebuggerNotificationObserver = 2632,
  DecompressionStream = 2661,
  DedicatedWorkerGlobalScope = 2681,
  DelayNode = 2708,
  DeprecationReportBody = 2718,
  DeviceAcceleration = 2740,
  DeviceLightEvent = 2759,
  DeviceMotionEvent = 2776,
  DeviceOrientationEvent = 2794,
  DeviceRotationRate = 2817,
  Directory = 2836,
  Document = 2846,
  DocumentFragment = 2855,
  DocumentL10n = 2872,
  DocumentTimeline = 2885,
  DocumentType = 2902,
  DominatorTree = 2915,
  DragEvent = 2929,
  DynamicsCompressorNode = 2939,
  EXT_blend_minmax = 2962,
  EXT_color_buffer_float = 2979,
  EXT_color_buffer_half_float = 3002,
  EXT_depth_clamp = 3030,
  EXT_disjoint_timer_query = 3046,
  EXT_float_blend = 3071,
  EXT_frag_depth = 3087,
  EXT_sRGB = 3102,
  EXT_shader_texture_lod = 3111,
  EXT_texture_compression_bptc = 3134,
  EXT_texture_compression_rgtc = 3163,
  EXT_texture_filter_anisotropic = 3192,
  EXT_texture_norm16 = 3223,
  Element = 3242,
  ElementInternals = 3250,
  EncodedAudioChunk = 3267,
  EncodedVideoChunk = 3285,
  ErrorEvent = 3303,
  Event = 3314,
  EventCallbackDebuggerNotification = 3320,
  EventCounts = 3354,
  EventSource = 3366,
  EventTarget = 3378,
  Exception = 3390,
  ExtendableEvent = 3400,
  ExtendableMessageEvent = 3416,
  ExtensionAlarms = 3439,
  ExtensionBrowser = 3455,
  ExtensionBrowserSettings = 3472,
  ExtensionBrowserSettingsColorManagement = 3497,
  ExtensionDns = 3537,
  ExtensionEventManager = 3550,
  ExtensionMockAPI = 3572,
  ExtensionPort = 3589,
  ExtensionProxy = 3603,
  ExtensionRuntime = 3618,
  ExtensionScripting = 3635,
  ExtensionSetting = 3654,
  ExtensionTest = 3671,
  External = 3685,
  FeaturePolicy = 3694,
  FeaturePolicyViolationReportBody = 3708,
  FetchEvent = 3741,
  FetchObserver = 3752,
  File = 3766,
  FileList = 3771,
  FileReader = 3780,
  FileReaderSync = 3791,
  FileSystem = 3806,
  FileSystemDirectoryEntry = 3817,
  FileSystemDirectoryHandle = 3842,
  FileSystemDirectoryHandle_AsyncIterator = 3868,
  FileSystemDirectoryIterator = 3908,
  FileSystemDirectoryReader = 3936,
  FileSystemEntry = 3962,
  FileSystemFileEntry = 3978,
  FileSystemFileHandle = 3998,
  FileSystemHandle = 4019,
  FileSystemSyncAccessHandle = 4036,
  FileSystemWritableFileStream = 4063,
  Flex = 4092,
  FlexItemValues = 4097,
  FlexLineValues = 4112,
  FluentBundle = 4127,
  FluentBundleAsyncIterator = 4140,
  FluentBundleIterator = 4166,
  FluentPattern = 4187,
  FluentResource = 4201,
  FocusEvent = 4216,
  FontFace = 4227,
  FontFaceSet = 4236,
  FontFaceSetIterator = 4248,
  FontFaceSetLoadEvent = 4268,
  FormData = 4289,
  FormData_Iterator = 4298,
  FormDataEvent = 4316,
  FragmentDirective = 4330,
  FrameCrashedEvent = 4348,
  FrameLoader = 4366,
  GPU = 4378,
  GPUAdapter = 4382,
  GPUAdapterInfo = 4393,
  GPUBindGroup = 4408,
  GPUBindGroupLayout = 4421,
  GPUBuffer = 4440,
  GPUBufferUsage = 4450,
  GPUCanvasContext = 4465,
  GPUColorWrite = 4482,
  GPUCommandBuffer = 4496,
  GPUCommandEncoder = 4513,
  GPUCompilationInfo = 4531,
  GPUCompilationMessage = 4550,
  GPUComputePassEncoder = 4572,
  GPUComputePipeline = 4594,
  GPUDevice = 4613,
  GPUDeviceLostInfo = 4623,
  GPUError = 4641,
  GPUInternalError = 4650,
  GPUMapMode = 4667,
  GPUOutOfMemoryError = 4678,
  GPUPipelineLayout = 4698,
  GPUQuerySet = 4716,
  GPUQueue = 4728,
  GPURenderBundle = 4737,
  GPURenderBundleEncoder = 4753,
  GPURenderPassEncoder = 4776,
  GPURenderPipeline = 4797,
  GPUSampler = 4815,
  GPUShaderModule = 4826,
  GPUShaderStage = 4842,
  GPUSupportedFeatures = 4857,
  GPUSupportedLimits = 4878,
  GPUTexture = 4897,
  GPUTextureUsage = 4908,
  GPUTextureView = 4924,
  GPUUncapturedErrorEvent = 4939,
  GPUValidationError = 4963,
  GainNode = 4982,
  Gamepad = 4991,
  GamepadAxisMoveEvent = 4999,
  GamepadButton = 5020,
  GamepadButtonEvent = 5034,
  GamepadEvent = 5053,
  GamepadHapticActuator = 5066,
  GamepadLightIndicator = 5088,
  GamepadPose = 5110,
  GamepadServiceTest = 5122,
  GamepadTouch = 5141,
  Geolocation = 5154,
  GeolocationCoordinates = 5166,
  GeolocationPosition = 5189,
  GeolocationPositionError = 5209,
  GetUserMediaRequest = 5234,
  GleanBoolean = 5254,
  GleanCategory = 5267,
  GleanCounter = 5281,
  GleanCustomDistribution = 5294,
  GleanDatetime = 5318,
  GleanDenominator = 5332,
  GleanEvent = 5349,
  GleanImpl = 5360,
  GleanLabeled = 5370,
  GleanMemoryDistribution = 5383,
  GleanMetric = 5407,
  GleanNumerator = 5419,
  GleanObject = 5434,
  GleanPingsImpl = 5446,
  GleanQuantity = 5461,
  GleanRate = 5475,
  GleanString = 5485,
  GleanStringList = 5497,
  GleanText = 5513,
  GleanTimespan = 5523,
  GleanTimingDistribution = 5537,
  GleanUrl = 5561,
  GleanUuid = 5570,
  Grid = 5580,
  GridArea = 5585,
  GridDimension = 5594,
  GridLine = 5608,
  GridLines = 5617,
  GridTrack = 5627,
  GridTracks = 5637,
  HTMLAllCollection = 5648,
  HTMLAnchorElement = 5666,
  HTMLAreaElement = 5684,
  HTMLAudioElement = 5700,
  HTMLBRElement = 5717,
  HTMLBaseElement = 5731,
  HTMLBodyElement = 5747,
  HTMLButtonElement = 5763,
  HTMLCanvasElement = 5781,
  HTMLCollection = 5799,
  HTMLDListElement = 5814,
  HTMLDataElement = 5831,
  HTMLDataListElement = 5847,
  HTMLDetailsElement = 5867,
  HTMLDialogElement = 5886,
  HTMLDirectoryElement = 5904,
  HTMLDivElement = 5925,
  HTMLDocument = 5940,
  HTMLElement = 5953,
  HTMLEmbedElement = 5965,
  HTMLFieldSetElement = 5982,
  HTMLFontElement = 6002,
  HTMLFormControlsCollection = 6018,
  HTMLFormElement = 6045,
  HTMLFrameElement = 6061,
  HTMLFrameSetElement = 6078,
  HTMLHRElement = 6098,
  HTMLHeadElement = 6112,
  HTMLHeadingElement = 6128,
  HTMLHtmlElement = 6147,
  HTMLIFrameElement = 6163,
  HTMLImageElement = 6181,
  HTMLInputElement = 6198,
  HTMLLIElement = 6215,
  HTMLLabelElement = 6229,
  HTMLLegendElement = 6246,
  HTMLLinkElement = 6264,
  HTMLMapElement = 6280,
  HTMLMarqueeElement = 6295,
  HTMLMediaElement = 6314,
  HTMLMenuElement = 6331,
  HTMLMetaElement = 6347,
  HTMLMeterElement = 6363,
  HTMLModElement = 6380,
  HTMLOListElement = 6395,
  HTMLObjectElement = 6412,
  HTMLOptGroupElement = 6430,
  HTMLOptionElement = 6450,
  HTMLOptionsCollection = 6468,
  HTMLOutputElement = 6490,
  HTMLParagraphElement = 6508,
  HTMLParamElement = 6529,
  HTMLPictureElement = 6546,
  HTMLPreElement = 6565,
  HTMLProgressElement = 6580,
  HTMLQuoteElement = 6600,
  HTMLScriptElement = 6617,
  HTMLSelectElement = 6635,
  HTMLSlotElement = 6653,
  HTMLSourceElement = 6669,
  HTMLSpanElement = 6687,
  HTMLStyleElement = 6703,
  HTMLTableCaptionElement = 6720,
  HTMLTableCellElement = 6744,
  HTMLTableColElement = 6765,
  HTMLTableElement = 6785,
  HTMLTableRowElement = 6802,
  HTMLTableSectionElement = 6822,
  HTMLTemplateElement = 6846,
  HTMLTextAreaElement = 6866,
  HTMLTimeElement = 6886,
  HTMLTitleElement = 6902,
  HTMLTrackElement = 6919,
  HTMLUListElement = 6936,
  HTMLUnknownElement = 6953,
  HTMLVideoElement = 6972,
  HashChangeEvent = 6989,
  Headers = 7005,
  Headers_Iterator = 7013,
  HeapSnapshot = 7030,
  Highlight = 7043,
  HighlightRegistry = 7053,
  History = 7071,
  IDBCursor = 7079,
  IDBCursorWithValue = 7089,
  IDBDatabase = 7108,
  IDBFactory = 7120,
  IDBIndex = 7131,
  IDBKeyRange = 7140,
  IDBObjectStore = 7152,
  IDBOpenDBRequest = 7167,
  IDBRequest = 7184,
  IDBTransaction = 7195,
  IDBVersionChangeEvent = 7210,
  IIRFilterNode = 7232,
  IOUtils = 7246,
  IdentityCredential = 7254,
  IdleDeadline = 7273,
  Image = 7286,
  ImageBitmap = 7292,
  ImageBitmapRenderingContext = 7304,
  ImageCapture = 7332,
  ImageCaptureError = 7345,
  ImageCaptureErrorEvent = 7363,
  ImageData = 7386,
  ImageDecoder = 7396,
  ImageDocument = 7409,
  ImageTrack = 7423,
  ImageTrackList = 7434,
  InputEvent = 7449,
  InspectorCSSParser = 7460,
  InspectorFontFace = 7479,
  InspectorUtils = 7497,
  InstallTriggerImpl = 7512,
  IntersectionObserver = 7531,
  IntersectionObserverEntry = 7552,
  IntlUtils = 7578,
  InvokeEvent = 7588,
  JSProcessActorChild = 7600,
  JSProcessActorParent = 7620,
  JSWindowActorChild = 7641,
  JSWindowActorParent = 7660,
  KeyEvent = 7680,
  KeyboardEvent = 7689,
  KeyframeEffect = 7703,
  L10nFileSource = 7718,
  L10nOverlays = 7733,
  L10nRegistry = 7746,
  LargestContentfulPaint = 7759,
  LegacyMozTCPSocket = 7782,
  Localization = 7801,
  Location = 7814,
  Lock = 7823,
  LockManager = 7828,
  MIDIAccess = 7840,
  MIDIConnectionEvent = 7851,
  MIDIInput = 7871,
  MIDIInputMap = 7881,
  MIDIMessageEvent = 7894,
  MIDIOutput = 7911,
  MIDIOutputMap = 7922,
  MIDIPort = 7936,
  MLS = 7945,
  MLSGroupView = 7949,
  MOZ_debug = 7962,
  MatchGlob = 7972,
  MatchPattern = 7982,
  MatchPatternSet = 7995,
  MathMLElement = 8011,
  MediaCapabilities = 8025,
  MediaControlService = 8043,
  MediaController = 8063,
  MediaDeviceInfo = 8079,
  MediaDevices = 8095,
  MediaElementAudioSourceNode = 8108,
  MediaEncryptedEvent = 8136,
  MediaError = 8156,
  MediaKeyError = 8167,
  MediaKeyMessageEvent = 8181,
  MediaKeySession = 8202,
  MediaKeyStatusMap = 8218,
  MediaKeyStatusMap_Iterator = 8236,
  MediaKeySystemAccess = 8263,
  MediaKeys = 8284,
  MediaList = 8294,
  MediaMetadata = 8304,
  MediaQueryList = 8318,
  MediaQueryListEvent = 8333,
  MediaRecorder = 8353,
  MediaRecorderErrorEvent = 8367,
  MediaSession = 8391,
  MediaSource = 8404,
  MediaStream = 8416,
  MediaStreamAudioDestinationNode = 8428,
  MediaStreamAudioSourceNode = 8460,
  MediaStreamError = 8487,
  MediaStreamEvent = 8504,
  MediaStreamTrack = 8521,
  MediaStreamTrackAudioSourceNode = 8538,
  MediaStreamTrackEvent = 8570,
  MerchantValidationEvent = 8592,
  MessageBroadcaster = 8616,
  MessageChannel = 8635,
  MessageEvent = 8650,
  MessageListenerManager = 8663,
  MessagePort = 8686,
  MessageSender = 8698,
  MimeType = 8712,
  MimeTypeArray = 8721,
  MouseEvent = 8735,
  MouseScrollEvent = 8746,
  MozCanvasPrintState = 8763,
  MozDocumentMatcher = 8783,
  MozDocumentObserver = 8802,
  MozQueryInterface = 8822,
  MozSharedMap = 8840,
  MozSharedMap_Iterator = 8853,
  MozSharedMapChangeEvent = 8875,
  MozStorageAsyncStatementParams = 8899,
  MozStorageStatementParams = 8930,
  MozStorageStatementRow = 8956,
  MozWritableSharedMap = 8979,
  MutationEvent = 9000,
  MutationObserver = 9014,
  MutationRecord = 9031,
  NamedNodeMap = 9046,
  NavigateEvent = 9059,
  Navigation = 9073,
  NavigationActivation = 9084,
  NavigationCurrentEntryChangeEvent = 9105,
  NavigationDestination = 9139,
  NavigationHistoryEntry = 9161,
  NavigationPreloadManager = 9184,
  NavigationTransition = 9209,
  Navigator = 9230,
  NetworkInformation = 9240,
  Node = 9259,
  NodeFilter = 9264,
  NodeIterator = 9275,
  NodeList = 9288,
  Notification = 9297,
  NotificationEvent = 9310,
  NotifyPaintEvent = 9328,
  OES_draw_buffers_indexed = 9345,
  OES_element_index_uint = 9370,
  OES_fbo_render_mipmap = 9393,
  OES_standard_derivatives = 9415,
  OES_texture_float = 9440,
  OES_texture_float_linear = 9458,
  OES_texture_half_float = 9483,
  OES_texture_half_float_linear = 9506,
  OES_vertex_array_object = 9536,
  OVR_multiview2 = 9560,
  OfflineAudioCompletionEvent = 9575,
  OfflineAudioContext = 9603,
  OffscreenCanvas = 9623,
  OffscreenCanvasRenderingContext2D = 9639,
  Option = 9673,
  OscillatorNode = 9680,
  PageTransitionEvent = 9695,
  PaintRequest = 9715,
  PaintRequestList = 9728,
  PaintWorkletGlobalScope = 9745,
  PannerNode = 9769,
  ParentProcessMessageManager = 9780,
  Path2D = 9808,
  PathUtils = 9815,
  PaymentAddress = 9825,
  PaymentMethodChangeEvent = 9840,
  PaymentRequest = 9865,
  PaymentRequestUpdateEvent = 9880,
  PaymentResponse = 9906,
  Performance = 9922,
  PerformanceEntry = 9934,
  PerformanceEntryEvent = 9951,
  PerformanceEventTiming = 9973,
  PerformanceMark = 9996,
  PerformanceMeasure = 10012,
  PerformanceNavigation = 10031,
  PerformanceNavigationTiming = 10053,
  PerformanceObserver = 10081,
  PerformanceObserverEntryList = 10101,
  PerformancePaintTiming = 10130,
  PerformanceResourceTiming = 10153,
  PerformanceServerTiming = 10179,
  PerformanceTiming = 10203,
  PeriodicWave = 10221,
  PermissionStatus = 10234,
  Permissions = 10251,
  PlacesBookmark = 10263,
  PlacesBookmarkAddition = 10278,
  PlacesBookmarkChanged = 10301,
  PlacesBookmarkGuid = 10323,
  PlacesBookmarkKeyword = 10342,
  PlacesBookmarkMoved = 10364,
  PlacesBookmarkRemoved = 10384,
  PlacesBookmarkTags = 10406,
  PlacesBookmarkTime = 10425,
  PlacesBookmarkTitle = 10444,
  PlacesBookmarkUrl = 10464,
  PlacesEvent = 10482,
  PlacesEventCounts = 10494,
  PlacesFavicon = 10512,
  PlacesHistoryCleared = 10526,
  PlacesObservers = 10547,
  PlacesPurgeCaches = 10563,
  PlacesRanking = 10581,
  PlacesVisit = 10595,
  PlacesVisitRemoved = 10607,
  PlacesVisitTitle = 10626,
  PlacesWeakCallbackWrapper = 10643,
  Plugin = 10669,
  PluginArray = 10676,
  PluginCrashedEvent = 10688,
  PointerEvent = 10707,
  PopStateEvent = 10720,
  PopupBlockedEvent = 10734,
  PopupPositionedEvent = 10752,
  PositionStateEvent = 10773,
  PrecompiledScript = 10792,
  PrivateAttribution = 10810,
  ProcessMessageManager = 10829,
  ProcessingInstruction = 10851,
  ProgressEvent = 10873,
  PromiseDebugging = 10887,
  PromiseNativeHandler = 10904,
  PromiseRejectionEvent = 10925,
  PublicKeyCredential = 10947,
  PushEvent = 10967,
  PushManager = 10977,
  PushManagerImpl = 10989,
  PushMessageData = 11005,
  PushSubscription = 11021,
  PushSubscriptionOptions = 11038,
  RadioNodeList = 11062,
  Range = 11076,
  ReadableByteStreamController = 11082,
  ReadableStream = 11111,
  ReadableStream_AsyncIterator = 11126,
  ReadableStreamBYOBReader = 11155,
  ReadableStreamBYOBRequest = 11180,
  ReadableStreamDefaultController = 11206,
  ReadableStreamDefaultReader = 11238,
  Report = 11266,
  ReportBody = 11273,
  ReportingObserver = 11284,
  Request = 11302,
  ResizeObserver = 11310,
  ResizeObserverEntry = 11325,
  ResizeObserverSize = 11345,
  Response = 11364,
  SVGAElement = 11373,
  SVGAngle = 11385,
  SVGAnimateElement = 11394,
  SVGAnimateMotionElement = 11412,
  SVGAnimateTransformElement = 11436,
  SVGAnimatedAngle = 11463,
  SVGAnimatedBoolean = 11480,
  SVGAnimatedEnumeration = 11499,
  SVGAnimatedInteger = 11522,
  SVGAnimatedLength = 11541,
  SVGAnimatedLengthList = 11559,
  SVGAnimatedNumber = 11581,
  SVGAnimatedNumberList = 11599,
  SVGAnimatedPreserveAspectRatio = 11621,
  SVGAnimatedRect = 11652,
  SVGAnimatedString = 11668,
  SVGAnimatedTransformList = 11686,
  SVGAnimationElement = 11711,
  SVGCircleElement = 11731,
  SVGClipPathElement = 11748,
  SVGComponentTransferFunctionElement = 11767,
  SVGDefsElement = 11803,
  SVGDescElement = 11818,
  SVGElement = 11833,
  SVGEllipseElement = 11844,
  SVGFEBlendElement = 11862,
  SVGFEColorMatrixElement = 11880,
  SVGFEComponentTransferElement = 11904,
  SVGFECompositeElement = 11934,
  SVGFEConvolveMatrixElement = 11956,
  SVGFEDiffuseLightingElement = 11983,
  SVGFEDisplacementMapElement = 12011,
  SVGFEDistantLightElement = 12039,
  SVGFEDropShadowElement = 12064,
  SVGFEFloodElement = 12087,
  SVGFEFuncAElement = 12105,
  SVGFEFuncBElement = 12123,
  SVGFEFuncGElement = 12141,
  SVGFEFuncRElement = 12159,
  SVGFEGaussianBlurElement = 12177,
  SVGFEImageElement = 12202,
  SVGFEMergeElement = 12220,
  SVGFEMergeNodeElement = 12238,
  SVGFEMorphologyElement = 12260,
  SVGFEOffsetElement = 12283,
  SVGFEPointLightElement = 12302,
  SVGFESpecularLightingElement = 12325,
  SVGFESpotLightElement = 12354,
  SVGFETileElement = 12376,
  SVGFETurbulenceElement = 12393,
  SVGFilterElement = 12416,
  SVGForeignObjectElement = 12433,
  SVGGElement = 12457,
  SVGGeometryElement = 12469,
  SVGGradientElement = 12488,
  SVGGraphicsElement = 12507,
  SVGImageElement = 12526,
  SVGLength = 12542,
  SVGLengthList = 12552,
  SVGLineElement = 12566,
  SVGLinearGradientElement = 12581,
  SVGMPathElement = 12606,
  SVGMarkerElement = 12622,
  SVGMaskElement = 12639,
  SVGMatrix = 12654,
  SVGMetadataElement = 12664,
  SVGNumber = 12683,
  SVGNumberList = 12693,
  SVGPathElement = 12707,
  SVGPatternElement = 12722,
  SVGPoint = 12740,
  SVGPointList = 12749,
  SVGPolygonElement = 12762,
  SVGPolylineElement = 12780,
  SVGPreserveAspectRatio = 12799,
  SVGRadialGradientElement = 12822,
  SVGRect = 12847,
  SVGRectElement = 12855,
  SVGSVGElement = 12870,
  SVGScriptElement = 12884,
  SVGSetElement = 12901,
  SVGStopElement = 12915,
  SVGStringList = 12930,
  SVGStyleElement = 12944,
  SVGSwitchElement = 12960,
  SVGSymbolElement = 12977,
  SVGTSpanElement = 12994,
  SVGTextContentElement = 13010,
  SVGTextElement = 13032,
  SVGTextPathElement = 13047,
  SVGTextPositioningElement = 13066,
  SVGTitleElement = 13092,
  SVGTransform = 13108,
  SVGTransformList = 13121,
  SVGUnitTypes = 13138,
  SVGUseElement = 13151,
  SVGViewElement = 13165,
  Sanitizer = 13180,
  Scheduler = 13190,
  Screen = 13200,
  ScreenLuminance = 13207,
  ScreenOrientation = 13223,
  ScriptProcessorNode = 13241,
  ScrollAreaEvent = 13261,
  ScrollViewChangeEvent = 13277,
  SecurityPolicyViolationEvent = 13299,
  Selection = 13328,
  ServiceWorker = 13338,
  ServiceWorkerContainer = 13352,
  ServiceWorkerGlobalScope = 13375,
  ServiceWorkerRegistration = 13400,
  SessionStoreFormData = 13426,
  SessionStoreScrollData = 13447,
  SessionStoreUtils = 13470,
  ShadowRealmGlobalScope = 13488,
  ShadowRoot = 13511,
  SharedWorker = 13522,
  SharedWorkerGlobalScope = 13535,
  SimpleGestureEvent = 13559,
  SourceBuffer = 13578,
  SourceBufferList = 13591,
  SpeechGrammar = 13608,
  SpeechGrammarList = 13622,
  SpeechRecognition = 13640,
  SpeechRecognitionAlternative = 13658,
  SpeechRecognitionError = 13687,
  SpeechRecognitionEvent = 13710,
  SpeechRecognitionResult = 13733,
  SpeechRecognitionResultList = 13757,
  SpeechSynthesis = 13785,
  SpeechSynthesisErrorEvent = 13801,
  SpeechSynthesisEvent = 13827,
  SpeechSynthesisUtterance = 13848,
  SpeechSynthesisVoice = 13873,
  StaticRange = 13894,
  StereoPannerNode = 13906,
  Storage = 13923,
  StorageEvent = 13931,
  StorageManager = 13944,
  StreamFilter = 13959,
  StreamFilterDataEvent = 13972,
  StructuredCloneHolder = 13994,
  StructuredCloneTester = 14016,
  StyleSheet = 14038,
  StyleSheetApplicableStateChangeEvent = 14049,
  StyleSheetList = 14086,
  StyleSheetRemovedEvent = 14101,
  SubmitEvent = 14124,
  SubtleCrypto = 14136,
  SyncMessageSender = 14149,
  SyncReadFile = 14167,
  TCPServerSocket = 14180,
  TCPServerSocketEvent = 14196,
  TCPSocket = 14217,
  TCPSocketErrorEvent = 14227,
  TCPSocketEvent = 14247,
  TaskController = 14262,
  TaskPriorityChangeEvent = 14277,
  TaskSignal = 14301,
  TelemetryStopwatch = 14312,
  TestUtils = 14331,
  TestingDeprecatedInterface = 14341,
  Text = 14368,
  TextClause = 14373,
  TextDecoder = 14384,
  TextDecoderStream = 14396,
  TextEncoder = 14414,
  TextEncoderStream = 14426,
  TextEvent = 14444,
  TextMetrics = 14454,
  TextTrack = 14466,
  TextTrackCue = 14476,
  TextTrackCueList = 14489,
  TextTrackList = 14506,
  TimeEvent = 14520,
  TimeRanges = 14530,
  ToggleEvent = 14541,
  Touch = 14553,
  TouchEvent = 14559,
  TouchList = 14570,
  TrackEvent = 14580,
  TransformStream = 14591,
  TransformStreamDefaultController = 14607,
  TransitionEvent = 14640,
  TreeColumn = 14656,
  TreeColumns = 14667,
  TreeContentView = 14679,
  TreeWalker = 14695,
  TrustedHTML = 14706,
  TrustedScript = 14718,
  TrustedScriptURL = 14732,
  TrustedTypePolicy = 14749,
  TrustedTypePolicyFactory = 14767,
  UDPMessageEvent = 14792,
  UDPSocket = 14808,
  UIEvent = 14818,
  URL = 14826,
  URLSearchParams = 14830,
  URLSearchParams_Iterator = 14846,
  UniFFIPointer = 14871,
  UniFFIScaffolding = 14885,
  UserActivation = 14903,
  UserInteraction = 14918,
  UserProximityEvent = 14934,
  VRDisplay = 14953,
  VRDisplayCapabilities = 14963,
  VRDisplayEvent = 14985,
  VREyeParameters = 15000,
  VRFieldOfView = 15016,
  VRFrameData = 15030,
  VRMockController = 15042,
  VRMockDisplay = 15059,
  VRPose = 15073,
  VRServiceTest = 15080,
  VRStageParameters = 15094,
  VTTCue = 15112,
  VTTRegion = 15119,
  ValidityState = 15129,
  VideoColorSpace = 15143,
  VideoDecoder = 15159,
  VideoEncoder = 15172,
  VideoFrame = 15185,
  VideoPlaybackQuality = 15196,
  VideoTrack = 15217,
  VideoTrackList = 15228,
  ViewTransition = 15243,
  VisualViewport = 15258,
  WEBGL_color_buffer_float = 15273,
  WEBGL_compressed_texture_astc = 15298,
  WEBGL_compressed_texture_etc = 15328,
  WEBGL_compressed_texture_etc1 = 15357,
  WEBGL_compressed_texture_pvrtc = 15387,
  WEBGL_compressed_texture_s3tc = 15418,
  WEBGL_compressed_texture_s3tc_srgb = 15448,
  WEBGL_debug_renderer_info = 15483,
  WEBGL_debug_shaders = 15509,
  WEBGL_depth_texture = 15529,
  WEBGL_draw_buffers = 15549,
  WEBGL_explicit_present = 15568,
  WEBGL_lose_context = 15591,
  WEBGL_provoking_vertex = 15610,
  WGSLLanguageFeatures = 15633,
  WakeLock = 15654,
  WakeLockSentinel = 15663,
  WaveShaperNode = 15680,
  WebExtensionContentScript = 15695,
  WebExtensionPolicy = 15721,
  WebGL2RenderingContext = 15740,
  WebGLActiveInfo = 15763,
  WebGLBuffer = 15779,
  WebGLContextEvent = 15791,
  WebGLFramebuffer = 15809,
  WebGLProgram = 15826,
  WebGLQuery = 15839,
  WebGLRenderbuffer = 15850,
  WebGLRenderingContext = 15868,
  WebGLSampler = 15890,
  WebGLShader = 15903,
  WebGLShaderPrecisionFormat = 15915,
  WebGLSync = 15942,
  WebGLTexture = 15952,
  WebGLTransformFeedback = 15965,
  WebGLUniformLocation = 15988,
  WebGLVertexArrayObject = 16009,
  WebKitCSSMatrix = 16032,
  WebSocket = 16048,
  WebTransport = 16058,
  WebTransportBidirectionalStream = 16071,
  WebTransportDatagramDuplexStream = 16103,
  WebTransportError = 16136,
  WebTransportReceiveStream = 16154,
  WebTransportSendStream = 16180,
  WheelEvent = 16203,
  Window = 16214,
  WindowClient = 16221,
  WindowContext = 16234,
  WindowGlobalChild = 16248,
  WindowGlobalParent = 16266,
  WindowRoot = 16285,
  Worker = 16296,
  WorkerDebuggerGlobalScope = 16303,
  WorkerGlobalScope = 16329,
  WorkerLocation = 16347,
  WorkerNavigator = 16362,
  WorkerTestUtils = 16378,
  Worklet = 16394,
  WorkletGlobalScope = 16402,
  WritableStream = 16421,
  WritableStreamDefaultController = 16436,
  WritableStreamDefaultWriter = 16468,
  XMLDocument = 16496,
  XMLHttpRequest = 16508,
  XMLHttpRequestEventTarget = 16523,
  XMLHttpRequestUpload = 16549,
  XMLSerializer = 16570,
  XPathEvaluator = 16584,
  XPathExpression = 16599,
  XPathResult = 16615,
  XRBoundedReferenceSpace = 16627,
  XRFrame = 16651,
  XRInputSource = 16659,
  XRInputSourceArray = 16673,
  XRInputSourceEvent = 16692,
  XRInputSourcesChangeEvent = 16711,
  XRPose = 16737,
  XRReferenceSpace = 16744,
  XRReferenceSpaceEvent = 16761,
  XRRenderState = 16783,
  XRRigidTransform = 16797,
  XRSession = 16814,
  XRSessionEvent = 16824,
  XRSpace = 16839,
  XRSystem = 16847,
  XRView = 16856,
  XRViewerPose = 16863,
  XRViewport = 16876,
  XRWebGLLayer = 16887,
  XSLTProcessor = 16900,
  XULCommandEvent = 16914,
  XULElement = 16930,
  XULFrameElement = 16941,
  XULMenuElement = 16957,
  XULPopupElement = 16972,
  XULResizerElement = 16988,
  XULTextElement = 17006,
  XULTreeElement = 17021,
  console = 17036,
  webkitSpeechGrammar = 17044,
  webkitSpeechGrammarList = 17064,
  webkitSpeechRecognition = 17088,
  webkitURL = 17112,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // DOM_BINDINGNAMES_H_
