// -*- mode: C++ -*-

/* This file is auto-generated by run_glean_parser.py.
   It is only for internal use by types in
   toolkit/components/glean/bindings/private */

#include "mozilla/AppShutdown.h"
#include "mozilla/ClearOnShutdown.h"
#include "mozilla/glean/bindings/GleanJSMetricsLookup.h"
#include "mozilla/glean/bindings/jog/JOG.h"
#include "mozilla/Maybe.h"
#include "mozilla/Telemetry.h"
#include "nsIThread.h"
#include "nsThreadUtils.h"

#ifndef mozilla_glean_ScalarGifftMap_h
#define mozilla_glean_ScalarGifftMap_h

#define DYNAMIC_METRIC_BIT (26)
#define GLEAN_METRIC_ID(id) ((id) & ((1ULL << 27) - 1))

namespace mozilla::glean {

using Telemetry::ScalarID;

static inline bool IsSubmetricId(uint32_t aId) {
  // Submetrics have the 2^25 bit set.
  // (ID_BITS - ID_SIGNAL_BITS, keep it in sync with js.py).
  return (aId & (1 << 25)) > 0;
}

static inline Maybe<ScalarID> ScalarIdForMetric(uint32_t aId) {
  switch(aId) {
    case 1: { // a11y.always_underline_links
      return Some(ScalarID::A11Y_ALWAYS_UNDERLINE_LINKS);
    }
    case 2: { // a11y.backplate
      return Some(ScalarID::A11Y_BACKPLATE);
    }
    case 3: { // a11y.hcm_background
      return Some(ScalarID::A11Y_HCM_BACKGROUND);
    }
    case 4: { // a11y.hcm_foreground
      return Some(ScalarID::A11Y_HCM_FOREGROUND);
    }
    case 5: { // a11y.instantiators
      return Some(ScalarID::A11Y_INSTANTIATORS);
    }
    case 6: { // a11y.invert_colors
      return Some(ScalarID::A11Y_INVERT_COLORS);
    }
    case 7: { // a11y.theme
      return Some(ScalarID::A11Y_THEME);
    }
    case 8: { // a11y.use_system_colors
      return Some(ScalarID::A11Y_USE_SYSTEM_COLORS);
    }
    case 9: { // browser.engagement.bookmarks_toolbar_bookmark_added
      return Some(ScalarID::BROWSER_ENGAGEMENT_BOOKMARKS_TOOLBAR_BOOKMARK_ADDED);
    }
    case 10: { // browser.engagement.bookmarks_toolbar_bookmark_opened
      return Some(ScalarID::BROWSER_ENGAGEMENT_BOOKMARKS_TOOLBAR_BOOKMARK_OPENED);
    }
    case 11: { // browser.engagement.sessionrestore_interstitial
      return Some(ScalarID::BROWSER_ENGAGEMENT_SESSIONRESTORE_INTERSTITIAL);
    }
    case 13: { // browser.engagement.tab_reload_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_TAB_RELOAD_COUNT);
    }
    case 14: { // browser.engagement.tab_unload_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_TAB_UNLOAD_COUNT);
    }
    case 15: { // browser.engagement.active_ticks
      return Some(ScalarID::BROWSER_ENGAGEMENT_ACTIVE_TICKS);
    }
    case 16: { // browser.engagement.max_concurrent_tab_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_MAX_CONCURRENT_TAB_COUNT);
    }
    case 17: { // browser.engagement.max_concurrent_tab_pinned_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_MAX_CONCURRENT_TAB_PINNED_COUNT);
    }
    case 18: { // browser.engagement.max_concurrent_vertical_tab_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_MAX_CONCURRENT_VERTICAL_TAB_COUNT);
    }
    case 19: { // browser.engagement.max_concurrent_vertical_tab_pinned_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_MAX_CONCURRENT_VERTICAL_TAB_PINNED_COUNT);
    }
    case 20: { // browser.engagement.max_concurrent_window_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_MAX_CONCURRENT_WINDOW_COUNT);
    }
    case 21: { // browser.engagement.profile_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_PROFILE_COUNT);
    }
    case 22: { // browser.engagement.tab_open_event_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_TAB_OPEN_EVENT_COUNT);
    }
    case 23: { // browser.engagement.tab_pinned_event_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_TAB_PINNED_EVENT_COUNT);
    }
    case 24: { // browser.engagement.unfiltered_uri_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_UNFILTERED_URI_COUNT);
    }
    case 25: { // browser.engagement.unique_domains_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_UNIQUE_DOMAINS_COUNT);
    }
    case 26: { // browser.engagement.uri_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_TOTAL_URI_COUNT_NORMAL_AND_PRIVATE_MODE);
    }
    case 27: { // browser.engagement.uri_count_normal_mode
      return Some(ScalarID::BROWSER_ENGAGEMENT_TOTAL_URI_COUNT);
    }
    case 28: { // browser.engagement.vertical_tab_open_event_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_VERTICAL_TAB_OPEN_EVENT_COUNT);
    }
    case 29: { // browser.engagement.vertical_tab_pinned_event_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_VERTICAL_TAB_PINNED_EVENT_COUNT);
    }
    case 30: { // browser.engagement.window_open_event_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_WINDOW_OPEN_EVENT_COUNT);
    }
    case 31: { // browser.engagement.session_time_excluding_suspend
      return Some(ScalarID::BROWSER_ENGAGEMENT_SESSION_TIME_EXCLUDING_SUSPEND);
    }
    case 32: { // browser.engagement.session_time_including_suspend
      return Some(ScalarID::BROWSER_ENGAGEMENT_SESSION_TIME_INCLUDING_SUSPEND);
    }
    case 33: { // networking.captive_portal_banner_display_time
      return Some(ScalarID::NETWORKING_CAPTIVE_PORTAL_BANNER_DISPLAY_TIME);
    }
    case 34: { // networking.captive_portal_banner_displayed
      return Some(ScalarID::NETWORKING_CAPTIVE_PORTAL_BANNER_DISPLAYED);
    }
    case 35: { // networking.doh_heuristic_ever_tripped
      return Some(ScalarID::NETWORKING_DOH_HEURISTIC_EVER_TRIPPED);
    }
    case 36: { // networking.doh_heuristics_attempts
      return Some(ScalarID::NETWORKING_DOH_HEURISTICS_ATTEMPTS);
    }
    case 37: { // networking.doh_heuristics_pass_count
      return Some(ScalarID::NETWORKING_DOH_HEURISTICS_PASS_COUNT);
    }
    case 38: { // networking.doh_heuristics_result
      return Some(ScalarID::NETWORKING_DOH_HEURISTICS_RESULT);
    }
    case 136: { // networking.speculative_connect_outcome
      return Some(ScalarID::NETWORKING_SPECULATIVE_CONNECT_OUTCOME);
    }
    case 152: { // networking.data_transferred_v3_kb
      return Some(ScalarID::NETWORKING_DATA_TRANSFERRED_V3_KB);
    }
    case 153: { // networking.http3_enabled
      return Some(ScalarID::NETWORKING_HTTP3_ENABLED);
    }
    case 155: { // networking.https_rr_prefs_usage
      return Some(ScalarID::NETWORKING_HTTPS_RR_PREFS_USAGE);
    }
    case 156: { // networking.trr_connection_cycle_count
      return Some(ScalarID::NETWORKING_TRR_CONNECTION_CYCLE_COUNT);
    }
    case 157: { // networking.loading_certs_task
      return Some(ScalarID::NETWORKING_LOADING_CERTS_TASK);
    }
    case 158: { // networking.nss_initialization
      return Some(ScalarID::NETWORKING_NSS_INITIALIZATION);
    }
    case 179: { // browser.backup.browser_extension_data_size
      return Some(ScalarID::BROWSER_BACKUP_BROWSER_EXTENSION_DATA_SIZE);
    }
    case 182: { // browser.backup.cookies_size
      return Some(ScalarID::BROWSER_BACKUP_COOKIES_SIZE);
    }
    case 184: { // browser.backup.credentials_data_size
      return Some(ScalarID::BROWSER_BACKUP_CREDENTIALS_DATA_SIZE);
    }
    case 185: { // browser.backup.enabled
      return Some(ScalarID::BROWSER_BACKUP_ENABLED);
    }
    case 187: { // browser.backup.extension_store_permissions_data_size
      return Some(ScalarID::BROWSER_BACKUP_EXTENSION_STORE_PERMISSIONS_DATA_SIZE);
    }
    case 188: { // browser.backup.extensions_json_size
      return Some(ScalarID::BROWSER_BACKUP_EXTENSIONS_JSON_SIZE);
    }
    case 189: { // browser.backup.extensions_storage_size
      return Some(ScalarID::BROWSER_BACKUP_EXTENSIONS_STORAGE_SIZE);
    }
    case 190: { // browser.backup.extensions_xpi_directory_size
      return Some(ScalarID::BROWSER_BACKUP_EXTENSIONS_XPI_DIRECTORY_SIZE);
    }
    case 191: { // browser.backup.favicons_size
      return Some(ScalarID::BROWSER_BACKUP_FAVICONS_SIZE);
    }
    case 193: { // browser.backup.form_history_size
      return Some(ScalarID::BROWSER_BACKUP_FORM_HISTORY_SIZE);
    }
    case 194: { // browser.backup.location_on_device
      return Some(ScalarID::BROWSER_BACKUP_LOCATION_ON_DEVICE);
    }
    case 195: { // browser.backup.misc_data_size
      return Some(ScalarID::BROWSER_BACKUP_MISC_DATA_SIZE);
    }
    case 199: { // browser.backup.places_size
      return Some(ScalarID::BROWSER_BACKUP_PLACES_SIZE);
    }
    case 201: { // browser.backup.preferences_size
      return Some(ScalarID::BROWSER_BACKUP_PREFERENCES_SIZE);
    }
    case 202: { // browser.backup.prof_d_disk_space
      return Some(ScalarID::BROWSER_BACKUP_PROF_D_DISK_SPACE);
    }
    case 203: { // browser.backup.pswd_encrypted
      return Some(ScalarID::BROWSER_BACKUP_PSWD_ENCRYPTED);
    }
    case 204: { // browser.backup.scheduler_enabled
      return Some(ScalarID::BROWSER_BACKUP_SCHEDULER_ENABLED);
    }
    case 205: { // browser.backup.security_data_size
      return Some(ScalarID::BROWSER_BACKUP_SECURITY_DATA_SIZE);
    }
    case 206: { // browser.backup.session_store_backups_directory_size
      return Some(ScalarID::BROWSER_BACKUP_SESSION_STORE_BACKUPS_DIRECTORY_SIZE);
    }
    case 207: { // browser.backup.session_store_size
      return Some(ScalarID::BROWSER_BACKUP_SESSION_STORE_SIZE);
    }
    case 208: { // browser.backup.storage_sync_size
      return Some(ScalarID::BROWSER_BACKUP_STORAGE_SYNC_SIZE);
    }
    case 225: { // downloads.panel_shown
      return Some(ScalarID::DOWNLOADS_PANEL_SHOWN);
    }
    case 227: { // downloads.file_opened
      return Some(ScalarID::DOWNLOADS_FILE_OPENED);
    }
    case 292: { // browser.startup.abouthome_cache_result
      return Some(ScalarID::BROWSER_STARTUP_ABOUTHOME_CACHE_RESULT);
    }
    case 293: { // browser.startup.abouthome_cache_shutdownwrite
      return Some(ScalarID::BROWSER_STARTUP_ABOUTHOME_CACHE_SHUTDOWNWRITE);
    }
    case 294: { // datasanitization.privacy_clear_on_shutdown_cache
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_CACHE);
    }
    case 295: { // datasanitization.privacy_clear_on_shutdown_cookies
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_COOKIES);
    }
    case 296: { // datasanitization.privacy_clear_on_shutdown_downloads
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_DOWNLOADS);
    }
    case 297: { // datasanitization.privacy_clear_on_shutdown_formdata
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_FORMDATA);
    }
    case 298: { // datasanitization.privacy_clear_on_shutdown_history
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_HISTORY);
    }
    case 299: { // datasanitization.privacy_clear_on_shutdown_offline_apps
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_OFFLINEAPPS);
    }
    case 300: { // datasanitization.privacy_clear_on_shutdown_open_windows
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_OPENWINDOWS);
    }
    case 301: { // datasanitization.privacy_clear_on_shutdown_sessions
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_SESSIONS);
    }
    case 302: { // datasanitization.privacy_clear_on_shutdown_site_settings
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_SITESETTINGS);
    }
    case 303: { // datasanitization.privacy_sanitize_sanitize_on_shutdown
      return Some(ScalarID::DATASANITIZATION_PRIVACY_SANITIZE_SANITIZEONSHUTDOWN);
    }
    case 304: { // datasanitization.session_permission_exceptions
      return Some(ScalarID::DATASANITIZATION_SESSION_PERMISSION_EXCEPTIONS);
    }
    case 306: { // os.environment.invoked_to_handle
      return Some(ScalarID::OS_ENVIRONMENT_INVOKED_TO_HANDLE);
    }
    case 307: { // os.environment.is_default_handler
      return Some(ScalarID::OS_ENVIRONMENT_IS_DEFAULT_HANDLER);
    }
    case 308: { // os.environment.is_kept_in_dock
      return Some(ScalarID::OS_ENVIRONMENT_IS_KEPT_IN_DOCK);
    }
    case 309: { // os.environment.is_taskbar_pinned
      return Some(ScalarID::OS_ENVIRONMENT_IS_TASKBAR_PINNED);
    }
    case 310: { // os.environment.is_taskbar_pinned_private
      return Some(ScalarID::OS_ENVIRONMENT_IS_TASKBAR_PINNED_PRIVATE);
    }
    case 311: { // os.environment.launch_method
      return Some(ScalarID::OS_ENVIRONMENT_LAUNCH_METHOD);
    }
    case 312: { // os.environment.launched_to_handle
      return Some(ScalarID::OS_ENVIRONMENT_LAUNCHED_TO_HANDLE);
    }
    case 313: { // os.environment.allowed_app_sources
      return Some(ScalarID::OS_ENVIRONMENT_ALLOWED_APP_SOURCES);
    }
    case 314: { // os.environment.is_admin_without_uac
      return Some(ScalarID::OS_ENVIRONMENT_IS_ADMIN_WITHOUT_UAC);
    }
    case 315: { // primary.password.enabled
      return Some(ScalarID::PRIMARY_PASSWORD_ENABLED);
    }
    case 316: { // security.global_privacy_control_enabled
      return Some(ScalarID::SECURITY_GLOBAL_PRIVACY_CONTROL_ENABLED);
    }
    case 317: { // security.https_only_mode_enabled
      return Some(ScalarID::SECURITY_HTTPS_ONLY_MODE_ENABLED);
    }
    case 318: { // security.https_only_mode_enabled_pbm
      return Some(ScalarID::SECURITY_HTTPS_ONLY_MODE_ENABLED_PBM);
    }
    case 325: { // security.client_auth_cert_usage
      return Some(ScalarID::SECURITY_CLIENT_AUTH_CERT_USAGE);
    }
    case 328: { // startup.is_cold
      return Some(ScalarID::STARTUP_IS_COLD);
    }
    case 329: { // startup.seconds_since_last_os_restart
      return Some(ScalarID::STARTUP_SECONDS_SINCE_LAST_OS_RESTART);
    }
    case 330: { // startup.profile_count
      return Some(ScalarID::STARTUP_PROFILE_COUNT);
    }
    case 331: { // startup.profile_database_version
      return Some(ScalarID::STARTUP_PROFILE_DATABASE_VERSION);
    }
    case 332: { // startup.profile_selection_reason
      return Some(ScalarID::STARTUP_PROFILE_SELECTION_REASON);
    }
    case 346: { // migration.discovered_migrators
      return Some(ScalarID::MIGRATION_DISCOVERED_MIGRATORS);
    }
    case 347: { // migration.time_to_produce_migrator_list
      return Some(ScalarID::MIGRATION_TIME_TO_PRODUCE_MIGRATOR_LIST);
    }
    case 348: { // migration.uninstaller_profile_refresh
      return Some(ScalarID::MIGRATION_UNINSTALLER_PROFILE_REFRESH);
    }
    case 402: { // contextual.services.topsites.click
      return Some(ScalarID::CONTEXTUAL_SERVICES_TOPSITES_CLICK);
    }
    case 403: { // contextual.services.topsites.impression
      return Some(ScalarID::CONTEXTUAL_SERVICES_TOPSITES_IMPRESSION);
    }
    case 404: { // deletion.request.context_id
      return Some(ScalarID::DELETION_REQUEST_CONTEXT_ID);
    }
    case 405: { // deletion.request.impression_id
      return Some(ScalarID::DELETION_REQUEST_IMPRESSION_ID);
    }
    case 406: { // deletion.request.sync_device_id
      return Some(ScalarID::DELETION_REQUEST_SYNC_DEVICE_ID);
    }
    case 505: { // library.link
      return Some(ScalarID::LIBRARY_LINK);
    }
    case 506: { // library.opened
      return Some(ScalarID::LIBRARY_OPENED);
    }
    case 507: { // library.search
      return Some(ScalarID::LIBRARY_SEARCH);
    }
    case 584: { // browser.engagement.navigation.about_home
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_ABOUT_HOME);
    }
    case 585: { // browser.engagement.navigation.about_newtab
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_ABOUT_NEWTAB);
    }
    case 586: { // browser.engagement.navigation.contextmenu
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_CONTEXTMENU);
    }
    case 587: { // browser.engagement.navigation.searchbar
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_SEARCHBAR);
    }
    case 588: { // browser.engagement.navigation.urlbar
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_URLBAR);
    }
    case 589: { // browser.engagement.navigation.urlbar_handoff
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_URLBAR_HANDOFF);
    }
    case 590: { // browser.engagement.navigation.urlbar_persisted
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_URLBAR_PERSISTED);
    }
    case 591: { // browser.engagement.navigation.urlbar_searchmode
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_URLBAR_SEARCHMODE);
    }
    case 592: { // browser.engagement.navigation.webextension
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_WEBEXTENSION);
    }
    case 593: { // browser.search.adclicks.about_home
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_ABOUT_HOME);
    }
    case 594: { // browser.search.adclicks.about_newtab
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_ABOUT_NEWTAB);
    }
    case 595: { // browser.search.adclicks.contextmenu
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_CONTEXTMENU);
    }
    case 596: { // browser.search.adclicks.reload
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_RELOAD);
    }
    case 597: { // browser.search.adclicks.searchbar
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_SEARCHBAR);
    }
    case 598: { // browser.search.adclicks.system
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_SYSTEM);
    }
    case 599: { // browser.search.adclicks.tabhistory
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_TABHISTORY);
    }
    case 600: { // browser.search.adclicks.unknown
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_UNKNOWN);
    }
    case 601: { // browser.search.adclicks.urlbar
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_URLBAR);
    }
    case 602: { // browser.search.adclicks.urlbar_handoff
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_URLBAR_HANDOFF);
    }
    case 603: { // browser.search.adclicks.urlbar_persisted
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_URLBAR_PERSISTED);
    }
    case 604: { // browser.search.adclicks.urlbar_searchmode
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_URLBAR_SEARCHMODE);
    }
    case 605: { // browser.search.adclicks.webextension
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_WEBEXTENSION);
    }
    case 606: { // browser.search.content.about_home
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_ABOUT_HOME);
    }
    case 607: { // browser.search.content.about_newtab
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_ABOUT_NEWTAB);
    }
    case 608: { // browser.search.content.contextmenu
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_CONTEXTMENU);
    }
    case 609: { // browser.search.content.reload
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_RELOAD);
    }
    case 610: { // browser.search.content.searchbar
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_SEARCHBAR);
    }
    case 611: { // browser.search.content.system
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_SYSTEM);
    }
    case 612: { // browser.search.content.tabhistory
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_TABHISTORY);
    }
    case 613: { // browser.search.content.unknown
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_UNKNOWN);
    }
    case 614: { // browser.search.content.urlbar
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_URLBAR);
    }
    case 615: { // browser.search.content.urlbar_handoff
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_URLBAR_HANDOFF);
    }
    case 616: { // browser.search.content.urlbar_persisted
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_URLBAR_PERSISTED);
    }
    case 617: { // browser.search.content.urlbar_searchmode
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_URLBAR_SEARCHMODE);
    }
    case 618: { // browser.search.content.webextension
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_WEBEXTENSION);
    }
    case 619: { // browser.search.withads.about_home
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_ABOUT_HOME);
    }
    case 620: { // browser.search.withads.about_newtab
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_ABOUT_NEWTAB);
    }
    case 621: { // browser.search.withads.contextmenu
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_CONTEXTMENU);
    }
    case 622: { // browser.search.withads.reload
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_RELOAD);
    }
    case 623: { // browser.search.withads.searchbar
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_SEARCHBAR);
    }
    case 624: { // browser.search.withads.system
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_SYSTEM);
    }
    case 625: { // browser.search.withads.tabhistory
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_TABHISTORY);
    }
    case 626: { // browser.search.withads.unknown
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_UNKNOWN);
    }
    case 627: { // browser.search.withads.urlbar
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_URLBAR);
    }
    case 628: { // browser.search.withads.urlbar_handoff
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_URLBAR_HANDOFF);
    }
    case 629: { // browser.search.withads.urlbar_persisted
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_URLBAR_PERSISTED);
    }
    case 630: { // browser.search.withads.urlbar_searchmode
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_URLBAR_SEARCHMODE);
    }
    case 631: { // browser.search.withads.webextension
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_WEBEXTENSION);
    }
    case 645: { // urlbar.searchmode.bookmarkmenu
      return Some(ScalarID::URLBAR_SEARCHMODE_BOOKMARKMENU);
    }
    case 646: { // urlbar.searchmode.handoff
      return Some(ScalarID::URLBAR_SEARCHMODE_HANDOFF);
    }
    case 647: { // urlbar.searchmode.historymenu
      return Some(ScalarID::URLBAR_SEARCHMODE_HISTORYMENU);
    }
    case 648: { // urlbar.searchmode.keywordoffer
      return Some(ScalarID::URLBAR_SEARCHMODE_KEYWORDOFFER);
    }
    case 649: { // urlbar.searchmode.oneoff
      return Some(ScalarID::URLBAR_SEARCHMODE_ONEOFF);
    }
    case 650: { // urlbar.searchmode.other
      return Some(ScalarID::URLBAR_SEARCHMODE_OTHER);
    }
    case 651: { // urlbar.searchmode.searchbutton
      return Some(ScalarID::URLBAR_SEARCHMODE_SEARCHBUTTON);
    }
    case 652: { // urlbar.searchmode.shortcut
      return Some(ScalarID::URLBAR_SEARCHMODE_SHORTCUT);
    }
    case 653: { // urlbar.searchmode.tabmenu
      return Some(ScalarID::URLBAR_SEARCHMODE_TABMENU);
    }
    case 654: { // urlbar.searchmode.tabtosearch
      return Some(ScalarID::URLBAR_SEARCHMODE_TABTOSEARCH);
    }
    case 655: { // urlbar.searchmode.tabtosearch_onboard
      return Some(ScalarID::URLBAR_SEARCHMODE_TABTOSEARCH_ONBOARD);
    }
    case 656: { // urlbar.searchmode.topsites_newtab
      return Some(ScalarID::URLBAR_SEARCHMODE_TOPSITES_NEWTAB);
    }
    case 657: { // urlbar.searchmode.topsites_urlbar
      return Some(ScalarID::URLBAR_SEARCHMODE_TOPSITES_URLBAR);
    }
    case 658: { // urlbar.searchmode.touchbar
      return Some(ScalarID::URLBAR_SEARCHMODE_TOUCHBAR);
    }
    case 659: { // urlbar.searchmode.typed
      return Some(ScalarID::URLBAR_SEARCHMODE_TYPED);
    }
    case 665: { // shopping.product_page_visits
      return Some(ScalarID::SHOPPING_PRODUCT_PAGE_VISITS);
    }
    case 693: { // shopping.settings.auto_open_user_disabled
      return Some(ScalarID::SHOPPING_AUTO_OPEN_USER_DISABLED);
    }
    case 694: { // shopping.settings.component_opted_out
      return Some(ScalarID::SHOPPING_COMPONENT_OPTED_OUT);
    }
    case 695: { // shopping.settings.disabled_ads
      return Some(ScalarID::SHOPPING_DISABLED_ADS);
    }
    case 696: { // shopping.settings.has_onboarded
      return Some(ScalarID::SHOPPING_HAS_ONBOARDED);
    }
    case 697: { // shopping.settings.nimbus_disabled_shopping
      return Some(ScalarID::SHOPPING_NIMBUS_DISABLED);
    }
    case 708: { // sidebar.link
      return Some(ScalarID::SIDEBAR_LINK);
    }
    case 711: { // sidebar.search
      return Some(ScalarID::SIDEBAR_SEARCH);
    }
    case 731: { // browser.ui.interaction.all_tabs_panel_dragstart_tab_event_count
      return Some(ScalarID::BROWSER_UI_INTERACTION_ALL_TABS_PANEL_DRAGSTART_TAB_EVENT_COUNT);
    }
    case 732: { // browser.ui.interaction.all_tabs_panel_entrypoint
      return Some(ScalarID::BROWSER_UI_INTERACTION_ALL_TABS_PANEL_ENTRYPOINT);
    }
    case 733: { // browser.ui.interaction.textrecognition_error
      return Some(ScalarID::BROWSER_UI_INTERACTION_TEXTRECOGNITION_ERROR);
    }
    case 734: { // browser.ui.interaction.app_menu
      return Some(ScalarID::BROWSER_UI_INTERACTION_APP_MENU);
    }
    case 735: { // browser.ui.interaction.bookmarks_bar
      return Some(ScalarID::BROWSER_UI_INTERACTION_BOOKMARKS_BAR);
    }
    case 736: { // browser.ui.interaction.content_context
      return Some(ScalarID::BROWSER_UI_INTERACTION_CONTENT_CONTEXT);
    }
    case 737: { // browser.ui.interaction.menu_bar
      return Some(ScalarID::BROWSER_UI_INTERACTION_MENU_BAR);
    }
    case 738: { // browser.ui.interaction.nav_bar
      return Some(ScalarID::BROWSER_UI_INTERACTION_NAV_BAR);
    }
    case 739: { // browser.ui.interaction.overflow_menu
      return Some(ScalarID::BROWSER_UI_INTERACTION_OVERFLOW_MENU);
    }
    case 740: { // browser.ui.interaction.pageaction_panel
      return Some(ScalarID::BROWSER_UI_INTERACTION_PAGEACTION_PANEL);
    }
    case 741: { // browser.ui.interaction.pageaction_urlbar
      return Some(ScalarID::BROWSER_UI_INTERACTION_PAGEACTION_URLBAR);
    }
    case 742: { // browser.ui.interaction.pinned_overflow_menu
      return Some(ScalarID::BROWSER_UI_INTERACTION_PINNED_OVERFLOW_MENU);
    }
    case 743: { // browser.ui.interaction.preferences_pane_containers
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANECONTAINERS);
    }
    case 744: { // browser.ui.interaction.preferences_pane_experimental
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEEXPERIMENTAL);
    }
    case 745: { // browser.ui.interaction.preferences_pane_general
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEGENERAL);
    }
    case 746: { // browser.ui.interaction.preferences_pane_home
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEHOME);
    }
    case 747: { // browser.ui.interaction.preferences_pane_more_from_mozilla
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEMOREFROMMOZILLA);
    }
    case 748: { // browser.ui.interaction.preferences_pane_privacy
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEPRIVACY);
    }
    case 749: { // browser.ui.interaction.preferences_pane_search
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANESEARCH);
    }
    case 750: { // browser.ui.interaction.preferences_pane_search_results
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANESEARCHRESULTS);
    }
    case 751: { // browser.ui.interaction.preferences_pane_sync
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANESYNC);
    }
    case 752: { // browser.ui.interaction.preferences_pane_unknown
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEUNKNOWN);
    }
    case 753: { // browser.ui.interaction.tabs_bar
      return Some(ScalarID::BROWSER_UI_INTERACTION_TABS_BAR);
    }
    case 754: { // browser.ui.interaction.tabs_context
      return Some(ScalarID::BROWSER_UI_INTERACTION_TABS_CONTEXT);
    }
    case 755: { // browser.ui.interaction.tabs_context_entrypoint
      return Some(ScalarID::BROWSER_UI_INTERACTION_TABS_CONTEXT_ENTRYPOINT);
    }
    case 756: { // browser.ui.interaction.unified_extensions_area
      return Some(ScalarID::BROWSER_UI_INTERACTION_UNIFIED_EXTENSIONS_AREA);
    }
    case 757: { // browser.ui.interaction.vertical_tabs_container
      return Some(ScalarID::BROWSER_UI_INTERACTION_VERTICAL_TABS_CONTAINER);
    }
    case 758: { // browser.ui.interaction.keyboard
      return Some(ScalarID::BROWSER_UI_INTERACTION_KEYBOARD);
    }
    case 779: { // urlbar.abandonment_count
      return Some(ScalarID::URLBAR_ABANDONMENT);
    }
    case 780: { // urlbar.autofill_deletion
      return Some(ScalarID::URLBAR_AUTOFILL_DELETION);
    }
    case 782: { // urlbar.engagement_count
      return Some(ScalarID::URLBAR_ENGAGEMENT);
    }
    case 793: { // urlbar.tips
      return Some(ScalarID::URLBAR_TIPS);
    }
    case 794: { // urlbar.impression.autofill_about
      return Some(ScalarID::URLBAR_IMPRESSION_AUTOFILL_ABOUT);
    }
    case 795: { // urlbar.impression.autofill_adaptive
      return Some(ScalarID::URLBAR_IMPRESSION_AUTOFILL_ADAPTIVE);
    }
    case 796: { // urlbar.impression.autofill_origin
      return Some(ScalarID::URLBAR_IMPRESSION_AUTOFILL_ORIGIN);
    }
    case 797: { // urlbar.impression.autofill_other
      return Some(ScalarID::URLBAR_IMPRESSION_AUTOFILL_OTHER);
    }
    case 798: { // urlbar.impression.autofill_url
      return Some(ScalarID::URLBAR_IMPRESSION_AUTOFILL_URL);
    }
    case 799: { // urlbar.persistedsearchterms.revert_by_popup_count
      return Some(ScalarID::URLBAR_PERSISTEDSEARCHTERMS_REVERT_BY_POPUP_COUNT);
    }
    case 800: { // urlbar.persistedsearchterms.view_count
      return Some(ScalarID::URLBAR_PERSISTEDSEARCHTERMS_VIEW_COUNT);
    }
    case 801: { // urlbar.picked.autofill_about
      return Some(ScalarID::URLBAR_PICKED_AUTOFILL_ABOUT);
    }
    case 802: { // urlbar.picked.autofill_adaptive
      return Some(ScalarID::URLBAR_PICKED_AUTOFILL_ADAPTIVE);
    }
    case 803: { // urlbar.picked.autofill_origin
      return Some(ScalarID::URLBAR_PICKED_AUTOFILL_ORIGIN);
    }
    case 804: { // urlbar.picked.autofill_other
      return Some(ScalarID::URLBAR_PICKED_AUTOFILL_OTHER);
    }
    case 805: { // urlbar.picked.autofill_url
      return Some(ScalarID::URLBAR_PICKED_AUTOFILL_URL);
    }
    case 806: { // urlbar.picked.bookmark
      return Some(ScalarID::URLBAR_PICKED_BOOKMARK);
    }
    case 807: { // urlbar.picked.bookmark_adaptive
      return Some(ScalarID::URLBAR_PICKED_BOOKMARK_ADAPTIVE);
    }
    case 808: { // urlbar.picked.clipboard
      return Some(ScalarID::URLBAR_PICKED_CLIPBOARD);
    }
    case 809: { // urlbar.picked.dynamic
      return Some(ScalarID::URLBAR_PICKED_DYNAMIC);
    }
    case 810: { // urlbar.picked.dynamic_wikipedia
      return Some(ScalarID::URLBAR_PICKED_DYNAMIC_WIKIPEDIA);
    }
    case 811: { // urlbar.picked.extension
      return Some(ScalarID::URLBAR_PICKED_EXTENSION);
    }
    case 812: { // urlbar.picked.formhistory
      return Some(ScalarID::URLBAR_PICKED_FORMHISTORY);
    }
    case 813: { // urlbar.picked.history
      return Some(ScalarID::URLBAR_PICKED_HISTORY);
    }
    case 814: { // urlbar.picked.history_adaptive
      return Some(ScalarID::URLBAR_PICKED_HISTORY_ADAPTIVE);
    }
    case 815: { // urlbar.picked.keyword
      return Some(ScalarID::URLBAR_PICKED_KEYWORD);
    }
    case 816: { // urlbar.picked.navigational
      return Some(ScalarID::URLBAR_PICKED_NAVIGATIONAL);
    }
    case 817: { // urlbar.picked.quickaction
      return Some(ScalarID::URLBAR_PICKED_QUICKACTION);
    }
    case 818: { // urlbar.picked.quicksuggest
      return Some(ScalarID::URLBAR_PICKED_QUICKSUGGEST);
    }
    case 819: { // urlbar.picked.recent_search
      return Some(ScalarID::URLBAR_PICKED_RECENT_SEARCH);
    }
    case 820: { // urlbar.picked.remotetab
      return Some(ScalarID::URLBAR_PICKED_REMOTETAB);
    }
    case 821: { // urlbar.picked.restrict_keyword_actions
      return Some(ScalarID::URLBAR_PICKED_RESTRICT_KEYWORD_ACTIONS);
    }
    case 822: { // urlbar.picked.restrict_keyword_bookmarks
      return Some(ScalarID::URLBAR_PICKED_RESTRICT_KEYWORD_BOOKMARKS);
    }
    case 823: { // urlbar.picked.restrict_keyword_history
      return Some(ScalarID::URLBAR_PICKED_RESTRICT_KEYWORD_HISTORY);
    }
    case 824: { // urlbar.picked.restrict_keyword_tabs
      return Some(ScalarID::URLBAR_PICKED_RESTRICT_KEYWORD_TABS);
    }
    case 825: { // urlbar.picked.searchengine
      return Some(ScalarID::URLBAR_PICKED_SEARCHENGINE);
    }
    case 826: { // urlbar.picked.searchsuggestion
      return Some(ScalarID::URLBAR_PICKED_SEARCHSUGGESTION);
    }
    case 827: { // urlbar.picked.searchsuggestion_rich
      return Some(ScalarID::URLBAR_PICKED_SEARCHSUGGESTION_RICH);
    }
    case 828: { // urlbar.picked.switchtab
      return Some(ScalarID::URLBAR_PICKED_SWITCHTAB);
    }
    case 829: { // urlbar.picked.tabtosearch
      return Some(ScalarID::URLBAR_PICKED_TABTOSEARCH);
    }
    case 830: { // urlbar.picked.tip
      return Some(ScalarID::URLBAR_PICKED_TIP);
    }
    case 831: { // urlbar.picked.topsite
      return Some(ScalarID::URLBAR_PICKED_TOPSITE);
    }
    case 832: { // urlbar.picked.trending
      return Some(ScalarID::URLBAR_PICKED_TRENDING);
    }
    case 833: { // urlbar.picked.trending_rich
      return Some(ScalarID::URLBAR_PICKED_TRENDING_RICH);
    }
    case 834: { // urlbar.picked.unknown
      return Some(ScalarID::URLBAR_PICKED_UNKNOWN);
    }
    case 835: { // urlbar.picked.visiturl
      return Some(ScalarID::URLBAR_PICKED_VISITURL);
    }
    case 836: { // urlbar.picked.weather
      return Some(ScalarID::URLBAR_PICKED_WEATHER);
    }
    case 837: { // urlbar.picked.searchmode.bookmarkmenu
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_BOOKMARKMENU);
    }
    case 838: { // urlbar.picked.searchmode.handoff
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_HANDOFF);
    }
    case 839: { // urlbar.picked.searchmode.historymenu
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_HISTORYMENU);
    }
    case 840: { // urlbar.picked.searchmode.keywordoffer
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_KEYWORDOFFER);
    }
    case 841: { // urlbar.picked.searchmode.oneoff
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_ONEOFF);
    }
    case 842: { // urlbar.picked.searchmode.other
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_OTHER);
    }
    case 843: { // urlbar.picked.searchmode.searchbutton
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_SEARCHBUTTON);
    }
    case 844: { // urlbar.picked.searchmode.shortcut
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_SHORTCUT);
    }
    case 845: { // urlbar.picked.searchmode.tabmenu
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_TABMENU);
    }
    case 846: { // urlbar.picked.searchmode.tabtosearch
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_TABTOSEARCH);
    }
    case 847: { // urlbar.picked.searchmode.tabtosearch_onboard
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_TABTOSEARCH_ONBOARD);
    }
    case 848: { // urlbar.picked.searchmode.topsites_newtab
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_TOPSITES_NEWTAB);
    }
    case 849: { // urlbar.picked.searchmode.topsites_urlbar
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_TOPSITES_URLBAR);
    }
    case 850: { // urlbar.picked.searchmode.touchbar
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_TOUCHBAR);
    }
    case 851: { // urlbar.picked.searchmode.typed
      return Some(ScalarID::URLBAR_PICKED_SEARCHMODE_TYPED);
    }
    case 852: { // urlbar.quickaction.picked
      return Some(ScalarID::QUICKACTION_PICKED);
    }
    case 853: { // urlbar.tabtosearch.impressions
      return Some(ScalarID::URLBAR_TABTOSEARCH_IMPRESSIONS);
    }
    case 854: { // urlbar.tabtosearch.impressions_onboarding
      return Some(ScalarID::URLBAR_TABTOSEARCH_IMPRESSIONS_ONBOARDING);
    }
    case 855: { // urlbar.trending.block
      return Some(ScalarID::URLBAR_TRENDING_BLOCK);
    }
    case 856: { // urlbar.unifiedsearchbutton.opened
      return Some(ScalarID::URLBAR_UNIFIEDSEARCHBUTTON_OPENED);
    }
    case 857: { // urlbar.unifiedsearchbutton.picked
      return Some(ScalarID::URLBAR_UNIFIEDSEARCHBUTTON_PICKED);
    }
    case 858: { // urlbar.zeroprefix.abandonment
      return Some(ScalarID::URLBAR_ZEROPREFIX_ABANDONMENT);
    }
    case 859: { // urlbar.zeroprefix.engagement
      return Some(ScalarID::URLBAR_ZEROPREFIX_ENGAGEMENT);
    }
    case 860: { // urlbar.zeroprefix.exposure
      return Some(ScalarID::URLBAR_ZEROPREFIX_EXPOSURE);
    }
    case 863: { // browser.ui.customized_widgets
      return Some(ScalarID::BROWSER_UI_CUSTOMIZED_WIDGETS);
    }
    case 864: { // browser.ui.mirror_for_toolbar_widgets
      return Some(ScalarID::BROWSER_UI_TOOLBAR_WIDGETS);
    }
    case 871: { // installation.first_seen.admin_user
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_ADMIN_USER);
    }
    case 872: { // installation.first_seen.default_path
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_DEFAULT_PATH);
    }
    case 873: { // installation.first_seen.failure_reason
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_FAILURE_REASON);
    }
    case 874: { // installation.first_seen.from_msi
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_FROM_MSI);
    }
    case 875: { // installation.first_seen.install_existed
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_INSTALL_EXISTED);
    }
    case 876: { // installation.first_seen.installer_type
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_INSTALLER_TYPE);
    }
    case 877: { // installation.first_seen.other_inst
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_OTHER_INST);
    }
    case 878: { // installation.first_seen.other_msix_inst
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_OTHER_MSIX_INST);
    }
    case 879: { // installation.first_seen.profdir_existed
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_PROFDIR_EXISTED);
    }
    case 880: { // installation.first_seen.silent
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_SILENT);
    }
    case 881: { // installation.first_seen.version
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_VERSION);
    }
    case 890: { // timestamps.about_home_topsites_first_paint
      return Some(ScalarID::TIMESTAMPS_ABOUT_HOME_TOPSITES_FIRST_PAINT);
    }
    case 891: { // timestamps.first_paint
      return Some(ScalarID::TIMESTAMPS_FIRST_PAINT);
    }
    case 892: { // timestamps.first_paint_two
      return Some(ScalarID::TIMESTAMPS_FIRST_PAINT_TWO);
    }
    case 893: { // devtools.accessibility.accessible_context_menu_item_activated
      return Some(ScalarID::DEVTOOLS_ACCESSIBILITY_ACCESSIBLE_CONTEXT_MENU_ITEM_ACTIVATED);
    }
    case 894: { // devtools.accessibility.accessible_context_menu_opened
      return Some(ScalarID::DEVTOOLS_ACCESSIBILITY_ACCESSIBLE_CONTEXT_MENU_OPENED);
    }
    case 895: { // devtools.accessibility.audit_activated
      return Some(ScalarID::DEVTOOLS_ACCESSIBILITY_AUDIT_ACTIVATED);
    }
    case 896: { // devtools.accessibility.node_inspected_count
      return Some(ScalarID::DEVTOOLS_ACCESSIBILITY_NODE_INSPECTED_COUNT);
    }
    case 897: { // devtools.accessibility.select_accessible_for_node
      return Some(ScalarID::DEVTOOLS_ACCESSIBILITY_SELECT_ACCESSIBLE_FOR_NODE);
    }
    case 898: { // devtools.accessibility.simulation_activated
      return Some(ScalarID::DEVTOOLS_ACCESSIBILITY_SIMULATION_ACTIVATED);
    }
    case 899: { // devtools.accessibility.opened_count
      return Some(ScalarID::DEVTOOLS_ACCESSIBILITY_OPENED_COUNT);
    }
    case 900: { // devtools.accessibility.picker_used_count
      return Some(ScalarID::DEVTOOLS_ACCESSIBILITY_PICKER_USED_COUNT);
    }
    case 901: { // devtools.current_theme
      return Some(ScalarID::DEVTOOLS_CURRENT_THEME);
    }
    case 902: { // devtools.tool.registered
      return Some(ScalarID::DEVTOOLS_TOOL_REGISTERED);
    }
    case 903: { // devtools.toolbox.tabs_reordered
      return Some(ScalarID::DEVTOOLS_TOOLBOX_TABS_REORDERED);
    }
    case 904: { // devtools.grid.gridinspector.opened
      return Some(ScalarID::DEVTOOLS_GRID_GRIDINSPECTOR_OPENED);
    }
    case 905: { // devtools.inspector.node_selection_count
      return Some(ScalarID::DEVTOOLS_INSPECTOR_NODE_SELECTION_COUNT);
    }
    case 906: { // devtools.inspector.three_pane_enabled
      return Some(ScalarID::DEVTOOLS_INSPECTOR_THREE_PANE_ENABLED);
    }
    case 907: { // devtools.layout.flexboxhighlighter.opened
      return Some(ScalarID::DEVTOOLS_LAYOUT_FLEXBOXHIGHLIGHTER_OPENED);
    }
    case 908: { // devtools.markup.flexboxhighlighter.opened
      return Some(ScalarID::DEVTOOLS_MARKUP_FLEXBOXHIGHLIGHTER_OPENED);
    }
    case 909: { // devtools.markup.gridinspector.opened
      return Some(ScalarID::DEVTOOLS_MARKUP_GRIDINSPECTOR_OPENED);
    }
    case 910: { // devtools.markup.scrollable.badge.clicked
      return Some(ScalarID::DEVTOOLS_MARKUP_SCROLLABLE_BADGE_CLICKED);
    }
    case 911: { // devtools.rules.flexboxhighlighter.opened
      return Some(ScalarID::DEVTOOLS_RULES_FLEXBOXHIGHLIGHTER_OPENED);
    }
    case 912: { // devtools.rules.gridinspector.opened
      return Some(ScalarID::DEVTOOLS_RULES_GRIDINSPECTOR_OPENED);
    }
    case 913: { // devtools.shadowdom.reveal_link_clicked
      return Some(ScalarID::DEVTOOLS_SHADOWDOM_REVEAL_LINK_CLICKED);
    }
    case 914: { // devtools.shadowdom.shadow_root_displayed
      return Some(ScalarID::DEVTOOLS_SHADOWDOM_SHADOW_ROOT_DISPLAYED);
    }
    case 915: { // devtools.shadowdom.shadow_root_expanded
      return Some(ScalarID::DEVTOOLS_SHADOWDOM_SHADOW_ROOT_EXPANDED);
    }
    case 916: { // devtools.tooltip.shown
      return Some(ScalarID::DEVTOOLS_TOOLTIP_SHOWN);
    }
    case 917: { // devtools.responsive.open_trigger
      return Some(ScalarID::DEVTOOLS_RESPONSIVE_OPEN_TRIGGER);
    }
    case 918: { // devtools.responsive.toolbox_opened_first
      return Some(ScalarID::DEVTOOLS_RESPONSIVE_TOOLBOX_OPENED_FIRST);
    }
    case 919: { // devtools.changesview.opened_count
      return Some(ScalarID::DEVTOOLS_CHANGESVIEW_OPENED_COUNT);
    }
    case 3443: { // media.element_in_page_count
      return Some(ScalarID::MEDIA_ELEMENT_IN_PAGE_COUNT);
    }
    case 3445: { // media.video_hardware_decoding_support
      return Some(ScalarID::MEDIA_VIDEO_HARDWARE_DECODING_SUPPORT);
    }
    case 3446: { // media.video_hd_hardware_decoding_support
      return Some(ScalarID::MEDIA_VIDEO_HD_HARDWARE_DECODING_SUPPORT);
    }
    case 3450: { // media.playback.device_hardware_decoder_support
      return Some(ScalarID::MEDIA_DEVICE_HARDWARE_DECODING_SUPPORT);
    }
    case 3472: { // webrtc.video.recv_codec_used
      return Some(ScalarID::WEBRTC_VIDEO_RECV_CODEC_USED);
    }
    case 3473: { // webrtc.video.send_codec_used
      return Some(ScalarID::WEBRTC_VIDEO_SEND_CODEC_USED);
    }
    case 3481: { // dom.contentprocess.build_id_mismatch
      return Some(ScalarID::DOM_CONTENTPROCESS_BUILDID_MISMATCH);
    }
    case 3482: { // dom.contentprocess.build_id_mismatch_false_positive
      return Some(ScalarID::DOM_CONTENTPROCESS_BUILDID_MISMATCH_FALSE_POSITIVE);
    }
    case 3483: { // dom.contentprocess.os_priority_change_considered
      return Some(ScalarID::DOM_CONTENTPROCESS_OS_PRIORITY_CHANGE_CONSIDERED);
    }
    case 3484: { // dom.contentprocess.os_priority_lowered
      return Some(ScalarID::DOM_CONTENTPROCESS_OS_PRIORITY_LOWERED);
    }
    case 3485: { // dom.contentprocess.os_priority_raised
      return Some(ScalarID::DOM_CONTENTPROCESS_OS_PRIORITY_RAISED);
    }
    case 3486: { // dom.parentprocess.private_window_used
      return Some(ScalarID::DOM_PARENTPROCESS_PRIVATE_WINDOW_USED);
    }
    case 3487: { // dom.parentprocess.process_launch_errors
      return Some(ScalarID::DOM_PARENTPROCESS_PROCESS_LAUNCH_ERRORS);
    }
    case 3495: { // mathml.doc_count
      return Some(ScalarID::MATHML_DOC_COUNT);
    }
    case 3540: { // gfx.linux_window_protocol
      return Some(ScalarID::GFX_LINUX_WINDOW_PROTOCOL);
    }
    case 3541: { // gfx.os_compositor
      return Some(ScalarID::GFX_OS_COMPOSITOR);
    }
    case 3543: { // gfx.skipped_composites
      return Some(ScalarID::GFX_SKIPPED_COMPOSITES);
    }
    case 3544: { // gfx.supports_hdr
      return Some(ScalarID::GFX_SUPPORTS_HDR);
    }
    case 3570: { // gfx.hdr.windows_display_colorspace_bitfield
      return Some(ScalarID::GFX_HDR_WINDOWS_DISPLAY_COLORSPACE_BITFIELD);
    }
    case 3631: { // script.preloader.mainthread_recompile
      return Some(ScalarID::SCRIPT_PRELOADER_MAINTHREAD_RECOMPILE);
    }
    case 3653: { // preferences.prefs_file_was_invalid
      return Some(ScalarID::PREFERENCES_PREFS_FILE_WAS_INVALID);
    }
    case 3711: { // opaque.response.blocking.cross_origin_opaque_response_count
      return Some(ScalarID::OPAQUE_RESPONSE_BLOCKING_CROSS_ORIGIN_OPAQUE_RESPONSE_COUNT);
    }
    case 3712: { // opaque.response.blocking.javascript_validation_count
      return Some(ScalarID::OPAQUE_RESPONSE_BLOCKING_JAVASCRIPT_VALIDATION_COUNT);
    }
    case 3789: { // contentblocking.category
      return Some(ScalarID::CONTENTBLOCKING_CATEGORY);
    }
    case 3790: { // contentblocking.cryptomining_blocking_enabled
      return Some(ScalarID::CONTENTBLOCKING_CRYPTOMINING_BLOCKING_ENABLED);
    }
    case 3791: { // contentblocking.fingerprinting_blocking_enabled
      return Some(ScalarID::CONTENTBLOCKING_FINGERPRINTING_BLOCKING_ENABLED);
    }
    case 3792: { // contentblocking.trackers_blocked_count
      return Some(ScalarID::CONTENTBLOCKING_TRACKERS_BLOCKED_COUNT);
    }
    case 3872: { // cookie.banners.normal_window_service_mode
      return Some(ScalarID::COOKIE_BANNERS_NORMAL_WINDOW_SERVICE_MODE);
    }
    case 3873: { // cookie.banners.private_window_service_mode
      return Some(ScalarID::COOKIE_BANNERS_PRIVATE_WINDOW_SERVICE_MODE);
    }
    case 3874: { // cookie.banners.service_detect_only
      return Some(ScalarID::COOKIE_BANNERS_SERVICE_DETECT_ONLY);
    }
    case 3923: { // policies.count
      return Some(ScalarID::POLICIES_COUNT);
    }
    case 3924: { // policies.is_enterprise
      return Some(ScalarID::POLICIES_IS_ENTERPRISE);
    }
    case 3926: { // extensions.startup_cache_load_time
      return Some(ScalarID::EXTENSIONS_STARTUPCACHE_LOAD_TIME);
    }
    case 3927: { // extensions.startup_cache_read_errors
      return Some(ScalarID::EXTENSIONS_STARTUPCACHE_READ_ERRORS);
    }
    case 3928: { // extensions.startup_cache_write_bytelength
      return Some(ScalarID::EXTENSIONS_STARTUPCACHE_WRITE_BYTELENGTH);
    }
    case 3931: { // extensions.apis.dnr.evaluate_rules_count_max
      return Some(ScalarID::EXTENSIONS_APIS_DNR_EVALUATE_RULES_COUNT_MAX);
    }
    case 3933: { // extensions.apis.dnr.startup_cache_entries
      return Some(ScalarID::EXTENSIONS_APIS_DNR_STARTUP_CACHE_ENTRIES);
    }
    case 4008: { // formautofill.availability
      return Some(ScalarID::FORMAUTOFILL_AVAILABILITY);
    }
    case 4011: { // formautofill.addresses.autofill_profiles_count
      return Some(ScalarID::FORMAUTOFILL_ADDRESSES_AUTOFILL_PROFILES_COUNT);
    }
    case 4012: { // formautofill.creditcards.autofill_profiles_count
      return Some(ScalarID::FORMAUTOFILL_CREDITCARDS_AUTOFILL_PROFILES_COUNT);
    }
    case 4031: { // test_only.button_jars
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_LABELED_QUANTITY);
    }
    case 4037: { // test_only.default_products
      return Some(ScalarID::TELEMETRY_TEST_DEFAULT_PRODUCTS);
    }
    case 4038: { // test_only.desktop_only
      return Some(ScalarID::TELEMETRY_TEST_DESKTOP_ONLY);
    }
    case 4040: { // test_only.expired
      return Some(ScalarID::TELEMETRY_TEST_EXPIRED);
    }
    case 4041: { // test_only.impression_id_only
      return Some(ScalarID::TELEMETRY_TEST_IMPRESSION_ID_ONLY);
    }
    case 4042: { // test_only.keyed_expired
      return Some(ScalarID::TELEMETRY_TEST_KEYED_EXPIRED);
    }
    case 4043: { // test_only.keyed_mobile_only
      return Some(ScalarID::TELEMETRY_TEST_KEYED_MOBILE_ONLY);
    }
    case 4044: { // test_only.keyed_release_optin
      return Some(ScalarID::TELEMETRY_TEST_KEYED_RELEASE_OPTIN);
    }
    case 4045: { // test_only.keyed_release_optout
      return Some(ScalarID::TELEMETRY_TEST_KEYED_RELEASE_OPTOUT);
    }
    case 4055: { // test_only.main_only
      return Some(ScalarID::TELEMETRY_TEST_MAIN_ONLY);
    }
    case 4056: { // test_only.meaning_of_life
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_QUANTITY);
    }
    case 4057: { // test_only.mirror_time
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_TIMESPAN);
    }
    case 4058: { // test_only.mirror_time_nanos
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_TIMESPAN_NANOS);
    }
    case 4059: { // test_only.mirrors_for_labeled_bools
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_LABELED_BOOL);
    }
    case 4060: { // test_only.mobile_only
      return Some(ScalarID::TELEMETRY_TEST_MOBILE_ONLY);
    }
    case 4061: { // test_only.multiproduct
      return Some(ScalarID::TELEMETRY_TEST_MULTIPRODUCT);
    }
    case 4063: { // test_only.release_optin
      return Some(ScalarID::TELEMETRY_TEST_RELEASE_OPTIN);
    }
    case 4064: { // test_only.release_optout
      return Some(ScalarID::TELEMETRY_TEST_RELEASE_OPTOUT);
    }
    case 4065: { // test_only.unexpired
      return Some(ScalarID::TELEMETRY_TEST_UNEXPIRED);
    }
    case 4071: { // test_only.ipc.a_bool
      return Some(ScalarID::TELEMETRY_TEST_BOOLEAN_KIND);
    }
    case 4072: { // test_only.ipc.a_counter
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_COUNTER);
    }
    case 4075: { // test_only.ipc.a_date
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_DATE);
    }
    case 4076: { // test_only.ipc.a_labeled_counter
      return Some(ScalarID::TELEMETRY_TEST_ANOTHER_MIRROR_FOR_LABELED_COUNTER);
    }
    case 4082: { // test_only.ipc.a_string
      return Some(ScalarID::TELEMETRY_TEST_MULTIPLE_STORES_STRING);
    }
    case 4083: { // test_only.ipc.a_string_list
      return Some(ScalarID::TELEMETRY_TEST_KEYED_BOOLEAN_KIND);
    }
    case 4086: { // test_only.ipc.a_url
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_URL);
    }
    case 4087: { // test_only.ipc.a_uuid
      return Some(ScalarID::TELEMETRY_TEST_STRING_KIND);
    }
    case 4090: { // test_only.ipc.an_unordered_bool
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_UNORDERED_BOOL);
    }
    case 4091: { // test_only.ipc.an_unordered_labeled_boolean
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_UNORDERED_LABELED_BOOL);
    }
    case 4092: { // test_only.ipc.another_labeled_counter
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_LABELED_COUNTER);
    }
    case 4094: { // test_only.ipc.irate
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_RATE);
    }
    case 4171: { // normandy.recipe_freshness
      return Some(ScalarID::NORMANDY_RECIPE_FRESHNESS);
    }
    case 4221: { // pwmgr.potentially_breached_passwords
      return Some(ScalarID::PWMGR_POTENTIALLY_BREACHED_PASSWORDS);
    }
    case 4303: { // pictureinpicture.most_concurrent_players
      return Some(ScalarID::PICTUREINPICTURE_MOST_CONCURRENT_PLAYERS);
    }
    case 4312: { // pictureinpicture.toggle_enabled
      return Some(ScalarID::PICTUREINPICTURE_TOGGLE_ENABLED);
    }
    case 4319: { // places.pages_need_frecency_recalculation
      return Some(ScalarID::PLACES_PAGES_NEED_FRECENCY_RECALCULATION);
    }
    case 4321: { // places.previousday_visits
      return Some(ScalarID::PLACES_PREVIOUSDAY_VISITS);
    }
    case 4322: { // places.sponsored_visit_no_triggering_url
      return Some(ScalarID::PLACES_SPONSORED_VISIT_NO_TRIGGERING_URL);
    }
    case 4323: { // printing.dialog_opened_via_preview_tm
      return Some(ScalarID::PRINTING_DIALOG_OPENED_VIA_PREVIEW_TM);
    }
    case 4324: { // printing.dialog_via_preview_cancelled_tm
      return Some(ScalarID::PRINTING_DIALOG_VIA_PREVIEW_CANCELLED_TM);
    }
    case 4325: { // printing.error
      return Some(ScalarID::PRINTING_ERROR);
    }
    case 4326: { // printing.preview_cancelled_tm
      return Some(ScalarID::PRINTING_PREVIEW_CANCELLED_TM);
    }
    case 4327: { // printing.preview_opened_tm
      return Some(ScalarID::PRINTING_PREVIEW_OPENED_TM);
    }
    case 4328: { // printing.settings_changed
      return Some(ScalarID::PRINTING_SETTINGS_CHANGED);
    }
    case 4329: { // printing.silent_print
      return Some(ScalarID::PRINTING_SILENT_PRINT);
    }
    case 4330: { // printing.target_type
      return Some(ScalarID::PRINTING_TARGET_TYPE);
    }
    case 4331: { // power.cpu_time_bogus_values
      return Some(ScalarID::POWER_CPU_TIME_BOGUS_VALUES);
    }
    case 4332: { // power.cpu_time_per_process_type_ms
      return Some(ScalarID::POWER_CPU_TIME_PER_PROCESS_TYPE_MS);
    }
    case 4335: { // power.gpu_time_bogus_values
      return Some(ScalarID::POWER_GPU_TIME_BOGUS_VALUES);
    }
    case 4336: { // power.gpu_time_per_process_type_ms
      return Some(ScalarID::POWER_GPU_TIME_PER_PROCESS_TYPE_MS);
    }
    case 4337: { // power.total_cpu_time_ms
      return Some(ScalarID::POWER_TOTAL_CPU_TIME_MS);
    }
    case 4338: { // power.total_gpu_time_ms
      return Some(ScalarID::POWER_TOTAL_GPU_TIME_MS);
    }
    case 4339: { // power.total_thread_wakeups
      return Some(ScalarID::POWER_TOTAL_THREAD_WAKEUPS);
    }
    case 4340: { // power.wakeups_per_process_type
      return Some(ScalarID::POWER_WAKEUPS_PER_PROCESS_TYPE);
    }
    case 4611: { // browser.searchinit.engine_invalid_webextension
      return Some(ScalarID::BROWSER_SEARCHINIT_ENGINE_INVALID_WEBEXTENSION);
    }
    case 4612: { // browser.searchinit.insecure_opensearch_engine_count
      return Some(ScalarID::BROWSER_SEARCHINIT_INSECURE_OPENSEARCH_ENGINE_COUNT);
    }
    case 4613: { // browser.searchinit.insecure_opensearch_update_count
      return Some(ScalarID::BROWSER_SEARCHINIT_INSECURE_OPENSEARCH_UPDATE_COUNT);
    }
    case 4614: { // browser.searchinit.secure_opensearch_engine_count
      return Some(ScalarID::BROWSER_SEARCHINIT_SECURE_OPENSEARCH_ENGINE_COUNT);
    }
    case 4615: { // browser.searchinit.secure_opensearch_update_count
      return Some(ScalarID::BROWSER_SEARCHINIT_SECURE_OPENSEARCH_UPDATE_COUNT);
    }
    case 4639: { // browser.timings.last_shutdown
      return Some(ScalarID::BROWSER_TIMINGS_LAST_SHUTDOWN);
    }
    case 4643: { // telemetry.data_upload_optin
      return Some(ScalarID::TELEMETRY_DATA_UPLOAD_OPTIN);
    }
    case 4693: { // findbar.find_next
      return Some(ScalarID::FINDBAR_FIND_NEXT);
    }
    case 4694: { // findbar.find_prev
      return Some(ScalarID::FINDBAR_FIND_PREV);
    }
    case 4695: { // findbar.highlight_all
      return Some(ScalarID::FINDBAR_HIGHLIGHT_ALL);
    }
    case 4696: { // findbar.match_case
      return Some(ScalarID::FINDBAR_MATCH_CASE);
    }
    case 4697: { // findbar.match_diacritics
      return Some(ScalarID::FINDBAR_MATCH_DIACRITICS);
    }
    case 4698: { // findbar.shown
      return Some(ScalarID::FINDBAR_SHOWN);
    }
    case 4699: { // findbar.whole_words
      return Some(ScalarID::FINDBAR_WHOLE_WORDS);
    }
    case 4725: { // mozstorage.sqlitejsm_transaction_timeout
      return Some(ScalarID::MOZSTORAGE_SQLITEJSM_TRANSACTION_TIMEOUT);
    }
    case 4800: { // blocklist.mlbf_softblocks_source
      return Some(ScalarID::BLOCKLIST_MLBF_SOFTBLOCKS_SOURCE);
    }
    case 4801: { // blocklist.mlbf_source
      return Some(ScalarID::BLOCKLIST_MLBF_SOURCE);
    }
    case 4806: { // update.bitshresult
      return Some(ScalarID::UPDATE_BITSHRESULT);
    }
    case 4813: { // update.move_result
      return Some(ScalarID::UPDATE_MOVE_RESULT);
    }
    case 4814: { // update.no_window_auto_restarts
      return Some(ScalarID::UPDATE_NO_WINDOW_AUTO_RESTARTS);
    }
    case 4817: { // update.suppress_prompts
      return Some(ScalarID::UPDATE_SUPPRESS_PROMPTS);
    }
    case 4818: { // update.version_pin
      return Some(ScalarID::UPDATE_VERSION_PIN);
    }
    case 4821: { // widget.ime_name_on_mac
      return Some(ScalarID::WIDGET_IME_NAME_ON_MAC);
    }
    case 4822: { // widget.gtk_version
      return Some(ScalarID::WIDGET_GTK_VERSION);
    }
    case 4823: { // widget.ime_name_on_linux
      return Some(ScalarID::WIDGET_IME_NAME_ON_LINUX);
    }
    case 4824: { // widget.dark_mode
      return Some(ScalarID::WIDGET_DARK_MODE);
    }
    case 4826: { // widget.ime_name_on_windows
      return Some(ScalarID::WIDGET_IME_NAME_ON_WINDOWS);
    }
    case 4827: { // widget.ime_name_on_windows_inserted_crlf
      return Some(ScalarID::WIDGET_IME_NAME_ON_WINDOWS_INSERTED_CRLF);
    }
    default: {
      if (MOZ_UNLIKELY(aId & (1 << DYNAMIC_METRIC_BIT))) {
        // Dynamic (runtime-registered) metric. Use its static (compiletime-
        // registered) metric's telemetry_mirror mapping.
        // ...if applicable.

        // Only JS can use dynamic (runtime-registered) metric ids.
        MOZ_ASSERT(NS_IsMainThread());

        auto metricName = JOG::GetMetricName(aId);
        // All of these should have names, but the storage only lasts until
        // XPCOMWillShutdown, so it might return `Nothing()`.
        if (metricName.isSome()) {
          auto maybeMetric = MetricByNameLookup(metricName.ref());
          if (maybeMetric.isSome()) {
            uint32_t staticId = GLEAN_METRIC_ID(maybeMetric.value());
            // Let's ensure we don't infinite loop, huh.
            MOZ_ASSERT(!(staticId & (1 << DYNAMIC_METRIC_BIT)));
            return ScalarIdForMetric(staticId);
          }
        }
      }
      return Nothing();
    }
  }
}

}  // namespace mozilla::glean

#undef GLEAN_METRIC_ID
#undef DYNAMIC_METRIC_BIT

#endif  // mozilla_glean_ScalarGifftMaps_h
