// -*- mode: C++ -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_Metrics_h
#define mozilla_Metrics_h

#include "mozilla/glean/bindings/MetricTypes.h"
#include "mozilla/Maybe.h"
#include "nsTArray.h"
#include "nsPrintfCString.h"

#include <tuple>

namespace mozilla::glean {
struct NoExtraKeys;
enum class DynamicLabel: uint16_t { };

namespace a11y {
  /**
   * generated from a11y.always_underline_links
   */
  /**
   * Bool tracking if the user has always underline links enabled in firefox. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * a11y.always_underline_links.
   */
  constexpr impl::BooleanMetric always_underline_links(1);

  /**
   * generated from a11y.backplate
   */
  /**
   * Boolean tracking if the user has the backplate preference enabled or disabled.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * a11y.backplate.
   */
  constexpr impl::BooleanMetric backplate(2);

  /**
   * generated from a11y.hcm_background
   */
  /**
   * Unsigned int tracking the user's prefered background color \ (logged when HCM
     * is enabled). This metric was generated to correspond to the Legacy Telemetry
     * scalar a11y.HCM_background.
   */
  constexpr impl::QuantityMetric hcm_background(3);

  /**
   * generated from a11y.hcm_foreground
   */
  /**
   * Unsigned int tracking the user's prefered foreground color \ (logged when HCM
     * is enabled). This metric was generated to correspond to the Legacy Telemetry
     * scalar a11y.HCM_foreground.
   */
  constexpr impl::QuantityMetric hcm_foreground(4);

  /**
   * generated from a11y.instantiators
   */
  /**
   * The leaf name and version number of the binary for the process responsible for
     * remotely instantiating a11y. This metric was generated to correspond to the
     * Legacy Telemetry scalar a11y.instantiators.
   */
  constexpr impl::StringMetric instantiators(5);

  /**
   * generated from a11y.invert_colors
   */
  /**
   * Boolean tracking if the user has an invert colors OS setting enabled. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * a11y.invert_colors.
   */
  constexpr impl::BooleanMetric invert_colors(6);

  /**
   * generated from a11y.theme
   */
  enum class ThemeLabel: uint16_t {
      eDefault = 0,
      eAlways = 1,
      eNever = 2,
      e__Other__,
    };
  /**
   * OS high contrast or other accessibility theme is enabled. The result is split
     * into keys which represent the values of browser.display.document_color_use:
     * "default", "always", or "never". This metric was generated to correspond to the
     * Legacy Telemetry scalar a11y.theme.
   */
  constexpr impl::Labeled<impl::BooleanMetric, ThemeLabel> theme(7);

  /**
   * generated from a11y.use_system_colors
   */
  /**
   * Bool tracking if the user has system colors enabled in firefox. This metric was
     * generated to correspond to the Legacy Telemetry scalar a11y.use_system_colors.
   */
  constexpr impl::BooleanMetric use_system_colors(8);

}
namespace browser_engagement {
  /**
   * generated from browser.engagement.bookmarks_toolbar_bookmark_added
   */
  /**
   * The count of bookmarks added to the bookmarks toolbar. This counts bookmarks
     * created on the bookmarks toolbar and bookmarks moved to the bookmarks toolbar.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.bookmarks_toolbar_bookmark_added.
   */
  constexpr impl::CounterMetric bookmarks_toolbar_bookmark_added(9);

  /**
   * generated from browser.engagement.bookmarks_toolbar_bookmark_opened
   */
  /**
   * The count of bookmarks opened from the Bookmarks Toolbar. This counts bookmarks
     * opened on the toolbar and bookmarks opened from the 'symlinked' Other Bookmarks
     * folder on the Bookmarks Toolbar. It does not count Bookmarks Toolbar bookmarks
     * opened via the Library, Bookmarks Menu, or other UI since the goal is to
     * measure interactions that pass through the toolbar. This metric was generated
     * to correspond to the Legacy Telemetry scalar
     * browser.engagement.bookmarks_toolbar_bookmark_opened.
   */
  constexpr impl::CounterMetric bookmarks_toolbar_bookmark_opened(10);

  /**
   * generated from browser.engagement.sessionrestore_interstitial
   */
  /**
   * Whether we show about:sessionrestore or not. Split by key, which indicates why
     * we showed the item or not. Specifically, 'deferred_restore' means we didn't
     * autorestore and thus didn't show the interstitial; 'autorestore' indicates we
     * autorestored without showing the interstitial. 'shown_old_session',
     * 'shown_only_about_welcomeback', 'shown_many_crashes',
     * 'shown_many_crashes_old_session' all indicate we did show the interstitial
     * because of a crash, and the text after 'shown' indicates what secondary reason
     * there was to show this page (as we don't show it for 'just' one crash). This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.sessionrestore_interstitial.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> sessionrestore_interstitial(11);

  /**
   * generated from browser.engagement.tab_explicit_unload
   */
    struct TabExplicitUnloadExtra {
      mozilla::Maybe<bool> allTabsUnloaded;
      mozilla::Maybe<uint32_t> memoryAfter;
      mozilla::Maybe<uint32_t> memoryBefore;
      mozilla::Maybe<uint32_t> tabsUnloaded;
      mozilla::Maybe<uint32_t> timeToUnloadInMs;
      mozilla::Maybe<bool> unloadSelectedTab;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (allTabsUnloaded) {
          extraKeys.AppendElement()->AssignASCII("all_tabs_unloaded");
          extraValues.AppendElement()->AssignASCII(allTabsUnloaded.value() ? "true" : "false");
        }
        if (memoryAfter) {
          extraKeys.AppendElement()->AssignASCII("memory_after");
          extraValues.EmplaceBack(nsPrintfCString("%d", memoryAfter.value()));
        }
        if (memoryBefore) {
          extraKeys.AppendElement()->AssignASCII("memory_before");
          extraValues.EmplaceBack(nsPrintfCString("%d", memoryBefore.value()));
        }
        if (tabsUnloaded) {
          extraKeys.AppendElement()->AssignASCII("tabs_unloaded");
          extraValues.EmplaceBack(nsPrintfCString("%d", tabsUnloaded.value()));
        }
        if (timeToUnloadInMs) {
          extraKeys.AppendElement()->AssignASCII("time_to_unload_in_ms");
          extraValues.EmplaceBack(nsPrintfCString("%d", timeToUnloadInMs.value()));
        }
        if (unloadSelectedTab) {
          extraKeys.AppendElement()->AssignASCII("unload_selected_tab");
          extraValues.AppendElement()->AssignASCII(unloadSelectedTab.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user explicitly unloads tab(s) from memory via the tab
     * context menu.
   */
  constexpr impl::EventMetric<TabExplicitUnloadExtra> tab_explicit_unload(12);

  /**
   * generated from browser.engagement.tab_reload_count
   */
  /**
   * The count of tab reload events by the user after unloaded. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.tab_reload_count.
   */
  constexpr impl::CounterMetric tab_reload_count(13);

  /**
   * generated from browser.engagement.tab_unload_count
   */
  /**
   * The count of tab unload events by TabUnloader due to a low-memory situation.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.tab_unload_count.
   */
  constexpr impl::CounterMetric tab_unload_count(14);

  /**
   * generated from browser.engagement.active_ticks
   */
  /**
   * The number of five-second intervals ('ticks') the user was considered
     * 'active'.
     * 
     * 'active' means keyboard or mouse interaction with the application.
     * It doesn't take into account whether or not the window has focus or is in
     * the foreground, only if it is receiving these interaction events.
     * 
     * Migrated from Telemetry's `browser.engagement.active_ticks`.
   */
  constexpr impl::CounterMetric active_ticks(15);

  /**
   * generated from browser.engagement.max_concurrent_tab_count
   */
  /**
   * The count of maximum number of tabs open during a subsession, across all
     * windows, including tabs in private windows and restored at startup. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.max_concurrent_tab_count.
   */
  constexpr impl::QuantityMetric max_concurrent_tab_count(16);

  /**
   * generated from browser.engagement.max_concurrent_tab_pinned_count
   */
  /**
   * The count of maximum number of pinned tabs open during a subsession. This
     * includes private windows and the ones opened when starting the browser.
     * Starting Firefox 85 this includes number of restored pinned tabs at startup.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.max_concurrent_tab_pinned_count.
   */
  constexpr impl::QuantityMetric max_concurrent_tab_pinned_count(17);

  /**
   * generated from browser.engagement.max_concurrent_vertical_tab_count
   */
  /**
   * The count of maximum number of tabs with vertical tabs enabled. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.max_concurrent_vertical_tab_count.
   */
  constexpr impl::QuantityMetric max_concurrent_vertical_tab_count(18);

  /**
   * generated from browser.engagement.max_concurrent_vertical_tab_pinned_count
   */
  /**
   * The count of maximum number of pinned tabs with vertical tabs enabled. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.max_concurrent_vertical_tab_pinned_count.
   */
  constexpr impl::QuantityMetric max_concurrent_vertical_tab_pinned_count(19);

  /**
   * generated from browser.engagement.max_concurrent_window_count
   */
  /**
   * The count of maximum number of browser windows open during a subsession. This
     * includes private windows and the ones opened when starting the browser. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.max_concurrent_window_count.
   */
  constexpr impl::QuantityMetric max_concurrent_window_count(20);

  /**
   * generated from browser.engagement.profile_count
   */
  /**
   * Windows only count of the browser profiles on the current system. This
     * counts profiles that have been used across all Windows user accounts on
     * machine since this probe was added. The value persists across installs.
     * A value of 0 is reported if there is an error determining the correct
     * count. Unset on other platforms.
   */
  constexpr impl::QuantityMetric profile_count(21);

  /**
   * generated from browser.engagement.tab_open_event_count
   */
  /**
   * The count of tab open events per subsession, across all windows, after the
     * session has been restored. This includes tab open events from private windows
     * and from manual session restorations (i.e. after crashes and from about:home),
     * but excludes tabs opened vertically. This metric was generated to correspond to
     * the Legacy Telemetry scalar browser.engagement.tab_open_event_count.
   */
  constexpr impl::CounterMetric tab_open_event_count(22);

  /**
   * generated from browser.engagement.tab_pinned_event_count
   */
  /**
   * The count of tab pinned events per subsession, across all windows, after the
     * session has been restored. This includes tab pinned events from private
     * windows. This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.tab_pinned_event_count.
   */
  constexpr impl::CounterMetric tab_pinned_event_count(23);

  /**
   * generated from browser.engagement.unfiltered_uri_count
   */
  /**
   * The count of the total non-unique URIs visited in a subsession, not restricted
     * to a specific protocol, including page reloads and about:* pages (other than
     * initial pages such as about:blank, ...), after the session has been restored.
     * This does not include background page requests and URIs from embedded pages or
     * private browsing. This metric was generated to correspond to the Legacy
     * Telemetry scalar browser.engagement.unfiltered_uri_count.
   */
  constexpr impl::CounterMetric unfiltered_uri_count(24);

  /**
   * generated from browser.engagement.unique_domains_count
   */
  /**
   * The count of the unique domains visited in a subsession, after the session has
     * been restored. Subdomains under eTLD are aggregated after the first level (i.e.
     * test.example.com and other.example.com are only counted once). This does not
     * include background page requests and domains from embedded pages or private
     * browsing. The count is limited to 100 unique domains. This metric was generated
     * to correspond to the Legacy Telemetry scalar
     * browser.engagement.unique_domains_count.
   */
  constexpr impl::QuantityMetric unique_domains_count(25);

  /**
   * generated from browser.engagement.uri_count
   */
  /**
   * The number of total non-unique http(s) URIs visited, including page
     * reloads, after the session has been restored. URIs on minimized or
     * background tabs may also be counted. Private browsing uris are included.
     * 
     * Migrated from Telemetry's
     * `browser.engagement.total_uri_count_normal_and_private_mode`.
   */
  constexpr impl::CounterMetric uri_count(26);

  /**
   * generated from browser.engagement.uri_count_normal_mode
   */
  /**
   * The count of the total non-unique http(s) URIs visited in a subsession,
     * including page reloads, after the session has been restored. URIs on minimized
     * or background tabs may also be counted towards this. Private browsing is not
     * included in this count. This metric was generated to correspond to the Legacy
     * Telemetry scalar browser.engagement.total_uri_count.
   */
  constexpr impl::CounterMetric uri_count_normal_mode(27);

  /**
   * generated from browser.engagement.vertical_tab_open_event_count
   */
  /**
   * The count of tab open events with vertical tabs enabled. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.vertical_tab_open_event_count.
   */
  constexpr impl::CounterMetric vertical_tab_open_event_count(28);

  /**
   * generated from browser.engagement.vertical_tab_pinned_event_count
   */
  /**
   * The count of tab pinned events with vertical tabs enabled. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.vertical_tab_pinned_event_count.
   */
  constexpr impl::CounterMetric vertical_tab_pinned_event_count(29);

  /**
   * generated from browser.engagement.window_open_event_count
   */
  /**
   * The count of browser window open events per subsession, after the session has
     * been restored. The count includes private windows and the ones from manual
     * session restorations (i.e. after crashes and from about:home). This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.window_open_event_count.
   */
  constexpr impl::CounterMetric window_open_event_count(30);

  /**
   * generated from browser.engagement.session_time_excluding_suspend
   */
  /**
   * The duration of the session in milliseconds, excluding the time the device was
     * suspended. This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.engagement.session_time_excluding_suspend.
   */
  constexpr impl::QuantityMetric session_time_excluding_suspend(31);

  /**
   * generated from browser.engagement.session_time_including_suspend
   */
  /**
   * The duration of the session in milliseconds, including the time the device was
     * suspended. This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.engagement.session_time_including_suspend.
   */
  constexpr impl::QuantityMetric session_time_including_suspend(32);

}
namespace networking {
  /**
   * generated from networking.captive_portal_banner_display_time
   */
  enum class CaptivePortalBannerDisplayTimeLabel: uint16_t {
      eSuccess = 0,
      eAbort = 1,
      eDismiss = 2,
      e__Other__,
    };
  /**
   * Number of seconds the captive portal banner was displayed for, keyed by close
     * reason:
     *   "success" - the portal login was completed
     *   "abort"   - the portal login was aborted (e.g. loss of network)
     *   "dismiss" - the user dismissed the banner
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * networking.captive_portal_banner_display_time.
   */
  constexpr impl::Labeled<impl::CounterMetric, CaptivePortalBannerDisplayTimeLabel> captive_portal_banner_display_time(33);

  /**
   * generated from networking.captive_portal_banner_displayed
   */
  /**
   * Number of times the captive portal banner was displayed in this session. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * networking.captive_portal_banner_displayed.
   */
  constexpr impl::CounterMetric captive_portal_banner_displayed(34);

  /**
   * generated from networking.doh_heuristic_ever_tripped
   */
  /**
   * True if this heuristic (key) was ever tripped during the session. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * networking.doh_heuristic_ever_tripped.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> doh_heuristic_ever_tripped(35);

  /**
   * generated from networking.doh_heuristics_attempts
   */
  /**
   * The number of times we ran DoH heuristics. This metric was generated to
     * correspond to the Legacy Telemetry scalar networking.doh_heuristics_attempts.
   */
  constexpr impl::CounterMetric doh_heuristics_attempts(36);

  /**
   * generated from networking.doh_heuristics_pass_count
   */
  /**
   * The number of times we passed DoH heuristics. This metric was generated to
     * correspond to the Legacy Telemetry scalar networking.doh_heuristics_pass_count.
   */
  constexpr impl::CounterMetric doh_heuristics_pass_count(37);

  /**
   * generated from networking.doh_heuristics_result
   */
  /**
   * The value of this scalar indicates the result of the last heuristic run. 0:
     * "incomplete" 1: "pass" 2: "opt-out" 3: "manually-disabled" 4: "manually-
     * enabled" 5: "enterprise-disabled" 6: "enterprise- present" 7: "enterprise-
     * enabled" 8: "vpn" 9: "proxy" 10: "nrpt" 11: "parental" 12: "modifiedRoots" 13:
     * "thirdPartyRoots" 14: "google" 15: "youtube" 16: "zscaler" 17: "canary" 18:
     * "ignored" This metric was generated to correspond to the Legacy Telemetry
     * scalar networking.doh_heuristics_result.
   */
  constexpr impl::QuantityMetric doh_heuristics_result(38);

  /**
   * generated from networking.cache_metadata_first_read_time
   */
  /**
   * Time spent to read the first part of the metadata from the cache entry file.
   */
  constexpr impl::TimingDistributionMetric cache_metadata_first_read_time(39);

  /**
   * generated from networking.cache_metadata_second_read_time
   */
  /**
   * Time spent to read the missing part of the metadata from the cache entry file.
   */
  constexpr impl::TimingDistributionMetric cache_metadata_second_read_time(40);

  /**
   * generated from networking.cache_metadata_size
   */
  /**
   * Size of the metadata in bytes parsed from the disk.
   */
  constexpr impl::MemoryDistributionMetric cache_metadata_size(41);

  /**
   * generated from networking.cookie_access_fixup_diff
   */
  /**
   * If we fix up a cookie lastAccessed timestamp that is in the future this metric
     * records the number of seconds that timestamp was off from NOW.
   */
  constexpr impl::CustomDistributionMetric cookie_access_fixup_diff(42);

  /**
   * generated from networking.cookie_chips_partition_limit_overflow
   */
  /**
   * The number of cookie bytes exceeding chips partition limit capacity for a
     * single partition
   */
  constexpr impl::CustomDistributionMetric cookie_chips_partition_limit_overflow(43);

  /**
   * generated from networking.cookie_count_invalid_first_party_partitioned_in_db
   */
  /**
   * This counts the number of invalid first-party partitioned cookies that don't
     * have the partitioned cookie attribution(CHIPS).
   */
  constexpr impl::CounterMetric cookie_count_invalid_first_party_partitioned_in_db(44);

  /**
   * generated from networking.cookie_count_part_by_key
   */
  /**
   * A distribution of the partitioned cookies in storage belonging to a particular
     * cookie key (host + origin attributes)
   */
  constexpr impl::CustomDistributionMetric cookie_count_part_by_key(45);

  /**
   * generated from networking.cookie_count_partitioned
   */
  /**
   * Reports the number of partitioned cookies in storage
   */
  constexpr impl::CustomDistributionMetric cookie_count_partitioned(46);

  /**
   * generated from networking.cookie_count_total
   */
  /**
   * Reports the total number of cookies in storage
   */
  constexpr impl::CustomDistributionMetric cookie_count_total(47);

  /**
   * generated from networking.cookie_count_unpart_by_key
   */
  /**
   * A distribution of the unpartitioned cookies in storage belonging to a
     * particular cookie key (host + origin attributes)
   */
  constexpr impl::CustomDistributionMetric cookie_count_unpart_by_key(48);

  /**
   * generated from networking.cookie_count_unpartitioned
   */
  /**
   * Reports the number of unpartitioned cookies in storage
   */
  constexpr impl::CustomDistributionMetric cookie_count_unpartitioned(49);

  /**
   * generated from networking.cookie_creation_fixup_diff
   */
  /**
   * If we fix up a cookie creation timestamp that is in the future this metric
     * records the number of seconds that timestamp was off from NOW.
   */
  constexpr impl::CustomDistributionMetric cookie_creation_fixup_diff(50);

  /**
   * generated from networking.cookie_purge_entry_max
   */
  /**
   * A distribution of the number of cookies purged for a single host + OA entry as
     * a result of exceeding the maximum threshold for the given host + OA (single
     * purge)
   */
  constexpr impl::CustomDistributionMetric cookie_purge_entry_max(51);

  /**
   * generated from networking.cookie_purge_max
   */
  /**
   * A distribution of the number of cookies purged across all host + OAs as a
     * result of exceeding the cookie maximum threshold (single purge)
   */
  constexpr impl::CustomDistributionMetric cookie_purge_max(52);

  /**
   * generated from networking.cookie_timestamp_fixed_count
   */
  enum class CookieTimestampFixedCountLabel: uint16_t {
      eCreationtime = 0,
      eLastaccessed = 1,
      e__Other__,
    };
  /**
   * Counts the number of times a cookie's invalid timestamp was fixed when reading
     * it from the DB.
   */
  constexpr impl::Labeled<impl::CounterMetric, CookieTimestampFixedCountLabel> cookie_timestamp_fixed_count(53);

  /**
   * generated from networking.dns_failed_lookup_time
   */
  /**
   * Time for an unsuccessful DNS OS resolution (msec) | Migrated from Firefox
     * Telemetry's `DNS_FAILED_LOOKUP_TIME`.
   */
  constexpr impl::TimingDistributionMetric dns_failed_lookup_time(54);

  /**
   * generated from networking.dns_lookup_time
   */
  /**
   * Time for a successful DNS resolution (msec) | Migrated from Firefox Telemetry's
     * `DNS_LOOKUP_TIME`.
   */
  constexpr impl::TimingDistributionMetric dns_lookup_time(55);

  /**
   * generated from networking.dns_native_count
   */
  enum class DnsNativeCountLabel: uint16_t {
      eRegular = 0,
      ePrivate = 1,
      eHttpsRegular = 2,
      eHttpsPrivate = 3,
      e__Other__,
    };
  /**
   * The count of calls to the native DNS APIs
   */
  constexpr impl::Labeled<impl::CounterMetric, DnsNativeCountLabel> dns_native_count(56);

  /**
   * generated from networking.dns_native_https_call_time
   */
  /**
   * Time spent in the call to the native OS DNS resolution.
   */
  constexpr impl::TimingDistributionMetric dns_native_https_call_time(57);

  /**
   * generated from networking.dns_renewal_time
   */
  /**
   * Time for a renewed DNS OS resolution (msec) | Migrated from Firefox Telemetry's
     * `DNS_RENEWAL_TIME`.
   */
  constexpr impl::TimingDistributionMetric dns_renewal_time(58);

  /**
   * generated from networking.dns_renewal_time_for_ttl
   */
  /**
   * Time for a DNS OS resolution (msec) used to get TTL | Migrated from Firefox
     * Telemetry's `DNS_RENEWAL_TIME_FOR_TTL`.
   */
  constexpr impl::TimingDistributionMetric dns_renewal_time_for_ttl(59);

  /**
   * generated from networking.fetch_keepalive_discard_count
   */
  enum class FetchKeepaliveDiscardCountLabel: uint16_t {
      eTotalKeepaliveLimit = 0,
      ePerOriginLimit = 1,
      e__Other__,
    };
  /**
   * Counts how many fetch keepalive requests are dropped due to configured resource
     * limits.
   */
  constexpr impl::Labeled<impl::CounterMetric, FetchKeepaliveDiscardCountLabel> fetch_keepalive_discard_count(60);

  /**
   * generated from networking.fetch_keepalive_request_count
   */
  enum class FetchKeepaliveRequestCountLabel: uint16_t {
      eWorker = 0,
      eMain = 1,
      e__Other__,
    };
  /**
   * Counts how many fetch keepalive requests are made. This counter helps us to
     * understand the adoption of fetch keepalive for firefox.
   */
  constexpr impl::Labeled<impl::CounterMetric, FetchKeepaliveRequestCountLabel> fetch_keepalive_request_count(61);

  /**
   * generated from networking.http_1_download_throughput
   */
  /**
   * The download throughput for  http/1.0, http/1.1 requests larger than 10MB.
     * Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_download_throughput(62);

  /**
   * generated from networking.http_1_download_throughput_100
   */
  /**
   * The download throughput for http/1.0 and http/1.1 requests size larger than
     * 100MB. Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_download_throughput_100(63);

  /**
   * generated from networking.http_1_download_throughput_10_50
   */
  /**
   * The download throughput for http/1.0 and http/1.1 requests between 10MB and
     * 50MB. Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_download_throughput_10_50(64);

  /**
   * generated from networking.http_1_download_throughput_50_100
   */
  /**
   * The download throughput for http/1.0 and http/1.1 requests between 50MB and
     * 100MB. Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_download_throughput_50_100(65);

  /**
   * generated from networking.http_1_upload_throughput
   */
  /**
   * The upload throughput for http/1.0, http/1.1 requests larger than 10MB.
     * Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_upload_throughput(66);

  /**
   * generated from networking.http_1_upload_throughput_100
   */
  /**
   * The upload throughput for http/1.0, http/1.1 request size larger than 100MB.
     * Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_upload_throughput_100(67);

  /**
   * generated from networking.http_1_upload_throughput_10_50
   */
  /**
   * The upload throughput for http/1.0, http/1.1 request size between 10MB and
     * 50MB. Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_upload_throughput_10_50(68);

  /**
   * generated from networking.http_1_upload_throughput_50_100
   */
  /**
   * The upload throughput for http/1.0, http/1.1 request size between 50MB and
     * 100MB. Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_upload_throughput_50_100(69);

  /**
   * generated from networking.http_2_download_throughput
   */
  /**
   * The download throughput for http/2 requests larger than 10MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_download_throughput(70);

  /**
   * generated from networking.http_2_download_throughput_100
   */
  /**
   * The download throughput for http/2 requests size larger than 100MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_download_throughput_100(71);

  /**
   * generated from networking.http_2_download_throughput_10_50
   */
  /**
   * The download throughput for http/2 requests between 10MB and 50MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_download_throughput_10_50(72);

  /**
   * generated from networking.http_2_download_throughput_50_100
   */
  /**
   * The download throughput for http/2 requests between 50MB and 100MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_download_throughput_50_100(73);

  /**
   * generated from networking.http_2_upload_throughput
   */
  /**
   * The upload throughput for http/2 requests larger than 10MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_upload_throughput(74);

  /**
   * generated from networking.http_2_upload_throughput_100
   */
  /**
   * The upload throughput for http/2 request size larger than 100MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_upload_throughput_100(75);

  /**
   * generated from networking.http_2_upload_throughput_10_50
   */
  /**
   * The upload throughput for http/2 request size between 10MB and 50MB. Measured
     * in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_upload_throughput_10_50(76);

  /**
   * generated from networking.http_2_upload_throughput_50_100
   */
  /**
   * The upload throughput for http/2 request size between 50MB and 100MB. Measured
     * in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_upload_throughput_50_100(77);

  /**
   * generated from networking.http_3_connection_close_reason
   */
  enum class Http3ConnectionCloseReasonLabel: uint16_t {
      eApplication = 0,
      eNoerror = 1,
      eInternalerror = 2,
      eConnectionrefused = 3,
      eFlowcontrolerror = 4,
      eStreamlimiterror = 5,
      eStreamstateerror = 6,
      eFinalsizeerror = 7,
      eFrameencodingerror = 8,
      eTransportparametererror = 9,
      eProtocolviolation = 10,
      eInvalidtoken = 11,
      eApplicationerror = 12,
      eCryptobufferexceeded = 13,
      eCryptoerror = 14,
      eQlogerror = 15,
      eCryptoalert = 16,
      eEchretry = 17,
      eAckedunsentpacket = 18,
      eConnectionidlimitexceeded = 19,
      eConnectionidsexhausted = 20,
      eConnectionstate = 21,
      eDecodingframe = 22,
      eDecrypterror = 23,
      eDisabledversion = 24,
      eIdletimeout = 25,
      eIntegeroverflow = 26,
      eInvalidinput = 27,
      eInvalidmigration = 28,
      eInvalidpacket = 29,
      eInvalidresumptiontoken = 30,
      eInvalidretry = 31,
      eInvalidstreamid = 32,
      eKeysdiscarded = 33,
      eKeysexhausted = 34,
      eKeyspending = 35,
      eKeyupdateblocked = 36,
      eNoavailablepath = 37,
      eNomoredata = 38,
      eNotavailable = 39,
      eNotconnected = 40,
      ePacketnumberoverlap = 41,
      ePeerapplicationerror = 42,
      ePeererror = 43,
      eStatelessreset = 44,
      eToomuchdata = 45,
      eUnexpectedmessage = 46,
      eUnknownconnectionid = 47,
      eUnknownframetype = 48,
      eVersionnegotiation = 49,
      eWrongrole = 50,
      e__Other__,
    };
  /**
   * Number of HTTP3 connections closed, labeled by reason.
   */
  constexpr impl::Labeled<impl::CounterMetric, Http3ConnectionCloseReasonLabel> http_3_connection_close_reason(78);

  /**
   * generated from networking.http_3_download_throughput
   */
  /**
   * The download throughput for http/3 requests larger than 10MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_download_throughput(79);

  /**
   * generated from networking.http_3_download_throughput_100
   */
  /**
   * The download throughput for http/3 requests size larger than 100MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_download_throughput_100(80);

  /**
   * generated from networking.http_3_download_throughput_10_50
   */
  /**
   * The download throughput for http/3 requests between 10MB and 50MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_download_throughput_10_50(81);

  /**
   * generated from networking.http_3_download_throughput_50_100
   */
  /**
   * The download throughput for http/3 requests between 50MB and 100MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_download_throughput_50_100(82);

  /**
   * generated from networking.http_3_ecn_ce_ect0_ratio_received
   */
  /**
   * HTTP3: ECN CE to ECT0 ratio (multiply by 10000) received.
   */
  constexpr impl::CustomDistributionMetric http_3_ecn_ce_ect0_ratio_received(83);

  /**
   * generated from networking.http_3_ecn_ce_ect0_ratio_sent
   */
  /**
   * HTTP3: ECN CE to ECT0 ratio (multiply by 10000) sent.
   */
  constexpr impl::CustomDistributionMetric http_3_ecn_ce_ect0_ratio_sent(84);

  /**
   * generated from networking.http_3_ecn_path_capability
   */
  enum class Http3EcnPathCapabilityLabel: uint16_t {
      eCapable = 0,
      eNotCapable = 1,
      e__Other__,
    };
  /**
   * Number of paths known to be ECN capable or not-capable.
   */
  constexpr impl::Labeled<impl::CounterMetric, Http3EcnPathCapabilityLabel> http_3_ecn_path_capability(85);

  /**
   * generated from networking.http_3_loss_ratio
   */
  /**
   * HTTP3: packet loss ratio (multiply by 10000).
   */
  constexpr impl::CustomDistributionMetric http_3_loss_ratio(86);

  /**
   * generated from networking.http_3_quic_frame_count
   */
  enum class Http3QuicFrameCountLabel: uint16_t {
      eAckTx = 0,
      eAckRx = 1,
      eCryptoTx = 2,
      eCryptoRx = 3,
      eStreamTx = 4,
      eStreamRx = 5,
      eResetStreamTx = 6,
      eResetStreamRx = 7,
      eStopSendingTx = 8,
      eStopSendingRx = 9,
      ePingTx = 10,
      ePingRx = 11,
      ePaddingTx = 12,
      ePaddingRx = 13,
      eMaxStreamsTx = 14,
      eMaxStreamsRx = 15,
      eStreamsBlockedTx = 16,
      eStreamsBlockedRx = 17,
      eMaxDataTx = 18,
      eMaxDataRx = 19,
      eDataBlockedTx = 20,
      eDataBlockedRx = 21,
      eMaxStreamDataTx = 22,
      eMaxStreamDataRx = 23,
      eStreamDataBlockedTx = 24,
      eStreamDataBlockedRx = 25,
      eNewConnectionIdTx = 26,
      eNewConnectionIdRx = 27,
      eRetireConnectionIdTx = 28,
      eRetireConnectionIdRx = 29,
      ePathChallengeTx = 30,
      ePathChallengeRx = 31,
      ePathResponseTx = 32,
      ePathResponseRx = 33,
      eConnectionCloseTx = 34,
      eConnectionCloseRx = 35,
      eHandshakeDoneTx = 36,
      eHandshakeDoneRx = 37,
      eNewTokenTx = 38,
      eNewTokenRx = 39,
      eAckFrequencyTx = 40,
      eAckFrequencyRx = 41,
      eDatagramTx = 42,
      eDatagramRx = 43,
      e__Other__,
    };
  /**
   * Number of QUIC frames send and received by type.
   */
  constexpr impl::Labeled<impl::CounterMetric, Http3QuicFrameCountLabel> http_3_quic_frame_count(87);

  /**
   * generated from networking.http_3_udp_datagram_segment_size_received
   */
  /**
   * HTTP3 UDP datagram size received.
   */
  constexpr impl::MemoryDistributionMetric http_3_udp_datagram_segment_size_received(88);

  /**
   * generated from networking.http_3_udp_datagram_segment_size_sent
   */
  /**
   * HTTP3 UDP datagram segment size sent.
   */
  constexpr impl::MemoryDistributionMetric http_3_udp_datagram_segment_size_sent(89);

  /**
   * generated from networking.http_3_udp_datagram_segments_received
   */
  /**
   * HTTP3 UDP number of segments per datagram received.
   */
  constexpr impl::CustomDistributionMetric http_3_udp_datagram_segments_received(90);

  /**
   * generated from networking.http_3_udp_datagram_size_received
   */
  /**
   * HTTP3 UDP datagram size received.
   */
  constexpr impl::MemoryDistributionMetric http_3_udp_datagram_size_received(91);

  /**
   * generated from networking.http_3_upload_throughput
   */
  /**
   * The upload throughput for http/3 requests larger than 10MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_upload_throughput(92);

  /**
   * generated from networking.http_3_upload_throughput_100
   */
  /**
   * The upload throughput for http/3 request size larger than 100MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_upload_throughput_100(93);

  /**
   * generated from networking.http_3_upload_throughput_10_50
   */
  /**
   * The upload throughput for http/3 request size between 10MB and 50MB. Measured
     * in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_upload_throughput_10_50(94);

  /**
   * generated from networking.http_3_upload_throughput_50_100
   */
  /**
   * The upload throughput for http/3 request size between 50MB and 100MB. Measured
     * in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_upload_throughput_50_100(95);

  /**
   * generated from networking.http_channel_disposition
   */
  enum class HttpChannelDispositionLabel: uint16_t {
      eHttpCancelled = 0,
      eHttpDisk = 1,
      eHttpNetOk = 2,
      eHttpNetEarlyFail = 3,
      eHttpNetLateFail = 4,
      eHttpsCancelled = 5,
      eHttpsDisk = 6,
      eHttpsNetOk = 7,
      eHttpsNetEarlyFail = 8,
      eHttpsNetLateFail = 9,
      e__Other__,
    };
  /**
   * Channel Disposition for HTTP and HTTPS: cancel, disk, net_ok, net_early_fail,
     * and net_late_fail
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpChannelDispositionLabel> http_channel_disposition(96);

  /**
   * generated from networking.http_channel_disposition_disabled_no_reason
   */
  enum class HttpChannelDispositionDisabledNoReasonLabel: uint16_t {
      eCancel = 0,
      eDisk = 1,
      eNetOk = 2,
      eNetEarlyFail = 3,
      eNetLateFail = 4,
      e__Other__,
    };
  /**
   * Upgrading display content Channel Disposition (key: disabled_no_reason)
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpChannelDispositionDisabledNoReasonLabel> http_channel_disposition_disabled_no_reason(97);

  /**
   * generated from networking.http_channel_disposition_disabled_upgrade
   */
  enum class HttpChannelDispositionDisabledUpgradeLabel: uint16_t {
      eCancel = 0,
      eDisk = 1,
      eNetOk = 2,
      eNetEarlyFail = 3,
      eNetLateFail = 4,
      e__Other__,
    };
  /**
   * Upgrading display content Channel Disposition (key: disable_upgrade)
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpChannelDispositionDisabledUpgradeLabel> http_channel_disposition_disabled_upgrade(98);

  /**
   * generated from networking.http_channel_disposition_disabled_wont
   */
  enum class HttpChannelDispositionDisabledWontLabel: uint16_t {
      eCancel = 0,
      eDisk = 1,
      eNetOk = 2,
      eNetEarlyFail = 3,
      eNetLateFail = 4,
      e__Other__,
    };
  /**
   * Upgrading display content Channel Disposition (key: disabled_wont)
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpChannelDispositionDisabledWontLabel> http_channel_disposition_disabled_wont(99);

  /**
   * generated from networking.http_channel_disposition_enabled_no_reason
   */
  enum class HttpChannelDispositionEnabledNoReasonLabel: uint16_t {
      eCancel = 0,
      eDisk = 1,
      eNetOk = 2,
      eNetEarlyFail = 3,
      eNetLateFail = 4,
      e__Other__,
    };
  /**
   * Upgrading display content Channel Disposition (key: enabled_no_reason)
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpChannelDispositionEnabledNoReasonLabel> http_channel_disposition_enabled_no_reason(100);

  /**
   * generated from networking.http_channel_disposition_enabled_upgrade
   */
  enum class HttpChannelDispositionEnabledUpgradeLabel: uint16_t {
      eCancel = 0,
      eDisk = 1,
      eNetOk = 2,
      eNetEarlyFail = 3,
      eNetLateFail = 4,
      e__Other__,
    };
  /**
   * Upgrading display content Channel Disposition (key: enable_upgrade)
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpChannelDispositionEnabledUpgradeLabel> http_channel_disposition_enabled_upgrade(101);

  /**
   * generated from networking.http_channel_disposition_enabled_wont
   */
  enum class HttpChannelDispositionEnabledWontLabel: uint16_t {
      eCancel = 0,
      eDisk = 1,
      eNetOk = 2,
      eNetEarlyFail = 3,
      eNetLateFail = 4,
      e__Other__,
    };
  /**
   * Upgrading display content Channel Disposition (key: enabled_wont)
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpChannelDispositionEnabledWontLabel> http_channel_disposition_enabled_wont(102);

  /**
   * generated from networking.http_channel_onstart_status
   */
  enum class HttpChannelOnstartStatusLabel: uint16_t {
      eSuccessful = 0,
      eFail = 1,
      e__Other__,
    };
  /**
   * Whether successfully started HTTP channels
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpChannelOnstartStatusLabel> http_channel_onstart_status(103);

  /**
   * generated from networking.http_channel_onstart_success_https_rr
   */
  enum class HttpChannelOnstartSuccessHttpsRrLabel: uint16_t {
      eSuccess = 0,
      eFailure = 1,
      eSuccessEchUsed = 2,
      eFailureEchUsed = 3,
      e__Other__,
    };
  /**
   * Successfully started HTTP channels when HTTPS RR is used
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpChannelOnstartSuccessHttpsRrLabel> http_channel_onstart_success_https_rr(104);

  /**
   * generated from networking.http_channel_page_open_to_first_sent
   */
  /**
   * Time in milliseconds from AsyncOpen to first byte of request sent, applicable
     * for page loads without HTTPS RR
   */
  constexpr impl::TimingDistributionMetric http_channel_page_open_to_first_sent(105);

  /**
   * generated from networking.http_channel_page_open_to_first_sent_https_rr
   */
  /**
   * Time in milliseconds from AsyncOpen to first byte of request sent, applicable
     * for page loads with HTTPS RR
   */
  constexpr impl::TimingDistributionMetric http_channel_page_open_to_first_sent_https_rr(106);

  /**
   * generated from networking.http_channel_sub_open_to_first_sent
   */
  /**
   * Time in milliseconds from AsyncOpen to first byte of request sent, applicable
     * for sub-resource loads without HTTPS RR
   */
  constexpr impl::TimingDistributionMetric http_channel_sub_open_to_first_sent(107);

  /**
   * generated from networking.http_channel_sub_open_to_first_sent_https_rr
   */
  /**
   * Time in milliseconds from AsyncOpen to first byte of request sent, applicable
     * for sub-resource loads with HTTPS RR
   */
  constexpr impl::TimingDistributionMetric http_channel_sub_open_to_first_sent_https_rr(108);

  /**
   * generated from networking.http_content_cssloader_ondatafinished_to_onstop_delay
   */
  /**
   * The time between processing OnDataFinished and processing OnStopRequest for
     * CSSLoader in the content process
   */
  constexpr impl::TimingDistributionMetric http_content_cssloader_ondatafinished_to_onstop_delay(109);

  /**
   * generated from networking.http_content_html5parser_ondatafinished_to_onstop_delay
   */
  /**
   * The time between processing OnDataFinished and processing OnStopRequest (if
     * OnDataFinished comes first)
   */
  constexpr impl::TimingDistributionMetric http_content_html5parser_ondatafinished_to_onstop_delay(110);

  /**
   * generated from networking.http_content_ondatafinished_delay
   */
  /**
   * The time between dispatching OnDataFinished from the socket thread and
     * processing it on main/background thread.
   */
  constexpr impl::TimingDistributionMetric http_content_ondatafinished_delay(111);

  /**
   * generated from networking.http_content_ondatafinished_delay_2
   */
  /**
   * The time between dispatching OnDataFinished from the socket thread and
     * processing it on the background thread.
   */
  constexpr impl::TimingDistributionMetric http_content_ondatafinished_delay_2(112);

  /**
   * generated from networking.http_content_ondatafinished_to_onstop_delay
   */
  /**
   * The time between processing OnDataFinished and processing OnStopRequest (if
     * OnDataFinished comes first)
   */
  constexpr impl::TimingDistributionMetric http_content_ondatafinished_to_onstop_delay(113);

  /**
   * generated from networking.http_content_onstart_delay
   */
  /**
   * The time between dispatching OnStartRequest from the socket thread and
     * processing it on the main thread (content process).
   */
  constexpr impl::TimingDistributionMetric http_content_onstart_delay(114);

  /**
   * generated from networking.http_content_onstop_delay
   */
  /**
   * The time between dispatching OnStopRequest from the socket thread and
     * processing it on the main thread (content process).
   */
  constexpr impl::TimingDistributionMetric http_content_onstop_delay(115);

  /**
   * generated from networking.http_ip_addr_any_count
   */
  enum class HttpIpAddrAnyCountLabel: uint16_t {
      eNotBlockedRequests = 0,
      eBlockedRequests = 1,
      e__Other__,
    };
  /**
   * The number of times we see the IP address 0.0.0.0 or its IPv6 equivalent.
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpIpAddrAnyCountLabel> http_ip_addr_any_count(116);

  /**
   * generated from networking.http_ip_addr_any_hostnames
   */
  enum class HttpIpAddrAnyHostnamesLabel: uint16_t {
      eSuccess = 0,
      eFailure = 1,
      e__Other__,
    };
  /**
   * The number of times we see the IP address 0.0.0.0 or its IPv6 equivalent used
     * as hostnames
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpIpAddrAnyHostnamesLabel> http_ip_addr_any_hostnames(117);

  /**
   * generated from networking.http_onstart_suspend_total_time
   */
  /**
   * Time in milliseconds that http channel spent suspended between AsyncOpen and
     * OnStartRequest.
   */
  constexpr impl::TimingDistributionMetric http_onstart_suspend_total_time(118);

  /**
   * generated from networking.http_redirect_to_scheme_subresource
   */
  /**
   * Count of the HTTP redirection that triggered by subresource, keyed by the URL
     * scheme redirected to
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> http_redirect_to_scheme_subresource(119);

  /**
   * generated from networking.http_redirect_to_scheme_top_level
   */
  /**
   * Count of the HTTP redirection that triggered by top-level document, keyed by
     * the URL scheme redirected to
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> http_redirect_to_scheme_top_level(120);

  /**
   * generated from networking.http_response_status_code
   */
  enum class HttpResponseStatusCodeLabel: uint16_t {
      e200Ok = 0,
      e301MovedPermanently = 1,
      e302Found = 2,
      e304NotModified = 3,
      e307TemporaryRedirect = 4,
      e308PermanentRedirect = 5,
      e400BadRequest = 6,
      e401Unauthorized = 7,
      e403Forbidden = 8,
      e404NotFound = 9,
      e421MisdirectedRequest = 10,
      e425TooEarly = 11,
      e429TooManyRequests = 12,
      eOther4xx = 13,
      eOther5xx = 14,
      eOther = 15,
      e__Other__,
    };
  /**
   * HTTP Response Status Code (200, 301, 302, 304, 307, 308, 400, 401, 403, 404,
     * 421, 425, 429, other 400 and 500)
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpResponseStatusCodeLabel> http_response_status_code(121);

  /**
   * generated from networking.http_response_version
   */
  enum class HttpResponseVersionLabel: uint16_t {
      eUnknown = 0,
      eHttp1 = 1,
      eHttp2 = 2,
      eHttp3 = 3,
      e__Other__,
    };
  /**
   * HTTP protocol version used on response from nsHttp.h
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpResponseVersionLabel> http_response_version(122);

  /**
   * generated from networking.http_to_https_upgrade_reason
   */
  enum class HttpToHttpsUpgradeReasonLabel: uint16_t {
      eNotInitialized = 0,
      eNotInitializedHttps = 1,
      eNoUpgrade = 2,
      eNoUpgradeHttps = 3,
      eAlreadyHttps = 4,
      eHsts = 5,
      eHttpsOnlyUpgrade = 6,
      eHttpsOnlyUpgradeDowngrade = 7,
      eHttpsFirstUpgrade = 8,
      eHttpsFirstUpgradeDowngrade = 9,
      eHttpsFirstSchemelessUpgrade = 10,
      eHttpsFirstSchemelessUpgradeDowngrade = 11,
      eCspUir = 12,
      eHttpsRr = 13,
      eWebExtensionUpgrade = 14,
      eUpgradeException = 15,
      eSkipUpgrade = 16,
      e__Other__,
    };
  /**
   * Whether a top-level HTTP request gets upgraded to HTTPS and the reason for it
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpToHttpsUpgradeReasonLabel> http_to_https_upgrade_reason(123);

  /**
   * generated from networking.https_http_or_local
   */
  enum class HttpsHttpOrLocalLabel: uint16_t {
      eLoadIsHttps = 0,
      eLoadIsHttp = 1,
      eLoadIsHttpForLocalDomain = 2,
      e__Other__,
    };
  /**
   * Whether a top-level request is HTTPS, HTTP, or HTTP for local domain
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpsHttpOrLocalLabel> https_http_or_local(124);

  /**
   * generated from networking.https_rr_presented
   */
  enum class HttpsRrPresentedLabel: uint16_t {
      ePresented = 0,
      ePresentedWithHttp3 = 1,
      eNone = 2,
      e__Other__,
    };
  /**
   * HTTPS RR is presented or not
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpsRrPresentedLabel> https_rr_presented(125);

  /**
   * generated from networking.os_socket_limit_reached
   */
  /**
   * Counts the number of times the os socket limit was reached. i.e.
     * CanAttachSocket() returned false.
   */
  constexpr impl::CounterMetric os_socket_limit_reached(126);

  /**
   * generated from networking.proxy_info_type
   */
  enum class ProxyInfoTypeLabel: uint16_t {
      eHttp = 0,
      eHttps = 1,
      eSocks4 = 2,
      eSocks4a = 3,
      eSocks5 = 4,
      eSocks5h = 5,
      eDirect = 6,
      eUnknown = 7,
      e__Other__,
    };
  /**
   * The proxies configurations created in the browser session (SOCKSv4, SOCKSv5,
     * HTTP, HTTPS)
   */
  constexpr impl::Labeled<impl::CounterMetric, ProxyInfoTypeLabel> proxy_info_type(127);

  /**
   * generated from networking.residual_cache_folder_count
   */
  /**
   * Counts how often we find a cache folder that wasn't purged at shutdown by a
     * background task process.
   */
  constexpr impl::CounterMetric residual_cache_folder_count(128);

  /**
   * generated from networking.residual_cache_folder_removal
   */
  enum class ResidualCacheFolderRemovalLabel: uint16_t {
      eSuccess = 0,
      eFailure = 1,
      e__Other__,
    };
  /**
   * Counts how often succeed/fail in removing cache folder that wasn't purged at
     * shutdown
   */
  constexpr impl::Labeled<impl::CounterMetric, ResidualCacheFolderRemovalLabel> residual_cache_folder_removal(129);

  /**
   * generated from networking.set_cookie
   */
  /**
   * This counts the number of times we set a cookie. Introduced as a denomenator
     * for measuring CHIPS adoption.
   */
  constexpr impl::DenominatorMetric set_cookie(130);

  /**
   * generated from networking.set_cookie_expired_without_server_time
   */
  /**
   * This counts the number of times a cookie is set already expires but it would
     * not if we considered the server time.
   */
  constexpr impl::NumeratorMetric set_cookie_expired_without_server_time(131);

  /**
   * generated from networking.set_cookie_foreign
   */
  /**
   * This counts the number of times we set a cookie from a foreign (not same-site)
     * context. Introduced as a denomenator for measuring CHIPS adoption.
   */
  constexpr impl::NumeratorMetric set_cookie_foreign(132);

  /**
   * generated from networking.set_cookie_foreign_partitioned
   */
  /**
   * This counts the number of times we set a cookie that has the Partitioned
     * attribute in a foreign (not same-site) context. This tracks the adoption of
     * CHIPS.
   */
  constexpr impl::NumeratorMetric set_cookie_foreign_partitioned(133);

  /**
   * generated from networking.set_cookie_partitioned
   */
  /**
   * This counts the number of times we set a cookie that has the Partitioned
     * attribute. This tracks the adoption of CHIPS.
   */
  constexpr impl::NumeratorMetric set_cookie_partitioned(134);

  /**
   * generated from networking.set_invalid_first_party_partitioned_cookie
   */
  /**
   * This counts the number of times we set an invalid first-party partitioned
     * cookie.
   */
  constexpr impl::CounterMetric set_invalid_first_party_partitioned_cookie(135);

  /**
   * generated from networking.speculative_connect_outcome
   */
  enum class SpeculativeConnectOutcomeLabel: uint16_t {
      eSuccessful = 0,
      eAbortedSocketLimit = 1,
      eAbortedSocketFail = 2,
      eAbortedHttpsNotEnabled = 3,
      e__Other__,
    };
  /**
   * Counts the occurrence of each outcome of a speculative connection
   */
  constexpr impl::Labeled<impl::CounterMetric, SpeculativeConnectOutcomeLabel> speculative_connect_outcome(136);

  /**
   * generated from networking.sqlite_cookies_block_main_thread
   */
  /**
   * Time spent on blocking main thread by startup cookie database read (in
     * milliseconds), only for blocking case
   */
  constexpr impl::TimingDistributionMetric sqlite_cookies_block_main_thread(137);

  /**
   * generated from networking.sqlite_cookies_time_to_block_main_thread
   */
  /**
   * How long (in milliseconds) after we finished reading the cookie db until the
     * first cookie request came in (0 implies we blocked the main thread)
   */
  constexpr impl::TimingDistributionMetric sqlite_cookies_time_to_block_main_thread(138);

  /**
   * generated from networking.transaction_wait_time
   */
  /**
   * Time from submission to dispatch of transaction without HTTPS RR (ms)
   */
  constexpr impl::TimingDistributionMetric transaction_wait_time(139);

  /**
   * generated from networking.transaction_wait_time_https_rr
   */
  /**
   * Time from submission to dispatch of transaction when HTTPS RR is used (ms)
   */
  constexpr impl::TimingDistributionMetric transaction_wait_time_https_rr(140);

  /**
   * generated from networking.trr_complete_load
   */
  enum class TrrCompleteLoadLabel: uint16_t {
      eMozillaCloudflareDnsCom = 0,
      eFirefoxDnsNextdnsIo = 1,
      ePrivateCanadianshieldCiraCa = 2,
      eDohXfinityCom = 3,
      eDnsShawCa = 4,
      eDoohCloudflareDnsCom = 5,
      eMozillaCloudflareDnsCom2 = 6,
      eFirefoxDnsNextdnsIo2 = 7,
      ePrivateCanadianshieldCiraCa2 = 8,
      eDohXfinityCom2 = 9,
      eDnsShawCa2 = 10,
      eDoohCloudflareDnsCom2 = 11,
      eMozillaCloudflareDnsCom3 = 12,
      eFirefoxDnsNextdnsIo3 = 13,
      ePrivateCanadianshieldCiraCa3 = 14,
      eDohXfinityCom3 = 15,
      eDnsShawCa3 = 16,
      eDoohCloudflareDnsCom3 = 17,
      e__Other__,
    };
  /**
   * In TRR channel, overall load time.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, TrrCompleteLoadLabel> trr_complete_load(141);

  /**
   * generated from networking.trr_dns_end
   */
  enum class TrrDnsEndLabel: uint16_t {
      eMozillaCloudflareDnsCom = 0,
      eFirefoxDnsNextdnsIo = 1,
      ePrivateCanadianshieldCiraCa = 2,
      eDohXfinityCom = 3,
      eDnsShawCa = 4,
      eDoohCloudflareDnsCom = 5,
      eMozillaCloudflareDnsCom2 = 6,
      eFirefoxDnsNextdnsIo2 = 7,
      ePrivateCanadianshieldCiraCa2 = 8,
      eDohXfinityCom2 = 9,
      eDnsShawCa2 = 10,
      eDoohCloudflareDnsCom2 = 11,
      eMozillaCloudflareDnsCom3 = 12,
      eFirefoxDnsNextdnsIo3 = 13,
      ePrivateCanadianshieldCiraCa3 = 14,
      eDohXfinityCom3 = 15,
      eDnsShawCa3 = 16,
      eDoohCloudflareDnsCom3 = 17,
      e__Other__,
    };
  /**
   * In TRR channel, time from the DNS request being issued to the response.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, TrrDnsEndLabel> trr_dns_end(142);

  /**
   * generated from networking.trr_dns_start
   */
  enum class TrrDnsStartLabel: uint16_t {
      eMozillaCloudflareDnsCom = 0,
      eFirefoxDnsNextdnsIo = 1,
      ePrivateCanadianshieldCiraCa = 2,
      eDohXfinityCom = 3,
      eDnsShawCa = 4,
      eDoohCloudflareDnsCom = 5,
      eMozillaCloudflareDnsCom2 = 6,
      eFirefoxDnsNextdnsIo2 = 7,
      ePrivateCanadianshieldCiraCa2 = 8,
      eDohXfinityCom2 = 9,
      eDnsShawCa2 = 10,
      eDoohCloudflareDnsCom2 = 11,
      eMozillaCloudflareDnsCom3 = 12,
      eFirefoxDnsNextdnsIo3 = 13,
      ePrivateCanadianshieldCiraCa3 = 14,
      eDohXfinityCom3 = 15,
      eDnsShawCa3 = 16,
      eDoohCloudflareDnsCom3 = 17,
      e__Other__,
    };
  /**
   * In TRR channel, time from connection open to the DNS request being issued.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, TrrDnsStartLabel> trr_dns_start(143);

  /**
   * generated from networking.trr_fetch_duration
   */
  enum class TrrFetchDurationLabel: uint16_t {
      eH1 = 0,
      eH1NetworkOnly = 1,
      eH2 = 2,
      eH2NetworkOnly = 3,
      eH3 = 4,
      eH3NetworkOnly = 5,
      e__Other__,
    };
  /**
   * Time for a successful DoH request, from AsyncOpen to ReturnData
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, TrrFetchDurationLabel> trr_fetch_duration(144);

  /**
   * generated from networking.trr_first_sent_to_last_received
   */
  enum class TrrFirstSentToLastReceivedLabel: uint16_t {
      eMozillaCloudflareDnsCom = 0,
      eFirefoxDnsNextdnsIo = 1,
      ePrivateCanadianshieldCiraCa = 2,
      eDohXfinityCom = 3,
      eDnsShawCa = 4,
      eDoohCloudflareDnsCom = 5,
      eMozillaCloudflareDnsCom2 = 6,
      eFirefoxDnsNextdnsIo2 = 7,
      ePrivateCanadianshieldCiraCa2 = 8,
      eDohXfinityCom2 = 9,
      eDnsShawCa2 = 10,
      eDoohCloudflareDnsCom2 = 11,
      eMozillaCloudflareDnsCom3 = 12,
      eFirefoxDnsNextdnsIo3 = 13,
      ePrivateCanadianshieldCiraCa3 = 14,
      eDohXfinityCom3 = 15,
      eDnsShawCa3 = 16,
      eDoohCloudflareDnsCom3 = 17,
      e__Other__,
    };
  /**
   * In TRR channel, time from first byte of request sent to last byte of response
     * received.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, TrrFirstSentToLastReceivedLabel> trr_first_sent_to_last_received(145);

  /**
   * generated from networking.trr_open_to_first_received
   */
  enum class TrrOpenToFirstReceivedLabel: uint16_t {
      eMozillaCloudflareDnsCom = 0,
      eFirefoxDnsNextdnsIo = 1,
      ePrivateCanadianshieldCiraCa = 2,
      eDohXfinityCom = 3,
      eDnsShawCa = 4,
      eDoohCloudflareDnsCom = 5,
      eMozillaCloudflareDnsCom2 = 6,
      eFirefoxDnsNextdnsIo2 = 7,
      ePrivateCanadianshieldCiraCa2 = 8,
      eDohXfinityCom2 = 9,
      eDnsShawCa2 = 10,
      eDoohCloudflareDnsCom2 = 11,
      eMozillaCloudflareDnsCom3 = 12,
      eFirefoxDnsNextdnsIo3 = 13,
      ePrivateCanadianshieldCiraCa3 = 14,
      eDohXfinityCom3 = 15,
      eDnsShawCa3 = 16,
      eDoohCloudflareDnsCom3 = 17,
      e__Other__,
    };
  /**
   * In TRR channel, time from open to first byte of reply received.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, TrrOpenToFirstReceivedLabel> trr_open_to_first_received(146);

  /**
   * generated from networking.trr_open_to_first_sent
   */
  enum class TrrOpenToFirstSentLabel: uint16_t {
      eMozillaCloudflareDnsCom = 0,
      eFirefoxDnsNextdnsIo = 1,
      ePrivateCanadianshieldCiraCa = 2,
      eDohXfinityCom = 3,
      eDnsShawCa = 4,
      eDoohCloudflareDnsCom = 5,
      eMozillaCloudflareDnsCom2 = 6,
      eFirefoxDnsNextdnsIo2 = 7,
      ePrivateCanadianshieldCiraCa2 = 8,
      eDohXfinityCom2 = 9,
      eDnsShawCa2 = 10,
      eDoohCloudflareDnsCom2 = 11,
      eMozillaCloudflareDnsCom3 = 12,
      eFirefoxDnsNextdnsIo3 = 13,
      ePrivateCanadianshieldCiraCa3 = 14,
      eDohXfinityCom3 = 15,
      eDnsShawCa3 = 16,
      eDoohCloudflareDnsCom3 = 17,
      e__Other__,
    };
  /**
   * In TRR channel, time from open to first byte of request.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, TrrOpenToFirstSentLabel> trr_open_to_first_sent(147);

  /**
   * generated from networking.trr_request_count
   */
  enum class TrrRequestCountLabel: uint16_t {
      eRegular = 0,
      ePrivate = 1,
      e__Other__,
    };
  /**
   * The count of successful TRR requests keyed by regular/private browsing
   */
  constexpr impl::Labeled<impl::CounterMetric, TrrRequestCountLabel> trr_request_count(148);

  /**
   * generated from networking.trr_request_count_per_conn
   */
  enum class TrrRequestCountPerConnLabel: uint16_t {
      eH1 = 0,
      eH2 = 1,
      eH3 = 2,
      e__Other__,
    };
  /**
   * Number of DOH requests per connection keyed by HTTP version
   */
  constexpr impl::Labeled<impl::CounterMetric, TrrRequestCountPerConnLabel> trr_request_count_per_conn(149);

  /**
   * generated from networking.trr_tcp_connection
   */
  enum class TrrTcpConnectionLabel: uint16_t {
      eMozillaCloudflareDnsCom = 0,
      eFirefoxDnsNextdnsIo = 1,
      ePrivateCanadianshieldCiraCa = 2,
      eDohXfinityCom = 3,
      eDnsShawCa = 4,
      eDoohCloudflareDnsCom = 5,
      eMozillaCloudflareDnsCom2 = 6,
      eFirefoxDnsNextdnsIo2 = 7,
      ePrivateCanadianshieldCiraCa2 = 8,
      eDohXfinityCom2 = 9,
      eDnsShawCa2 = 10,
      eDoohCloudflareDnsCom2 = 11,
      eMozillaCloudflareDnsCom3 = 12,
      eFirefoxDnsNextdnsIo3 = 13,
      ePrivateCanadianshieldCiraCa3 = 14,
      eDohXfinityCom3 = 15,
      eDnsShawCa3 = 16,
      eDoohCloudflareDnsCom3 = 17,
      e__Other__,
    };
  /**
   * In TRR channel, time from the TCP SYN packet is received to the connection is
     * established and ready for HTTP.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, TrrTcpConnectionLabel> trr_tcp_connection(150);

  /**
   * generated from networking.trr_tls_handshake
   */
  enum class TrrTlsHandshakeLabel: uint16_t {
      eMozillaCloudflareDnsCom = 0,
      eFirefoxDnsNextdnsIo = 1,
      ePrivateCanadianshieldCiraCa = 2,
      eDohXfinityCom = 3,
      eDnsShawCa = 4,
      eDoohCloudflareDnsCom = 5,
      eMozillaCloudflareDnsCom2 = 6,
      eFirefoxDnsNextdnsIo2 = 7,
      ePrivateCanadianshieldCiraCa2 = 8,
      eDohXfinityCom2 = 9,
      eDnsShawCa2 = 10,
      eDoohCloudflareDnsCom2 = 11,
      eMozillaCloudflareDnsCom3 = 12,
      eFirefoxDnsNextdnsIo3 = 13,
      ePrivateCanadianshieldCiraCa3 = 14,
      eDohXfinityCom3 = 15,
      eDnsShawCa3 = 16,
      eDoohCloudflareDnsCom3 = 17,
      e__Other__,
    };
  /**
   * In TRR channel, time from after the TCP SYN packet is received to the secure
     * connection is established and ready for HTTP.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, TrrTlsHandshakeLabel> trr_tls_handshake(151);

  /**
   * generated from networking.data_transferred_v3_kb
   */
  /**
   * How many KB of HTTP data transferred by type, there are some categories
     * separated by keys based on 5 parameters:
     *   1. normal browsing or private browsing
     *   2. system principal or not
     *   3. first party or third party
     *   4. class of service (Leader/Background/Others)
     *   5. tracking classification (Basic/Content/FingerprintingContent)
     * 
     * Available keys are:
     *   "Y0_N1Sys",
     *   "Y1_N1",
     *   "Y2_N3Oth",
     *   "Y3_N3BasicLead",
     *   "Y4_N3BasicBg",
     *   "Y5_N3BasicOth",
     *   "Y6_N3ContentLead",
     *   "Y7_N3ContentBg",
     *   "Y8_N3ContentOth",
     *   "Y9_N3FpLead",
     *   "Y10_N3FpBg",
     *   "Y11_N3FpOth",
     *   "Y12_P1Sys",
     *   "Y13_P1",
     *   "Y14_P3Oth",
     *   "Y15_P3BasicLead",
     *   "Y16_P3BasicBg",
     *   "Y17_P3BasicOth",
     *   "Y18_P3ContentLead",
     *   "Y19_P3ContentBg",
     *   "Y20_P3ContentOth",
     *   "Y21_P3FpLead",
     *   "Y22_P3FpBg",
     *   "Y23_P3FpOth"
     * 
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * networking.data_transferred_v3_kb.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> data_transferred_v3_kb(152);

  /**
   * generated from networking.http3_enabled
   */
  /**
   * True if HTTP3 is enabled at the start of a session. This metric was generated
     * to correspond to the Legacy Telemetry scalar networking.http3_enabled.
   */
  constexpr impl::BooleanMetric http3_enabled(153);

  /**
   * generated from networking.https_record_state
   */
  enum class HttpsRecordStateLabel: uint16_t {
      eInvalid = 0,
      eSucceeded = 1,
      eUnmatchedCname = 2,
      eAllExcluded = 3,
      eNoDefaultAlpn = 4,
      eOthers = 5,
      e__Other__,
    };
  /**
   * Gather the outcome of checking if a HTTPS record can be used: - "invalid" -
     * "succeeded" - "unmatched_cname" - "all_excluded" - "no_default_alpn" - "others"
   */
  constexpr impl::Labeled<impl::CounterMetric, HttpsRecordStateLabel> https_record_state(154);

  /**
   * generated from networking.https_rr_prefs_usage
   */
  /**
   * A bitfield representation for the usage of HTTPS RR prefs. bit 0:
     * network.dns.upgrade_with_https_rr is enabled or not. bit 1:
     * network.dns.use_https_rr_as_altsvc is enabled or not. bit 2:
     * network.dns.echconfig.enabled is enabled or not. This metric was generated to
     * correspond to the Legacy Telemetry scalar networking.https_rr_prefs_usage.
   */
  constexpr impl::QuantityMetric https_rr_prefs_usage(155);

  /**
   * generated from networking.trr_connection_cycle_count
   */
  /**
   * Number of times we cycled the TRR connection during a subsession. Keyed by TRR
     * provider URL. This metric was generated to correspond to the Legacy Telemetry
     * scalar networking.trr_connection_cycle_count.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> trr_connection_cycle_count(156);

  /**
   * generated from networking.loading_certs_task
   */
  /**
   * The time in milliseconds to load any external certificates. This occurs off of
     * the main-thread, but can block main-thread operations. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * networking.loading_certs_task.
   */
  constexpr impl::QuantityMetric loading_certs_task(157);

  /**
   * generated from networking.nss_initialization
   */
  /**
   * The time in milliseconds to initialize the NSS component in the parent process.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * networking.nss_initialization.
   */
  constexpr impl::QuantityMetric nss_initialization(158);

}
namespace privacy_sanitize {
  /**
   * generated from privacy.sanitize.clear
   */
    struct ClearExtra {
      mozilla::Maybe<bool> cache;
      mozilla::Maybe<nsCString> context;
      mozilla::Maybe<bool> cookiesAndStorage;
      mozilla::Maybe<bool> historyFormDataDownloads;
      mozilla::Maybe<bool> siteSettings;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cache) {
          extraKeys.AppendElement()->AssignASCII("cache");
          extraValues.AppendElement()->AssignASCII(cache.value() ? "true" : "false");
        }
        if (context) {
          extraKeys.AppendElement()->AssignASCII("context");
          extraValues.EmplaceBack(context.value());
        }
        if (cookiesAndStorage) {
          extraKeys.AppendElement()->AssignASCII("cookies_and_storage");
          extraValues.AppendElement()->AssignASCII(cookiesAndStorage.value() ? "true" : "false");
        }
        if (historyFormDataDownloads) {
          extraKeys.AppendElement()->AssignASCII("history_form_data_downloads");
          extraValues.AppendElement()->AssignASCII(historyFormDataDownloads.value() ? "true" : "false");
        }
        if (siteSettings) {
          extraKeys.AppendElement()->AssignASCII("site_settings");
          extraValues.AppendElement()->AssignASCII(siteSettings.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Dispatched when the dialog is accepted (to clear)
   */
  constexpr impl::EventMetric<ClearExtra> clear(159);

  /**
   * generated from privacy.sanitize.clearing_time_span_selected
   */
    struct ClearingTimeSpanSelectedExtra {
      mozilla::Maybe<nsCString> timeSpan;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (timeSpan) {
          extraKeys.AppendElement()->AssignASCII("time_span");
          extraValues.EmplaceBack(timeSpan.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The time span range selected to sanitize
   */
  constexpr impl::EventMetric<ClearingTimeSpanSelectedExtra> clearing_time_span_selected(160);

  /**
   * generated from privacy.sanitize.dialog_open
   */
    struct DialogOpenExtra {
      mozilla::Maybe<nsCString> context;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (context) {
          extraKeys.AppendElement()->AssignASCII("context");
          extraValues.EmplaceBack(context.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Dispatched when one of the sanitize dialogs opens
   */
  constexpr impl::EventMetric<DialogOpenExtra> dialog_open(161);

  /**
   * generated from privacy.sanitize.load_time
   */
  /**
   * How much time was spent to open the dialog, including loading data sizes
   */
  constexpr impl::TimingDistributionMetric load_time(162);

}
namespace security_ui_protectionspopup {
  /**
   * generated from security.ui.protectionspopup.click_cookieb_toggle_off
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#cookieb_toggle_off.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_cookieb_toggle_off(163);

  /**
   * generated from security.ui.protectionspopup.click_cookieb_toggle_on
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#cookieb_toggle_on.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_cookieb_toggle_on(164);

  /**
   * generated from security.ui.protectionspopup.click_cookies
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#cookies.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_cookies(165);

  /**
   * generated from security.ui.protectionspopup.click_cryptominers
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#cryptominers.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_cryptominers(166);

  /**
   * generated from security.ui.protectionspopup.click_etp_toggle_off
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#etp_toggle_off.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_etp_toggle_off(167);

  /**
   * generated from security.ui.protectionspopup.click_etp_toggle_on
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#etp_toggle_on.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_etp_toggle_on(168);

  /**
   * generated from security.ui.protectionspopup.click_fingerprinters
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#fingerprinters.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_fingerprinters(169);

  /**
   * generated from security.ui.protectionspopup.click_full_report
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#full_report.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_full_report(170);

  /**
   * generated from security.ui.protectionspopup.click_milestone_message
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#milestone_message.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_milestone_message(171);

  /**
   * generated from security.ui.protectionspopup.click_protectionspopup_cfr
   */
    struct ClickProtectionspopupCfrExtra {
      mozilla::Maybe<nsCString> message;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (message) {
          extraKeys.AppendElement()->AssignASCII("message");
          extraValues.EmplaceBack(message.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#protectionspopup_cfr.
   */
  constexpr impl::EventMetric<ClickProtectionspopupCfrExtra> click_protectionspopup_cfr(172);

  /**
   * generated from security.ui.protectionspopup.click_settings
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#settings.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_settings(173);

  /**
   * generated from security.ui.protectionspopup.click_social
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#social.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_social(174);

  /**
   * generated from security.ui.protectionspopup.click_subview_settings
   */
    struct ClickSubviewSettingsExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#subview_settings.
   */
  constexpr impl::EventMetric<ClickSubviewSettingsExtra> click_subview_settings(175);

  /**
   * generated from security.ui.protectionspopup.click_trackers
   */
  /**
   * User interaction by click events in the protections panel. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.click#trackers.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_trackers(176);

  /**
   * generated from security.ui.protectionspopup.open_protections_popup
   */
  /**
   * How many times the protections panel was opened. This event was generated to
     * correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.open#protections_popup.
   */
  constexpr impl::EventMetric<NoExtraKeys> open_protections_popup(177);

  /**
   * generated from security.ui.protectionspopup.open_protectionspopup_cfr
   */
    struct OpenProtectionspopupCfrExtra {
      mozilla::Maybe<nsCString> message;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (message) {
          extraKeys.AppendElement()->AssignASCII("message");
          extraValues.EmplaceBack(message.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * How many times the protections panel was opened. This event was generated to
     * correspond to the Legacy Telemetry event
     * security.ui.protectionspopup.open#protectionspopup_cfr.
   */
  constexpr impl::EventMetric<OpenProtectionspopupCfrExtra> open_protectionspopup_cfr(178);

}
namespace browser_backup {
  /**
   * generated from browser.backup.browser_extension_data_size
   */
  /**
   * The total size of the current profiles storage.local legacy JSON backend in the
     * browser-extension-data directory, rounded to the nearest 10 kilobytes.
   */
  constexpr impl::QuantityMetric browser_extension_data_size(179);

  /**
   * generated from browser.backup.change_location
   */
  /**
   * Dispatched when the backup destination location is changed.
   */
  constexpr impl::EventMetric<NoExtraKeys> change_location(180);

  /**
   * generated from browser.backup.compressed_archive_size
   */
  /**
   * The total compressed size of a single-file profile data backup archive. To
     * reduce fingerprintability, we round to the nearest 1 mebibyte.
   */
  constexpr impl::MemoryDistributionMetric compressed_archive_size(181);

  /**
   * generated from browser.backup.cookies_size
   */
  /**
   * The total file size of the cookies.sqlite db located in the current profile
     * directory, in kilobytes.
   */
  constexpr impl::QuantityMetric cookies_size(182);

  /**
   * generated from browser.backup.created
   */
  /**
   * Dispatched when a backup is successfully created.
   */
  constexpr impl::EventMetric<NoExtraKeys> created(183);

  /**
   * generated from browser.backup.credentials_data_size
   */
  /**
   * The total size of logins, payment method, and form autofill related files in
     * the current profile directory, in kilobytes.
   */
  constexpr impl::QuantityMetric credentials_data_size(184);

  /**
   * generated from browser.backup.enabled
   */
  /**
   * True if the BackupService is enabled by default.
   */
  constexpr impl::BooleanMetric enabled(185);

  /**
   * generated from browser.backup.error
   */
    struct ErrorExtra {
      mozilla::Maybe<nsCString> backupStep;
      mozilla::Maybe<nsCString> errorCode;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (backupStep) {
          extraKeys.AppendElement()->AssignASCII("backup_step");
          extraValues.EmplaceBack(backupStep.value());
        }
        if (errorCode) {
          extraKeys.AppendElement()->AssignASCII("error_code");
          extraValues.EmplaceBack(errorCode.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Dispatched when a backup fails to be created. We encode the error code as well
     * as the stage the backup failed in in the extra data.
   */
  constexpr impl::EventMetric<ErrorExtra> error(186);

  /**
   * generated from browser.backup.extension_store_permissions_data_size
   */
  /**
   * The file size of the current profiles extension-store-permissions/data.safe.bin
     * file, rounded to the nearest 10 kilobytes.
   */
  constexpr impl::QuantityMetric extension_store_permissions_data_size(187);

  /**
   * generated from browser.backup.extensions_json_size
   */
  /**
   * The total file size of the current profiles extensions metadata files, rounded
     * to the nearest 10 kilobytes. Files included are:
     *   - extensions.json
     *   - extension-settings.json
     *   - extension-preferences.json
     *   - addonStartup.json.lz4
   */
  constexpr impl::QuantityMetric extensions_json_size(188);

  /**
   * generated from browser.backup.extensions_storage_size
   */
  /**
   * The total size of all extensions storage directories, rounded to the nearest 10
     * kilobytes.
   */
  constexpr impl::QuantityMetric extensions_storage_size(189);

  /**
   * generated from browser.backup.extensions_xpi_directory_size
   */
  /**
   * The total size of the current profiles extensions directory, rounded to the
     * nearest 10 kilobytes.
   */
  constexpr impl::QuantityMetric extensions_xpi_directory_size(190);

  /**
   * generated from browser.backup.favicons_size
   */
  /**
   * The total file size of the favicons.sqlite db located in the current profile
     * directory, in kilobytes.
   */
  constexpr impl::QuantityMetric favicons_size(191);

  /**
   * generated from browser.backup.favicons_time
   */
  /**
   * Total time, in milliseconds, required to back up a profile's favicons database.
   */
  constexpr impl::TimingDistributionMetric favicons_time(192);

  /**
   * generated from browser.backup.form_history_size
   */
  /**
   * The file size of the formhistory.sqlite db located in the current profile
     * directory, in kilobytes.
   */
  constexpr impl::QuantityMetric form_history_size(193);

  /**
   * generated from browser.backup.location_on_device
   */
  /**
   * 1 = the default location, 2 = a non-default location
   */
  constexpr impl::QuantityMetric location_on_device(194);

  /**
   * generated from browser.backup.misc_data_size
   */
  /**
   * The total size of files for telemetry, site storage, media device origin
     * mapping, chrome privileged IndexedDB databases, and Mozilla Accounts in the
     * current profile directory, rounded to the nearest tenth kilobyte.
   */
  constexpr impl::QuantityMetric misc_data_size(195);

  /**
   * generated from browser.backup.password_added
   */
  /**
   * Dispatched when the backup encryption is enabled.
   */
  constexpr impl::EventMetric<NoExtraKeys> password_added(196);

  /**
   * generated from browser.backup.password_changed
   */
  /**
   * Dispatched when the backup encryption password is changed.
   */
  constexpr impl::EventMetric<NoExtraKeys> password_changed(197);

  /**
   * generated from browser.backup.password_removed
   */
  /**
   * Dispatched when the backup encryption is removed.
   */
  constexpr impl::EventMetric<NoExtraKeys> password_removed(198);

  /**
   * generated from browser.backup.places_size
   */
  /**
   * The total file size of the places.sqlite db located in the current profile
     * directory, in kilobytes.
   */
  constexpr impl::QuantityMetric places_size(199);

  /**
   * generated from browser.backup.places_time
   */
  /**
   * Total time, in milliseconds, required to back up a profile's places database.
   */
  constexpr impl::TimingDistributionMetric places_time(200);

  /**
   * generated from browser.backup.preferences_size
   */
  /**
   * The total size of files relating to user preferences and permissions in the
     * current profile directory, in kilobytes.
   */
  constexpr impl::QuantityMetric preferences_size(201);

  /**
   * generated from browser.backup.prof_d_disk_space
   */
  /**
   * The total disk space available on the storage device that the profile directory
     * is stored on. To reduce fingerprintability, we round to the nearest 10
     * megabytes and return the result in kilobytes.
   */
  constexpr impl::QuantityMetric prof_d_disk_space(202);

  /**
   * generated from browser.backup.pswd_encrypted
   */
  /**
   * True if the BackupService is configured to encrypt backups.
   */
  constexpr impl::BooleanMetric pswd_encrypted(203);

  /**
   * generated from browser.backup.scheduler_enabled
   */
  /**
   * True if the BackupService is configured to automatically create backups in the
     * background.
   */
  constexpr impl::BooleanMetric scheduler_enabled(204);

  /**
   * generated from browser.backup.security_data_size
   */
  /**
   * The total size of files needed for NSS initialization parameters and security
     * certificate settings in the current profile directory, in kilobytes.
   */
  constexpr impl::QuantityMetric security_data_size(205);

  /**
   * generated from browser.backup.session_store_backups_directory_size
   */
  /**
   * The total size of the session store backups directory, in kilobytes.
   */
  constexpr impl::QuantityMetric session_store_backups_directory_size(206);

  /**
   * generated from browser.backup.session_store_size
   */
  /**
   * The size of uncompressed session store json, in kilobytes.
   */
  constexpr impl::QuantityMetric session_store_size(207);

  /**
   * generated from browser.backup.storage_sync_size
   */
  /**
   * The file size of the current profiles storage-sync-v2.sqlite db, rounded to the
     * nearest 10 kilobytes.
   */
  constexpr impl::QuantityMetric storage_sync_size(208);

  /**
   * generated from browser.backup.toggle_off
   */
  /**
   * Dispatched when scheduled backups are disabled.
   */
  constexpr impl::EventMetric<NoExtraKeys> toggle_off(209);

  /**
   * generated from browser.backup.toggle_on
   */
  /**
   * Dispatched when scheduled backups are enabled.
   */
  constexpr impl::EventMetric<NoExtraKeys> toggle_on(210);

  /**
   * generated from browser.backup.total_backup_size
   */
  /**
   * The total uncompressed size of all profile data included in a completed backup.
     * To reduce fingerprintability, we round to the nearest 1 mebibyte.
   */
  constexpr impl::MemoryDistributionMetric total_backup_size(211);

  /**
   * generated from browser.backup.total_backup_time
   */
  /**
   * Total time elapsed, in milliseconds, between the start and end of the profile
     * backup creation process
   */
  constexpr impl::TimingDistributionMetric total_backup_time(212);

}
namespace doh {
  /**
   * generated from doh.evaluate_v2_heuristics
   */
    struct EvaluateV2HeuristicsExtra {
      mozilla::Maybe<nsCString> canaries;
      mozilla::Maybe<nsCString> captivestate;
      mozilla::Maybe<nsCString> enterprise;
      mozilla::Maybe<nsCString> evaluatereason;
      mozilla::Maybe<nsCString> filtering;
      mozilla::Maybe<nsCString> networkid;
      mozilla::Maybe<nsCString> platform;
      mozilla::Maybe<nsCString> steeredprovider;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (canaries) {
          extraKeys.AppendElement()->AssignASCII("canaries");
          extraValues.EmplaceBack(canaries.value());
        }
        if (captivestate) {
          extraKeys.AppendElement()->AssignASCII("captiveState");
          extraValues.EmplaceBack(captivestate.value());
        }
        if (enterprise) {
          extraKeys.AppendElement()->AssignASCII("enterprise");
          extraValues.EmplaceBack(enterprise.value());
        }
        if (evaluatereason) {
          extraKeys.AppendElement()->AssignASCII("evaluateReason");
          extraValues.EmplaceBack(evaluatereason.value());
        }
        if (filtering) {
          extraKeys.AppendElement()->AssignASCII("filtering");
          extraValues.EmplaceBack(filtering.value());
        }
        if (networkid) {
          extraKeys.AppendElement()->AssignASCII("networkID");
          extraValues.EmplaceBack(networkid.value());
        }
        if (platform) {
          extraKeys.AppendElement()->AssignASCII("platform");
          extraValues.EmplaceBack(platform.value());
        }
        if (steeredprovider) {
          extraKeys.AppendElement()->AssignASCII("steeredProvider");
          extraValues.EmplaceBack(steeredprovider.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Results of DoH heuristics at startup and after network changes. This event was
     * generated to correspond to the Legacy Telemetry event
     * doh.evaluate_v2#heuristics.
   */
  constexpr impl::EventMetric<EvaluateV2HeuristicsExtra> evaluate_v2_heuristics(213);

  /**
   * generated from doh.state_disabled
   */
    struct StateDisabledExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Results of DoH heuristics at startup and after network changes. This event was
     * generated to correspond to the Legacy Telemetry event doh.state#disabled.
   */
  constexpr impl::EventMetric<StateDisabledExtra> state_disabled(214);

  /**
   * generated from doh.state_enabled
   */
    struct StateEnabledExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Results of DoH heuristics at startup and after network changes. This event was
     * generated to correspond to the Legacy Telemetry event doh.state#enabled.
   */
  constexpr impl::EventMetric<StateEnabledExtra> state_enabled(215);

  /**
   * generated from doh.state_manually_disabled
   */
    struct StateManuallyDisabledExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Results of DoH heuristics at startup and after network changes. This event was
     * generated to correspond to the Legacy Telemetry event
     * doh.state#manuallyDisabled.
   */
  constexpr impl::EventMetric<StateManuallyDisabledExtra> state_manually_disabled(216);

  /**
   * generated from doh.state_policy_disabled
   */
    struct StatePolicyDisabledExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Results of DoH heuristics at startup and after network changes. This event was
     * generated to correspond to the Legacy Telemetry event doh.state#policyDisabled.
   */
  constexpr impl::EventMetric<StatePolicyDisabledExtra> state_policy_disabled(217);

  /**
   * generated from doh.state_rollback
   */
    struct StateRollbackExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Results of DoH heuristics at startup and after network changes. This event was
     * generated to correspond to the Legacy Telemetry event doh.state#rollback.
   */
  constexpr impl::EventMetric<StateRollbackExtra> state_rollback(218);

  /**
   * generated from doh.state_shutdown
   */
    struct StateShutdownExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Results of DoH heuristics at startup and after network changes. This event was
     * generated to correspond to the Legacy Telemetry event doh.state#shutdown.
   */
  constexpr impl::EventMetric<StateShutdownExtra> state_shutdown(219);

  /**
   * generated from doh.state_uidisabled
   */
    struct StateUidisabledExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Results of DoH heuristics at startup and after network changes. This event was
     * generated to correspond to the Legacy Telemetry event doh.state#UIDisabled.
   */
  constexpr impl::EventMetric<StateUidisabledExtra> state_uidisabled(220);

  /**
   * generated from doh.state_uiok
   */
    struct StateUiokExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Results of DoH heuristics at startup and after network changes. This event was
     * generated to correspond to the Legacy Telemetry event doh.state#UIOk.
   */
  constexpr impl::EventMetric<StateUiokExtra> state_uiok(221);

  /**
   * generated from doh.state_uninstalled
   */
    struct StateUninstalledExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Results of DoH heuristics at startup and after network changes. This event was
     * generated to correspond to the Legacy Telemetry event doh.state#uninstalled.
   */
  constexpr impl::EventMetric<StateUninstalledExtra> state_uninstalled(222);

}
namespace security_doh_trr_performance {
  /**
   * generated from security.doh.trr_performance.resolved_record
   */
    struct ResolvedRecordExtra {
      mozilla::Maybe<nsCString> captiveportal;
      mozilla::Maybe<nsCString> domain;
      mozilla::Maybe<nsCString> networkunstable;
      mozilla::Maybe<nsCString> retrycount;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<nsCString> time;
      mozilla::Maybe<nsCString> trr;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (captiveportal) {
          extraKeys.AppendElement()->AssignASCII("captivePortal");
          extraValues.EmplaceBack(captiveportal.value());
        }
        if (domain) {
          extraKeys.AppendElement()->AssignASCII("domain");
          extraValues.EmplaceBack(domain.value());
        }
        if (networkunstable) {
          extraKeys.AppendElement()->AssignASCII("networkUnstable");
          extraValues.EmplaceBack(networkunstable.value());
        }
        if (retrycount) {
          extraKeys.AppendElement()->AssignASCII("retryCount");
          extraValues.EmplaceBack(retrycount.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (time) {
          extraKeys.AppendElement()->AssignASCII("time");
          extraValues.EmplaceBack(time.value());
        }
        if (trr) {
          extraKeys.AppendElement()->AssignASCII("trr");
          extraValues.EmplaceBack(trr.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * How long it took to resolve a test domain using TRR. This event was generated
     * to correspond to the Legacy Telemetry event
     * security.doh.trrPerformance.resolved#record.
   */
  constexpr impl::EventMetric<ResolvedRecordExtra> resolved_record(223);

  /**
   * generated from security.doh.trr_performance.trrselect_dryrunresult
   */
    struct TrrselectDryrunresultExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The URL of the DoH provider chosen by the TRR selection dry-run This event was
     * generated to correspond to the Legacy Telemetry event
     * security.doh.trrPerformance.trrselect#dryrunresult.
   */
  constexpr impl::EventMetric<TrrselectDryrunresultExtra> trrselect_dryrunresult(224);

}
namespace downloads {
  /**
   * generated from downloads.panel_shown
   */
  /**
   * The count of how many times the downloads panel was shown per session. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * downloads.panel_shown.
   */
  constexpr impl::CounterMetric panel_shown(225);

  /**
   * generated from downloads.added_file_extension
   */
    struct AddedFileExtensionExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when downloading a new file. This event was generated to correspond to the
     * Legacy Telemetry event downloads.added#fileExtension.
   */
  constexpr impl::EventMetric<AddedFileExtensionExtra> added_file_extension(226);

  /**
   * generated from downloads.file_opened
   */
  /**
   * The count of how many times files were opened from the download panel. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * downloads.file_opened.
   */
  constexpr impl::CounterMetric file_opened(227);

}
namespace firefoxview_next {
  /**
   * generated from firefoxview_next.browser_context_menu_tabs
   */
    struct BrowserContextMenuTabsExtra {
      mozilla::Maybe<nsCString> menuAction;
      mozilla::Maybe<nsCString> page;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (menuAction) {
          extraKeys.AppendElement()->AssignASCII("menu_action");
          extraValues.EmplaceBack(menuAction.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a browser context menu selection is made in Firefox View This
     * event was generated to correspond to the Legacy Telemetry event
     * firefoxview_next.browser_context_menu#tabs.
   */
  constexpr impl::EventMetric<BrowserContextMenuTabsExtra> browser_context_menu_tabs(228);

  /**
   * generated from firefoxview_next.card_collapsed_card_container
   */
    struct CardCollapsedCardContainerExtra {
      mozilla::Maybe<nsCString> dataType;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (dataType) {
          extraKeys.AppendElement()->AssignASCII("data_type");
          extraValues.EmplaceBack(dataType.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a card-container is collapsed on the 'Recent browsing' page This
     * event was generated to correspond to the Legacy Telemetry event
     * firefoxview_next.card_collapsed#card_container.
   */
  constexpr impl::EventMetric<CardCollapsedCardContainerExtra> card_collapsed_card_container(229);

  /**
   * generated from firefoxview_next.card_expanded_card_container
   */
    struct CardExpandedCardContainerExtra {
      mozilla::Maybe<nsCString> dataType;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (dataType) {
          extraKeys.AppendElement()->AssignASCII("data_type");
          extraValues.EmplaceBack(dataType.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a card-container is expanded on the 'Recent browsing' page This
     * event was generated to correspond to the Legacy Telemetry event
     * firefoxview_next.card_expanded#card_container.
   */
  constexpr impl::EventMetric<CardExpandedCardContainerExtra> card_expanded_card_container(230);

  /**
   * generated from firefoxview_next.change_page_navigation
   */
    struct ChangePageNavigationExtra {
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> source;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the page/view is changed in Firefox View This event was generated
     * to correspond to the Legacy Telemetry event
     * firefoxview_next.change_page#navigation.
   */
  constexpr impl::EventMetric<ChangePageNavigationExtra> change_page_navigation(231);

  /**
   * generated from firefoxview_next.close_open_tab_tabs
   */
  /**
   * Recorded when a tab is closed via the close button on an open tab row. This
     * event was generated to correspond to the Legacy Telemetry event
     * firefoxview_next.close_open_tab#tabs.
   */
  constexpr impl::EventMetric<NoExtraKeys> close_open_tab_tabs(232);

  /**
   * generated from firefoxview_next.context_menu_tabs
   */
    struct ContextMenuTabsExtra {
      mozilla::Maybe<nsCString> dataType;
      mozilla::Maybe<nsCString> menuAction;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (dataType) {
          extraKeys.AppendElement()->AssignASCII("data_type");
          extraValues.EmplaceBack(dataType.value());
        }
        if (menuAction) {
          extraKeys.AppendElement()->AssignASCII("menu_action");
          extraValues.EmplaceBack(menuAction.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a context menu selection is made in Firefox View This event was
     * generated to correspond to the Legacy Telemetry event
     * firefoxview_next.context_menu#tabs.
   */
  constexpr impl::EventMetric<ContextMenuTabsExtra> context_menu_tabs(233);

  /**
   * generated from firefoxview_next.dismiss_closed_tab_tabs
   */
    struct DismissClosedTabTabsExtra {
      mozilla::Maybe<nsCString> delta;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<uint32_t> position;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (delta) {
          extraKeys.AppendElement()->AssignASCII("delta");
          extraValues.EmplaceBack(delta.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a recently closed tab is dismissed This event was generated to
     * correspond to the Legacy Telemetry event
     * firefoxview_next.dismiss_closed_tab#tabs.
   */
  constexpr impl::EventMetric<DismissClosedTabTabsExtra> dismiss_closed_tab_tabs(234);

  /**
   * generated from firefoxview_next.entered_firefoxview
   */
    struct EnteredFirefoxviewExtra {
      mozilla::Maybe<nsCString> page;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the Firefox View tab is selected This event was generated to
     * correspond to the Legacy Telemetry event firefoxview_next.entered#firefoxview.
   */
  constexpr impl::EventMetric<EnteredFirefoxviewExtra> entered_firefoxview(235);

  /**
   * generated from firefoxview_next.fxa_continue_sync
   */
  /**
   * Recorded when button to sign in or sign up is clicked This event was generated
     * to correspond to the Legacy Telemetry event firefoxview_next.fxa_continue#sync.
   */
  constexpr impl::EventMetric<NoExtraKeys> fxa_continue_sync(236);

  /**
   * generated from firefoxview_next.fxa_mobile_sync
   */
    struct FxaMobileSyncExtra {
      mozilla::Maybe<bool> hasDevices;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasDevices) {
          extraKeys.AppendElement()->AssignASCII("has_devices");
          extraValues.AppendElement()->AssignASCII(hasDevices.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the 'Try Firefox for mobile' button is clicked This event was
     * generated to correspond to the Legacy Telemetry event
     * firefoxview_next.fxa_mobile#sync.
   */
  constexpr impl::EventMetric<FxaMobileSyncExtra> fxa_mobile_sync(237);

  /**
   * generated from firefoxview_next.history_visits
   */
  /**
   * Recorded when a history tab is clicked This event was generated to correspond
     * to the Legacy Telemetry event firefoxview_next.history#visits.
   */
  constexpr impl::EventMetric<NoExtraKeys> history_visits(238);

  /**
   * generated from firefoxview_next.open_tab_tabs
   */
    struct OpenTabTabsExtra {
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> window;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (window) {
          extraKeys.AppendElement()->AssignASCII("window");
          extraValues.EmplaceBack(window.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when an open tab is clicked This event was generated to correspond to
     * the Legacy Telemetry event firefoxview_next.open_tab#tabs.
   */
  constexpr impl::EventMetric<OpenTabTabsExtra> open_tab_tabs(239);

  /**
   * generated from firefoxview_next.recently_closed_tabs
   */
    struct RecentlyClosedTabsExtra {
      mozilla::Maybe<nsCString> delta;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<uint32_t> position;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (delta) {
          extraKeys.AppendElement()->AssignASCII("delta");
          extraValues.EmplaceBack(delta.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a recently closed tab is clicked This event was generated to
     * correspond to the Legacy Telemetry event firefoxview_next.recently_closed#tabs.
   */
  constexpr impl::EventMetric<RecentlyClosedTabsExtra> recently_closed_tabs(240);

  /**
   * generated from firefoxview_next.search_initiated_search
   */
    struct SearchInitiatedSearchExtra {
      mozilla::Maybe<nsCString> page;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when search is initiated and from what page. This event was generated
     * to correspond to the Legacy Telemetry event
     * firefoxview_next.search_initiated#search.
   */
  constexpr impl::EventMetric<SearchInitiatedSearchExtra> search_initiated_search(241);

  /**
   * generated from firefoxview_next.search_show_all_showallbutton
   */
    struct SearchShowAllShowallbuttonExtra {
      mozilla::Maybe<nsCString> section;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (section) {
          extraKeys.AppendElement()->AssignASCII("section");
          extraValues.EmplaceBack(section.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the show all button is clicked to show more search results. This
     * event was generated to correspond to the Legacy Telemetry event
     * firefoxview_next.search_show_all#showallbutton.
   */
  constexpr impl::EventMetric<SearchShowAllShowallbuttonExtra> search_show_all_showallbutton(242);

  /**
   * generated from firefoxview_next.show_all_history_tabs
   */
  /**
   * Recorded when the 'Show all history' button is clicked on the History page in
     * Firefox View This event was generated to correspond to the Legacy Telemetry
     * event firefoxview_next.show_all_history#tabs.
   */
  constexpr impl::EventMetric<NoExtraKeys> show_all_history_tabs(243);

  /**
   * generated from firefoxview_next.sort_history_tabs
   */
    struct SortHistoryTabsExtra {
      mozilla::Maybe<nsCString> searchStart;
      mozilla::Maybe<nsCString> sortType;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (searchStart) {
          extraKeys.AppendElement()->AssignASCII("search_start");
          extraValues.EmplaceBack(searchStart.value());
        }
        if (sortType) {
          extraKeys.AppendElement()->AssignASCII("sort_type");
          extraValues.EmplaceBack(sortType.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the sort option is changed for History in Firefox View This event
     * was generated to correspond to the Legacy Telemetry event
     * firefoxview_next.sort_history#tabs.
   */
  constexpr impl::EventMetric<SortHistoryTabsExtra> sort_history_tabs(244);

  /**
   * generated from firefoxview_next.synced_tabs_tabs
   */
    struct SyncedTabsTabsExtra {
      mozilla::Maybe<nsCString> page;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a synced tab is clicked This event was generated to correspond to
     * the Legacy Telemetry event firefoxview_next.synced_tabs#tabs.
   */
  constexpr impl::EventMetric<SyncedTabsTabsExtra> synced_tabs_tabs(245);

  /**
   * generated from firefoxview_next.tab_selected_toolbarbutton
   */
  /**
   * Recorded when the Firefox View tab is clicked This event was generated to
     * correspond to the Legacy Telemetry event
     * firefoxview_next.tab_selected#toolbarbutton.
   */
  constexpr impl::EventMetric<NoExtraKeys> tab_selected_toolbarbutton(246);

}
namespace genai_chatbot {
  /**
   * generated from genai.chatbot.contextmenu_prompt_click
   */
    struct ContextmenuPromptClickExtra {
      mozilla::Maybe<nsCString> prompt;
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> selection;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (prompt) {
          extraKeys.AppendElement()->AssignASCII("prompt");
          extraValues.EmplaceBack(prompt.value());
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (selection) {
          extraKeys.AppendElement()->AssignASCII("selection");
          extraValues.EmplaceBack(nsPrintfCString("%d", selection.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot prompt was clicked from the context menu.
   */
  constexpr impl::EventMetric<ContextmenuPromptClickExtra> contextmenu_prompt_click(247);

  /**
   * generated from genai.chatbot.enabled
   */
  /**
   * Indicates if the chatbot feature is enabled.
   */
  constexpr impl::BooleanMetric enabled(248);

  /**
   * generated from genai.chatbot.experiment_checkbox_click
   */
    struct ExperimentCheckboxClickExtra {
      mozilla::Maybe<bool> enabled;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (enabled) {
          extraKeys.AppendElement()->AssignASCII("enabled");
          extraValues.AppendElement()->AssignASCII(enabled.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot experiment checkbox was clicked to enable/disable.
   */
  constexpr impl::EventMetric<ExperimentCheckboxClickExtra> experiment_checkbox_click(249);

  /**
   * generated from genai.chatbot.keyboard_shortcut
   */
    struct KeyboardShortcutExtra {
      mozilla::Maybe<bool> enabled;
      mozilla::Maybe<nsCString> sidebar;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (enabled) {
          extraKeys.AppendElement()->AssignASCII("enabled");
          extraValues.AppendElement()->AssignASCII(enabled.value() ? "true" : "false");
        }
        if (sidebar) {
          extraKeys.AppendElement()->AssignASCII("sidebar");
          extraValues.EmplaceBack(sidebar.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot sidebar toggled with keyboard shortcut.
   */
  constexpr impl::EventMetric<KeyboardShortcutExtra> keyboard_shortcut(250);

  /**
   * generated from genai.chatbot.onboarding_close
   */
    struct OnboardingCloseExtra {
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> step;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(nsPrintfCString("%d", step.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot onboarding closed from provider choice.
   */
  constexpr impl::EventMetric<OnboardingCloseExtra> onboarding_close(251);

  /**
   * generated from genai.chatbot.onboarding_continue
   */
    struct OnboardingContinueExtra {
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> step;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(nsPrintfCString("%d", step.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot onboarding continued from provider choice.
   */
  constexpr impl::EventMetric<OnboardingContinueExtra> onboarding_continue(252);

  /**
   * generated from genai.chatbot.onboarding_finish
   */
    struct OnboardingFinishExtra {
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> step;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(nsPrintfCString("%d", step.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot onboarding finished with start chatting button.
   */
  constexpr impl::EventMetric<OnboardingFinishExtra> onboarding_finish(253);

  /**
   * generated from genai.chatbot.onboarding_learn_more
   */
    struct OnboardingLearnMoreExtra {
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> step;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(nsPrintfCString("%d", step.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot onboarding opened feature learn more link.
   */
  constexpr impl::EventMetric<OnboardingLearnMoreExtra> onboarding_learn_more(254);

  /**
   * generated from genai.chatbot.onboarding_provider_choice_displayed
   */
    struct OnboardingProviderChoiceDisplayedExtra {
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> step;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(nsPrintfCString("%d", step.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot onboarding impression for provider choice screen.
   */
  constexpr impl::EventMetric<OnboardingProviderChoiceDisplayedExtra> onboarding_provider_choice_displayed(255);

  /**
   * generated from genai.chatbot.onboarding_provider_learn
   */
    struct OnboardingProviderLearnExtra {
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> step;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(nsPrintfCString("%d", step.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot onboarding opened provider learn more link.
   */
  constexpr impl::EventMetric<OnboardingProviderLearnExtra> onboarding_provider_learn(256);

  /**
   * generated from genai.chatbot.onboarding_provider_selection
   */
    struct OnboardingProviderSelectionExtra {
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> step;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(nsPrintfCString("%d", step.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot onboarding selected a provider.
   */
  constexpr impl::EventMetric<OnboardingProviderSelectionExtra> onboarding_provider_selection(257);

  /**
   * generated from genai.chatbot.onboarding_provider_terms
   */
    struct OnboardingProviderTermsExtra {
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> step;
      mozilla::Maybe<nsCString> text;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(nsPrintfCString("%d", step.value()));
        }
        if (text) {
          extraKeys.AppendElement()->AssignASCII("text");
          extraValues.EmplaceBack(text.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot onboarding opened provider terms link.
   */
  constexpr impl::EventMetric<OnboardingProviderTermsExtra> onboarding_provider_terms(258);

  /**
   * generated from genai.chatbot.onboarding_text_highlight_displayed
   */
    struct OnboardingTextHighlightDisplayedExtra {
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> step;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(nsPrintfCString("%d", step.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot onboarding impression for text highlight screen.
   */
  constexpr impl::EventMetric<OnboardingTextHighlightDisplayedExtra> onboarding_text_highlight_displayed(259);

  /**
   * generated from genai.chatbot.provider
   */
  /**
   * Indicates id of activated chatbot provider or "custom" or "none"
   */
  constexpr impl::StringMetric provider(260);

  /**
   * generated from genai.chatbot.provider_change
   */
    struct ProviderChangeExtra {
      mozilla::Maybe<nsCString> current;
      mozilla::Maybe<nsCString> previous;
      mozilla::Maybe<nsCString> surface;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (current) {
          extraKeys.AppendElement()->AssignASCII("current");
          extraValues.EmplaceBack(current.value());
        }
        if (previous) {
          extraKeys.AppendElement()->AssignASCII("previous");
          extraValues.EmplaceBack(previous.value());
        }
        if (surface) {
          extraKeys.AppendElement()->AssignASCII("surface");
          extraValues.EmplaceBack(surface.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot provider UI changed providers.
   */
  constexpr impl::EventMetric<ProviderChangeExtra> provider_change(261);

  /**
   * generated from genai.chatbot.shortcuts
   */
  /**
   * Indicates if the chatbot feature would show shortcuts on selection.
   */
  constexpr impl::BooleanMetric shortcuts(262);

  /**
   * generated from genai.chatbot.shortcuts_checkbox_click
   */
    struct ShortcutsCheckboxClickExtra {
      mozilla::Maybe<bool> enabled;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (enabled) {
          extraKeys.AppendElement()->AssignASCII("enabled");
          extraValues.AppendElement()->AssignASCII(enabled.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot shortcuts checkbox was clicked to enable/disable.
   */
  constexpr impl::EventMetric<ShortcutsCheckboxClickExtra> shortcuts_checkbox_click(263);

  /**
   * generated from genai.chatbot.shortcuts_custom
   */
  /**
   * Indicates if the chatbot feature would show shortcuts custom input.
   */
  constexpr impl::BooleanMetric shortcuts_custom(264);

  /**
   * generated from genai.chatbot.shortcuts_displayed
   */
    struct ShortcutsDisplayedExtra {
      mozilla::Maybe<uint32_t> delay;
      mozilla::Maybe<nsCString> inputtype;
      mozilla::Maybe<uint32_t> selection;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (delay) {
          extraKeys.AppendElement()->AssignASCII("delay");
          extraValues.EmplaceBack(nsPrintfCString("%d", delay.value()));
        }
        if (inputtype) {
          extraKeys.AppendElement()->AssignASCII("inputType");
          extraValues.EmplaceBack(inputtype.value());
        }
        if (selection) {
          extraKeys.AppendElement()->AssignASCII("selection");
          extraValues.EmplaceBack(nsPrintfCString("%d", selection.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Shortcuts displayed on text selection.
   */
  constexpr impl::EventMetric<ShortcutsDisplayedExtra> shortcuts_displayed(265);

  /**
   * generated from genai.chatbot.shortcuts_expanded
   */
    struct ShortcutsExpandedExtra {
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> selection;
      mozilla::Maybe<bool> warning;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (selection) {
          extraKeys.AppendElement()->AssignASCII("selection");
          extraValues.EmplaceBack(nsPrintfCString("%d", selection.value()));
        }
        if (warning) {
          extraKeys.AppendElement()->AssignASCII("warning");
          extraValues.AppendElement()->AssignASCII(warning.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Shortcuts expanded to show prompts.
   */
  constexpr impl::EventMetric<ShortcutsExpandedExtra> shortcuts_expanded(266);

  /**
   * generated from genai.chatbot.shortcuts_hide_click
   */
    struct ShortcutsHideClickExtra {
      mozilla::Maybe<uint32_t> selection;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (selection) {
          extraKeys.AppendElement()->AssignASCII("selection");
          extraValues.EmplaceBack(nsPrintfCString("%d", selection.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot hide shortcuts was clicked from the shortcuts.
   */
  constexpr impl::EventMetric<ShortcutsHideClickExtra> shortcuts_hide_click(267);

  /**
   * generated from genai.chatbot.shortcuts_prompt_click
   */
    struct ShortcutsPromptClickExtra {
      mozilla::Maybe<nsCString> prompt;
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<uint32_t> selection;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (prompt) {
          extraKeys.AppendElement()->AssignASCII("prompt");
          extraValues.EmplaceBack(prompt.value());
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (selection) {
          extraKeys.AppendElement()->AssignASCII("selection");
          extraValues.EmplaceBack(nsPrintfCString("%d", selection.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot prompt was clicked from the shortcuts.
   */
  constexpr impl::EventMetric<ShortcutsPromptClickExtra> shortcuts_prompt_click(268);

  /**
   * generated from genai.chatbot.sidebar
   */
  /**
   * Indicates if the chatbot feature would open in sidebar.
   */
  constexpr impl::BooleanMetric sidebar(269);

  /**
   * generated from genai.chatbot.sidebar_close_click
   */
    struct SidebarCloseClickExtra {
      mozilla::Maybe<nsCString> provider;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot close X clicked.
   */
  constexpr impl::EventMetric<SidebarCloseClickExtra> sidebar_close_click(270);

  /**
   * generated from genai.chatbot.sidebar_more_menu_click
   */
    struct SidebarMoreMenuClickExtra {
      mozilla::Maybe<nsCString> action;
      mozilla::Maybe<nsCString> provider;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot more menu clicked an action.
   */
  constexpr impl::EventMetric<SidebarMoreMenuClickExtra> sidebar_more_menu_click(271);

  /**
   * generated from genai.chatbot.sidebar_more_menu_display
   */
    struct SidebarMoreMenuDisplayExtra {
      mozilla::Maybe<nsCString> provider;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot more menu opened.
   */
  constexpr impl::EventMetric<SidebarMoreMenuDisplayExtra> sidebar_more_menu_display(272);

  /**
   * generated from genai.chatbot.sidebar_provider_menu_click
   */
    struct SidebarProviderMenuClickExtra {
      mozilla::Maybe<nsCString> action;
      mozilla::Maybe<nsCString> provider;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot provider menu clicked an action.
   */
  constexpr impl::EventMetric<SidebarProviderMenuClickExtra> sidebar_provider_menu_click(273);

  /**
   * generated from genai.chatbot.sidebar_toggle
   */
    struct SidebarToggleExtra {
      mozilla::Maybe<bool> opened;
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> version;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (opened) {
          extraKeys.AppendElement()->AssignASCII("opened");
          extraValues.AppendElement()->AssignASCII(opened.value() ? "true" : "false");
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (version) {
          extraKeys.AppendElement()->AssignASCII("version");
          extraValues.EmplaceBack(version.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Chatbot sidebar panel was toggled open/close.
   */
  constexpr impl::EventMetric<SidebarToggleExtra> sidebar_toggle(274);

}
namespace background_update {
  /**
   * generated from background_update.reasons_to_not_update
   */
  /**
   * Records which error was causing the background updater to fail. This list
     * supercedes the `background-update.reason` in `mozapps/update/metrics.yaml`
   */
  constexpr impl::StringListMetric reasons_to_not_update(275);

  /**
   * generated from background_update.time_last_update_scheduled
   */
  /**
   * Last time the background update was triggered.
   */
  constexpr impl::DatetimeMetric time_last_update_scheduled(276);

  /**
   * generated from background_update.automatic_restart_attempted
   */
  /**
   * True if the background update task successfully attempted an automatic restart.
   */
  constexpr impl::BooleanMetric automatic_restart_attempted(277);

  /**
   * generated from background_update.automatic_restart_success
   */
  /**
   * True if the background update task successfully restarted after an automatic
     * restart.
   */
  constexpr impl::BooleanMetric automatic_restart_success(278);

  /**
   * generated from background_update.client_id
   */
  /**
   * The legacy Telemetry client ID of this installation's default profile.
     * The default profile is as determined by the Profile Service, namely
     * `nsIToolkitProfileService.defaultProfile`.  The majority of users have only one
     * Firefox installation and only one profile, so the default profile is their
     * regular browsing profile.
     * It is possible for a Firefox installation to not have a default profile, but in
     * such cases the background update task will abort before sending any telemetry;
     * therefore, the legacy Telemetry client ID should always be present.
   */
  constexpr impl::UuidMetric client_id(279);

  /**
   * generated from background_update.exit_code_exception
   */
  /**
   * True if the exit code/status of the background update task is 3, which means an
     * exception was thrown.
   */
  constexpr impl::BooleanMetric exit_code_exception(280);

  /**
   * generated from background_update.exit_code_success
   */
  /**
   * True if the exit code/status of the background update task is 0, which means
     * success.
   */
  constexpr impl::BooleanMetric exit_code_success(281);

  /**
   * generated from background_update.final_state
   */
  /**
   * String description of the final state the update state machine reached.
   */
  constexpr impl::StringMetric final_state(282);

  /**
   * generated from background_update.reasons
   */
  /**
   * List of reasons that the background update task did not run.
   */
  constexpr impl::StringListMetric reasons(283);

  /**
   * generated from background_update.states
   */
  /**
   * Ordered list of string descriptions of the states that the update state machine
     * reached.
   */
  constexpr impl::StringListMetric states(284);

  /**
   * generated from background_update.targeting_env_current_date
   */
  /**
   * The `environment.currentDate` of the default profile's serialized targeting
     * snapshot.
   */
  constexpr impl::DatetimeMetric targeting_env_current_date(285);

  /**
   * generated from background_update.targeting_env_firefox_version
   */
  /**
   * The `environment.firefoxVersion` of the default profile's serialized targeting
     * snapshot.  At the time of writing, this version is an integer representing the
     * Firefox major version, e.g., `109`.
   */
  constexpr impl::QuantityMetric targeting_env_firefox_version(286);

  /**
   * generated from background_update.targeting_env_profile_age
   */
  /**
   * The `environment.profileAgeCreated` of the default profile's serialized
     * targeting snapshot.
   */
  constexpr impl::DatetimeMetric targeting_env_profile_age(287);

  /**
   * generated from background_update.targeting_exception
   */
  /**
   * True if the default profile had a targeting snapshot serialized to disk, but an
     * exception was thrown reading it.
   */
  constexpr impl::BooleanMetric targeting_exception(288);

  /**
   * generated from background_update.targeting_exists
   */
  /**
   * True if the default profile had a targeting snapshot serialized to disk, and
     * there was no exception thrown reading it.
   */
  constexpr impl::BooleanMetric targeting_exists(289);

  /**
   * generated from background_update.targeting_version
   */
  /**
   * If the default profile had a targeting snapshot serialized to disk, the
     * `version` of the snapshot.
     * This version number does not have a physical unit: it's only useful to compare
     * between versions.
   */
  constexpr impl::QuantityMetric targeting_version(290);

}
namespace browser_launched_to_handle {
  /**
   * generated from browser.launched_to_handle.system_notification
   */
    struct SystemNotificationExtra {
      mozilla::Maybe<nsCString> action;
      mozilla::Maybe<nsCString> name;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        if (name) {
          extraKeys.AppendElement()->AssignASCII("name");
          extraValues.EmplaceBack(name.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when Firefox launches to complete a native notification popped by a
     * system (chrome privileged) alert.  Windows-only at the time of writing.
   */
  constexpr impl::EventMetric<SystemNotificationExtra> system_notification(291);

}
namespace browser_startup {
  /**
   * generated from browser.startup.abouthome_cache_result
   */
  /**
   * How the about:home startup cache functioned on startup.
     * 0: Result value was never set (error case) 1: Cache did not exist 2: Cache page
     * stream was corrupt / inaccessible 3: Cache script stream was corrupt /
     * inaccessible 4: Cache was invalidated by a version bump 5: Cache was valid, but
     * read too late to be useful. 6: Cache was valid and used. 7: Cache is disabled.
     * 8: User did not load about:home on its own by default. 9: Cache is disabled
     * because about:newtab preloading is disabled.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.startup.abouthome_cache_result.
   */
  constexpr impl::QuantityMetric abouthome_cache_result(292);

  /**
   * generated from browser.startup.abouthome_cache_shutdownwrite
   */
  /**
   * True if the about:home startup cache was written via the AsyncShutdown blocker.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.startup.abouthome_cache_shutdownwrite.
   */
  constexpr impl::BooleanMetric abouthome_cache_shutdownwrite(293);

}
namespace datasanitization {
  /**
   * generated from datasanitization.privacy_clear_on_shutdown_cache
   */
  /**
   * A boolean reporting the value of the privacy.clearOnShutdown.cache pref. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * datasanitization.privacy_clearOnShutdown_cache.
   */
  constexpr impl::BooleanMetric privacy_clear_on_shutdown_cache(294);

  /**
   * generated from datasanitization.privacy_clear_on_shutdown_cookies
   */
  /**
   * A boolean reporting the value of the privacy.clearOnShutdown.cookies pref. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * datasanitization.privacy_clearOnShutdown_cookies.
   */
  constexpr impl::BooleanMetric privacy_clear_on_shutdown_cookies(295);

  /**
   * generated from datasanitization.privacy_clear_on_shutdown_downloads
   */
  /**
   * A boolean reporting the value of the privacy.clearOnShutdown.downloads pref.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * datasanitization.privacy_clearOnShutdown_downloads.
   */
  constexpr impl::BooleanMetric privacy_clear_on_shutdown_downloads(296);

  /**
   * generated from datasanitization.privacy_clear_on_shutdown_formdata
   */
  /**
   * A boolean reporting the value of the privacy.clearOnShutdown.formdata pref.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * datasanitization.privacy_clearOnShutdown_formdata.
   */
  constexpr impl::BooleanMetric privacy_clear_on_shutdown_formdata(297);

  /**
   * generated from datasanitization.privacy_clear_on_shutdown_history
   */
  /**
   * A boolean reporting the value of the privacy.clearOnShutdown.history pref. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * datasanitization.privacy_clearOnShutdown_history.
   */
  constexpr impl::BooleanMetric privacy_clear_on_shutdown_history(298);

  /**
   * generated from datasanitization.privacy_clear_on_shutdown_offline_apps
   */
  /**
   * A boolean reporting the value of the privacy.clearOnShutdown.offlineApps pref.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * datasanitization.privacy_clearOnShutdown_offlineApps.
   */
  constexpr impl::BooleanMetric privacy_clear_on_shutdown_offline_apps(299);

  /**
   * generated from datasanitization.privacy_clear_on_shutdown_open_windows
   */
  /**
   * A boolean reporting the value of the privacy.clearOnShutdown.openWindows pref.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * datasanitization.privacy_clearOnShutdown_openWindows.
   */
  constexpr impl::BooleanMetric privacy_clear_on_shutdown_open_windows(300);

  /**
   * generated from datasanitization.privacy_clear_on_shutdown_sessions
   */
  /**
   * A boolean reporting the value of the privacy.clearOnShutdown.sessions pref.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * datasanitization.privacy_clearOnShutdown_sessions.
   */
  constexpr impl::BooleanMetric privacy_clear_on_shutdown_sessions(301);

  /**
   * generated from datasanitization.privacy_clear_on_shutdown_site_settings
   */
  /**
   * A boolean reporting the value of the privacy.clearOnShutdown.siteSettings pref.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * datasanitization.privacy_clearOnShutdown_siteSettings.
   */
  constexpr impl::BooleanMetric privacy_clear_on_shutdown_site_settings(302);

  /**
   * generated from datasanitization.privacy_sanitize_sanitize_on_shutdown
   */
  /**
   * A boolean reporting the value of the privacy.sanitize.sanitizeOnShutdown pref.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * datasanitization.privacy_sanitize_sanitizeOnShutdown.
   */
  constexpr impl::BooleanMetric privacy_sanitize_sanitize_on_shutdown(303);

  /**
   * generated from datasanitization.session_permission_exceptions
   */
  /**
   * A count of how many "session" cookie exceptions a user has set. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * datasanitization.session_permission_exceptions.
   */
  constexpr impl::QuantityMetric session_permission_exceptions(304);

}
namespace launch_on_login {
  /**
   * generated from launch_on_login.last_profile_disable_startup
   */
  /**
   * Recorded when Launch on login is disabled because the start with last profile
     * setting has been disabled. This event was generated to correspond to the Legacy
     * Telemetry event launch_on_login.last_profile_disable#startup.
   */
  constexpr impl::EventMetric<NoExtraKeys> last_profile_disable_startup(305);

}
namespace os_environment {
  /**
   * generated from os.environment.invoked_to_handle
   */
  /**
   * Records counts for when Firefox was invoked (i.e., was already running and was
     * not launched) to handle a file type or protocol with `-osint -url ...`.  The
     * result is split into keys which represent the file extension: currently, the
     * set of file types Firefox registers to handle, namely ".avif", ".htm", ".html",
     * ".pdf", ".shtml", ".xht", ".xhtml", ".svg", ".webp", and the set of protocol
     * schemes that Firefox registers to handle, namely "about", "http", "https",
     * "mailto".  If Firefox was invoked to handle a file type or protocol it does not
     * register to handle by default, the count is recorded as ".<other extension>" or
     * "<other protocol>", respectively (neither of which are valid extension or
     * protocol identifiers). This metric was generated to correspond to the Legacy
     * Telemetry scalar os.environment.invoked_to_handle.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> invoked_to_handle(306);

  /**
   * generated from os.environment.is_default_handler
   */
  /**
   * Records whether Firefox was the default handler for particular file types or
     * protocols.  The result is split into keys which represent the file extension or
     * scheme: currently, a subset of the file types Firefox registers to handle,
     * namely ".pdf" and "mailto" as protocol. In the future, more file types may be
     * recorded. This metric was generated to correspond to the Legacy Telemetry
     * scalar os.environment.is_default_handler.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> is_default_handler(307);

  /**
   * generated from os.environment.is_kept_in_dock
   */
  /**
   * Whether this app was kept in macOS Dock on startup This metric was generated to
     * correspond to the Legacy Telemetry scalar os.environment.is_kept_in_dock.
   */
  constexpr impl::BooleanMetric is_kept_in_dock(308);

  /**
   * generated from os.environment.is_taskbar_pinned
   */
  /**
   * Whether the non-Private Browsing version of this app was pinned to taskbar on
     * startup This metric was generated to correspond to the Legacy Telemetry scalar
     * os.environment.is_taskbar_pinned.
   */
  constexpr impl::BooleanMetric is_taskbar_pinned(309);

  /**
   * generated from os.environment.is_taskbar_pinned_private
   */
  /**
   * Whether the Private Browsing version of this app was pinned to taskbar on
     * startup This metric was generated to correspond to the Legacy Telemetry scalar
     * os.environment.is_taskbar_pinned_private.
   */
  constexpr impl::BooleanMetric is_taskbar_pinned_private(310);

  /**
   * generated from os.environment.launch_method
   */
  /**
   * Records how Firefox was started on Windows. Currently will be one of "Desktop",
     * "DesktopPrivate", "StartMenu" (including pins), "StartMenuPrivate", "Taskbar",
     * "TaskbarPrivate", "OtherShortcut", or "Other" This metric was generated to
     * correspond to the Legacy Telemetry scalar os.environment.launch_method.
   */
  constexpr impl::StringMetric launch_method(311);

  /**
   * generated from os.environment.launched_to_handle
   */
  /**
   * Records counts for when Firefox was launched afresh (i.e., was not already
     * running) to handle a file type or protocol with `-osint -url ...`.  The result
     * is split into keys which represent the file extension: currently, the set of
     * file types Firefox registers to handle, namely ".avif", ".htm", ".html",
     * ".pdf", ".shtml", ".xht", ".xhtml", ".svg", ".webp", and the set of protocol
     * schemes that Firefox registers to handle, namely "about", "http", "https",
     * "mailto".  If Firefox was launched to handle a file type or protocol it does
     * not register to handle by default, the count is recorded as ".<other
     * extension>" or "<other protocol>", respectively (neither of which are valid
     * extension or protocol identifiers). This metric was generated to correspond to
     * the Legacy Telemetry scalar os.environment.launched_to_handle.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> launched_to_handle(312);

  /**
   * generated from os.environment.allowed_app_sources
   */
  /**
   * Indicates what sources the OS is currently configured to allow apps to be
     * installed from. Possible values are "Anywhere", "Recommendations",
     * "PreferStore", "StoreOnly", "NoSuchFeature", or "Error". "Recommendations"
     * allows installs from anywhere, but recommends a comparable app from the store,
     * if available. "NoSuchFeature" will be reported on versions of Windows that do
     * not have an app source setting. This metric was generated to correspond to the
     * Legacy Telemetry scalar os.environment.allowed_app_sources.
   */
  constexpr impl::StringMetric allowed_app_sources(313);

  /**
   * generated from os.environment.is_admin_without_uac
   */
  /**
   * Indicates that the process is lauched with Admin privileges but without UAC.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * os.environment.is_admin_without_uac.
   */
  constexpr impl::BooleanMetric is_admin_without_uac(314);

}
namespace primary_password {
  /**
   * generated from primary.password.enabled
   */
  /**
   * If a primary-password is enabled for this profile. Set soon after browser
     * startup. Does not update if a primary password is added or removed after
     * startup.
   */
  constexpr impl::BooleanMetric enabled(315);

}
namespace security {
  /**
   * generated from security.global_privacy_control_enabled
   */
  /**
   * Measures user retention of the Global Privacy Control. 0 = never enabled, 1 =
     * enabled, 2 = disabled (but was enabled) This metric was generated to correspond
     * to the Legacy Telemetry scalar security.global_privacy_control_enabled.
   */
  constexpr impl::QuantityMetric global_privacy_control_enabled(316);

  /**
   * generated from security.https_only_mode_enabled
   */
  /**
   * Measures user retention of the HTTPS-Only Mode. 0 = never enabled, 1 = enabled,
     * 2 = disabled (but was enabled) This metric was generated to correspond to the
     * Legacy Telemetry scalar security.https_only_mode_enabled.
   */
  constexpr impl::QuantityMetric https_only_mode_enabled(317);

  /**
   * generated from security.https_only_mode_enabled_pbm
   */
  /**
   * Measures user retention of the HTTPS-Only Mode in Private Browsing. 0 = https-
     * only never enabled in PBM, 1 = https-only enabled in PBM, 2 = https-only
     * disabled in PBM (but was enabled) This metric was generated to correspond to
     * the Legacy Telemetry scalar security.https_only_mode_enabled_pbm.
   */
  constexpr impl::QuantityMetric https_only_mode_enabled_pbm(318);

  /**
   * generated from security.fission_principals
   */
    struct FissionPrincipalsExtra {
      mozilla::Maybe<nsCString> principaltype;
      mozilla::Maybe<nsCString> scheme;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (principaltype) {
          extraKeys.AppendElement()->AssignASCII("principalType");
          extraValues.EmplaceBack(principaltype.value());
        }
        if (scheme) {
          extraKeys.AppendElement()->AssignASCII("scheme");
          extraValues.EmplaceBack(scheme.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * When running with Fission, we received an unexpected principal from the content
     * process. Expected values for this telemetry event are the method names in
     * ContentParent that received the unexpected principal. This event was generated
     * to correspond to the Legacy Telemetry event
     * security.fissionPrincipals#contentParent.
   */
  constexpr impl::EventMetric<FissionPrincipalsExtra> fission_principals(319);

  /**
   * generated from security.eval_usage_parent_process
   */
    struct EvalUsageParentProcessExtra {
      mozilla::Maybe<nsCString> fileinfo;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fileinfo) {
          extraKeys.AppendElement()->AssignASCII("fileinfo");
          extraValues.EmplaceBack(fileinfo.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * eval() (or an eval()-like method) was called while running in the System
     * Principal context or the Parent Process. Expected values are: chromeuri -
     * chrome:// file   resourceuri - resource:// file datauri - a data URI   bloburi
     * - a blob URI   abouturi - an about URI   singlestring - A single file or string
     * with no slashes mozillaextension - An extension claiming to be from
     * *mozilla.org (Deprecated)   otherextension - Another extension not from Mozilla
     * (Deprecated)   mozillaextension_file - An extension claiming to be from
     * *mozilla.org, loaded from a file://   otherextension_file - Another extension
     * not from Mozilla, loaded from a file:// extension_uri - A URI with the moz-
     * extension:// scheme suspectedUserChromeJS - A filepath ending in .uc.js
     * sanitizedWindowsPath - A filepath, on Windows, sanitized by
     * WinUtils::PreparePathForTelemetry                          which is a bare
     * filename or a subpath of %ProgramFiles%, %SystemRoot%, or %TEMP%
     * sanitizedWindowsURL - A partial URL, on Windows, consisting of either
     * file://../ followed by the value prepared as for sanitizedWindowsPath, or the
     * bare scheme of                         the original url   other - Unknown
     * other-on-worker - We cannot do a regex; it is not a chrome, resource, data, or
     * blob uri, but                     could be any other.   regexfailure - Our
     * Regex Matching code threw an error The fileinfo key may contain additional
     * information about the file that caused the eval() depending on the above value.
     * Resource, Chrome, About, and SingleString will contain the full value. (About
     * URIs will remove any querystring values.) Extensions-from-file will contain the
     * full value; however .xpi! will be shortened to !, shield.mozilla.org! to s! and
     * mozilla.org! to m!.  Data, Blob, UserChromeJS, Other, and Regexfailure should
     * have no value. This event was generated to correspond to the Legacy Telemetry
     * event security.evalUsage#parentProcess.
   */
  constexpr impl::EventMetric<EvalUsageParentProcessExtra> eval_usage_parent_process(320);

  /**
   * generated from security.eval_usage_system_context
   */
    struct EvalUsageSystemContextExtra {
      mozilla::Maybe<nsCString> fileinfo;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fileinfo) {
          extraKeys.AppendElement()->AssignASCII("fileinfo");
          extraValues.EmplaceBack(fileinfo.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * eval() (or an eval()-like method) was called while running in the System
     * Principal context or the Parent Process. Expected values are:
     *   - chromeuri - chrome:// file
     *   - resourceuri - resource:// file
     *   - datauri - a data URI
     *   - bloburi - a blob URI
     *   - abouturi - an about URI
     *   - singlestring - A single file or string with no slashes
     *   - mozillaextension - An extension claiming to be from *mozilla.org
     * (Deprecated)
     *   - otherextension - Another extension not from Mozilla (Deprecated)
     *   - mozillaextension_file - An extension claiming to be from *mozilla.org,
     * loaded from a file://
     *   - otherextension_file - Another extension not from Mozilla, loaded from a
     * file://
     *   - extension_uri - A URI with the moz-extension:// scheme
     *   - suspectedUserChromeJS - A filepath ending in .uc.js
     *   - sanitizedWindowsPath - A filepath, on Windows, sanitized by
     * WinUtils::PreparePathForTelemetry which is a bare filename or a subpath of
     * %ProgramFiles%, %SystemRoot%, or %TEMP%
     *   - sanitizedWindowsURL - A partial URL, on Windows, consisting of either
     * file://../ followed by the value prepared as for sanitizedWindowsPath, or the
     * bare scheme of the original url
     *   - other - Unknown
     *   - other-on-worker - We cannot do a regex; it is not a chrome, resource, data,
     * or blob uri, but could be any other.
     *   - regexfailure - Our Regex Matching code threw an error
     * 
     * The fileinfo key may contain additional information about the file that caused
     * the eval() depending on the above value. Resource, Chrome, About, and
     * SingleString will contain the full value. (About URIs will remove any
     * querystring values.)
     * Extensions-from-file will contain the full value; however .xpi! will be
     * shortened to !, shield.mozilla.org! to s! and mozilla.org! to m!.  Data, Blob,
     * UserChromeJS, Other, and Regexfailure should have no value.
     * This event was generated to correspond to the Legacy Telemetry event
     * security.evalUsage#systemContext.
   */
  constexpr impl::EventMetric<EvalUsageSystemContextExtra> eval_usage_system_context(321);

  /**
   * generated from security.javascript_load_parent_process
   */
    struct JavascriptLoadParentProcessExtra {
      mozilla::Maybe<nsCString> fileinfo;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fileinfo) {
          extraKeys.AppendElement()->AssignASCII("fileinfo");
          extraValues.EmplaceBack(fileinfo.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The javascript engine requested to load a filename that was not allowed.
     * Expected values, and fileinfo key, are the same possible values as above in
     * 'evalUsage' This event was generated to correspond to the Legacy Telemetry
     * event security.javascriptLoad#parentProcess.
   */
  constexpr impl::EventMetric<JavascriptLoadParentProcessExtra> javascript_load_parent_process(322);

  /**
   * generated from security.unexpected_load
   */
    struct UnexpectedLoadExtra {
      mozilla::Maybe<nsCString> contenttype;
      mozilla::Maybe<nsCString> filedetails;
      mozilla::Maybe<nsCString> redirects;
      mozilla::Maybe<nsCString> remotetype;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (contenttype) {
          extraKeys.AppendElement()->AssignASCII("contenttype");
          extraValues.EmplaceBack(contenttype.value());
        }
        if (filedetails) {
          extraKeys.AppendElement()->AssignASCII("filedetails");
          extraValues.EmplaceBack(filedetails.value());
        }
        if (redirects) {
          extraKeys.AppendElement()->AssignASCII("redirects");
          extraValues.EmplaceBack(redirects.value());
        }
        if (remotetype) {
          extraKeys.AppendElement()->AssignASCII("remotetype");
          extraValues.EmplaceBack(remotetype.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Long term want to block all loads from the system principal that cause us to
     * parse non-trivial data. We don't look to break existing functionality and will
     * allow exceptions, for this we are collecting information about unexpected
     * requests triggered by the system principal Our measurement *excludes*
     * acceptable requests. Those are: - annotated using the
     * 'AllowedDeprecatedSystemRequests' loadinfo flag - using a nsContentPolicyType
     * of FETCH, XMLHTTPREQUEST, WEBSOCKET, SAVEAS_DOWNLOAD or IMAGE - with a
     * requested URI object has the flag URI_IS_UI_RESOURCE - if the URL scheme is
     * 'view-source' - if the URL scheme is 'file' and the Content-Type is STYLESHEET
     * or OTHER - if the scheme is 'jar', 'about' or 'moz-extension' This event was
     * generated to correspond to the Legacy Telemetry event
     * security.unexpectedload#systemprincipal.
   */
  constexpr impl::EventMetric<UnexpectedLoadExtra> unexpected_load(323);

  /**
   * generated from security.pref_usage_content_process
   */
    struct PrefUsageContentProcessExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * We block certain preferences from being sent to the content process because
     * they contain sensitive user data. Some preferences are blocked by name, others
     * by heuristic. If one of the preferences so blocked is accidently accessed we
     * want to know about it so we can allowlist it or refactor the access. This event
     * was generated to correspond to the Legacy Telemetry event
     * security.prefUsage#contentProcess.
   */
  constexpr impl::EventMetric<PrefUsageContentProcessExtra> pref_usage_content_process(324);

  /**
   * generated from security.client_auth_cert_usage
   */
  /**
   * Measures how many servers have requested a client authentication certificate
     * (key: "requested") and how many times the user has opted to send one in
     * response (key: "sent"). This metric was generated to correspond to the Legacy
     * Telemetry scalar security.client_auth_cert_usage.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> client_auth_cert_usage(325);

}
namespace sslkeylogging {
  /**
   * generated from sslkeylogging.enabled
   */
  /**
   * Records whether TLS key logging has been enabled via the environment variable
     * SSLKEYLOGFILE.
   */
  constexpr impl::BooleanMetric enabled(326);

}
namespace start_menu {
  /**
   * generated from start_menu.manually_unpinned_since_last_launch
   */
  /**
   * Records whether Firefox has been unpinned from the Windows start menu since
     * last launch. This will only be recorded on MSIX due to the underlying API only
     * being available for packaged applications.
   */
  constexpr impl::EventMetric<NoExtraKeys> manually_unpinned_since_last_launch(327);

}
namespace startup {
  /**
   * generated from startup.is_cold
   */
  /**
   * Whether or not this startup is the first startup since OS reboot (according to
     * our best guess.) This metric was generated to correspond to the Legacy
     * Telemetry scalar startup.is_cold.
   */
  constexpr impl::BooleanMetric is_cold(328);

  /**
   * generated from startup.seconds_since_last_os_restart
   */
  /**
   * The time in seconds between the first browser window loading, and the time the
     * OS started. This can give us an indication of whether starting the browser may
     * have been the first thing the user did after starting their computer. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * startup.seconds_since_last_os_restart.
   */
  constexpr impl::QuantityMetric seconds_since_last_os_restart(329);

  /**
   * generated from startup.profile_count
   */
  /**
   * This records the number of known profiles after startup completes. This
     * includes any profiles that were created during startup. This metric was
     * generated to correspond to the Legacy Telemetry scalar startup.profile_count.
   */
  constexpr impl::QuantityMetric profile_count(330);

  /**
   * generated from startup.profile_database_version
   */
  /**
   * The version of the profiles.ini database loaded during startup. A value of "0"
     * is used to indicate that no file was present during startup. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * startup.profile_database_version.
   */
  constexpr impl::StringMetric profile_database_version(331);

  /**
   * generated from startup.profile_selection_reason
   */
  /**
   * How the profile was selected during startup. One of the following reasons:
     *   unknown:
     *     Generally should not happen, set as a default in case no other reason
     *     occured.
     *   profile-manager:
     *     The profile was selected by the profile manager.
     *   profile-selector:
     *     The profile was selected by the profile selector window.
     *   profile-reset:
     *     The profile was selected for reset, normally this would mean a restart.
     *   restart:
     *     The user restarted the application, the same profile as previous will
     *     be used.
     *   argument-profile:
     *     The profile was selected by the --profile command line argument.
     *   argument-p:
     *     The profile was selected by the -p command line argument.
     *   firstrun-claimed-default:
     *     A first run of a dedicated profiles build chose the old default
     *     profile to be the default for this install.
     *   firstrun-skipped-default:
     *     A first run of a dedicated profiles build skipped over the old default
     *     profile and created a new profile.
     *   restart-claimed-default:
     *     A first run of a dedicated profiles build after a restart chose the
     *     old default profile to be the default for this install.
     *   restart-skipped-default:
     *     A first run of a dedicated profiles build after a restart skipped over
     *     the old default profile and created a new profile.
     *   firstrun-created-default:
     *     A first run of the application created a new profile to use.
     *   default:
     *     The default profile was selected as normal.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * startup.profile_selection_reason.
   */
  constexpr impl::StringMetric profile_selection_reason(332);

}
namespace upgrade_dialog {
  /**
   * generated from upgrade_dialog.trigger_reason
   */
    struct TriggerReasonExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggering behaviors of the upgrade dialog. Value indicates which condition
     * failed or all satisfied. This event was generated to correspond to the Legacy
     * Telemetry event upgrade_dialog.trigger#reason.
   */
  constexpr impl::EventMetric<TriggerReasonExtra> trigger_reason(333);

}
namespace browser_migration {
  /**
   * generated from browser.migration.browser_selected_wizard
   */
    struct BrowserSelectedWizardExtra {
      mozilla::Maybe<nsCString> migratorKey;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (migratorKey) {
          extraKeys.AppendElement()->AssignASCII("migrator_key");
          extraValues.EmplaceBack(migratorKey.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user selects a browser to migrate from. This event was
     * generated to correspond to the Legacy Telemetry event
     * browser.migration.browser_selected#wizard.
   */
  constexpr impl::EventMetric<BrowserSelectedWizardExtra> browser_selected_wizard(334);

  /**
   * generated from browser.migration.linux_perms_wizard
   */
    struct LinuxPermsWizardExtra {
      mozilla::Maybe<nsCString> migratorKey;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (migratorKey) {
          extraKeys.AppendElement()->AssignASCII("migrator_key");
          extraValues.EmplaceBack(migratorKey.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded if the user is on Linux and the browser is installed in a sandboxed
     * environment that prevents it from reading other browser's data, and the user is
     * presented with instructions and an option to grant the browser permission to
     * read that other data. This event was generated to correspond to the Legacy
     * Telemetry event browser.migration.linux_perms#wizard.
   */
  constexpr impl::EventMetric<LinuxPermsWizardExtra> linux_perms_wizard(335);

  /**
   * generated from browser.migration.matched_extensions
   */
  /**
   * Records a list of the Chrome extension IDs that were successfully matched to
     * Firefox equivalents from the list downloaded from AMO.
   */
  constexpr impl::StringListMetric matched_extensions(336);

  /**
   * generated from browser.migration.migration_finished_wizard
   */
    struct MigrationFinishedWizardExtra {
      mozilla::Maybe<nsCString> bookmarks;
      mozilla::Maybe<nsCString> extensions;
      mozilla::Maybe<nsCString> formdata;
      mozilla::Maybe<nsCString> history;
      mozilla::Maybe<nsCString> migratorKey;
      mozilla::Maybe<uint32_t> other;
      mozilla::Maybe<nsCString> passwords;
      mozilla::Maybe<nsCString> paymentMethods;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (bookmarks) {
          extraKeys.AppendElement()->AssignASCII("bookmarks");
          extraValues.EmplaceBack(bookmarks.value());
        }
        if (extensions) {
          extraKeys.AppendElement()->AssignASCII("extensions");
          extraValues.EmplaceBack(extensions.value());
        }
        if (formdata) {
          extraKeys.AppendElement()->AssignASCII("formdata");
          extraValues.EmplaceBack(formdata.value());
        }
        if (history) {
          extraKeys.AppendElement()->AssignASCII("history");
          extraValues.EmplaceBack(history.value());
        }
        if (migratorKey) {
          extraKeys.AppendElement()->AssignASCII("migrator_key");
          extraValues.EmplaceBack(migratorKey.value());
        }
        if (other) {
          extraKeys.AppendElement()->AssignASCII("other");
          extraValues.EmplaceBack(nsPrintfCString("%d", other.value()));
        }
        if (passwords) {
          extraKeys.AppendElement()->AssignASCII("passwords");
          extraValues.EmplaceBack(passwords.value());
        }
        if (paymentMethods) {
          extraKeys.AppendElement()->AssignASCII("payment_methods");
          extraValues.EmplaceBack(paymentMethods.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user finishes a migration. This event was generated to
     * correspond to the Legacy Telemetry event
     * browser.migration.migration_finished#wizard.
   */
  constexpr impl::EventMetric<MigrationFinishedWizardExtra> migration_finished_wizard(337);

  /**
   * generated from browser.migration.migration_started_wizard
   */
    struct MigrationStartedWizardExtra {
      mozilla::Maybe<nsCString> bookmarks;
      mozilla::Maybe<nsCString> extensions;
      mozilla::Maybe<nsCString> formdata;
      mozilla::Maybe<nsCString> history;
      mozilla::Maybe<nsCString> migratorKey;
      mozilla::Maybe<uint32_t> other;
      mozilla::Maybe<nsCString> passwords;
      mozilla::Maybe<nsCString> paymentMethods;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (bookmarks) {
          extraKeys.AppendElement()->AssignASCII("bookmarks");
          extraValues.EmplaceBack(bookmarks.value());
        }
        if (extensions) {
          extraKeys.AppendElement()->AssignASCII("extensions");
          extraValues.EmplaceBack(extensions.value());
        }
        if (formdata) {
          extraKeys.AppendElement()->AssignASCII("formdata");
          extraValues.EmplaceBack(formdata.value());
        }
        if (history) {
          extraKeys.AppendElement()->AssignASCII("history");
          extraValues.EmplaceBack(history.value());
        }
        if (migratorKey) {
          extraKeys.AppendElement()->AssignASCII("migrator_key");
          extraValues.EmplaceBack(migratorKey.value());
        }
        if (other) {
          extraKeys.AppendElement()->AssignASCII("other");
          extraValues.EmplaceBack(nsPrintfCString("%d", other.value()));
        }
        if (passwords) {
          extraKeys.AppendElement()->AssignASCII("passwords");
          extraValues.EmplaceBack(passwords.value());
        }
        if (paymentMethods) {
          extraKeys.AppendElement()->AssignASCII("payment_methods");
          extraValues.EmplaceBack(paymentMethods.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user begins a migration. This event was generated to
     * correspond to the Legacy Telemetry event
     * browser.migration.migration_started#wizard.
   */
  constexpr impl::EventMetric<MigrationStartedWizardExtra> migration_started_wizard(338);

  /**
   * generated from browser.migration.no_browsers_found_wizard
   */
  /**
   * Recorded when the migration wizard reports that there are no browsers to
     * migrate from. This event was generated to correspond to the Legacy Telemetry
     * event browser.migration.no_browsers_found#wizard.
   */
  constexpr impl::EventMetric<NoExtraKeys> no_browsers_found_wizard(339);

  /**
   * generated from browser.migration.opened_wizard
   */
  /**
   * Recorded when the migration wizard opens. This event was generated to
     * correspond to the Legacy Telemetry event browser.migration.opened#wizard.
   */
  constexpr impl::EventMetric<NoExtraKeys> opened_wizard(340);

  /**
   * generated from browser.migration.profile_selected_wizard
   */
    struct ProfileSelectedWizardExtra {
      mozilla::Maybe<nsCString> migratorKey;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (migratorKey) {
          extraKeys.AppendElement()->AssignASCII("migrator_key");
          extraValues.EmplaceBack(migratorKey.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user selects a profile to migrate from. If the browser
     * doesn't support multiple profiles, this will not be recorded. This event was
     * generated to correspond to the Legacy Telemetry event
     * browser.migration.profile_selected#wizard.
   */
  constexpr impl::EventMetric<ProfileSelectedWizardExtra> profile_selected_wizard(341);

  /**
   * generated from browser.migration.resources_selected_wizard
   */
    struct ResourcesSelectedWizardExtra {
      mozilla::Maybe<nsCString> bookmarks;
      mozilla::Maybe<nsCString> configured;
      mozilla::Maybe<nsCString> extensions;
      mozilla::Maybe<nsCString> formdata;
      mozilla::Maybe<nsCString> history;
      mozilla::Maybe<nsCString> migratorKey;
      mozilla::Maybe<uint32_t> other;
      mozilla::Maybe<nsCString> passwords;
      mozilla::Maybe<nsCString> paymentMethods;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (bookmarks) {
          extraKeys.AppendElement()->AssignASCII("bookmarks");
          extraValues.EmplaceBack(bookmarks.value());
        }
        if (configured) {
          extraKeys.AppendElement()->AssignASCII("configured");
          extraValues.EmplaceBack(configured.value());
        }
        if (extensions) {
          extraKeys.AppendElement()->AssignASCII("extensions");
          extraValues.EmplaceBack(extensions.value());
        }
        if (formdata) {
          extraKeys.AppendElement()->AssignASCII("formdata");
          extraValues.EmplaceBack(formdata.value());
        }
        if (history) {
          extraKeys.AppendElement()->AssignASCII("history");
          extraValues.EmplaceBack(history.value());
        }
        if (migratorKey) {
          extraKeys.AppendElement()->AssignASCII("migrator_key");
          extraValues.EmplaceBack(migratorKey.value());
        }
        if (other) {
          extraKeys.AppendElement()->AssignASCII("other");
          extraValues.EmplaceBack(nsPrintfCString("%d", other.value()));
        }
        if (passwords) {
          extraKeys.AppendElement()->AssignASCII("passwords");
          extraValues.EmplaceBack(passwords.value());
        }
        if (paymentMethods) {
          extraKeys.AppendElement()->AssignASCII("payment_methods");
          extraValues.EmplaceBack(paymentMethods.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user selects resources from the browser / profile to import.
     * This event was generated to correspond to the Legacy Telemetry event
     * browser.migration.resources_selected#wizard.
   */
  constexpr impl::EventMetric<ResourcesSelectedWizardExtra> resources_selected_wizard(342);

  /**
   * generated from browser.migration.safari_password_file_wizard
   */
  /**
   * Recorded if the user is on macOS, chose to migrate from Safari, and was
     * presented with the page of the wizard requesting to import passwords from a
     * file. This only gets recorded in the new migration wizard. This event was
     * generated to correspond to the Legacy Telemetry event
     * browser.migration.safari_password_file#wizard.
   */
  constexpr impl::EventMetric<NoExtraKeys> safari_password_file_wizard(343);

  /**
   * generated from browser.migration.safari_perms_wizard
   */
  /**
   * Recorded if the user is on macOS, chose to migrate from Safari, and was
     * presented with the page of the wizard requesting permission to read from the
     * Safari profile folder. This event was generated to correspond to the Legacy
     * Telemetry event browser.migration.safari_perms#wizard.
   */
  constexpr impl::EventMetric<NoExtraKeys> safari_perms_wizard(344);

  /**
   * generated from browser.migration.unmatched_extensions
   */
  /**
   * Records a list of the Chrome extension IDs that were unsuccessfully matched to
     * Firefox equivalents from the list downloaded from AMO.
   */
  constexpr impl::StringListMetric unmatched_extensions(345);

}
namespace migration {
  /**
   * generated from migration.discovered_migrators
   */
  /**
   * A keyed uint recording how many times the migration wizard detected a browser /
     * profile pair for a particular browser. This is incremented every time the
     * discovery occurs, so multiple openings of the wizard will increase the counts
     * each time. This metric was generated to correspond to the Legacy Telemetry
     * scalar migration.discovered_migrators.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> discovered_migrators(346);

  /**
   * generated from migration.time_to_produce_migrator_list
   */
  /**
   * The amount of time it took in milliseconds to produce the list of migrators and
     * profiles for the first time the migration wizard opened during the process
     * lifetime. This metric was generated to correspond to the Legacy Telemetry
     * scalar migration.time_to_produce_migrator_list.
   */
  constexpr impl::TimespanMetric time_to_produce_migrator_list(347);

  /**
   * generated from migration.uninstaller_profile_refresh
   */
  /**
   * Set when a profile refresh is initiated from the uninstaller. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * migration.uninstaller_profile_refresh.
   */
  constexpr impl::BooleanMetric uninstaller_profile_refresh(348);

}
namespace activity_stream {
  /**
   * generated from activity_stream.end_session
   */
    struct EndSessionExtra {
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<uint32_t> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(nsPrintfCString("%d", value.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every session ended in Activity Stream. This event was
     * generated to correspond to the Legacy Telemetry event
     * activity_stream.end#session.
   */
  constexpr impl::EventMetric<EndSessionExtra> end_session(349);

  /**
   * generated from activity_stream.event_archive_from_pocket
   */
    struct EventArchiveFromPocketExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#ARCHIVE_FROM_POCKET.
   */
  constexpr impl::EventMetric<EventArchiveFromPocketExtra> event_archive_from_pocket(350);

  /**
   * generated from activity_stream.event_block
   */
    struct EventBlockExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#BLOCK.
   */
  constexpr impl::EventMetric<EventBlockExtra> event_block(351);

  /**
   * generated from activity_stream.event_bookmark_add
   */
    struct EventBookmarkAddExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#BOOKMARK_ADD.
   */
  constexpr impl::EventMetric<EventBookmarkAddExtra> event_bookmark_add(352);

  /**
   * generated from activity_stream.event_bookmark_delete
   */
    struct EventBookmarkDeleteExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#BOOKMARK_DELETE.
   */
  constexpr impl::EventMetric<EventBookmarkDeleteExtra> event_bookmark_delete(353);

  /**
   * generated from activity_stream.event_click
   */
    struct EventClickExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#CLICK.
   */
  constexpr impl::EventMetric<EventClickExtra> event_click(354);

  /**
   * generated from activity_stream.event_click_privacy_info
   */
    struct EventClickPrivacyInfoExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#CLICK_PRIVACY_INFO.
   */
  constexpr impl::EventMetric<EventClickPrivacyInfoExtra> event_click_privacy_info(355);

  /**
   * generated from activity_stream.event_close_newtab_prefs
   */
    struct EventCloseNewtabPrefsExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#CLOSE_NEWTAB_PREFS.
   */
  constexpr impl::EventMetric<EventCloseNewtabPrefsExtra> event_close_newtab_prefs(356);

  /**
   * generated from activity_stream.event_delete
   */
    struct EventDeleteExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#DELETE.
   */
  constexpr impl::EventMetric<EventDeleteExtra> event_delete(357);

  /**
   * generated from activity_stream.event_delete_confirm
   */
    struct EventDeleteConfirmExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#DELETE_CONFIRM.
   */
  constexpr impl::EventMetric<EventDeleteConfirmExtra> event_delete_confirm(358);

  /**
   * generated from activity_stream.event_delete_from_pocket
   */
    struct EventDeleteFromPocketExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#DELETE_FROM_POCKET.
   */
  constexpr impl::EventMetric<EventDeleteFromPocketExtra> event_delete_from_pocket(359);

  /**
   * generated from activity_stream.event_dialog_cancel
   */
    struct EventDialogCancelExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#DIALOG_CANCEL.
   */
  constexpr impl::EventMetric<EventDialogCancelExtra> event_dialog_cancel(360);

  /**
   * generated from activity_stream.event_dialog_open
   */
    struct EventDialogOpenExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#DIALOG_OPEN.
   */
  constexpr impl::EventMetric<EventDialogOpenExtra> event_dialog_open(361);

  /**
   * generated from activity_stream.event_disclaimer_acked
   */
    struct EventDisclaimerAckedExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#DISCLAIMER_ACKED.
   */
  constexpr impl::EventMetric<EventDisclaimerAckedExtra> event_disclaimer_acked(362);

  /**
   * generated from activity_stream.event_drag
   */
    struct EventDragExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#DRAG.
   */
  constexpr impl::EventMetric<EventDragExtra> event_drag(363);

  /**
   * generated from activity_stream.event_drop
   */
    struct EventDropExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#DROP.
   */
  constexpr impl::EventMetric<EventDropExtra> event_drop(364);

  /**
   * generated from activity_stream.event_fakespot_category
   */
    struct EventFakespotCategoryExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#FAKESPOT_CATEGORY.
   */
  constexpr impl::EventMetric<EventFakespotCategoryExtra> event_fakespot_category(365);

  /**
   * generated from activity_stream.event_fakespot_click
   */
    struct EventFakespotClickExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#FAKESPOT_CLICK.
   */
  constexpr impl::EventMetric<EventFakespotClickExtra> event_fakespot_click(366);

  /**
   * generated from activity_stream.event_hide_personalize
   */
    struct EventHidePersonalizeExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#HIDE_PERSONALIZE.
   */
  constexpr impl::EventMetric<EventHidePersonalizeExtra> event_hide_personalize(367);

  /**
   * generated from activity_stream.event_impression
   */
    struct EventImpressionExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#IMPRESSION.
   */
  constexpr impl::EventMetric<EventImpressionExtra> event_impression(368);

  /**
   * generated from activity_stream.event_menu_add_search
   */
    struct EventMenuAddSearchExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#MENU_ADD_SEARCH.
   */
  constexpr impl::EventMetric<EventMenuAddSearchExtra> event_menu_add_search(369);

  /**
   * generated from activity_stream.event_menu_add_topsite
   */
    struct EventMenuAddTopsiteExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#MENU_ADD_TOPSITE.
   */
  constexpr impl::EventMetric<EventMenuAddTopsiteExtra> event_menu_add_topsite(370);

  /**
   * generated from activity_stream.event_menu_collapse
   */
    struct EventMenuCollapseExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#MENU_COLLAPSE.
   */
  constexpr impl::EventMetric<EventMenuCollapseExtra> event_menu_collapse(371);

  /**
   * generated from activity_stream.event_menu_expand
   */
    struct EventMenuExpandExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#MENU_EXPAND.
   */
  constexpr impl::EventMetric<EventMenuExpandExtra> event_menu_expand(372);

  /**
   * generated from activity_stream.event_menu_manage
   */
    struct EventMenuManageExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#MENU_MANAGE.
   */
  constexpr impl::EventMetric<EventMenuManageExtra> event_menu_manage(373);

  /**
   * generated from activity_stream.event_menu_move_down
   */
    struct EventMenuMoveDownExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#MENU_MOVE_DOWN.
   */
  constexpr impl::EventMetric<EventMenuMoveDownExtra> event_menu_move_down(374);

  /**
   * generated from activity_stream.event_menu_move_up
   */
    struct EventMenuMoveUpExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#MENU_MOVE_UP.
   */
  constexpr impl::EventMetric<EventMenuMoveUpExtra> event_menu_move_up(375);

  /**
   * generated from activity_stream.event_menu_privacy_notice
   */
    struct EventMenuPrivacyNoticeExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#MENU_PRIVACY_NOTICE.
   */
  constexpr impl::EventMetric<EventMenuPrivacyNoticeExtra> event_menu_privacy_notice(376);

  /**
   * generated from activity_stream.event_menu_remove
   */
    struct EventMenuRemoveExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#MENU_REMOVE.
   */
  constexpr impl::EventMetric<EventMenuRemoveExtra> event_menu_remove(377);

  /**
   * generated from activity_stream.event_migration_cancel
   */
    struct EventMigrationCancelExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#MIGRATION_CANCEL.
   */
  constexpr impl::EventMetric<EventMigrationCancelExtra> event_migration_cancel(378);

  /**
   * generated from activity_stream.event_migration_start
   */
    struct EventMigrationStartExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#MIGRATION_START.
   */
  constexpr impl::EventMetric<EventMigrationStartExtra> event_migration_start(379);

  /**
   * generated from activity_stream.event_open_new_window
   */
    struct EventOpenNewWindowExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#OPEN_NEW_WINDOW.
   */
  constexpr impl::EventMetric<EventOpenNewWindowExtra> event_open_new_window(380);

  /**
   * generated from activity_stream.event_open_newtab_prefs
   */
    struct EventOpenNewtabPrefsExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#OPEN_NEWTAB_PREFS.
   */
  constexpr impl::EventMetric<EventOpenNewtabPrefsExtra> event_open_newtab_prefs(381);

  /**
   * generated from activity_stream.event_open_private_window
   */
    struct EventOpenPrivateWindowExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#OPEN_PRIVATE_WINDOW.
   */
  constexpr impl::EventMetric<EventOpenPrivateWindowExtra> event_open_private_window(382);

  /**
   * generated from activity_stream.event_pin
   */
    struct EventPinExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#PIN.
   */
  constexpr impl::EventMetric<EventPinExtra> event_pin(383);

  /**
   * generated from activity_stream.event_pocket_thumbs_down
   */
    struct EventPocketThumbsDownExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#POCKET_THUMBS_DOWN.
   */
  constexpr impl::EventMetric<EventPocketThumbsDownExtra> event_pocket_thumbs_down(384);

  /**
   * generated from activity_stream.event_pocket_thumbs_up
   */
    struct EventPocketThumbsUpExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#POCKET_THUMBS_UP.
   */
  constexpr impl::EventMetric<EventPocketThumbsUpExtra> event_pocket_thumbs_up(385);

  /**
   * generated from activity_stream.event_pref_changed
   */
    struct EventPrefChangedExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#PREF_CHANGED.
   */
  constexpr impl::EventMetric<EventPrefChangedExtra> event_pref_changed(386);

  /**
   * generated from activity_stream.event_preview_request
   */
    struct EventPreviewRequestExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#PREVIEW_REQUEST.
   */
  constexpr impl::EventMetric<EventPreviewRequestExtra> event_preview_request(387);

  /**
   * generated from activity_stream.event_save_to_pocket
   */
    struct EventSaveToPocketExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#SAVE_TO_POCKET.
   */
  constexpr impl::EventMetric<EventSaveToPocketExtra> event_save_to_pocket(388);

  /**
   * generated from activity_stream.event_search
   */
    struct EventSearchExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#SEARCH.
   */
  constexpr impl::EventMetric<EventSearchExtra> event_search(389);

  /**
   * generated from activity_stream.event_search_edit_add
   */
    struct EventSearchEditAddExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#SEARCH_EDIT_ADD.
   */
  constexpr impl::EventMetric<EventSearchEditAddExtra> event_search_edit_add(390);

  /**
   * generated from activity_stream.event_search_edit_close
   */
    struct EventSearchEditCloseExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#SEARCH_EDIT_CLOSE.
   */
  constexpr impl::EventMetric<EventSearchEditCloseExtra> event_search_edit_close(391);

  /**
   * generated from activity_stream.event_search_edit_delete
   */
    struct EventSearchEditDeleteExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#SEARCH_EDIT_DELETE.
   */
  constexpr impl::EventMetric<EventSearchEditDeleteExtra> event_search_edit_delete(392);

  /**
   * generated from activity_stream.event_search_handoff
   */
    struct EventSearchHandoffExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#SEARCH_HANDOFF.
   */
  constexpr impl::EventMetric<EventSearchHandoffExtra> event_search_handoff(393);

  /**
   * generated from activity_stream.event_show_personalize
   */
    struct EventShowPersonalizeExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#SHOW_PERSONALIZE.
   */
  constexpr impl::EventMetric<EventShowPersonalizeExtra> event_show_personalize(394);

  /**
   * generated from activity_stream.event_show_privacy_info
   */
    struct EventShowPrivacyInfoExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#SHOW_PRIVACY_INFO.
   */
  constexpr impl::EventMetric<EventShowPrivacyInfoExtra> event_show_privacy_info(395);

  /**
   * generated from activity_stream.event_skipped_signin
   */
    struct EventSkippedSigninExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#SKIPPED_SIGNIN.
   */
  constexpr impl::EventMetric<EventSkippedSigninExtra> event_skipped_signin(396);

  /**
   * generated from activity_stream.event_submit_email
   */
    struct EventSubmitEmailExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#SUBMIT_EMAIL.
   */
  constexpr impl::EventMetric<EventSubmitEmailExtra> event_submit_email(397);

  /**
   * generated from activity_stream.event_top_sites_edit
   */
    struct EventTopSitesEditExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#TOP_SITES_EDIT.
   */
  constexpr impl::EventMetric<EventTopSitesEditExtra> event_top_sites_edit(398);

  /**
   * generated from activity_stream.event_top_sites_edit_close
   */
    struct EventTopSitesEditCloseExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#TOP_SITES_EDIT_CLOSE.
   */
  constexpr impl::EventMetric<EventTopSitesEditCloseExtra> event_top_sites_edit_close(399);

  /**
   * generated from activity_stream.event_topsite_sponsor_info
   */
    struct EventTopsiteSponsorInfoExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#TOPSITE_SPONSOR_INFO.
   */
  constexpr impl::EventMetric<EventTopsiteSponsorInfoExtra> event_topsite_sponsor_info(400);

  /**
   * generated from activity_stream.event_unpin
   */
    struct EventUnpinExtra {
      mozilla::Maybe<uint32_t> actionPosition;
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> page;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<uint32_t> userPrefs;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actionPosition) {
          extraKeys.AppendElement()->AssignASCII("action_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", actionPosition.value()));
        }
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (page) {
          extraKeys.AppendElement()->AssignASCII("page");
          extraValues.EmplaceBack(page.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (userPrefs) {
          extraKeys.AppendElement()->AssignASCII("user_prefs");
          extraValues.EmplaceBack(nsPrintfCString("%d", userPrefs.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded with every user interaction on Activity Stream elements. This
     * event was generated to correspond to the Legacy Telemetry event
     * activity_stream.event#UNPIN.
   */
  constexpr impl::EventMetric<EventUnpinExtra> event_unpin(401);

}
namespace contextual_services_topsites {
  /**
   * generated from contextual.services.topsites.click
   */
  /**
   * A keyed uint recording how many times the user has clicked on the sponsored
     * TopSites on the newtab page. The key is a combination of the source and the
     * placement of the TopSites tile (1-based). such as 'urlbar_1', 'newtab_2'. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * contextual.services.topsites.click.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> click(402);

  /**
   * generated from contextual.services.topsites.impression
   */
  /**
   * A keyed uint recording how many times the user has viewed the sponsored
     * TopSites on the newtab page. The key is a combination of the source and the
     * placement of the TopSites tile (1-based). such as 'urlbar_1', 'newtab_2'. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * contextual.services.topsites.impression.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> impression(403);

}
namespace deletion_request {
  /**
   * generated from deletion.request.context_id
   */
  /**
   * An identifier to identify users for Contextual Services user interaction pings.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * deletion.request.context_id.
   */
  constexpr impl::StringMetric context_id(404);

  /**
   * generated from deletion.request.impression_id
   */
  /**
   * An identifier used by user interaction pings in Pocket/newtab and Messaging
     * System. This metric was generated to correspond to the Legacy Telemetry scalar
     * deletion.request.impression_id.
   */
  constexpr impl::StringMetric impression_id(405);

  /**
   * generated from deletion.request.sync_device_id
   */
  /**
   * An identifier used by sync ping, to identify the current Firefox profile for a
     * specific Account. This metric was generated to correspond to the Legacy
     * Telemetry scalar deletion.request.sync_device_id.
   */
  constexpr impl::StringMetric sync_device_id(406);

}
namespace messaging_system {
  /**
   * generated from messaging_system.addon_version
   */
  /**
   * Used to hold the system addon's version, now is almost certainly an echo of the
     * app's build id.
   */
  constexpr impl::StringMetric addon_version(407);

  /**
   * generated from messaging_system.browser_session_id
   */
  /**
   * The Legacy Telemetry browser "session id". Identifies a specific period from
     * application start to shutdown. See [the "main" ping docs](https://firefox-
     * source-docs.mozilla.org/toolkit/components/telemetry/data/main-ping.html) for
     * details.
   */
  constexpr impl::UuidMetric browser_session_id(408);

  /**
   * generated from messaging_system.bucket_id
   */
  /**
   * A name shared between multiple messages that may individually be too targetted.
     * e.g. a message that gets shown on specific websites or a message asking about
     * personal information.
   */
  constexpr impl::StringMetric bucket_id(409);

  /**
   * generated from messaging_system.client_id
   */
  /**
   * The client_id according to Telemetry.
     * Might not always have a value due to policy around specific types of
     * ping being sent. Value may be the canary client id
     * `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
     * in pings near when the data upload pref is disabled (if Telemetry gets
     * to go first), or between when a client_id has been removed and when it
     * has been regenerated.
     * Present only in some circumstances (see
     * [bug 1484035]https://bugzilla.mozilla.org/show_bug.cgi?id=1484035)).
   */
  constexpr impl::UuidMetric client_id(410);

  /**
   * generated from messaging_system.event
   */
  /**
   * The type of event. Any user defined string (e.g. “IMPRESSION”, “CLICK_BUTTON”,
     * "INDEXEDDB_OPEN_FAILED", “SESSION_END”)
   */
  constexpr impl::StringMetric event(411);

  /**
   * generated from messaging_system.event_context
   */
  /**
   * The stringified JSON of `event_context`.
   */
  constexpr impl::TextMetric event_context(412);

  /**
   * generated from messaging_system.event_context_parse_error
   */
  /**
   * How often we failed to parse event_context as JSON.
   */
  constexpr impl::CounterMetric event_context_parse_error(413);

  /**
   * generated from messaging_system.event_page
   */
  /**
   * The event_context's `page`. Almost always "about:welcome".
   */
  constexpr impl::StringMetric event_page(414);

  /**
   * generated from messaging_system.event_reason
   */
  /**
   * The event_context's `reason`. Likely something like
     * "welcome-window-closed" or "app-shut-down",.
   */
  constexpr impl::StringMetric event_reason(415);

  /**
   * generated from messaging_system.event_screen_family
   */
  /**
   * A string identifier of the message family derived from the message id
     * (e.g. MR_WELCOME_DEFAULT).
   */
  constexpr impl::TextMetric event_screen_family(416);

  /**
   * generated from messaging_system.event_screen_id
   */
  /**
   * A string identifier of the message screen id
     * (e.g. AW_MOBILE_DOWNLOAD).
   */
  constexpr impl::TextMetric event_screen_id(417);

  /**
   * generated from messaging_system.event_screen_index
   */
  /**
   * A number identifier of the screen index in a sequence of screens
     * (e.g. 0 for first message).
   */
  constexpr impl::QuantityMetric event_screen_index(418);

  /**
   * generated from messaging_system.event_screen_initials
   */
  /**
   * A string identifier of the message screen initials
     * (e.g. 'EMAG' for EASY_SETUP, MOBILE_DOWNLOADS, AMO, GRATITUDE).
   */
  constexpr impl::TextMetric event_screen_initials(419);

  /**
   * generated from messaging_system.event_source
   */
  /**
   * The event_context's `source`. Likely something like "primary_button".
   */
  constexpr impl::StringMetric event_source(420);

  /**
   * generated from messaging_system.glean_ping_for_ping_failures
   */
  /**
   * How often something went awry within
     * `AboutWelcome.submitGleanPingForPing`, preventing ping submission.
   */
  constexpr impl::CounterMetric glean_ping_for_ping_failures(421);

  /**
   * generated from messaging_system.impression_id
   */
  /**
   * The unique impression identifier for a specific client.
   */
  constexpr impl::UuidMetric impression_id(422);

  /**
   * generated from messaging_system.invalid_nested_data
   */
  /**
   * We received a ping with non-scalar data on a field of this name.
     * If this is existing pre-PingCentre-replacement data, you may need to
     * augment the logic in
     * `AboutWelcome.submitGleanPingForPing` like the other `handledKeys`.
     * If this is for new, post-PingCentre-replacement data, you should
     * probably prefer a flat structure.
     * If you're unsure, please ask in
     * [the #glean channel](https://chat.mozilla.org/#/room/#glean:mozilla.org).
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> invalid_nested_data(423);

  /**
   * generated from messaging_system.locale
   */
  /**
   * The locale as supplied to the messaging system by
     * `Services.locale.appLocaleAsBCP47`.
   */
  constexpr impl::StringMetric locale(424);

  /**
   * generated from messaging_system.message_id
   */
  /**
   * A string identifier of the message in Activity Stream Router.
   */
  constexpr impl::TextMetric message_id(425);

  /**
   * generated from messaging_system.ping_type
   */
  /**
   * Type of event the ping is capturing. e.g. "cfr", "onboarding"
   */
  constexpr impl::StringMetric ping_type(426);

  /**
   * generated from messaging_system.source
   */
  /**
   * The source of the interaction described by the other metrics. e.g.
     * "frecent_links", "newtab", "CFR"
   */
  constexpr impl::StringMetric source(427);

  /**
   * generated from messaging_system.unknown_key_count
   */
  /**
   * The sum of all unknown keys counted.
     * Useful for testing.
     * Can be removed after bug 1600008 is resolved.
   */
  constexpr impl::CounterMetric unknown_key_count(428);

  /**
   * generated from messaging_system.unknown_keys
   */
  /**
   * Ping keys supplied to the messaging system for which
     * we did not have a corresponding metric mapped to how often they attempted
     * to be recorded.
     * You may have forgotten to define an appropriate metric in
     * `browser/components/newtab/metrics.yaml`.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> unknown_keys(429);

}
namespace messaging_system_attribution {
  /**
   * generated from messaging_system.attribution.campaign
   */
  /**
   * Attribution's campaign, possibly derived from the utm parameter of the
     * same name.
   */
  constexpr impl::StringMetric campaign(430);

  /**
   * generated from messaging_system.attribution.content
   */
  /**
   * Attribution's content, possibly derived from the utm parameter of the
     * same name.
   */
  constexpr impl::StringMetric content(431);

  /**
   * generated from messaging_system.attribution.dlsource
   */
  /**
   * Mozilla-specific download "source" name. Could be something like
     * "mozillaci" to identify that the installer came from
     * `{archive|ftp}.mozilla.org`.
   */
  constexpr impl::StringMetric dlsource(432);

  /**
   * generated from messaging_system.attribution.dltoken
   */
  /**
   * String representation of the dltoken identifying the particular
     * installer used to install this Firefox.
     * Likely a UUID, if present.
   */
  constexpr impl::StringMetric dltoken(433);

  /**
   * generated from messaging_system.attribution.experiment
   */
  /**
   * Attribution's experiment key.
   */
  constexpr impl::StringMetric experiment(434);

  /**
   * generated from messaging_system.attribution.medium
   */
  /**
   * Attribution's medium, possibly derived from the utm parameter of the same
     * name.
   */
  constexpr impl::StringMetric medium(435);

  /**
   * generated from messaging_system.attribution.msstoresignedin
   */
  /**
   * Either the string "true" or the string "false" to indicate whether the
     * attributed install came from the Microsoft store and, if so, whether the
     * user was signed in at the time.
   */
  constexpr impl::StringMetric msstoresignedin(436);

  /**
   * generated from messaging_system.attribution.source
   */
  /**
   * Attribution's source, possibly derived from the utm parameter of the same
     * name.
   */
  constexpr impl::StringMetric source(437);

  /**
   * generated from messaging_system.attribution.ua
   */
  /**
   * Attribution's ua key.
   */
  constexpr impl::StringMetric ua(438);

  /**
   * generated from messaging_system.attribution.unknown_keys
   */
  /**
   * Attribution keys supplied to the messaging system for which
     * we did not have a corresponding metric, and the count of how
     * often that happened.
     * Either add this key to a list of known attribution keys in
     * `AboutWelcomeTelemetry` to suppress or define an appropriate metric in
     * `browser/components/newtab/metrics.yaml` to collect.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> unknown_keys(439);

  /**
   * generated from messaging_system.attribution.variation
   */
  /**
   * Attribution's variation key.
   */
  constexpr impl::StringMetric variation(440);

}
namespace newtab {
  /**
   * generated from newtab.blocked_sponsors
   */
  /**
   * The advertiser names that have been dismissed by the user.
   */
  constexpr impl::StringListMetric blocked_sponsors(441);

  /**
   * generated from newtab.closed
   */
    struct ClosedExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when newtab UI is closed by * navigation * closing the tab
     * Doesn't mean that the newtab was ever visible to a user.
   */
  constexpr impl::EventMetric<ClosedExtra> closed(442);

  /**
   * generated from newtab.fakespot_about_click
   */
    struct FakespotAboutClickExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user the 'About Fakespot' link in TBR fakespot feed context
     * menu
   */
  constexpr impl::EventMetric<FakespotAboutClickExtra> fakespot_about_click(443);

  /**
   * generated from newtab.fakespot_category
   */
    struct FakespotCategoryExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user changes the category in TBR fakespot feed
   */
  constexpr impl::EventMetric<FakespotCategoryExtra> fakespot_category(444);

  /**
   * generated from newtab.fakespot_click
   */
    struct FakespotClickExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> productId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (productId) {
          extraKeys.AppendElement()->AssignASCII("product_id");
          extraValues.EmplaceBack(productId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user clicks on a card in TBR fakespot feed
   */
  constexpr impl::EventMetric<FakespotClickExtra> fakespot_click(445);

  /**
   * generated from newtab.fakespot_cta_click
   */
    struct FakespotCtaClickExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user clicks on the CTA in TBR fakespot feed
   */
  constexpr impl::EventMetric<FakespotCtaClickExtra> fakespot_cta_click(446);

  /**
   * generated from newtab.fakespot_dismiss
   */
    struct FakespotDismissExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user dissmisses TBR fakespot feed
   */
  constexpr impl::EventMetric<FakespotDismissExtra> fakespot_dismiss(447);

  /**
   * generated from newtab.fakespot_product_impression
   */
    struct FakespotProductImpressionExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> productId;
      mozilla::Maybe<nsCString> productTitle;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (productId) {
          extraKeys.AppendElement()->AssignASCII("product_id");
          extraValues.EmplaceBack(productId.value());
        }
        if (productTitle) {
          extraKeys.AppendElement()->AssignASCII("product_title");
          extraValues.EmplaceBack(productTitle.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user triggers an impression on a card in TBR fakespot feed
   */
  constexpr impl::EventMetric<FakespotProductImpressionExtra> fakespot_product_impression(448);

  /**
   * generated from newtab.homepage_category
   */
  /**
   * The current setting of the home page. One of ["enabled", "disabled",
     * "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
     * media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
     * `home_url_category`. Sampled once after newtab init.
   */
  constexpr impl::StringMetric homepage_category(449);

  /**
   * generated from newtab.locale
   */
  /**
   * The application's locale as of when newtab's TelemetryFeed was init. Comes from
     * `Services.local.appLocaleAsBCP47`. Looks like `en-US`.
   */
  constexpr impl::StringMetric locale(450);

  /**
   * generated from newtab.newtab_category
   */
  /**
   * The current setting of the newtab page. One of ["enabled", "disabled",
     * "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
     * media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
     * `newtab_url_category`. Sampled once after newtab init.
   */
  constexpr impl::StringMetric newtab_category(451);

  /**
   * generated from newtab.opened
   */
    struct OpenedExtra {
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> windowInnerHeight;
      mozilla::Maybe<nsCString> windowInnerWidth;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (windowInnerHeight) {
          extraKeys.AppendElement()->AssignASCII("window_inner_height");
          extraValues.EmplaceBack(windowInnerHeight.value());
        }
        if (windowInnerWidth) {
          extraKeys.AppendElement()->AssignASCII("window_inner_width");
          extraValues.EmplaceBack(windowInnerWidth.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when newtab UI is opened via `about:newtab` or `about:home` or
     * `about:welcome` and has been made visible (see `visibility_event_rcvd_ts` in
     * [detect-user-session-start.js](https://searchfox.org/mozilla-
     * central/source/browser/components/newtab/content-src/lib/detect-user-session-
     * start.js)).
   */
  constexpr impl::EventMetric<OpenedExtra> opened(452);

  /**
   * generated from newtab.sections_block_section
   */
    struct SectionsBlockSectionExtra {
      mozilla::Maybe<nsCString> eventSource;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> section;
      mozilla::Maybe<nsCString> sectionPosition;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (eventSource) {
          extraKeys.AppendElement()->AssignASCII("event_source");
          extraValues.EmplaceBack(eventSource.value());
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (section) {
          extraKeys.AppendElement()->AssignASCII("section");
          extraValues.EmplaceBack(section.value());
        }
        if (sectionPosition) {
          extraKeys.AppendElement()->AssignASCII("section_position");
          extraValues.EmplaceBack(sectionPosition.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a section is blocked
   */
  constexpr impl::EventMetric<SectionsBlockSectionExtra> sections_block_section(453);

  /**
   * generated from newtab.sections_follow_section
   */
    struct SectionsFollowSectionExtra {
      mozilla::Maybe<nsCString> eventSource;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> section;
      mozilla::Maybe<nsCString> sectionPosition;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (eventSource) {
          extraKeys.AppendElement()->AssignASCII("event_source");
          extraValues.EmplaceBack(eventSource.value());
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (section) {
          extraKeys.AppendElement()->AssignASCII("section");
          extraValues.EmplaceBack(section.value());
        }
        if (sectionPosition) {
          extraKeys.AppendElement()->AssignASCII("section_position");
          extraValues.EmplaceBack(sectionPosition.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a section is followed
   */
  constexpr impl::EventMetric<SectionsFollowSectionExtra> sections_follow_section(454);

  /**
   * generated from newtab.sections_impression
   */
    struct SectionsImpressionExtra {
      mozilla::Maybe<bool> isSectonFollowed;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> section;
      mozilla::Maybe<nsCString> sectionPosition;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isSectonFollowed) {
          extraKeys.AppendElement()->AssignASCII("is_secton_followed");
          extraValues.AppendElement()->AssignASCII(isSectonFollowed.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (section) {
          extraKeys.AppendElement()->AssignASCII("section");
          extraValues.EmplaceBack(section.value());
        }
        if (sectionPosition) {
          extraKeys.AppendElement()->AssignASCII("section_position");
          extraValues.EmplaceBack(sectionPosition.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a section is viewport and triggers an impression event
   */
  constexpr impl::EventMetric<SectionsImpressionExtra> sections_impression(455);

  /**
   * generated from newtab.sections_unfollow_section
   */
    struct SectionsUnfollowSectionExtra {
      mozilla::Maybe<nsCString> eventSource;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> section;
      mozilla::Maybe<nsCString> sectionPosition;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (eventSource) {
          extraKeys.AppendElement()->AssignASCII("event_source");
          extraValues.EmplaceBack(eventSource.value());
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (section) {
          extraKeys.AppendElement()->AssignASCII("section");
          extraValues.EmplaceBack(section.value());
        }
        if (sectionPosition) {
          extraKeys.AppendElement()->AssignASCII("section_position");
          extraValues.EmplaceBack(sectionPosition.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a section is unfollowed
   */
  constexpr impl::EventMetric<SectionsUnfollowSectionExtra> sections_unfollow_section(456);

  /**
   * generated from newtab.selected_topics
   */
  /**
   * The list of topics the user selected
   */
  constexpr impl::StringListMetric selected_topics(457);

  /**
   * generated from newtab.sov_allocation
   */
  /**
   * The partner group assignment for sov
   */
  constexpr impl::StringListMetric sov_allocation(458);

  /**
   * generated from newtab.tooltip_click
   */
    struct TooltipClickExtra {
      mozilla::Maybe<nsCString> feature;
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (feature) {
          extraKeys.AppendElement()->AssignASCII("feature");
          extraValues.EmplaceBack(feature.value());
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a feature highlight tooltip is opened.
   */
  constexpr impl::EventMetric<TooltipClickExtra> tooltip_click(459);

  /**
   * generated from newtab.topic_selection_dismiss
   */
    struct TopicSelectionDismissExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the topic selection modal is dismissed (topics are not saved)
   */
  constexpr impl::EventMetric<TopicSelectionDismissExtra> topic_selection_dismiss(460);

  /**
   * generated from newtab.topic_selection_open
   */
    struct TopicSelectionOpenExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the topic selection modal is opened
   */
  constexpr impl::EventMetric<TopicSelectionOpenExtra> topic_selection_open(461);

  /**
   * generated from newtab.topic_selection_topics_saved
   */
    struct TopicSelectionTopicsSavedExtra {
      mozilla::Maybe<bool> firstSave;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> previousTopics;
      mozilla::Maybe<nsCString> topics;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstSave) {
          extraKeys.AppendElement()->AssignASCII("first_save");
          extraValues.AppendElement()->AssignASCII(firstSave.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (previousTopics) {
          extraKeys.AppendElement()->AssignASCII("previous_topics");
          extraValues.EmplaceBack(previousTopics.value());
        }
        if (topics) {
          extraKeys.AppendElement()->AssignASCII("topics");
          extraValues.EmplaceBack(topics.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when topics are saved from the topics selection modal
   */
  constexpr impl::EventMetric<TopicSelectionTopicsSavedExtra> topic_selection_topics_saved(462);

  /**
   * generated from newtab.wallpaper_category_click
   */
    struct WallpaperCategoryClickExtra {
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> selectedCategory;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (selectedCategory) {
          extraKeys.AppendElement()->AssignASCII("selected_category");
          extraValues.EmplaceBack(selectedCategory.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user clicks a wallpaper category option
   */
  constexpr impl::EventMetric<WallpaperCategoryClickExtra> wallpaper_category_click(463);

  /**
   * generated from newtab.wallpaper_click
   */
    struct WallpaperClickExtra {
      mozilla::Maybe<bool> hadPreviousWallpaper;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> selectedWallpaper;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hadPreviousWallpaper) {
          extraKeys.AppendElement()->AssignASCII("had_previous_wallpaper");
          extraValues.AppendElement()->AssignASCII(hadPreviousWallpaper.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (selectedWallpaper) {
          extraKeys.AppendElement()->AssignASCII("selected_wallpaper");
          extraValues.EmplaceBack(selectedWallpaper.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user clicks on a wallpaper option
   */
  constexpr impl::EventMetric<WallpaperClickExtra> wallpaper_click(464);

  /**
   * generated from newtab.wallpaper_highlight_cta_click
   */
    struct WallpaperHighlightCtaClickExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user clicks the CTA on the wallpaper feature highlight
   */
  constexpr impl::EventMetric<WallpaperHighlightCtaClickExtra> wallpaper_highlight_cta_click(465);

  /**
   * generated from newtab.wallpaper_highlight_dismissed
   */
    struct WallpaperHighlightDismissedExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user dismisses the wallpaper feature highlight
   */
  constexpr impl::EventMetric<WallpaperHighlightDismissedExtra> wallpaper_highlight_dismissed(466);

  /**
   * generated from newtab.weather_change_display
   */
    struct WeatherChangeDisplayExtra {
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> weatherDisplayMode;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (weatherDisplayMode) {
          extraKeys.AppendElement()->AssignASCII("weather_display_mode");
          extraValues.EmplaceBack(weatherDisplayMode.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user changes the weather display.
   */
  constexpr impl::EventMetric<WeatherChangeDisplayExtra> weather_change_display(467);

  /**
   * generated from newtab.weather_enabled
   */
  /**
   * Whether the weather widget is enabled on the newtab. Corresponds to the value
     * of the `browser.newtabpage.activity-stream.showWeather` pref.
   */
  constexpr impl::BooleanMetric weather_enabled(468);

  /**
   * generated from newtab.weather_impression
   */
    struct WeatherImpressionExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the weather widget is viewed
   */
  constexpr impl::EventMetric<WeatherImpressionExtra> weather_impression(469);

  /**
   * generated from newtab.weather_load_error
   */
    struct WeatherLoadErrorExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the weather widget is not available
   */
  constexpr impl::EventMetric<WeatherLoadErrorExtra> weather_load_error(470);

  /**
   * generated from newtab.weather_location_selected
   */
    struct WeatherLocationSelectedExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user selects a location for weather widget
   */
  constexpr impl::EventMetric<WeatherLocationSelectedExtra> weather_location_selected(471);

  /**
   * generated from newtab.weather_open_provider_url
   */
    struct WeatherOpenProviderUrlExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user opens a link to the Weather provider website.
   */
  constexpr impl::EventMetric<WeatherOpenProviderUrlExtra> weather_open_provider_url(472);

}
namespace newtab_handoff_preference {
  /**
   * generated from newtab.handoff_preference.enabled
   */
  /**
   * Records whether the browser.newtabpage.activity-
     * stream.improvesearch.handoffToAwesomebar preference is enabled or disabled
   */
  constexpr impl::BooleanMetric enabled(473);

}
namespace newtab_search {
  /**
   * generated from newtab.search.enabled
   */
  /**
   * Whether the search input is enabled on the newtab. Corresponds to the value of
     * the `browser.newtabpage.activity-stream.showSearch` pref.
   */
  constexpr impl::BooleanMetric enabled(474);

  /**
   * generated from newtab.search.issued
   */
    struct IssuedExtra {
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> searchAccessPoint;
      mozilla::Maybe<nsCString> telemetryId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (searchAccessPoint) {
          extraKeys.AppendElement()->AssignASCII("search_access_point");
          extraValues.EmplaceBack(searchAccessPoint.value());
        }
        if (telemetryId) {
          extraKeys.AppendElement()->AssignASCII("telemetry_id");
          extraValues.EmplaceBack(telemetryId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * When Firefox was asked to issue a search from a Search Access Point (SAP) on a
     * newtab page. Doesn't record searches in Private Browsing Mode unless
     * `browser.engagement.search_counts.pbm` is set to `true`.
   */
  constexpr impl::EventMetric<IssuedExtra> issued(475);

}
namespace pocket {
  /**
   * generated from pocket.click
   */
    struct ClickExtra {
      mozilla::Maybe<nsCString> corpusItemId;
      mozilla::Maybe<nsCString> format;
      mozilla::Maybe<bool> isListCard;
      mozilla::Maybe<bool> isSectonFollowed;
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> matchesSelectedTopic;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> receivedRank;
      mozilla::Maybe<nsCString> recommendationId;
      mozilla::Maybe<uint32_t> recommendedAt;
      mozilla::Maybe<nsCString> scheduledCorpusItemId;
      mozilla::Maybe<nsCString> section;
      mozilla::Maybe<nsCString> sectionPosition;
      mozilla::Maybe<nsCString> selectedTopics;
      mozilla::Maybe<uint32_t> tileId;
      mozilla::Maybe<nsCString> topic;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (corpusItemId) {
          extraKeys.AppendElement()->AssignASCII("corpus_item_id");
          extraValues.EmplaceBack(corpusItemId.value());
        }
        if (format) {
          extraKeys.AppendElement()->AssignASCII("format");
          extraValues.EmplaceBack(format.value());
        }
        if (isListCard) {
          extraKeys.AppendElement()->AssignASCII("is_list_card");
          extraValues.AppendElement()->AssignASCII(isListCard.value() ? "true" : "false");
        }
        if (isSectonFollowed) {
          extraKeys.AppendElement()->AssignASCII("is_secton_followed");
          extraValues.AppendElement()->AssignASCII(isSectonFollowed.value() ? "true" : "false");
        }
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (matchesSelectedTopic) {
          extraKeys.AppendElement()->AssignASCII("matches_selected_topic");
          extraValues.EmplaceBack(matchesSelectedTopic.value());
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (receivedRank) {
          extraKeys.AppendElement()->AssignASCII("received_rank");
          extraValues.EmplaceBack(nsPrintfCString("%d", receivedRank.value()));
        }
        if (recommendationId) {
          extraKeys.AppendElement()->AssignASCII("recommendation_id");
          extraValues.EmplaceBack(recommendationId.value());
        }
        if (recommendedAt) {
          extraKeys.AppendElement()->AssignASCII("recommended_at");
          extraValues.EmplaceBack(nsPrintfCString("%d", recommendedAt.value()));
        }
        if (scheduledCorpusItemId) {
          extraKeys.AppendElement()->AssignASCII("scheduled_corpus_item_id");
          extraValues.EmplaceBack(scheduledCorpusItemId.value());
        }
        if (section) {
          extraKeys.AppendElement()->AssignASCII("section");
          extraValues.EmplaceBack(section.value());
        }
        if (sectionPosition) {
          extraKeys.AppendElement()->AssignASCII("section_position");
          extraValues.EmplaceBack(sectionPosition.value());
        }
        if (selectedTopics) {
          extraKeys.AppendElement()->AssignASCII("selected_topics");
          extraValues.EmplaceBack(selectedTopics.value());
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        if (topic) {
          extraKeys.AppendElement()->AssignASCII("topic");
          extraValues.EmplaceBack(topic.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a pocket tile is clicked. Only happens on click. Not on middle-
     * click. Not on "Open in new Tab"-like options in the context menu.
   */
  constexpr impl::EventMetric<ClickExtra> click(476);

  /**
   * generated from pocket.dismiss
   */
    struct DismissExtra {
      mozilla::Maybe<nsCString> corpusItemId;
      mozilla::Maybe<nsCString> format;
      mozilla::Maybe<bool> isListCard;
      mozilla::Maybe<bool> isSectonFollowed;
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> receivedRank;
      mozilla::Maybe<nsCString> recommendationId;
      mozilla::Maybe<uint32_t> recommendedAt;
      mozilla::Maybe<nsCString> scheduledCorpusItemId;
      mozilla::Maybe<nsCString> section;
      mozilla::Maybe<nsCString> sectionPosition;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (corpusItemId) {
          extraKeys.AppendElement()->AssignASCII("corpus_item_id");
          extraValues.EmplaceBack(corpusItemId.value());
        }
        if (format) {
          extraKeys.AppendElement()->AssignASCII("format");
          extraValues.EmplaceBack(format.value());
        }
        if (isListCard) {
          extraKeys.AppendElement()->AssignASCII("is_list_card");
          extraValues.AppendElement()->AssignASCII(isListCard.value() ? "true" : "false");
        }
        if (isSectonFollowed) {
          extraKeys.AppendElement()->AssignASCII("is_secton_followed");
          extraValues.AppendElement()->AssignASCII(isSectonFollowed.value() ? "true" : "false");
        }
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (receivedRank) {
          extraKeys.AppendElement()->AssignASCII("received_rank");
          extraValues.EmplaceBack(nsPrintfCString("%d", receivedRank.value()));
        }
        if (recommendationId) {
          extraKeys.AppendElement()->AssignASCII("recommendation_id");
          extraValues.EmplaceBack(recommendationId.value());
        }
        if (recommendedAt) {
          extraKeys.AppendElement()->AssignASCII("recommended_at");
          extraValues.EmplaceBack(nsPrintfCString("%d", recommendedAt.value()));
        }
        if (scheduledCorpusItemId) {
          extraKeys.AppendElement()->AssignASCII("scheduled_corpus_item_id");
          extraValues.EmplaceBack(scheduledCorpusItemId.value());
        }
        if (section) {
          extraKeys.AppendElement()->AssignASCII("section");
          extraValues.EmplaceBack(section.value());
        }
        if (sectionPosition) {
          extraKeys.AppendElement()->AssignASCII("section_position");
          extraValues.EmplaceBack(sectionPosition.value());
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a pocket tile is dismissed.
   */
  constexpr impl::EventMetric<DismissExtra> dismiss(477);

  /**
   * generated from pocket.enabled
   */
  /**
   * Whether Pocket is enabled on the newtab. AKA the "Recommended by Pocket"
     * section. Corresponds to the value of the `browser.newtabpage.activity-
     * stream.feeds.section.topstories` pref.
   */
  constexpr impl::BooleanMetric enabled(478);

  /**
   * generated from pocket.fetch_timestamp
   */
  /**
   * Timestamp of when the spoc was fetched by the client
   */
  constexpr impl::DatetimeMetric fetch_timestamp(479);

  /**
   * generated from pocket.impression
   */
    struct ImpressionExtra {
      mozilla::Maybe<nsCString> corpusItemId;
      mozilla::Maybe<nsCString> format;
      mozilla::Maybe<bool> isListCard;
      mozilla::Maybe<bool> isSectonFollowed;
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> receivedRank;
      mozilla::Maybe<nsCString> recommendationId;
      mozilla::Maybe<uint32_t> recommendedAt;
      mozilla::Maybe<nsCString> scheduledCorpusItemId;
      mozilla::Maybe<nsCString> section;
      mozilla::Maybe<nsCString> sectionPosition;
      mozilla::Maybe<nsCString> selectedTopics;
      mozilla::Maybe<uint32_t> tileId;
      mozilla::Maybe<nsCString> topic;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (corpusItemId) {
          extraKeys.AppendElement()->AssignASCII("corpus_item_id");
          extraValues.EmplaceBack(corpusItemId.value());
        }
        if (format) {
          extraKeys.AppendElement()->AssignASCII("format");
          extraValues.EmplaceBack(format.value());
        }
        if (isListCard) {
          extraKeys.AppendElement()->AssignASCII("is_list_card");
          extraValues.AppendElement()->AssignASCII(isListCard.value() ? "true" : "false");
        }
        if (isSectonFollowed) {
          extraKeys.AppendElement()->AssignASCII("is_secton_followed");
          extraValues.AppendElement()->AssignASCII(isSectonFollowed.value() ? "true" : "false");
        }
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (receivedRank) {
          extraKeys.AppendElement()->AssignASCII("received_rank");
          extraValues.EmplaceBack(nsPrintfCString("%d", receivedRank.value()));
        }
        if (recommendationId) {
          extraKeys.AppendElement()->AssignASCII("recommendation_id");
          extraValues.EmplaceBack(recommendationId.value());
        }
        if (recommendedAt) {
          extraKeys.AppendElement()->AssignASCII("recommended_at");
          extraValues.EmplaceBack(nsPrintfCString("%d", recommendedAt.value()));
        }
        if (scheduledCorpusItemId) {
          extraKeys.AppendElement()->AssignASCII("scheduled_corpus_item_id");
          extraValues.EmplaceBack(scheduledCorpusItemId.value());
        }
        if (section) {
          extraKeys.AppendElement()->AssignASCII("section");
          extraValues.EmplaceBack(section.value());
        }
        if (sectionPosition) {
          extraKeys.AppendElement()->AssignASCII("section_position");
          extraValues.EmplaceBack(sectionPosition.value());
        }
        if (selectedTopics) {
          extraKeys.AppendElement()->AssignASCII("selected_topics");
          extraValues.EmplaceBack(selectedTopics.value());
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        if (topic) {
          extraKeys.AppendElement()->AssignASCII("topic");
          extraValues.EmplaceBack(topic.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a pocket tile is visible to the user.
   */
  constexpr impl::EventMetric<ImpressionExtra> impression(480);

  /**
   * generated from pocket.is_signed_in
   */
  /**
   * Whether the Firefox user is signed in to Pocket. Does not correspond to a pref,
     * so its value is resampled at newtab's component init and whenever there is a
     * Discovery Stream user event.
   */
  constexpr impl::BooleanMetric is_signed_in(481);

  /**
   * generated from pocket.newtab_creation_timestamp
   */
  /**
   * Timestamp of when this instance of the newtab was first visible to the user.
   */
  constexpr impl::DatetimeMetric newtab_creation_timestamp(482);

  /**
   * generated from pocket.save
   */
    struct SaveExtra {
      mozilla::Maybe<nsCString> corpusItemId;
      mozilla::Maybe<nsCString> format;
      mozilla::Maybe<bool> isListCard;
      mozilla::Maybe<bool> isSectonFollowed;
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> matchesSelectedTopic;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> receivedRank;
      mozilla::Maybe<nsCString> recommendationId;
      mozilla::Maybe<uint32_t> recommendedAt;
      mozilla::Maybe<nsCString> scheduledCorpusItemId;
      mozilla::Maybe<nsCString> section;
      mozilla::Maybe<nsCString> sectionPosition;
      mozilla::Maybe<nsCString> selectedTopics;
      mozilla::Maybe<uint32_t> tileId;
      mozilla::Maybe<nsCString> topic;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (corpusItemId) {
          extraKeys.AppendElement()->AssignASCII("corpus_item_id");
          extraValues.EmplaceBack(corpusItemId.value());
        }
        if (format) {
          extraKeys.AppendElement()->AssignASCII("format");
          extraValues.EmplaceBack(format.value());
        }
        if (isListCard) {
          extraKeys.AppendElement()->AssignASCII("is_list_card");
          extraValues.AppendElement()->AssignASCII(isListCard.value() ? "true" : "false");
        }
        if (isSectonFollowed) {
          extraKeys.AppendElement()->AssignASCII("is_secton_followed");
          extraValues.AppendElement()->AssignASCII(isSectonFollowed.value() ? "true" : "false");
        }
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (matchesSelectedTopic) {
          extraKeys.AppendElement()->AssignASCII("matches_selected_topic");
          extraValues.EmplaceBack(matchesSelectedTopic.value());
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (receivedRank) {
          extraKeys.AppendElement()->AssignASCII("received_rank");
          extraValues.EmplaceBack(nsPrintfCString("%d", receivedRank.value()));
        }
        if (recommendationId) {
          extraKeys.AppendElement()->AssignASCII("recommendation_id");
          extraValues.EmplaceBack(recommendationId.value());
        }
        if (recommendedAt) {
          extraKeys.AppendElement()->AssignASCII("recommended_at");
          extraValues.EmplaceBack(nsPrintfCString("%d", recommendedAt.value()));
        }
        if (scheduledCorpusItemId) {
          extraKeys.AppendElement()->AssignASCII("scheduled_corpus_item_id");
          extraValues.EmplaceBack(scheduledCorpusItemId.value());
        }
        if (section) {
          extraKeys.AppendElement()->AssignASCII("section");
          extraValues.EmplaceBack(section.value());
        }
        if (sectionPosition) {
          extraKeys.AppendElement()->AssignASCII("section_position");
          extraValues.EmplaceBack(sectionPosition.value());
        }
        if (selectedTopics) {
          extraKeys.AppendElement()->AssignASCII("selected_topics");
          extraValues.EmplaceBack(selectedTopics.value());
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        if (topic) {
          extraKeys.AppendElement()->AssignASCII("topic");
          extraValues.EmplaceBack(topic.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user decides to save a pocket tile. Does not mean it ends up
     * successfully saved. Just that the user clicked on "Save to Pocket" in the
     * little pocket tile menu.
   */
  constexpr impl::EventMetric<SaveExtra> save(483);

  /**
   * generated from pocket.shim
   */
  /**
   * Opaque partner identifier for a given ad impression or engagement action,
     * unique per market and region.
     * Pocket
     * [proxies requests to ad partners](https://github.com/Pocket/proxy-server/)
     * and provides them solely with market, region, and action to generate these
     * shims. Thus, though the contents of this field are obscure, they cannot
     * identify clients.
     * At time of writing this information is a comma-separated trio.
     * The first item is an index into the proxy server's list of acceptable http
     * endpoints for contacting the ad service. The second item is a
     * several-hundred-byte base64-encoded JSON-encoded struct with fields for,
     * amongst other things, market and region. The third is unknown, but appears
     * to be a signature or checksum.
     * This shim should not be sent with the client_id.
   */
  constexpr impl::TextMetric shim(484);

  /**
   * generated from pocket.sponsored_stories_enabled
   */
  /**
   * Whether Pocket sponsored stories are enabled on the newtab. Corresponds to the
     * value of the `browser.newtabpage.activity-stream.showSponsored` pref. Can be
     * `true` even if pocket.enabled is `false`.
   */
  constexpr impl::BooleanMetric sponsored_stories_enabled(485);

  /**
   * generated from pocket.thumb_voting_interaction
   */
    struct ThumbVotingInteractionExtra {
      mozilla::Maybe<nsCString> corpusItemId;
      mozilla::Maybe<bool> isListCard;
      mozilla::Maybe<bool> isSectonFollowed;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> receivedRank;
      mozilla::Maybe<nsCString> recommendationId;
      mozilla::Maybe<uint32_t> recommendedAt;
      mozilla::Maybe<nsCString> scheduledCorpusItemId;
      mozilla::Maybe<nsCString> section;
      mozilla::Maybe<nsCString> sectionPosition;
      mozilla::Maybe<bool> thumbsDown;
      mozilla::Maybe<bool> thumbsUp;
      mozilla::Maybe<uint32_t> tileId;
      mozilla::Maybe<nsCString> topic;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (corpusItemId) {
          extraKeys.AppendElement()->AssignASCII("corpus_item_id");
          extraValues.EmplaceBack(corpusItemId.value());
        }
        if (isListCard) {
          extraKeys.AppendElement()->AssignASCII("is_list_card");
          extraValues.AppendElement()->AssignASCII(isListCard.value() ? "true" : "false");
        }
        if (isSectonFollowed) {
          extraKeys.AppendElement()->AssignASCII("is_secton_followed");
          extraValues.AppendElement()->AssignASCII(isSectonFollowed.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (receivedRank) {
          extraKeys.AppendElement()->AssignASCII("received_rank");
          extraValues.EmplaceBack(nsPrintfCString("%d", receivedRank.value()));
        }
        if (recommendationId) {
          extraKeys.AppendElement()->AssignASCII("recommendation_id");
          extraValues.EmplaceBack(recommendationId.value());
        }
        if (recommendedAt) {
          extraKeys.AppendElement()->AssignASCII("recommended_at");
          extraValues.EmplaceBack(nsPrintfCString("%d", recommendedAt.value()));
        }
        if (scheduledCorpusItemId) {
          extraKeys.AppendElement()->AssignASCII("scheduled_corpus_item_id");
          extraValues.EmplaceBack(scheduledCorpusItemId.value());
        }
        if (section) {
          extraKeys.AppendElement()->AssignASCII("section");
          extraValues.EmplaceBack(section.value());
        }
        if (sectionPosition) {
          extraKeys.AppendElement()->AssignASCII("section_position");
          extraValues.EmplaceBack(sectionPosition.value());
        }
        if (thumbsDown) {
          extraKeys.AppendElement()->AssignASCII("thumbs_down");
          extraValues.AppendElement()->AssignASCII(thumbsDown.value() ? "true" : "false");
        }
        if (thumbsUp) {
          extraKeys.AppendElement()->AssignASCII("thumbs_up");
          extraValues.AppendElement()->AssignASCII(thumbsUp.value() ? "true" : "false");
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        if (topic) {
          extraKeys.AppendElement()->AssignASCII("topic");
          extraValues.EmplaceBack(topic.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a thumbs up/down on a tile is clicked. Only happens on click. Not
     * on middle-click. Not on "Open in new Tab"-like options in the context menu.
   */
  constexpr impl::EventMetric<ThumbVotingInteractionExtra> thumb_voting_interaction(486);

  /**
   * generated from pocket.topic_click
   */
    struct TopicClickExtra {
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> topic;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (topic) {
          extraKeys.AppendElement()->AssignASCII("topic");
          extraValues.EmplaceBack(topic.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a pocket "Popular Topic" is clicked. Only happens on click. Not
     * on middle-click. Not on "Open in new Tab"-like options in the context menu.
   */
  constexpr impl::EventMetric<TopicClickExtra> topic_click(487);

}
namespace top_sites {
  /**
   * generated from top_sites.advertiser
   */
  /**
   * The name of the advertiser providing the sponsored TopSite.
   */
  constexpr impl::StringMetric advertiser(488);

  /**
   * generated from top_sites.context_id
   */
  /**
   * An identifier to identify users for Contextual Services user interaction pings.
   */
  constexpr impl::UuidMetric context_id(489);

  /**
   * generated from top_sites.ping_type
   */
  /**
   * The ping's type. In other situations might be designated by an event's name or
     * an interaction field. E.g. "topsites-impression", "topsites-click".
   */
  constexpr impl::StringMetric ping_type(490);

  /**
   * generated from top_sites.position
   */
  /**
   * The position (1-based) of the topsites item being interatcted with.
   */
  constexpr impl::QuantityMetric position(491);

  /**
   * generated from top_sites.reporting_url
   */
  /**
   * The url to report this interaction to.
   */
  constexpr impl::UrlMetric reporting_url(492);

  /**
   * generated from top_sites.source
   */
  /**
   * The source of the interaction. Always set to "newtab".
   */
  constexpr impl::StringMetric source(493);

  /**
   * generated from top_sites.tile_id
   */
  /**
   * String-encoded number for the tile's sponsored tile id.
   */
  constexpr impl::StringMetric tile_id(494);

}
namespace topsites {
  /**
   * generated from topsites.click
   */
    struct ClickExtra {
      mozilla::Maybe<nsCString> advertiserName;
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (advertiserName) {
          extraKeys.AppendElement()->AssignASCII("advertiser_name");
          extraValues.EmplaceBack(advertiserName.value());
        }
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a topsite tile is clicked. Only happens on click. Not on middle-
     * click. Not on "Open in new Tab"-like options in the context menu.
   */
  constexpr impl::EventMetric<ClickExtra> click(495);

  /**
   * generated from topsites.dismiss
   */
    struct DismissExtra {
      mozilla::Maybe<nsCString> advertiserName;
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (advertiserName) {
          extraKeys.AppendElement()->AssignASCII("advertiser_name");
          extraValues.EmplaceBack(advertiserName.value());
        }
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the "Dismiss" menu item in the three-dots menu of a topsite is
     * clicked. Corresponds to the receipt of a dispatched `BLOCK_URL` action by
     * `TelemetryFeed`. Applies to both sponsored and non-sponsored topsites.
     * `advertiser_name` is only provided for sponsored topsites.
   */
  constexpr impl::EventMetric<DismissExtra> dismiss(496);

  /**
   * generated from topsites.enabled
   */
  /**
   * Whether "topsites" is enabled on the newtab. AKA the "Shortcuts" section.
     * Corresponds to the value of the `browser.newtabpage.activity-
     * stream.feeds.topsites` pref.
   */
  constexpr impl::BooleanMetric enabled(497);

  /**
   * generated from topsites.impression
   */
    struct ImpressionExtra {
      mozilla::Maybe<nsCString> advertiserName;
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (advertiserName) {
          extraKeys.AppendElement()->AssignASCII("advertiser_name");
          extraValues.EmplaceBack(advertiserName.value());
        }
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when topsite tiles are loaded.
   */
  constexpr impl::EventMetric<ImpressionExtra> impression(498);

  /**
   * generated from topsites.pref_changed
   */
    struct PrefChangedExtra {
      mozilla::Maybe<bool> newValue;
      mozilla::Maybe<nsCString> prefName;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newValue) {
          extraKeys.AppendElement()->AssignASCII("new_value");
          extraValues.AppendElement()->AssignASCII(newValue.value() ? "true" : "false");
        }
        if (prefName) {
          extraKeys.AppendElement()->AssignASCII("pref_name");
          extraValues.EmplaceBack(prefName.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when specific topsites prefs have changed.
     * The list of possible prefs is presently:
     *  * browser.newtabpage.activity-stream.feeds.topsites
     *  * browser.newtabpage.activity-stream.showSponsoredTopSites
   */
  constexpr impl::EventMetric<PrefChangedExtra> pref_changed(499);

  /**
   * generated from topsites.rows
   */
  /**
   * The number of topsite tile rows configured to be shown on the newtab page.
     * Corresponds to the value of the `browser.newtabpage.activity-
     * stream.topSitesRows` pref. This is not the number of rows actually seen by the
     * user: if the browser window is partially off-screen, or isn't wide enough to
     * accommodate eight tiles per row, the actual number of rows may be different.
   */
  constexpr impl::QuantityMetric rows(500);

  /**
   * generated from topsites.show_privacy_click
   */
    struct ShowPrivacyClickExtra {
      mozilla::Maybe<nsCString> advertiserName;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (advertiserName) {
          extraKeys.AppendElement()->AssignASCII("advertiser_name");
          extraValues.EmplaceBack(advertiserName.value());
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the "Our Sponsors and Your Privacy" menu item in the three- dots
     * menu of a sponsored topsite is clicked. Corresponds to the receipt of a
     * dispatched `ABOUT_SPONSORED_TOP_SITES` action by `TelemetryFeed`.
   */
  constexpr impl::EventMetric<ShowPrivacyClickExtra> show_privacy_click(501);

  /**
   * generated from topsites.sponsored_enabled
   */
  /**
   * Whether sponsored topsites are enabled on the newtab. AKA the "Sponsored
     * Shortcuts" section. Corresponds to the value of the
     * `browser.newtabpage.activity-stream.showSponsoredTopSites` pref. Can be `true`
     * even if topsites.enabled is `false`.
   */
  constexpr impl::BooleanMetric sponsored_enabled(502);

  /**
   * generated from topsites.sponsored_tiles_configured
   */
  /**
   * The number of topsite tiles configured to be shown on newtab.
   */
  constexpr impl::QuantityMetric sponsored_tiles_configured(503);

  /**
   * generated from topsites.sponsored_tiles_received
   */
  /**
   * The stringified JSON of tiles processed for display (array of objects).
     * Includes tiles not displayed and reason for not displaying. Fields included:
     * advertiser, provider, display_position, display_fail_reason.
   */
  constexpr impl::TextMetric sponsored_tiles_received(504);

}
namespace library {
  /**
   * generated from library.link
   */
  /**
   * The number of history or bookmark items opened from the Library window This
     * metric was generated to correspond to the Legacy Telemetry scalar library.link.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> link(505);

  /**
   * generated from library.opened
   */
  /**
   * The number of times the Library window was opened, keyed by 'history' or
     * 'bookmarks' This metric was generated to correspond to the Legacy Telemetry
     * scalar library.opened.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> opened(506);

  /**
   * generated from library.search
   */
  /**
   * The number of history-specific or bookmark-specific searches made from the
     * Library window This metric was generated to correspond to the Legacy Telemetry
     * scalar library.search.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> search(507);

}
namespace pocket_button {
  /**
   * generated from pocket.button.event_action
   */
  /**
   * The action that was taken, like "click" or... actually, it might only ever be
     * "click".
   */
  constexpr impl::StringMetric event_action(508);

  /**
   * generated from pocket.button.event_position
   */
  /**
   * 0-based index of the item on which the action was performed. Not always
     * provided.
   */
  constexpr impl::QuantityMetric event_position(509);

  /**
   * generated from pocket.button.event_source
   */
  /**
   * The source of the taken action, like "save_button", "home_button",
     * "on_save_recs", or the like.
   */
  constexpr impl::StringMetric event_source(510);

  /**
   * generated from pocket.button.impression_id
   */
  /**
   * A UUID representing this profile. This isn't client_id, nor can it be used to
     * link to a client_id. This also means it should never be sent in a ping with a
     * client_id.
   */
  constexpr impl::UuidMetric impression_id(511);

  /**
   * generated from pocket.button.model
   */
  /**
   * A string that identifies the ML model (if any) used to generate on-save
     * recommendations. Like "doc2vec-incremental-best-article-pubspread".
   */
  constexpr impl::StringMetric model(512);

  /**
   * generated from pocket.button.pocket_logged_in_status
   */
  /**
   * Whether there was a logged-in Pocket account in the Pocket-Firefox integration
     * at the point in time this action occurred.
   */
  constexpr impl::BooleanMetric pocket_logged_in_status(513);

  /**
   * generated from pocket.button.profile_creation_date
   */
  /**
   * The days since Jan 1, 1970 that the oldest file in the profile dir was
     * modified. Or created. Or just the day and time of the first thing to ask for
     * the profile age called in. Or something earlier or later than that.
     * You may not want to use this.
   */
  constexpr impl::QuantityMetric profile_creation_date(514);

}
namespace aboutpreferences {
  /**
   * generated from aboutpreferences.show_click
   */
    struct ShowClickExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded when a pane is shown when user clicks category name inside
     * about:preferences. This event was generated to correspond to the Legacy
     * Telemetry event aboutpreferences.show#click.
   */
  constexpr impl::EventMetric<ShowClickExtra> show_click(515);

  /**
   * generated from aboutpreferences.show_hash
   */
    struct ShowHashExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded when a pane is shown via a hash change in url. This event was
     * generated to correspond to the Legacy Telemetry event
     * aboutpreferences.show#hash.
   */
  constexpr impl::EventMetric<ShowHashExtra> show_hash(516);

  /**
   * generated from aboutpreferences.show_initial
   */
    struct ShowInitialExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded when a pane is shown direclty. This happens with or without a
     * hash in the URL. The "general" pane loads without such a hash, when the pane is
     * loaded via the "main" entrypoints in the menu system or with shortcuts. This
     * event was generated to correspond to the Legacy Telemetry event
     * aboutpreferences.show#initial.
   */
  constexpr impl::EventMetric<ShowInitialExtra> show_initial(517);

}
namespace intl_ui_browser_language {
  /**
   * generated from intl.ui.browser_language.accept_dialog
   */
    struct AcceptDialogExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser language within about-preferences in the main
     * pane and in the browser language dialog. Each dialog event (on the dialog
     * object, and the manage and search methods of the main object) has a value which
     * is a monotonically increasing number that links it with other events related to
     * the same dialog instance. This event was generated to correspond to the Legacy
     * Telemetry event intl.ui.browserLanguage.accept#dialog.
   */
  constexpr impl::EventMetric<AcceptDialogExtra> accept_dialog(518);

  /**
   * generated from intl.ui.browser_language.add_dialog
   */
    struct AddDialogExtra {
      mozilla::Maybe<nsCString> installid;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (installid) {
          extraKeys.AppendElement()->AssignASCII("installId");
          extraValues.EmplaceBack(installid.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser language within about-preferences in the main
     * pane and in the browser language dialog. Each dialog event (on the dialog
     * object, and the manage and search methods of the main object) has a value which
     * is a monotonically increasing number that links it with other events related to
     * the same dialog instance. This event was generated to correspond to the Legacy
     * Telemetry event intl.ui.browserLanguage.add#dialog.
   */
  constexpr impl::EventMetric<AddDialogExtra> add_dialog(519);

  /**
   * generated from intl.ui.browser_language.apply_main
   */
  /**
   * User interactions for the browser language within about-preferences in the main
     * pane and in the browser language dialog. Each dialog event (on the dialog
     * object, and the manage and search methods of the main object) has a value which
     * is a monotonically increasing number that links it with other events related to
     * the same dialog instance. This event was generated to correspond to the Legacy
     * Telemetry event intl.ui.browserLanguage.apply#main.
   */
  constexpr impl::EventMetric<NoExtraKeys> apply_main(520);

  /**
   * generated from intl.ui.browser_language.cancel_dialog
   */
    struct CancelDialogExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser language within about-preferences in the main
     * pane and in the browser language dialog. Each dialog event (on the dialog
     * object, and the manage and search methods of the main object) has a value which
     * is a monotonically increasing number that links it with other events related to
     * the same dialog instance. This event was generated to correspond to the Legacy
     * Telemetry event intl.ui.browserLanguage.cancel#dialog.
   */
  constexpr impl::EventMetric<CancelDialogExtra> cancel_dialog(521);

  /**
   * generated from intl.ui.browser_language.manage_main
   */
    struct ManageMainExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser language within about-preferences in the main
     * pane and in the browser language dialog. Each dialog event (on the dialog
     * object, and the manage and search methods of the main object) has a value which
     * is a monotonically increasing number that links it with other events related to
     * the same dialog instance. This event was generated to correspond to the Legacy
     * Telemetry event intl.ui.browserLanguage.manage#main.
   */
  constexpr impl::EventMetric<ManageMainExtra> manage_main(522);

  /**
   * generated from intl.ui.browser_language.remove_dialog
   */
    struct RemoveDialogExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser language within about-preferences in the main
     * pane and in the browser language dialog. Each dialog event (on the dialog
     * object, and the manage and search methods of the main object) has a value which
     * is a monotonically increasing number that links it with other events related to
     * the same dialog instance. This event was generated to correspond to the Legacy
     * Telemetry event intl.ui.browserLanguage.remove#dialog.
   */
  constexpr impl::EventMetric<RemoveDialogExtra> remove_dialog(523);

  /**
   * generated from intl.ui.browser_language.reorder_dialog
   */
    struct ReorderDialogExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser language within about-preferences in the main
     * pane and in the browser language dialog. Each dialog event (on the dialog
     * object, and the manage and search methods of the main object) has a value which
     * is a monotonically increasing number that links it with other events related to
     * the same dialog instance. This event was generated to correspond to the Legacy
     * Telemetry event intl.ui.browserLanguage.reorder#dialog.
   */
  constexpr impl::EventMetric<ReorderDialogExtra> reorder_dialog(524);

  /**
   * generated from intl.ui.browser_language.reorder_main
   */
  /**
   * User interactions for the browser language within about-preferences in the main
     * pane and in the browser language dialog. Each dialog event (on the dialog
     * object, and the manage and search methods of the main object) has a value which
     * is a monotonically increasing number that links it with other events related to
     * the same dialog instance. This event was generated to correspond to the Legacy
     * Telemetry event intl.ui.browserLanguage.reorder#main.
   */
  constexpr impl::EventMetric<NoExtraKeys> reorder_main(525);

  /**
   * generated from intl.ui.browser_language.search_dialog
   */
    struct SearchDialogExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser language within about-preferences in the main
     * pane and in the browser language dialog. Each dialog event (on the dialog
     * object, and the manage and search methods of the main object) has a value which
     * is a monotonically increasing number that links it with other events related to
     * the same dialog instance. This event was generated to correspond to the Legacy
     * Telemetry event intl.ui.browserLanguage.search#dialog.
   */
  constexpr impl::EventMetric<SearchDialogExtra> search_dialog(526);

  /**
   * generated from intl.ui.browser_language.search_main
   */
    struct SearchMainExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser language within about-preferences in the main
     * pane and in the browser language dialog. Each dialog event (on the dialog
     * object, and the manage and search methods of the main object) has a value which
     * is a monotonically increasing number that links it with other events related to
     * the same dialog instance. This event was generated to correspond to the Legacy
     * Telemetry event intl.ui.browserLanguage.search#main.
   */
  constexpr impl::EventMetric<SearchMainExtra> search_main(527);

  /**
   * generated from intl.ui.browser_language.set_fallback_dialog
   */
    struct SetFallbackDialogExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser language within about-preferences in the main
     * pane and in the browser language dialog. Each dialog event (on the dialog
     * object, and the manage and search methods of the main object) has a value which
     * is a monotonically increasing number that links it with other events related to
     * the same dialog instance. This event was generated to correspond to the Legacy
     * Telemetry event intl.ui.browserLanguage.set_fallback#dialog.
   */
  constexpr impl::EventMetric<SetFallbackDialogExtra> set_fallback_dialog(528);

}
namespace network_proxy_settings {
  /**
   * generated from network.proxy.settings.proxy_type_preference
   */
    struct ProxyTypePreferenceExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This metric tracks what proxy types users are choosing in the Network Settings
     * dialog at the bottom of about:preferences#general. It gets recorded when
     * pressing OK in the dialog box.
   */
  constexpr impl::EventMetric<ProxyTypePreferenceExtra> proxy_type_preference(529);

}
namespace privacy_ui_fpp_click {
  /**
   * generated from privacy.ui.fpp.click.checkbox
   */
    struct CheckboxExtra {
      mozilla::Maybe<bool> checked;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (checked) {
          extraKeys.AppendElement()->AssignASCII("checked");
          extraValues.AppendElement()->AssignASCII(checked.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on fingerprinting protection checkbox in the
     * ETP Custom subpanel.
   */
  constexpr impl::EventMetric<CheckboxExtra> checkbox(530);

  /**
   * generated from privacy.ui.fpp.click.menu
   */
    struct MenuExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on fingerprinting protection menulist in the
     * ETP Custom subpanel.
   */
  constexpr impl::EventMetric<MenuExtra> menu(531);

}
namespace security_doh_settings {
  /**
   * generated from security.doh.settings.mode_changed_button
   */
    struct ModeChangedButtonExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User changed the TRR mode in about:preferences#privacy settings Value is id of
     * the clicked button. This event was generated to correspond to the Legacy
     * Telemetry event security.doh.settings.mode_changed#button.
   */
  constexpr impl::EventMetric<ModeChangedButtonExtra> mode_changed_button(532);

  /**
   * generated from security.doh.settings.provider_choice_value
   */
    struct ProviderChoiceValueExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User changed their DoH provider. Recorded value is URL of one of the existing
     * providers or "custom". This event was generated to correspond to the Legacy
     * Telemetry event security.doh.settings.provider_choice#value.
   */
  constexpr impl::EventMetric<ProviderChoiceValueExtra> provider_choice_value(533);

  /**
   * generated from security.doh.settings.warn_checkbox_checkbox
   */
    struct WarnCheckboxCheckboxExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User clicked the Warn if a third party actively prevents secure DNS checkbox in
     * about:preferences#privacy. Value is true or false, reflecting if box is checked
     * or unchecked. This event was generated to correspond to the Legacy Telemetry
     * event security.doh.settings.warn_checkbox#checkbox.
   */
  constexpr impl::EventMetric<WarnCheckboxCheckboxExtra> warn_checkbox_checkbox(534);

}
namespace aboutprivatebrowsing {
  /**
   * generated from aboutprivatebrowsing.click_dismiss_button
   */
  /**
   * This is recorded when a user clicks a link on the private browsing newtab. This
     * event was generated to correspond to the Legacy Telemetry event
     * aboutprivatebrowsing.click#dismiss_button.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_dismiss_button(535);

  /**
   * generated from aboutprivatebrowsing.click_info_link
   */
  /**
   * This is recorded when a user clicks a link on the private browsing newtab. This
     * event was generated to correspond to the Legacy Telemetry event
     * aboutprivatebrowsing.click#info_link.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_info_link(536);

  /**
   * generated from aboutprivatebrowsing.click_promo_link
   */
  /**
   * This is recorded when a user clicks a link on the private browsing newtab. This
     * event was generated to correspond to the Legacy Telemetry event
     * aboutprivatebrowsing.click#promo_link.
   */
  constexpr impl::EventMetric<NoExtraKeys> click_promo_link(537);

}
namespace private_browsing_reset_pbm {
  /**
   * generated from private_browsing.reset_pbm.confirm_panel
   */
    struct ConfirmPanelExtra {
      mozilla::Maybe<nsCString> action;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Confirm panel show / hide event.
   */
  constexpr impl::EventMetric<ConfirmPanelExtra> confirm_panel(538);

  /**
   * generated from private_browsing.reset_pbm.reset_action
   */
    struct ResetActionExtra {
      mozilla::Maybe<bool> didConfirm;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (didConfirm) {
          extraKeys.AppendElement()->AssignASCII("did_confirm");
          extraValues.AppendElement()->AssignASCII(didConfirm.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Dispatched whenever PBM is restarted / reset via the resetPBM feature.
   */
  constexpr impl::EventMetric<ResetActionExtra> reset_action(539);

}
namespace profiles_default {
  /**
   * generated from profiles.default.updated
   */
  /**
   * Recorded when a new profile from a profile group becomes the default startup
     * profile for the group. This may happen when a profile other than the current
     * default is launched from the profile selector window, or when the user has
     * multiple profiles running at the same time and switches app focus to a profile
     * other than the current default. An event is not recorded if the current default
     * profile is launched or gains app focus.
   */
  constexpr impl::EventMetric<NoExtraKeys> updated(540);

}
namespace security_ui_protections {
  /**
   * generated from security.ui.protections.click_lw_about_link
   */
    struct ClickLwAboutLinkExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#lw_about_link.
   */
  constexpr impl::EventMetric<ClickLwAboutLinkExtra> click_lw_about_link(541);

  /**
   * generated from security.ui.protections.click_lw_open_button
   */
    struct ClickLwOpenButtonExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#lw_open_button.
   */
  constexpr impl::EventMetric<ClickLwOpenButtonExtra> click_lw_open_button(542);

  /**
   * generated from security.ui.protections.click_lw_sync_link
   */
    struct ClickLwSyncLinkExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#lw_sync_link.
   */
  constexpr impl::EventMetric<ClickLwSyncLinkExtra> click_lw_sync_link(543);

  /**
   * generated from security.ui.protections.click_mobile_app_link
   */
    struct ClickMobileAppLinkExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#mobile_app_link.
   */
  constexpr impl::EventMetric<ClickMobileAppLinkExtra> click_mobile_app_link(544);

  /**
   * generated from security.ui.protections.click_mtr_about_link
   */
    struct ClickMtrAboutLinkExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#mtr_about_link.
   */
  constexpr impl::EventMetric<ClickMtrAboutLinkExtra> click_mtr_about_link(545);

  /**
   * generated from security.ui.protections.click_mtr_report_link
   */
    struct ClickMtrReportLinkExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#mtr_report_link.
   */
  constexpr impl::EventMetric<ClickMtrReportLinkExtra> click_mtr_report_link(546);

  /**
   * generated from security.ui.protections.click_mtr_signup_button
   */
    struct ClickMtrSignupButtonExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#mtr_signup_button.
   */
  constexpr impl::EventMetric<ClickMtrSignupButtonExtra> click_mtr_signup_button(547);

  /**
   * generated from security.ui.protections.click_settings_link
   */
    struct ClickSettingsLinkExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#settings_link.
   */
  constexpr impl::EventMetric<ClickSettingsLinkExtra> click_settings_link(548);

  /**
   * generated from security.ui.protections.click_trackers_about_link
   */
    struct ClickTrackersAboutLinkExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#trackers_about_link.
   */
  constexpr impl::EventMetric<ClickTrackersAboutLinkExtra> click_trackers_about_link(549);

  /**
   * generated from security.ui.protections.click_vpn_app_link_android
   */
    struct ClickVpnAppLinkAndroidExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#vpn_app_link_android.
   */
  constexpr impl::EventMetric<ClickVpnAppLinkAndroidExtra> click_vpn_app_link_android(550);

  /**
   * generated from security.ui.protections.click_vpn_app_link_ios
   */
    struct ClickVpnAppLinkIosExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#vpn_app_link_ios.
   */
  constexpr impl::EventMetric<ClickVpnAppLinkIosExtra> click_vpn_app_link_ios(551);

  /**
   * generated from security.ui.protections.click_vpn_banner_close
   */
    struct ClickVpnBannerCloseExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#vpn_banner_close.
   */
  constexpr impl::EventMetric<ClickVpnBannerCloseExtra> click_vpn_banner_close(552);

  /**
   * generated from security.ui.protections.click_vpn_banner_link
   */
    struct ClickVpnBannerLinkExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#vpn_banner_link.
   */
  constexpr impl::EventMetric<ClickVpnBannerLinkExtra> click_vpn_banner_link(553);

  /**
   * generated from security.ui.protections.click_vpn_card_link
   */
    struct ClickVpnCardLinkExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the protection report. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.click#vpn_card_link.
   */
  constexpr impl::EventMetric<ClickVpnCardLinkExtra> click_vpn_card_link(554);

  /**
   * generated from security.ui.protections.close_protection_report
   */
    struct CloseProtectionReportExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closed on the protection report. This event was generated to correspond to
     * the Legacy Telemetry event security.ui.protections.close#protection_report.
   */
  constexpr impl::EventMetric<CloseProtectionReportExtra> close_protection_report(555);

  /**
   * generated from security.ui.protections.show_protection_report
   */
    struct ShowProtectionReportExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User arrived on the protection report. This also includes a 'value' attribute
     * which defaults to 'direct' or will be the value that a referring website addds
     * to the url. This also indicates if the vpn banner has been seen. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.show#protection_report.
   */
  constexpr impl::EventMetric<ShowProtectionReportExtra> show_protection_report(556);

  /**
   * generated from security.ui.protections.show_vpn_banner
   */
    struct ShowVpnBannerExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User arrived on the protection report. This also includes a 'value' attribute
     * which defaults to 'direct' or will be the value that a referring website addds
     * to the url. This also indicates if the vpn banner has been seen. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.protections.show#vpn_banner.
   */
  constexpr impl::EventMetric<ShowVpnBannerExtra> show_vpn_banner(557);

}
namespace protocolhandler_mailto {
  /**
   * generated from protocolhandler.mailto.handler_prompt_shown
   */
  enum class HandlerPromptShownLabel: uint16_t {
      eOsDefault = 0,
      eFxDefault = 1,
      e__Other__,
    };
  /**
   * A website was visited, which called registerProtocolHandler for mailto://
   */
  constexpr impl::Labeled<impl::CounterMetric, HandlerPromptShownLabel> handler_prompt_shown(558);

  /**
   * generated from protocolhandler.mailto.prompt_clicked
   */
  enum class PromptClickedLabel: uint16_t {
      eSetOsDefault = 0,
      eSetOsDefaultError = 1,
      eSetOsDefaultImpossible = 2,
      eDismissOsDefault = 3,
      eSetLocalDefault = 4,
      eDismissLocalDefault = 5,
      e__Other__,
    };
  /**
   * User clicked on a button to approve setting the current site as default web
     * mail site. The sum of all counters is the total amount of user interactions and
     * dismissing the same dialog often could be a sign of a bug.
   */
  constexpr impl::Labeled<impl::CounterMetric, PromptClickedLabel> prompt_clicked(559);

  /**
   * generated from protocolhandler.mailto.visit
   */
    struct VisitExtra {
      mozilla::Maybe<bool> triggeredExternally;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (triggeredExternally) {
          extraKeys.AppendElement()->AssignASCII("triggered_externally");
          extraValues.AppendElement()->AssignASCII(triggeredExternally.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * a URI of type mailto was visited. Furthermore we want to know if from within
     * the browser.
   */
  constexpr impl::EventMetric<VisitExtra> visit(560);

}
namespace screenshots {
  /**
   * generated from screenshots.canceled_context_menu
   */
  /**
   * Recorded when a user closes the screenshots ui. The screenshots ui is closed
     * after copying/downloading but we do not record that as canceling the
     * screenshots ui. This event was generated to correspond to the Legacy Telemetry
     * event screenshots.canceled#context_menu.
   */
  constexpr impl::EventMetric<NoExtraKeys> canceled_context_menu(561);

  /**
   * generated from screenshots.canceled_escape
   */
  /**
   * Recorded when a user closes the screenshots ui. The screenshots ui is closed
     * after copying/downloading but we do not record that as canceling the
     * screenshots ui. This event was generated to correspond to the Legacy Telemetry
     * event screenshots.canceled#escape.
   */
  constexpr impl::EventMetric<NoExtraKeys> canceled_escape(562);

  /**
   * generated from screenshots.canceled_navigation
   */
  /**
   * Recorded when a user closes the screenshots ui. The screenshots ui is closed
     * after copying/downloading but we do not record that as canceling the
     * screenshots ui. This event was generated to correspond to the Legacy Telemetry
     * event screenshots.canceled#navigation.
   */
  constexpr impl::EventMetric<NoExtraKeys> canceled_navigation(563);

  /**
   * generated from screenshots.canceled_overlay_cancel
   */
  /**
   * Recorded when a user closes the screenshots ui. The screenshots ui is closed
     * after copying/downloading but we do not record that as canceling the
     * screenshots ui. This event was generated to correspond to the Legacy Telemetry
     * event screenshots.canceled#overlay_cancel.
   */
  constexpr impl::EventMetric<NoExtraKeys> canceled_overlay_cancel(564);

  /**
   * generated from screenshots.canceled_preview_cancel
   */
  /**
   * Recorded when a user closes the screenshots ui. The screenshots ui is closed
     * after copying/downloading but we do not record that as canceling the
     * screenshots ui. This event was generated to correspond to the Legacy Telemetry
     * event screenshots.canceled#preview_cancel.
   */
  constexpr impl::EventMetric<NoExtraKeys> canceled_preview_cancel(565);

  /**
   * generated from screenshots.canceled_quick_actions
   */
  /**
   * Recorded when a user closes the screenshots ui. The screenshots ui is closed
     * after copying/downloading but we do not record that as canceling the
     * screenshots ui. This event was generated to correspond to the Legacy Telemetry
     * event screenshots.canceled#quick_actions.
   */
  constexpr impl::EventMetric<NoExtraKeys> canceled_quick_actions(566);

  /**
   * generated from screenshots.canceled_shortcut
   */
  /**
   * Recorded when a user closes the screenshots ui. The screenshots ui is closed
     * after copying/downloading but we do not record that as canceling the
     * screenshots ui. This event was generated to correspond to the Legacy Telemetry
     * event screenshots.canceled#shortcut.
   */
  constexpr impl::EventMetric<NoExtraKeys> canceled_shortcut(567);

  /**
   * generated from screenshots.canceled_toolbar_button
   */
  /**
   * Recorded when a user closes the screenshots ui. The screenshots ui is closed
     * after copying/downloading but we do not record that as canceling the
     * screenshots ui. This event was generated to correspond to the Legacy Telemetry
     * event screenshots.canceled#toolbar_button.
   */
  constexpr impl::EventMetric<NoExtraKeys> canceled_toolbar_button(568);

  /**
   * generated from screenshots.copy_overlay_copy
   */
    struct CopyOverlayCopyExtra {
      mozilla::Maybe<nsCString> element;
      mozilla::Maybe<nsCString> fullpage;
      mozilla::Maybe<nsCString> move;
      mozilla::Maybe<nsCString> region;
      mozilla::Maybe<nsCString> resize;
      mozilla::Maybe<nsCString> visible;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (element) {
          extraKeys.AppendElement()->AssignASCII("element");
          extraValues.EmplaceBack(element.value());
        }
        if (fullpage) {
          extraKeys.AppendElement()->AssignASCII("fullpage");
          extraValues.EmplaceBack(fullpage.value());
        }
        if (move) {
          extraKeys.AppendElement()->AssignASCII("move");
          extraValues.EmplaceBack(move.value());
        }
        if (region) {
          extraKeys.AppendElement()->AssignASCII("region");
          extraValues.EmplaceBack(region.value());
        }
        if (resize) {
          extraKeys.AppendElement()->AssignASCII("resize");
          extraValues.EmplaceBack(resize.value());
        }
        if (visible) {
          extraKeys.AppendElement()->AssignASCII("visible");
          extraValues.EmplaceBack(visible.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user copies a screenshot from the overlay or the preview. This
     * event was generated to correspond to the Legacy Telemetry event
     * screenshots.copy#overlay_copy.
   */
  constexpr impl::EventMetric<CopyOverlayCopyExtra> copy_overlay_copy(569);

  /**
   * generated from screenshots.copy_preview_copy
   */
    struct CopyPreviewCopyExtra {
      mozilla::Maybe<nsCString> element;
      mozilla::Maybe<nsCString> fullpage;
      mozilla::Maybe<nsCString> move;
      mozilla::Maybe<nsCString> region;
      mozilla::Maybe<nsCString> resize;
      mozilla::Maybe<nsCString> visible;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (element) {
          extraKeys.AppendElement()->AssignASCII("element");
          extraValues.EmplaceBack(element.value());
        }
        if (fullpage) {
          extraKeys.AppendElement()->AssignASCII("fullpage");
          extraValues.EmplaceBack(fullpage.value());
        }
        if (move) {
          extraKeys.AppendElement()->AssignASCII("move");
          extraValues.EmplaceBack(move.value());
        }
        if (region) {
          extraKeys.AppendElement()->AssignASCII("region");
          extraValues.EmplaceBack(region.value());
        }
        if (resize) {
          extraKeys.AppendElement()->AssignASCII("resize");
          extraValues.EmplaceBack(resize.value());
        }
        if (visible) {
          extraKeys.AppendElement()->AssignASCII("visible");
          extraValues.EmplaceBack(visible.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user copies a screenshot from the overlay or the preview. This
     * event was generated to correspond to the Legacy Telemetry event
     * screenshots.copy#preview_copy.
   */
  constexpr impl::EventMetric<CopyPreviewCopyExtra> copy_preview_copy(570);

  /**
   * generated from screenshots.download_overlay_download
   */
    struct DownloadOverlayDownloadExtra {
      mozilla::Maybe<nsCString> element;
      mozilla::Maybe<nsCString> fullpage;
      mozilla::Maybe<nsCString> move;
      mozilla::Maybe<nsCString> region;
      mozilla::Maybe<nsCString> resize;
      mozilla::Maybe<nsCString> visible;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (element) {
          extraKeys.AppendElement()->AssignASCII("element");
          extraValues.EmplaceBack(element.value());
        }
        if (fullpage) {
          extraKeys.AppendElement()->AssignASCII("fullpage");
          extraValues.EmplaceBack(fullpage.value());
        }
        if (move) {
          extraKeys.AppendElement()->AssignASCII("move");
          extraValues.EmplaceBack(move.value());
        }
        if (region) {
          extraKeys.AppendElement()->AssignASCII("region");
          extraValues.EmplaceBack(region.value());
        }
        if (resize) {
          extraKeys.AppendElement()->AssignASCII("resize");
          extraValues.EmplaceBack(resize.value());
        }
        if (visible) {
          extraKeys.AppendElement()->AssignASCII("visible");
          extraValues.EmplaceBack(visible.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user downloads a screenshot from the overlay or the preview.
     * This event was generated to correspond to the Legacy Telemetry event
     * screenshots.download#overlay_download.
   */
  constexpr impl::EventMetric<DownloadOverlayDownloadExtra> download_overlay_download(571);

  /**
   * generated from screenshots.download_preview_download
   */
    struct DownloadPreviewDownloadExtra {
      mozilla::Maybe<nsCString> element;
      mozilla::Maybe<nsCString> fullpage;
      mozilla::Maybe<nsCString> move;
      mozilla::Maybe<nsCString> region;
      mozilla::Maybe<nsCString> resize;
      mozilla::Maybe<nsCString> visible;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (element) {
          extraKeys.AppendElement()->AssignASCII("element");
          extraValues.EmplaceBack(element.value());
        }
        if (fullpage) {
          extraKeys.AppendElement()->AssignASCII("fullpage");
          extraValues.EmplaceBack(fullpage.value());
        }
        if (move) {
          extraKeys.AppendElement()->AssignASCII("move");
          extraValues.EmplaceBack(move.value());
        }
        if (region) {
          extraKeys.AppendElement()->AssignASCII("region");
          extraValues.EmplaceBack(region.value());
        }
        if (resize) {
          extraKeys.AppendElement()->AssignASCII("resize");
          extraValues.EmplaceBack(resize.value());
        }
        if (visible) {
          extraKeys.AppendElement()->AssignASCII("visible");
          extraValues.EmplaceBack(visible.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user downloads a screenshot from the overlay or the preview.
     * This event was generated to correspond to the Legacy Telemetry event
     * screenshots.download#preview_download.
   */
  constexpr impl::EventMetric<DownloadPreviewDownloadExtra> download_preview_download(572);

  /**
   * generated from screenshots.failed_screenshot_too_large
   */
  /**
   * Recorded when a screenshot is too big to capture and we have to crop the
     * screenshot. This event was generated to correspond to the Legacy Telemetry
     * event screenshots.failed#screenshot_too_large.
   */
  constexpr impl::EventMetric<NoExtraKeys> failed_screenshot_too_large(573);

  /**
   * generated from screenshots.selected_element
   */
  /**
   * Recorded when a user selects a region by hand, selects an element, selects the
     * save visible, or selects save full page. Note that this is recorded independent
     * of whether or not the screenshot is saved. This event was generated to
     * correspond to the Legacy Telemetry event screenshots.selected#element.
   */
  constexpr impl::EventMetric<NoExtraKeys> selected_element(574);

  /**
   * generated from screenshots.selected_full_page
   */
  /**
   * Recorded when a user selects a region by hand, selects an element, selects the
     * save visible, or selects save full page. Note that this is recorded independent
     * of whether or not the screenshot is saved. This event was generated to
     * correspond to the Legacy Telemetry event screenshots.selected#full_page.
   */
  constexpr impl::EventMetric<NoExtraKeys> selected_full_page(575);

  /**
   * generated from screenshots.selected_region_selection
   */
  /**
   * Recorded when a user selects a region by hand, selects an element, selects the
     * save visible, or selects save full page. Note that this is recorded independent
     * of whether or not the screenshot is saved. This event was generated to
     * correspond to the Legacy Telemetry event screenshots.selected#region_selection.
   */
  constexpr impl::EventMetric<NoExtraKeys> selected_region_selection(576);

  /**
   * generated from screenshots.selected_visible
   */
  /**
   * Recorded when a user selects a region by hand, selects an element, selects the
     * save visible, or selects save full page. Note that this is recorded independent
     * of whether or not the screenshot is saved. This event was generated to
     * correspond to the Legacy Telemetry event screenshots.selected#visible.
   */
  constexpr impl::EventMetric<NoExtraKeys> selected_visible(577);

  /**
   * generated from screenshots.started_context_menu
   */
  /**
   * Recorded when a user opens the screenshots ui. This event was generated to
     * correspond to the Legacy Telemetry event screenshots.started#context_menu.
   */
  constexpr impl::EventMetric<NoExtraKeys> started_context_menu(578);

  /**
   * generated from screenshots.started_overlay_retry
   */
  /**
   * Recorded when a user opens the screenshots ui. This event was generated to
     * correspond to the Legacy Telemetry event screenshots.started#overlay_retry.
   */
  constexpr impl::EventMetric<NoExtraKeys> started_overlay_retry(579);

  /**
   * generated from screenshots.started_preview_retry
   */
  /**
   * Recorded when a user opens the screenshots ui. This event was generated to
     * correspond to the Legacy Telemetry event screenshots.started#preview_retry.
   */
  constexpr impl::EventMetric<NoExtraKeys> started_preview_retry(580);

  /**
   * generated from screenshots.started_quick_actions
   */
  /**
   * Recorded when a user opens the screenshots ui. This event was generated to
     * correspond to the Legacy Telemetry event screenshots.started#quick_actions.
   */
  constexpr impl::EventMetric<NoExtraKeys> started_quick_actions(581);

  /**
   * generated from screenshots.started_shortcut
   */
  /**
   * Recorded when a user opens the screenshots ui. This event was generated to
     * correspond to the Legacy Telemetry event screenshots.started#shortcut.
   */
  constexpr impl::EventMetric<NoExtraKeys> started_shortcut(582);

  /**
   * generated from screenshots.started_toolbar_button
   */
  /**
   * Recorded when a user opens the screenshots ui. This event was generated to
     * correspond to the Legacy Telemetry event screenshots.started#toolbar_button.
   */
  constexpr impl::EventMetric<NoExtraKeys> started_toolbar_button(583);

}
namespace browser_engagement_navigation {
  /**
   * generated from browser.engagement.navigation.about_home
   */
  /**
   * The count URI loads triggered in a subsession from about:home, broken down by
     * the originating action. This metric was generated to correspond to the Legacy
     * Telemetry scalar browser.engagement.navigation.about_home.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> about_home(584);

  /**
   * generated from browser.engagement.navigation.about_newtab
   */
  /**
   * The count URI loads triggered in a subsession from about:newtab, broken down by
     * the originating action. This metric was generated to correspond to the Legacy
     * Telemetry scalar browser.engagement.navigation.about_newtab.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> about_newtab(585);

  /**
   * generated from browser.engagement.navigation.contextmenu
   */
  /**
   * The count URI loads triggered in a subsession from the contextmenu, broken down
     * by the originating action. This metric was generated to correspond to the
     * Legacy Telemetry scalar browser.engagement.navigation.contextmenu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> contextmenu(586);

  /**
   * generated from browser.engagement.navigation.searchbar
   */
  /**
   * The count URI loads triggered in a subsession from the searchbar, broken down
     * by the originating action. This metric was generated to correspond to the
     * Legacy Telemetry scalar browser.engagement.navigation.searchbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> searchbar(587);

  /**
   * generated from browser.engagement.navigation.urlbar
   */
  /**
   * The count URI loads triggered in a subsession from the urlbar, broken down by
     * the originating action. This metric was generated to correspond to the Legacy
     * Telemetry scalar browser.engagement.navigation.urlbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar(588);

  /**
   * generated from browser.engagement.navigation.urlbar_handoff
   */
  /**
   * The count URI loads triggered in a subsession from the urlbar via handoff,
     * broken down by the originating action. This metric was generated to correspond
     * to the Legacy Telemetry scalar browser.engagement.navigation.urlbar_handoff.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_handoff(589);

  /**
   * generated from browser.engagement.navigation.urlbar_persisted
   */
  /**
   * The count of URI loads triggered in a subsession from the urlbar after the
     * search term was shown in the urlbar, broken down by the originating action.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.navigation.urlbar_persisted.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_persisted(590);

  /**
   * generated from browser.engagement.navigation.urlbar_searchmode
   */
  /**
   * The count URI loads triggered in a subsession from the urlbar's search mode,
     * broken down by the originating action. This metric was generated to correspond
     * to the Legacy Telemetry scalar browser.engagement.navigation.urlbar_searchmode.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_searchmode(591);

  /**
   * generated from browser.engagement.navigation.webextension
   */
  /**
   * The count URI loads triggered in a subsession from a webextension. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * browser.engagement.navigation.webextension.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> webextension(592);

}
namespace browser_search_adclicks {
  /**
   * generated from browser.search.adclicks.about_home
   */
  /**
   * Records clicks of adverts on SERP pages where the search was started from
     * about:home. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source- docs.mozilla.org/browser/search/telemetry.html#browser-
     * search- content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.adclicks.about_home.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> about_home(593);

  /**
   * generated from browser.search.adclicks.about_newtab
   */
  /**
   * Records clicks of adverts on SERP pages where the search was started from
     * about:newtab. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.adclicks.about_newtab.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> about_newtab(594);

  /**
   * generated from browser.search.adclicks.contextmenu
   */
  /**
   * Records clicks of adverts on SERP pages where the search was started from the
     * context menu. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.adclicks.contextmenu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> contextmenu(595);

  /**
   * generated from browser.search.adclicks.reload
   */
  /**
   * Records clicks of adverts on SERP pages where the search was loaded by
     * reloading the page. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.adclicks.reload.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> reload(596);

  /**
   * generated from browser.search.adclicks.searchbar
   */
  /**
   * Records clicks of adverts on SERP pages where the search was started from the
     * search bar. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.adclicks.searchbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> searchbar(597);

  /**
   * generated from browser.search.adclicks.system
   */
  /**
   * Records clicks of adverts on SERP pages where the search was started from the
     * system, e.g. command line. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.adclicks.system.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> system(598);

  /**
   * generated from browser.search.adclicks.tabhistory
   */
  /**
   * Records clicks of adverts on SERP pages where the search was loaded from the
     * tab history. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.adclicks.tabhistory.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabhistory(599);

  /**
   * generated from browser.search.adclicks.unknown
   */
  /**
   * Records clicks of adverts on SERP pages where the search was started from a
     * place not categorized by the other scalars. The key format is
     * ‘<provider>:<tagged|organic>’ See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.adclicks.unknown.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> unknown(600);

  /**
   * generated from browser.search.adclicks.urlbar
   */
  /**
   * Records clicks of adverts on SERP pages where the search was started from the
     * urlbar. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-
     * source- docs.mozilla.org/browser/search/telemetry.html#browser-search- content
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.adclicks.urlbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar(601);

  /**
   * generated from browser.search.adclicks.urlbar_handoff
   */
  /**
   * The count URI loads triggered in a subsession from the urlbar via handoff,
     * broken down by the originating action. This metric was generated to correspond
     * to the Legacy Telemetry scalar browser.search.adclicks.urlbar_handoff.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_handoff(602);

  /**
   * generated from browser.search.adclicks.urlbar_persisted
   */
  /**
   * Records clicks of adverts on SERP pages where the search was started from the
     * urlbar after the search term was shown in the urlbar. The key format is
     * ‘<provider>:<tagged|organic>’ See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.adclicks.urlbar_persisted.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_persisted(603);

  /**
   * generated from browser.search.adclicks.urlbar_searchmode
   */
  /**
   * Records clicks of adverts on SERP pages where the search was started from the
     * urlbar in search mode. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.adclicks.urlbar_searchmode.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_searchmode(604);

  /**
   * generated from browser.search.adclicks.webextension
   */
  /**
   * Records clicks of adverts on SERP pages where the search was started from a
     * webextension. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.adclicks.webextension.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> webextension(605);

}
namespace browser_search_content {
  /**
   * generated from browser.search.content.about_home
   */
  /**
   * Records counts for in-content searches where the search was most likely started
     * from the about:home. The key format is <provider>:[tagged|tagged-follow-
     * on|organic]:[code|other|none] See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.content.about_home.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> about_home(606);

  /**
   * generated from browser.search.content.about_newtab
   */
  /**
   * Records counts for in-content searches where the search was most likely started
     * from the about:newtab. The key format is <provider>:[tagged|tagged-follow-
     * on|organic]:[code|other|none] See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.content.about_newtab.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> about_newtab(607);

  /**
   * generated from browser.search.content.contextmenu
   */
  /**
   * Records counts for in-content searches where the search was most likely started
     * from the context menu. The key format is <provider>:[tagged|tagged-follow-
     * on|organic]:[code|other|none] See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.content.contextmenu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> contextmenu(608);

  /**
   * generated from browser.search.content.reload
   */
  /**
   * Records counts for in-content searches where the search was loaded by reloading
     * the page. The key format is <provider>:[tagged|tagged-follow-
     * on|organic]:[code|other|none] See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.content.reload.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> reload(609);

  /**
   * generated from browser.search.content.searchbar
   */
  /**
   * Records counts for in-content searches where the search was most likely started
     * from the search bar. The key format is <provider>:[tagged|tagged-follow-
     * on|organic]:[code|other|none] See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.content.searchbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> searchbar(610);

  /**
   * generated from browser.search.content.system
   */
  /**
   * Records counts for in-content searches where the search was most likely started
     * from the system, e.g. command line. The key format is
     * <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.content.system.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> system(611);

  /**
   * generated from browser.search.content.tabhistory
   */
  /**
   * Records counts for in-content searches where the search was loaded from the tab
     * history. The key format is <provider>:[tagged|tagged-follow-
     * on|organic]:[code|other|none] See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.content.tabhistory.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabhistory(612);

  /**
   * generated from browser.search.content.unknown
   */
  /**
   * Records counts for in-content searches where the search was started from a
     * place that could not be determined or not categorized by the other scalars. The
     * key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none]
     * See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.content.unknown.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> unknown(613);

  /**
   * generated from browser.search.content.urlbar
   */
  /**
   * Records counts for in-content searches where the search was most likely started
     * from the urlbar. The key format is <provider>:[tagged|tagged-follow-
     * on|organic]:[code|other|none] See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.content.urlbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar(614);

  /**
   * generated from browser.search.content.urlbar_handoff
   */
  /**
   * The count URI loads triggered in a subsession from the urlbar via handoff,
     * broken down by the originating action. This metric was generated to correspond
     * to the Legacy Telemetry scalar browser.search.content.urlbar_handoff.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_handoff(615);

  /**
   * generated from browser.search.content.urlbar_persisted
   */
  /**
   * Records counts for in-content searches where the search was most likely started
     * from the urlbar after the search term was shown in the urlbar. The key format
     * is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.content.urlbar_persisted.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_persisted(616);

  /**
   * generated from browser.search.content.urlbar_searchmode
   */
  /**
   * Records counts for in-content searches where the search was most likely started
     * from the urlbar in search mode. The key format is <provider>:[tagged|tagged-
     * follow-on|organic]:[code|other|none] See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.content.urlbar_searchmode.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_searchmode(617);

  /**
   * generated from browser.search.content.webextension
   */
  /**
   * Records counts for in-content searches where the search was most likely started
     * from a webextension. The key format is <provider>:[tagged|tagged-follow-
     * on|organic]:[code|other|none] See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.content.webextension.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> webextension(618);

}
namespace browser_search_withads {
  /**
   * generated from browser.search.withads.about_home
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was
     * started from about:home. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.withads.about_home.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> about_home(619);

  /**
   * generated from browser.search.withads.about_newtab
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was
     * started from about:newtab. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.withads.about_newtab.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> about_newtab(620);

  /**
   * generated from browser.search.withads.contextmenu
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was
     * started from the context menu. The key format is ‘<provider>:<tagged|organic>’
     * See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.withads.contextmenu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> contextmenu(621);

  /**
   * generated from browser.search.withads.reload
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was loaded
     * by reloading the page. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.withads.reload.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> reload(622);

  /**
   * generated from browser.search.withads.searchbar
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was
     * started from the search bar. The key format is ‘<provider>:<tagged|organic>’
     * See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.withads.searchbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> searchbar(623);

  /**
   * generated from browser.search.withads.system
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was
     * started from the system, e.g. command line. The key format is
     * ‘<provider>:<tagged|organic>’ See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.withads.system.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> system(624);

  /**
   * generated from browser.search.withads.tabhistory
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was loaded
     * from the tab history. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.withads.tabhistory.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabhistory(625);

  /**
   * generated from browser.search.withads.unknown
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was
     * started from a place not categorized by the other scalars. The key format is
     * ‘<provider>:<tagged|organic>’ See https://firefox- source-
     * docs.mozilla.org/browser/search/telemetry.html#browser- search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.withads.unknown.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> unknown(626);

  /**
   * generated from browser.search.withads.urlbar
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was
     * started from the urlbar. The key format is ‘<provider>:<tagged|organic>’ See
     * https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
     * search-content This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.search.withads.urlbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar(627);

  /**
   * generated from browser.search.withads.urlbar_handoff
   */
  /**
   * The count URI loads triggered in a subsession from the urlbar via handoff,
     * broken down by the originating action. This metric was generated to correspond
     * to the Legacy Telemetry scalar browser.search.withads.urlbar_handoff.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_handoff(628);

  /**
   * generated from browser.search.withads.urlbar_persisted
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was
     * started from the urlbar after the search term was shown in the urlbar. The key
     * format is ‘<provider>:<tagged|organic>’ See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.withads.urlbar_persisted.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_persisted(629);

  /**
   * generated from browser.search.withads.urlbar_searchmode
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was
     * started from the urlbar in search mode. The key format is
     * ‘<provider>:<tagged|organic>’ See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.withads.urlbar_searchmode.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> urlbar_searchmode(630);

  /**
   * generated from browser.search.withads.webextension
   */
  /**
   * Records counts of SERP pages with adverts displayed where the search was
     * started from a webextension. The key format is ‘<provider>:<tagged|organic>’
     * See https://firefox-source-
     * docs.mozilla.org/browser/search/telemetry.html#browser-search- content This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.search.withads.webextension.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> webextension(631);

}
namespace newtab_search_ad {
  /**
   * generated from newtab.search.ad.click
   */
    struct ClickExtra {
      mozilla::Maybe<bool> isFollowOn;
      mozilla::Maybe<bool> isTagged;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> searchAccessPoint;
      mozilla::Maybe<nsCString> telemetryId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isFollowOn) {
          extraKeys.AppendElement()->AssignASCII("is_follow_on");
          extraValues.AppendElement()->AssignASCII(isFollowOn.value() ? "true" : "false");
        }
        if (isTagged) {
          extraKeys.AppendElement()->AssignASCII("is_tagged");
          extraValues.AppendElement()->AssignASCII(isTagged.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (searchAccessPoint) {
          extraKeys.AppendElement()->AssignASCII("search_access_point");
          extraValues.EmplaceBack(searchAccessPoint.value());
        }
        if (telemetryId) {
          extraKeys.AppendElement()->AssignASCII("telemetry_id");
          extraValues.EmplaceBack(telemetryId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when an ad link is clicked on a Search Engine Result Page (SERP) which
     * was loaded by a seach that began on a newtab page.
   */
  constexpr impl::EventMetric<ClickExtra> click(632);

  /**
   * generated from newtab.search.ad.impression
   */
    struct ImpressionExtra {
      mozilla::Maybe<bool> isFollowOn;
      mozilla::Maybe<bool> isTagged;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> searchAccessPoint;
      mozilla::Maybe<nsCString> telemetryId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isFollowOn) {
          extraKeys.AppendElement()->AssignASCII("is_follow_on");
          extraValues.AppendElement()->AssignASCII(isFollowOn.value() ? "true" : "false");
        }
        if (isTagged) {
          extraKeys.AppendElement()->AssignASCII("is_tagged");
          extraValues.AppendElement()->AssignASCII(isTagged.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (searchAccessPoint) {
          extraKeys.AppendElement()->AssignASCII("search_access_point");
          extraValues.EmplaceBack(searchAccessPoint.value());
        }
        if (telemetryId) {
          extraKeys.AppendElement()->AssignASCII("telemetry_id");
          extraValues.EmplaceBack(telemetryId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a newtab visit resulted in a search that loaded a Search Engine
     * Result Page (SERP) that contains an ad link. And the SERP is visible.
   */
  constexpr impl::EventMetric<ImpressionExtra> impression(633);

}
namespace search_with {
  /**
   * generated from search_with.context_id
   */
  /**
   * An identifier for Contextual Services user interaction pings. This is used
     * internally for counting unique users as well as for anti-fraud. It is shared
     * with other Contextual Services. It is not shared externally.
   */
  constexpr impl::UuidMetric context_id(634);

  /**
   * generated from search_with.reporting_url
   */
  /**
   * The external url to report this interaction to.
   */
  constexpr impl::UrlMetric reporting_url(635);

}
namespace serp {
  /**
   * generated from serp.abandonment
   */
    struct AbandonmentExtra {
      mozilla::Maybe<nsCString> impressionId;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (impressionId) {
          extraKeys.AppendElement()->AssignASCII("impression_id");
          extraValues.EmplaceBack(impressionId.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when there is no engagement with the SERP before the tab is closed,
     * the window is closed, the app is closed, or the tab is navigated away from.
   */
  constexpr impl::EventMetric<AbandonmentExtra> abandonment(636);

  /**
   * generated from serp.ad_impression
   */
    struct AdImpressionExtra {
      mozilla::Maybe<uint32_t> adsHidden;
      mozilla::Maybe<uint32_t> adsLoaded;
      mozilla::Maybe<uint32_t> adsVisible;
      mozilla::Maybe<nsCString> component;
      mozilla::Maybe<nsCString> impressionId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (adsHidden) {
          extraKeys.AppendElement()->AssignASCII("ads_hidden");
          extraValues.EmplaceBack(nsPrintfCString("%d", adsHidden.value()));
        }
        if (adsLoaded) {
          extraKeys.AppendElement()->AssignASCII("ads_loaded");
          extraValues.EmplaceBack(nsPrintfCString("%d", adsLoaded.value()));
        }
        if (adsVisible) {
          extraKeys.AppendElement()->AssignASCII("ads_visible");
          extraValues.EmplaceBack(nsPrintfCString("%d", adsVisible.value()));
        }
        if (component) {
          extraKeys.AppendElement()->AssignASCII("component");
          extraValues.EmplaceBack(component.value());
        }
        if (impressionId) {
          extraKeys.AppendElement()->AssignASCII("impression_id");
          extraValues.EmplaceBack(impressionId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user loads a SERP and ads are detected.
   */
  constexpr impl::EventMetric<AdImpressionExtra> ad_impression(637);

  /**
   * generated from serp.ads_blocked_count
   */
  enum class AdsBlockedCountLabel: uint16_t {
      eBeyondViewport = 0,
      eHiddenParent = 1,
      eHiddenChild = 2,
      e__Other__,
    };
  /**
   * Counts the specific type of block.
   */
  constexpr impl::Labeled<impl::CounterMetric, AdsBlockedCountLabel> ads_blocked_count(638);

  /**
   * generated from serp.categorization
   */
    struct CategorizationExtra {
      mozilla::Maybe<uint32_t> appVersion;
      mozilla::Maybe<nsCString> channel;
      mozilla::Maybe<bool> isShoppingPage;
      mozilla::Maybe<uint32_t> mappingsVersion;
      mozilla::Maybe<uint32_t> numAdsClicked;
      mozilla::Maybe<uint32_t> numAdsHidden;
      mozilla::Maybe<uint32_t> numAdsLoaded;
      mozilla::Maybe<uint32_t> numAdsVisible;
      mozilla::Maybe<uint32_t> organicCategory;
      mozilla::Maybe<uint32_t> organicNumDomains;
      mozilla::Maybe<uint32_t> organicNumInconclusive;
      mozilla::Maybe<uint32_t> organicNumUnknown;
      mozilla::Maybe<nsCString> partnerCode;
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<nsCString> region;
      mozilla::Maybe<uint32_t> sponsoredCategory;
      mozilla::Maybe<uint32_t> sponsoredNumDomains;
      mozilla::Maybe<uint32_t> sponsoredNumInconclusive;
      mozilla::Maybe<uint32_t> sponsoredNumUnknown;
      mozilla::Maybe<bool> tagged;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (appVersion) {
          extraKeys.AppendElement()->AssignASCII("app_version");
          extraValues.EmplaceBack(nsPrintfCString("%d", appVersion.value()));
        }
        if (channel) {
          extraKeys.AppendElement()->AssignASCII("channel");
          extraValues.EmplaceBack(channel.value());
        }
        if (isShoppingPage) {
          extraKeys.AppendElement()->AssignASCII("is_shopping_page");
          extraValues.AppendElement()->AssignASCII(isShoppingPage.value() ? "true" : "false");
        }
        if (mappingsVersion) {
          extraKeys.AppendElement()->AssignASCII("mappings_version");
          extraValues.EmplaceBack(nsPrintfCString("%d", mappingsVersion.value()));
        }
        if (numAdsClicked) {
          extraKeys.AppendElement()->AssignASCII("num_ads_clicked");
          extraValues.EmplaceBack(nsPrintfCString("%d", numAdsClicked.value()));
        }
        if (numAdsHidden) {
          extraKeys.AppendElement()->AssignASCII("num_ads_hidden");
          extraValues.EmplaceBack(nsPrintfCString("%d", numAdsHidden.value()));
        }
        if (numAdsLoaded) {
          extraKeys.AppendElement()->AssignASCII("num_ads_loaded");
          extraValues.EmplaceBack(nsPrintfCString("%d", numAdsLoaded.value()));
        }
        if (numAdsVisible) {
          extraKeys.AppendElement()->AssignASCII("num_ads_visible");
          extraValues.EmplaceBack(nsPrintfCString("%d", numAdsVisible.value()));
        }
        if (organicCategory) {
          extraKeys.AppendElement()->AssignASCII("organic_category");
          extraValues.EmplaceBack(nsPrintfCString("%d", organicCategory.value()));
        }
        if (organicNumDomains) {
          extraKeys.AppendElement()->AssignASCII("organic_num_domains");
          extraValues.EmplaceBack(nsPrintfCString("%d", organicNumDomains.value()));
        }
        if (organicNumInconclusive) {
          extraKeys.AppendElement()->AssignASCII("organic_num_inconclusive");
          extraValues.EmplaceBack(nsPrintfCString("%d", organicNumInconclusive.value()));
        }
        if (organicNumUnknown) {
          extraKeys.AppendElement()->AssignASCII("organic_num_unknown");
          extraValues.EmplaceBack(nsPrintfCString("%d", organicNumUnknown.value()));
        }
        if (partnerCode) {
          extraKeys.AppendElement()->AssignASCII("partner_code");
          extraValues.EmplaceBack(partnerCode.value());
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (region) {
          extraKeys.AppendElement()->AssignASCII("region");
          extraValues.EmplaceBack(region.value());
        }
        if (sponsoredCategory) {
          extraKeys.AppendElement()->AssignASCII("sponsored_category");
          extraValues.EmplaceBack(nsPrintfCString("%d", sponsoredCategory.value()));
        }
        if (sponsoredNumDomains) {
          extraKeys.AppendElement()->AssignASCII("sponsored_num_domains");
          extraValues.EmplaceBack(nsPrintfCString("%d", sponsoredNumDomains.value()));
        }
        if (sponsoredNumInconclusive) {
          extraKeys.AppendElement()->AssignASCII("sponsored_num_inconclusive");
          extraValues.EmplaceBack(nsPrintfCString("%d", sponsoredNumInconclusive.value()));
        }
        if (sponsoredNumUnknown) {
          extraKeys.AppendElement()->AssignASCII("sponsored_num_unknown");
          extraValues.EmplaceBack(nsPrintfCString("%d", sponsoredNumUnknown.value()));
        }
        if (tagged) {
          extraKeys.AppendElement()->AssignASCII("tagged");
          extraValues.AppendElement()->AssignASCII(tagged.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * A high-level categorization of a SERP (a best guess as to its topic), using
     * buckets such as "sports" or "travel".
   */
  constexpr impl::EventMetric<CategorizationExtra> categorization(639);

  /**
   * generated from serp.categorization_duration
   */
  /**
   * The time it takes to categorize elements on a SERP.
   */
  constexpr impl::TimingDistributionMetric categorization_duration(640);

  /**
   * generated from serp.categorization_no_map_found
   */
  /**
   * A count incremented upon a SERP categorization event being recorded without a
     * corresponding impression event being recorded. This metric effectively counts
     * missing impressions due to issues with the domain-to-categories map.
   */
  constexpr impl::CounterMetric categorization_no_map_found(641);

  /**
   * generated from serp.engagement
   */
    struct EngagementExtra {
      mozilla::Maybe<nsCString> action;
      mozilla::Maybe<nsCString> impressionId;
      mozilla::Maybe<nsCString> target;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        if (impressionId) {
          extraKeys.AppendElement()->AssignASCII("impression_id");
          extraValues.EmplaceBack(impressionId.value());
        }
        if (target) {
          extraKeys.AppendElement()->AssignASCII("target");
          extraValues.EmplaceBack(target.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded user actions on a SERP.
   */
  constexpr impl::EventMetric<EngagementExtra> engagement(642);


  /**
   * generated from serp.impression
   */
    struct ImpressionExtra {
      mozilla::Maybe<nsCString> impressionId;
      mozilla::Maybe<bool> isPrivate;
      mozilla::Maybe<bool> isShoppingPage;
      mozilla::Maybe<bool> isSignedIn;
      mozilla::Maybe<nsCString> partnerCode;
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<bool> shoppingTabDisplayed;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<bool> tagged;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (impressionId) {
          extraKeys.AppendElement()->AssignASCII("impression_id");
          extraValues.EmplaceBack(impressionId.value());
        }
        if (isPrivate) {
          extraKeys.AppendElement()->AssignASCII("is_private");
          extraValues.AppendElement()->AssignASCII(isPrivate.value() ? "true" : "false");
        }
        if (isShoppingPage) {
          extraKeys.AppendElement()->AssignASCII("is_shopping_page");
          extraValues.AppendElement()->AssignASCII(isShoppingPage.value() ? "true" : "false");
        }
        if (isSignedIn) {
          extraKeys.AppendElement()->AssignASCII("is_signed_in");
          extraValues.AppendElement()->AssignASCII(isSignedIn.value() ? "true" : "false");
        }
        if (partnerCode) {
          extraKeys.AppendElement()->AssignASCII("partner_code");
          extraValues.EmplaceBack(partnerCode.value());
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (shoppingTabDisplayed) {
          extraKeys.AppendElement()->AssignASCII("shopping_tab_displayed");
          extraValues.AppendElement()->AssignASCII(shoppingTabDisplayed.value() ? "true" : "false");
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (tagged) {
          extraKeys.AppendElement()->AssignASCII("tagged");
          extraValues.AppendElement()->AssignASCII(tagged.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a search engine results page (SERP) is shown to a user. The
     * feature began rolling out to all users with Firefox 115, and was permanently
     * enabled in Firefox 119.
   */
  constexpr impl::EventMetric<ImpressionExtra> impression(644);

}
namespace urlbar_searchmode {
  /**
   * generated from urlbar.searchmode.bookmarkmenu
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after selecing the Search Bookmarks menu item in the Library menu. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.searchmode.bookmarkmenu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> bookmarkmenu(645);

  /**
   * generated from urlbar.searchmode.handoff
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after being handed off from the search bar on the new tab page. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * urlbar.searchmode.handoff.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> handoff(646);

  /**
   * generated from urlbar.searchmode.historymenu
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after selecing the Search History menu item in a History menu. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * urlbar.searchmode.historymenu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> historymenu(647);

  /**
   * generated from urlbar.searchmode.keywordoffer
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after selecting a keyword offer result. The scalar key for local search modes
     * entered using a restrict keyword will be suffixed with "keyword". For example:
     * tabs_keyword, bookmarks_keyword, history_keyword, and actions_keyword. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.searchmode.keywordoffer.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> keywordoffer(648);

  /**
   * generated from urlbar.searchmode.oneoff
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after selecting a one-off. This metric was generated to correspond to the
     * Legacy Telemetry scalar urlbar.searchmode.oneoff.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> oneoff(649);

  /**
   * generated from urlbar.searchmode.other
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * from an unknown entry point. If values appear for this probe in Telemetry, we
     * should review the entry points to search mode. This metric was generated to
     * correspond to the Legacy Telemetry scalar urlbar.searchmode.other.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> other(650);

  /**
   * generated from urlbar.searchmode.searchbutton
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * by unified search button. This metric was generated to correspond to the Legacy
     * Telemetry scalar urlbar.searchmode.searchbutton.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> searchbutton(651);

  /**
   * generated from urlbar.searchmode.shortcut
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after pressing a keyboard shortcut. This metric was generated to correspond to
     * the Legacy Telemetry scalar urlbar.searchmode.shortcut.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> shortcut(652);

  /**
   * generated from urlbar.searchmode.tabmenu
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after selecting the Search Tabs menu item in the Tab Overflow menu. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.searchmode.tabmenu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabmenu(653);

  /**
   * generated from urlbar.searchmode.tabtosearch
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after selecting a tab-to-search result. This metric was generated to correspond
     * to the Legacy Telemetry scalar urlbar.searchmode.tabtosearch.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabtosearch(654);

  /**
   * generated from urlbar.searchmode.tabtosearch_onboard
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after selecting a tab-to-search onboarding result. This metric was generated to
     * correspond to the Legacy Telemetry scalar
     * urlbar.searchmode.tabtosearch_onboard.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabtosearch_onboard(655);

  /**
   * generated from urlbar.searchmode.topsites_newtab
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after selecting a search shortcut Top Site on the New Tab Page. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * urlbar.searchmode.topsites_newtab.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> topsites_newtab(656);

  /**
   * generated from urlbar.searchmode.topsites_urlbar
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after selecting a search shortcut Top Site in the Urlbar. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * urlbar.searchmode.topsites_urlbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> topsites_urlbar(657);

  /**
   * generated from urlbar.searchmode.touchbar
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after selecting a search shortcut on the macOS Touch Bar. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * urlbar.searchmode.touchbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> touchbar(658);

  /**
   * generated from urlbar.searchmode.typed
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * after typing an alias. The scalar keys for local search modes entered by typing
     * a restrict keyword will be suffixed with "keyword". For example: tabs_keyword,
     * bookmarks_keyword, history_keyword, and actions_keyword. If instead search mode
     * was entered by typing a restrict symbol the key will be suffixed with "symbol"
     * (e.g. typing "%" will generate "tabs_symbol"). This metric was generated to
     * correspond to the Legacy Telemetry scalar urlbar.searchmode.typed.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> typed(659);

}
namespace session_restore {
  /**
   * generated from session_restore.backup_can_be_loaded_session_file
   */
    struct BackupCanBeLoadedSessionFileExtra {
      mozilla::Maybe<nsCString> canLoad;
      mozilla::Maybe<nsCString> loadfailReason;
      mozilla::Maybe<nsCString> pathKey;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (canLoad) {
          extraKeys.AppendElement()->AssignASCII("can_load");
          extraValues.EmplaceBack(canLoad.value());
        }
        if (loadfailReason) {
          extraKeys.AppendElement()->AssignASCII("loadfail_reason");
          extraValues.EmplaceBack(loadfailReason.value());
        }
        if (pathKey) {
          extraKeys.AppendElement()->AssignASCII("path_key");
          extraValues.EmplaceBack(pathKey.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a file is able to be successfully read on startup This event was
     * generated to correspond to the Legacy Telemetry event
     * session_restore.backup_can_be_loaded#session_file.
   */
  constexpr impl::EventMetric<BackupCanBeLoadedSessionFileExtra> backup_can_be_loaded_session_file(660);

  /**
   * generated from session_restore.shutdown_success_session_startup
   */
    struct ShutdownSuccessSessionStartupExtra {
      mozilla::Maybe<nsCString> shutdownOk;
      mozilla::Maybe<nsCString> shutdownReason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (shutdownOk) {
          extraKeys.AppendElement()->AssignASCII("shutdown_ok");
          extraValues.EmplaceBack(shutdownOk.value());
        }
        if (shutdownReason) {
          extraKeys.AppendElement()->AssignASCII("shutdown_reason");
          extraValues.EmplaceBack(shutdownReason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Report shutdown success This event was generated to correspond to the Legacy
     * Telemetry event session_restore.shutdown_success#session_startup.
   */
  constexpr impl::EventMetric<ShutdownSuccessSessionStartupExtra> shutdown_success_session_startup(661);

}
namespace shopping {
  /**
   * generated from shopping.address_bar_feature_callout_displayed
   */
    struct AddressBarFeatureCalloutDisplayedExtra {
      mozilla::Maybe<nsCString> configuration;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (configuration) {
          extraKeys.AppendElement()->AssignASCII("configuration");
          extraValues.EmplaceBack(configuration.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user was shown the feature callout for the Shopping component.
   */
  constexpr impl::EventMetric<AddressBarFeatureCalloutDisplayedExtra> address_bar_feature_callout_displayed(662);

  /**
   * generated from shopping.address_bar_icon_clicked
   */
    struct AddressBarIconClickedExtra {
      mozilla::Maybe<nsCString> action;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The Shopping product Address Bar Icon was clicked by the user.
   */
  constexpr impl::EventMetric<AddressBarIconClickedExtra> address_bar_icon_clicked(663);

  /**
   * generated from shopping.address_bar_icon_displayed
   */
  /**
   * The Shopping product Address Bar Icon was displayed to the user.
   */
  constexpr impl::EventMetric<NoExtraKeys> address_bar_icon_displayed(664);

  /**
   * generated from shopping.product_page_visits
   */
  /**
   * Counts number of visits to a supported retailer product page
     * while enrolled in either the control or treatment branches
     * of the shopping experiment.
   */
  constexpr impl::CounterMetric product_page_visits(665);

  /**
   * generated from shopping.surface_ads_clicked
   */
    struct SurfaceAdsClickedExtra {
      mozilla::Maybe<bool> sponsored;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sponsored) {
          extraKeys.AppendElement()->AssignASCII("sponsored");
          extraValues.AppendElement()->AssignASCII(sponsored.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * An ad shown in the sidebar was clicked.
   */
  constexpr impl::EventMetric<SurfaceAdsClickedExtra> surface_ads_clicked(666);

  /**
   * generated from shopping.surface_ads_impression
   */
    struct SurfaceAdsImpressionExtra {
      mozilla::Maybe<bool> sponsored;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sponsored) {
          extraKeys.AppendElement()->AssignASCII("sponsored");
          extraValues.AppendElement()->AssignASCII(sponsored.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * An ad was shown and visible in the sidebar for 1.5 seconds.
   */
  constexpr impl::EventMetric<SurfaceAdsImpressionExtra> surface_ads_impression(667);

  /**
   * generated from shopping.surface_ads_placement
   */
    struct SurfaceAdsPlacementExtra {
      mozilla::Maybe<bool> sponsored;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sponsored) {
          extraKeys.AppendElement()->AssignASCII("sponsored");
          extraValues.AppendElement()->AssignASCII(sponsored.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * An ad unit was fetched successfully.
   */
  constexpr impl::EventMetric<SurfaceAdsPlacementExtra> surface_ads_placement(668);

  /**
   * generated from shopping.surface_ads_setting_toggled
   */
    struct SurfaceAdsSettingToggledExtra {
      mozilla::Maybe<nsCString> action;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user clicked the settings toggle to enable or disable ads in the
     * sidebar settings component.
   */
  constexpr impl::EventMetric<SurfaceAdsSettingToggledExtra> surface_ads_setting_toggled(669);

  /**
   * generated from shopping.surface_analyze_reviews_none_available_clicked
   */
  /**
   * The user clicked to analyze reviews in the case the reliability rating
     * was not available for display in the shopping side bar. This metric
     * does not contain any information about the product the user is viewing.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_analyze_reviews_none_available_clicked(670);

  /**
   * generated from shopping.surface_auto_open_setting_toggled
   */
    struct SurfaceAutoOpenSettingToggledExtra {
      mozilla::Maybe<nsCString> action;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user clicked the settings toggle to enable or disable auto-open in the
     * sidebar settings component.
   */
  constexpr impl::EventMetric<SurfaceAutoOpenSettingToggledExtra> surface_auto_open_setting_toggled(671);

  /**
   * generated from shopping.surface_closed
   */
    struct SurfaceClosedExtra {
      mozilla::Maybe<nsCString> source;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user opened the settings menu of the shopping component.
   */
  constexpr impl::EventMetric<SurfaceClosedExtra> surface_closed(672);

  /**
   * generated from shopping.surface_displayed
   */
    struct SurfaceDisplayedExtra {
      mozilla::Maybe<nsCString> sideBarState;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sideBarState) {
          extraKeys.AppendElement()->AssignASCII("side_bar_state");
          extraValues.EmplaceBack(sideBarState.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The Shopping product Sidebar was displayed.
   */
  constexpr impl::EventMetric<SurfaceDisplayedExtra> surface_displayed(673);

  /**
   * generated from shopping.surface_learn_more_clicked
   */
  /**
   * The user clicked the 'Learn More' link in the Shopping onboarding
     * experience.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_learn_more_clicked(674);

  /**
   * generated from shopping.surface_no_ads_available
   */
  /**
   * On a supported product page, the review checker showed analysis, and
     * review checker ads were enabled, but when we tried to fetch an ad from
     * the ad server, no ad was available.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_no_ads_available(675);

  /**
   * generated from shopping.surface_no_review_reliability_available
   */
  /**
   * Review reliability was not available for display in the shopping side
     * bar. This metric does not contain any information about the product
     * the user is viewing.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_no_review_reliability_available(676);

  /**
   * generated from shopping.surface_no_thanks_button_clicked
   */
  /**
   * The user clicks the 'No thanks' button when asked if they want to
     * disable auto-open behavior.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_no_thanks_button_clicked(677);

  /**
   * generated from shopping.surface_not_now_clicked
   */
  /**
   * The user clicked 'Not Now' to dismiss the dialog.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_not_now_clicked(678);

  /**
   * generated from shopping.surface_onboarding_displayed
   */
    struct SurfaceOnboardingDisplayedExtra {
      mozilla::Maybe<nsCString> configuration;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (configuration) {
          extraKeys.AppendElement()->AssignASCII("configuration");
          extraValues.EmplaceBack(configuration.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The Shopping Side bar displayed the onboarding experience.
   */
  constexpr impl::EventMetric<SurfaceOnboardingDisplayedExtra> surface_onboarding_displayed(679);

  /**
   * generated from shopping.surface_opt_in_clicked
   */
  /**
   * The user clicked the "Yes, try it" element to use the Shopping product's
     * functionality.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_opt_in_clicked(680);

  /**
   * generated from shopping.surface_opt_out_button_clicked
   */
  /**
   * The user clicked the button in the settings panel to turn off the shopping
     * experience.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_opt_out_button_clicked(681);

  /**
   * generated from shopping.surface_powered_by_fakespot_link_clicked
   */
  /**
   * The user clicked the "Fakespot by Mozilla" link in the shopping side
     * bar.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_powered_by_fakespot_link_clicked(682);

  /**
   * generated from shopping.surface_reactivated_button_clicked
   */
  /**
   * The user clicked the reactivated product button.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_reactivated_button_clicked(683);

  /**
   * generated from shopping.surface_reanalyze_clicked
   */
  /**
   * The user clicked to REanalyze reviews in the shopping side bar. This
     * metric does not contain any information about the product the user is
     * viewing or any displayed trusted deals.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_reanalyze_clicked(684);

  /**
   * generated from shopping.surface_settings_expand_clicked
   */
    struct SurfaceSettingsExpandClickedExtra {
      mozilla::Maybe<nsCString> action;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user opened the settings menu of the shopping component.
   */
  constexpr impl::EventMetric<SurfaceSettingsExpandClickedExtra> surface_settings_expand_clicked(685);

  /**
   * generated from shopping.surface_show_more_reviews_button_clicked
   */
    struct SurfaceShowMoreReviewsButtonClickedExtra {
      mozilla::Maybe<nsCString> action;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user clicked to expand the recent reviews to see more.
   */
  constexpr impl::EventMetric<SurfaceShowMoreReviewsButtonClickedExtra> surface_show_more_reviews_button_clicked(686);

  /**
   * generated from shopping.surface_show_privacy_policy_clicked
   */
  /**
   * The user clicked to view the Privacy Policy.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_show_privacy_policy_clicked(687);

  /**
   * generated from shopping.surface_show_quality_explainer_clicked
   */
    struct SurfaceShowQualityExplainerClickedExtra {
      mozilla::Maybe<nsCString> action;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user clicked to see the explanation of Review Quality in the
     * shopping component.
   */
  constexpr impl::EventMetric<SurfaceShowQualityExplainerClickedExtra> surface_show_quality_explainer_clicked(688);

  /**
   * generated from shopping.surface_show_quality_explainer_url_clicked
   */
  /**
   * The user clicked to see the explanation of Review Quality in the
     * shopping component.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_show_quality_explainer_url_clicked(689);

  /**
   * generated from shopping.surface_show_terms_clicked
   */
  /**
   * The user clicked to view the Terms of Service.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_show_terms_clicked(690);

  /**
   * generated from shopping.surface_stale_analysis_shown
   */
  /**
   * The user was shown the dialogue box indicating that analysis of a product
     * was stale. No information about the product is included.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_stale_analysis_shown(691);

  /**
   * generated from shopping.surface_yes_keep_closed_button_clicked
   */
  /**
   * The user clicks the 'Yes, keep closed' button when asked if they want to
     * disable auto-open behavior.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_yes_keep_closed_button_clicked(692);

}
namespace shopping_settings {
  /**
   * generated from shopping.settings.auto_open_user_disabled
   */
  /**
   * Indicates if the user has manually disabled the auto open sidebar feature.
     * Set during shopping component init and updated when changed in browser.
   */
  constexpr impl::BooleanMetric auto_open_user_disabled(693);

  /**
   * generated from shopping.settings.component_opted_out
   */
  /**
   * Indicates if the user has opted out of using the shopping component.
     * Set during shopping component init and updated when changed in browser.
   */
  constexpr impl::BooleanMetric component_opted_out(694);

  /**
   * generated from shopping.settings.disabled_ads
   */
  /**
   * Indicates if the user has manually disabled ads. Set during shopping
     * component init and updated when changed in browser.
   */
  constexpr impl::BooleanMetric disabled_ads(695);

  /**
   * generated from shopping.settings.has_onboarded
   */
  /**
   * Indicates if the user has completed the Shopping product Onboarding
     * experience. Set during shopping component init and updated when changed
     * in browser.
   */
  constexpr impl::BooleanMetric has_onboarded(696);

  /**
   * generated from shopping.settings.nimbus_disabled_shopping
   */
  /**
   * Indicates if Nimbus has disabled the use the shopping component.
   */
  constexpr impl::BooleanMetric nimbus_disabled_shopping(697);

}
namespace bookmarks {
  /**
   * generated from bookmarks.sidebar_toggle
   */
    struct SidebarToggleExtra {
      mozilla::Maybe<bool> opened;
      mozilla::Maybe<nsCString> version;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (opened) {
          extraKeys.AppendElement()->AssignASCII("opened");
          extraValues.AppendElement()->AssignASCII(opened.value() ? "true" : "false");
        }
        if (version) {
          extraKeys.AppendElement()->AssignASCII("version");
          extraValues.EmplaceBack(version.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The Bookmarks sidebar panel was loaded or unloaded.
   */
  constexpr impl::EventMetric<SidebarToggleExtra> sidebar_toggle(698);

}
namespace extension {
  /**
   * generated from extension.sidebar_toggle
   */
    struct SidebarToggleExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> addonName;
      mozilla::Maybe<bool> opened;
      mozilla::Maybe<nsCString> version;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (addonName) {
          extraKeys.AppendElement()->AssignASCII("addon_name");
          extraValues.EmplaceBack(addonName.value());
        }
        if (opened) {
          extraKeys.AppendElement()->AssignASCII("opened");
          extraValues.AppendElement()->AssignASCII(opened.value() ? "true" : "false");
        }
        if (version) {
          extraKeys.AppendElement()->AssignASCII("version");
          extraValues.EmplaceBack(version.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * A sidebar extension panel was loaded or unloaded.
   */
  constexpr impl::EventMetric<SidebarToggleExtra> sidebar_toggle(699);

}
namespace history {
  /**
   * generated from history.sidebar_toggle
   */
    struct SidebarToggleExtra {
      mozilla::Maybe<bool> opened;
      mozilla::Maybe<nsCString> version;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (opened) {
          extraKeys.AppendElement()->AssignASCII("opened");
          extraValues.AppendElement()->AssignASCII(opened.value() ? "true" : "false");
        }
        if (version) {
          extraKeys.AppendElement()->AssignASCII("version");
          extraValues.EmplaceBack(version.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The History sidebar panel was loaded or unloaded.
   */
  constexpr impl::EventMetric<SidebarToggleExtra> sidebar_toggle(700);

}
namespace sidebar {
  /**
   * generated from sidebar.addon_icon_click
   */
    struct AddonIconClickExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<bool> sidebarOpen;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (sidebarOpen) {
          extraKeys.AppendElement()->AssignASCII("sidebar_open");
          extraValues.AppendElement()->AssignASCII(sidebarOpen.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * An extension icon was clicked.
   */
  constexpr impl::EventMetric<AddonIconClickExtra> addon_icon_click(701);

  /**
   * generated from sidebar.bookmarks_icon_click
   */
    struct BookmarksIconClickExtra {
      mozilla::Maybe<bool> sidebarOpen;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sidebarOpen) {
          extraKeys.AppendElement()->AssignASCII("sidebar_open");
          extraValues.AppendElement()->AssignASCII(sidebarOpen.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The bookmarks icon was clicked.
   */
  constexpr impl::EventMetric<BookmarksIconClickExtra> bookmarks_icon_click(702);

  /**
   * generated from sidebar.chatbot_icon_click
   */
    struct ChatbotIconClickExtra {
      mozilla::Maybe<bool> sidebarOpen;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sidebarOpen) {
          extraKeys.AppendElement()->AssignASCII("sidebar_open");
          extraValues.AppendElement()->AssignASCII(sidebarOpen.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The chatbot icon was clicked.
   */
  constexpr impl::EventMetric<ChatbotIconClickExtra> chatbot_icon_click(703);

  /**
   * generated from sidebar.display_settings
   */
  /**
   * Setting for sidebar display (either "always" or "hide").
   */
  constexpr impl::StringMetric display_settings(704);

  /**
   * generated from sidebar.expand
   */
  /**
   * The sidebar was expanded.
   */
  constexpr impl::EventMetric<NoExtraKeys> expand(705);

  /**
   * generated from sidebar.history_icon_click
   */
    struct HistoryIconClickExtra {
      mozilla::Maybe<bool> sidebarOpen;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sidebarOpen) {
          extraKeys.AppendElement()->AssignASCII("sidebar_open");
          extraValues.AppendElement()->AssignASCII(sidebarOpen.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The history icon was clicked.
   */
  constexpr impl::EventMetric<HistoryIconClickExtra> history_icon_click(706);

  /**
   * generated from sidebar.keyboard_shortcut
   */
    struct KeyboardShortcutExtra {
      mozilla::Maybe<bool> opened;
      mozilla::Maybe<nsCString> panel;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (opened) {
          extraKeys.AppendElement()->AssignASCII("opened");
          extraValues.AppendElement()->AssignASCII(opened.value() ? "true" : "false");
        }
        if (panel) {
          extraKeys.AppendElement()->AssignASCII("panel");
          extraValues.EmplaceBack(panel.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Revamped sidebar toggled with keyboard shortcut.
   */
  constexpr impl::EventMetric<KeyboardShortcutExtra> keyboard_shortcut(707);

  /**
   * generated from sidebar.link
   */
  /**
   * The number of history items opened from the History sidebar. This metric was
     * generated to correspond to the Legacy Telemetry scalar sidebar.link.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> link(708);

  /**
   * generated from sidebar.position_settings
   */
  /**
   * Setting for sidebar position (either "left" or "right").
   */
  constexpr impl::StringMetric position_settings(709);

  /**
   * generated from sidebar.resize
   */
    struct ResizeExtra {
      mozilla::Maybe<uint32_t> current;
      mozilla::Maybe<uint32_t> percentage;
      mozilla::Maybe<uint32_t> previous;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (current) {
          extraKeys.AppendElement()->AssignASCII("current");
          extraValues.EmplaceBack(nsPrintfCString("%d", current.value()));
        }
        if (percentage) {
          extraKeys.AppendElement()->AssignASCII("percentage");
          extraValues.EmplaceBack(nsPrintfCString("%d", percentage.value()));
        }
        if (previous) {
          extraKeys.AppendElement()->AssignASCII("previous");
          extraValues.EmplaceBack(nsPrintfCString("%d", previous.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User resized the sidebar.
   */
  constexpr impl::EventMetric<ResizeExtra> resize(710);

  /**
   * generated from sidebar.search
   */
  /**
   * The number of searches from the sidebar, per view (e.g.: bookmarks, history).
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * sidebar.search.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> search(711);

  /**
   * generated from sidebar.synced_tabs_icon_click
   */
    struct SyncedTabsIconClickExtra {
      mozilla::Maybe<bool> sidebarOpen;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sidebarOpen) {
          extraKeys.AppendElement()->AssignASCII("sidebar_open");
          extraValues.AppendElement()->AssignASCII(sidebarOpen.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The synced tabs icon was clicked.
   */
  constexpr impl::EventMetric<SyncedTabsIconClickExtra> synced_tabs_icon_click(712);

  /**
   * generated from sidebar.tabs_layout
   */
  /**
   * Setting for tabs orientation (either "horizontal" or "vertical").
   */
  constexpr impl::StringMetric tabs_layout(713);

  /**
   * generated from sidebar.width
   */
  /**
   * Width of the sidebar, in pixels.
   */
  constexpr impl::QuantityMetric width(714);

}
namespace sidebar_customize {
  /**
   * generated from sidebar.customize.bookmarks_enabled
   */
    struct BookmarksEnabledExtra {
      mozilla::Maybe<bool> checked;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (checked) {
          extraKeys.AppendElement()->AssignASCII("checked");
          extraValues.AppendElement()->AssignASCII(checked.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User clicked on the checkbox corresponding to bookmarks on sidebar
     * customization settings.
   */
  constexpr impl::EventMetric<BookmarksEnabledExtra> bookmarks_enabled(715);

  /**
   * generated from sidebar.customize.chatbot_enabled
   */
    struct ChatbotEnabledExtra {
      mozilla::Maybe<bool> checked;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (checked) {
          extraKeys.AppendElement()->AssignASCII("checked");
          extraValues.AppendElement()->AssignASCII(checked.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User clicked on the checkbox corresponding to chatbot on sidebar customization
     * settings.
   */
  constexpr impl::EventMetric<ChatbotEnabledExtra> chatbot_enabled(716);

  /**
   * generated from sidebar.customize.extensions_clicked
   */
  /**
   * User clicked on the link to go to Browser Extensions on sidebar customization
     * settings.
   */
  constexpr impl::EventMetric<NoExtraKeys> extensions_clicked(717);

  /**
   * generated from sidebar.customize.firefox_settings_clicked
   */
  /**
   * User clicked on the link to Manage Firefox Settings on sidebar customization
     * settings.
   */
  constexpr impl::EventMetric<NoExtraKeys> firefox_settings_clicked(718);

  /**
   * generated from sidebar.customize.history_enabled
   */
    struct HistoryEnabledExtra {
      mozilla::Maybe<bool> checked;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (checked) {
          extraKeys.AppendElement()->AssignASCII("checked");
          extraValues.AppendElement()->AssignASCII(checked.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User clicked on the checkbox corresponding to history on sidebar customization
     * settings.
   */
  constexpr impl::EventMetric<HistoryEnabledExtra> history_enabled(719);

  /**
   * generated from sidebar.customize.icon_click
   */
  /**
   * User clicked on the gear icon to customize the sidebar.
   */
  constexpr impl::EventMetric<NoExtraKeys> icon_click(720);

  /**
   * generated from sidebar.customize.panel_toggle
   */
    struct PanelToggleExtra {
      mozilla::Maybe<bool> opened;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (opened) {
          extraKeys.AppendElement()->AssignASCII("opened");
          extraValues.AppendElement()->AssignASCII(opened.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The Customize sidebar panel was loaded or unloaded.
   */
  constexpr impl::EventMetric<PanelToggleExtra> panel_toggle(721);

  /**
   * generated from sidebar.customize.sidebar_display
   */
    struct SidebarDisplayExtra {
      mozilla::Maybe<nsCString> preference;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (preference) {
          extraKeys.AppendElement()->AssignASCII("preference");
          extraValues.EmplaceBack(preference.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User selected an option of when the sidebar is shown on sidebar customization
     * settings.
   */
  constexpr impl::EventMetric<SidebarDisplayExtra> sidebar_display(722);

  /**
   * generated from sidebar.customize.sidebar_position
   */
    struct SidebarPositionExtra {
      mozilla::Maybe<nsCString> position;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(position.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User selected an option of in which side the sidebar is displayed from the
     * sidebar customization settings.
   */
  constexpr impl::EventMetric<SidebarPositionExtra> sidebar_position(723);

  /**
   * generated from sidebar.customize.synced_tabs_enabled
   */
    struct SyncedTabsEnabledExtra {
      mozilla::Maybe<bool> checked;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (checked) {
          extraKeys.AppendElement()->AssignASCII("checked");
          extraValues.AppendElement()->AssignASCII(checked.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User clicked on the checkbox corresponding to synced tabs on sidebar
     * customization settings.
   */
  constexpr impl::EventMetric<SyncedTabsEnabledExtra> synced_tabs_enabled(724);

  /**
   * generated from sidebar.customize.tabs_display
   */
    struct TabsDisplayExtra {
      mozilla::Maybe<bool> checked;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (checked) {
          extraKeys.AppendElement()->AssignASCII("checked");
          extraValues.AppendElement()->AssignASCII(checked.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User clicked on the checkbox corresponding to hiding horizontal tabs on sidebar
     * customization settings.
   */
  constexpr impl::EventMetric<TabsDisplayExtra> tabs_display(725);

  /**
   * generated from sidebar.customize.tabs_layout
   */
    struct TabsLayoutExtra {
      mozilla::Maybe<nsCString> orientation;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (orientation) {
          extraKeys.AppendElement()->AssignASCII("orientation");
          extraValues.EmplaceBack(orientation.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User selected between horizontal or vertical tabs on sidebar customization
     * settings.
   */
  constexpr impl::EventMetric<TabsLayoutExtra> tabs_layout(726);

}
namespace synced_tabs {
  /**
   * generated from synced_tabs.sidebar_toggle
   */
    struct SidebarToggleExtra {
      mozilla::Maybe<bool> opened;
      mozilla::Maybe<bool> syncedTabsLoaded;
      mozilla::Maybe<nsCString> version;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (opened) {
          extraKeys.AppendElement()->AssignASCII("opened");
          extraValues.AppendElement()->AssignASCII(opened.value() ? "true" : "false");
        }
        if (syncedTabsLoaded) {
          extraKeys.AppendElement()->AssignASCII("synced_tabs_loaded");
          extraValues.AppendElement()->AssignASCII(syncedTabsLoaded.value() ? "true" : "false");
        }
        if (version) {
          extraKeys.AppendElement()->AssignASCII("version");
          extraValues.EmplaceBack(version.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The Synced Tabs sidebar panel was loaded or unloaded.
   */
  constexpr impl::EventMetric<SidebarToggleExtra> sidebar_toggle(727);

  /**
   * generated from synced_tabs.click_fxa_app_menu
   */
    struct ClickFxaAppMenuExtra {
      mozilla::Maybe<nsCString> filter;
      mozilla::Maybe<nsCString> tabPos;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (filter) {
          extraKeys.AppendElement()->AssignASCII("filter");
          extraValues.EmplaceBack(filter.value());
        }
        if (tabPos) {
          extraKeys.AppendElement()->AssignASCII("tab_pos");
          extraValues.EmplaceBack(tabPos.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record how users access and use synced tabs component This event was generated
     * to correspond to the Legacy Telemetry event synced_tabs.click#fxa_app_menu.
   */
  constexpr impl::EventMetric<ClickFxaAppMenuExtra> click_fxa_app_menu(728);

  /**
   * generated from synced_tabs.click_fxa_avatar_menu
   */
    struct ClickFxaAvatarMenuExtra {
      mozilla::Maybe<nsCString> filter;
      mozilla::Maybe<nsCString> tabPos;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (filter) {
          extraKeys.AppendElement()->AssignASCII("filter");
          extraValues.EmplaceBack(filter.value());
        }
        if (tabPos) {
          extraKeys.AppendElement()->AssignASCII("tab_pos");
          extraValues.EmplaceBack(tabPos.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record how users access and use synced tabs component This event was generated
     * to correspond to the Legacy Telemetry event synced_tabs.click#fxa_avatar_menu.
   */
  constexpr impl::EventMetric<ClickFxaAvatarMenuExtra> click_fxa_avatar_menu(729);

  /**
   * generated from synced_tabs.click_synced_tabs_sidebar
   */
    struct ClickSyncedTabsSidebarExtra {
      mozilla::Maybe<nsCString> filter;
      mozilla::Maybe<nsCString> tabPos;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (filter) {
          extraKeys.AppendElement()->AssignASCII("filter");
          extraValues.EmplaceBack(filter.value());
        }
        if (tabPos) {
          extraKeys.AppendElement()->AssignASCII("tab_pos");
          extraValues.EmplaceBack(tabPos.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record how users access and use synced tabs component This event was generated
     * to correspond to the Legacy Telemetry event
     * synced_tabs.click#synced_tabs_sidebar.
   */
  constexpr impl::EventMetric<ClickSyncedTabsSidebarExtra> click_synced_tabs_sidebar(730);

}
namespace browser_ui_interaction {
  /**
   * generated from browser.ui.interaction.all_tabs_panel_dragstart_tab_event_count
   */
  /**
   * Records a count of how many times a drag event started for a tab within the All
     * Tabs panel. This metric was generated to correspond to the Legacy Telemetry
     * scalar browser.ui.interaction.all_tabs_panel_dragstart_tab_event_count.
   */
  constexpr impl::CounterMetric all_tabs_panel_dragstart_tab_event_count(731);

  /**
   * generated from browser.ui.interaction.all_tabs_panel_entrypoint
   */
  /**
   * Records a count of how many times the All Tabs Panel was opened, keyed on a
     * string describing the entrypoint. This metric was generated to correspond to
     * the Legacy Telemetry scalar browser.ui.interaction.all_tabs_panel_entrypoint.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> all_tabs_panel_entrypoint(732);

  /**
   * generated from browser.ui.interaction.textrecognition_error
   */
  /**
   * Recorded when text recognition in images fails for some unknown reason. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.textrecognition_error.
   */
  constexpr impl::CounterMetric textrecognition_error(733);

  /**
   * generated from browser.ui.interaction.app_menu
   */
  /**
   * Records a count of interactions with items in the app menu. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.app_menu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> app_menu(734);

  /**
   * generated from browser.ui.interaction.bookmarks_bar
   */
  /**
   * Records a count of interactions with items in the bookmarks bar. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.bookmarks_bar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> bookmarks_bar(735);

  /**
   * generated from browser.ui.interaction.content_context
   */
  /**
   * Records a count of interactions with items in the content context menu. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.content_context.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> content_context(736);

  /**
   * generated from browser.ui.interaction.menu_bar
   */
  /**
   * Records a count of interactions with items in the menu bar. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.menu_bar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> menu_bar(737);

  /**
   * generated from browser.ui.interaction.nav_bar
   */
  /**
   * Records a count of interactions with items in the nav bar. See https://firefox-
     * source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.nav_bar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> nav_bar(738);

  /**
   * generated from browser.ui.interaction.overflow_menu
   */
  /**
   * Records a count of interactions with items in the overflow menu. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.overflow_menu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> overflow_menu(739);

  /**
   * generated from browser.ui.interaction.pageaction_panel
   */
  /**
   * Records a count of interactions with page action items in the panel. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.pageaction_panel.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> pageaction_panel(740);

  /**
   * generated from browser.ui.interaction.pageaction_urlbar
   */
  /**
   * Records a count of interactions with page action items in the url bar. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.pageaction_urlbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> pageaction_urlbar(741);

  /**
   * generated from browser.ui.interaction.pinned_overflow_menu
   */
  /**
   * Records a count of interactions with items in the pinned area of the overflow
     * menu. See https://firefox-source-
     * docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated
     * to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.pinned_overflow_menu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> pinned_overflow_menu(742);

  /**
   * generated from browser.ui.interaction.preferences_pane_containers
   */
  /**
   * Records the items interacted with in the Containers section of preferences. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.preferences_paneContainers.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> preferences_pane_containers(743);

  /**
   * generated from browser.ui.interaction.preferences_pane_experimental
   */
  /**
   * Records the items interacted with in the Experimental section of preferences.
     * See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.preferences_paneExperimental.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> preferences_pane_experimental(744);

  /**
   * generated from browser.ui.interaction.preferences_pane_general
   */
  /**
   * Records the items interacted with in the General section of preferences. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.preferences_paneGeneral.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> preferences_pane_general(745);

  /**
   * generated from browser.ui.interaction.preferences_pane_home
   */
  /**
   * Records the items interacted with in the Home section of preferences. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.preferences_paneHome.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> preferences_pane_home(746);

  /**
   * generated from browser.ui.interaction.preferences_pane_more_from_mozilla
   */
  /**
   * Records the items interacted with in the More From Mozilla section of
     * preferences. See https://firefox-source-
     * docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated
     * to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.preferences_paneMoreFromMozilla.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> preferences_pane_more_from_mozilla(747);

  /**
   * generated from browser.ui.interaction.preferences_pane_privacy
   */
  /**
   * Records the items interacted with in the Privacy section of preferences. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.preferences_panePrivacy.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> preferences_pane_privacy(748);

  /**
   * generated from browser.ui.interaction.preferences_pane_search
   */
  /**
   * Records the items interacted with in the Search section of preferences. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.preferences_paneSearch.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> preferences_pane_search(749);

  /**
   * generated from browser.ui.interaction.preferences_pane_search_results
   */
  /**
   * Records the items interacted with in the Search results section of preferences.
     * See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.preferences_paneSearchResults.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> preferences_pane_search_results(750);

  /**
   * generated from browser.ui.interaction.preferences_pane_sync
   */
  /**
   * Records the items interacted with in the Sync section of preferences. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.preferences_paneSync.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> preferences_pane_sync(751);

  /**
   * generated from browser.ui.interaction.preferences_pane_unknown
   */
  /**
   * Records the items interacted with in any other section of preferences. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.preferences_paneUnknown.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> preferences_pane_unknown(752);

  /**
   * generated from browser.ui.interaction.tabs_bar
   */
  /**
   * Records a count of interactions with items in the tab bar. See https://firefox-
     * source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.tabs_bar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabs_bar(753);

  /**
   * generated from browser.ui.interaction.tabs_context
   */
  /**
   * Records a count of interactions with items in the tab context menu. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.tabs_context.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabs_context(754);

  /**
   * generated from browser.ui.interaction.tabs_context_entrypoint
   */
  /**
   * Records a count for each entrypoint (the container of the trigger node) when an
     * item from the tabs context menu is selected. See https://firefox-source-
     * docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated
     * to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.tabs_context_entrypoint.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabs_context_entrypoint(755);

  /**
   * generated from browser.ui.interaction.unified_extensions_area
   */
  /**
   * Records a count of interactions with items in the Unified Extensions area. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.unified_extensions_area.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> unified_extensions_area(756);

  /**
   * generated from browser.ui.interaction.vertical_tabs_container
   */
  /**
   * Records a count of interactions with items in the vertical tab bar. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.vertical_tabs_container.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> vertical_tabs_container(757);

  /**
   * generated from browser.ui.interaction.keyboard
   */
  /**
   * Records a count of interactions with keyboard shortcuts. See https://firefox-
     * source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * browser.ui.interaction.keyboard.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> keyboard(758);

}
namespace quick_suggest {
  /**
   * generated from quick_suggest.advertiser
   */
  /**
   * The name of the advertiser providing the sponsored TopSite.
   */
  constexpr impl::StringMetric advertiser(759);

  /**
   * generated from quick_suggest.block_id
   */
  /**
   * A unique identifier for the suggestion (a.k.a. a keywords block).
   */
  constexpr impl::StringMetric block_id(760);

  /**
   * generated from quick_suggest.context_id
   */
  /**
   * An identifier to identify users for Contextual Services user interaction pings.
   */
  constexpr impl::UuidMetric context_id(761);

  /**
   * generated from quick_suggest.iab_category
   */
  /**
   * The suggestion's category. Either "22 - Shopping" or "5 - Educational".
   */
  constexpr impl::StringMetric iab_category(762);

  /**
   * generated from quick_suggest.improve_suggest_experience
   */
  /**
   * Whether the "Improve Suggest Experience" checkbox is checked.
   */
  constexpr impl::BooleanMetric improve_suggest_experience(763);

  /**
   * generated from quick_suggest.is_clicked
   */
  /**
   * Whether this quicksuggest-impression ping was for an item that was clicked.
   */
  constexpr impl::BooleanMetric is_clicked(764);

  /**
   * generated from quick_suggest.match_type
   */
  /**
   * Whether this was a best/top match or not. Either "best-match" or "firefox-
     * suggest".
   */
  constexpr impl::StringMetric match_type(765);

  /**
   * generated from quick_suggest.ping_type
   */
  /**
   * The ping's type. In other situations might be designated by an event's name or
     * an interaction field. E.g. "quicksuggest-impression", "quicksuggest-block",
     * "quicksuggest-click".
   */
  constexpr impl::StringMetric ping_type(766);

  /**
   * generated from quick_suggest.position
   */
  /**
   * The position (1-based) of the QuickSuggest item being interatcted with.
   */
  constexpr impl::QuantityMetric position(767);

  /**
   * generated from quick_suggest.reporting_url
   */
  /**
   * The url to report this interaction to.
   */
  constexpr impl::UrlMetric reporting_url(768);

  /**
   * generated from quick_suggest.request_id
   */
  /**
   * A request identifier for each API request to [Merino](https://mozilla-
     * services.github.io/merino/). Only present for suggestions provided by Merino.
   */
  constexpr impl::StringMetric request_id(769);

  /**
   * generated from quick_suggest.source
   */
  /**
   * The source of the interaction. E.g. "urlbar".
   */
  constexpr impl::StringMetric source(770);

  /**
   * generated from quick_suggest.suggested_index
   */
  /**
   * A stringified integer value that is the intended index of the suggestion being
     * interacted with. If `suggested_index_relative_to_group` is true, the index is
     * relative to the "Firefox Suggest" group; otherwise the index is relative to the
     * entire list of suggestions. Non-negative values (starting at 0) are relative to
     * the start/top of the group/list; negative values are relative to the end/bottom
     * of the group/list.
   */
  constexpr impl::StringMetric suggested_index(771);

  /**
   * generated from quick_suggest.suggested_index_relative_to_group
   */
  /**
   * Whether `suggested_index` is relative to the "Firefox Suggest" group. If false,
     * it is relative to the entire list of suggestions.
   */
  constexpr impl::BooleanMetric suggested_index_relative_to_group(772);

}
namespace suggest {
  /**
   * generated from suggest.ingest_download_time
   */
  enum class IngestDownloadTimeLabel: uint16_t {
      eIcon = 0,
      eData = 1,
      eAmoSuggestions = 2,
      ePocketSuggestions = 3,
      eYelpSuggestions = 4,
      eMdnSuggestions = 5,
      eWeather = 6,
      eConfiguration = 7,
      eAmpMobileSuggestions = 8,
      eFakespotSuggestions = 9,
      e__Other__,
    };
  /**
   * Download time for ingestion, labelled by record type
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, IngestDownloadTimeLabel> ingest_download_time(773);

  /**
   * generated from suggest.ingest_time
   */
  enum class IngestTimeLabel: uint16_t {
      eIcon = 0,
      eData = 1,
      eAmoSuggestions = 2,
      ePocketSuggestions = 3,
      eYelpSuggestions = 4,
      eMdnSuggestions = 5,
      eWeather = 6,
      eConfiguration = 7,
      eAmpMobileSuggestions = 8,
      eFakespotSuggestions = 9,
      e__Other__,
    };
  /**
   * Time for ingestion (excluding download time), labelled by record type
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, IngestTimeLabel> ingest_time(774);

  /**
   * generated from suggest.query_time
   */
  enum class QueryTimeLabel: uint16_t {
      eAmp = 0,
      eAmpmobile = 1,
      eWikipedia = 2,
      eAmo = 3,
      ePocket = 4,
      eYelp = 5,
      eMdn = 6,
      eWeather = 7,
      eFakespot = 8,
      e__Other__,
    };
  /**
   * Time executing queries, labelled by provider type
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, QueryTimeLabel> query_time(775);

}
namespace suggest_relevance {
  /**
   * generated from suggest_relevance.outcome
   */
  enum class OutcomeLabel: uint16_t {
      eBoosted = 0,
      eDecreased = 1,
      e__Other__,
    };
  /**
   * For each successful scoring, count whether the relevance score gets boosted or
     * decreased over the original score. Note that given how the score is calculated,
     * it's practically impossible to have the two scores tied. If that's the case
     * anyhow, it will increment the "boosted" counter.
   */
  constexpr impl::Labeled<impl::CounterMetric, OutcomeLabel> outcome(776);

  /**
   * generated from suggest_relevance.status
   */
  enum class StatusLabel: uint16_t {
      eSuccess = 0,
      eFailure = 1,
      e__Other__,
    };
  /**
   * Count the successful / failed attempts of relevance scoring in Firefox Suggest.
   */
  constexpr impl::Labeled<impl::CounterMetric, StatusLabel> status(777);

}
namespace urlbar {
  /**
   * generated from urlbar.abandonment
   */
    struct AbandonmentExtra {
      mozilla::Maybe<nsCString> abandonmentType;
      mozilla::Maybe<nsCString> actions;
      mozilla::Maybe<nsCString> groups;
      mozilla::Maybe<nsCString> interaction;
      mozilla::Maybe<uint32_t> nChars;
      mozilla::Maybe<uint32_t> nResults;
      mozilla::Maybe<uint32_t> nWords;
      mozilla::Maybe<nsCString> results;
      mozilla::Maybe<nsCString> sap;
      mozilla::Maybe<nsCString> searchEngineDefaultId;
      mozilla::Maybe<nsCString> searchMode;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (abandonmentType) {
          extraKeys.AppendElement()->AssignASCII("abandonment_type");
          extraValues.EmplaceBack(abandonmentType.value());
        }
        if (actions) {
          extraKeys.AppendElement()->AssignASCII("actions");
          extraValues.EmplaceBack(actions.value());
        }
        if (groups) {
          extraKeys.AppendElement()->AssignASCII("groups");
          extraValues.EmplaceBack(groups.value());
        }
        if (interaction) {
          extraKeys.AppendElement()->AssignASCII("interaction");
          extraValues.EmplaceBack(interaction.value());
        }
        if (nChars) {
          extraKeys.AppendElement()->AssignASCII("n_chars");
          extraValues.EmplaceBack(nsPrintfCString("%d", nChars.value()));
        }
        if (nResults) {
          extraKeys.AppendElement()->AssignASCII("n_results");
          extraValues.EmplaceBack(nsPrintfCString("%d", nResults.value()));
        }
        if (nWords) {
          extraKeys.AppendElement()->AssignASCII("n_words");
          extraValues.EmplaceBack(nsPrintfCString("%d", nWords.value()));
        }
        if (results) {
          extraKeys.AppendElement()->AssignASCII("results");
          extraValues.EmplaceBack(results.value());
        }
        if (sap) {
          extraKeys.AppendElement()->AssignASCII("sap");
          extraValues.EmplaceBack(sap.value());
        }
        if (searchEngineDefaultId) {
          extraKeys.AppendElement()->AssignASCII("search_engine_default_id");
          extraValues.EmplaceBack(searchEngineDefaultId.value());
        }
        if (searchMode) {
          extraKeys.AppendElement()->AssignASCII("search_mode");
          extraValues.EmplaceBack(searchMode.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user abandons a search (blurring the urlbar).
   */
  constexpr impl::EventMetric<AbandonmentExtra> abandonment(778);

  /**
   * generated from urlbar.abandonment_count
   */
  /**
   * A uint recording the number of abandoned engagements in the urlbar. An
     * abandonment occurs when the user begins using the urlbar but stops before
     * completing the engagement. This can happen when the user clicks outside the
     * urlbar to focus a different part of the window. It can also happen when the
     * user switches to another window while the urlbar is focused. This metric was
     * generated to correspond to the Legacy Telemetry scalar urlbar.abandonment.
   */
  constexpr impl::CounterMetric abandonment_count(779);

  /**
   * generated from urlbar.autofill_deletion
   */
  /**
   * A uint recording the deletion count for autofilled string in the urlbar. This
     * occurs when the user deletes whole autofilled string by BACKSPACE or DELETE key
     * while the autofilled string is selected. This metric was generated to
     * correspond to the Legacy Telemetry scalar urlbar.autofill_deletion.
   */
  constexpr impl::CounterMetric autofill_deletion(780);

  /**
   * generated from urlbar.engagement
   */
    struct EngagementExtra {
      mozilla::Maybe<nsCString> actions;
      mozilla::Maybe<nsCString> engagementType;
      mozilla::Maybe<nsCString> groups;
      mozilla::Maybe<nsCString> interaction;
      mozilla::Maybe<uint32_t> nChars;
      mozilla::Maybe<uint32_t> nResults;
      mozilla::Maybe<uint32_t> nWords;
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<nsCString> results;
      mozilla::Maybe<nsCString> sap;
      mozilla::Maybe<nsCString> searchEngineDefaultId;
      mozilla::Maybe<nsCString> searchMode;
      mozilla::Maybe<uint32_t> selectedPosition;
      mozilla::Maybe<nsCString> selectedResult;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (actions) {
          extraKeys.AppendElement()->AssignASCII("actions");
          extraValues.EmplaceBack(actions.value());
        }
        if (engagementType) {
          extraKeys.AppendElement()->AssignASCII("engagement_type");
          extraValues.EmplaceBack(engagementType.value());
        }
        if (groups) {
          extraKeys.AppendElement()->AssignASCII("groups");
          extraValues.EmplaceBack(groups.value());
        }
        if (interaction) {
          extraKeys.AppendElement()->AssignASCII("interaction");
          extraValues.EmplaceBack(interaction.value());
        }
        if (nChars) {
          extraKeys.AppendElement()->AssignASCII("n_chars");
          extraValues.EmplaceBack(nsPrintfCString("%d", nChars.value()));
        }
        if (nResults) {
          extraKeys.AppendElement()->AssignASCII("n_results");
          extraValues.EmplaceBack(nsPrintfCString("%d", nResults.value()));
        }
        if (nWords) {
          extraKeys.AppendElement()->AssignASCII("n_words");
          extraValues.EmplaceBack(nsPrintfCString("%d", nWords.value()));
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (results) {
          extraKeys.AppendElement()->AssignASCII("results");
          extraValues.EmplaceBack(results.value());
        }
        if (sap) {
          extraKeys.AppendElement()->AssignASCII("sap");
          extraValues.EmplaceBack(sap.value());
        }
        if (searchEngineDefaultId) {
          extraKeys.AppendElement()->AssignASCII("search_engine_default_id");
          extraValues.EmplaceBack(searchEngineDefaultId.value());
        }
        if (searchMode) {
          extraKeys.AppendElement()->AssignASCII("search_mode");
          extraValues.EmplaceBack(searchMode.value());
        }
        if (selectedPosition) {
          extraKeys.AppendElement()->AssignASCII("selected_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", selectedPosition.value()));
        }
        if (selectedResult) {
          extraKeys.AppendElement()->AssignASCII("selected_result");
          extraValues.EmplaceBack(selectedResult.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user executes an action on a result.
   */
  constexpr impl::EventMetric<EngagementExtra> engagement(781);

  /**
   * generated from urlbar.engagement_count
   */
  /**
   * A uint recording the number of engagements the user completes in the urlbar.
     * An engagement occurs when the user navigates to a page using the urlbar, for
     * example by picking a result in the urlbar panel or typing a search term or URL
     * in the urlbar and pressing the enter key. This metric was generated to
     * correspond to the Legacy Telemetry scalar urlbar.engagement.
   */
  constexpr impl::CounterMetric engagement_count(782);

  /**
   * generated from urlbar.exposure
   */
    struct ExposureExtra {
      mozilla::Maybe<nsCString> results;
      mozilla::Maybe<nsCString> terminal;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (results) {
          extraKeys.AppendElement()->AssignASCII("results");
          extraValues.EmplaceBack(results.value());
        }
        if (terminal) {
          extraKeys.AppendElement()->AssignASCII("terminal");
          extraValues.EmplaceBack(terminal.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when client is exposed to urlbar experiment results.
   */
  constexpr impl::EventMetric<ExposureExtra> exposure(783);

  /**
   * generated from urlbar.fakespot_engagement
   */
    struct FakespotEngagementExtra {
      mozilla::Maybe<nsCString> grade;
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<nsCString> rating;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (grade) {
          extraKeys.AppendElement()->AssignASCII("grade");
          extraValues.EmplaceBack(grade.value());
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (rating) {
          extraKeys.AppendElement()->AssignASCII("rating");
          extraValues.EmplaceBack(rating.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user engages with a Fakespot suggestion.
   */
  constexpr impl::EventMetric<FakespotEngagementExtra> fakespot_engagement(784);

  /**
   * generated from urlbar.keyword_exposure
   */
    struct KeywordExposureExtra {
      mozilla::Maybe<nsCString> keyword;
      mozilla::Maybe<nsCString> result;
      mozilla::Maybe<bool> terminal;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (keyword) {
          extraKeys.AppendElement()->AssignASCII("keyword");
          extraValues.EmplaceBack(keyword.value());
        }
        if (result) {
          extraKeys.AppendElement()->AssignASCII("result");
          extraValues.EmplaceBack(result.value());
        }
        if (terminal) {
          extraKeys.AppendElement()->AssignASCII("terminal");
          extraValues.AppendElement()->AssignASCII(terminal.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * When keyword exposures are enabled, this event is recorded in the `urlbar-
     * keyword-exposure` ping, which is submitted at the end of urlbar sessions during
     * which one or more exposure results are matched. The ping will contain one
     * `keyword_exposure` event for each instance where a result is matched during the
     * session. See the `urlbar-keyword-exposure` ping for details.
   */
  constexpr impl::EventMetric<KeywordExposureExtra> keyword_exposure(785);

  /**
   * generated from urlbar.pref_max_results
   */
  /**
   * Maximum results to show in the Address Bar. Corresponds to the value of the
     * `browser.urlbar.maxRichResults` pref.
   */
  constexpr impl::QuantityMetric pref_max_results(786);

  /**
   * generated from urlbar.pref_suggest_data_collection
   */
  /**
   * Whether the user has opted in to data collection for Firefox Suggest, i.e.,
     * online suggestions served from Merino. Corresponds to the value of the
     * `browser.urlbar.quicksuggest.dataCollection.enabled` pref.
   */
  constexpr impl::BooleanMetric pref_suggest_data_collection(787);

  /**
   * generated from urlbar.pref_suggest_nonsponsored
   */
  /**
   * Whether non-sponsored quick suggest results are shown in the urlbar.
     * Corresponds to the value of the
     * `browser.urlbar.suggest.quicksuggest.nonsponsored` pref.
   */
  constexpr impl::BooleanMetric pref_suggest_nonsponsored(788);

  /**
   * generated from urlbar.pref_suggest_sponsored
   */
  /**
   * Whether sponsored quick suggest results are shown in the urlbar. Corresponds to
     * the value of the `browser.urlbar.suggest.quicksuggest.sponsored` pref.
   */
  constexpr impl::BooleanMetric pref_suggest_sponsored(789);

  /**
   * generated from urlbar.pref_suggest_topsites
   */
  /**
   * Whether topsite results are enabled in the urlbar. Corresponds to the value of
     * the `browser.urlbar.suggest.topsites` pref.
   */
  constexpr impl::BooleanMetric pref_suggest_topsites(790);

  /**
   * generated from urlbar.quick_suggest_contextual_opt_in
   */
    struct QuickSuggestContextualOptInExtra {
      mozilla::Maybe<nsCString> interaction;
      mozilla::Maybe<bool> sayHello;
      mozilla::Maybe<bool> topPosition;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (interaction) {
          extraKeys.AppendElement()->AssignASCII("interaction");
          extraValues.EmplaceBack(interaction.value());
        }
        if (sayHello) {
          extraKeys.AppendElement()->AssignASCII("say_hello");
          extraValues.AppendElement()->AssignASCII(sayHello.value() ? "true" : "false");
        }
        if (topPosition) {
          extraKeys.AppendElement()->AssignASCII("top_position");
          extraValues.AppendElement()->AssignASCII(topPosition.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the contextual opt-in UI is shown or interacted with.
   */
  constexpr impl::EventMetric<QuickSuggestContextualOptInExtra> quick_suggest_contextual_opt_in(791);

  /**
   * generated from urlbar.quick_suggest_ingest_time
   */
  /**
   * Counts how long each successful ingest takes in the Firefox Suggest Rust
     * component. Ingests that fail for whatever reason are not included.
   */
  constexpr impl::TimingDistributionMetric quick_suggest_ingest_time(792);

  /**
   * generated from urlbar.tips
   */
  /**
   * A keyed uint recording how many times particular tips are shown in the Urlbar
     * and how often their confirm and help buttons are pressed. This metric was
     * generated to correspond to the Legacy Telemetry scalar urlbar.tips.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tips(793);

}
namespace urlbar_impression {
  /**
   * generated from urlbar.impression.autofill_about
   */
  /**
   * Counts how many times about-page type was autofilled per engagement. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.impression.autofill_about.
   */
  constexpr impl::CounterMetric autofill_about(794);

  /**
   * generated from urlbar.impression.autofill_adaptive
   */
  /**
   * Counts how many times adaptive history type was autofilled per engagement. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.impression.autofill_adaptive.
   */
  constexpr impl::CounterMetric autofill_adaptive(795);

  /**
   * generated from urlbar.impression.autofill_origin
   */
  /**
   * Counts how many times origin type was autofilled per engagement. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.impression.autofill_origin.
   */
  constexpr impl::CounterMetric autofill_origin(796);

  /**
   * generated from urlbar.impression.autofill_other
   */
  /**
   * Counts how many times other type was autofilled per engagement. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * urlbar.impression.autofill_other.
   */
  constexpr impl::CounterMetric autofill_other(797);

  /**
   * generated from urlbar.impression.autofill_url
   */
  /**
   * Counts how many times url type was autofilled per engagement. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * urlbar.impression.autofill_url.
   */
  constexpr impl::CounterMetric autofill_url(798);

}
namespace urlbar_persistedsearchterms {
  /**
   * generated from urlbar.persistedsearchterms.revert_by_popup_count
   */
  /**
   * The count of the number of times search terms were removed from the urlbar due
     * to a shown PopupNotification. This event can happen when a user loads a SERP
     * and a PopupNotification is shown, as well as when a user switches away from a
     * tab on a SERP showing a PopupNotification and switches back to it. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.persistedsearchterms.revert_by_popup_count.
   */
  constexpr impl::CounterMetric revert_by_popup_count(799);

  /**
   * generated from urlbar.persistedsearchterms.view_count
   */
  /**
   * The count of the number of times search terms persisted in the Urlbar. This
     * gets recorded after a user loads a SERP that persists search terms, or switches
     * back to an existing tab that should be showing the persisted search terms in
     * the Urlbar, regardless of whether PopupNotification cleared the search terms
     * from the Urlbar. This metric was generated to correspond to the Legacy
     * Telemetry scalar urlbar.persistedsearchterms.view_count.
   */
  constexpr impl::CounterMetric view_count(800);

}
namespace urlbar_picked {
  /**
   * generated from urlbar.picked.autofill_about
   */
  /**
   * Counts how many times an about-page autofill result (e.g., "about:config") was
     * picked at a given index. This metric was generated to correspond to the Legacy
     * Telemetry scalar urlbar.picked.autofill_about.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> autofill_about(801);

  /**
   * generated from urlbar.picked.autofill_adaptive
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.autofill_adaptive.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> autofill_adaptive(802);

  /**
   * generated from urlbar.picked.autofill_origin
   */
  /**
   * Counts how many times an origin (domain) autofill result (e.g., "mozilla.org")
     * was picked at a given index. This metric was generated to correspond to the
     * Legacy Telemetry scalar urlbar.picked.autofill_origin.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> autofill_origin(803);

  /**
   * generated from urlbar.picked.autofill_other
   */
  /**
   * Counts how many times some other type of autofill result that does not have a
     * specific keyed scalar was picked at a given index. This is a fallback that is
     * used when the code is not properly setting a specific autofill type, and it
     * should not normally be used. If it appears in the data, it means we need to
     * investigate and fix the code that is not properly setting a specific autofill
     * type. This metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.autofill_other.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> autofill_other(804);

  /**
   * generated from urlbar.picked.autofill_url
   */
  /**
   * Counts how many times a URL autofill result (e.g., "mozilla.org/firefox") was
     * picked at a given index. This metric was generated to correspond to the Legacy
     * Telemetry scalar urlbar.picked.autofill_url.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> autofill_url(805);

  /**
   * generated from urlbar.picked.bookmark
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.bookmark.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> bookmark(806);

  /**
   * generated from urlbar.picked.bookmark_adaptive
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.bookmark_adaptive.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> bookmark_adaptive(807);

  /**
   * generated from urlbar.picked.clipboard
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.clipboard.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> clipboard(808);

  /**
   * generated from urlbar.picked.dynamic
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.dynamic.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> dynamic(809);

  /**
   * generated from urlbar.picked.dynamic_wikipedia
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.dynamic_wikipedia.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> dynamic_wikipedia(810);

  /**
   * generated from urlbar.picked.extension
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.extension.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> extension(811);

  /**
   * generated from urlbar.picked.formhistory
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.formhistory.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> formhistory(812);

  /**
   * generated from urlbar.picked.history
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.history.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> history(813);

  /**
   * generated from urlbar.picked.history_adaptive
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.history_adaptive.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> history_adaptive(814);

  /**
   * generated from urlbar.picked.keyword
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.keyword.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> keyword(815);

  /**
   * generated from urlbar.picked.navigational
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.navigational.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> navigational(816);

  /**
   * generated from urlbar.picked.quickaction
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.quickaction.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> quickaction(817);

  /**
   * generated from urlbar.picked.quicksuggest
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.quicksuggest.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> quicksuggest(818);

  /**
   * generated from urlbar.picked.recent_search
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.recent_search.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> recent_search(819);

  /**
   * generated from urlbar.picked.remotetab
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.remotetab.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> remotetab(820);

  /**
   * generated from urlbar.picked.restrict_keyword_actions
   */
  /**
   * Counts how many times this restrict actions result was picked at a given index.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.restrict_keyword_actions.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> restrict_keyword_actions(821);

  /**
   * generated from urlbar.picked.restrict_keyword_bookmarks
   */
  /**
   * Counts how many times this restrict bookmarks result was picked at a given
     * index. This metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.restrict_keyword_bookmarks.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> restrict_keyword_bookmarks(822);

  /**
   * generated from urlbar.picked.restrict_keyword_history
   */
  /**
   * Counts how many times this restrict history result was picked at a given index.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.restrict_keyword_history.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> restrict_keyword_history(823);

  /**
   * generated from urlbar.picked.restrict_keyword_tabs
   */
  /**
   * Counts how many times this restrict tabs result was picked at a given index.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.restrict_keyword_tabs.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> restrict_keyword_tabs(824);

  /**
   * generated from urlbar.picked.searchengine
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.searchengine.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> searchengine(825);

  /**
   * generated from urlbar.picked.searchsuggestion
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.searchsuggestion.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> searchsuggestion(826);

  /**
   * generated from urlbar.picked.searchsuggestion_rich
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.searchsuggestion_rich.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> searchsuggestion_rich(827);

  /**
   * generated from urlbar.picked.switchtab
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.switchtab.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> switchtab(828);

  /**
   * generated from urlbar.picked.tabtosearch
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.tabtosearch.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabtosearch(829);

  /**
   * generated from urlbar.picked.tip
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar urlbar.picked.tip.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tip(830);

  /**
   * generated from urlbar.picked.topsite
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.topsite.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> topsite(831);

  /**
   * generated from urlbar.picked.trending
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.trending.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> trending(832);

  /**
   * generated from urlbar.picked.trending_rich
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.trending_rich.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> trending_rich(833);

  /**
   * generated from urlbar.picked.unknown
   */
  /**
   * Counts how many times an unknown result type was picked at a given index. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.unknown.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> unknown(834);

  /**
   * generated from urlbar.picked.visiturl
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.visiturl.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> visiturl(835);

  /**
   * generated from urlbar.picked.weather
   */
  /**
   * Counts how many times this result type was picked at a given index. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.weather.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> weather(836);

}
namespace urlbar_picked_searchmode {
  /**
   * generated from urlbar.picked.searchmode.bookmarkmenu
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode from the Search
     * Bookmarks menu item in the Library menu. This metric was generated to
     * correspond to the Legacy Telemetry scalar
     * urlbar.picked.searchmode.bookmarkmenu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> bookmarkmenu(837);

  /**
   * generated from urlbar.picked.searchmode.handoff
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode by being handed off from
     * the search bar on the new tab page. This metric was generated to correspond to
     * the Legacy Telemetry scalar urlbar.picked.searchmode.handoff.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> handoff(838);

  /**
   * generated from urlbar.picked.searchmode.historymenu
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode from the Search History
     * menu item in a History menu. This metric was generated to correspond to the
     * Legacy Telemetry scalar urlbar.picked.searchmode.historymenu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> historymenu(839);

  /**
   * generated from urlbar.picked.searchmode.keywordoffer
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode by selecting a keyword
     * offer result. This metric was generated to correspond to the Legacy Telemetry
     * scalar urlbar.picked.searchmode.keywordoffer.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> keywordoffer(840);

  /**
   * generated from urlbar.picked.searchmode.oneoff
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode by selecting a one-off.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.searchmode.oneoff.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> oneoff(841);

  /**
   * generated from urlbar.picked.searchmode.other
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode from an unknown entry
     * point. If values appear for this probe in Telemetry, we should review the entry
     * points to search mode. This metric was generated to correspond to the Legacy
     * Telemetry scalar urlbar.picked.searchmode.other.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> other(842);

  /**
   * generated from urlbar.picked.searchmode.searchbutton
   */
  /**
   * A keyed uint recording how many times the user entered a particular search mode
     * by unified search button. This metric was generated to correspond to the Legacy
     * Telemetry scalar urlbar.picked.searchmode.searchbutton.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> searchbutton(843);

  /**
   * generated from urlbar.picked.searchmode.shortcut
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode by pressing a keyboard
     * shortcut. This metric was generated to correspond to the Legacy Telemetry
     * scalar urlbar.picked.searchmode.shortcut.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> shortcut(844);

  /**
   * generated from urlbar.picked.searchmode.tabmenu
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode by selecting the Search
     * Tabs menu item in the Tab Overflow menu. This metric was generated to
     * correspond to the Legacy Telemetry scalar urlbar.picked.searchmode.tabmenu.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabmenu(845);

  /**
   * generated from urlbar.picked.searchmode.tabtosearch
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode by selecting a tab-to-
     * search result. This metric was generated to correspond to the Legacy Telemetry
     * scalar urlbar.picked.searchmode.tabtosearch.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabtosearch(846);

  /**
   * generated from urlbar.picked.searchmode.tabtosearch_onboard
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode by selecting a tab-to-
     * search onboarding result. This metric was generated to correspond to the Legacy
     * Telemetry scalar urlbar.picked.searchmode.tabtosearch_onboard.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabtosearch_onboard(847);

  /**
   * generated from urlbar.picked.searchmode.topsites_newtab
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode by selecting a search
     * shortcut Top Site on the New Tab Page. This metric was generated to correspond
     * to the Legacy Telemetry scalar urlbar.picked.searchmode.topsites_newtab.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> topsites_newtab(848);

  /**
   * generated from urlbar.picked.searchmode.topsites_urlbar
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode by selecting a search
     * shortcut Top Site in the Urlbar. This metric was generated to correspond to the
     * Legacy Telemetry scalar urlbar.picked.searchmode.topsites_urlbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> topsites_urlbar(849);

  /**
   * generated from urlbar.picked.searchmode.touchbar
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode by selecting a search
     * shortcut on the macOS Touch Bar. This metric was generated to correspond to the
     * Legacy Telemetry scalar urlbar.picked.searchmode.touchbar.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> touchbar(850);

  /**
   * generated from urlbar.picked.searchmode.typed
   */
  /**
   * A keyed uint recording how many times the user picked a particular kind of
     * result while in search mode after entering search mode by typing an alias. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.picked.searchmode.typed.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> typed(851);

}
namespace urlbar_quickaction {
  /**
   * generated from urlbar.quickaction.picked
   */
  /**
   * Counts how many times quickaction results were selected. The key is the in the
     * form "actionkey-N" where N is the number of characters the user typed to be
     * shown the action. This metric was generated to correspond to the Legacy
     * Telemetry scalar quickaction.picked.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> picked(852);

}
namespace urlbar_tabtosearch {
  /**
   * generated from urlbar.tabtosearch.impressions
   */
  /**
   * A keyed uint recording how many times non-onboarding tab-to-search results are
     * shown in the Urlbar for a particular search engine. This metric was generated
     * to correspond to the Legacy Telemetry scalar urlbar.tabtosearch.impressions.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> impressions(853);

  /**
   * generated from urlbar.tabtosearch.impressions_onboarding
   */
  /**
   * A keyed uint recording how many times onboarding tab-to-search results are
     * shown in the Urlbar for a particular search engine. This metric was generated
     * to correspond to the Legacy Telemetry scalar
     * urlbar.tabtosearch.impressions_onboarding.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> impressions_onboarding(854);

}
namespace urlbar_trending {
  /**
   * generated from urlbar.trending.block
   */
  /**
   * User has blocked seeing trending results. This metric was generated to
     * correspond to the Legacy Telemetry scalar urlbar.trending.block.
   */
  constexpr impl::CounterMetric block(855);

}
namespace urlbar_unifiedsearchbutton {
  /**
   * generated from urlbar.unifiedsearchbutton.opened
   */
  /**
   * Counts how many times Unified Search Button popup is opened. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * urlbar.unifiedsearchbutton.opened.
   */
  constexpr impl::CounterMetric opened(856);

  /**
   * generated from urlbar.unifiedsearchbutton.picked
   */
  /**
   * Counts how many times Unified Search Button items were selected. The key is
     * followings. * builtin_search: Builtin search engine. * addon_search: Addon
     * search engine. * local_search: Local search engine such as Bookmarks. *
     * settings: Settings menu. This metric was generated to correspond to the Legacy
     * Telemetry scalar urlbar.unifiedsearchbutton.picked.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> picked(857);

}
namespace urlbar_zeroprefix {
  /**
   * generated from urlbar.zeroprefix.abandonment
   */
  /**
   * Counts how many times the zero-prefix urlbar results panel was abandoned. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.zeroprefix.abandonment.
   */
  constexpr impl::CounterMetric abandonment(858);

  /**
   * generated from urlbar.zeroprefix.engagement
   */
  /**
   * Counts how many times a result was picked in the zero-prefix urlbar results
     * panel. This metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.zeroprefix.engagement.
   */
  constexpr impl::CounterMetric engagement(859);

  /**
   * generated from urlbar.zeroprefix.exposure
   */
  /**
   * Counts how many times the zero-prefix urlbar results panel was shown to the
     * user. This metric was generated to correspond to the Legacy Telemetry scalar
     * urlbar.zeroprefix.exposure.
   */
  constexpr impl::CounterMetric exposure(860);

}
namespace addons_search_detection {
  /**
   * generated from addons.search_detection.etld_change_other
   */
    struct EtldChangeOtherExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> from;
      mozilla::Maybe<nsCString> to;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (from) {
          extraKeys.AppendElement()->AssignASCII("from");
          extraValues.EmplaceBack(from.value());
        }
        if (to) {
          extraKeys.AppendElement()->AssignASCII("to");
          extraValues.EmplaceBack(to.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a request for a search query is redirected to another
     * domain via something other than the `webRequest` API.
     * This event was generated to correspond to the Legacy Telemetry event
     * addonsSearchDetection.etld_change#other.
   */
  constexpr impl::EventMetric<EtldChangeOtherExtra> etld_change_other(861);

  /**
   * generated from addons.search_detection.etld_change_webrequest
   */
    struct EtldChangeWebrequestExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> from;
      mozilla::Maybe<nsCString> to;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (from) {
          extraKeys.AppendElement()->AssignASCII("from");
          extraValues.EmplaceBack(from.value());
        }
        if (to) {
          extraKeys.AppendElement()->AssignASCII("to");
          extraValues.EmplaceBack(to.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a request for a search query is redirected to another
     * domain via the `webRequest` API.
     * This event was generated to correspond to the Legacy Telemetry event
     * addonsSearchDetection.etld_change#webrequest.
   */
  constexpr impl::EventMetric<EtldChangeWebrequestExtra> etld_change_webrequest(862);

}
namespace browser_ui {
  /**
   * generated from browser.ui.customized_widgets
   */
  /**
   * Records when widgets are added, removed or moved in the UI. See
     * https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * browser.ui.customized_widgets.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> customized_widgets(863);

  /**
   * generated from browser.ui.mirror_for_toolbar_widgets
   */
  /**
   * The widgets in the toolbars. See https://firefox-source-
     * docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated
     * to correspond to the Legacy Telemetry scalar browser.ui.toolbar_widgets.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> mirror_for_toolbar_widgets(864);


}
namespace browser_usage {
  /**
   * generated from browser.usage.interaction
   */
    struct InteractionExtra {
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> widgetId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (widgetId) {
          extraKeys.AppendElement()->AssignASCII("widget_id");
          extraValues.EmplaceBack(widgetId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user interacted with something in the Firefox Desktop frontend. Could be
     * via mouse or keyboard, could be a command or a UI element.
   */
  constexpr impl::EventMetric<InteractionExtra> interaction(866);

}
namespace homepage {
  /**
   * generated from homepage.preference_ignore
   */
    struct PreferenceIgnoreExtra {
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> webextensionid;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (webextensionid) {
          extraKeys.AppendElement()->AssignASCII("webExtensionId");
          extraValues.EmplaceBack(webextensionid.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded whenever the homepage preference is either reset due to being
     * on the ignore list, or setting is blocked due to being on the same list. The
     * value field records the reason for the ignore. "saved_reset" for when a saved
     * preference value is reset. "set_blocked" for when the setting was blocked and
     * "set_blocked_extension" for when we know a WebExtension attempting to set it
     * was blocked. This event was generated to correspond to the Legacy Telemetry
     * event homepage.preference#ignore.
   */
  constexpr impl::EventMetric<PreferenceIgnoreExtra> preference_ignore(867);

}
namespace installation {
  /**
   * generated from installation.first_seen_full
   */
    struct FirstSeenFullExtra {
      mozilla::Maybe<nsCString> adminUser;
      mozilla::Maybe<nsCString> buildId;
      mozilla::Maybe<nsCString> defaultPath;
      mozilla::Maybe<nsCString> fromMsi;
      mozilla::Maybe<nsCString> installExisted;
      mozilla::Maybe<nsCString> otherInst;
      mozilla::Maybe<nsCString> otherMsixInst;
      mozilla::Maybe<nsCString> profdirExisted;
      mozilla::Maybe<nsCString> silent;
      mozilla::Maybe<nsCString> version;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (adminUser) {
          extraKeys.AppendElement()->AssignASCII("admin_user");
          extraValues.EmplaceBack(adminUser.value());
        }
        if (buildId) {
          extraKeys.AppendElement()->AssignASCII("build_id");
          extraValues.EmplaceBack(buildId.value());
        }
        if (defaultPath) {
          extraKeys.AppendElement()->AssignASCII("default_path");
          extraValues.EmplaceBack(defaultPath.value());
        }
        if (fromMsi) {
          extraKeys.AppendElement()->AssignASCII("from_msi");
          extraValues.EmplaceBack(fromMsi.value());
        }
        if (installExisted) {
          extraKeys.AppendElement()->AssignASCII("install_existed");
          extraValues.EmplaceBack(installExisted.value());
        }
        if (otherInst) {
          extraKeys.AppendElement()->AssignASCII("other_inst");
          extraValues.EmplaceBack(otherInst.value());
        }
        if (otherMsixInst) {
          extraKeys.AppendElement()->AssignASCII("other_msix_inst");
          extraValues.EmplaceBack(otherMsixInst.value());
        }
        if (profdirExisted) {
          extraKeys.AppendElement()->AssignASCII("profdir_existed");
          extraValues.EmplaceBack(profdirExisted.value());
        }
        if (silent) {
          extraKeys.AppendElement()->AssignASCII("silent");
          extraValues.EmplaceBack(silent.value());
        }
        if (version) {
          extraKeys.AppendElement()->AssignASCII("version");
          extraValues.EmplaceBack(version.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded after the application has been installed or reinstalled, the first
     * time that a profile sees that there was a new installation. This includes
     * information about how the installer was run. This event was generated to
     * correspond to the Legacy Telemetry event installation.first_seen#full.
   */
  constexpr impl::EventMetric<FirstSeenFullExtra> first_seen_full(868);

  /**
   * generated from installation.first_seen_msix
   */
    struct FirstSeenMsixExtra {
      mozilla::Maybe<nsCString> adminUser;
      mozilla::Maybe<nsCString> buildId;
      mozilla::Maybe<nsCString> defaultPath;
      mozilla::Maybe<nsCString> fromMsi;
      mozilla::Maybe<nsCString> installExisted;
      mozilla::Maybe<nsCString> otherInst;
      mozilla::Maybe<nsCString> otherMsixInst;
      mozilla::Maybe<nsCString> profdirExisted;
      mozilla::Maybe<nsCString> silent;
      mozilla::Maybe<nsCString> version;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (adminUser) {
          extraKeys.AppendElement()->AssignASCII("admin_user");
          extraValues.EmplaceBack(adminUser.value());
        }
        if (buildId) {
          extraKeys.AppendElement()->AssignASCII("build_id");
          extraValues.EmplaceBack(buildId.value());
        }
        if (defaultPath) {
          extraKeys.AppendElement()->AssignASCII("default_path");
          extraValues.EmplaceBack(defaultPath.value());
        }
        if (fromMsi) {
          extraKeys.AppendElement()->AssignASCII("from_msi");
          extraValues.EmplaceBack(fromMsi.value());
        }
        if (installExisted) {
          extraKeys.AppendElement()->AssignASCII("install_existed");
          extraValues.EmplaceBack(installExisted.value());
        }
        if (otherInst) {
          extraKeys.AppendElement()->AssignASCII("other_inst");
          extraValues.EmplaceBack(otherInst.value());
        }
        if (otherMsixInst) {
          extraKeys.AppendElement()->AssignASCII("other_msix_inst");
          extraValues.EmplaceBack(otherMsixInst.value());
        }
        if (profdirExisted) {
          extraKeys.AppendElement()->AssignASCII("profdir_existed");
          extraValues.EmplaceBack(profdirExisted.value());
        }
        if (silent) {
          extraKeys.AppendElement()->AssignASCII("silent");
          extraValues.EmplaceBack(silent.value());
        }
        if (version) {
          extraKeys.AppendElement()->AssignASCII("version");
          extraValues.EmplaceBack(version.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded after the application has been installed or reinstalled, the first
     * time that a profile sees that there was a new installation. This includes
     * information about how the installer was run. This event was generated to
     * correspond to the Legacy Telemetry event installation.first_seen#msix.
   */
  constexpr impl::EventMetric<FirstSeenMsixExtra> first_seen_msix(869);

  /**
   * generated from installation.first_seen_stub
   */
    struct FirstSeenStubExtra {
      mozilla::Maybe<nsCString> adminUser;
      mozilla::Maybe<nsCString> buildId;
      mozilla::Maybe<nsCString> defaultPath;
      mozilla::Maybe<nsCString> fromMsi;
      mozilla::Maybe<nsCString> installExisted;
      mozilla::Maybe<nsCString> otherInst;
      mozilla::Maybe<nsCString> otherMsixInst;
      mozilla::Maybe<nsCString> profdirExisted;
      mozilla::Maybe<nsCString> silent;
      mozilla::Maybe<nsCString> version;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (adminUser) {
          extraKeys.AppendElement()->AssignASCII("admin_user");
          extraValues.EmplaceBack(adminUser.value());
        }
        if (buildId) {
          extraKeys.AppendElement()->AssignASCII("build_id");
          extraValues.EmplaceBack(buildId.value());
        }
        if (defaultPath) {
          extraKeys.AppendElement()->AssignASCII("default_path");
          extraValues.EmplaceBack(defaultPath.value());
        }
        if (fromMsi) {
          extraKeys.AppendElement()->AssignASCII("from_msi");
          extraValues.EmplaceBack(fromMsi.value());
        }
        if (installExisted) {
          extraKeys.AppendElement()->AssignASCII("install_existed");
          extraValues.EmplaceBack(installExisted.value());
        }
        if (otherInst) {
          extraKeys.AppendElement()->AssignASCII("other_inst");
          extraValues.EmplaceBack(otherInst.value());
        }
        if (otherMsixInst) {
          extraKeys.AppendElement()->AssignASCII("other_msix_inst");
          extraValues.EmplaceBack(otherMsixInst.value());
        }
        if (profdirExisted) {
          extraKeys.AppendElement()->AssignASCII("profdir_existed");
          extraValues.EmplaceBack(profdirExisted.value());
        }
        if (silent) {
          extraKeys.AppendElement()->AssignASCII("silent");
          extraValues.EmplaceBack(silent.value());
        }
        if (version) {
          extraKeys.AppendElement()->AssignASCII("version");
          extraValues.EmplaceBack(version.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded after the application has been installed or reinstalled, the first
     * time that a profile sees that there was a new installation. This includes
     * information about how the installer was run. This event was generated to
     * correspond to the Legacy Telemetry event installation.first_seen#stub.
   */
  constexpr impl::EventMetric<FirstSeenStubExtra> first_seen_stub(870);

}
namespace installation_first_seen {
  /**
   * generated from installation.first_seen.admin_user
   */
  /**
   * Whether the installer is running from an elevated admin user
   */
  constexpr impl::BooleanMetric admin_user(871);

  /**
   * generated from installation.first_seen.default_path
   */
  /**
   * (optional, present if installer_type is "full") Whether the default path was
     * used
   */
  constexpr impl::BooleanMetric default_path(872);

  /**
   * generated from installation.first_seen.failure_reason
   */
  /**
   * Only sent if unable to collect firstSeen data. Can have value "NotFoundError"
     * if file not found or other values depending on the failure reason.
   */
  constexpr impl::StringMetric failure_reason(873);

  /**
   * generated from installation.first_seen.from_msi
   */
  /**
   * (optional, present if installer_type is "full") Whether this was an MSI install
   */
  constexpr impl::BooleanMetric from_msi(874);

  /**
   * generated from installation.first_seen.install_existed
   */
  /**
   * Whether there was already an install in this location
   */
  constexpr impl::BooleanMetric install_existed(875);

  /**
   * generated from installation.first_seen.installer_type
   */
  /**
   * The type of installer used to install Firefox. The value is one of "stub",
     * "full", or "msix"
   */
  constexpr impl::StringMetric installer_type(876);

  /**
   * generated from installation.first_seen.other_inst
   */
  /**
   * Whether there was already any non-MSIX install on this system
   */
  constexpr impl::BooleanMetric other_inst(877);

  /**
   * generated from installation.first_seen.other_msix_inst
   */
  /**
   * Whether there was already any MSIX install on this system
   */
  constexpr impl::BooleanMetric other_msix_inst(878);

  /**
   * generated from installation.first_seen.profdir_existed
   */
  /**
   * Whether the top-level profile directory existed
   */
  constexpr impl::BooleanMetric profdir_existed(879);

  /**
   * generated from installation.first_seen.silent
   */
  /**
   * (optional, present if installer_type is "full") Whether this was a silent
     * install
   */
  constexpr impl::BooleanMetric silent(880);

  /**
   * generated from installation.first_seen.version
   */
  /**
   * The application version installed by the installer (not necessarily the current
     * version)
   */
  constexpr impl::StringMetric version(881);

}
namespace partner_link {
  /**
   * generated from partner_link.attribution_abort
   */
    struct AttributionAbortExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded when sending an attribution request for a partner link. The
     * value is the partner. This event was generated to correspond to the Legacy
     * Telemetry event partner_link.attribution#abort.
   */
  constexpr impl::EventMetric<AttributionAbortExtra> attribution_abort(882);

  /**
   * generated from partner_link.attribution_failure
   */
    struct AttributionFailureExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded when sending an attribution request for a partner link. The
     * value is the partner. This event was generated to correspond to the Legacy
     * Telemetry event partner_link.attribution#failure.
   */
  constexpr impl::EventMetric<AttributionFailureExtra> attribution_failure(883);

  /**
   * generated from partner_link.attribution_success
   */
    struct AttributionSuccessExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded when sending an attribution request for a partner link. The
     * value is the partner. This event was generated to correspond to the Legacy
     * Telemetry event partner_link.attribution#success.
   */
  constexpr impl::EventMetric<AttributionSuccessExtra> attribution_success(884);

  /**
   * generated from partner_link.click_newtab
   */
    struct ClickNewtabExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded when clicking a partner link. The value is the partner. This
     * event was generated to correspond to the Legacy Telemetry event
     * partner_link.click#newtab.
   */
  constexpr impl::EventMetric<ClickNewtabExtra> click_newtab(885);

  /**
   * generated from partner_link.click_urlbar
   */
    struct ClickUrlbarExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded when clicking a partner link. The value is the partner. This
     * event was generated to correspond to the Legacy Telemetry event
     * partner_link.click#urlbar.
   */
  constexpr impl::EventMetric<ClickUrlbarExtra> click_urlbar(886);

}
namespace performance_interaction {
  /**
   * generated from performance.interaction.tab_switch_composite
   */
  /**
   * Time between tab selection and first composite of the tab content onto the
     * screen. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric tab_switch_composite(887);

  /**
   * generated from performance.interaction.keypress_present_latency
   */
  /**
   * Time between receiving a keypress event in the event loop and compositing its
     * result onto the screen. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric keypress_present_latency(888);

  /**
   * generated from performance.interaction.mouseup_click_present_latency
   */
  /**
   * Time between receiving a mouseup which follow by a mouseclick on the event loop
     * and compositing its result onto the screen. (Migrated from the geckoview metric
     * of the same name).
   */
  constexpr impl::TimingDistributionMetric mouseup_click_present_latency(889);

}
namespace timestamps {
  /**
   * generated from timestamps.about_home_topsites_first_paint
   */
  /**
   * Record the timestamp of when the first about:home's Topsites are painted. Only
     * records if about:home is set as the default homepage, and if sessions are not
     * being restored by default. This metric was generated to correspond to the
     * Legacy Telemetry scalar timestamps.about_home_topsites_first_paint.
   */
  constexpr impl::QuantityMetric about_home_topsites_first_paint(890);

  /**
   * generated from timestamps.first_paint
   */
  /**
   * Record the timestamp of the first content window paint, in milliseconds since
     * process start. This metric was generated to correspond to the Legacy Telemetry
     * scalar timestamps.first_paint.
   */
  constexpr impl::QuantityMetric first_paint(891);

  /**
   * generated from timestamps.first_paint_two
   */
  /**
   * Record the timestamp of the first main window paint, in milliseconds since
     * process start. Intended to replace first_paint since first_paint is broken.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * timestamps.first_paint_two.
   */
  constexpr impl::QuantityMetric first_paint_two(892);

}
namespace devtools_accessibility {
  /**
   * generated from devtools.accessibility.accessible_context_menu_item_activated
   */
  /**
   * Number of times a context menu item for an accessible object was activated
     * (with mouse or keyboard) from the context menu opened in the accessibility
     * tree. Keyed by the id of the context menu item. This metric was generated to
     * correspond to the Legacy Telemetry scalar
     * devtools.accessibility.accessible_context_menu_item_activated.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> accessible_context_menu_item_activated(893);

  /**
   * generated from devtools.accessibility.accessible_context_menu_opened
   */
  /**
   * Number of times a context menu was opened for an accessible object in the
     * accessibility tree. This metric was generated to correspond to the Legacy
     * Telemetry scalar devtools.accessibility.accessible_context_menu_opened.
   */
  constexpr impl::CounterMetric accessible_context_menu_opened(894);

  /**
   * generated from devtools.accessibility.audit_activated
   */
  /**
   * Number of times accessibility audit was activated (with mouse or keyboard) from
     * the accessibility panel's toolbar. Keyed by the audit filter type (e.g.
     * "CONTRAST"). This metric was generated to correspond to the Legacy Telemetry
     * scalar devtools.accessibility.audit_activated.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> audit_activated(895);

  /**
   * generated from devtools.accessibility.node_inspected_count
   */
  /**
   * Number of times a DOM node was inspected from within the Accessibility tool.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.accessibility.node_inspected_count.
   */
  constexpr impl::CounterMetric node_inspected_count(896);

  /**
   * generated from devtools.accessibility.select_accessible_for_node
   */
  /**
   * Number of times an accessible object was inspected from outside the
     * Accessibility tool (navigation to Accessibility panel). Keyed by the source of
     * user action (inspector context menu, browser context menu, etc). This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * devtools.accessibility.select_accessible_for_node.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> select_accessible_for_node(897);

  /**
   * generated from devtools.accessibility.simulation_activated
   */
  /**
   * Number of times accessibility simulation was activated (with mouse or keyboard)
     * from the accessibility panel's toolbar. Keyed by the simulation type (e.g.
     * "DEUTERANOPIA"). This metric was generated to correspond to the Legacy
     * Telemetry scalar devtools.accessibility.simulation_activated.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> simulation_activated(898);

  /**
   * generated from devtools.accessibility.opened_count
   */
  /**
   * Number of times the DevTools Accessibility tool has been opened. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * devtools.accessibility.opened_count.
   */
  constexpr impl::CounterMetric opened_count(899);

  /**
   * generated from devtools.accessibility.picker_used_count
   */
  /**
   * Number of times the picker tool has been used in DevTools Accessibility panel.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.accessibility.picker_used_count.
   */
  constexpr impl::CounterMetric picker_used_count(900);

}
namespace devtools {
  /**
   * generated from devtools.current_theme
   */
  /**
   * Number of times DevTools was opened, keyed by theme. This metric was generated
     * to correspond to the Legacy Telemetry scalar devtools.current_theme.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> current_theme(901);

}
namespace devtools_tool {
  /**
   * generated from devtools.tool.registered
   */
  /**
   * Recorded on enable tool checkbox check/uncheck in Developer Tools options
     * panel. Boolean stating if the tool was enabled or disabled by the user. Keyed
     * by tool id. Current default tools with their id's are defined in
     * https://searchfox.org/mozilla- central/source/devtools/client/definitions.js
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.tool.registered.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> registered(902);

}
namespace devtools_toolbox {
  /**
   * generated from devtools.toolbox.tabs_reordered
   */
  /**
   * Number of times the DevTools tab was reordered. Keyed by tab's id. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * devtools.toolbox.tabs_reordered.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> tabs_reordered(903);

}
namespace devtools_grid_gridinspector {
  /**
   * generated from devtools.grid.gridinspector.opened
   */
  /**
   * Number of times the DevTools grid inspector was opened from the grid view. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.grid.gridinspector.opened.
   */
  constexpr impl::CounterMetric opened(904);

}
namespace devtools_inspector {
  /**
   * generated from devtools.inspector.node_selection_count
   */
  /**
   * Number of times a different node is marked as selected in the Inspector
     * regardless of the cause: context menu, manual selection in markup view, etc.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.inspector.node_selection_count.
   */
  constexpr impl::CounterMetric node_selection_count(905);

  /**
   * generated from devtools.inspector.three_pane_enabled
   */
  /**
   * Number of times the DevTools inspector was opened with the 3 pane inspector
     * enabled, keyed by true/false. This metric was generated to correspond to the
     * Legacy Telemetry scalar devtools.inspector.three_pane_enabled.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> three_pane_enabled(906);

}
namespace devtools_layout_flexboxhighlighter {
  /**
   * generated from devtools.layout.flexboxhighlighter.opened
   */
  /**
   * Number of times the DevTools flexbox highlighter was activated from the layout
     * view. This metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.layout.flexboxhighlighter.opened.
   */
  constexpr impl::CounterMetric opened(907);

}
namespace devtools_markup_flexboxhighlighter {
  /**
   * generated from devtools.markup.flexboxhighlighter.opened
   */
  /**
   * Number of times the DevTools flexbox highlighter was activated from the markup
     * view. This metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.markup.flexboxhighlighter.opened.
   */
  constexpr impl::CounterMetric opened(908);

}
namespace devtools_markup_gridinspector {
  /**
   * generated from devtools.markup.gridinspector.opened
   */
  /**
   * Number of times the DevTools grid inspector was opened from the markup view.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.markup.gridinspector.opened.
   */
  constexpr impl::CounterMetric opened(909);

}
namespace devtools_markup_scrollable_badge {
  /**
   * generated from devtools.markup.scrollable.badge.clicked
   */
  /**
   * Number of times the scrollable inspector badge has been clicked. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * devtools.markup.scrollable.badge.clicked.
   */
  constexpr impl::CounterMetric clicked(910);

}
namespace devtools_rules_flexboxhighlighter {
  /**
   * generated from devtools.rules.flexboxhighlighter.opened
   */
  /**
   * Number of times the DevTools flexbox highlighter was activated from the rules
     * view. This metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.rules.flexboxhighlighter.opened.
   */
  constexpr impl::CounterMetric opened(911);

}
namespace devtools_rules_gridinspector {
  /**
   * generated from devtools.rules.gridinspector.opened
   */
  /**
   * Number of times the DevTools grid inspector was opened from the rules view.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.rules.gridinspector.opened.
   */
  constexpr impl::CounterMetric opened(912);

}
namespace devtools_shadowdom {
  /**
   * generated from devtools.shadowdom.reveal_link_clicked
   */
  /**
   * Whether the user clicked on any "reveal" link. "reveal" links are displayed in
     * shadow dom trees in the markup view. This metric was generated to correspond to
     * the Legacy Telemetry scalar devtools.shadowdom.reveal_link_clicked.
   */
  constexpr impl::BooleanMetric reveal_link_clicked(913);

  /**
   * generated from devtools.shadowdom.shadow_root_displayed
   */
  /**
   * Whether the markup view displayed any #shadow-root element in the UI. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.shadowdom.shadow_root_displayed.
   */
  constexpr impl::BooleanMetric shadow_root_displayed(914);

  /**
   * generated from devtools.shadowdom.shadow_root_expanded
   */
  /**
   * Whether the user expanded any #shadow-root element. This metric was generated
     * to correspond to the Legacy Telemetry scalar
     * devtools.shadowdom.shadow_root_expanded.
   */
  constexpr impl::BooleanMetric shadow_root_expanded(915);

}
namespace devtools_tooltip {
  /**
   * generated from devtools.tooltip.shown
   */
  /**
   * Number of times a tooltip was shown, keyed by tooltip type. Currently supported
     * types are "image", "font-family", "inactive- css", "css-compatibility", "css-
     * query-container" and "variable." This metric was generated to correspond to the
     * Legacy Telemetry scalar devtools.tooltip.shown.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> shown(916);

}
namespace devtools_responsive {
  /**
   * generated from devtools.responsive.open_trigger
   */
  /**
   * Number of Responsive Design Mode opens keyed by the UI entry point used. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * devtools.responsive.open_trigger.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> open_trigger(917);

  /**
   * generated from devtools.responsive.toolbox_opened_first
   */
  /**
   * Number of Responsive Design Mode opens with a toolbox already open. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * devtools.responsive.toolbox_opened_first.
   */
  constexpr impl::CounterMetric toolbox_opened_first(918);

}
namespace devtools_changesview {
  /**
   * generated from devtools.changesview.opened_count
   */
  /**
   * Number of times the Changes panel has been opened. This metric was generated to
     * correspond to the Legacy Telemetry scalar devtools.changesview.opened_count.
   */
  constexpr impl::CounterMetric opened_count(919);

}
namespace devtools_main {
  /**
   * generated from devtools.main.activate_responsive_design
   */
    struct ActivateResponsiveDesignExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User activates the responsive_design or split_console in the devtools toolbox.
     * This event was generated to correspond to the Legacy Telemetry event
     * devtools.main.activate#responsive_design.
   */
  constexpr impl::EventMetric<ActivateResponsiveDesignExtra> activate_responsive_design(920);

  /**
   * generated from devtools.main.activate_split_console
   */
    struct ActivateSplitConsoleExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User activates the responsive_design or split_console in the devtools toolbox.
     * This event was generated to correspond to the Legacy Telemetry event
     * devtools.main.activate#split_console.
   */
  constexpr impl::EventMetric<ActivateSplitConsoleExtra> activate_split_console(921);

  /**
   * generated from devtools.main.add_breakpoint_debugger
   */
    struct AddBreakpointDebuggerExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has added a breakpoint to a script. This event was generated to correspond
     * to the Legacy Telemetry event devtools.main.add_breakpoint#debugger.
   */
  constexpr impl::EventMetric<AddBreakpointDebuggerExtra> add_breakpoint_debugger(922);

  /**
   * generated from devtools.main.blackbox_debugger
   */
    struct BlackboxDebuggerExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User clicked the blackbox button to blackbox a script. This event was generated
     * to correspond to the Legacy Telemetry event devtools.main.blackbox#debugger.
   */
  constexpr impl::EventMetric<BlackboxDebuggerExtra> blackbox_debugger(923);

  /**
   * generated from devtools.main.close_adbg_aboutdebugging
   */
    struct CloseAdbgAboutdebuggingExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes about:debugging. This event was generated to correspond to the
     * Legacy Telemetry event devtools.main.close_adbg#aboutdebugging.
   */
  constexpr impl::EventMetric<CloseAdbgAboutdebuggingExtra> close_adbg_aboutdebugging(924);

  /**
   * generated from devtools.main.close_tools
   */
    struct CloseToolsExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes devtools toolbox. This event was generated to correspond to the
     * Legacy Telemetry event devtools.main.close#tools.
   */
  constexpr impl::EventMetric<CloseToolsExtra> close_tools(925);

  /**
   * generated from devtools.main.connection_attempt_aboutdebugging
   */
    struct ConnectionAttemptAboutdebuggingExtra {
      mozilla::Maybe<nsCString> connectionId;
      mozilla::Maybe<nsCString> connectionType;
      mozilla::Maybe<nsCString> runtimeId;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (connectionId) {
          extraKeys.AppendElement()->AssignASCII("connection_id");
          extraValues.EmplaceBack(connectionId.value());
        }
        if (connectionType) {
          extraKeys.AppendElement()->AssignASCII("connection_type");
          extraValues.EmplaceBack(connectionType.value());
        }
        if (runtimeId) {
          extraKeys.AppendElement()->AssignASCII("runtime_id");
          extraValues.EmplaceBack(runtimeId.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User is trying to connect to a remote runtime. This event was generated to
     * correspond to the Legacy Telemetry event
     * devtools.main.connection_attempt#aboutdebugging.
   */
  constexpr impl::EventMetric<ConnectionAttemptAboutdebuggingExtra> connection_attempt_aboutdebugging(926);

  /**
   * generated from devtools.main.continue_debugger
   */
    struct ContinueDebuggerExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has pressed the continue button on a paused script. This event was
     * generated to correspond to the Legacy Telemetry event
     * devtools.main.continue#debugger.
   */
  constexpr impl::EventMetric<ContinueDebuggerExtra> continue_debugger(927);

  /**
   * generated from devtools.main.deactivate_responsive_design
   */
    struct DeactivateResponsiveDesignExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User deactivates the responsive_design or split_console in the devtools
     * toolbox. This event was generated to correspond to the Legacy Telemetry event
     * devtools.main.deactivate#responsive_design.
   */
  constexpr impl::EventMetric<DeactivateResponsiveDesignExtra> deactivate_responsive_design(928);

  /**
   * generated from devtools.main.deactivate_split_console
   */
    struct DeactivateSplitConsoleExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User deactivates the responsive_design or split_console in the devtools
     * toolbox. This event was generated to correspond to the Legacy Telemetry event
     * devtools.main.deactivate#split_console.
   */
  constexpr impl::EventMetric<DeactivateSplitConsoleExtra> deactivate_split_console(929);

  /**
   * generated from devtools.main.device_added_aboutdebugging
   */
    struct DeviceAddedAboutdebuggingExtra {
      mozilla::Maybe<nsCString> connectionType;
      mozilla::Maybe<nsCString> deviceName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (connectionType) {
          extraKeys.AppendElement()->AssignASCII("connection_type");
          extraValues.EmplaceBack(connectionType.value());
        }
        if (deviceName) {
          extraKeys.AppendElement()->AssignASCII("device_name");
          extraValues.EmplaceBack(deviceName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * A new device was detected in about:debugging This event was generated to
     * correspond to the Legacy Telemetry event
     * devtools.main.device_added#aboutdebugging.
   */
  constexpr impl::EventMetric<DeviceAddedAboutdebuggingExtra> device_added_aboutdebugging(930);

  /**
   * generated from devtools.main.device_removed_aboutdebugging
   */
    struct DeviceRemovedAboutdebuggingExtra {
      mozilla::Maybe<nsCString> connectionType;
      mozilla::Maybe<nsCString> deviceName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (connectionType) {
          extraKeys.AppendElement()->AssignASCII("connection_type");
          extraValues.EmplaceBack(connectionType.value());
        }
        if (deviceName) {
          extraKeys.AppendElement()->AssignASCII("device_name");
          extraValues.EmplaceBack(deviceName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * A previously listed device was removed in about:debugging This event was
     * generated to correspond to the Legacy Telemetry event
     * devtools.main.device_removed#aboutdebugging.
   */
  constexpr impl::EventMetric<DeviceRemovedAboutdebuggingExtra> device_removed_aboutdebugging(931);

  /**
   * generated from devtools.main.edit_html_inspector
   */
    struct EditHtmlInspectorExtra {
      mozilla::Maybe<nsCString> madeChanges;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> timeOpen;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (madeChanges) {
          extraKeys.AppendElement()->AssignASCII("made_changes");
          extraValues.EmplaceBack(madeChanges.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (timeOpen) {
          extraKeys.AppendElement()->AssignASCII("time_open");
          extraValues.EmplaceBack(timeOpen.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User is editing HTML via the context menu item in the markup view. This event
     * was generated to correspond to the Legacy Telemetry event
     * devtools.main.edit_html#inspector.
   */
  constexpr impl::EventMetric<EditHtmlInspectorExtra> edit_html_inspector(932);

  /**
   * generated from devtools.main.edit_resend_netmonitor
   */
    struct EditResendNetmonitorExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has executed edit / resend in the netmonitor. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.edit_resend#netmonitor.
   */
  constexpr impl::EventMetric<EditResendNetmonitorExtra> edit_resend_netmonitor(933);

  /**
   * generated from devtools.main.edit_rule_ruleview
   */
    struct EditRuleRuleviewExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User is editing a CSS rule by clicking on or next to a CSS property, enabling /
     * disabling a rule or creating a new property. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.edit_rule#ruleview.
   */
  constexpr impl::EventMetric<EditRuleRuleviewExtra> edit_rule_ruleview(934);

  /**
   * generated from devtools.main.enter_accessibility
   */
    struct EnterAccessibilityExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#accessibility.
   */
  constexpr impl::EventMetric<EnterAccessibilityExtra> enter_accessibility(935);

  /**
   * generated from devtools.main.enter_application
   */
    struct EnterApplicationExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#application.
   */
  constexpr impl::EventMetric<EnterApplicationExtra> enter_application(936);

  /**
   * generated from devtools.main.enter_dom
   */
    struct EnterDomExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#dom.
   */
  constexpr impl::EventMetric<EnterDomExtra> enter_dom(937);

  /**
   * generated from devtools.main.enter_fake_tool4242
   */
    struct EnterFakeTool4242Extra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#fakeTool4242.
   */
  constexpr impl::EventMetric<EnterFakeTool4242Extra> enter_fake_tool4242(938);

  /**
   * generated from devtools.main.enter_inspector
   */
    struct EnterInspectorExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#inspector.
   */
  constexpr impl::EventMetric<EnterInspectorExtra> enter_inspector(939);

  /**
   * generated from devtools.main.enter_jsdebugger
   */
    struct EnterJsdebuggerExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#jsdebugger.
   */
  constexpr impl::EventMetric<EnterJsdebuggerExtra> enter_jsdebugger(940);

  /**
   * generated from devtools.main.enter_memory
   */
    struct EnterMemoryExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#memory.
   */
  constexpr impl::EventMetric<EnterMemoryExtra> enter_memory(941);

  /**
   * generated from devtools.main.enter_netmonitor
   */
    struct EnterNetmonitorExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#netmonitor.
   */
  constexpr impl::EventMetric<EnterNetmonitorExtra> enter_netmonitor(942);

  /**
   * generated from devtools.main.enter_options
   */
    struct EnterOptionsExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#options.
   */
  constexpr impl::EventMetric<EnterOptionsExtra> enter_options(943);

  /**
   * generated from devtools.main.enter_other
   */
    struct EnterOtherExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#other.
   */
  constexpr impl::EventMetric<EnterOtherExtra> enter_other(944);

  /**
   * generated from devtools.main.enter_performance
   */
    struct EnterPerformanceExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#performance.
   */
  constexpr impl::EventMetric<EnterPerformanceExtra> enter_performance(945);

  /**
   * generated from devtools.main.enter_storage
   */
    struct EnterStorageExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#storage.
   */
  constexpr impl::EventMetric<EnterStorageExtra> enter_storage(946);

  /**
   * generated from devtools.main.enter_styleeditor
   */
    struct EnterStyleeditorExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#styleeditor.
   */
  constexpr impl::EventMetric<EnterStyleeditorExtra> enter_styleeditor(947);

  /**
   * generated from devtools.main.enter_test_blank_panel
   */
    struct EnterTestBlankPanelExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#testBlankPanel.
   */
  constexpr impl::EventMetric<EnterTestBlankPanelExtra> enter_test_blank_panel(948);

  /**
   * generated from devtools.main.enter_test_tool
   */
    struct EnterTestToolExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#testTool.
   */
  constexpr impl::EventMetric<EnterTestToolExtra> enter_test_tool(949);

  /**
   * generated from devtools.main.enter_test_tool1072208
   */
    struct EnterTestTool1072208Extra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#testTool1072208.
   */
  constexpr impl::EventMetric<EnterTestTool1072208Extra> enter_test_tool1072208(950);

  /**
   * generated from devtools.main.enter_testtool1
   */
    struct EnterTesttool1Extra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#testtool1.
   */
  constexpr impl::EventMetric<EnterTesttool1Extra> enter_testtool1(951);

  /**
   * generated from devtools.main.enter_testtool2
   */
    struct EnterTesttool2Extra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#testtool2.
   */
  constexpr impl::EventMetric<EnterTesttool2Extra> enter_testtool2(952);

  /**
   * generated from devtools.main.enter_webconsole
   */
    struct EnterWebconsoleExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#webconsole.
   */
  constexpr impl::EventMetric<EnterWebconsoleExtra> enter_webconsole(953);

  /**
   * generated from devtools.main.enter_whatsnew
   */
    struct EnterWhatsnewExtra {
      mozilla::Maybe<nsCString> cold;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> messageCount;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> startState;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cold) {
          extraKeys.AppendElement()->AssignASCII("cold");
          extraValues.EmplaceBack(cold.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (messageCount) {
          extraKeys.AppendElement()->AssignASCII("message_count");
          extraValues.EmplaceBack(messageCount.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (startState) {
          extraKeys.AppendElement()->AssignASCII("start_state");
          extraValues.EmplaceBack(startState.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.enter#whatsnew.
   */
  constexpr impl::EventMetric<EnterWhatsnewExtra> enter_whatsnew(954);

  /**
   * generated from devtools.main.execute_js_webconsole
   */
    struct ExecuteJsWebconsoleExtra {
      mozilla::Maybe<nsCString> input;
      mozilla::Maybe<nsCString> lines;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (input) {
          extraKeys.AppendElement()->AssignASCII("input");
          extraValues.EmplaceBack(input.value());
        }
        if (lines) {
          extraKeys.AppendElement()->AssignASCII("lines");
          extraValues.EmplaceBack(lines.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has executed some JS in the Web Console. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.execute_js#webconsole.
   */
  constexpr impl::EventMetric<ExecuteJsWebconsoleExtra> execute_js_webconsole(955);

  /**
   * generated from devtools.main.exit_accessibility
   */
    struct ExitAccessibilityExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#accessibility.
   */
  constexpr impl::EventMetric<ExitAccessibilityExtra> exit_accessibility(956);

  /**
   * generated from devtools.main.exit_application
   */
    struct ExitApplicationExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#application.
   */
  constexpr impl::EventMetric<ExitApplicationExtra> exit_application(957);

  /**
   * generated from devtools.main.exit_dom
   */
    struct ExitDomExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#dom.
   */
  constexpr impl::EventMetric<ExitDomExtra> exit_dom(958);

  /**
   * generated from devtools.main.exit_fake_tool4242
   */
    struct ExitFakeTool4242Extra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#fakeTool4242.
   */
  constexpr impl::EventMetric<ExitFakeTool4242Extra> exit_fake_tool4242(959);

  /**
   * generated from devtools.main.exit_inspector
   */
    struct ExitInspectorExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#inspector.
   */
  constexpr impl::EventMetric<ExitInspectorExtra> exit_inspector(960);

  /**
   * generated from devtools.main.exit_jsdebugger
   */
    struct ExitJsdebuggerExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#jsdebugger.
   */
  constexpr impl::EventMetric<ExitJsdebuggerExtra> exit_jsdebugger(961);

  /**
   * generated from devtools.main.exit_memory
   */
    struct ExitMemoryExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#memory.
   */
  constexpr impl::EventMetric<ExitMemoryExtra> exit_memory(962);

  /**
   * generated from devtools.main.exit_netmonitor
   */
    struct ExitNetmonitorExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#netmonitor.
   */
  constexpr impl::EventMetric<ExitNetmonitorExtra> exit_netmonitor(963);

  /**
   * generated from devtools.main.exit_options
   */
    struct ExitOptionsExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#options.
   */
  constexpr impl::EventMetric<ExitOptionsExtra> exit_options(964);

  /**
   * generated from devtools.main.exit_other
   */
    struct ExitOtherExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#other.
   */
  constexpr impl::EventMetric<ExitOtherExtra> exit_other(965);

  /**
   * generated from devtools.main.exit_performance
   */
    struct ExitPerformanceExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#performance.
   */
  constexpr impl::EventMetric<ExitPerformanceExtra> exit_performance(966);

  /**
   * generated from devtools.main.exit_storage
   */
    struct ExitStorageExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#storage.
   */
  constexpr impl::EventMetric<ExitStorageExtra> exit_storage(967);

  /**
   * generated from devtools.main.exit_styleeditor
   */
    struct ExitStyleeditorExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#styleeditor.
   */
  constexpr impl::EventMetric<ExitStyleeditorExtra> exit_styleeditor(968);

  /**
   * generated from devtools.main.exit_test_blank_panel
   */
    struct ExitTestBlankPanelExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#testBlankPanel.
   */
  constexpr impl::EventMetric<ExitTestBlankPanelExtra> exit_test_blank_panel(969);

  /**
   * generated from devtools.main.exit_test_tool
   */
    struct ExitTestToolExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#testTool.
   */
  constexpr impl::EventMetric<ExitTestToolExtra> exit_test_tool(970);

  /**
   * generated from devtools.main.exit_test_tool1072208
   */
    struct ExitTestTool1072208Extra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#testTool1072208.
   */
  constexpr impl::EventMetric<ExitTestTool1072208Extra> exit_test_tool1072208(971);

  /**
   * generated from devtools.main.exit_testtool1
   */
    struct ExitTesttool1Extra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#testtool1.
   */
  constexpr impl::EventMetric<ExitTesttool1Extra> exit_testtool1(972);

  /**
   * generated from devtools.main.exit_testtool2
   */
    struct ExitTesttool2Extra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#testtool2.
   */
  constexpr impl::EventMetric<ExitTesttool2Extra> exit_testtool2(973);

  /**
   * generated from devtools.main.exit_webconsole
   */
    struct ExitWebconsoleExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#webconsole.
   */
  constexpr impl::EventMetric<ExitWebconsoleExtra> exit_webconsole(974);

  /**
   * generated from devtools.main.exit_whatsnew
   */
    struct ExitWhatsnewExtra {
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> nextPanel;
      mozilla::Maybe<nsCString> panelName;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (nextPanel) {
          extraKeys.AppendElement()->AssignASCII("next_panel");
          extraValues.EmplaceBack(nextPanel.value());
        }
        if (panelName) {
          extraKeys.AppendElement()->AssignASCII("panel_name");
          extraValues.EmplaceBack(panelName.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User closes a tool in the devtools toolbox. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.exit#whatsnew.
   */
  constexpr impl::EventMetric<ExitWhatsnewExtra> exit_whatsnew(975);

  /**
   * generated from devtools.main.filters_changed_netmonitor
   */
    struct FiltersChangedNetmonitorExtra {
      mozilla::Maybe<nsCString> active;
      mozilla::Maybe<nsCString> inactive;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> trigger;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (active) {
          extraKeys.AppendElement()->AssignASCII("active");
          extraValues.EmplaceBack(active.value());
        }
        if (inactive) {
          extraKeys.AppendElement()->AssignASCII("inactive");
          extraValues.EmplaceBack(inactive.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (trigger) {
          extraKeys.AppendElement()->AssignASCII("trigger");
          extraValues.EmplaceBack(trigger.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has changed filters in the web console. This event was generated to
     * correspond to the Legacy Telemetry event
     * devtools.main.filters_changed#netmonitor.
   */
  constexpr impl::EventMetric<FiltersChangedNetmonitorExtra> filters_changed_netmonitor(976);

  /**
   * generated from devtools.main.filters_changed_webconsole
   */
    struct FiltersChangedWebconsoleExtra {
      mozilla::Maybe<nsCString> active;
      mozilla::Maybe<nsCString> inactive;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> trigger;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (active) {
          extraKeys.AppendElement()->AssignASCII("active");
          extraValues.EmplaceBack(active.value());
        }
        if (inactive) {
          extraKeys.AppendElement()->AssignASCII("inactive");
          extraValues.EmplaceBack(inactive.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (trigger) {
          extraKeys.AppendElement()->AssignASCII("trigger");
          extraValues.EmplaceBack(trigger.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has changed filters in the web console. This event was generated to
     * correspond to the Legacy Telemetry event
     * devtools.main.filters_changed#webconsole.
   */
  constexpr impl::EventMetric<FiltersChangedWebconsoleExtra> filters_changed_webconsole(977);

  /**
   * generated from devtools.main.inspect_aboutdebugging
   */
    struct InspectAboutdebuggingExtra {
      mozilla::Maybe<nsCString> runtimeType;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> targetType;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (runtimeType) {
          extraKeys.AppendElement()->AssignASCII("runtime_type");
          extraValues.EmplaceBack(runtimeType.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (targetType) {
          extraKeys.AppendElement()->AssignASCII("target_type");
          extraValues.EmplaceBack(targetType.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has clicked on the inspect button of one of the debug targets of
     * aboutdebugging. This event was generated to correspond to the Legacy Telemetry
     * event devtools.main.inspect#aboutdebugging.
   */
  constexpr impl::EventMetric<InspectAboutdebuggingExtra> inspect_aboutdebugging(978);

  /**
   * generated from devtools.main.jump_to_definition_webconsole
   */
    struct JumpToDefinitionWebconsoleExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has clicked "Jump to definition" icon (next to logged functions) in the
     * web console. This event was generated to correspond to the Legacy Telemetry
     * event devtools.main.jump_to_definition#webconsole.
   */
  constexpr impl::EventMetric<JumpToDefinitionWebconsoleExtra> jump_to_definition_webconsole(979);

  /**
   * generated from devtools.main.jump_to_source_webconsole
   */
    struct JumpToSourceWebconsoleExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has clicked a link to a source file in the web console. This event was
     * generated to correspond to the Legacy Telemetry event
     * devtools.main.jump_to_source#webconsole.
   */
  constexpr impl::EventMetric<JumpToSourceWebconsoleExtra> jump_to_source_webconsole(980);

  /**
   * generated from devtools.main.object_expanded_webconsole
   */
    struct ObjectExpandedWebconsoleExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has expanded an object in the web console. This event was generated to
     * correspond to the Legacy Telemetry event
     * devtools.main.object_expanded#webconsole.
   */
  constexpr impl::EventMetric<ObjectExpandedWebconsoleExtra> object_expanded_webconsole(981);

  /**
   * generated from devtools.main.open_adbg_aboutdebugging
   */
    struct OpenAdbgAboutdebuggingExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens about:debugging. This event was generated to correspond to the
     * Legacy Telemetry event devtools.main.open_adbg#aboutdebugging.
   */
  constexpr impl::EventMetric<OpenAdbgAboutdebuggingExtra> open_adbg_aboutdebugging(982);

  /**
   * generated from devtools.main.open_tools
   */
    struct OpenToolsExtra {
      mozilla::Maybe<nsCString> entrypoint;
      mozilla::Maybe<nsCString> firstPanel;
      mozilla::Maybe<nsCString> host;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> shortcut;
      mozilla::Maybe<nsCString> splitconsole;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<nsCString> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (entrypoint) {
          extraKeys.AppendElement()->AssignASCII("entrypoint");
          extraValues.EmplaceBack(entrypoint.value());
        }
        if (firstPanel) {
          extraKeys.AppendElement()->AssignASCII("first_panel");
          extraValues.EmplaceBack(firstPanel.value());
        }
        if (host) {
          extraKeys.AppendElement()->AssignASCII("host");
          extraValues.EmplaceBack(host.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (shortcut) {
          extraKeys.AppendElement()->AssignASCII("shortcut");
          extraValues.EmplaceBack(shortcut.value());
        }
        if (splitconsole) {
          extraKeys.AppendElement()->AssignASCII("splitconsole");
          extraValues.EmplaceBack(splitconsole.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(width.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User opens devtools toolbox. This event was generated to correspond to the
     * Legacy Telemetry event devtools.main.open#tools.
   */
  constexpr impl::EventMetric<OpenToolsExtra> open_tools(983);

  /**
   * generated from devtools.main.pause_debugger
   */
    struct PauseDebuggerExtra {
      mozilla::Maybe<nsCString> libStacks;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (libStacks) {
          extraKeys.AppendElement()->AssignASCII("lib_stacks");
          extraValues.EmplaceBack(libStacks.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Debugger has paused in a script due to a breakpoint or exception. This event
     * was generated to correspond to the Legacy Telemetry event
     * devtools.main.pause#debugger.
   */
  constexpr impl::EventMetric<PauseDebuggerExtra> pause_debugger(984);

  /**
   * generated from devtools.main.pause_on_exceptions_debugger
   */
    struct PauseOnExceptionsDebuggerExtra {
      mozilla::Maybe<nsCString> caughtExceptio;
      mozilla::Maybe<nsCString> exceptions;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (caughtExceptio) {
          extraKeys.AppendElement()->AssignASCII("caught_exceptio");
          extraValues.EmplaceBack(caughtExceptio.value());
        }
        if (exceptions) {
          extraKeys.AppendElement()->AssignASCII("exceptions");
          extraValues.EmplaceBack(exceptions.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has changed pausing behaviour in the debugger. This event was generated to
     * correspond to the Legacy Telemetry event
     * devtools.main.pause_on_exceptions#debugger.
   */
  constexpr impl::EventMetric<PauseOnExceptionsDebuggerExtra> pause_on_exceptions_debugger(985);

  /**
   * generated from devtools.main.persist_changed_netmonitor
   */
    struct PersistChangedNetmonitorExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has changed log persist status. This event was generated to correspond to
     * the Legacy Telemetry event devtools.main.persist_changed#netmonitor.
   */
  constexpr impl::EventMetric<PersistChangedNetmonitorExtra> persist_changed_netmonitor(986);

  /**
   * generated from devtools.main.persist_changed_webconsole
   */
    struct PersistChangedWebconsoleExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has changed log persist status. This event was generated to correspond to
     * the Legacy Telemetry event devtools.main.persist_changed#webconsole.
   */
  constexpr impl::EventMetric<PersistChangedWebconsoleExtra> persist_changed_webconsole(987);

  /**
   * generated from devtools.main.pretty_print_debugger
   */
    struct PrettyPrintDebuggerExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User clicked the pretty print button to pretty print a script. This event was
     * generated to correspond to the Legacy Telemetry event
     * devtools.main.pretty_print#debugger.
   */
  constexpr impl::EventMetric<PrettyPrintDebuggerExtra> pretty_print_debugger(988);

  /**
   * generated from devtools.main.remove_breakpoint_debugger
   */
    struct RemoveBreakpointDebuggerExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has removed a breakpoint from a script. This event was generated to
     * correspond to the Legacy Telemetry event
     * devtools.main.remove_breakpoint#debugger.
   */
  constexpr impl::EventMetric<RemoveBreakpointDebuggerExtra> remove_breakpoint_debugger(989);

  /**
   * generated from devtools.main.reverse_search_webconsole
   */
    struct ReverseSearchWebconsoleExtra {
      mozilla::Maybe<nsCString> functionality;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (functionality) {
          extraKeys.AppendElement()->AssignASCII("functionality");
          extraValues.EmplaceBack(functionality.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has toggled, navigated or evaluated expressions from reverse search . This
     * event was generated to correspond to the Legacy Telemetry event
     * devtools.main.reverse_search#webconsole.
   */
  constexpr impl::EventMetric<ReverseSearchWebconsoleExtra> reverse_search_webconsole(990);

  /**
   * generated from devtools.main.runtime_added_aboutdebugging
   */
    struct RuntimeAddedAboutdebuggingExtra {
      mozilla::Maybe<nsCString> connectionType;
      mozilla::Maybe<nsCString> deviceName;
      mozilla::Maybe<nsCString> runtimeId;
      mozilla::Maybe<nsCString> runtimeName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (connectionType) {
          extraKeys.AppendElement()->AssignASCII("connection_type");
          extraValues.EmplaceBack(connectionType.value());
        }
        if (deviceName) {
          extraKeys.AppendElement()->AssignASCII("device_name");
          extraValues.EmplaceBack(deviceName.value());
        }
        if (runtimeId) {
          extraKeys.AppendElement()->AssignASCII("runtime_id");
          extraValues.EmplaceBack(runtimeId.value());
        }
        if (runtimeName) {
          extraKeys.AppendElement()->AssignASCII("runtime_name");
          extraValues.EmplaceBack(runtimeName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * A new remote runtime has been detected in about:debugging This event was
     * generated to correspond to the Legacy Telemetry event
     * devtools.main.runtime_added#aboutdebugging.
   */
  constexpr impl::EventMetric<RuntimeAddedAboutdebuggingExtra> runtime_added_aboutdebugging(991);

  /**
   * generated from devtools.main.runtime_connected_aboutdebugging
   */
    struct RuntimeConnectedAboutdebuggingExtra {
      mozilla::Maybe<nsCString> connectionType;
      mozilla::Maybe<nsCString> deviceName;
      mozilla::Maybe<nsCString> runtimeId;
      mozilla::Maybe<nsCString> runtimeName;
      mozilla::Maybe<nsCString> runtimeOs;
      mozilla::Maybe<nsCString> runtimeVersion;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (connectionType) {
          extraKeys.AppendElement()->AssignASCII("connection_type");
          extraValues.EmplaceBack(connectionType.value());
        }
        if (deviceName) {
          extraKeys.AppendElement()->AssignASCII("device_name");
          extraValues.EmplaceBack(deviceName.value());
        }
        if (runtimeId) {
          extraKeys.AppendElement()->AssignASCII("runtime_id");
          extraValues.EmplaceBack(runtimeId.value());
        }
        if (runtimeName) {
          extraKeys.AppendElement()->AssignASCII("runtime_name");
          extraValues.EmplaceBack(runtimeName.value());
        }
        if (runtimeOs) {
          extraKeys.AppendElement()->AssignASCII("runtime_os");
          extraValues.EmplaceBack(runtimeOs.value());
        }
        if (runtimeVersion) {
          extraKeys.AppendElement()->AssignASCII("runtime_version");
          extraValues.EmplaceBack(runtimeVersion.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Connection was established with a remote runtime in about:debugging This event
     * was generated to correspond to the Legacy Telemetry event
     * devtools.main.runtime_connected#aboutdebugging.
   */
  constexpr impl::EventMetric<RuntimeConnectedAboutdebuggingExtra> runtime_connected_aboutdebugging(992);

  /**
   * generated from devtools.main.runtime_disconnected_aboutdebugging
   */
    struct RuntimeDisconnectedAboutdebuggingExtra {
      mozilla::Maybe<nsCString> connectionType;
      mozilla::Maybe<nsCString> deviceName;
      mozilla::Maybe<nsCString> runtimeId;
      mozilla::Maybe<nsCString> runtimeName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (connectionType) {
          extraKeys.AppendElement()->AssignASCII("connection_type");
          extraValues.EmplaceBack(connectionType.value());
        }
        if (deviceName) {
          extraKeys.AppendElement()->AssignASCII("device_name");
          extraValues.EmplaceBack(deviceName.value());
        }
        if (runtimeId) {
          extraKeys.AppendElement()->AssignASCII("runtime_id");
          extraValues.EmplaceBack(runtimeId.value());
        }
        if (runtimeName) {
          extraKeys.AppendElement()->AssignASCII("runtime_name");
          extraValues.EmplaceBack(runtimeName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Connection was lost with a remote runtime in about debugging This event was
     * generated to correspond to the Legacy Telemetry event
     * devtools.main.runtime_disconnected#aboutdebugging.
   */
  constexpr impl::EventMetric<RuntimeDisconnectedAboutdebuggingExtra> runtime_disconnected_aboutdebugging(993);

  /**
   * generated from devtools.main.runtime_removed_aboutdebugging
   */
    struct RuntimeRemovedAboutdebuggingExtra {
      mozilla::Maybe<nsCString> connectionType;
      mozilla::Maybe<nsCString> deviceName;
      mozilla::Maybe<nsCString> runtimeId;
      mozilla::Maybe<nsCString> runtimeName;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (connectionType) {
          extraKeys.AppendElement()->AssignASCII("connection_type");
          extraValues.EmplaceBack(connectionType.value());
        }
        if (deviceName) {
          extraKeys.AppendElement()->AssignASCII("device_name");
          extraValues.EmplaceBack(deviceName.value());
        }
        if (runtimeId) {
          extraKeys.AppendElement()->AssignASCII("runtime_id");
          extraValues.EmplaceBack(runtimeId.value());
        }
        if (runtimeName) {
          extraKeys.AppendElement()->AssignASCII("runtime_name");
          extraValues.EmplaceBack(runtimeName.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * A previously listed runtime was removed in about:debugging This event was
     * generated to correspond to the Legacy Telemetry event
     * devtools.main.runtime_removed#aboutdebugging.
   */
  constexpr impl::EventMetric<RuntimeRemovedAboutdebuggingExtra> runtime_removed_aboutdebugging(994);

  /**
   * generated from devtools.main.select_page_aboutdebugging
   */
    struct SelectPageAboutdebuggingExtra {
      mozilla::Maybe<nsCString> pageType;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (pageType) {
          extraKeys.AppendElement()->AssignASCII("page_type");
          extraValues.EmplaceBack(pageType.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User navigates to a new page of an application such as about:debugging This
     * event was generated to correspond to the Legacy Telemetry event
     * devtools.main.select_page#aboutdebugging.
   */
  constexpr impl::EventMetric<SelectPageAboutdebuggingExtra> select_page_aboutdebugging(995);

  /**
   * generated from devtools.main.select_page_application
   */
    struct SelectPageApplicationExtra {
      mozilla::Maybe<nsCString> pageType;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (pageType) {
          extraKeys.AppendElement()->AssignASCII("page_type");
          extraValues.EmplaceBack(pageType.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User navigates to a new page of an application such as about:debugging This
     * event was generated to correspond to the Legacy Telemetry event
     * devtools.main.select_page#application.
   */
  constexpr impl::EventMetric<SelectPageApplicationExtra> select_page_application(996);

  /**
   * generated from devtools.main.select_ws_frame_netmonitor
   */
    struct SelectWsFrameNetmonitorExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has selected a WebSocket frame. This event was generated to correspond to
     * the Legacy Telemetry event devtools.main.select_ws_frame#netmonitor.
   */
  constexpr impl::EventMetric<SelectWsFrameNetmonitorExtra> select_ws_frame_netmonitor(997);

  /**
   * generated from devtools.main.show_profiler_aboutdebugging
   */
    struct ShowProfilerAboutdebuggingExtra {
      mozilla::Maybe<nsCString> runtimeId;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (runtimeId) {
          extraKeys.AppendElement()->AssignASCII("runtime_id");
          extraValues.EmplaceBack(runtimeId.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has clicked on the "Open Profiler" button in a runtime page of
     * about:debugging This event was generated to correspond to the Legacy Telemetry
     * event devtools.main.show_profiler#aboutdebugging.
   */
  constexpr impl::EventMetric<ShowProfilerAboutdebuggingExtra> show_profiler_aboutdebugging(998);

  /**
   * generated from devtools.main.sidepanel_changed_inspector
   */
    struct SidepanelChangedInspectorExtra {
      mozilla::Maybe<nsCString> newpanel;
      mozilla::Maybe<nsCString> oldpanel;
      mozilla::Maybe<nsCString> os;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newpanel) {
          extraKeys.AppendElement()->AssignASCII("newpanel");
          extraValues.EmplaceBack(newpanel.value());
        }
        if (oldpanel) {
          extraKeys.AppendElement()->AssignASCII("oldpanel");
          extraValues.EmplaceBack(oldpanel.value());
        }
        if (os) {
          extraKeys.AppendElement()->AssignASCII("os");
          extraValues.EmplaceBack(os.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has switched sidepanel tabs. This event was generated to correspond to the
     * Legacy Telemetry event devtools.main.sidepanel_changed#inspector.
   */
  constexpr impl::EventMetric<SidepanelChangedInspectorExtra> sidepanel_changed_inspector(999);

  /**
   * generated from devtools.main.sidepanel_changed_netmonitor
   */
    struct SidepanelChangedNetmonitorExtra {
      mozilla::Maybe<nsCString> newpanel;
      mozilla::Maybe<nsCString> oldpanel;
      mozilla::Maybe<nsCString> os;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newpanel) {
          extraKeys.AppendElement()->AssignASCII("newpanel");
          extraValues.EmplaceBack(newpanel.value());
        }
        if (oldpanel) {
          extraKeys.AppendElement()->AssignASCII("oldpanel");
          extraValues.EmplaceBack(oldpanel.value());
        }
        if (os) {
          extraKeys.AppendElement()->AssignASCII("os");
          extraValues.EmplaceBack(os.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has switched sidepanel tabs. This event was generated to correspond to the
     * Legacy Telemetry event devtools.main.sidepanel_changed#netmonitor.
   */
  constexpr impl::EventMetric<SidepanelChangedNetmonitorExtra> sidepanel_changed_netmonitor(1000);

  /**
   * generated from devtools.main.start_worker_application
   */
    struct StartWorkerApplicationExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User manually starts a service worker This event was generated to correspond to
     * the Legacy Telemetry event devtools.main.start_worker#application.
   */
  constexpr impl::EventMetric<StartWorkerApplicationExtra> start_worker_application(1001);

  /**
   * generated from devtools.main.throttle_changed_netmonitor
   */
    struct ThrottleChangedNetmonitorExtra {
      mozilla::Maybe<nsCString> mode;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (mode) {
          extraKeys.AppendElement()->AssignASCII("mode");
          extraValues.EmplaceBack(mode.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has changed the throttle setting in the netmonitor. This event was
     * generated to correspond to the Legacy Telemetry event
     * devtools.main.throttle_changed#netmonitor.
   */
  constexpr impl::EventMetric<ThrottleChangedNetmonitorExtra> throttle_changed_netmonitor(1002);

  /**
   * generated from devtools.main.tool_timer_animationinspector
   */
    struct ToolTimerAnimationinspectorExtra {
      mozilla::Maybe<nsCString> os;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> timeOpen;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (os) {
          extraKeys.AppendElement()->AssignASCII("os");
          extraValues.EmplaceBack(os.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (timeOpen) {
          extraKeys.AppendElement()->AssignASCII("time_open");
          extraValues.EmplaceBack(timeOpen.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The amount of time a tool was opened for. This event was generated to
     * correspond to the Legacy Telemetry event
     * devtools.main.tool_timer#animationinspector.
   */
  constexpr impl::EventMetric<ToolTimerAnimationinspectorExtra> tool_timer_animationinspector(1003);

  /**
   * generated from devtools.main.tool_timer_changesview
   */
    struct ToolTimerChangesviewExtra {
      mozilla::Maybe<nsCString> os;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> timeOpen;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (os) {
          extraKeys.AppendElement()->AssignASCII("os");
          extraValues.EmplaceBack(os.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (timeOpen) {
          extraKeys.AppendElement()->AssignASCII("time_open");
          extraValues.EmplaceBack(timeOpen.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The amount of time a tool was opened for. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.tool_timer#changesview.
   */
  constexpr impl::EventMetric<ToolTimerChangesviewExtra> tool_timer_changesview(1004);

  /**
   * generated from devtools.main.tool_timer_compatibilityview
   */
    struct ToolTimerCompatibilityviewExtra {
      mozilla::Maybe<nsCString> os;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> timeOpen;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (os) {
          extraKeys.AppendElement()->AssignASCII("os");
          extraValues.EmplaceBack(os.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (timeOpen) {
          extraKeys.AppendElement()->AssignASCII("time_open");
          extraValues.EmplaceBack(timeOpen.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The amount of time a tool was opened for. This event was generated to
     * correspond to the Legacy Telemetry event
     * devtools.main.tool_timer#compatibilityview.
   */
  constexpr impl::EventMetric<ToolTimerCompatibilityviewExtra> tool_timer_compatibilityview(1005);

  /**
   * generated from devtools.main.tool_timer_computedview
   */
    struct ToolTimerComputedviewExtra {
      mozilla::Maybe<nsCString> os;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> timeOpen;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (os) {
          extraKeys.AppendElement()->AssignASCII("os");
          extraValues.EmplaceBack(os.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (timeOpen) {
          extraKeys.AppendElement()->AssignASCII("time_open");
          extraValues.EmplaceBack(timeOpen.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The amount of time a tool was opened for. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.tool_timer#computedview.
   */
  constexpr impl::EventMetric<ToolTimerComputedviewExtra> tool_timer_computedview(1006);

  /**
   * generated from devtools.main.tool_timer_fontinspector
   */
    struct ToolTimerFontinspectorExtra {
      mozilla::Maybe<nsCString> os;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> timeOpen;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (os) {
          extraKeys.AppendElement()->AssignASCII("os");
          extraValues.EmplaceBack(os.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (timeOpen) {
          extraKeys.AppendElement()->AssignASCII("time_open");
          extraValues.EmplaceBack(timeOpen.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The amount of time a tool was opened for. This event was generated to
     * correspond to the Legacy Telemetry event
     * devtools.main.tool_timer#fontinspector.
   */
  constexpr impl::EventMetric<ToolTimerFontinspectorExtra> tool_timer_fontinspector(1007);

  /**
   * generated from devtools.main.tool_timer_layoutview
   */
    struct ToolTimerLayoutviewExtra {
      mozilla::Maybe<nsCString> os;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> timeOpen;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (os) {
          extraKeys.AppendElement()->AssignASCII("os");
          extraValues.EmplaceBack(os.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (timeOpen) {
          extraKeys.AppendElement()->AssignASCII("time_open");
          extraValues.EmplaceBack(timeOpen.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The amount of time a tool was opened for. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.tool_timer#layoutview.
   */
  constexpr impl::EventMetric<ToolTimerLayoutviewExtra> tool_timer_layoutview(1008);

  /**
   * generated from devtools.main.tool_timer_ruleview
   */
    struct ToolTimerRuleviewExtra {
      mozilla::Maybe<nsCString> os;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> timeOpen;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (os) {
          extraKeys.AppendElement()->AssignASCII("os");
          extraValues.EmplaceBack(os.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (timeOpen) {
          extraKeys.AppendElement()->AssignASCII("time_open");
          extraValues.EmplaceBack(timeOpen.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The amount of time a tool was opened for. This event was generated to
     * correspond to the Legacy Telemetry event devtools.main.tool_timer#ruleview.
   */
  constexpr impl::EventMetric<ToolTimerRuleviewExtra> tool_timer_ruleview(1009);

  /**
   * generated from devtools.main.unregister_worker_application
   */
    struct UnregisterWorkerApplicationExtra {
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User manually unregisters a service worker registration This event was
     * generated to correspond to the Legacy Telemetry event
     * devtools.main.unregister_worker#application.
   */
  constexpr impl::EventMetric<UnregisterWorkerApplicationExtra> unregister_worker_application(1010);

  /**
   * generated from devtools.main.update_conn_prompt_aboutdebugging
   */
    struct UpdateConnPromptAboutdebuggingExtra {
      mozilla::Maybe<nsCString> promptEnabled;
      mozilla::Maybe<nsCString> runtimeId;
      mozilla::Maybe<nsCString> sessionId;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (promptEnabled) {
          extraKeys.AppendElement()->AssignASCII("prompt_enabled");
          extraValues.EmplaceBack(promptEnabled.value());
        }
        if (runtimeId) {
          extraKeys.AppendElement()->AssignASCII("runtime_id");
          extraValues.EmplaceBack(runtimeId.value());
        }
        if (sessionId) {
          extraKeys.AppendElement()->AssignASCII("session_id");
          extraValues.EmplaceBack(sessionId.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User has clicked on the "Enable/Disable connection prompt" button in a runtime
     * page of about:debugging This event was generated to correspond to the Legacy
     * Telemetry event devtools.main.update_conn_prompt#aboutdebugging.
   */
  constexpr impl::EventMetric<UpdateConnPromptAboutdebuggingExtra> update_conn_prompt_aboutdebugging(1011);

}
namespace performance_page {
  /**
   * generated from performance.page.total_content_page_load
   */
  /**
   * Time to load all of a page's resources and render. (Migrated from the geckoview
     * metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric total_content_page_load(1012);

  /**
   * generated from performance.page.non_blank_paint
   */
  /**
   * The time between navigationStart and the first non-blank paint of a foreground
     * root content document, in milliseconds. This only records documents that were
     * in an active docshell throughout the whole time between navigation start and
     * non-blank paint. The non-blank paint timestamp is taken during display list
     * building and does not include rasterization or compositing of that paint.
     * (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric non_blank_paint(1013);

}
namespace use_counter {
  /**
   * generated from use.counter.content_documents_destroyed
   */
  /**
   * A count of how many content documents were destroyed. Used to turn document use
     * counters' counts into rates. Excludes documents for which we do not count use
     * counters (See `Document::ShouldIncludeInTelemetry`).
   */
  constexpr impl::CounterMetric content_documents_destroyed(1014);

  /**
   * generated from use.counter.dedicated_workers_destroyed
   */
  /**
   * A count of how many `Dedicated`-kind workers were destroyed. Used to turn
     * dedicated worker use counters' counts into rates. Excludes chrome workers.
   */
  constexpr impl::CounterMetric dedicated_workers_destroyed(1015);

  /**
   * generated from use.counter.service_workers_destroyed
   */
  /**
   * A count of how many `Service`-kind workers were destroyed. Used to turn service
     * worker use counters' counts into rates. Excludes chrome workers.
   */
  constexpr impl::CounterMetric service_workers_destroyed(1016);

  /**
   * generated from use.counter.shared_workers_destroyed
   */
  /**
   * A count of how many `Shared`-kind workers were destroyed. Used to turn shared
     * worker use counters' counts into rates. Excludes chrome workers.
   */
  constexpr impl::CounterMetric shared_workers_destroyed(1017);

  /**
   * generated from use.counter.top_level_content_documents_destroyed
   */
  /**
   * A count of how many "pages" were destroyed. Used to turn page use counters'
     * counts into rates. Excludes pages that contain only documents for which we do
     * not count use counters (See `Document::ShouldIncludeInTelemetry`).
   */
  constexpr impl::CounterMetric top_level_content_documents_destroyed(1018);

}
namespace use_counter_css_doc {
  /**
   * generated from use.counter.css.doc.alignment_baseline
   */
  /**
   * Whether a document used the (unknown, counted) CSS property alignment-baseline.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric alignment_baseline(1019);

  /**
   * generated from use.counter.css.doc.background_repeat_x
   */
  /**
   * Whether a document used the (unknown, counted) CSS property background-
     * repeat-x. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric background_repeat_x(1020);

  /**
   * generated from use.counter.css.doc.background_repeat_y
   */
  /**
   * Whether a document used the (unknown, counted) CSS property background-
     * repeat-y. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric background_repeat_y(1021);

  /**
   * generated from use.counter.css.doc.baseline_shift
   */
  /**
   * Whether a document used the (unknown, counted) CSS property baseline-shift.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric baseline_shift(1022);

  /**
   * generated from use.counter.css.doc.buffered_rendering
   */
  /**
   * Whether a document used the (unknown, counted) CSS property buffered-rendering.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric buffered_rendering(1023);

  /**
   * generated from use.counter.css.doc.color_rendering
   */
  /**
   * Whether a document used the (unknown, counted) CSS property color-rendering.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric color_rendering(1024);

  /**
   * generated from use.counter.css.doc.css_accent_color
   */
  /**
   * Whether a document used the CSS property accent-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_accent_color(1025);

  /**
   * generated from use.counter.css.doc.css_align_content
   */
  /**
   * Whether a document used the CSS property align-content. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_content(1026);

  /**
   * generated from use.counter.css.doc.css_align_items
   */
  /**
   * Whether a document used the CSS property align-items. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_items(1027);

  /**
   * generated from use.counter.css.doc.css_align_self
   */
  /**
   * Whether a document used the CSS property align-self. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_self(1028);

  /**
   * generated from use.counter.css.doc.css_all
   */
  /**
   * Whether a document used the CSS property all. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_all(1029);

  /**
   * generated from use.counter.css.doc.css_anchor_name
   */
  /**
   * Whether a document used the CSS property anchor-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_anchor_name(1030);

  /**
   * generated from use.counter.css.doc.css_anchor_scope
   */
  /**
   * Whether a document used the CSS property anchor-scope. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_anchor_scope(1031);

  /**
   * generated from use.counter.css.doc.css_animation
   */
  /**
   * Whether a document used the CSS property animation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation(1032);

  /**
   * generated from use.counter.css.doc.css_animation_composition
   */
  /**
   * Whether a document used the CSS property animation-composition. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_composition(1033);

  /**
   * generated from use.counter.css.doc.css_animation_delay
   */
  /**
   * Whether a document used the CSS property animation-delay. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_delay(1034);

  /**
   * generated from use.counter.css.doc.css_animation_direction
   */
  /**
   * Whether a document used the CSS property animation-direction. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_direction(1035);

  /**
   * generated from use.counter.css.doc.css_animation_duration
   */
  /**
   * Whether a document used the CSS property animation-duration. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_duration(1036);

  /**
   * generated from use.counter.css.doc.css_animation_fill_mode
   */
  /**
   * Whether a document used the CSS property animation-fill-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_fill_mode(1037);

  /**
   * generated from use.counter.css.doc.css_animation_iteration_count
   */
  /**
   * Whether a document used the CSS property animation-iteration-count. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_iteration_count(1038);

  /**
   * generated from use.counter.css.doc.css_animation_name
   */
  /**
   * Whether a document used the CSS property animation-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_name(1039);

  /**
   * generated from use.counter.css.doc.css_animation_play_state
   */
  /**
   * Whether a document used the CSS property animation-play-state. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_play_state(1040);

  /**
   * generated from use.counter.css.doc.css_animation_timeline
   */
  /**
   * Whether a document used the CSS property animation-timeline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_timeline(1041);

  /**
   * generated from use.counter.css.doc.css_animation_timing_function
   */
  /**
   * Whether a document used the CSS property animation-timing-function. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_timing_function(1042);

  /**
   * generated from use.counter.css.doc.css_appearance
   */
  /**
   * Whether a document used the CSS property appearance. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_appearance(1043);

  /**
   * generated from use.counter.css.doc.css_aspect_ratio
   */
  /**
   * Whether a document used the CSS property aspect-ratio. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_aspect_ratio(1044);

  /**
   * generated from use.counter.css.doc.css_backdrop_filter
   */
  /**
   * Whether a document used the CSS property backdrop-filter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_backdrop_filter(1045);

  /**
   * generated from use.counter.css.doc.css_backface_visibility
   */
  /**
   * Whether a document used the CSS property backface-visibility. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_backface_visibility(1046);

  /**
   * generated from use.counter.css.doc.css_background
   */
  /**
   * Whether a document used the CSS property background. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background(1047);

  /**
   * generated from use.counter.css.doc.css_background_attachment
   */
  /**
   * Whether a document used the CSS property background-attachment. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_attachment(1048);

  /**
   * generated from use.counter.css.doc.css_background_blend_mode
   */
  /**
   * Whether a document used the CSS property background-blend-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_blend_mode(1049);

  /**
   * generated from use.counter.css.doc.css_background_clip
   */
  /**
   * Whether a document used the CSS property background-clip. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_clip(1050);

  /**
   * generated from use.counter.css.doc.css_background_color
   */
  /**
   * Whether a document used the CSS property background-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_color(1051);

  /**
   * generated from use.counter.css.doc.css_background_image
   */
  /**
   * Whether a document used the CSS property background-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_image(1052);

  /**
   * generated from use.counter.css.doc.css_background_origin
   */
  /**
   * Whether a document used the CSS property background-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_origin(1053);

  /**
   * generated from use.counter.css.doc.css_background_position
   */
  /**
   * Whether a document used the CSS property background-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position(1054);

  /**
   * generated from use.counter.css.doc.css_background_position_x
   */
  /**
   * Whether a document used the CSS property background-position-x. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position_x(1055);

  /**
   * generated from use.counter.css.doc.css_background_position_y
   */
  /**
   * Whether a document used the CSS property background-position-y. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position_y(1056);

  /**
   * generated from use.counter.css.doc.css_background_repeat
   */
  /**
   * Whether a document used the CSS property background-repeat. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_repeat(1057);

  /**
   * generated from use.counter.css.doc.css_background_size
   */
  /**
   * Whether a document used the CSS property background-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_size(1058);

  /**
   * generated from use.counter.css.doc.css_baseline_source
   */
  /**
   * Whether a document used the CSS property baseline-source. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_baseline_source(1059);

  /**
   * generated from use.counter.css.doc.css_block_size
   */
  /**
   * Whether a document used the CSS property block-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_block_size(1060);

  /**
   * generated from use.counter.css.doc.css_border
   */
  /**
   * Whether a document used the CSS property border. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border(1061);

  /**
   * generated from use.counter.css.doc.css_border_block
   */
  /**
   * Whether a document used the CSS property border-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block(1062);

  /**
   * generated from use.counter.css.doc.css_border_block_color
   */
  /**
   * Whether a document used the CSS property border-block-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_color(1063);

  /**
   * generated from use.counter.css.doc.css_border_block_end
   */
  /**
   * Whether a document used the CSS property border-block-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end(1064);

  /**
   * generated from use.counter.css.doc.css_border_block_end_color
   */
  /**
   * Whether a document used the CSS property border-block-end-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_color(1065);

  /**
   * generated from use.counter.css.doc.css_border_block_end_style
   */
  /**
   * Whether a document used the CSS property border-block-end-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_style(1066);

  /**
   * generated from use.counter.css.doc.css_border_block_end_width
   */
  /**
   * Whether a document used the CSS property border-block-end-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_width(1067);

  /**
   * generated from use.counter.css.doc.css_border_block_start
   */
  /**
   * Whether a document used the CSS property border-block-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start(1068);

  /**
   * generated from use.counter.css.doc.css_border_block_start_color
   */
  /**
   * Whether a document used the CSS property border-block-start-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_color(1069);

  /**
   * generated from use.counter.css.doc.css_border_block_start_style
   */
  /**
   * Whether a document used the CSS property border-block-start-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_style(1070);

  /**
   * generated from use.counter.css.doc.css_border_block_start_width
   */
  /**
   * Whether a document used the CSS property border-block-start-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_width(1071);

  /**
   * generated from use.counter.css.doc.css_border_block_style
   */
  /**
   * Whether a document used the CSS property border-block-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_style(1072);

  /**
   * generated from use.counter.css.doc.css_border_block_width
   */
  /**
   * Whether a document used the CSS property border-block-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_width(1073);

  /**
   * generated from use.counter.css.doc.css_border_bottom
   */
  /**
   * Whether a document used the CSS property border-bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom(1074);

  /**
   * generated from use.counter.css.doc.css_border_bottom_color
   */
  /**
   * Whether a document used the CSS property border-bottom-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_color(1075);

  /**
   * generated from use.counter.css.doc.css_border_bottom_left_radius
   */
  /**
   * Whether a document used the CSS property border-bottom-left-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_left_radius(1076);

  /**
   * generated from use.counter.css.doc.css_border_bottom_right_radius
   */
  /**
   * Whether a document used the CSS property border-bottom-right-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_right_radius(1077);

  /**
   * generated from use.counter.css.doc.css_border_bottom_style
   */
  /**
   * Whether a document used the CSS property border-bottom-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_style(1078);

  /**
   * generated from use.counter.css.doc.css_border_bottom_width
   */
  /**
   * Whether a document used the CSS property border-bottom-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_width(1079);

  /**
   * generated from use.counter.css.doc.css_border_collapse
   */
  /**
   * Whether a document used the CSS property border-collapse. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_collapse(1080);

  /**
   * generated from use.counter.css.doc.css_border_color
   */
  /**
   * Whether a document used the CSS property border-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_color(1081);

  /**
   * generated from use.counter.css.doc.css_border_end_end_radius
   */
  /**
   * Whether a document used the CSS property border-end-end-radius. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_end_end_radius(1082);

  /**
   * generated from use.counter.css.doc.css_border_end_start_radius
   */
  /**
   * Whether a document used the CSS property border-end-start-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_end_start_radius(1083);

  /**
   * generated from use.counter.css.doc.css_border_image
   */
  /**
   * Whether a document used the CSS property border-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image(1084);

  /**
   * generated from use.counter.css.doc.css_border_image_outset
   */
  /**
   * Whether a document used the CSS property border-image-outset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_outset(1085);

  /**
   * generated from use.counter.css.doc.css_border_image_repeat
   */
  /**
   * Whether a document used the CSS property border-image-repeat. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_repeat(1086);

  /**
   * generated from use.counter.css.doc.css_border_image_slice
   */
  /**
   * Whether a document used the CSS property border-image-slice. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_slice(1087);

  /**
   * generated from use.counter.css.doc.css_border_image_source
   */
  /**
   * Whether a document used the CSS property border-image-source. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_source(1088);

  /**
   * generated from use.counter.css.doc.css_border_image_width
   */
  /**
   * Whether a document used the CSS property border-image-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_width(1089);

  /**
   * generated from use.counter.css.doc.css_border_inline
   */
  /**
   * Whether a document used the CSS property border-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline(1090);

  /**
   * generated from use.counter.css.doc.css_border_inline_color
   */
  /**
   * Whether a document used the CSS property border-inline-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_color(1091);

  /**
   * generated from use.counter.css.doc.css_border_inline_end
   */
  /**
   * Whether a document used the CSS property border-inline-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end(1092);

  /**
   * generated from use.counter.css.doc.css_border_inline_end_color
   */
  /**
   * Whether a document used the CSS property border-inline-end-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_color(1093);

  /**
   * generated from use.counter.css.doc.css_border_inline_end_style
   */
  /**
   * Whether a document used the CSS property border-inline-end-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_style(1094);

  /**
   * generated from use.counter.css.doc.css_border_inline_end_width
   */
  /**
   * Whether a document used the CSS property border-inline-end-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_width(1095);

  /**
   * generated from use.counter.css.doc.css_border_inline_start
   */
  /**
   * Whether a document used the CSS property border-inline-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start(1096);

  /**
   * generated from use.counter.css.doc.css_border_inline_start_color
   */
  /**
   * Whether a document used the CSS property border-inline-start-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_color(1097);

  /**
   * generated from use.counter.css.doc.css_border_inline_start_style
   */
  /**
   * Whether a document used the CSS property border-inline-start-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_style(1098);

  /**
   * generated from use.counter.css.doc.css_border_inline_start_width
   */
  /**
   * Whether a document used the CSS property border-inline-start-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_width(1099);

  /**
   * generated from use.counter.css.doc.css_border_inline_style
   */
  /**
   * Whether a document used the CSS property border-inline-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_style(1100);

  /**
   * generated from use.counter.css.doc.css_border_inline_width
   */
  /**
   * Whether a document used the CSS property border-inline-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_width(1101);

  /**
   * generated from use.counter.css.doc.css_border_left
   */
  /**
   * Whether a document used the CSS property border-left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left(1102);

  /**
   * generated from use.counter.css.doc.css_border_left_color
   */
  /**
   * Whether a document used the CSS property border-left-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_color(1103);

  /**
   * generated from use.counter.css.doc.css_border_left_style
   */
  /**
   * Whether a document used the CSS property border-left-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_style(1104);

  /**
   * generated from use.counter.css.doc.css_border_left_width
   */
  /**
   * Whether a document used the CSS property border-left-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_width(1105);

  /**
   * generated from use.counter.css.doc.css_border_radius
   */
  /**
   * Whether a document used the CSS property border-radius. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_radius(1106);

  /**
   * generated from use.counter.css.doc.css_border_right
   */
  /**
   * Whether a document used the CSS property border-right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right(1107);

  /**
   * generated from use.counter.css.doc.css_border_right_color
   */
  /**
   * Whether a document used the CSS property border-right-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_color(1108);

  /**
   * generated from use.counter.css.doc.css_border_right_style
   */
  /**
   * Whether a document used the CSS property border-right-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_style(1109);

  /**
   * generated from use.counter.css.doc.css_border_right_width
   */
  /**
   * Whether a document used the CSS property border-right-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_width(1110);

  /**
   * generated from use.counter.css.doc.css_border_spacing
   */
  /**
   * Whether a document used the CSS property border-spacing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_spacing(1111);

  /**
   * generated from use.counter.css.doc.css_border_start_end_radius
   */
  /**
   * Whether a document used the CSS property border-start-end-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_start_end_radius(1112);

  /**
   * generated from use.counter.css.doc.css_border_start_start_radius
   */
  /**
   * Whether a document used the CSS property border-start-start-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_start_start_radius(1113);

  /**
   * generated from use.counter.css.doc.css_border_style
   */
  /**
   * Whether a document used the CSS property border-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_style(1114);

  /**
   * generated from use.counter.css.doc.css_border_top
   */
  /**
   * Whether a document used the CSS property border-top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top(1115);

  /**
   * generated from use.counter.css.doc.css_border_top_color
   */
  /**
   * Whether a document used the CSS property border-top-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_color(1116);

  /**
   * generated from use.counter.css.doc.css_border_top_left_radius
   */
  /**
   * Whether a document used the CSS property border-top-left-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_left_radius(1117);

  /**
   * generated from use.counter.css.doc.css_border_top_right_radius
   */
  /**
   * Whether a document used the CSS property border-top-right-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_right_radius(1118);

  /**
   * generated from use.counter.css.doc.css_border_top_style
   */
  /**
   * Whether a document used the CSS property border-top-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_style(1119);

  /**
   * generated from use.counter.css.doc.css_border_top_width
   */
  /**
   * Whether a document used the CSS property border-top-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_width(1120);

  /**
   * generated from use.counter.css.doc.css_border_width
   */
  /**
   * Whether a document used the CSS property border-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_width(1121);

  /**
   * generated from use.counter.css.doc.css_bottom
   */
  /**
   * Whether a document used the CSS property bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_bottom(1122);

  /**
   * generated from use.counter.css.doc.css_box_decoration_break
   */
  /**
   * Whether a document used the CSS property box-decoration-break. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_decoration_break(1123);

  /**
   * generated from use.counter.css.doc.css_box_shadow
   */
  /**
   * Whether a document used the CSS property box-shadow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_shadow(1124);

  /**
   * generated from use.counter.css.doc.css_box_sizing
   */
  /**
   * Whether a document used the CSS property box-sizing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_sizing(1125);

  /**
   * generated from use.counter.css.doc.css_break_after
   */
  /**
   * Whether a document used the CSS property break-after. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_after(1126);

  /**
   * generated from use.counter.css.doc.css_break_before
   */
  /**
   * Whether a document used the CSS property break-before. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_before(1127);

  /**
   * generated from use.counter.css.doc.css_break_inside
   */
  /**
   * Whether a document used the CSS property break-inside. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_inside(1128);

  /**
   * generated from use.counter.css.doc.css_caption_side
   */
  /**
   * Whether a document used the CSS property caption-side. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_caption_side(1129);

  /**
   * generated from use.counter.css.doc.css_caret_color
   */
  /**
   * Whether a document used the CSS property caret-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_caret_color(1130);

  /**
   * generated from use.counter.css.doc.css_clear
   */
  /**
   * Whether a document used the CSS property clear. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clear(1131);

  /**
   * generated from use.counter.css.doc.css_clip
   */
  /**
   * Whether a document used the CSS property clip. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip(1132);

  /**
   * generated from use.counter.css.doc.css_clip_path
   */
  /**
   * Whether a document used the CSS property clip-path. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip_path(1133);

  /**
   * generated from use.counter.css.doc.css_clip_rule
   */
  /**
   * Whether a document used the CSS property clip-rule. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip_rule(1134);

  /**
   * generated from use.counter.css.doc.css_color
   */
  /**
   * Whether a document used the CSS property color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color(1135);

  /**
   * generated from use.counter.css.doc.css_color_adjust
   */
  /**
   * Whether a document used the CSS property color-adjust. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_adjust(1136);

  /**
   * generated from use.counter.css.doc.css_color_interpolation
   */
  /**
   * Whether a document used the CSS property color-interpolation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_interpolation(1137);

  /**
   * generated from use.counter.css.doc.css_color_interpolation_filters
   */
  /**
   * Whether a document used the CSS property color-interpolation-filters. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_interpolation_filters(1138);

  /**
   * generated from use.counter.css.doc.css_color_scheme
   */
  /**
   * Whether a document used the CSS property color-scheme. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_scheme(1139);

  /**
   * generated from use.counter.css.doc.css_column_count
   */
  /**
   * Whether a document used the CSS property column-count. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_count(1140);

  /**
   * generated from use.counter.css.doc.css_column_fill
   */
  /**
   * Whether a document used the CSS property column-fill. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_fill(1141);

  /**
   * generated from use.counter.css.doc.css_column_gap
   */
  /**
   * Whether a document used the CSS property column-gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_gap(1142);

  /**
   * generated from use.counter.css.doc.css_column_rule
   */
  /**
   * Whether a document used the CSS property column-rule. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule(1143);

  /**
   * generated from use.counter.css.doc.css_column_rule_color
   */
  /**
   * Whether a document used the CSS property column-rule-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_color(1144);

  /**
   * generated from use.counter.css.doc.css_column_rule_style
   */
  /**
   * Whether a document used the CSS property column-rule-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_style(1145);

  /**
   * generated from use.counter.css.doc.css_column_rule_width
   */
  /**
   * Whether a document used the CSS property column-rule-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_width(1146);

  /**
   * generated from use.counter.css.doc.css_column_span
   */
  /**
   * Whether a document used the CSS property column-span. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_span(1147);

  /**
   * generated from use.counter.css.doc.css_column_width
   */
  /**
   * Whether a document used the CSS property column-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_width(1148);

  /**
   * generated from use.counter.css.doc.css_columns
   */
  /**
   * Whether a document used the CSS property columns. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_columns(1149);

  /**
   * generated from use.counter.css.doc.css_contain
   */
  /**
   * Whether a document used the CSS property contain. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain(1150);

  /**
   * generated from use.counter.css.doc.css_contain_intrinsic_block_size
   */
  /**
   * Whether a document used the CSS property contain-intrinsic-block-size. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_block_size(1151);

  /**
   * generated from use.counter.css.doc.css_contain_intrinsic_height
   */
  /**
   * Whether a document used the CSS property contain-intrinsic-height. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_height(1152);

  /**
   * generated from use.counter.css.doc.css_contain_intrinsic_inline_size
   */
  /**
   * Whether a document used the CSS property contain-intrinsic-inline-size. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_inline_size(1153);

  /**
   * generated from use.counter.css.doc.css_contain_intrinsic_size
   */
  /**
   * Whether a document used the CSS property contain-intrinsic-size. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_size(1154);

  /**
   * generated from use.counter.css.doc.css_contain_intrinsic_width
   */
  /**
   * Whether a document used the CSS property contain-intrinsic-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_width(1155);

  /**
   * generated from use.counter.css.doc.css_container
   */
  /**
   * Whether a document used the CSS property container. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container(1156);

  /**
   * generated from use.counter.css.doc.css_container_name
   */
  /**
   * Whether a document used the CSS property container-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container_name(1157);

  /**
   * generated from use.counter.css.doc.css_container_type
   */
  /**
   * Whether a document used the CSS property container-type. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container_type(1158);

  /**
   * generated from use.counter.css.doc.css_content
   */
  /**
   * Whether a document used the CSS property content. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_content(1159);

  /**
   * generated from use.counter.css.doc.css_content_visibility
   */
  /**
   * Whether a document used the CSS property content-visibility. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_content_visibility(1160);

  /**
   * generated from use.counter.css.doc.css_counter_increment
   */
  /**
   * Whether a document used the CSS property counter-increment. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_increment(1161);

  /**
   * generated from use.counter.css.doc.css_counter_reset
   */
  /**
   * Whether a document used the CSS property counter-reset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_reset(1162);

  /**
   * generated from use.counter.css.doc.css_counter_set
   */
  /**
   * Whether a document used the CSS property counter-set. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_set(1163);

  /**
   * generated from use.counter.css.doc.css_cursor
   */
  /**
   * Whether a document used the CSS property cursor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cursor(1164);

  /**
   * generated from use.counter.css.doc.css_cx
   */
  /**
   * Whether a document used the CSS property cx. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cx(1165);

  /**
   * generated from use.counter.css.doc.css_cy
   */
  /**
   * Whether a document used the CSS property cy. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cy(1166);

  /**
   * generated from use.counter.css.doc.css_d
   */
  /**
   * Whether a document used the CSS property d. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_d(1167);

  /**
   * generated from use.counter.css.doc.css_direction
   */
  /**
   * Whether a document used the CSS property direction. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_direction(1168);

  /**
   * generated from use.counter.css.doc.css_display
   */
  /**
   * Whether a document used the CSS property display. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_display(1169);

  /**
   * generated from use.counter.css.doc.css_dominant_baseline
   */
  /**
   * Whether a document used the CSS property dominant-baseline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_dominant_baseline(1170);

  /**
   * generated from use.counter.css.doc.css_empty_cells
   */
  /**
   * Whether a document used the CSS property empty-cells. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_empty_cells(1171);

  /**
   * generated from use.counter.css.doc.css_field_sizing
   */
  /**
   * Whether a document used the CSS property field-sizing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_field_sizing(1172);

  /**
   * generated from use.counter.css.doc.css_fill
   */
  /**
   * Whether a document used the CSS property fill. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill(1173);

  /**
   * generated from use.counter.css.doc.css_fill_opacity
   */
  /**
   * Whether a document used the CSS property fill-opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill_opacity(1174);

  /**
   * generated from use.counter.css.doc.css_fill_rule
   */
  /**
   * Whether a document used the CSS property fill-rule. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill_rule(1175);

  /**
   * generated from use.counter.css.doc.css_filter
   */
  /**
   * Whether a document used the CSS property filter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_filter(1176);

  /**
   * generated from use.counter.css.doc.css_flex
   */
  /**
   * Whether a document used the CSS property flex. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex(1177);

  /**
   * generated from use.counter.css.doc.css_flex_basis
   */
  /**
   * Whether a document used the CSS property flex-basis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_basis(1178);

  /**
   * generated from use.counter.css.doc.css_flex_direction
   */
  /**
   * Whether a document used the CSS property flex-direction. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_direction(1179);

  /**
   * generated from use.counter.css.doc.css_flex_flow
   */
  /**
   * Whether a document used the CSS property flex-flow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_flow(1180);

  /**
   * generated from use.counter.css.doc.css_flex_grow
   */
  /**
   * Whether a document used the CSS property flex-grow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_grow(1181);

  /**
   * generated from use.counter.css.doc.css_flex_shrink
   */
  /**
   * Whether a document used the CSS property flex-shrink. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_shrink(1182);

  /**
   * generated from use.counter.css.doc.css_flex_wrap
   */
  /**
   * Whether a document used the CSS property flex-wrap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_wrap(1183);

  /**
   * generated from use.counter.css.doc.css_float
   */
  /**
   * Whether a document used the CSS property float. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_float(1184);

  /**
   * generated from use.counter.css.doc.css_flood_color
   */
  /**
   * Whether a document used the CSS property flood-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flood_color(1185);

  /**
   * generated from use.counter.css.doc.css_flood_opacity
   */
  /**
   * Whether a document used the CSS property flood-opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flood_opacity(1186);

  /**
   * generated from use.counter.css.doc.css_font
   */
  /**
   * Whether a document used the CSS property font. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font(1187);

  /**
   * generated from use.counter.css.doc.css_font_family
   */
  /**
   * Whether a document used the CSS property font-family. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_family(1188);

  /**
   * generated from use.counter.css.doc.css_font_feature_settings
   */
  /**
   * Whether a document used the CSS property font-feature-settings. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_feature_settings(1189);

  /**
   * generated from use.counter.css.doc.css_font_kerning
   */
  /**
   * Whether a document used the CSS property font-kerning. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_kerning(1190);

  /**
   * generated from use.counter.css.doc.css_font_language_override
   */
  /**
   * Whether a document used the CSS property font-language-override. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_language_override(1191);

  /**
   * generated from use.counter.css.doc.css_font_optical_sizing
   */
  /**
   * Whether a document used the CSS property font-optical-sizing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_optical_sizing(1192);

  /**
   * generated from use.counter.css.doc.css_font_palette
   */
  /**
   * Whether a document used the CSS property font-palette. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_palette(1193);

  /**
   * generated from use.counter.css.doc.css_font_size
   */
  /**
   * Whether a document used the CSS property font-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_size(1194);

  /**
   * generated from use.counter.css.doc.css_font_size_adjust
   */
  /**
   * Whether a document used the CSS property font-size-adjust. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_size_adjust(1195);

  /**
   * generated from use.counter.css.doc.css_font_stretch
   */
  /**
   * Whether a document used the CSS property font-stretch. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_stretch(1196);

  /**
   * generated from use.counter.css.doc.css_font_style
   */
  /**
   * Whether a document used the CSS property font-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_style(1197);

  /**
   * generated from use.counter.css.doc.css_font_synthesis
   */
  /**
   * Whether a document used the CSS property font-synthesis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis(1198);

  /**
   * generated from use.counter.css.doc.css_font_synthesis_position
   */
  /**
   * Whether a document used the CSS property font-synthesis-position. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_position(1199);

  /**
   * generated from use.counter.css.doc.css_font_synthesis_small_caps
   */
  /**
   * Whether a document used the CSS property font-synthesis-small-caps. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_small_caps(1200);

  /**
   * generated from use.counter.css.doc.css_font_synthesis_style
   */
  /**
   * Whether a document used the CSS property font-synthesis-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_style(1201);

  /**
   * generated from use.counter.css.doc.css_font_synthesis_weight
   */
  /**
   * Whether a document used the CSS property font-synthesis-weight. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_weight(1202);

  /**
   * generated from use.counter.css.doc.css_font_variant
   */
  /**
   * Whether a document used the CSS property font-variant. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant(1203);

  /**
   * generated from use.counter.css.doc.css_font_variant_alternates
   */
  /**
   * Whether a document used the CSS property font-variant-alternates. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_alternates(1204);

  /**
   * generated from use.counter.css.doc.css_font_variant_caps
   */
  /**
   * Whether a document used the CSS property font-variant-caps. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_caps(1205);

  /**
   * generated from use.counter.css.doc.css_font_variant_east_asian
   */
  /**
   * Whether a document used the CSS property font-variant-east-asian. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_east_asian(1206);

  /**
   * generated from use.counter.css.doc.css_font_variant_emoji
   */
  /**
   * Whether a document used the CSS property font-variant-emoji. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_emoji(1207);

  /**
   * generated from use.counter.css.doc.css_font_variant_ligatures
   */
  /**
   * Whether a document used the CSS property font-variant-ligatures. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_ligatures(1208);

  /**
   * generated from use.counter.css.doc.css_font_variant_numeric
   */
  /**
   * Whether a document used the CSS property font-variant-numeric. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_numeric(1209);

  /**
   * generated from use.counter.css.doc.css_font_variant_position
   */
  /**
   * Whether a document used the CSS property font-variant-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_position(1210);

  /**
   * generated from use.counter.css.doc.css_font_variation_settings
   */
  /**
   * Whether a document used the CSS property font-variation-settings. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variation_settings(1211);

  /**
   * generated from use.counter.css.doc.css_font_weight
   */
  /**
   * Whether a document used the CSS property font-weight. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_weight(1212);

  /**
   * generated from use.counter.css.doc.css_forced_color_adjust
   */
  /**
   * Whether a document used the CSS property forced-color-adjust. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_forced_color_adjust(1213);

  /**
   * generated from use.counter.css.doc.css_gap
   */
  /**
   * Whether a document used the CSS property gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_gap(1214);

  /**
   * generated from use.counter.css.doc.css_grid
   */
  /**
   * Whether a document used the CSS property grid. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid(1215);

  /**
   * generated from use.counter.css.doc.css_grid_area
   */
  /**
   * Whether a document used the CSS property grid-area. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_area(1216);

  /**
   * generated from use.counter.css.doc.css_grid_auto_columns
   */
  /**
   * Whether a document used the CSS property grid-auto-columns. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_columns(1217);

  /**
   * generated from use.counter.css.doc.css_grid_auto_flow
   */
  /**
   * Whether a document used the CSS property grid-auto-flow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_flow(1218);

  /**
   * generated from use.counter.css.doc.css_grid_auto_rows
   */
  /**
   * Whether a document used the CSS property grid-auto-rows. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_rows(1219);

  /**
   * generated from use.counter.css.doc.css_grid_column
   */
  /**
   * Whether a document used the CSS property grid-column. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column(1220);

  /**
   * generated from use.counter.css.doc.css_grid_column_end
   */
  /**
   * Whether a document used the CSS property grid-column-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_end(1221);

  /**
   * generated from use.counter.css.doc.css_grid_column_gap
   */
  /**
   * Whether a document used the CSS property grid-column-gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_gap(1222);

  /**
   * generated from use.counter.css.doc.css_grid_column_start
   */
  /**
   * Whether a document used the CSS property grid-column-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_start(1223);

  /**
   * generated from use.counter.css.doc.css_grid_gap
   */
  /**
   * Whether a document used the CSS property grid-gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_gap(1224);

  /**
   * generated from use.counter.css.doc.css_grid_row
   */
  /**
   * Whether a document used the CSS property grid-row. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row(1225);

  /**
   * generated from use.counter.css.doc.css_grid_row_end
   */
  /**
   * Whether a document used the CSS property grid-row-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_end(1226);

  /**
   * generated from use.counter.css.doc.css_grid_row_gap
   */
  /**
   * Whether a document used the CSS property grid-row-gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_gap(1227);

  /**
   * generated from use.counter.css.doc.css_grid_row_start
   */
  /**
   * Whether a document used the CSS property grid-row-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_start(1228);

  /**
   * generated from use.counter.css.doc.css_grid_template
   */
  /**
   * Whether a document used the CSS property grid-template. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template(1229);

  /**
   * generated from use.counter.css.doc.css_grid_template_areas
   */
  /**
   * Whether a document used the CSS property grid-template-areas. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_areas(1230);

  /**
   * generated from use.counter.css.doc.css_grid_template_columns
   */
  /**
   * Whether a document used the CSS property grid-template-columns. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_columns(1231);

  /**
   * generated from use.counter.css.doc.css_grid_template_rows
   */
  /**
   * Whether a document used the CSS property grid-template-rows. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_rows(1232);

  /**
   * generated from use.counter.css.doc.css_height
   */
  /**
   * Whether a document used the CSS property height. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_height(1233);

  /**
   * generated from use.counter.css.doc.css_hyphenate_character
   */
  /**
   * Whether a document used the CSS property hyphenate-character. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_hyphenate_character(1234);

  /**
   * generated from use.counter.css.doc.css_hyphens
   */
  /**
   * Whether a document used the CSS property hyphens. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_hyphens(1235);

  /**
   * generated from use.counter.css.doc.css_image_orientation
   */
  /**
   * Whether a document used the CSS property image-orientation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_image_orientation(1236);

  /**
   * generated from use.counter.css.doc.css_image_rendering
   */
  /**
   * Whether a document used the CSS property image-rendering. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_image_rendering(1237);

  /**
   * generated from use.counter.css.doc.css_ime_mode
   */
  /**
   * Whether a document used the CSS property ime-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ime_mode(1238);

  /**
   * generated from use.counter.css.doc.css_initial_letter
   */
  /**
   * Whether a document used the CSS property initial-letter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_initial_letter(1239);

  /**
   * generated from use.counter.css.doc.css_inline_size
   */
  /**
   * Whether a document used the CSS property inline-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inline_size(1240);

  /**
   * generated from use.counter.css.doc.css_inset
   */
  /**
   * Whether a document used the CSS property inset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset(1241);

  /**
   * generated from use.counter.css.doc.css_inset_block
   */
  /**
   * Whether a document used the CSS property inset-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block(1242);

  /**
   * generated from use.counter.css.doc.css_inset_block_end
   */
  /**
   * Whether a document used the CSS property inset-block-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block_end(1243);

  /**
   * generated from use.counter.css.doc.css_inset_block_start
   */
  /**
   * Whether a document used the CSS property inset-block-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block_start(1244);

  /**
   * generated from use.counter.css.doc.css_inset_inline
   */
  /**
   * Whether a document used the CSS property inset-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline(1245);

  /**
   * generated from use.counter.css.doc.css_inset_inline_end
   */
  /**
   * Whether a document used the CSS property inset-inline-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline_end(1246);

  /**
   * generated from use.counter.css.doc.css_inset_inline_start
   */
  /**
   * Whether a document used the CSS property inset-inline-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline_start(1247);

  /**
   * generated from use.counter.css.doc.css_isolation
   */
  /**
   * Whether a document used the CSS property isolation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_isolation(1248);

  /**
   * generated from use.counter.css.doc.css_justify_content
   */
  /**
   * Whether a document used the CSS property justify-content. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_content(1249);

  /**
   * generated from use.counter.css.doc.css_justify_items
   */
  /**
   * Whether a document used the CSS property justify-items. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_items(1250);

  /**
   * generated from use.counter.css.doc.css_justify_self
   */
  /**
   * Whether a document used the CSS property justify-self. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_self(1251);

  /**
   * generated from use.counter.css.doc.css_left
   */
  /**
   * Whether a document used the CSS property left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_left(1252);

  /**
   * generated from use.counter.css.doc.css_letter_spacing
   */
  /**
   * Whether a document used the CSS property letter-spacing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_letter_spacing(1253);

  /**
   * generated from use.counter.css.doc.css_lighting_color
   */
  /**
   * Whether a document used the CSS property lighting-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_lighting_color(1254);

  /**
   * generated from use.counter.css.doc.css_line_break
   */
  /**
   * Whether a document used the CSS property line-break. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_line_break(1255);

  /**
   * generated from use.counter.css.doc.css_line_height
   */
  /**
   * Whether a document used the CSS property line-height. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_line_height(1256);

  /**
   * generated from use.counter.css.doc.css_list_style
   */
  /**
   * Whether a document used the CSS property list-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style(1257);

  /**
   * generated from use.counter.css.doc.css_list_style_image
   */
  /**
   * Whether a document used the CSS property list-style-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_image(1258);

  /**
   * generated from use.counter.css.doc.css_list_style_position
   */
  /**
   * Whether a document used the CSS property list-style-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_position(1259);

  /**
   * generated from use.counter.css.doc.css_list_style_type
   */
  /**
   * Whether a document used the CSS property list-style-type. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_type(1260);

  /**
   * generated from use.counter.css.doc.css_margin
   */
  /**
   * Whether a document used the CSS property margin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin(1261);

  /**
   * generated from use.counter.css.doc.css_margin_block
   */
  /**
   * Whether a document used the CSS property margin-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block(1262);

  /**
   * generated from use.counter.css.doc.css_margin_block_end
   */
  /**
   * Whether a document used the CSS property margin-block-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block_end(1263);

  /**
   * generated from use.counter.css.doc.css_margin_block_start
   */
  /**
   * Whether a document used the CSS property margin-block-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block_start(1264);

  /**
   * generated from use.counter.css.doc.css_margin_bottom
   */
  /**
   * Whether a document used the CSS property margin-bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_bottom(1265);

  /**
   * generated from use.counter.css.doc.css_margin_inline
   */
  /**
   * Whether a document used the CSS property margin-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline(1266);

  /**
   * generated from use.counter.css.doc.css_margin_inline_end
   */
  /**
   * Whether a document used the CSS property margin-inline-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline_end(1267);

  /**
   * generated from use.counter.css.doc.css_margin_inline_start
   */
  /**
   * Whether a document used the CSS property margin-inline-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline_start(1268);

  /**
   * generated from use.counter.css.doc.css_margin_left
   */
  /**
   * Whether a document used the CSS property margin-left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_left(1269);

  /**
   * generated from use.counter.css.doc.css_margin_right
   */
  /**
   * Whether a document used the CSS property margin-right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_right(1270);

  /**
   * generated from use.counter.css.doc.css_margin_top
   */
  /**
   * Whether a document used the CSS property margin-top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_top(1271);

  /**
   * generated from use.counter.css.doc.css_marker
   */
  /**
   * Whether a document used the CSS property marker. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker(1272);

  /**
   * generated from use.counter.css.doc.css_marker_end
   */
  /**
   * Whether a document used the CSS property marker-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_end(1273);

  /**
   * generated from use.counter.css.doc.css_marker_mid
   */
  /**
   * Whether a document used the CSS property marker-mid. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_mid(1274);

  /**
   * generated from use.counter.css.doc.css_marker_start
   */
  /**
   * Whether a document used the CSS property marker-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_start(1275);

  /**
   * generated from use.counter.css.doc.css_mask
   */
  /**
   * Whether a document used the CSS property mask. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask(1276);

  /**
   * generated from use.counter.css.doc.css_mask_clip
   */
  /**
   * Whether a document used the CSS property mask-clip. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_clip(1277);

  /**
   * generated from use.counter.css.doc.css_mask_composite
   */
  /**
   * Whether a document used the CSS property mask-composite. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_composite(1278);

  /**
   * generated from use.counter.css.doc.css_mask_image
   */
  /**
   * Whether a document used the CSS property mask-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_image(1279);

  /**
   * generated from use.counter.css.doc.css_mask_mode
   */
  /**
   * Whether a document used the CSS property mask-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_mode(1280);

  /**
   * generated from use.counter.css.doc.css_mask_origin
   */
  /**
   * Whether a document used the CSS property mask-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_origin(1281);

  /**
   * generated from use.counter.css.doc.css_mask_position
   */
  /**
   * Whether a document used the CSS property mask-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position(1282);

  /**
   * generated from use.counter.css.doc.css_mask_position_x
   */
  /**
   * Whether a document used the CSS property mask-position-x. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position_x(1283);

  /**
   * generated from use.counter.css.doc.css_mask_position_y
   */
  /**
   * Whether a document used the CSS property mask-position-y. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position_y(1284);

  /**
   * generated from use.counter.css.doc.css_mask_repeat
   */
  /**
   * Whether a document used the CSS property mask-repeat. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_repeat(1285);

  /**
   * generated from use.counter.css.doc.css_mask_size
   */
  /**
   * Whether a document used the CSS property mask-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_size(1286);

  /**
   * generated from use.counter.css.doc.css_mask_type
   */
  /**
   * Whether a document used the CSS property mask-type. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_type(1287);

  /**
   * generated from use.counter.css.doc.css_masonry_auto_flow
   */
  /**
   * Whether a document used the CSS property masonry-auto-flow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_masonry_auto_flow(1288);

  /**
   * generated from use.counter.css.doc.css_math_depth
   */
  /**
   * Whether a document used the CSS property math-depth. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_math_depth(1289);

  /**
   * generated from use.counter.css.doc.css_math_style
   */
  /**
   * Whether a document used the CSS property math-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_math_style(1290);

  /**
   * generated from use.counter.css.doc.css_max_block_size
   */
  /**
   * Whether a document used the CSS property max-block-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_block_size(1291);

  /**
   * generated from use.counter.css.doc.css_max_height
   */
  /**
   * Whether a document used the CSS property max-height. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_height(1292);

  /**
   * generated from use.counter.css.doc.css_max_inline_size
   */
  /**
   * Whether a document used the CSS property max-inline-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_inline_size(1293);

  /**
   * generated from use.counter.css.doc.css_max_width
   */
  /**
   * Whether a document used the CSS property max-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_width(1294);

  /**
   * generated from use.counter.css.doc.css_min_block_size
   */
  /**
   * Whether a document used the CSS property min-block-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_block_size(1295);

  /**
   * generated from use.counter.css.doc.css_min_height
   */
  /**
   * Whether a document used the CSS property min-height. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_height(1296);

  /**
   * generated from use.counter.css.doc.css_min_inline_size
   */
  /**
   * Whether a document used the CSS property min-inline-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_inline_size(1297);

  /**
   * generated from use.counter.css.doc.css_min_width
   */
  /**
   * Whether a document used the CSS property min-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_width(1298);

  /**
   * generated from use.counter.css.doc.css_mix_blend_mode
   */
  /**
   * Whether a document used the CSS property mix-blend-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mix_blend_mode(1299);

  /**
   * generated from use.counter.css.doc.css_moz_animation
   */
  /**
   * Whether a document used the CSS property -moz-animation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation(1300);

  /**
   * generated from use.counter.css.doc.css_moz_animation_delay
   */
  /**
   * Whether a document used the CSS property -moz-animation-delay. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_delay(1301);

  /**
   * generated from use.counter.css.doc.css_moz_animation_direction
   */
  /**
   * Whether a document used the CSS property -moz-animation-direction. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_direction(1302);

  /**
   * generated from use.counter.css.doc.css_moz_animation_duration
   */
  /**
   * Whether a document used the CSS property -moz-animation-duration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_duration(1303);

  /**
   * generated from use.counter.css.doc.css_moz_animation_fill_mode
   */
  /**
   * Whether a document used the CSS property -moz-animation-fill-mode. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_fill_mode(1304);

  /**
   * generated from use.counter.css.doc.css_moz_animation_iteration_count
   */
  /**
   * Whether a document used the CSS property -moz-animation-iteration-count.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_animation_iteration_count(1305);

  /**
   * generated from use.counter.css.doc.css_moz_animation_name
   */
  /**
   * Whether a document used the CSS property -moz-animation-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_name(1306);

  /**
   * generated from use.counter.css.doc.css_moz_animation_play_state
   */
  /**
   * Whether a document used the CSS property -moz-animation-play-state. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_play_state(1307);

  /**
   * generated from use.counter.css.doc.css_moz_animation_timing_function
   */
  /**
   * Whether a document used the CSS property -moz-animation-timing-function.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_animation_timing_function(1308);

  /**
   * generated from use.counter.css.doc.css_moz_appearance
   */
  /**
   * Whether a document used the CSS property -moz-appearance. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_appearance(1309);

  /**
   * generated from use.counter.css.doc.css_moz_backface_visibility
   */
  /**
   * Whether a document used the CSS property -moz-backface-visibility. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_backface_visibility(1310);

  /**
   * generated from use.counter.css.doc.css_moz_border_end
   */
  /**
   * Whether a document used the CSS property -moz-border-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end(1311);

  /**
   * generated from use.counter.css.doc.css_moz_border_end_color
   */
  /**
   * Whether a document used the CSS property -moz-border-end-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_color(1312);

  /**
   * generated from use.counter.css.doc.css_moz_border_end_style
   */
  /**
   * Whether a document used the CSS property -moz-border-end-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_style(1313);

  /**
   * generated from use.counter.css.doc.css_moz_border_end_width
   */
  /**
   * Whether a document used the CSS property -moz-border-end-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_width(1314);

  /**
   * generated from use.counter.css.doc.css_moz_border_image
   */
  /**
   * Whether a document used the CSS property -moz-border-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_image(1315);

  /**
   * generated from use.counter.css.doc.css_moz_border_start
   */
  /**
   * Whether a document used the CSS property -moz-border-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start(1316);

  /**
   * generated from use.counter.css.doc.css_moz_border_start_color
   */
  /**
   * Whether a document used the CSS property -moz-border-start-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_color(1317);

  /**
   * generated from use.counter.css.doc.css_moz_border_start_style
   */
  /**
   * Whether a document used the CSS property -moz-border-start-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_style(1318);

  /**
   * generated from use.counter.css.doc.css_moz_border_start_width
   */
  /**
   * Whether a document used the CSS property -moz-border-start-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_width(1319);

  /**
   * generated from use.counter.css.doc.css_moz_box_align
   */
  /**
   * Whether a document used the CSS property -moz-box-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_align(1320);

  /**
   * generated from use.counter.css.doc.css_moz_box_collapse
   */
  /**
   * Whether a document used the CSS property -moz-box-collapse. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_collapse(1321);

  /**
   * generated from use.counter.css.doc.css_moz_box_direction
   */
  /**
   * Whether a document used the CSS property -moz-box-direction. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_direction(1322);

  /**
   * generated from use.counter.css.doc.css_moz_box_flex
   */
  /**
   * Whether a document used the CSS property -moz-box-flex. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_flex(1323);

  /**
   * generated from use.counter.css.doc.css_moz_box_ordinal_group
   */
  /**
   * Whether a document used the CSS property -moz-box-ordinal-group. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_ordinal_group(1324);

  /**
   * generated from use.counter.css.doc.css_moz_box_orient
   */
  /**
   * Whether a document used the CSS property -moz-box-orient. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_orient(1325);

  /**
   * generated from use.counter.css.doc.css_moz_box_pack
   */
  /**
   * Whether a document used the CSS property -moz-box-pack. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_pack(1326);

  /**
   * generated from use.counter.css.doc.css_moz_box_sizing
   */
  /**
   * Whether a document used the CSS property -moz-box-sizing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_sizing(1327);

  /**
   * generated from use.counter.css.doc.css_moz_context_properties
   */
  /**
   * Whether a document used the CSS property -moz-context-properties. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_context_properties(1328);

  /**
   * generated from use.counter.css.doc.css_moz_control_character_visibility
   */
  /**
   * Whether a document used the CSS property -moz-control-character-visibility.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_control_character_visibility(1329);

  /**
   * generated from use.counter.css.doc.css_moz_default_appearance
   */
  /**
   * Whether a document used the CSS property -moz-default-appearance. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_default_appearance(1330);

  /**
   * generated from use.counter.css.doc.css_moz_float_edge
   */
  /**
   * Whether a document used the CSS property -moz-float-edge. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_float_edge(1331);

  /**
   * generated from use.counter.css.doc.css_moz_font_feature_settings
   */
  /**
   * Whether a document used the CSS property -moz-font-feature-settings. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_font_feature_settings(1332);

  /**
   * generated from use.counter.css.doc.css_moz_font_language_override
   */
  /**
   * Whether a document used the CSS property -moz-font-language-override. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_font_language_override(1333);

  /**
   * generated from use.counter.css.doc.css_moz_force_broken_image_icon
   */
  /**
   * Whether a document used the CSS property -moz-force-broken-image-icon. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_force_broken_image_icon(1334);

  /**
   * generated from use.counter.css.doc.css_moz_hyphens
   */
  /**
   * Whether a document used the CSS property -moz-hyphens. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_hyphens(1335);

  /**
   * generated from use.counter.css.doc.css_moz_inert
   */
  /**
   * Whether a document used the CSS property -moz-inert. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_inert(1336);

  /**
   * generated from use.counter.css.doc.css_moz_margin_end
   */
  /**
   * Whether a document used the CSS property -moz-margin-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_margin_end(1337);

  /**
   * generated from use.counter.css.doc.css_moz_margin_start
   */
  /**
   * Whether a document used the CSS property -moz-margin-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_margin_start(1338);

  /**
   * generated from use.counter.css.doc.css_moz_math_variant
   */
  /**
   * Whether a document used the CSS property -moz-math-variant. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_math_variant(1339);

  /**
   * generated from use.counter.css.doc.css_moz_min_font_size_ratio
   */
  /**
   * Whether a document used the CSS property -moz-min-font-size-ratio. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_min_font_size_ratio(1340);

  /**
   * generated from use.counter.css.doc.css_moz_orient
   */
  /**
   * Whether a document used the CSS property -moz-orient. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_orient(1341);

  /**
   * generated from use.counter.css.doc.css_moz_osx_font_smoothing
   */
  /**
   * Whether a document used the CSS property -moz-osx-font-smoothing. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_osx_font_smoothing(1342);

  /**
   * generated from use.counter.css.doc.css_moz_padding_end
   */
  /**
   * Whether a document used the CSS property -moz-padding-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_padding_end(1343);

  /**
   * generated from use.counter.css.doc.css_moz_padding_start
   */
  /**
   * Whether a document used the CSS property -moz-padding-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_padding_start(1344);

  /**
   * generated from use.counter.css.doc.css_moz_perspective
   */
  /**
   * Whether a document used the CSS property -moz-perspective. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_perspective(1345);

  /**
   * generated from use.counter.css.doc.css_moz_perspective_origin
   */
  /**
   * Whether a document used the CSS property -moz-perspective-origin. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_perspective_origin(1346);

  /**
   * generated from use.counter.css.doc.css_moz_subtree_hidden_only_visually
   */
  /**
   * Whether a document used the CSS property -moz-subtree-hidden-only-visually.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_subtree_hidden_only_visually(1347);

  /**
   * generated from use.counter.css.doc.css_moz_tab_size
   */
  /**
   * Whether a document used the CSS property -moz-tab-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_tab_size(1348);

  /**
   * generated from use.counter.css.doc.css_moz_text_size_adjust
   */
  /**
   * Whether a document used the CSS property -moz-text-size-adjust. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_text_size_adjust(1349);

  /**
   * generated from use.counter.css.doc.css_moz_theme
   */
  /**
   * Whether a document used the CSS property -moz-theme. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_theme(1350);

  /**
   * generated from use.counter.css.doc.css_moz_top_layer
   */
  /**
   * Whether a document used the CSS property -moz-top-layer. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_top_layer(1351);

  /**
   * generated from use.counter.css.doc.css_moz_transform
   */
  /**
   * Whether a document used the CSS property -moz-transform. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform(1352);

  /**
   * generated from use.counter.css.doc.css_moz_transform_origin
   */
  /**
   * Whether a document used the CSS property -moz-transform-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform_origin(1353);

  /**
   * generated from use.counter.css.doc.css_moz_transform_style
   */
  /**
   * Whether a document used the CSS property -moz-transform-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform_style(1354);

  /**
   * generated from use.counter.css.doc.css_moz_transition
   */
  /**
   * Whether a document used the CSS property -moz-transition. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition(1355);

  /**
   * generated from use.counter.css.doc.css_moz_transition_delay
   */
  /**
   * Whether a document used the CSS property -moz-transition-delay. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_delay(1356);

  /**
   * generated from use.counter.css.doc.css_moz_transition_duration
   */
  /**
   * Whether a document used the CSS property -moz-transition-duration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_duration(1357);

  /**
   * generated from use.counter.css.doc.css_moz_transition_property
   */
  /**
   * Whether a document used the CSS property -moz-transition-property. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_property(1358);

  /**
   * generated from use.counter.css.doc.css_moz_transition_timing_function
   */
  /**
   * Whether a document used the CSS property -moz-transition-timing-function.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_transition_timing_function(1359);

  /**
   * generated from use.counter.css.doc.css_moz_user_focus
   */
  /**
   * Whether a document used the CSS property -moz-user-focus. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_focus(1360);

  /**
   * generated from use.counter.css.doc.css_moz_user_input
   */
  /**
   * Whether a document used the CSS property -moz-user-input. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_input(1361);

  /**
   * generated from use.counter.css.doc.css_moz_user_select
   */
  /**
   * Whether a document used the CSS property -moz-user-select. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_select(1362);

  /**
   * generated from use.counter.css.doc.css_moz_window_dragging
   */
  /**
   * Whether a document used the CSS property -moz-window-dragging. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_dragging(1363);

  /**
   * generated from use.counter.css.doc.css_moz_window_input_region_margin
   */
  /**
   * Whether a document used the CSS property -moz-window-input-region-margin.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_window_input_region_margin(1364);

  /**
   * generated from use.counter.css.doc.css_moz_window_opacity
   */
  /**
   * Whether a document used the CSS property -moz-window-opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_opacity(1365);

  /**
   * generated from use.counter.css.doc.css_moz_window_shadow
   */
  /**
   * Whether a document used the CSS property -moz-window-shadow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_shadow(1366);

  /**
   * generated from use.counter.css.doc.css_moz_window_transform
   */
  /**
   * Whether a document used the CSS property -moz-window-transform. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_transform(1367);

  /**
   * generated from use.counter.css.doc.css_object_fit
   */
  /**
   * Whether a document used the CSS property object-fit. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_object_fit(1368);

  /**
   * generated from use.counter.css.doc.css_object_position
   */
  /**
   * Whether a document used the CSS property object-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_object_position(1369);

  /**
   * generated from use.counter.css.doc.css_offset
   */
  /**
   * Whether a document used the CSS property offset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset(1370);

  /**
   * generated from use.counter.css.doc.css_offset_anchor
   */
  /**
   * Whether a document used the CSS property offset-anchor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_anchor(1371);

  /**
   * generated from use.counter.css.doc.css_offset_distance
   */
  /**
   * Whether a document used the CSS property offset-distance. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_distance(1372);

  /**
   * generated from use.counter.css.doc.css_offset_path
   */
  /**
   * Whether a document used the CSS property offset-path. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_path(1373);

  /**
   * generated from use.counter.css.doc.css_offset_position
   */
  /**
   * Whether a document used the CSS property offset-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_position(1374);

  /**
   * generated from use.counter.css.doc.css_offset_rotate
   */
  /**
   * Whether a document used the CSS property offset-rotate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_rotate(1375);

  /**
   * generated from use.counter.css.doc.css_opacity
   */
  /**
   * Whether a document used the CSS property opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_opacity(1376);

  /**
   * generated from use.counter.css.doc.css_order
   */
  /**
   * Whether a document used the CSS property order. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_order(1377);

  /**
   * generated from use.counter.css.doc.css_outline
   */
  /**
   * Whether a document used the CSS property outline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline(1378);

  /**
   * generated from use.counter.css.doc.css_outline_color
   */
  /**
   * Whether a document used the CSS property outline-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_color(1379);

  /**
   * generated from use.counter.css.doc.css_outline_offset
   */
  /**
   * Whether a document used the CSS property outline-offset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_offset(1380);

  /**
   * generated from use.counter.css.doc.css_outline_style
   */
  /**
   * Whether a document used the CSS property outline-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_style(1381);

  /**
   * generated from use.counter.css.doc.css_outline_width
   */
  /**
   * Whether a document used the CSS property outline-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_width(1382);

  /**
   * generated from use.counter.css.doc.css_overflow
   */
  /**
   * Whether a document used the CSS property overflow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow(1383);

  /**
   * generated from use.counter.css.doc.css_overflow_anchor
   */
  /**
   * Whether a document used the CSS property overflow-anchor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_anchor(1384);

  /**
   * generated from use.counter.css.doc.css_overflow_block
   */
  /**
   * Whether a document used the CSS property overflow-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_block(1385);

  /**
   * generated from use.counter.css.doc.css_overflow_clip_box
   */
  /**
   * Whether a document used the CSS property overflow-clip-box. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box(1386);

  /**
   * generated from use.counter.css.doc.css_overflow_clip_box_block
   */
  /**
   * Whether a document used the CSS property overflow-clip-box-block. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box_block(1387);

  /**
   * generated from use.counter.css.doc.css_overflow_clip_box_inline
   */
  /**
   * Whether a document used the CSS property overflow-clip-box-inline. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box_inline(1388);

  /**
   * generated from use.counter.css.doc.css_overflow_clip_margin
   */
  /**
   * Whether a document used the CSS property overflow-clip-margin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_margin(1389);

  /**
   * generated from use.counter.css.doc.css_overflow_inline
   */
  /**
   * Whether a document used the CSS property overflow-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_inline(1390);

  /**
   * generated from use.counter.css.doc.css_overflow_wrap
   */
  /**
   * Whether a document used the CSS property overflow-wrap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_wrap(1391);

  /**
   * generated from use.counter.css.doc.css_overflow_x
   */
  /**
   * Whether a document used the CSS property overflow-x. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_x(1392);

  /**
   * generated from use.counter.css.doc.css_overflow_y
   */
  /**
   * Whether a document used the CSS property overflow-y. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_y(1393);

  /**
   * generated from use.counter.css.doc.css_overscroll_behavior
   */
  /**
   * Whether a document used the CSS property overscroll-behavior. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior(1394);

  /**
   * generated from use.counter.css.doc.css_overscroll_behavior_block
   */
  /**
   * Whether a document used the CSS property overscroll-behavior-block. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_block(1395);

  /**
   * generated from use.counter.css.doc.css_overscroll_behavior_inline
   */
  /**
   * Whether a document used the CSS property overscroll-behavior-inline. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_inline(1396);

  /**
   * generated from use.counter.css.doc.css_overscroll_behavior_x
   */
  /**
   * Whether a document used the CSS property overscroll-behavior-x. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_x(1397);

  /**
   * generated from use.counter.css.doc.css_overscroll_behavior_y
   */
  /**
   * Whether a document used the CSS property overscroll-behavior-y. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_y(1398);

  /**
   * generated from use.counter.css.doc.css_padding
   */
  /**
   * Whether a document used the CSS property padding. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding(1399);

  /**
   * generated from use.counter.css.doc.css_padding_block
   */
  /**
   * Whether a document used the CSS property padding-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block(1400);

  /**
   * generated from use.counter.css.doc.css_padding_block_end
   */
  /**
   * Whether a document used the CSS property padding-block-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block_end(1401);

  /**
   * generated from use.counter.css.doc.css_padding_block_start
   */
  /**
   * Whether a document used the CSS property padding-block-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block_start(1402);

  /**
   * generated from use.counter.css.doc.css_padding_bottom
   */
  /**
   * Whether a document used the CSS property padding-bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_bottom(1403);

  /**
   * generated from use.counter.css.doc.css_padding_inline
   */
  /**
   * Whether a document used the CSS property padding-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline(1404);

  /**
   * generated from use.counter.css.doc.css_padding_inline_end
   */
  /**
   * Whether a document used the CSS property padding-inline-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline_end(1405);

  /**
   * generated from use.counter.css.doc.css_padding_inline_start
   */
  /**
   * Whether a document used the CSS property padding-inline-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline_start(1406);

  /**
   * generated from use.counter.css.doc.css_padding_left
   */
  /**
   * Whether a document used the CSS property padding-left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_left(1407);

  /**
   * generated from use.counter.css.doc.css_padding_right
   */
  /**
   * Whether a document used the CSS property padding-right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_right(1408);

  /**
   * generated from use.counter.css.doc.css_padding_top
   */
  /**
   * Whether a document used the CSS property padding-top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_top(1409);

  /**
   * generated from use.counter.css.doc.css_page
   */
  /**
   * Whether a document used the CSS property page. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page(1410);

  /**
   * generated from use.counter.css.doc.css_page_break_after
   */
  /**
   * Whether a document used the CSS property page-break-after. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_after(1411);

  /**
   * generated from use.counter.css.doc.css_page_break_before
   */
  /**
   * Whether a document used the CSS property page-break-before. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_before(1412);

  /**
   * generated from use.counter.css.doc.css_page_break_inside
   */
  /**
   * Whether a document used the CSS property page-break-inside. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_inside(1413);

  /**
   * generated from use.counter.css.doc.css_page_orientation
   */
  /**
   * Whether a document used the CSS property page-orientation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_orientation(1414);

  /**
   * generated from use.counter.css.doc.css_paint_order
   */
  /**
   * Whether a document used the CSS property paint-order. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_paint_order(1415);

  /**
   * generated from use.counter.css.doc.css_perspective
   */
  /**
   * Whether a document used the CSS property perspective. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_perspective(1416);

  /**
   * generated from use.counter.css.doc.css_perspective_origin
   */
  /**
   * Whether a document used the CSS property perspective-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_perspective_origin(1417);

  /**
   * generated from use.counter.css.doc.css_place_content
   */
  /**
   * Whether a document used the CSS property place-content. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_content(1418);

  /**
   * generated from use.counter.css.doc.css_place_items
   */
  /**
   * Whether a document used the CSS property place-items. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_items(1419);

  /**
   * generated from use.counter.css.doc.css_place_self
   */
  /**
   * Whether a document used the CSS property place-self. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_self(1420);

  /**
   * generated from use.counter.css.doc.css_pointer_events
   */
  /**
   * Whether a document used the CSS property pointer-events. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_pointer_events(1421);

  /**
   * generated from use.counter.css.doc.css_position
   */
  /**
   * Whether a document used the CSS property position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position(1422);

  /**
   * generated from use.counter.css.doc.css_position_anchor
   */
  /**
   * Whether a document used the CSS property position-anchor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_anchor(1423);

  /**
   * generated from use.counter.css.doc.css_position_area
   */
  /**
   * Whether a document used the CSS property position-area. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_area(1424);

  /**
   * generated from use.counter.css.doc.css_position_try
   */
  /**
   * Whether a document used the CSS property position-try. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_try(1425);

  /**
   * generated from use.counter.css.doc.css_position_try_fallbacks
   */
  /**
   * Whether a document used the CSS property position-try-fallbacks. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_try_fallbacks(1426);

  /**
   * generated from use.counter.css.doc.css_position_try_order
   */
  /**
   * Whether a document used the CSS property position-try-order. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_try_order(1427);

  /**
   * generated from use.counter.css.doc.css_position_visibility
   */
  /**
   * Whether a document used the CSS property position-visibility. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_visibility(1428);

  /**
   * generated from use.counter.css.doc.css_print_color_adjust
   */
  /**
   * Whether a document used the CSS property print-color-adjust. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_print_color_adjust(1429);

  /**
   * generated from use.counter.css.doc.css_quotes
   */
  /**
   * Whether a document used the CSS property quotes. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_quotes(1430);

  /**
   * generated from use.counter.css.doc.css_r
   */
  /**
   * Whether a document used the CSS property r. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_r(1431);

  /**
   * generated from use.counter.css.doc.css_resize
   */
  /**
   * Whether a document used the CSS property resize. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_resize(1432);

  /**
   * generated from use.counter.css.doc.css_right
   */
  /**
   * Whether a document used the CSS property right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_right(1433);

  /**
   * generated from use.counter.css.doc.css_rotate
   */
  /**
   * Whether a document used the CSS property rotate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_rotate(1434);

  /**
   * generated from use.counter.css.doc.css_row_gap
   */
  /**
   * Whether a document used the CSS property row-gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_row_gap(1435);

  /**
   * generated from use.counter.css.doc.css_ruby_align
   */
  /**
   * Whether a document used the CSS property ruby-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ruby_align(1436);

  /**
   * generated from use.counter.css.doc.css_ruby_position
   */
  /**
   * Whether a document used the CSS property ruby-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ruby_position(1437);

  /**
   * generated from use.counter.css.doc.css_rx
   */
  /**
   * Whether a document used the CSS property rx. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_rx(1438);

  /**
   * generated from use.counter.css.doc.css_ry
   */
  /**
   * Whether a document used the CSS property ry. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ry(1439);

  /**
   * generated from use.counter.css.doc.css_scale
   */
  /**
   * Whether a document used the CSS property scale. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scale(1440);

  /**
   * generated from use.counter.css.doc.css_scroll_behavior
   */
  /**
   * Whether a document used the CSS property scroll-behavior. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_behavior(1441);

  /**
   * generated from use.counter.css.doc.css_scroll_margin
   */
  /**
   * Whether a document used the CSS property scroll-margin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin(1442);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_block
   */
  /**
   * Whether a document used the CSS property scroll-margin-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block(1443);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_block_end
   */
  /**
   * Whether a document used the CSS property scroll-margin-block-end. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block_end(1444);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_block_start
   */
  /**
   * Whether a document used the CSS property scroll-margin-block-start. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block_start(1445);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_bottom
   */
  /**
   * Whether a document used the CSS property scroll-margin-bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_bottom(1446);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_inline
   */
  /**
   * Whether a document used the CSS property scroll-margin-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline(1447);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_inline_end
   */
  /**
   * Whether a document used the CSS property scroll-margin-inline-end. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline_end(1448);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_inline_start
   */
  /**
   * Whether a document used the CSS property scroll-margin-inline-start. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline_start(1449);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_left
   */
  /**
   * Whether a document used the CSS property scroll-margin-left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_left(1450);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_right
   */
  /**
   * Whether a document used the CSS property scroll-margin-right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_right(1451);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_top
   */
  /**
   * Whether a document used the CSS property scroll-margin-top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_top(1452);

  /**
   * generated from use.counter.css.doc.css_scroll_padding
   */
  /**
   * Whether a document used the CSS property scroll-padding. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding(1453);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_block
   */
  /**
   * Whether a document used the CSS property scroll-padding-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block(1454);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_block_end
   */
  /**
   * Whether a document used the CSS property scroll-padding-block-end. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block_end(1455);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_block_start
   */
  /**
   * Whether a document used the CSS property scroll-padding-block-start. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block_start(1456);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_bottom
   */
  /**
   * Whether a document used the CSS property scroll-padding-bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_bottom(1457);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_inline
   */
  /**
   * Whether a document used the CSS property scroll-padding-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline(1458);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_inline_end
   */
  /**
   * Whether a document used the CSS property scroll-padding-inline-end. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline_end(1459);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_inline_start
   */
  /**
   * Whether a document used the CSS property scroll-padding-inline-start. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline_start(1460);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_left
   */
  /**
   * Whether a document used the CSS property scroll-padding-left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_left(1461);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_right
   */
  /**
   * Whether a document used the CSS property scroll-padding-right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_right(1462);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_top
   */
  /**
   * Whether a document used the CSS property scroll-padding-top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_top(1463);

  /**
   * generated from use.counter.css.doc.css_scroll_snap_align
   */
  /**
   * Whether a document used the CSS property scroll-snap-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_align(1464);

  /**
   * generated from use.counter.css.doc.css_scroll_snap_stop
   */
  /**
   * Whether a document used the CSS property scroll-snap-stop. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_stop(1465);

  /**
   * generated from use.counter.css.doc.css_scroll_snap_type
   */
  /**
   * Whether a document used the CSS property scroll-snap-type. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_type(1466);

  /**
   * generated from use.counter.css.doc.css_scroll_timeline
   */
  /**
   * Whether a document used the CSS property scroll-timeline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline(1467);

  /**
   * generated from use.counter.css.doc.css_scroll_timeline_axis
   */
  /**
   * Whether a document used the CSS property scroll-timeline-axis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline_axis(1468);

  /**
   * generated from use.counter.css.doc.css_scroll_timeline_name
   */
  /**
   * Whether a document used the CSS property scroll-timeline-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline_name(1469);

  /**
   * generated from use.counter.css.doc.css_scrollbar_color
   */
  /**
   * Whether a document used the CSS property scrollbar-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_color(1470);

  /**
   * generated from use.counter.css.doc.css_scrollbar_gutter
   */
  /**
   * Whether a document used the CSS property scrollbar-gutter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_gutter(1471);

  /**
   * generated from use.counter.css.doc.css_scrollbar_width
   */
  /**
   * Whether a document used the CSS property scrollbar-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_width(1472);

  /**
   * generated from use.counter.css.doc.css_shape_image_threshold
   */
  /**
   * Whether a document used the CSS property shape-image-threshold. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_image_threshold(1473);

  /**
   * generated from use.counter.css.doc.css_shape_margin
   */
  /**
   * Whether a document used the CSS property shape-margin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_margin(1474);

  /**
   * generated from use.counter.css.doc.css_shape_outside
   */
  /**
   * Whether a document used the CSS property shape-outside. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_outside(1475);

  /**
   * generated from use.counter.css.doc.css_shape_rendering
   */
  /**
   * Whether a document used the CSS property shape-rendering. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_rendering(1476);

  /**
   * generated from use.counter.css.doc.css_size
   */
  /**
   * Whether a document used the CSS property size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_size(1477);

  /**
   * generated from use.counter.css.doc.css_stop_color
   */
  /**
   * Whether a document used the CSS property stop-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stop_color(1478);

  /**
   * generated from use.counter.css.doc.css_stop_opacity
   */
  /**
   * Whether a document used the CSS property stop-opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stop_opacity(1479);

  /**
   * generated from use.counter.css.doc.css_stroke
   */
  /**
   * Whether a document used the CSS property stroke. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke(1480);

  /**
   * generated from use.counter.css.doc.css_stroke_dasharray
   */
  /**
   * Whether a document used the CSS property stroke-dasharray. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_dasharray(1481);

  /**
   * generated from use.counter.css.doc.css_stroke_dashoffset
   */
  /**
   * Whether a document used the CSS property stroke-dashoffset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_dashoffset(1482);

  /**
   * generated from use.counter.css.doc.css_stroke_linecap
   */
  /**
   * Whether a document used the CSS property stroke-linecap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_linecap(1483);

  /**
   * generated from use.counter.css.doc.css_stroke_linejoin
   */
  /**
   * Whether a document used the CSS property stroke-linejoin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_linejoin(1484);

  /**
   * generated from use.counter.css.doc.css_stroke_miterlimit
   */
  /**
   * Whether a document used the CSS property stroke-miterlimit. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_miterlimit(1485);

  /**
   * generated from use.counter.css.doc.css_stroke_opacity
   */
  /**
   * Whether a document used the CSS property stroke-opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_opacity(1486);

  /**
   * generated from use.counter.css.doc.css_stroke_width
   */
  /**
   * Whether a document used the CSS property stroke-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_width(1487);

  /**
   * generated from use.counter.css.doc.css_tab_size
   */
  /**
   * Whether a document used the CSS property tab-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_tab_size(1488);

  /**
   * generated from use.counter.css.doc.css_table_layout
   */
  /**
   * Whether a document used the CSS property table-layout. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_table_layout(1489);

  /**
   * generated from use.counter.css.doc.css_text_align
   */
  /**
   * Whether a document used the CSS property text-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_align(1490);

  /**
   * generated from use.counter.css.doc.css_text_align_last
   */
  /**
   * Whether a document used the CSS property text-align-last. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_align_last(1491);

  /**
   * generated from use.counter.css.doc.css_text_anchor
   */
  /**
   * Whether a document used the CSS property text-anchor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_anchor(1492);

  /**
   * generated from use.counter.css.doc.css_text_combine_upright
   */
  /**
   * Whether a document used the CSS property text-combine-upright. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_combine_upright(1493);

  /**
   * generated from use.counter.css.doc.css_text_decoration
   */
  /**
   * Whether a document used the CSS property text-decoration. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration(1494);

  /**
   * generated from use.counter.css.doc.css_text_decoration_color
   */
  /**
   * Whether a document used the CSS property text-decoration-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_color(1495);

  /**
   * generated from use.counter.css.doc.css_text_decoration_line
   */
  /**
   * Whether a document used the CSS property text-decoration-line. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_line(1496);

  /**
   * generated from use.counter.css.doc.css_text_decoration_skip_ink
   */
  /**
   * Whether a document used the CSS property text-decoration-skip-ink. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_skip_ink(1497);

  /**
   * generated from use.counter.css.doc.css_text_decoration_style
   */
  /**
   * Whether a document used the CSS property text-decoration-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_style(1498);

  /**
   * generated from use.counter.css.doc.css_text_decoration_thickness
   */
  /**
   * Whether a document used the CSS property text-decoration-thickness. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_thickness(1499);

  /**
   * generated from use.counter.css.doc.css_text_emphasis
   */
  /**
   * Whether a document used the CSS property text-emphasis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis(1500);

  /**
   * generated from use.counter.css.doc.css_text_emphasis_color
   */
  /**
   * Whether a document used the CSS property text-emphasis-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_color(1501);

  /**
   * generated from use.counter.css.doc.css_text_emphasis_position
   */
  /**
   * Whether a document used the CSS property text-emphasis-position. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_position(1502);

  /**
   * generated from use.counter.css.doc.css_text_emphasis_style
   */
  /**
   * Whether a document used the CSS property text-emphasis-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_style(1503);

  /**
   * generated from use.counter.css.doc.css_text_indent
   */
  /**
   * Whether a document used the CSS property text-indent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_indent(1504);

  /**
   * generated from use.counter.css.doc.css_text_justify
   */
  /**
   * Whether a document used the CSS property text-justify. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_justify(1505);

  /**
   * generated from use.counter.css.doc.css_text_orientation
   */
  /**
   * Whether a document used the CSS property text-orientation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_orientation(1506);

  /**
   * generated from use.counter.css.doc.css_text_overflow
   */
  /**
   * Whether a document used the CSS property text-overflow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_overflow(1507);

  /**
   * generated from use.counter.css.doc.css_text_rendering
   */
  /**
   * Whether a document used the CSS property text-rendering. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_rendering(1508);

  /**
   * generated from use.counter.css.doc.css_text_shadow
   */
  /**
   * Whether a document used the CSS property text-shadow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_shadow(1509);

  /**
   * generated from use.counter.css.doc.css_text_transform
   */
  /**
   * Whether a document used the CSS property text-transform. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_transform(1510);

  /**
   * generated from use.counter.css.doc.css_text_underline_offset
   */
  /**
   * Whether a document used the CSS property text-underline-offset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_underline_offset(1511);

  /**
   * generated from use.counter.css.doc.css_text_underline_position
   */
  /**
   * Whether a document used the CSS property text-underline-position. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_underline_position(1512);

  /**
   * generated from use.counter.css.doc.css_text_wrap
   */
  /**
   * Whether a document used the CSS property text-wrap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_wrap(1513);

  /**
   * generated from use.counter.css.doc.css_text_wrap_mode
   */
  /**
   * Whether a document used the CSS property text-wrap-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_wrap_mode(1514);

  /**
   * generated from use.counter.css.doc.css_text_wrap_style
   */
  /**
   * Whether a document used the CSS property text-wrap-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_wrap_style(1515);

  /**
   * generated from use.counter.css.doc.css_top
   */
  /**
   * Whether a document used the CSS property top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_top(1516);

  /**
   * generated from use.counter.css.doc.css_touch_action
   */
  /**
   * Whether a document used the CSS property touch-action. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_touch_action(1517);

  /**
   * generated from use.counter.css.doc.css_transform
   */
  /**
   * Whether a document used the CSS property transform. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform(1518);

  /**
   * generated from use.counter.css.doc.css_transform_box
   */
  /**
   * Whether a document used the CSS property transform-box. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_box(1519);

  /**
   * generated from use.counter.css.doc.css_transform_origin
   */
  /**
   * Whether a document used the CSS property transform-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_origin(1520);

  /**
   * generated from use.counter.css.doc.css_transform_style
   */
  /**
   * Whether a document used the CSS property transform-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_style(1521);

  /**
   * generated from use.counter.css.doc.css_transition
   */
  /**
   * Whether a document used the CSS property transition. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition(1522);

  /**
   * generated from use.counter.css.doc.css_transition_behavior
   */
  /**
   * Whether a document used the CSS property transition-behavior. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_behavior(1523);

  /**
   * generated from use.counter.css.doc.css_transition_delay
   */
  /**
   * Whether a document used the CSS property transition-delay. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_delay(1524);

  /**
   * generated from use.counter.css.doc.css_transition_duration
   */
  /**
   * Whether a document used the CSS property transition-duration. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_duration(1525);

  /**
   * generated from use.counter.css.doc.css_transition_property
   */
  /**
   * Whether a document used the CSS property transition-property. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_property(1526);

  /**
   * generated from use.counter.css.doc.css_transition_timing_function
   */
  /**
   * Whether a document used the CSS property transition-timing-function. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_timing_function(1527);

  /**
   * generated from use.counter.css.doc.css_translate
   */
  /**
   * Whether a document used the CSS property translate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_translate(1528);

  /**
   * generated from use.counter.css.doc.css_unicode_bidi
   */
  /**
   * Whether a document used the CSS property unicode-bidi. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_unicode_bidi(1529);

  /**
   * generated from use.counter.css.doc.css_user_select
   */
  /**
   * Whether a document used the CSS property user-select. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_user_select(1530);

  /**
   * generated from use.counter.css.doc.css_vector_effect
   */
  /**
   * Whether a document used the CSS property vector-effect. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_vector_effect(1531);

  /**
   * generated from use.counter.css.doc.css_vertical_align
   */
  /**
   * Whether a document used the CSS property vertical-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_vertical_align(1532);

  /**
   * generated from use.counter.css.doc.css_view_timeline
   */
  /**
   * Whether a document used the CSS property view-timeline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline(1533);

  /**
   * generated from use.counter.css.doc.css_view_timeline_axis
   */
  /**
   * Whether a document used the CSS property view-timeline-axis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_axis(1534);

  /**
   * generated from use.counter.css.doc.css_view_timeline_inset
   */
  /**
   * Whether a document used the CSS property view-timeline-inset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_inset(1535);

  /**
   * generated from use.counter.css.doc.css_view_timeline_name
   */
  /**
   * Whether a document used the CSS property view-timeline-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_name(1536);

  /**
   * generated from use.counter.css.doc.css_view_transition_name
   */
  /**
   * Whether a document used the CSS property view-transition-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_transition_name(1537);

  /**
   * generated from use.counter.css.doc.css_visibility
   */
  /**
   * Whether a document used the CSS property visibility. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_visibility(1538);

  /**
   * generated from use.counter.css.doc.css_webkit_align_content
   */
  /**
   * Whether a document used the CSS property -webkit-align-content. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_content(1539);

  /**
   * generated from use.counter.css.doc.css_webkit_align_items
   */
  /**
   * Whether a document used the CSS property -webkit-align-items. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_items(1540);

  /**
   * generated from use.counter.css.doc.css_webkit_align_self
   */
  /**
   * Whether a document used the CSS property -webkit-align-self. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_self(1541);

  /**
   * generated from use.counter.css.doc.css_webkit_animation
   */
  /**
   * Whether a document used the CSS property -webkit-animation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation(1542);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_delay
   */
  /**
   * Whether a document used the CSS property -webkit-animation-delay. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_delay(1543);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_direction
   */
  /**
   * Whether a document used the CSS property -webkit-animation-direction. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_direction(1544);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_duration
   */
  /**
   * Whether a document used the CSS property -webkit-animation-duration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_duration(1545);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_fill_mode
   */
  /**
   * Whether a document used the CSS property -webkit-animation-fill-mode. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_fill_mode(1546);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_iteration_count
   */
  /**
   * Whether a document used the CSS property -webkit-animation-iteration-count.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_iteration_count(1547);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_name
   */
  /**
   * Whether a document used the CSS property -webkit-animation-name. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_name(1548);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_play_state
   */
  /**
   * Whether a document used the CSS property -webkit-animation-play-state. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_play_state(1549);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_timing_function
   */
  /**
   * Whether a document used the CSS property -webkit-animation-timing-function.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_timing_function(1550);

  /**
   * generated from use.counter.css.doc.css_webkit_appearance
   */
  /**
   * Whether a document used the CSS property -webkit-appearance. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_appearance(1551);

  /**
   * generated from use.counter.css.doc.css_webkit_backface_visibility
   */
  /**
   * Whether a document used the CSS property -webkit-backface-visibility. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_backface_visibility(1552);

  /**
   * generated from use.counter.css.doc.css_webkit_background_clip
   */
  /**
   * Whether a document used the CSS property -webkit-background-clip. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_clip(1553);

  /**
   * generated from use.counter.css.doc.css_webkit_background_origin
   */
  /**
   * Whether a document used the CSS property -webkit-background-origin. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_origin(1554);

  /**
   * generated from use.counter.css.doc.css_webkit_background_size
   */
  /**
   * Whether a document used the CSS property -webkit-background-size. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_size(1555);

  /**
   * generated from use.counter.css.doc.css_webkit_border_bottom_left_radius
   */
  /**
   * Whether a document used the CSS property -webkit-border-bottom-left-radius.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_bottom_left_radius(1556);

  /**
   * generated from use.counter.css.doc.css_webkit_border_bottom_right_radius
   */
  /**
   * Whether a document used the CSS property -webkit-border-bottom-right-radius.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_bottom_right_radius(1557);

  /**
   * generated from use.counter.css.doc.css_webkit_border_image
   */
  /**
   * Whether a document used the CSS property -webkit-border-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_border_image(1558);

  /**
   * generated from use.counter.css.doc.css_webkit_border_radius
   */
  /**
   * Whether a document used the CSS property -webkit-border-radius. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_border_radius(1559);

  /**
   * generated from use.counter.css.doc.css_webkit_border_top_left_radius
   */
  /**
   * Whether a document used the CSS property -webkit-border-top-left-radius.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_top_left_radius(1560);

  /**
   * generated from use.counter.css.doc.css_webkit_border_top_right_radius
   */
  /**
   * Whether a document used the CSS property -webkit-border-top-right-radius.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_top_right_radius(1561);

  /**
   * generated from use.counter.css.doc.css_webkit_box_align
   */
  /**
   * Whether a document used the CSS property -webkit-box-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_align(1562);

  /**
   * generated from use.counter.css.doc.css_webkit_box_direction
   */
  /**
   * Whether a document used the CSS property -webkit-box-direction. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_direction(1563);

  /**
   * generated from use.counter.css.doc.css_webkit_box_flex
   */
  /**
   * Whether a document used the CSS property -webkit-box-flex. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_flex(1564);

  /**
   * generated from use.counter.css.doc.css_webkit_box_ordinal_group
   */
  /**
   * Whether a document used the CSS property -webkit-box-ordinal-group. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_ordinal_group(1565);

  /**
   * generated from use.counter.css.doc.css_webkit_box_orient
   */
  /**
   * Whether a document used the CSS property -webkit-box-orient. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_orient(1566);

  /**
   * generated from use.counter.css.doc.css_webkit_box_pack
   */
  /**
   * Whether a document used the CSS property -webkit-box-pack. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_pack(1567);

  /**
   * generated from use.counter.css.doc.css_webkit_box_shadow
   */
  /**
   * Whether a document used the CSS property -webkit-box-shadow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_shadow(1568);

  /**
   * generated from use.counter.css.doc.css_webkit_box_sizing
   */
  /**
   * Whether a document used the CSS property -webkit-box-sizing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_sizing(1569);

  /**
   * generated from use.counter.css.doc.css_webkit_clip_path
   */
  /**
   * Whether a document used the CSS property -webkit-clip-path. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_clip_path(1570);

  /**
   * generated from use.counter.css.doc.css_webkit_filter
   */
  /**
   * Whether a document used the CSS property -webkit-filter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_filter(1571);

  /**
   * generated from use.counter.css.doc.css_webkit_flex
   */
  /**
   * Whether a document used the CSS property -webkit-flex. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex(1572);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_basis
   */
  /**
   * Whether a document used the CSS property -webkit-flex-basis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_basis(1573);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_direction
   */
  /**
   * Whether a document used the CSS property -webkit-flex-direction. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_direction(1574);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_flow
   */
  /**
   * Whether a document used the CSS property -webkit-flex-flow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_flow(1575);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_grow
   */
  /**
   * Whether a document used the CSS property -webkit-flex-grow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_grow(1576);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_shrink
   */
  /**
   * Whether a document used the CSS property -webkit-flex-shrink. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_shrink(1577);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_wrap
   */
  /**
   * Whether a document used the CSS property -webkit-flex-wrap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_wrap(1578);

  /**
   * generated from use.counter.css.doc.css_webkit_font_feature_settings
   */
  /**
   * Whether a document used the CSS property -webkit-font-feature-settings. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_font_feature_settings(1579);

  /**
   * generated from use.counter.css.doc.css_webkit_font_smoothing
   */
  /**
   * Whether a document used the CSS property -webkit-font-smoothing. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_font_smoothing(1580);

  /**
   * generated from use.counter.css.doc.css_webkit_justify_content
   */
  /**
   * Whether a document used the CSS property -webkit-justify-content. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_justify_content(1581);

  /**
   * generated from use.counter.css.doc.css_webkit_line_clamp
   */
  /**
   * Whether a document used the CSS property -webkit-line-clamp. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_line_clamp(1582);

  /**
   * generated from use.counter.css.doc.css_webkit_mask
   */
  /**
   * Whether a document used the CSS property -webkit-mask. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask(1583);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_clip
   */
  /**
   * Whether a document used the CSS property -webkit-mask-clip. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_clip(1584);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_composite
   */
  /**
   * Whether a document used the CSS property -webkit-mask-composite. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_composite(1585);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_image
   */
  /**
   * Whether a document used the CSS property -webkit-mask-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_image(1586);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_origin
   */
  /**
   * Whether a document used the CSS property -webkit-mask-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_origin(1587);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_position
   */
  /**
   * Whether a document used the CSS property -webkit-mask-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position(1588);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_position_x
   */
  /**
   * Whether a document used the CSS property -webkit-mask-position-x. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position_x(1589);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_position_y
   */
  /**
   * Whether a document used the CSS property -webkit-mask-position-y. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position_y(1590);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_repeat
   */
  /**
   * Whether a document used the CSS property -webkit-mask-repeat. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_repeat(1591);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_size
   */
  /**
   * Whether a document used the CSS property -webkit-mask-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_size(1592);

  /**
   * generated from use.counter.css.doc.css_webkit_order
   */
  /**
   * Whether a document used the CSS property -webkit-order. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_order(1593);

  /**
   * generated from use.counter.css.doc.css_webkit_perspective
   */
  /**
   * Whether a document used the CSS property -webkit-perspective. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_perspective(1594);

  /**
   * generated from use.counter.css.doc.css_webkit_perspective_origin
   */
  /**
   * Whether a document used the CSS property -webkit-perspective-origin. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_perspective_origin(1595);

  /**
   * generated from use.counter.css.doc.css_webkit_text_fill_color
   */
  /**
   * Whether a document used the CSS property -webkit-text-fill-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_fill_color(1596);

  /**
   * generated from use.counter.css.doc.css_webkit_text_security
   */
  /**
   * Whether a document used the CSS property -webkit-text-security. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_security(1597);

  /**
   * generated from use.counter.css.doc.css_webkit_text_size_adjust
   */
  /**
   * Whether a document used the CSS property -webkit-text-size-adjust. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_size_adjust(1598);

  /**
   * generated from use.counter.css.doc.css_webkit_text_stroke
   */
  /**
   * Whether a document used the CSS property -webkit-text-stroke. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke(1599);

  /**
   * generated from use.counter.css.doc.css_webkit_text_stroke_color
   */
  /**
   * Whether a document used the CSS property -webkit-text-stroke-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke_color(1600);

  /**
   * generated from use.counter.css.doc.css_webkit_text_stroke_width
   */
  /**
   * Whether a document used the CSS property -webkit-text-stroke-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke_width(1601);

  /**
   * generated from use.counter.css.doc.css_webkit_transform
   */
  /**
   * Whether a document used the CSS property -webkit-transform. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform(1602);

  /**
   * generated from use.counter.css.doc.css_webkit_transform_origin
   */
  /**
   * Whether a document used the CSS property -webkit-transform-origin. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform_origin(1603);

  /**
   * generated from use.counter.css.doc.css_webkit_transform_style
   */
  /**
   * Whether a document used the CSS property -webkit-transform-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform_style(1604);

  /**
   * generated from use.counter.css.doc.css_webkit_transition
   */
  /**
   * Whether a document used the CSS property -webkit-transition. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition(1605);

  /**
   * generated from use.counter.css.doc.css_webkit_transition_delay
   */
  /**
   * Whether a document used the CSS property -webkit-transition-delay. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_delay(1606);

  /**
   * generated from use.counter.css.doc.css_webkit_transition_duration
   */
  /**
   * Whether a document used the CSS property -webkit-transition-duration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_duration(1607);

  /**
   * generated from use.counter.css.doc.css_webkit_transition_property
   */
  /**
   * Whether a document used the CSS property -webkit-transition-property. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_property(1608);

  /**
   * generated from use.counter.css.doc.css_webkit_transition_timing_function
   */
  /**
   * Whether a document used the CSS property -webkit-transition-timing-function.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_timing_function(1609);

  /**
   * generated from use.counter.css.doc.css_webkit_user_select
   */
  /**
   * Whether a document used the CSS property -webkit-user-select. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_user_select(1610);

  /**
   * generated from use.counter.css.doc.css_white_space
   */
  /**
   * Whether a document used the CSS property white-space. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_white_space(1611);

  /**
   * generated from use.counter.css.doc.css_white_space_collapse
   */
  /**
   * Whether a document used the CSS property white-space-collapse. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_white_space_collapse(1612);

  /**
   * generated from use.counter.css.doc.css_width
   */
  /**
   * Whether a document used the CSS property width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_width(1613);

  /**
   * generated from use.counter.css.doc.css_will_change
   */
  /**
   * Whether a document used the CSS property will-change. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_will_change(1614);

  /**
   * generated from use.counter.css.doc.css_word_break
   */
  /**
   * Whether a document used the CSS property word-break. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_break(1615);

  /**
   * generated from use.counter.css.doc.css_word_spacing
   */
  /**
   * Whether a document used the CSS property word-spacing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_spacing(1616);

  /**
   * generated from use.counter.css.doc.css_word_wrap
   */
  /**
   * Whether a document used the CSS property word-wrap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_wrap(1617);

  /**
   * generated from use.counter.css.doc.css_writing_mode
   */
  /**
   * Whether a document used the CSS property writing-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_writing_mode(1618);

  /**
   * generated from use.counter.css.doc.css_x
   */
  /**
   * Whether a document used the CSS property x. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x(1619);

  /**
   * generated from use.counter.css.doc.css_x_lang
   */
  /**
   * Whether a document used the CSS property -x-lang. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_lang(1620);

  /**
   * generated from use.counter.css.doc.css_x_span
   */
  /**
   * Whether a document used the CSS property -x-span. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_span(1621);

  /**
   * generated from use.counter.css.doc.css_x_text_scale
   */
  /**
   * Whether a document used the CSS property -x-text-scale. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_text_scale(1622);

  /**
   * generated from use.counter.css.doc.css_y
   */
  /**
   * Whether a document used the CSS property y. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_y(1623);

  /**
   * generated from use.counter.css.doc.css_z_index
   */
  /**
   * Whether a document used the CSS property z-index. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_z_index(1624);

  /**
   * generated from use.counter.css.doc.css_zoom
   */
  /**
   * Whether a document used the CSS property zoom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_zoom(1625);

  /**
   * generated from use.counter.css.doc.max_zoom
   */
  /**
   * Whether a document used the (unknown, counted) CSS property max-zoom. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric max_zoom(1626);

  /**
   * generated from use.counter.css.doc.min_zoom
   */
  /**
   * Whether a document used the (unknown, counted) CSS property min-zoom. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric min_zoom(1627);

  /**
   * generated from use.counter.css.doc.orientation
   */
  /**
   * Whether a document used the (unknown, counted) CSS property orientation.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric orientation(1628);

  /**
   * generated from use.counter.css.doc.orphans
   */
  /**
   * Whether a document used the (unknown, counted) CSS property orphans. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric orphans(1629);

  /**
   * generated from use.counter.css.doc.speak
   */
  /**
   * Whether a document used the (unknown, counted) CSS property speak. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric speak(1630);

  /**
   * generated from use.counter.css.doc.text_size_adjust
   */
  /**
   * Whether a document used the (unknown, counted) CSS property text-size-adjust.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric text_size_adjust(1631);

  /**
   * generated from use.counter.css.doc.user_zoom
   */
  /**
   * Whether a document used the (unknown, counted) CSS property user-zoom. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric user_zoom(1632);

  /**
   * generated from use.counter.css.doc.webkit_app_region
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-app-region.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_app_region(1633);

  /**
   * generated from use.counter.css.doc.webkit_border_after
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * after. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_after(1634);

  /**
   * generated from use.counter.css.doc.webkit_border_after_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * after-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_color(1635);

  /**
   * generated from use.counter.css.doc.webkit_border_after_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * after-style. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_style(1636);

  /**
   * generated from use.counter.css.doc.webkit_border_after_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * after-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_width(1637);

  /**
   * generated from use.counter.css.doc.webkit_border_before
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * before. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_before(1638);

  /**
   * generated from use.counter.css.doc.webkit_border_before_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * before-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_color(1639);

  /**
   * generated from use.counter.css.doc.webkit_border_before_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * before-style. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_style(1640);

  /**
   * generated from use.counter.css.doc.webkit_border_before_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * before-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_width(1641);

  /**
   * generated from use.counter.css.doc.webkit_border_end
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-end.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_border_end(1642);

  /**
   * generated from use.counter.css.doc.webkit_border_end_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-end-
     * color. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_color(1643);

  /**
   * generated from use.counter.css.doc.webkit_border_end_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-end-
     * style. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_style(1644);

  /**
   * generated from use.counter.css.doc.webkit_border_end_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-end-
     * width. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_width(1645);

  /**
   * generated from use.counter.css.doc.webkit_border_horizontal_spacing
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * horizontal-spacing. Compare against `use.counter.content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_horizontal_spacing(1646);

  /**
   * generated from use.counter.css.doc.webkit_border_start
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * start. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_start(1647);

  /**
   * generated from use.counter.css.doc.webkit_border_start_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * start-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_color(1648);

  /**
   * generated from use.counter.css.doc.webkit_border_start_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * start-style. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_style(1649);

  /**
   * generated from use.counter.css.doc.webkit_border_start_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * start-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_width(1650);

  /**
   * generated from use.counter.css.doc.webkit_border_vertical_spacing
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * vertical-spacing. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_vertical_spacing(1651);

  /**
   * generated from use.counter.css.doc.webkit_box_decoration_break
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-box-
     * decoration-break. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_box_decoration_break(1652);

  /**
   * generated from use.counter.css.doc.webkit_box_reflect
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-box-
     * reflect. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_box_reflect(1653);

  /**
   * generated from use.counter.css.doc.webkit_column_break_after
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * break-after. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_after(1654);

  /**
   * generated from use.counter.css.doc.webkit_column_break_before
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * break-before. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_before(1655);

  /**
   * generated from use.counter.css.doc.webkit_column_break_inside
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * break-inside. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_inside(1656);

  /**
   * generated from use.counter.css.doc.webkit_column_count
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * count. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_column_count(1657);

  /**
   * generated from use.counter.css.doc.webkit_column_gap
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-gap.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_column_gap(1658);

  /**
   * generated from use.counter.css.doc.webkit_column_rule
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * rule. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule(1659);

  /**
   * generated from use.counter.css.doc.webkit_column_rule_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * rule-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_color(1660);

  /**
   * generated from use.counter.css.doc.webkit_column_rule_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * rule-style. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_style(1661);

  /**
   * generated from use.counter.css.doc.webkit_column_rule_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * rule-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_width(1662);

  /**
   * generated from use.counter.css.doc.webkit_column_span
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * span. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_column_span(1663);

  /**
   * generated from use.counter.css.doc.webkit_column_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * width. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_column_width(1664);

  /**
   * generated from use.counter.css.doc.webkit_columns
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-columns.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_columns(1665);

  /**
   * generated from use.counter.css.doc.webkit_font_size_delta
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-font-size-
     * delta. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_font_size_delta(1666);

  /**
   * generated from use.counter.css.doc.webkit_highlight
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-highlight.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_highlight(1667);

  /**
   * generated from use.counter.css.doc.webkit_hyphenate_character
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-hyphenate-
     * character. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_hyphenate_character(1668);

  /**
   * generated from use.counter.css.doc.webkit_line_break
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-line-break.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_line_break(1669);

  /**
   * generated from use.counter.css.doc.webkit_locale
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-locale.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_locale(1670);

  /**
   * generated from use.counter.css.doc.webkit_logical_height
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-logical-
     * height. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_logical_height(1671);

  /**
   * generated from use.counter.css.doc.webkit_logical_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-logical-
     * width. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_logical_width(1672);

  /**
   * generated from use.counter.css.doc.webkit_margin_after
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * after. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_margin_after(1673);

  /**
   * generated from use.counter.css.doc.webkit_margin_after_collapse
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * after-collapse. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_after_collapse(1674);

  /**
   * generated from use.counter.css.doc.webkit_margin_before
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * before. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_margin_before(1675);

  /**
   * generated from use.counter.css.doc.webkit_margin_before_collapse
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * before-collapse. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_before_collapse(1676);

  /**
   * generated from use.counter.css.doc.webkit_margin_bottom_collapse
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * bottom-collapse. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_bottom_collapse(1677);

  /**
   * generated from use.counter.css.doc.webkit_margin_collapse
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * collapse. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_collapse(1678);

  /**
   * generated from use.counter.css.doc.webkit_margin_end
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-end.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_margin_end(1679);

  /**
   * generated from use.counter.css.doc.webkit_margin_start
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * start. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_margin_start(1680);

  /**
   * generated from use.counter.css.doc.webkit_margin_top_collapse
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-top-
     * collapse. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_top_collapse(1681);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image(1682);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image_outset
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image-outset. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_outset(1683);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image_repeat
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image-repeat. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_repeat(1684);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image_slice
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image-slice. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_slice(1685);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image_source
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image-source. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_source(1686);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_width(1687);

  /**
   * generated from use.counter.css.doc.webkit_mask_repeat_x
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-
     * repeat-x. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_repeat_x(1688);

  /**
   * generated from use.counter.css.doc.webkit_mask_repeat_y
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-
     * repeat-y. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_repeat_y(1689);

  /**
   * generated from use.counter.css.doc.webkit_max_logical_height
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-max-
     * logical-height. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_max_logical_height(1690);

  /**
   * generated from use.counter.css.doc.webkit_max_logical_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-max-
     * logical-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_max_logical_width(1691);

  /**
   * generated from use.counter.css.doc.webkit_min_logical_height
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-min-
     * logical-height. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_min_logical_height(1692);

  /**
   * generated from use.counter.css.doc.webkit_min_logical_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-min-
     * logical-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_min_logical_width(1693);

  /**
   * generated from use.counter.css.doc.webkit_opacity
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-opacity.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_opacity(1694);

  /**
   * generated from use.counter.css.doc.webkit_padding_after
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-padding-
     * after. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_padding_after(1695);

  /**
   * generated from use.counter.css.doc.webkit_padding_before
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-padding-
     * before. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_padding_before(1696);

  /**
   * generated from use.counter.css.doc.webkit_padding_end
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-padding-
     * end. Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_padding_end(1697);

  /**
   * generated from use.counter.css.doc.webkit_padding_start
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-padding-
     * start. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_padding_start(1698);

  /**
   * generated from use.counter.css.doc.webkit_perspective_origin_x
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-
     * perspective-origin-x. Compare against `use.counter.content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_perspective_origin_x(1699);

  /**
   * generated from use.counter.css.doc.webkit_perspective_origin_y
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-
     * perspective-origin-y. Compare against `use.counter.content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_perspective_origin_y(1700);

  /**
   * generated from use.counter.css.doc.webkit_print_color_adjust
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-print-
     * color-adjust. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_print_color_adjust(1701);

  /**
   * generated from use.counter.css.doc.webkit_rtl_ordering
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-rtl-
     * ordering. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_rtl_ordering(1702);

  /**
   * generated from use.counter.css.doc.webkit_ruby_position
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-ruby-
     * position. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_ruby_position(1703);

  /**
   * generated from use.counter.css.doc.webkit_shape_image_threshold
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-shape-
     * image-threshold. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_shape_image_threshold(1704);

  /**
   * generated from use.counter.css.doc.webkit_shape_margin
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-shape-
     * margin. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_shape_margin(1705);

  /**
   * generated from use.counter.css.doc.webkit_shape_outside
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-shape-
     * outside. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_shape_outside(1706);

  /**
   * generated from use.counter.css.doc.webkit_tap_highlight_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-tap-
     * highlight-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_tap_highlight_color(1707);

  /**
   * generated from use.counter.css.doc.webkit_text_combine
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * combine. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_text_combine(1708);

  /**
   * generated from use.counter.css.doc.webkit_text_decorations_in_effect
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * decorations-in-effect. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_decorations_in_effect(1709);

  /**
   * generated from use.counter.css.doc.webkit_text_emphasis
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * emphasis. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis(1710);

  /**
   * generated from use.counter.css.doc.webkit_text_emphasis_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * emphasis-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_color(1711);

  /**
   * generated from use.counter.css.doc.webkit_text_emphasis_position
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * emphasis-position. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_position(1712);

  /**
   * generated from use.counter.css.doc.webkit_text_emphasis_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * emphasis-style. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_style(1713);

  /**
   * generated from use.counter.css.doc.webkit_text_orientation
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * orientation. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_orientation(1714);

  /**
   * generated from use.counter.css.doc.webkit_transform_origin_x
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-transform-
     * origin-x. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_x(1715);

  /**
   * generated from use.counter.css.doc.webkit_transform_origin_y
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-transform-
     * origin-y. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_y(1716);

  /**
   * generated from use.counter.css.doc.webkit_transform_origin_z
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-transform-
     * origin-z. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_z(1717);

  /**
   * generated from use.counter.css.doc.webkit_user_drag
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-user-drag.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_user_drag(1718);

  /**
   * generated from use.counter.css.doc.webkit_user_modify
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-user-
     * modify. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_user_modify(1719);

  /**
   * generated from use.counter.css.doc.webkit_writing_mode
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-writing-
     * mode. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_writing_mode(1720);

  /**
   * generated from use.counter.css.doc.widows
   */
  /**
   * Whether a document used the (unknown, counted) CSS property widows. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric widows(1721);

}
namespace use_counter_css_page {
  /**
   * generated from use.counter.css.page.alignment_baseline
   */
  /**
   * Whether a page used the (unknown, counted) CSS property alignment-baseline.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric alignment_baseline(1722);

  /**
   * generated from use.counter.css.page.background_repeat_x
   */
  /**
   * Whether a page used the (unknown, counted) CSS property background-repeat-x.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric background_repeat_x(1723);

  /**
   * generated from use.counter.css.page.background_repeat_y
   */
  /**
   * Whether a page used the (unknown, counted) CSS property background-repeat-y.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric background_repeat_y(1724);

  /**
   * generated from use.counter.css.page.baseline_shift
   */
  /**
   * Whether a page used the (unknown, counted) CSS property baseline-shift. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric baseline_shift(1725);

  /**
   * generated from use.counter.css.page.buffered_rendering
   */
  /**
   * Whether a page used the (unknown, counted) CSS property buffered-rendering.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric buffered_rendering(1726);

  /**
   * generated from use.counter.css.page.color_rendering
   */
  /**
   * Whether a page used the (unknown, counted) CSS property color-rendering.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric color_rendering(1727);

  /**
   * generated from use.counter.css.page.css_accent_color
   */
  /**
   * Whether a page used the CSS property accent-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_accent_color(1728);

  /**
   * generated from use.counter.css.page.css_align_content
   */
  /**
   * Whether a page used the CSS property align-content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_content(1729);

  /**
   * generated from use.counter.css.page.css_align_items
   */
  /**
   * Whether a page used the CSS property align-items. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_items(1730);

  /**
   * generated from use.counter.css.page.css_align_self
   */
  /**
   * Whether a page used the CSS property align-self. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_self(1731);

  /**
   * generated from use.counter.css.page.css_all
   */
  /**
   * Whether a page used the CSS property all. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_all(1732);

  /**
   * generated from use.counter.css.page.css_anchor_name
   */
  /**
   * Whether a page used the CSS property anchor-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_anchor_name(1733);

  /**
   * generated from use.counter.css.page.css_anchor_scope
   */
  /**
   * Whether a page used the CSS property anchor-scope. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_anchor_scope(1734);

  /**
   * generated from use.counter.css.page.css_animation
   */
  /**
   * Whether a page used the CSS property animation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation(1735);

  /**
   * generated from use.counter.css.page.css_animation_composition
   */
  /**
   * Whether a page used the CSS property animation-composition. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_composition(1736);

  /**
   * generated from use.counter.css.page.css_animation_delay
   */
  /**
   * Whether a page used the CSS property animation-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_delay(1737);

  /**
   * generated from use.counter.css.page.css_animation_direction
   */
  /**
   * Whether a page used the CSS property animation-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_direction(1738);

  /**
   * generated from use.counter.css.page.css_animation_duration
   */
  /**
   * Whether a page used the CSS property animation-duration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_duration(1739);

  /**
   * generated from use.counter.css.page.css_animation_fill_mode
   */
  /**
   * Whether a page used the CSS property animation-fill-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_fill_mode(1740);

  /**
   * generated from use.counter.css.page.css_animation_iteration_count
   */
  /**
   * Whether a page used the CSS property animation-iteration-count. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_iteration_count(1741);

  /**
   * generated from use.counter.css.page.css_animation_name
   */
  /**
   * Whether a page used the CSS property animation-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_name(1742);

  /**
   * generated from use.counter.css.page.css_animation_play_state
   */
  /**
   * Whether a page used the CSS property animation-play-state. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_play_state(1743);

  /**
   * generated from use.counter.css.page.css_animation_timeline
   */
  /**
   * Whether a page used the CSS property animation-timeline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_timeline(1744);

  /**
   * generated from use.counter.css.page.css_animation_timing_function
   */
  /**
   * Whether a page used the CSS property animation-timing-function. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_timing_function(1745);

  /**
   * generated from use.counter.css.page.css_appearance
   */
  /**
   * Whether a page used the CSS property appearance. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_appearance(1746);

  /**
   * generated from use.counter.css.page.css_aspect_ratio
   */
  /**
   * Whether a page used the CSS property aspect-ratio. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_aspect_ratio(1747);

  /**
   * generated from use.counter.css.page.css_backdrop_filter
   */
  /**
   * Whether a page used the CSS property backdrop-filter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_backdrop_filter(1748);

  /**
   * generated from use.counter.css.page.css_backface_visibility
   */
  /**
   * Whether a page used the CSS property backface-visibility. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_backface_visibility(1749);

  /**
   * generated from use.counter.css.page.css_background
   */
  /**
   * Whether a page used the CSS property background. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background(1750);

  /**
   * generated from use.counter.css.page.css_background_attachment
   */
  /**
   * Whether a page used the CSS property background-attachment. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_attachment(1751);

  /**
   * generated from use.counter.css.page.css_background_blend_mode
   */
  /**
   * Whether a page used the CSS property background-blend-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_blend_mode(1752);

  /**
   * generated from use.counter.css.page.css_background_clip
   */
  /**
   * Whether a page used the CSS property background-clip. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_clip(1753);

  /**
   * generated from use.counter.css.page.css_background_color
   */
  /**
   * Whether a page used the CSS property background-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_color(1754);

  /**
   * generated from use.counter.css.page.css_background_image
   */
  /**
   * Whether a page used the CSS property background-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_image(1755);

  /**
   * generated from use.counter.css.page.css_background_origin
   */
  /**
   * Whether a page used the CSS property background-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_origin(1756);

  /**
   * generated from use.counter.css.page.css_background_position
   */
  /**
   * Whether a page used the CSS property background-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position(1757);

  /**
   * generated from use.counter.css.page.css_background_position_x
   */
  /**
   * Whether a page used the CSS property background-position-x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position_x(1758);

  /**
   * generated from use.counter.css.page.css_background_position_y
   */
  /**
   * Whether a page used the CSS property background-position-y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position_y(1759);

  /**
   * generated from use.counter.css.page.css_background_repeat
   */
  /**
   * Whether a page used the CSS property background-repeat. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_repeat(1760);

  /**
   * generated from use.counter.css.page.css_background_size
   */
  /**
   * Whether a page used the CSS property background-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_size(1761);

  /**
   * generated from use.counter.css.page.css_baseline_source
   */
  /**
   * Whether a page used the CSS property baseline-source. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_baseline_source(1762);

  /**
   * generated from use.counter.css.page.css_block_size
   */
  /**
   * Whether a page used the CSS property block-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_block_size(1763);

  /**
   * generated from use.counter.css.page.css_border
   */
  /**
   * Whether a page used the CSS property border. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border(1764);

  /**
   * generated from use.counter.css.page.css_border_block
   */
  /**
   * Whether a page used the CSS property border-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block(1765);

  /**
   * generated from use.counter.css.page.css_border_block_color
   */
  /**
   * Whether a page used the CSS property border-block-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_color(1766);

  /**
   * generated from use.counter.css.page.css_border_block_end
   */
  /**
   * Whether a page used the CSS property border-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end(1767);

  /**
   * generated from use.counter.css.page.css_border_block_end_color
   */
  /**
   * Whether a page used the CSS property border-block-end-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_color(1768);

  /**
   * generated from use.counter.css.page.css_border_block_end_style
   */
  /**
   * Whether a page used the CSS property border-block-end-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_style(1769);

  /**
   * generated from use.counter.css.page.css_border_block_end_width
   */
  /**
   * Whether a page used the CSS property border-block-end-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_width(1770);

  /**
   * generated from use.counter.css.page.css_border_block_start
   */
  /**
   * Whether a page used the CSS property border-block-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start(1771);

  /**
   * generated from use.counter.css.page.css_border_block_start_color
   */
  /**
   * Whether a page used the CSS property border-block-start-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_color(1772);

  /**
   * generated from use.counter.css.page.css_border_block_start_style
   */
  /**
   * Whether a page used the CSS property border-block-start-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_style(1773);

  /**
   * generated from use.counter.css.page.css_border_block_start_width
   */
  /**
   * Whether a page used the CSS property border-block-start-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_width(1774);

  /**
   * generated from use.counter.css.page.css_border_block_style
   */
  /**
   * Whether a page used the CSS property border-block-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_style(1775);

  /**
   * generated from use.counter.css.page.css_border_block_width
   */
  /**
   * Whether a page used the CSS property border-block-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_width(1776);

  /**
   * generated from use.counter.css.page.css_border_bottom
   */
  /**
   * Whether a page used the CSS property border-bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom(1777);

  /**
   * generated from use.counter.css.page.css_border_bottom_color
   */
  /**
   * Whether a page used the CSS property border-bottom-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_color(1778);

  /**
   * generated from use.counter.css.page.css_border_bottom_left_radius
   */
  /**
   * Whether a page used the CSS property border-bottom-left-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_left_radius(1779);

  /**
   * generated from use.counter.css.page.css_border_bottom_right_radius
   */
  /**
   * Whether a page used the CSS property border-bottom-right-radius. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_border_bottom_right_radius(1780);

  /**
   * generated from use.counter.css.page.css_border_bottom_style
   */
  /**
   * Whether a page used the CSS property border-bottom-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_style(1781);

  /**
   * generated from use.counter.css.page.css_border_bottom_width
   */
  /**
   * Whether a page used the CSS property border-bottom-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_width(1782);

  /**
   * generated from use.counter.css.page.css_border_collapse
   */
  /**
   * Whether a page used the CSS property border-collapse. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_collapse(1783);

  /**
   * generated from use.counter.css.page.css_border_color
   */
  /**
   * Whether a page used the CSS property border-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_color(1784);

  /**
   * generated from use.counter.css.page.css_border_end_end_radius
   */
  /**
   * Whether a page used the CSS property border-end-end-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_end_end_radius(1785);

  /**
   * generated from use.counter.css.page.css_border_end_start_radius
   */
  /**
   * Whether a page used the CSS property border-end-start-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_end_start_radius(1786);

  /**
   * generated from use.counter.css.page.css_border_image
   */
  /**
   * Whether a page used the CSS property border-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image(1787);

  /**
   * generated from use.counter.css.page.css_border_image_outset
   */
  /**
   * Whether a page used the CSS property border-image-outset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_outset(1788);

  /**
   * generated from use.counter.css.page.css_border_image_repeat
   */
  /**
   * Whether a page used the CSS property border-image-repeat. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_repeat(1789);

  /**
   * generated from use.counter.css.page.css_border_image_slice
   */
  /**
   * Whether a page used the CSS property border-image-slice. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_slice(1790);

  /**
   * generated from use.counter.css.page.css_border_image_source
   */
  /**
   * Whether a page used the CSS property border-image-source. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_source(1791);

  /**
   * generated from use.counter.css.page.css_border_image_width
   */
  /**
   * Whether a page used the CSS property border-image-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_width(1792);

  /**
   * generated from use.counter.css.page.css_border_inline
   */
  /**
   * Whether a page used the CSS property border-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline(1793);

  /**
   * generated from use.counter.css.page.css_border_inline_color
   */
  /**
   * Whether a page used the CSS property border-inline-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_color(1794);

  /**
   * generated from use.counter.css.page.css_border_inline_end
   */
  /**
   * Whether a page used the CSS property border-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end(1795);

  /**
   * generated from use.counter.css.page.css_border_inline_end_color
   */
  /**
   * Whether a page used the CSS property border-inline-end-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_color(1796);

  /**
   * generated from use.counter.css.page.css_border_inline_end_style
   */
  /**
   * Whether a page used the CSS property border-inline-end-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_style(1797);

  /**
   * generated from use.counter.css.page.css_border_inline_end_width
   */
  /**
   * Whether a page used the CSS property border-inline-end-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_width(1798);

  /**
   * generated from use.counter.css.page.css_border_inline_start
   */
  /**
   * Whether a page used the CSS property border-inline-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start(1799);

  /**
   * generated from use.counter.css.page.css_border_inline_start_color
   */
  /**
   * Whether a page used the CSS property border-inline-start-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_color(1800);

  /**
   * generated from use.counter.css.page.css_border_inline_start_style
   */
  /**
   * Whether a page used the CSS property border-inline-start-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_style(1801);

  /**
   * generated from use.counter.css.page.css_border_inline_start_width
   */
  /**
   * Whether a page used the CSS property border-inline-start-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_width(1802);

  /**
   * generated from use.counter.css.page.css_border_inline_style
   */
  /**
   * Whether a page used the CSS property border-inline-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_style(1803);

  /**
   * generated from use.counter.css.page.css_border_inline_width
   */
  /**
   * Whether a page used the CSS property border-inline-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_width(1804);

  /**
   * generated from use.counter.css.page.css_border_left
   */
  /**
   * Whether a page used the CSS property border-left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left(1805);

  /**
   * generated from use.counter.css.page.css_border_left_color
   */
  /**
   * Whether a page used the CSS property border-left-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_color(1806);

  /**
   * generated from use.counter.css.page.css_border_left_style
   */
  /**
   * Whether a page used the CSS property border-left-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_style(1807);

  /**
   * generated from use.counter.css.page.css_border_left_width
   */
  /**
   * Whether a page used the CSS property border-left-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_width(1808);

  /**
   * generated from use.counter.css.page.css_border_radius
   */
  /**
   * Whether a page used the CSS property border-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_radius(1809);

  /**
   * generated from use.counter.css.page.css_border_right
   */
  /**
   * Whether a page used the CSS property border-right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right(1810);

  /**
   * generated from use.counter.css.page.css_border_right_color
   */
  /**
   * Whether a page used the CSS property border-right-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_color(1811);

  /**
   * generated from use.counter.css.page.css_border_right_style
   */
  /**
   * Whether a page used the CSS property border-right-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_style(1812);

  /**
   * generated from use.counter.css.page.css_border_right_width
   */
  /**
   * Whether a page used the CSS property border-right-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_width(1813);

  /**
   * generated from use.counter.css.page.css_border_spacing
   */
  /**
   * Whether a page used the CSS property border-spacing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_spacing(1814);

  /**
   * generated from use.counter.css.page.css_border_start_end_radius
   */
  /**
   * Whether a page used the CSS property border-start-end-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_start_end_radius(1815);

  /**
   * generated from use.counter.css.page.css_border_start_start_radius
   */
  /**
   * Whether a page used the CSS property border-start-start-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_start_start_radius(1816);

  /**
   * generated from use.counter.css.page.css_border_style
   */
  /**
   * Whether a page used the CSS property border-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_style(1817);

  /**
   * generated from use.counter.css.page.css_border_top
   */
  /**
   * Whether a page used the CSS property border-top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top(1818);

  /**
   * generated from use.counter.css.page.css_border_top_color
   */
  /**
   * Whether a page used the CSS property border-top-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_color(1819);

  /**
   * generated from use.counter.css.page.css_border_top_left_radius
   */
  /**
   * Whether a page used the CSS property border-top-left-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_left_radius(1820);

  /**
   * generated from use.counter.css.page.css_border_top_right_radius
   */
  /**
   * Whether a page used the CSS property border-top-right-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_right_radius(1821);

  /**
   * generated from use.counter.css.page.css_border_top_style
   */
  /**
   * Whether a page used the CSS property border-top-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_style(1822);

  /**
   * generated from use.counter.css.page.css_border_top_width
   */
  /**
   * Whether a page used the CSS property border-top-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_width(1823);

  /**
   * generated from use.counter.css.page.css_border_width
   */
  /**
   * Whether a page used the CSS property border-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_width(1824);

  /**
   * generated from use.counter.css.page.css_bottom
   */
  /**
   * Whether a page used the CSS property bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_bottom(1825);

  /**
   * generated from use.counter.css.page.css_box_decoration_break
   */
  /**
   * Whether a page used the CSS property box-decoration-break. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_decoration_break(1826);

  /**
   * generated from use.counter.css.page.css_box_shadow
   */
  /**
   * Whether a page used the CSS property box-shadow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_shadow(1827);

  /**
   * generated from use.counter.css.page.css_box_sizing
   */
  /**
   * Whether a page used the CSS property box-sizing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_sizing(1828);

  /**
   * generated from use.counter.css.page.css_break_after
   */
  /**
   * Whether a page used the CSS property break-after. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_after(1829);

  /**
   * generated from use.counter.css.page.css_break_before
   */
  /**
   * Whether a page used the CSS property break-before. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_before(1830);

  /**
   * generated from use.counter.css.page.css_break_inside
   */
  /**
   * Whether a page used the CSS property break-inside. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_inside(1831);

  /**
   * generated from use.counter.css.page.css_caption_side
   */
  /**
   * Whether a page used the CSS property caption-side. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_caption_side(1832);

  /**
   * generated from use.counter.css.page.css_caret_color
   */
  /**
   * Whether a page used the CSS property caret-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_caret_color(1833);

  /**
   * generated from use.counter.css.page.css_clear
   */
  /**
   * Whether a page used the CSS property clear. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clear(1834);

  /**
   * generated from use.counter.css.page.css_clip
   */
  /**
   * Whether a page used the CSS property clip. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip(1835);

  /**
   * generated from use.counter.css.page.css_clip_path
   */
  /**
   * Whether a page used the CSS property clip-path. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip_path(1836);

  /**
   * generated from use.counter.css.page.css_clip_rule
   */
  /**
   * Whether a page used the CSS property clip-rule. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip_rule(1837);

  /**
   * generated from use.counter.css.page.css_color
   */
  /**
   * Whether a page used the CSS property color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color(1838);

  /**
   * generated from use.counter.css.page.css_color_adjust
   */
  /**
   * Whether a page used the CSS property color-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_adjust(1839);

  /**
   * generated from use.counter.css.page.css_color_interpolation
   */
  /**
   * Whether a page used the CSS property color-interpolation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_interpolation(1840);

  /**
   * generated from use.counter.css.page.css_color_interpolation_filters
   */
  /**
   * Whether a page used the CSS property color-interpolation-filters. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_color_interpolation_filters(1841);

  /**
   * generated from use.counter.css.page.css_color_scheme
   */
  /**
   * Whether a page used the CSS property color-scheme. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_scheme(1842);

  /**
   * generated from use.counter.css.page.css_column_count
   */
  /**
   * Whether a page used the CSS property column-count. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_count(1843);

  /**
   * generated from use.counter.css.page.css_column_fill
   */
  /**
   * Whether a page used the CSS property column-fill. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_fill(1844);

  /**
   * generated from use.counter.css.page.css_column_gap
   */
  /**
   * Whether a page used the CSS property column-gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_gap(1845);

  /**
   * generated from use.counter.css.page.css_column_rule
   */
  /**
   * Whether a page used the CSS property column-rule. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule(1846);

  /**
   * generated from use.counter.css.page.css_column_rule_color
   */
  /**
   * Whether a page used the CSS property column-rule-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_color(1847);

  /**
   * generated from use.counter.css.page.css_column_rule_style
   */
  /**
   * Whether a page used the CSS property column-rule-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_style(1848);

  /**
   * generated from use.counter.css.page.css_column_rule_width
   */
  /**
   * Whether a page used the CSS property column-rule-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_width(1849);

  /**
   * generated from use.counter.css.page.css_column_span
   */
  /**
   * Whether a page used the CSS property column-span. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_span(1850);

  /**
   * generated from use.counter.css.page.css_column_width
   */
  /**
   * Whether a page used the CSS property column-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_width(1851);

  /**
   * generated from use.counter.css.page.css_columns
   */
  /**
   * Whether a page used the CSS property columns. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_columns(1852);

  /**
   * generated from use.counter.css.page.css_contain
   */
  /**
   * Whether a page used the CSS property contain. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain(1853);

  /**
   * generated from use.counter.css.page.css_contain_intrinsic_block_size
   */
  /**
   * Whether a page used the CSS property contain-intrinsic-block-size. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_block_size(1854);

  /**
   * generated from use.counter.css.page.css_contain_intrinsic_height
   */
  /**
   * Whether a page used the CSS property contain-intrinsic-height. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_height(1855);

  /**
   * generated from use.counter.css.page.css_contain_intrinsic_inline_size
   */
  /**
   * Whether a page used the CSS property contain-intrinsic-inline-size. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_inline_size(1856);

  /**
   * generated from use.counter.css.page.css_contain_intrinsic_size
   */
  /**
   * Whether a page used the CSS property contain-intrinsic-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_size(1857);

  /**
   * generated from use.counter.css.page.css_contain_intrinsic_width
   */
  /**
   * Whether a page used the CSS property contain-intrinsic-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_width(1858);

  /**
   * generated from use.counter.css.page.css_container
   */
  /**
   * Whether a page used the CSS property container. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container(1859);

  /**
   * generated from use.counter.css.page.css_container_name
   */
  /**
   * Whether a page used the CSS property container-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container_name(1860);

  /**
   * generated from use.counter.css.page.css_container_type
   */
  /**
   * Whether a page used the CSS property container-type. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container_type(1861);

  /**
   * generated from use.counter.css.page.css_content
   */
  /**
   * Whether a page used the CSS property content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_content(1862);

  /**
   * generated from use.counter.css.page.css_content_visibility
   */
  /**
   * Whether a page used the CSS property content-visibility. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_content_visibility(1863);

  /**
   * generated from use.counter.css.page.css_counter_increment
   */
  /**
   * Whether a page used the CSS property counter-increment. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_increment(1864);

  /**
   * generated from use.counter.css.page.css_counter_reset
   */
  /**
   * Whether a page used the CSS property counter-reset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_reset(1865);

  /**
   * generated from use.counter.css.page.css_counter_set
   */
  /**
   * Whether a page used the CSS property counter-set. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_set(1866);

  /**
   * generated from use.counter.css.page.css_cursor
   */
  /**
   * Whether a page used the CSS property cursor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cursor(1867);

  /**
   * generated from use.counter.css.page.css_cx
   */
  /**
   * Whether a page used the CSS property cx. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cx(1868);

  /**
   * generated from use.counter.css.page.css_cy
   */
  /**
   * Whether a page used the CSS property cy. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cy(1869);

  /**
   * generated from use.counter.css.page.css_d
   */
  /**
   * Whether a page used the CSS property d. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_d(1870);

  /**
   * generated from use.counter.css.page.css_direction
   */
  /**
   * Whether a page used the CSS property direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_direction(1871);

  /**
   * generated from use.counter.css.page.css_display
   */
  /**
   * Whether a page used the CSS property display. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_display(1872);

  /**
   * generated from use.counter.css.page.css_dominant_baseline
   */
  /**
   * Whether a page used the CSS property dominant-baseline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_dominant_baseline(1873);

  /**
   * generated from use.counter.css.page.css_empty_cells
   */
  /**
   * Whether a page used the CSS property empty-cells. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_empty_cells(1874);

  /**
   * generated from use.counter.css.page.css_field_sizing
   */
  /**
   * Whether a page used the CSS property field-sizing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_field_sizing(1875);

  /**
   * generated from use.counter.css.page.css_fill
   */
  /**
   * Whether a page used the CSS property fill. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill(1876);

  /**
   * generated from use.counter.css.page.css_fill_opacity
   */
  /**
   * Whether a page used the CSS property fill-opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill_opacity(1877);

  /**
   * generated from use.counter.css.page.css_fill_rule
   */
  /**
   * Whether a page used the CSS property fill-rule. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill_rule(1878);

  /**
   * generated from use.counter.css.page.css_filter
   */
  /**
   * Whether a page used the CSS property filter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_filter(1879);

  /**
   * generated from use.counter.css.page.css_flex
   */
  /**
   * Whether a page used the CSS property flex. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex(1880);

  /**
   * generated from use.counter.css.page.css_flex_basis
   */
  /**
   * Whether a page used the CSS property flex-basis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_basis(1881);

  /**
   * generated from use.counter.css.page.css_flex_direction
   */
  /**
   * Whether a page used the CSS property flex-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_direction(1882);

  /**
   * generated from use.counter.css.page.css_flex_flow
   */
  /**
   * Whether a page used the CSS property flex-flow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_flow(1883);

  /**
   * generated from use.counter.css.page.css_flex_grow
   */
  /**
   * Whether a page used the CSS property flex-grow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_grow(1884);

  /**
   * generated from use.counter.css.page.css_flex_shrink
   */
  /**
   * Whether a page used the CSS property flex-shrink. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_shrink(1885);

  /**
   * generated from use.counter.css.page.css_flex_wrap
   */
  /**
   * Whether a page used the CSS property flex-wrap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_wrap(1886);

  /**
   * generated from use.counter.css.page.css_float
   */
  /**
   * Whether a page used the CSS property float. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_float(1887);

  /**
   * generated from use.counter.css.page.css_flood_color
   */
  /**
   * Whether a page used the CSS property flood-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flood_color(1888);

  /**
   * generated from use.counter.css.page.css_flood_opacity
   */
  /**
   * Whether a page used the CSS property flood-opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flood_opacity(1889);

  /**
   * generated from use.counter.css.page.css_font
   */
  /**
   * Whether a page used the CSS property font. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font(1890);

  /**
   * generated from use.counter.css.page.css_font_family
   */
  /**
   * Whether a page used the CSS property font-family. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_family(1891);

  /**
   * generated from use.counter.css.page.css_font_feature_settings
   */
  /**
   * Whether a page used the CSS property font-feature-settings. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_feature_settings(1892);

  /**
   * generated from use.counter.css.page.css_font_kerning
   */
  /**
   * Whether a page used the CSS property font-kerning. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_kerning(1893);

  /**
   * generated from use.counter.css.page.css_font_language_override
   */
  /**
   * Whether a page used the CSS property font-language-override. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_language_override(1894);

  /**
   * generated from use.counter.css.page.css_font_optical_sizing
   */
  /**
   * Whether a page used the CSS property font-optical-sizing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_optical_sizing(1895);

  /**
   * generated from use.counter.css.page.css_font_palette
   */
  /**
   * Whether a page used the CSS property font-palette. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_palette(1896);

  /**
   * generated from use.counter.css.page.css_font_size
   */
  /**
   * Whether a page used the CSS property font-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_size(1897);

  /**
   * generated from use.counter.css.page.css_font_size_adjust
   */
  /**
   * Whether a page used the CSS property font-size-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_size_adjust(1898);

  /**
   * generated from use.counter.css.page.css_font_stretch
   */
  /**
   * Whether a page used the CSS property font-stretch. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_stretch(1899);

  /**
   * generated from use.counter.css.page.css_font_style
   */
  /**
   * Whether a page used the CSS property font-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_style(1900);

  /**
   * generated from use.counter.css.page.css_font_synthesis
   */
  /**
   * Whether a page used the CSS property font-synthesis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis(1901);

  /**
   * generated from use.counter.css.page.css_font_synthesis_position
   */
  /**
   * Whether a page used the CSS property font-synthesis-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_position(1902);

  /**
   * generated from use.counter.css.page.css_font_synthesis_small_caps
   */
  /**
   * Whether a page used the CSS property font-synthesis-small-caps. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_small_caps(1903);

  /**
   * generated from use.counter.css.page.css_font_synthesis_style
   */
  /**
   * Whether a page used the CSS property font-synthesis-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_style(1904);

  /**
   * generated from use.counter.css.page.css_font_synthesis_weight
   */
  /**
   * Whether a page used the CSS property font-synthesis-weight. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_weight(1905);

  /**
   * generated from use.counter.css.page.css_font_variant
   */
  /**
   * Whether a page used the CSS property font-variant. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant(1906);

  /**
   * generated from use.counter.css.page.css_font_variant_alternates
   */
  /**
   * Whether a page used the CSS property font-variant-alternates. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_alternates(1907);

  /**
   * generated from use.counter.css.page.css_font_variant_caps
   */
  /**
   * Whether a page used the CSS property font-variant-caps. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_caps(1908);

  /**
   * generated from use.counter.css.page.css_font_variant_east_asian
   */
  /**
   * Whether a page used the CSS property font-variant-east-asian. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_east_asian(1909);

  /**
   * generated from use.counter.css.page.css_font_variant_emoji
   */
  /**
   * Whether a page used the CSS property font-variant-emoji. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_emoji(1910);

  /**
   * generated from use.counter.css.page.css_font_variant_ligatures
   */
  /**
   * Whether a page used the CSS property font-variant-ligatures. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_ligatures(1911);

  /**
   * generated from use.counter.css.page.css_font_variant_numeric
   */
  /**
   * Whether a page used the CSS property font-variant-numeric. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_numeric(1912);

  /**
   * generated from use.counter.css.page.css_font_variant_position
   */
  /**
   * Whether a page used the CSS property font-variant-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_position(1913);

  /**
   * generated from use.counter.css.page.css_font_variation_settings
   */
  /**
   * Whether a page used the CSS property font-variation-settings. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variation_settings(1914);

  /**
   * generated from use.counter.css.page.css_font_weight
   */
  /**
   * Whether a page used the CSS property font-weight. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_weight(1915);

  /**
   * generated from use.counter.css.page.css_forced_color_adjust
   */
  /**
   * Whether a page used the CSS property forced-color-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_forced_color_adjust(1916);

  /**
   * generated from use.counter.css.page.css_gap
   */
  /**
   * Whether a page used the CSS property gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_gap(1917);

  /**
   * generated from use.counter.css.page.css_grid
   */
  /**
   * Whether a page used the CSS property grid. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid(1918);

  /**
   * generated from use.counter.css.page.css_grid_area
   */
  /**
   * Whether a page used the CSS property grid-area. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_area(1919);

  /**
   * generated from use.counter.css.page.css_grid_auto_columns
   */
  /**
   * Whether a page used the CSS property grid-auto-columns. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_columns(1920);

  /**
   * generated from use.counter.css.page.css_grid_auto_flow
   */
  /**
   * Whether a page used the CSS property grid-auto-flow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_flow(1921);

  /**
   * generated from use.counter.css.page.css_grid_auto_rows
   */
  /**
   * Whether a page used the CSS property grid-auto-rows. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_rows(1922);

  /**
   * generated from use.counter.css.page.css_grid_column
   */
  /**
   * Whether a page used the CSS property grid-column. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column(1923);

  /**
   * generated from use.counter.css.page.css_grid_column_end
   */
  /**
   * Whether a page used the CSS property grid-column-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_end(1924);

  /**
   * generated from use.counter.css.page.css_grid_column_gap
   */
  /**
   * Whether a page used the CSS property grid-column-gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_gap(1925);

  /**
   * generated from use.counter.css.page.css_grid_column_start
   */
  /**
   * Whether a page used the CSS property grid-column-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_start(1926);

  /**
   * generated from use.counter.css.page.css_grid_gap
   */
  /**
   * Whether a page used the CSS property grid-gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_gap(1927);

  /**
   * generated from use.counter.css.page.css_grid_row
   */
  /**
   * Whether a page used the CSS property grid-row. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row(1928);

  /**
   * generated from use.counter.css.page.css_grid_row_end
   */
  /**
   * Whether a page used the CSS property grid-row-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_end(1929);

  /**
   * generated from use.counter.css.page.css_grid_row_gap
   */
  /**
   * Whether a page used the CSS property grid-row-gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_gap(1930);

  /**
   * generated from use.counter.css.page.css_grid_row_start
   */
  /**
   * Whether a page used the CSS property grid-row-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_start(1931);

  /**
   * generated from use.counter.css.page.css_grid_template
   */
  /**
   * Whether a page used the CSS property grid-template. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template(1932);

  /**
   * generated from use.counter.css.page.css_grid_template_areas
   */
  /**
   * Whether a page used the CSS property grid-template-areas. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_areas(1933);

  /**
   * generated from use.counter.css.page.css_grid_template_columns
   */
  /**
   * Whether a page used the CSS property grid-template-columns. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_columns(1934);

  /**
   * generated from use.counter.css.page.css_grid_template_rows
   */
  /**
   * Whether a page used the CSS property grid-template-rows. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_rows(1935);

  /**
   * generated from use.counter.css.page.css_height
   */
  /**
   * Whether a page used the CSS property height. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_height(1936);

  /**
   * generated from use.counter.css.page.css_hyphenate_character
   */
  /**
   * Whether a page used the CSS property hyphenate-character. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_hyphenate_character(1937);

  /**
   * generated from use.counter.css.page.css_hyphens
   */
  /**
   * Whether a page used the CSS property hyphens. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_hyphens(1938);

  /**
   * generated from use.counter.css.page.css_image_orientation
   */
  /**
   * Whether a page used the CSS property image-orientation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_image_orientation(1939);

  /**
   * generated from use.counter.css.page.css_image_rendering
   */
  /**
   * Whether a page used the CSS property image-rendering. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_image_rendering(1940);

  /**
   * generated from use.counter.css.page.css_ime_mode
   */
  /**
   * Whether a page used the CSS property ime-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ime_mode(1941);

  /**
   * generated from use.counter.css.page.css_initial_letter
   */
  /**
   * Whether a page used the CSS property initial-letter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_initial_letter(1942);

  /**
   * generated from use.counter.css.page.css_inline_size
   */
  /**
   * Whether a page used the CSS property inline-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inline_size(1943);

  /**
   * generated from use.counter.css.page.css_inset
   */
  /**
   * Whether a page used the CSS property inset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset(1944);

  /**
   * generated from use.counter.css.page.css_inset_block
   */
  /**
   * Whether a page used the CSS property inset-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block(1945);

  /**
   * generated from use.counter.css.page.css_inset_block_end
   */
  /**
   * Whether a page used the CSS property inset-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block_end(1946);

  /**
   * generated from use.counter.css.page.css_inset_block_start
   */
  /**
   * Whether a page used the CSS property inset-block-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block_start(1947);

  /**
   * generated from use.counter.css.page.css_inset_inline
   */
  /**
   * Whether a page used the CSS property inset-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline(1948);

  /**
   * generated from use.counter.css.page.css_inset_inline_end
   */
  /**
   * Whether a page used the CSS property inset-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline_end(1949);

  /**
   * generated from use.counter.css.page.css_inset_inline_start
   */
  /**
   * Whether a page used the CSS property inset-inline-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline_start(1950);

  /**
   * generated from use.counter.css.page.css_isolation
   */
  /**
   * Whether a page used the CSS property isolation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_isolation(1951);

  /**
   * generated from use.counter.css.page.css_justify_content
   */
  /**
   * Whether a page used the CSS property justify-content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_content(1952);

  /**
   * generated from use.counter.css.page.css_justify_items
   */
  /**
   * Whether a page used the CSS property justify-items. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_items(1953);

  /**
   * generated from use.counter.css.page.css_justify_self
   */
  /**
   * Whether a page used the CSS property justify-self. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_self(1954);

  /**
   * generated from use.counter.css.page.css_left
   */
  /**
   * Whether a page used the CSS property left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_left(1955);

  /**
   * generated from use.counter.css.page.css_letter_spacing
   */
  /**
   * Whether a page used the CSS property letter-spacing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_letter_spacing(1956);

  /**
   * generated from use.counter.css.page.css_lighting_color
   */
  /**
   * Whether a page used the CSS property lighting-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_lighting_color(1957);

  /**
   * generated from use.counter.css.page.css_line_break
   */
  /**
   * Whether a page used the CSS property line-break. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_line_break(1958);

  /**
   * generated from use.counter.css.page.css_line_height
   */
  /**
   * Whether a page used the CSS property line-height. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_line_height(1959);

  /**
   * generated from use.counter.css.page.css_list_style
   */
  /**
   * Whether a page used the CSS property list-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style(1960);

  /**
   * generated from use.counter.css.page.css_list_style_image
   */
  /**
   * Whether a page used the CSS property list-style-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_image(1961);

  /**
   * generated from use.counter.css.page.css_list_style_position
   */
  /**
   * Whether a page used the CSS property list-style-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_position(1962);

  /**
   * generated from use.counter.css.page.css_list_style_type
   */
  /**
   * Whether a page used the CSS property list-style-type. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_type(1963);

  /**
   * generated from use.counter.css.page.css_margin
   */
  /**
   * Whether a page used the CSS property margin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin(1964);

  /**
   * generated from use.counter.css.page.css_margin_block
   */
  /**
   * Whether a page used the CSS property margin-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block(1965);

  /**
   * generated from use.counter.css.page.css_margin_block_end
   */
  /**
   * Whether a page used the CSS property margin-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block_end(1966);

  /**
   * generated from use.counter.css.page.css_margin_block_start
   */
  /**
   * Whether a page used the CSS property margin-block-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block_start(1967);

  /**
   * generated from use.counter.css.page.css_margin_bottom
   */
  /**
   * Whether a page used the CSS property margin-bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_bottom(1968);

  /**
   * generated from use.counter.css.page.css_margin_inline
   */
  /**
   * Whether a page used the CSS property margin-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline(1969);

  /**
   * generated from use.counter.css.page.css_margin_inline_end
   */
  /**
   * Whether a page used the CSS property margin-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline_end(1970);

  /**
   * generated from use.counter.css.page.css_margin_inline_start
   */
  /**
   * Whether a page used the CSS property margin-inline-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline_start(1971);

  /**
   * generated from use.counter.css.page.css_margin_left
   */
  /**
   * Whether a page used the CSS property margin-left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_left(1972);

  /**
   * generated from use.counter.css.page.css_margin_right
   */
  /**
   * Whether a page used the CSS property margin-right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_right(1973);

  /**
   * generated from use.counter.css.page.css_margin_top
   */
  /**
   * Whether a page used the CSS property margin-top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_top(1974);

  /**
   * generated from use.counter.css.page.css_marker
   */
  /**
   * Whether a page used the CSS property marker. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker(1975);

  /**
   * generated from use.counter.css.page.css_marker_end
   */
  /**
   * Whether a page used the CSS property marker-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_end(1976);

  /**
   * generated from use.counter.css.page.css_marker_mid
   */
  /**
   * Whether a page used the CSS property marker-mid. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_mid(1977);

  /**
   * generated from use.counter.css.page.css_marker_start
   */
  /**
   * Whether a page used the CSS property marker-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_start(1978);

  /**
   * generated from use.counter.css.page.css_mask
   */
  /**
   * Whether a page used the CSS property mask. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask(1979);

  /**
   * generated from use.counter.css.page.css_mask_clip
   */
  /**
   * Whether a page used the CSS property mask-clip. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_clip(1980);

  /**
   * generated from use.counter.css.page.css_mask_composite
   */
  /**
   * Whether a page used the CSS property mask-composite. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_composite(1981);

  /**
   * generated from use.counter.css.page.css_mask_image
   */
  /**
   * Whether a page used the CSS property mask-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_image(1982);

  /**
   * generated from use.counter.css.page.css_mask_mode
   */
  /**
   * Whether a page used the CSS property mask-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_mode(1983);

  /**
   * generated from use.counter.css.page.css_mask_origin
   */
  /**
   * Whether a page used the CSS property mask-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_origin(1984);

  /**
   * generated from use.counter.css.page.css_mask_position
   */
  /**
   * Whether a page used the CSS property mask-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position(1985);

  /**
   * generated from use.counter.css.page.css_mask_position_x
   */
  /**
   * Whether a page used the CSS property mask-position-x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position_x(1986);

  /**
   * generated from use.counter.css.page.css_mask_position_y
   */
  /**
   * Whether a page used the CSS property mask-position-y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position_y(1987);

  /**
   * generated from use.counter.css.page.css_mask_repeat
   */
  /**
   * Whether a page used the CSS property mask-repeat. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_repeat(1988);

  /**
   * generated from use.counter.css.page.css_mask_size
   */
  /**
   * Whether a page used the CSS property mask-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_size(1989);

  /**
   * generated from use.counter.css.page.css_mask_type
   */
  /**
   * Whether a page used the CSS property mask-type. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_type(1990);

  /**
   * generated from use.counter.css.page.css_masonry_auto_flow
   */
  /**
   * Whether a page used the CSS property masonry-auto-flow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_masonry_auto_flow(1991);

  /**
   * generated from use.counter.css.page.css_math_depth
   */
  /**
   * Whether a page used the CSS property math-depth. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_math_depth(1992);

  /**
   * generated from use.counter.css.page.css_math_style
   */
  /**
   * Whether a page used the CSS property math-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_math_style(1993);

  /**
   * generated from use.counter.css.page.css_max_block_size
   */
  /**
   * Whether a page used the CSS property max-block-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_block_size(1994);

  /**
   * generated from use.counter.css.page.css_max_height
   */
  /**
   * Whether a page used the CSS property max-height. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_height(1995);

  /**
   * generated from use.counter.css.page.css_max_inline_size
   */
  /**
   * Whether a page used the CSS property max-inline-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_inline_size(1996);

  /**
   * generated from use.counter.css.page.css_max_width
   */
  /**
   * Whether a page used the CSS property max-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_width(1997);

  /**
   * generated from use.counter.css.page.css_min_block_size
   */
  /**
   * Whether a page used the CSS property min-block-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_block_size(1998);

  /**
   * generated from use.counter.css.page.css_min_height
   */
  /**
   * Whether a page used the CSS property min-height. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_height(1999);

  /**
   * generated from use.counter.css.page.css_min_inline_size
   */
  /**
   * Whether a page used the CSS property min-inline-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_inline_size(2000);

  /**
   * generated from use.counter.css.page.css_min_width
   */
  /**
   * Whether a page used the CSS property min-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_width(2001);

  /**
   * generated from use.counter.css.page.css_mix_blend_mode
   */
  /**
   * Whether a page used the CSS property mix-blend-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mix_blend_mode(2002);

  /**
   * generated from use.counter.css.page.css_moz_animation
   */
  /**
   * Whether a page used the CSS property -moz-animation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation(2003);

  /**
   * generated from use.counter.css.page.css_moz_animation_delay
   */
  /**
   * Whether a page used the CSS property -moz-animation-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_delay(2004);

  /**
   * generated from use.counter.css.page.css_moz_animation_direction
   */
  /**
   * Whether a page used the CSS property -moz-animation-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_direction(2005);

  /**
   * generated from use.counter.css.page.css_moz_animation_duration
   */
  /**
   * Whether a page used the CSS property -moz-animation-duration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_duration(2006);

  /**
   * generated from use.counter.css.page.css_moz_animation_fill_mode
   */
  /**
   * Whether a page used the CSS property -moz-animation-fill-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_fill_mode(2007);

  /**
   * generated from use.counter.css.page.css_moz_animation_iteration_count
   */
  /**
   * Whether a page used the CSS property -moz-animation-iteration-count. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_animation_iteration_count(2008);

  /**
   * generated from use.counter.css.page.css_moz_animation_name
   */
  /**
   * Whether a page used the CSS property -moz-animation-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_name(2009);

  /**
   * generated from use.counter.css.page.css_moz_animation_play_state
   */
  /**
   * Whether a page used the CSS property -moz-animation-play-state. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_play_state(2010);

  /**
   * generated from use.counter.css.page.css_moz_animation_timing_function
   */
  /**
   * Whether a page used the CSS property -moz-animation-timing-function. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_animation_timing_function(2011);

  /**
   * generated from use.counter.css.page.css_moz_appearance
   */
  /**
   * Whether a page used the CSS property -moz-appearance. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_appearance(2012);

  /**
   * generated from use.counter.css.page.css_moz_backface_visibility
   */
  /**
   * Whether a page used the CSS property -moz-backface-visibility. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_backface_visibility(2013);

  /**
   * generated from use.counter.css.page.css_moz_border_end
   */
  /**
   * Whether a page used the CSS property -moz-border-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end(2014);

  /**
   * generated from use.counter.css.page.css_moz_border_end_color
   */
  /**
   * Whether a page used the CSS property -moz-border-end-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_color(2015);

  /**
   * generated from use.counter.css.page.css_moz_border_end_style
   */
  /**
   * Whether a page used the CSS property -moz-border-end-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_style(2016);

  /**
   * generated from use.counter.css.page.css_moz_border_end_width
   */
  /**
   * Whether a page used the CSS property -moz-border-end-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_width(2017);

  /**
   * generated from use.counter.css.page.css_moz_border_image
   */
  /**
   * Whether a page used the CSS property -moz-border-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_image(2018);

  /**
   * generated from use.counter.css.page.css_moz_border_start
   */
  /**
   * Whether a page used the CSS property -moz-border-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start(2019);

  /**
   * generated from use.counter.css.page.css_moz_border_start_color
   */
  /**
   * Whether a page used the CSS property -moz-border-start-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_color(2020);

  /**
   * generated from use.counter.css.page.css_moz_border_start_style
   */
  /**
   * Whether a page used the CSS property -moz-border-start-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_style(2021);

  /**
   * generated from use.counter.css.page.css_moz_border_start_width
   */
  /**
   * Whether a page used the CSS property -moz-border-start-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_width(2022);

  /**
   * generated from use.counter.css.page.css_moz_box_align
   */
  /**
   * Whether a page used the CSS property -moz-box-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_align(2023);

  /**
   * generated from use.counter.css.page.css_moz_box_collapse
   */
  /**
   * Whether a page used the CSS property -moz-box-collapse. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_collapse(2024);

  /**
   * generated from use.counter.css.page.css_moz_box_direction
   */
  /**
   * Whether a page used the CSS property -moz-box-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_direction(2025);

  /**
   * generated from use.counter.css.page.css_moz_box_flex
   */
  /**
   * Whether a page used the CSS property -moz-box-flex. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_flex(2026);

  /**
   * generated from use.counter.css.page.css_moz_box_ordinal_group
   */
  /**
   * Whether a page used the CSS property -moz-box-ordinal-group. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_ordinal_group(2027);

  /**
   * generated from use.counter.css.page.css_moz_box_orient
   */
  /**
   * Whether a page used the CSS property -moz-box-orient. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_orient(2028);

  /**
   * generated from use.counter.css.page.css_moz_box_pack
   */
  /**
   * Whether a page used the CSS property -moz-box-pack. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_pack(2029);

  /**
   * generated from use.counter.css.page.css_moz_box_sizing
   */
  /**
   * Whether a page used the CSS property -moz-box-sizing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_sizing(2030);

  /**
   * generated from use.counter.css.page.css_moz_context_properties
   */
  /**
   * Whether a page used the CSS property -moz-context-properties. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_context_properties(2031);

  /**
   * generated from use.counter.css.page.css_moz_control_character_visibility
   */
  /**
   * Whether a page used the CSS property -moz-control-character-visibility. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_control_character_visibility(2032);

  /**
   * generated from use.counter.css.page.css_moz_default_appearance
   */
  /**
   * Whether a page used the CSS property -moz-default-appearance. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_default_appearance(2033);

  /**
   * generated from use.counter.css.page.css_moz_float_edge
   */
  /**
   * Whether a page used the CSS property -moz-float-edge. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_float_edge(2034);

  /**
   * generated from use.counter.css.page.css_moz_font_feature_settings
   */
  /**
   * Whether a page used the CSS property -moz-font-feature-settings. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_font_feature_settings(2035);

  /**
   * generated from use.counter.css.page.css_moz_font_language_override
   */
  /**
   * Whether a page used the CSS property -moz-font-language-override. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_font_language_override(2036);

  /**
   * generated from use.counter.css.page.css_moz_force_broken_image_icon
   */
  /**
   * Whether a page used the CSS property -moz-force-broken-image-icon. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_force_broken_image_icon(2037);

  /**
   * generated from use.counter.css.page.css_moz_hyphens
   */
  /**
   * Whether a page used the CSS property -moz-hyphens. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_hyphens(2038);

  /**
   * generated from use.counter.css.page.css_moz_inert
   */
  /**
   * Whether a page used the CSS property -moz-inert. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_inert(2039);

  /**
   * generated from use.counter.css.page.css_moz_margin_end
   */
  /**
   * Whether a page used the CSS property -moz-margin-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_margin_end(2040);

  /**
   * generated from use.counter.css.page.css_moz_margin_start
   */
  /**
   * Whether a page used the CSS property -moz-margin-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_margin_start(2041);

  /**
   * generated from use.counter.css.page.css_moz_math_variant
   */
  /**
   * Whether a page used the CSS property -moz-math-variant. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_math_variant(2042);

  /**
   * generated from use.counter.css.page.css_moz_min_font_size_ratio
   */
  /**
   * Whether a page used the CSS property -moz-min-font-size-ratio. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_min_font_size_ratio(2043);

  /**
   * generated from use.counter.css.page.css_moz_orient
   */
  /**
   * Whether a page used the CSS property -moz-orient. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_orient(2044);

  /**
   * generated from use.counter.css.page.css_moz_osx_font_smoothing
   */
  /**
   * Whether a page used the CSS property -moz-osx-font-smoothing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_osx_font_smoothing(2045);

  /**
   * generated from use.counter.css.page.css_moz_padding_end
   */
  /**
   * Whether a page used the CSS property -moz-padding-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_padding_end(2046);

  /**
   * generated from use.counter.css.page.css_moz_padding_start
   */
  /**
   * Whether a page used the CSS property -moz-padding-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_padding_start(2047);

  /**
   * generated from use.counter.css.page.css_moz_perspective
   */
  /**
   * Whether a page used the CSS property -moz-perspective. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_perspective(2048);

  /**
   * generated from use.counter.css.page.css_moz_perspective_origin
   */
  /**
   * Whether a page used the CSS property -moz-perspective-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_perspective_origin(2049);

  /**
   * generated from use.counter.css.page.css_moz_subtree_hidden_only_visually
   */
  /**
   * Whether a page used the CSS property -moz-subtree-hidden-only-visually. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_subtree_hidden_only_visually(2050);

  /**
   * generated from use.counter.css.page.css_moz_tab_size
   */
  /**
   * Whether a page used the CSS property -moz-tab-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_tab_size(2051);

  /**
   * generated from use.counter.css.page.css_moz_text_size_adjust
   */
  /**
   * Whether a page used the CSS property -moz-text-size-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_text_size_adjust(2052);

  /**
   * generated from use.counter.css.page.css_moz_theme
   */
  /**
   * Whether a page used the CSS property -moz-theme. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_theme(2053);

  /**
   * generated from use.counter.css.page.css_moz_top_layer
   */
  /**
   * Whether a page used the CSS property -moz-top-layer. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_top_layer(2054);

  /**
   * generated from use.counter.css.page.css_moz_transform
   */
  /**
   * Whether a page used the CSS property -moz-transform. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform(2055);

  /**
   * generated from use.counter.css.page.css_moz_transform_origin
   */
  /**
   * Whether a page used the CSS property -moz-transform-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform_origin(2056);

  /**
   * generated from use.counter.css.page.css_moz_transform_style
   */
  /**
   * Whether a page used the CSS property -moz-transform-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform_style(2057);

  /**
   * generated from use.counter.css.page.css_moz_transition
   */
  /**
   * Whether a page used the CSS property -moz-transition. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition(2058);

  /**
   * generated from use.counter.css.page.css_moz_transition_delay
   */
  /**
   * Whether a page used the CSS property -moz-transition-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_delay(2059);

  /**
   * generated from use.counter.css.page.css_moz_transition_duration
   */
  /**
   * Whether a page used the CSS property -moz-transition-duration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_duration(2060);

  /**
   * generated from use.counter.css.page.css_moz_transition_property
   */
  /**
   * Whether a page used the CSS property -moz-transition-property. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_property(2061);

  /**
   * generated from use.counter.css.page.css_moz_transition_timing_function
   */
  /**
   * Whether a page used the CSS property -moz-transition-timing-function. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_transition_timing_function(2062);

  /**
   * generated from use.counter.css.page.css_moz_user_focus
   */
  /**
   * Whether a page used the CSS property -moz-user-focus. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_focus(2063);

  /**
   * generated from use.counter.css.page.css_moz_user_input
   */
  /**
   * Whether a page used the CSS property -moz-user-input. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_input(2064);

  /**
   * generated from use.counter.css.page.css_moz_user_select
   */
  /**
   * Whether a page used the CSS property -moz-user-select. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_select(2065);

  /**
   * generated from use.counter.css.page.css_moz_window_dragging
   */
  /**
   * Whether a page used the CSS property -moz-window-dragging. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_dragging(2066);

  /**
   * generated from use.counter.css.page.css_moz_window_input_region_margin
   */
  /**
   * Whether a page used the CSS property -moz-window-input-region-margin. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_window_input_region_margin(2067);

  /**
   * generated from use.counter.css.page.css_moz_window_opacity
   */
  /**
   * Whether a page used the CSS property -moz-window-opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_opacity(2068);

  /**
   * generated from use.counter.css.page.css_moz_window_shadow
   */
  /**
   * Whether a page used the CSS property -moz-window-shadow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_shadow(2069);

  /**
   * generated from use.counter.css.page.css_moz_window_transform
   */
  /**
   * Whether a page used the CSS property -moz-window-transform. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_transform(2070);

  /**
   * generated from use.counter.css.page.css_object_fit
   */
  /**
   * Whether a page used the CSS property object-fit. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_object_fit(2071);

  /**
   * generated from use.counter.css.page.css_object_position
   */
  /**
   * Whether a page used the CSS property object-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_object_position(2072);

  /**
   * generated from use.counter.css.page.css_offset
   */
  /**
   * Whether a page used the CSS property offset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset(2073);

  /**
   * generated from use.counter.css.page.css_offset_anchor
   */
  /**
   * Whether a page used the CSS property offset-anchor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_anchor(2074);

  /**
   * generated from use.counter.css.page.css_offset_distance
   */
  /**
   * Whether a page used the CSS property offset-distance. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_distance(2075);

  /**
   * generated from use.counter.css.page.css_offset_path
   */
  /**
   * Whether a page used the CSS property offset-path. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_path(2076);

  /**
   * generated from use.counter.css.page.css_offset_position
   */
  /**
   * Whether a page used the CSS property offset-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_position(2077);

  /**
   * generated from use.counter.css.page.css_offset_rotate
   */
  /**
   * Whether a page used the CSS property offset-rotate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_rotate(2078);

  /**
   * generated from use.counter.css.page.css_opacity
   */
  /**
   * Whether a page used the CSS property opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_opacity(2079);

  /**
   * generated from use.counter.css.page.css_order
   */
  /**
   * Whether a page used the CSS property order. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_order(2080);

  /**
   * generated from use.counter.css.page.css_outline
   */
  /**
   * Whether a page used the CSS property outline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline(2081);

  /**
   * generated from use.counter.css.page.css_outline_color
   */
  /**
   * Whether a page used the CSS property outline-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_color(2082);

  /**
   * generated from use.counter.css.page.css_outline_offset
   */
  /**
   * Whether a page used the CSS property outline-offset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_offset(2083);

  /**
   * generated from use.counter.css.page.css_outline_style
   */
  /**
   * Whether a page used the CSS property outline-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_style(2084);

  /**
   * generated from use.counter.css.page.css_outline_width
   */
  /**
   * Whether a page used the CSS property outline-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_width(2085);

  /**
   * generated from use.counter.css.page.css_overflow
   */
  /**
   * Whether a page used the CSS property overflow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow(2086);

  /**
   * generated from use.counter.css.page.css_overflow_anchor
   */
  /**
   * Whether a page used the CSS property overflow-anchor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_anchor(2087);

  /**
   * generated from use.counter.css.page.css_overflow_block
   */
  /**
   * Whether a page used the CSS property overflow-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_block(2088);

  /**
   * generated from use.counter.css.page.css_overflow_clip_box
   */
  /**
   * Whether a page used the CSS property overflow-clip-box. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box(2089);

  /**
   * generated from use.counter.css.page.css_overflow_clip_box_block
   */
  /**
   * Whether a page used the CSS property overflow-clip-box-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box_block(2090);

  /**
   * generated from use.counter.css.page.css_overflow_clip_box_inline
   */
  /**
   * Whether a page used the CSS property overflow-clip-box-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box_inline(2091);

  /**
   * generated from use.counter.css.page.css_overflow_clip_margin
   */
  /**
   * Whether a page used the CSS property overflow-clip-margin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_margin(2092);

  /**
   * generated from use.counter.css.page.css_overflow_inline
   */
  /**
   * Whether a page used the CSS property overflow-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_inline(2093);

  /**
   * generated from use.counter.css.page.css_overflow_wrap
   */
  /**
   * Whether a page used the CSS property overflow-wrap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_wrap(2094);

  /**
   * generated from use.counter.css.page.css_overflow_x
   */
  /**
   * Whether a page used the CSS property overflow-x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_x(2095);

  /**
   * generated from use.counter.css.page.css_overflow_y
   */
  /**
   * Whether a page used the CSS property overflow-y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_y(2096);

  /**
   * generated from use.counter.css.page.css_overscroll_behavior
   */
  /**
   * Whether a page used the CSS property overscroll-behavior. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior(2097);

  /**
   * generated from use.counter.css.page.css_overscroll_behavior_block
   */
  /**
   * Whether a page used the CSS property overscroll-behavior-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_block(2098);

  /**
   * generated from use.counter.css.page.css_overscroll_behavior_inline
   */
  /**
   * Whether a page used the CSS property overscroll-behavior-inline. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_inline(2099);

  /**
   * generated from use.counter.css.page.css_overscroll_behavior_x
   */
  /**
   * Whether a page used the CSS property overscroll-behavior-x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_x(2100);

  /**
   * generated from use.counter.css.page.css_overscroll_behavior_y
   */
  /**
   * Whether a page used the CSS property overscroll-behavior-y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_y(2101);

  /**
   * generated from use.counter.css.page.css_padding
   */
  /**
   * Whether a page used the CSS property padding. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding(2102);

  /**
   * generated from use.counter.css.page.css_padding_block
   */
  /**
   * Whether a page used the CSS property padding-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block(2103);

  /**
   * generated from use.counter.css.page.css_padding_block_end
   */
  /**
   * Whether a page used the CSS property padding-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block_end(2104);

  /**
   * generated from use.counter.css.page.css_padding_block_start
   */
  /**
   * Whether a page used the CSS property padding-block-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block_start(2105);

  /**
   * generated from use.counter.css.page.css_padding_bottom
   */
  /**
   * Whether a page used the CSS property padding-bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_bottom(2106);

  /**
   * generated from use.counter.css.page.css_padding_inline
   */
  /**
   * Whether a page used the CSS property padding-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline(2107);

  /**
   * generated from use.counter.css.page.css_padding_inline_end
   */
  /**
   * Whether a page used the CSS property padding-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline_end(2108);

  /**
   * generated from use.counter.css.page.css_padding_inline_start
   */
  /**
   * Whether a page used the CSS property padding-inline-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline_start(2109);

  /**
   * generated from use.counter.css.page.css_padding_left
   */
  /**
   * Whether a page used the CSS property padding-left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_left(2110);

  /**
   * generated from use.counter.css.page.css_padding_right
   */
  /**
   * Whether a page used the CSS property padding-right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_right(2111);

  /**
   * generated from use.counter.css.page.css_padding_top
   */
  /**
   * Whether a page used the CSS property padding-top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_top(2112);

  /**
   * generated from use.counter.css.page.css_page
   */
  /**
   * Whether a page used the CSS property page. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page(2113);

  /**
   * generated from use.counter.css.page.css_page_break_after
   */
  /**
   * Whether a page used the CSS property page-break-after. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_after(2114);

  /**
   * generated from use.counter.css.page.css_page_break_before
   */
  /**
   * Whether a page used the CSS property page-break-before. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_before(2115);

  /**
   * generated from use.counter.css.page.css_page_break_inside
   */
  /**
   * Whether a page used the CSS property page-break-inside. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_inside(2116);

  /**
   * generated from use.counter.css.page.css_page_orientation
   */
  /**
   * Whether a page used the CSS property page-orientation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_orientation(2117);

  /**
   * generated from use.counter.css.page.css_paint_order
   */
  /**
   * Whether a page used the CSS property paint-order. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_paint_order(2118);

  /**
   * generated from use.counter.css.page.css_perspective
   */
  /**
   * Whether a page used the CSS property perspective. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_perspective(2119);

  /**
   * generated from use.counter.css.page.css_perspective_origin
   */
  /**
   * Whether a page used the CSS property perspective-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_perspective_origin(2120);

  /**
   * generated from use.counter.css.page.css_place_content
   */
  /**
   * Whether a page used the CSS property place-content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_content(2121);

  /**
   * generated from use.counter.css.page.css_place_items
   */
  /**
   * Whether a page used the CSS property place-items. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_items(2122);

  /**
   * generated from use.counter.css.page.css_place_self
   */
  /**
   * Whether a page used the CSS property place-self. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_self(2123);

  /**
   * generated from use.counter.css.page.css_pointer_events
   */
  /**
   * Whether a page used the CSS property pointer-events. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_pointer_events(2124);

  /**
   * generated from use.counter.css.page.css_position
   */
  /**
   * Whether a page used the CSS property position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position(2125);

  /**
   * generated from use.counter.css.page.css_position_anchor
   */
  /**
   * Whether a page used the CSS property position-anchor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_anchor(2126);

  /**
   * generated from use.counter.css.page.css_position_area
   */
  /**
   * Whether a page used the CSS property position-area. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_area(2127);

  /**
   * generated from use.counter.css.page.css_position_try
   */
  /**
   * Whether a page used the CSS property position-try. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_try(2128);

  /**
   * generated from use.counter.css.page.css_position_try_fallbacks
   */
  /**
   * Whether a page used the CSS property position-try-fallbacks. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_try_fallbacks(2129);

  /**
   * generated from use.counter.css.page.css_position_try_order
   */
  /**
   * Whether a page used the CSS property position-try-order. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_try_order(2130);

  /**
   * generated from use.counter.css.page.css_position_visibility
   */
  /**
   * Whether a page used the CSS property position-visibility. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position_visibility(2131);

  /**
   * generated from use.counter.css.page.css_print_color_adjust
   */
  /**
   * Whether a page used the CSS property print-color-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_print_color_adjust(2132);

  /**
   * generated from use.counter.css.page.css_quotes
   */
  /**
   * Whether a page used the CSS property quotes. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_quotes(2133);

  /**
   * generated from use.counter.css.page.css_r
   */
  /**
   * Whether a page used the CSS property r. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_r(2134);

  /**
   * generated from use.counter.css.page.css_resize
   */
  /**
   * Whether a page used the CSS property resize. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_resize(2135);

  /**
   * generated from use.counter.css.page.css_right
   */
  /**
   * Whether a page used the CSS property right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_right(2136);

  /**
   * generated from use.counter.css.page.css_rotate
   */
  /**
   * Whether a page used the CSS property rotate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_rotate(2137);

  /**
   * generated from use.counter.css.page.css_row_gap
   */
  /**
   * Whether a page used the CSS property row-gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_row_gap(2138);

  /**
   * generated from use.counter.css.page.css_ruby_align
   */
  /**
   * Whether a page used the CSS property ruby-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ruby_align(2139);

  /**
   * generated from use.counter.css.page.css_ruby_position
   */
  /**
   * Whether a page used the CSS property ruby-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ruby_position(2140);

  /**
   * generated from use.counter.css.page.css_rx
   */
  /**
   * Whether a page used the CSS property rx. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_rx(2141);

  /**
   * generated from use.counter.css.page.css_ry
   */
  /**
   * Whether a page used the CSS property ry. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ry(2142);

  /**
   * generated from use.counter.css.page.css_scale
   */
  /**
   * Whether a page used the CSS property scale. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scale(2143);

  /**
   * generated from use.counter.css.page.css_scroll_behavior
   */
  /**
   * Whether a page used the CSS property scroll-behavior. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_behavior(2144);

  /**
   * generated from use.counter.css.page.css_scroll_margin
   */
  /**
   * Whether a page used the CSS property scroll-margin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin(2145);

  /**
   * generated from use.counter.css.page.css_scroll_margin_block
   */
  /**
   * Whether a page used the CSS property scroll-margin-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block(2146);

  /**
   * generated from use.counter.css.page.css_scroll_margin_block_end
   */
  /**
   * Whether a page used the CSS property scroll-margin-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block_end(2147);

  /**
   * generated from use.counter.css.page.css_scroll_margin_block_start
   */
  /**
   * Whether a page used the CSS property scroll-margin-block-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block_start(2148);

  /**
   * generated from use.counter.css.page.css_scroll_margin_bottom
   */
  /**
   * Whether a page used the CSS property scroll-margin-bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_bottom(2149);

  /**
   * generated from use.counter.css.page.css_scroll_margin_inline
   */
  /**
   * Whether a page used the CSS property scroll-margin-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline(2150);

  /**
   * generated from use.counter.css.page.css_scroll_margin_inline_end
   */
  /**
   * Whether a page used the CSS property scroll-margin-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline_end(2151);

  /**
   * generated from use.counter.css.page.css_scroll_margin_inline_start
   */
  /**
   * Whether a page used the CSS property scroll-margin-inline-start. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline_start(2152);

  /**
   * generated from use.counter.css.page.css_scroll_margin_left
   */
  /**
   * Whether a page used the CSS property scroll-margin-left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_left(2153);

  /**
   * generated from use.counter.css.page.css_scroll_margin_right
   */
  /**
   * Whether a page used the CSS property scroll-margin-right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_right(2154);

  /**
   * generated from use.counter.css.page.css_scroll_margin_top
   */
  /**
   * Whether a page used the CSS property scroll-margin-top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_top(2155);

  /**
   * generated from use.counter.css.page.css_scroll_padding
   */
  /**
   * Whether a page used the CSS property scroll-padding. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding(2156);

  /**
   * generated from use.counter.css.page.css_scroll_padding_block
   */
  /**
   * Whether a page used the CSS property scroll-padding-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block(2157);

  /**
   * generated from use.counter.css.page.css_scroll_padding_block_end
   */
  /**
   * Whether a page used the CSS property scroll-padding-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block_end(2158);

  /**
   * generated from use.counter.css.page.css_scroll_padding_block_start
   */
  /**
   * Whether a page used the CSS property scroll-padding-block-start. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block_start(2159);

  /**
   * generated from use.counter.css.page.css_scroll_padding_bottom
   */
  /**
   * Whether a page used the CSS property scroll-padding-bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_bottom(2160);

  /**
   * generated from use.counter.css.page.css_scroll_padding_inline
   */
  /**
   * Whether a page used the CSS property scroll-padding-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline(2161);

  /**
   * generated from use.counter.css.page.css_scroll_padding_inline_end
   */
  /**
   * Whether a page used the CSS property scroll-padding-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline_end(2162);

  /**
   * generated from use.counter.css.page.css_scroll_padding_inline_start
   */
  /**
   * Whether a page used the CSS property scroll-padding-inline-start. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline_start(2163);

  /**
   * generated from use.counter.css.page.css_scroll_padding_left
   */
  /**
   * Whether a page used the CSS property scroll-padding-left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_left(2164);

  /**
   * generated from use.counter.css.page.css_scroll_padding_right
   */
  /**
   * Whether a page used the CSS property scroll-padding-right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_right(2165);

  /**
   * generated from use.counter.css.page.css_scroll_padding_top
   */
  /**
   * Whether a page used the CSS property scroll-padding-top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_top(2166);

  /**
   * generated from use.counter.css.page.css_scroll_snap_align
   */
  /**
   * Whether a page used the CSS property scroll-snap-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_align(2167);

  /**
   * generated from use.counter.css.page.css_scroll_snap_stop
   */
  /**
   * Whether a page used the CSS property scroll-snap-stop. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_stop(2168);

  /**
   * generated from use.counter.css.page.css_scroll_snap_type
   */
  /**
   * Whether a page used the CSS property scroll-snap-type. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_type(2169);

  /**
   * generated from use.counter.css.page.css_scroll_timeline
   */
  /**
   * Whether a page used the CSS property scroll-timeline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline(2170);

  /**
   * generated from use.counter.css.page.css_scroll_timeline_axis
   */
  /**
   * Whether a page used the CSS property scroll-timeline-axis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline_axis(2171);

  /**
   * generated from use.counter.css.page.css_scroll_timeline_name
   */
  /**
   * Whether a page used the CSS property scroll-timeline-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline_name(2172);

  /**
   * generated from use.counter.css.page.css_scrollbar_color
   */
  /**
   * Whether a page used the CSS property scrollbar-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_color(2173);

  /**
   * generated from use.counter.css.page.css_scrollbar_gutter
   */
  /**
   * Whether a page used the CSS property scrollbar-gutter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_gutter(2174);

  /**
   * generated from use.counter.css.page.css_scrollbar_width
   */
  /**
   * Whether a page used the CSS property scrollbar-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_width(2175);

  /**
   * generated from use.counter.css.page.css_shape_image_threshold
   */
  /**
   * Whether a page used the CSS property shape-image-threshold. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_image_threshold(2176);

  /**
   * generated from use.counter.css.page.css_shape_margin
   */
  /**
   * Whether a page used the CSS property shape-margin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_margin(2177);

  /**
   * generated from use.counter.css.page.css_shape_outside
   */
  /**
   * Whether a page used the CSS property shape-outside. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_outside(2178);

  /**
   * generated from use.counter.css.page.css_shape_rendering
   */
  /**
   * Whether a page used the CSS property shape-rendering. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_rendering(2179);

  /**
   * generated from use.counter.css.page.css_size
   */
  /**
   * Whether a page used the CSS property size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_size(2180);

  /**
   * generated from use.counter.css.page.css_stop_color
   */
  /**
   * Whether a page used the CSS property stop-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stop_color(2181);

  /**
   * generated from use.counter.css.page.css_stop_opacity
   */
  /**
   * Whether a page used the CSS property stop-opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stop_opacity(2182);

  /**
   * generated from use.counter.css.page.css_stroke
   */
  /**
   * Whether a page used the CSS property stroke. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke(2183);

  /**
   * generated from use.counter.css.page.css_stroke_dasharray
   */
  /**
   * Whether a page used the CSS property stroke-dasharray. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_dasharray(2184);

  /**
   * generated from use.counter.css.page.css_stroke_dashoffset
   */
  /**
   * Whether a page used the CSS property stroke-dashoffset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_dashoffset(2185);

  /**
   * generated from use.counter.css.page.css_stroke_linecap
   */
  /**
   * Whether a page used the CSS property stroke-linecap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_linecap(2186);

  /**
   * generated from use.counter.css.page.css_stroke_linejoin
   */
  /**
   * Whether a page used the CSS property stroke-linejoin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_linejoin(2187);

  /**
   * generated from use.counter.css.page.css_stroke_miterlimit
   */
  /**
   * Whether a page used the CSS property stroke-miterlimit. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_miterlimit(2188);

  /**
   * generated from use.counter.css.page.css_stroke_opacity
   */
  /**
   * Whether a page used the CSS property stroke-opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_opacity(2189);

  /**
   * generated from use.counter.css.page.css_stroke_width
   */
  /**
   * Whether a page used the CSS property stroke-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_width(2190);

  /**
   * generated from use.counter.css.page.css_tab_size
   */
  /**
   * Whether a page used the CSS property tab-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_tab_size(2191);

  /**
   * generated from use.counter.css.page.css_table_layout
   */
  /**
   * Whether a page used the CSS property table-layout. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_table_layout(2192);

  /**
   * generated from use.counter.css.page.css_text_align
   */
  /**
   * Whether a page used the CSS property text-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_align(2193);

  /**
   * generated from use.counter.css.page.css_text_align_last
   */
  /**
   * Whether a page used the CSS property text-align-last. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_align_last(2194);

  /**
   * generated from use.counter.css.page.css_text_anchor
   */
  /**
   * Whether a page used the CSS property text-anchor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_anchor(2195);

  /**
   * generated from use.counter.css.page.css_text_combine_upright
   */
  /**
   * Whether a page used the CSS property text-combine-upright. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_combine_upright(2196);

  /**
   * generated from use.counter.css.page.css_text_decoration
   */
  /**
   * Whether a page used the CSS property text-decoration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration(2197);

  /**
   * generated from use.counter.css.page.css_text_decoration_color
   */
  /**
   * Whether a page used the CSS property text-decoration-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_color(2198);

  /**
   * generated from use.counter.css.page.css_text_decoration_line
   */
  /**
   * Whether a page used the CSS property text-decoration-line. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_line(2199);

  /**
   * generated from use.counter.css.page.css_text_decoration_skip_ink
   */
  /**
   * Whether a page used the CSS property text-decoration-skip-ink. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_skip_ink(2200);

  /**
   * generated from use.counter.css.page.css_text_decoration_style
   */
  /**
   * Whether a page used the CSS property text-decoration-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_style(2201);

  /**
   * generated from use.counter.css.page.css_text_decoration_thickness
   */
  /**
   * Whether a page used the CSS property text-decoration-thickness. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_thickness(2202);

  /**
   * generated from use.counter.css.page.css_text_emphasis
   */
  /**
   * Whether a page used the CSS property text-emphasis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis(2203);

  /**
   * generated from use.counter.css.page.css_text_emphasis_color
   */
  /**
   * Whether a page used the CSS property text-emphasis-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_color(2204);

  /**
   * generated from use.counter.css.page.css_text_emphasis_position
   */
  /**
   * Whether a page used the CSS property text-emphasis-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_position(2205);

  /**
   * generated from use.counter.css.page.css_text_emphasis_style
   */
  /**
   * Whether a page used the CSS property text-emphasis-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_style(2206);

  /**
   * generated from use.counter.css.page.css_text_indent
   */
  /**
   * Whether a page used the CSS property text-indent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_indent(2207);

  /**
   * generated from use.counter.css.page.css_text_justify
   */
  /**
   * Whether a page used the CSS property text-justify. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_justify(2208);

  /**
   * generated from use.counter.css.page.css_text_orientation
   */
  /**
   * Whether a page used the CSS property text-orientation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_orientation(2209);

  /**
   * generated from use.counter.css.page.css_text_overflow
   */
  /**
   * Whether a page used the CSS property text-overflow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_overflow(2210);

  /**
   * generated from use.counter.css.page.css_text_rendering
   */
  /**
   * Whether a page used the CSS property text-rendering. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_rendering(2211);

  /**
   * generated from use.counter.css.page.css_text_shadow
   */
  /**
   * Whether a page used the CSS property text-shadow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_shadow(2212);

  /**
   * generated from use.counter.css.page.css_text_transform
   */
  /**
   * Whether a page used the CSS property text-transform. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_transform(2213);

  /**
   * generated from use.counter.css.page.css_text_underline_offset
   */
  /**
   * Whether a page used the CSS property text-underline-offset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_underline_offset(2214);

  /**
   * generated from use.counter.css.page.css_text_underline_position
   */
  /**
   * Whether a page used the CSS property text-underline-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_underline_position(2215);

  /**
   * generated from use.counter.css.page.css_text_wrap
   */
  /**
   * Whether a page used the CSS property text-wrap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_wrap(2216);

  /**
   * generated from use.counter.css.page.css_text_wrap_mode
   */
  /**
   * Whether a page used the CSS property text-wrap-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_wrap_mode(2217);

  /**
   * generated from use.counter.css.page.css_text_wrap_style
   */
  /**
   * Whether a page used the CSS property text-wrap-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_wrap_style(2218);

  /**
   * generated from use.counter.css.page.css_top
   */
  /**
   * Whether a page used the CSS property top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_top(2219);

  /**
   * generated from use.counter.css.page.css_touch_action
   */
  /**
   * Whether a page used the CSS property touch-action. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_touch_action(2220);

  /**
   * generated from use.counter.css.page.css_transform
   */
  /**
   * Whether a page used the CSS property transform. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform(2221);

  /**
   * generated from use.counter.css.page.css_transform_box
   */
  /**
   * Whether a page used the CSS property transform-box. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_box(2222);

  /**
   * generated from use.counter.css.page.css_transform_origin
   */
  /**
   * Whether a page used the CSS property transform-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_origin(2223);

  /**
   * generated from use.counter.css.page.css_transform_style
   */
  /**
   * Whether a page used the CSS property transform-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_style(2224);

  /**
   * generated from use.counter.css.page.css_transition
   */
  /**
   * Whether a page used the CSS property transition. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition(2225);

  /**
   * generated from use.counter.css.page.css_transition_behavior
   */
  /**
   * Whether a page used the CSS property transition-behavior. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_behavior(2226);

  /**
   * generated from use.counter.css.page.css_transition_delay
   */
  /**
   * Whether a page used the CSS property transition-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_delay(2227);

  /**
   * generated from use.counter.css.page.css_transition_duration
   */
  /**
   * Whether a page used the CSS property transition-duration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_duration(2228);

  /**
   * generated from use.counter.css.page.css_transition_property
   */
  /**
   * Whether a page used the CSS property transition-property. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_property(2229);

  /**
   * generated from use.counter.css.page.css_transition_timing_function
   */
  /**
   * Whether a page used the CSS property transition-timing-function. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_transition_timing_function(2230);

  /**
   * generated from use.counter.css.page.css_translate
   */
  /**
   * Whether a page used the CSS property translate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_translate(2231);

  /**
   * generated from use.counter.css.page.css_unicode_bidi
   */
  /**
   * Whether a page used the CSS property unicode-bidi. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_unicode_bidi(2232);

  /**
   * generated from use.counter.css.page.css_user_select
   */
  /**
   * Whether a page used the CSS property user-select. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_user_select(2233);

  /**
   * generated from use.counter.css.page.css_vector_effect
   */
  /**
   * Whether a page used the CSS property vector-effect. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_vector_effect(2234);

  /**
   * generated from use.counter.css.page.css_vertical_align
   */
  /**
   * Whether a page used the CSS property vertical-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_vertical_align(2235);

  /**
   * generated from use.counter.css.page.css_view_timeline
   */
  /**
   * Whether a page used the CSS property view-timeline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline(2236);

  /**
   * generated from use.counter.css.page.css_view_timeline_axis
   */
  /**
   * Whether a page used the CSS property view-timeline-axis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_axis(2237);

  /**
   * generated from use.counter.css.page.css_view_timeline_inset
   */
  /**
   * Whether a page used the CSS property view-timeline-inset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_inset(2238);

  /**
   * generated from use.counter.css.page.css_view_timeline_name
   */
  /**
   * Whether a page used the CSS property view-timeline-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_name(2239);

  /**
   * generated from use.counter.css.page.css_view_transition_name
   */
  /**
   * Whether a page used the CSS property view-transition-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_transition_name(2240);

  /**
   * generated from use.counter.css.page.css_visibility
   */
  /**
   * Whether a page used the CSS property visibility. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_visibility(2241);

  /**
   * generated from use.counter.css.page.css_webkit_align_content
   */
  /**
   * Whether a page used the CSS property -webkit-align-content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_content(2242);

  /**
   * generated from use.counter.css.page.css_webkit_align_items
   */
  /**
   * Whether a page used the CSS property -webkit-align-items. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_items(2243);

  /**
   * generated from use.counter.css.page.css_webkit_align_self
   */
  /**
   * Whether a page used the CSS property -webkit-align-self. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_self(2244);

  /**
   * generated from use.counter.css.page.css_webkit_animation
   */
  /**
   * Whether a page used the CSS property -webkit-animation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation(2245);

  /**
   * generated from use.counter.css.page.css_webkit_animation_delay
   */
  /**
   * Whether a page used the CSS property -webkit-animation-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_delay(2246);

  /**
   * generated from use.counter.css.page.css_webkit_animation_direction
   */
  /**
   * Whether a page used the CSS property -webkit-animation-direction. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_direction(2247);

  /**
   * generated from use.counter.css.page.css_webkit_animation_duration
   */
  /**
   * Whether a page used the CSS property -webkit-animation-duration. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_duration(2248);

  /**
   * generated from use.counter.css.page.css_webkit_animation_fill_mode
   */
  /**
   * Whether a page used the CSS property -webkit-animation-fill-mode. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_fill_mode(2249);

  /**
   * generated from use.counter.css.page.css_webkit_animation_iteration_count
   */
  /**
   * Whether a page used the CSS property -webkit-animation-iteration-count. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_iteration_count(2250);

  /**
   * generated from use.counter.css.page.css_webkit_animation_name
   */
  /**
   * Whether a page used the CSS property -webkit-animation-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_name(2251);

  /**
   * generated from use.counter.css.page.css_webkit_animation_play_state
   */
  /**
   * Whether a page used the CSS property -webkit-animation-play-state. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_play_state(2252);

  /**
   * generated from use.counter.css.page.css_webkit_animation_timing_function
   */
  /**
   * Whether a page used the CSS property -webkit-animation-timing-function. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_timing_function(2253);

  /**
   * generated from use.counter.css.page.css_webkit_appearance
   */
  /**
   * Whether a page used the CSS property -webkit-appearance. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_appearance(2254);

  /**
   * generated from use.counter.css.page.css_webkit_backface_visibility
   */
  /**
   * Whether a page used the CSS property -webkit-backface-visibility. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_backface_visibility(2255);

  /**
   * generated from use.counter.css.page.css_webkit_background_clip
   */
  /**
   * Whether a page used the CSS property -webkit-background-clip. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_clip(2256);

  /**
   * generated from use.counter.css.page.css_webkit_background_origin
   */
  /**
   * Whether a page used the CSS property -webkit-background-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_origin(2257);

  /**
   * generated from use.counter.css.page.css_webkit_background_size
   */
  /**
   * Whether a page used the CSS property -webkit-background-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_size(2258);

  /**
   * generated from use.counter.css.page.css_webkit_border_bottom_left_radius
   */
  /**
   * Whether a page used the CSS property -webkit-border-bottom-left-radius. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_bottom_left_radius(2259);

  /**
   * generated from use.counter.css.page.css_webkit_border_bottom_right_radius
   */
  /**
   * Whether a page used the CSS property -webkit-border-bottom-right-radius.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_border_bottom_right_radius(2260);

  /**
   * generated from use.counter.css.page.css_webkit_border_image
   */
  /**
   * Whether a page used the CSS property -webkit-border-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_border_image(2261);

  /**
   * generated from use.counter.css.page.css_webkit_border_radius
   */
  /**
   * Whether a page used the CSS property -webkit-border-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_border_radius(2262);

  /**
   * generated from use.counter.css.page.css_webkit_border_top_left_radius
   */
  /**
   * Whether a page used the CSS property -webkit-border-top-left-radius. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_top_left_radius(2263);

  /**
   * generated from use.counter.css.page.css_webkit_border_top_right_radius
   */
  /**
   * Whether a page used the CSS property -webkit-border-top-right-radius. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_top_right_radius(2264);

  /**
   * generated from use.counter.css.page.css_webkit_box_align
   */
  /**
   * Whether a page used the CSS property -webkit-box-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_align(2265);

  /**
   * generated from use.counter.css.page.css_webkit_box_direction
   */
  /**
   * Whether a page used the CSS property -webkit-box-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_direction(2266);

  /**
   * generated from use.counter.css.page.css_webkit_box_flex
   */
  /**
   * Whether a page used the CSS property -webkit-box-flex. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_flex(2267);

  /**
   * generated from use.counter.css.page.css_webkit_box_ordinal_group
   */
  /**
   * Whether a page used the CSS property -webkit-box-ordinal-group. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_ordinal_group(2268);

  /**
   * generated from use.counter.css.page.css_webkit_box_orient
   */
  /**
   * Whether a page used the CSS property -webkit-box-orient. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_orient(2269);

  /**
   * generated from use.counter.css.page.css_webkit_box_pack
   */
  /**
   * Whether a page used the CSS property -webkit-box-pack. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_pack(2270);

  /**
   * generated from use.counter.css.page.css_webkit_box_shadow
   */
  /**
   * Whether a page used the CSS property -webkit-box-shadow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_shadow(2271);

  /**
   * generated from use.counter.css.page.css_webkit_box_sizing
   */
  /**
   * Whether a page used the CSS property -webkit-box-sizing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_sizing(2272);

  /**
   * generated from use.counter.css.page.css_webkit_clip_path
   */
  /**
   * Whether a page used the CSS property -webkit-clip-path. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_clip_path(2273);

  /**
   * generated from use.counter.css.page.css_webkit_filter
   */
  /**
   * Whether a page used the CSS property -webkit-filter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_filter(2274);

  /**
   * generated from use.counter.css.page.css_webkit_flex
   */
  /**
   * Whether a page used the CSS property -webkit-flex. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex(2275);

  /**
   * generated from use.counter.css.page.css_webkit_flex_basis
   */
  /**
   * Whether a page used the CSS property -webkit-flex-basis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_basis(2276);

  /**
   * generated from use.counter.css.page.css_webkit_flex_direction
   */
  /**
   * Whether a page used the CSS property -webkit-flex-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_direction(2277);

  /**
   * generated from use.counter.css.page.css_webkit_flex_flow
   */
  /**
   * Whether a page used the CSS property -webkit-flex-flow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_flow(2278);

  /**
   * generated from use.counter.css.page.css_webkit_flex_grow
   */
  /**
   * Whether a page used the CSS property -webkit-flex-grow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_grow(2279);

  /**
   * generated from use.counter.css.page.css_webkit_flex_shrink
   */
  /**
   * Whether a page used the CSS property -webkit-flex-shrink. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_shrink(2280);

  /**
   * generated from use.counter.css.page.css_webkit_flex_wrap
   */
  /**
   * Whether a page used the CSS property -webkit-flex-wrap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_wrap(2281);

  /**
   * generated from use.counter.css.page.css_webkit_font_feature_settings
   */
  /**
   * Whether a page used the CSS property -webkit-font-feature-settings. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_font_feature_settings(2282);

  /**
   * generated from use.counter.css.page.css_webkit_font_smoothing
   */
  /**
   * Whether a page used the CSS property -webkit-font-smoothing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_font_smoothing(2283);

  /**
   * generated from use.counter.css.page.css_webkit_justify_content
   */
  /**
   * Whether a page used the CSS property -webkit-justify-content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_justify_content(2284);

  /**
   * generated from use.counter.css.page.css_webkit_line_clamp
   */
  /**
   * Whether a page used the CSS property -webkit-line-clamp. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_line_clamp(2285);

  /**
   * generated from use.counter.css.page.css_webkit_mask
   */
  /**
   * Whether a page used the CSS property -webkit-mask. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask(2286);

  /**
   * generated from use.counter.css.page.css_webkit_mask_clip
   */
  /**
   * Whether a page used the CSS property -webkit-mask-clip. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_clip(2287);

  /**
   * generated from use.counter.css.page.css_webkit_mask_composite
   */
  /**
   * Whether a page used the CSS property -webkit-mask-composite. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_composite(2288);

  /**
   * generated from use.counter.css.page.css_webkit_mask_image
   */
  /**
   * Whether a page used the CSS property -webkit-mask-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_image(2289);

  /**
   * generated from use.counter.css.page.css_webkit_mask_origin
   */
  /**
   * Whether a page used the CSS property -webkit-mask-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_origin(2290);

  /**
   * generated from use.counter.css.page.css_webkit_mask_position
   */
  /**
   * Whether a page used the CSS property -webkit-mask-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position(2291);

  /**
   * generated from use.counter.css.page.css_webkit_mask_position_x
   */
  /**
   * Whether a page used the CSS property -webkit-mask-position-x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position_x(2292);

  /**
   * generated from use.counter.css.page.css_webkit_mask_position_y
   */
  /**
   * Whether a page used the CSS property -webkit-mask-position-y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position_y(2293);

  /**
   * generated from use.counter.css.page.css_webkit_mask_repeat
   */
  /**
   * Whether a page used the CSS property -webkit-mask-repeat. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_repeat(2294);

  /**
   * generated from use.counter.css.page.css_webkit_mask_size
   */
  /**
   * Whether a page used the CSS property -webkit-mask-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_size(2295);

  /**
   * generated from use.counter.css.page.css_webkit_order
   */
  /**
   * Whether a page used the CSS property -webkit-order. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_order(2296);

  /**
   * generated from use.counter.css.page.css_webkit_perspective
   */
  /**
   * Whether a page used the CSS property -webkit-perspective. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_perspective(2297);

  /**
   * generated from use.counter.css.page.css_webkit_perspective_origin
   */
  /**
   * Whether a page used the CSS property -webkit-perspective-origin. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_perspective_origin(2298);

  /**
   * generated from use.counter.css.page.css_webkit_text_fill_color
   */
  /**
   * Whether a page used the CSS property -webkit-text-fill-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_fill_color(2299);

  /**
   * generated from use.counter.css.page.css_webkit_text_security
   */
  /**
   * Whether a page used the CSS property -webkit-text-security. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_security(2300);

  /**
   * generated from use.counter.css.page.css_webkit_text_size_adjust
   */
  /**
   * Whether a page used the CSS property -webkit-text-size-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_size_adjust(2301);

  /**
   * generated from use.counter.css.page.css_webkit_text_stroke
   */
  /**
   * Whether a page used the CSS property -webkit-text-stroke. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke(2302);

  /**
   * generated from use.counter.css.page.css_webkit_text_stroke_color
   */
  /**
   * Whether a page used the CSS property -webkit-text-stroke-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke_color(2303);

  /**
   * generated from use.counter.css.page.css_webkit_text_stroke_width
   */
  /**
   * Whether a page used the CSS property -webkit-text-stroke-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke_width(2304);

  /**
   * generated from use.counter.css.page.css_webkit_transform
   */
  /**
   * Whether a page used the CSS property -webkit-transform. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform(2305);

  /**
   * generated from use.counter.css.page.css_webkit_transform_origin
   */
  /**
   * Whether a page used the CSS property -webkit-transform-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform_origin(2306);

  /**
   * generated from use.counter.css.page.css_webkit_transform_style
   */
  /**
   * Whether a page used the CSS property -webkit-transform-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform_style(2307);

  /**
   * generated from use.counter.css.page.css_webkit_transition
   */
  /**
   * Whether a page used the CSS property -webkit-transition. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition(2308);

  /**
   * generated from use.counter.css.page.css_webkit_transition_delay
   */
  /**
   * Whether a page used the CSS property -webkit-transition-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_delay(2309);

  /**
   * generated from use.counter.css.page.css_webkit_transition_duration
   */
  /**
   * Whether a page used the CSS property -webkit-transition-duration. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_duration(2310);

  /**
   * generated from use.counter.css.page.css_webkit_transition_property
   */
  /**
   * Whether a page used the CSS property -webkit-transition-property. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_property(2311);

  /**
   * generated from use.counter.css.page.css_webkit_transition_timing_function
   */
  /**
   * Whether a page used the CSS property -webkit-transition-timing-function.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_timing_function(2312);

  /**
   * generated from use.counter.css.page.css_webkit_user_select
   */
  /**
   * Whether a page used the CSS property -webkit-user-select. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_user_select(2313);

  /**
   * generated from use.counter.css.page.css_white_space
   */
  /**
   * Whether a page used the CSS property white-space. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_white_space(2314);

  /**
   * generated from use.counter.css.page.css_white_space_collapse
   */
  /**
   * Whether a page used the CSS property white-space-collapse. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_white_space_collapse(2315);

  /**
   * generated from use.counter.css.page.css_width
   */
  /**
   * Whether a page used the CSS property width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_width(2316);

  /**
   * generated from use.counter.css.page.css_will_change
   */
  /**
   * Whether a page used the CSS property will-change. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_will_change(2317);

  /**
   * generated from use.counter.css.page.css_word_break
   */
  /**
   * Whether a page used the CSS property word-break. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_break(2318);

  /**
   * generated from use.counter.css.page.css_word_spacing
   */
  /**
   * Whether a page used the CSS property word-spacing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_spacing(2319);

  /**
   * generated from use.counter.css.page.css_word_wrap
   */
  /**
   * Whether a page used the CSS property word-wrap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_wrap(2320);

  /**
   * generated from use.counter.css.page.css_writing_mode
   */
  /**
   * Whether a page used the CSS property writing-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_writing_mode(2321);

  /**
   * generated from use.counter.css.page.css_x
   */
  /**
   * Whether a page used the CSS property x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x(2322);

  /**
   * generated from use.counter.css.page.css_x_lang
   */
  /**
   * Whether a page used the CSS property -x-lang. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_lang(2323);

  /**
   * generated from use.counter.css.page.css_x_span
   */
  /**
   * Whether a page used the CSS property -x-span. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_span(2324);

  /**
   * generated from use.counter.css.page.css_x_text_scale
   */
  /**
   * Whether a page used the CSS property -x-text-scale. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_text_scale(2325);

  /**
   * generated from use.counter.css.page.css_y
   */
  /**
   * Whether a page used the CSS property y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_y(2326);

  /**
   * generated from use.counter.css.page.css_z_index
   */
  /**
   * Whether a page used the CSS property z-index. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_z_index(2327);

  /**
   * generated from use.counter.css.page.css_zoom
   */
  /**
   * Whether a page used the CSS property zoom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_zoom(2328);

  /**
   * generated from use.counter.css.page.max_zoom
   */
  /**
   * Whether a page used the (unknown, counted) CSS property max-zoom. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric max_zoom(2329);

  /**
   * generated from use.counter.css.page.min_zoom
   */
  /**
   * Whether a page used the (unknown, counted) CSS property min-zoom. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric min_zoom(2330);

  /**
   * generated from use.counter.css.page.orientation
   */
  /**
   * Whether a page used the (unknown, counted) CSS property orientation. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric orientation(2331);

  /**
   * generated from use.counter.css.page.orphans
   */
  /**
   * Whether a page used the (unknown, counted) CSS property orphans. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric orphans(2332);

  /**
   * generated from use.counter.css.page.speak
   */
  /**
   * Whether a page used the (unknown, counted) CSS property speak. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric speak(2333);

  /**
   * generated from use.counter.css.page.text_size_adjust
   */
  /**
   * Whether a page used the (unknown, counted) CSS property text-size-adjust.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric text_size_adjust(2334);

  /**
   * generated from use.counter.css.page.user_zoom
   */
  /**
   * Whether a page used the (unknown, counted) CSS property user-zoom. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric user_zoom(2335);

  /**
   * generated from use.counter.css.page.webkit_app_region
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-app-region.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_app_region(2336);

  /**
   * generated from use.counter.css.page.webkit_border_after
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-after.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after(2337);

  /**
   * generated from use.counter.css.page.webkit_border_after_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-after-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_color(2338);

  /**
   * generated from use.counter.css.page.webkit_border_after_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-after-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_style(2339);

  /**
   * generated from use.counter.css.page.webkit_border_after_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-after-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_width(2340);

  /**
   * generated from use.counter.css.page.webkit_border_before
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-before.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before(2341);

  /**
   * generated from use.counter.css.page.webkit_border_before_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-before-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_color(2342);

  /**
   * generated from use.counter.css.page.webkit_border_before_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-before-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_style(2343);

  /**
   * generated from use.counter.css.page.webkit_border_before_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-before-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_width(2344);

  /**
   * generated from use.counter.css.page.webkit_border_end
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-end.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_end(2345);

  /**
   * generated from use.counter.css.page.webkit_border_end_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-end-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_color(2346);

  /**
   * generated from use.counter.css.page.webkit_border_end_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-end-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_style(2347);

  /**
   * generated from use.counter.css.page.webkit_border_end_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-end-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_width(2348);

  /**
   * generated from use.counter.css.page.webkit_border_horizontal_spacing
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-
     * horizontal-spacing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_horizontal_spacing(2349);

  /**
   * generated from use.counter.css.page.webkit_border_start
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-start.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start(2350);

  /**
   * generated from use.counter.css.page.webkit_border_start_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-start-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_color(2351);

  /**
   * generated from use.counter.css.page.webkit_border_start_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-start-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_style(2352);

  /**
   * generated from use.counter.css.page.webkit_border_start_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-start-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_width(2353);

  /**
   * generated from use.counter.css.page.webkit_border_vertical_spacing
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-
     * vertical-spacing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_vertical_spacing(2354);

  /**
   * generated from use.counter.css.page.webkit_box_decoration_break
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-box-decoration-
     * break. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_box_decoration_break(2355);

  /**
   * generated from use.counter.css.page.webkit_box_reflect
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-box-reflect.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_box_reflect(2356);

  /**
   * generated from use.counter.css.page.webkit_column_break_after
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-break-
     * after. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_after(2357);

  /**
   * generated from use.counter.css.page.webkit_column_break_before
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-break-
     * before. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_before(2358);

  /**
   * generated from use.counter.css.page.webkit_column_break_inside
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-break-
     * inside. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_inside(2359);

  /**
   * generated from use.counter.css.page.webkit_column_count
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-count.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_count(2360);

  /**
   * generated from use.counter.css.page.webkit_column_gap
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-gap.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_gap(2361);

  /**
   * generated from use.counter.css.page.webkit_column_rule
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-rule.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule(2362);

  /**
   * generated from use.counter.css.page.webkit_column_rule_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_color(2363);

  /**
   * generated from use.counter.css.page.webkit_column_rule_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_style(2364);

  /**
   * generated from use.counter.css.page.webkit_column_rule_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_width(2365);

  /**
   * generated from use.counter.css.page.webkit_column_span
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-span.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_span(2366);

  /**
   * generated from use.counter.css.page.webkit_column_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-width.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_width(2367);

  /**
   * generated from use.counter.css.page.webkit_columns
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-columns.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_columns(2368);

  /**
   * generated from use.counter.css.page.webkit_font_size_delta
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-font-size-
     * delta. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_font_size_delta(2369);

  /**
   * generated from use.counter.css.page.webkit_highlight
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-highlight.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_highlight(2370);

  /**
   * generated from use.counter.css.page.webkit_hyphenate_character
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-hyphenate-
     * character. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_hyphenate_character(2371);

  /**
   * generated from use.counter.css.page.webkit_line_break
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-line-break.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_line_break(2372);

  /**
   * generated from use.counter.css.page.webkit_locale
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-locale. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_locale(2373);

  /**
   * generated from use.counter.css.page.webkit_logical_height
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-logical-height.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_logical_height(2374);

  /**
   * generated from use.counter.css.page.webkit_logical_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-logical-width.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_logical_width(2375);

  /**
   * generated from use.counter.css.page.webkit_margin_after
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-after.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_after(2376);

  /**
   * generated from use.counter.css.page.webkit_margin_after_collapse
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-after-
     * collapse. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_after_collapse(2377);

  /**
   * generated from use.counter.css.page.webkit_margin_before
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-before.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_before(2378);

  /**
   * generated from use.counter.css.page.webkit_margin_before_collapse
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-before-
     * collapse. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_before_collapse(2379);

  /**
   * generated from use.counter.css.page.webkit_margin_bottom_collapse
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-bottom-
     * collapse. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_bottom_collapse(2380);

  /**
   * generated from use.counter.css.page.webkit_margin_collapse
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-
     * collapse. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_collapse(2381);

  /**
   * generated from use.counter.css.page.webkit_margin_end
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-end.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_end(2382);

  /**
   * generated from use.counter.css.page.webkit_margin_start
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-start.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_start(2383);

  /**
   * generated from use.counter.css.page.webkit_margin_top_collapse
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-top-
     * collapse. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_top_collapse(2384);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image(2385);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image_outset
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
     * outset. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_outset(2386);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image_repeat
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
     * repeat. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_repeat(2387);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image_slice
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
     * slice. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_slice(2388);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image_source
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
     * source. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_source(2389);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_width(2390);

  /**
   * generated from use.counter.css.page.webkit_mask_repeat_x
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-repeat-x.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_repeat_x(2391);

  /**
   * generated from use.counter.css.page.webkit_mask_repeat_y
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-repeat-y.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_repeat_y(2392);

  /**
   * generated from use.counter.css.page.webkit_max_logical_height
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-max-logical-
     * height. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_max_logical_height(2393);

  /**
   * generated from use.counter.css.page.webkit_max_logical_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-max-logical-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_max_logical_width(2394);

  /**
   * generated from use.counter.css.page.webkit_min_logical_height
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-min-logical-
     * height. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_min_logical_height(2395);

  /**
   * generated from use.counter.css.page.webkit_min_logical_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-min-logical-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_min_logical_width(2396);

  /**
   * generated from use.counter.css.page.webkit_opacity
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-opacity.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_opacity(2397);

  /**
   * generated from use.counter.css.page.webkit_padding_after
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-padding-after.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_padding_after(2398);

  /**
   * generated from use.counter.css.page.webkit_padding_before
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-padding-before.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_padding_before(2399);

  /**
   * generated from use.counter.css.page.webkit_padding_end
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-padding-end.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_padding_end(2400);

  /**
   * generated from use.counter.css.page.webkit_padding_start
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-padding-start.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_padding_start(2401);

  /**
   * generated from use.counter.css.page.webkit_perspective_origin_x
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-perspective-
     * origin-x. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_perspective_origin_x(2402);

  /**
   * generated from use.counter.css.page.webkit_perspective_origin_y
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-perspective-
     * origin-y. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_perspective_origin_y(2403);

  /**
   * generated from use.counter.css.page.webkit_print_color_adjust
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-print-color-
     * adjust. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_print_color_adjust(2404);

  /**
   * generated from use.counter.css.page.webkit_rtl_ordering
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-rtl-ordering.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_rtl_ordering(2405);

  /**
   * generated from use.counter.css.page.webkit_ruby_position
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-ruby-position.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_ruby_position(2406);

  /**
   * generated from use.counter.css.page.webkit_shape_image_threshold
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-shape-image-
     * threshold. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_shape_image_threshold(2407);

  /**
   * generated from use.counter.css.page.webkit_shape_margin
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-shape-margin.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_shape_margin(2408);

  /**
   * generated from use.counter.css.page.webkit_shape_outside
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-shape-outside.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_shape_outside(2409);

  /**
   * generated from use.counter.css.page.webkit_tap_highlight_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-tap-highlight-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_tap_highlight_color(2410);

  /**
   * generated from use.counter.css.page.webkit_text_combine
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-combine.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_combine(2411);

  /**
   * generated from use.counter.css.page.webkit_text_decorations_in_effect
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-
     * decorations-in-effect. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_decorations_in_effect(2412);

  /**
   * generated from use.counter.css.page.webkit_text_emphasis
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis(2413);

  /**
   * generated from use.counter.css.page.webkit_text_emphasis_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_color(2414);

  /**
   * generated from use.counter.css.page.webkit_text_emphasis_position
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
     * position. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_position(2415);

  /**
   * generated from use.counter.css.page.webkit_text_emphasis_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_style(2416);

  /**
   * generated from use.counter.css.page.webkit_text_orientation
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-
     * orientation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_orientation(2417);

  /**
   * generated from use.counter.css.page.webkit_transform_origin_x
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-transform-
     * origin-x. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_x(2418);

  /**
   * generated from use.counter.css.page.webkit_transform_origin_y
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-transform-
     * origin-y. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_y(2419);

  /**
   * generated from use.counter.css.page.webkit_transform_origin_z
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-transform-
     * origin-z. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_z(2420);

  /**
   * generated from use.counter.css.page.webkit_user_drag
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-user-drag.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_user_drag(2421);

  /**
   * generated from use.counter.css.page.webkit_user_modify
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-user-modify.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_user_modify(2422);

  /**
   * generated from use.counter.css.page.webkit_writing_mode
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-writing-mode.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_writing_mode(2423);

  /**
   * generated from use.counter.css.page.widows
   */
  /**
   * Whether a page used the (unknown, counted) CSS property widows. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric widows(2424);

}
namespace use_counter_deprecated_ops_doc {
  /**
   * generated from use.counter.deprecated_ops.doc.ambient_light_event
   */
  /**
   * Whether a document used AmbientLightEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric ambient_light_event(2425);

  /**
   * generated from use.counter.deprecated_ops.doc.app_cache
   */
  /**
   * Whether a document used AppCache. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric app_cache(2426);

  /**
   * generated from use.counter.deprecated_ops.doc.components
   */
  /**
   * Whether a document used Components. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric components(2427);

  /**
   * generated from use.counter.deprecated_ops.doc.create_image_bitmap_canvas_rendering_context2_d
   */
  /**
   * Whether a document used CreateImageBitmapCanvasRenderingContext2D. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric create_image_bitmap_canvas_rendering_context2_d(2428);

  /**
   * generated from use.counter.deprecated_ops.doc.deprecated_testing_attribute
   */
  /**
   * Whether a document used DeprecatedTestingAttribute. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_attribute(2429);

  /**
   * generated from use.counter.deprecated_ops.doc.deprecated_testing_interface
   */
  /**
   * Whether a document used DeprecatedTestingInterface. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_interface(2430);

  /**
   * generated from use.counter.deprecated_ops.doc.deprecated_testing_method
   */
  /**
   * Whether a document used DeprecatedTestingMethod. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_method(2431);

  /**
   * generated from use.counter.deprecated_ops.doc.document_release_capture
   */
  /**
   * Whether a document used DocumentReleaseCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_release_capture(2432);

  /**
   * generated from use.counter.deprecated_ops.doc.domattr_modified
   */
  /**
   * Whether a document used DOMAttrModified. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domattr_modified(2433);

  /**
   * generated from use.counter.deprecated_ops.doc.domcharacter_data_modified
   */
  /**
   * Whether a document used DOMCharacterDataModified. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domcharacter_data_modified(2434);

  /**
   * generated from use.counter.deprecated_ops.doc.domnode_inserted
   */
  /**
   * Whether a document used DOMNodeInserted. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domnode_inserted(2435);

  /**
   * generated from use.counter.deprecated_ops.doc.domnode_inserted_into_document
   */
  /**
   * Whether a document used DOMNodeInsertedIntoDocument. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domnode_inserted_into_document(2436);

  /**
   * generated from use.counter.deprecated_ops.doc.domnode_removed
   */
  /**
   * Whether a document used DOMNodeRemoved. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domnode_removed(2437);

  /**
   * generated from use.counter.deprecated_ops.doc.domnode_removed_from_document
   */
  /**
   * Whether a document used DOMNodeRemovedFromDocument. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domnode_removed_from_document(2438);

  /**
   * generated from use.counter.deprecated_ops.doc.domquad_bounds_attr
   */
  /**
   * Whether a document used DOMQuadBoundsAttr. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domquad_bounds_attr(2439);

  /**
   * generated from use.counter.deprecated_ops.doc.domsubtree_modified
   */
  /**
   * Whether a document used DOMSubtreeModified. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domsubtree_modified(2440);

  /**
   * generated from use.counter.deprecated_ops.doc.draw_window_canvas_rendering_context2_d
   */
  /**
   * Whether a document used DrawWindowCanvasRenderingContext2D. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric draw_window_canvas_rendering_context2_d(2441);

  /**
   * generated from use.counter.deprecated_ops.doc.element_release_capture
   */
  /**
   * Whether a document used ElementReleaseCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_release_capture(2442);

  /**
   * generated from use.counter.deprecated_ops.doc.element_set_capture
   */
  /**
   * Whether a document used ElementSetCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_set_capture(2443);

  /**
   * generated from use.counter.deprecated_ops.doc.external__add_search_provider
   */
  /**
   * Whether a document used External_AddSearchProvider. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric external__add_search_provider(2444);

  /**
   * generated from use.counter.deprecated_ops.doc.form_submission_untrusted_event
   */
  /**
   * Whether a document used FormSubmissionUntrustedEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric form_submission_untrusted_event(2445);

  /**
   * generated from use.counter.deprecated_ops.doc.idbobject_store_create_index_locale
   */
  /**
   * Whether a document used IDBObjectStoreCreateIndexLocale. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric idbobject_store_create_index_locale(2446);

  /**
   * generated from use.counter.deprecated_ops.doc.idbopen_dboptions__storage_type
   */
  /**
   * Whether a document used IDBOpenDBOptions_StorageType. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric idbopen_dboptions__storage_type(2447);

  /**
   * generated from use.counter.deprecated_ops.doc.image_bitmap_rendering_context__transfer_image_bitmap
   */
  /**
   * Whether a document used ImageBitmapRenderingContext_TransferImageBitmap.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric image_bitmap_rendering_context__transfer_image_bitmap(2448);

  /**
   * generated from use.counter.deprecated_ops.doc.import_xulinto_content
   */
  /**
   * Whether a document used ImportXULIntoContent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric import_xulinto_content(2449);

  /**
   * generated from use.counter.deprecated_ops.doc.init_mouse_event
   */
  /**
   * Whether a document used InitMouseEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric init_mouse_event(2450);

  /**
   * generated from use.counter.deprecated_ops.doc.init_nsmouse_event
   */
  /**
   * Whether a document used InitNSMouseEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric init_nsmouse_event(2451);

  /**
   * generated from use.counter.deprecated_ops.doc.install_trigger_deprecated
   */
  /**
   * Whether a document used InstallTriggerDeprecated. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric install_trigger_deprecated(2452);

  /**
   * generated from use.counter.deprecated_ops.doc.install_trigger_install_deprecated
   */
  /**
   * Whether a document used InstallTriggerInstallDeprecated. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric install_trigger_install_deprecated(2453);

  /**
   * generated from use.counter.deprecated_ops.doc.lenient_setter
   */
  /**
   * Whether a document used LenientSetter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric lenient_setter(2454);

  /**
   * generated from use.counter.deprecated_ops.doc.lenient_this
   */
  /**
   * Whether a document used LenientThis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric lenient_this(2455);

  /**
   * generated from use.counter.deprecated_ops.doc.math_ml__deprecated_math_space_value2
   */
  /**
   * Whether a document used MathML_DeprecatedMathSpaceValue2. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_math_space_value2(2456);

  /**
   * generated from use.counter.deprecated_ops.doc.math_ml__deprecated_math_variant
   */
  /**
   * Whether a document used MathML_DeprecatedMathVariant. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_math_variant(2457);

  /**
   * generated from use.counter.deprecated_ops.doc.math_ml__deprecated_stixgeneral_operator_stretching
   */
  /**
   * Whether a document used MathML_DeprecatedStixgeneralOperatorStretching. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_stixgeneral_operator_stretching(2458);

  /**
   * generated from use.counter.deprecated_ops.doc.motion_event
   */
  /**
   * Whether a document used MotionEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric motion_event(2459);

  /**
   * generated from use.counter.deprecated_ops.doc.mouse_event__moz_pressure
   */
  /**
   * Whether a document used MouseEvent_MozPressure. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mouse_event__moz_pressure(2460);

  /**
   * generated from use.counter.deprecated_ops.doc.moz_input_source
   */
  /**
   * Whether a document used MozInputSource. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric moz_input_source(2461);

  /**
   * generated from use.counter.deprecated_ops.doc.moz_request_full_screen_deprecated_prefix
   */
  /**
   * Whether a document used MozRequestFullScreenDeprecatedPrefix. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric moz_request_full_screen_deprecated_prefix(2462);

  /**
   * generated from use.counter.deprecated_ops.doc.mozfullscreenchange_deprecated_prefix
   */
  /**
   * Whether a document used MozfullscreenchangeDeprecatedPrefix. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mozfullscreenchange_deprecated_prefix(2463);

  /**
   * generated from use.counter.deprecated_ops.doc.mozfullscreenerror_deprecated_prefix
   */
  /**
   * Whether a document used MozfullscreenerrorDeprecatedPrefix. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mozfullscreenerror_deprecated_prefix(2464);

  /**
   * generated from use.counter.deprecated_ops.doc.navigator_get_user_media
   */
  /**
   * Whether a document used NavigatorGetUserMedia. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_get_user_media(2465);

  /**
   * generated from use.counter.deprecated_ops.doc.node_iterator_detach
   */
  /**
   * Whether a document used NodeIteratorDetach. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric node_iterator_detach(2466);

  /**
   * generated from use.counter.deprecated_ops.doc.offscreen_canvas_to_blob
   */
  /**
   * Whether a document used OffscreenCanvasToBlob. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric offscreen_canvas_to_blob(2467);

  /**
   * generated from use.counter.deprecated_ops.doc.orientation_event
   */
  /**
   * Whether a document used OrientationEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric orientation_event(2468);

  /**
   * generated from use.counter.deprecated_ops.doc.proximity_event
   */
  /**
   * Whether a document used ProximityEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric proximity_event(2469);

  /**
   * generated from use.counter.deprecated_ops.doc.rtcpeer_connection_get_streams
   */
  /**
   * Whether a document used RTCPeerConnectionGetStreams. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric rtcpeer_connection_get_streams(2470);

  /**
   * generated from use.counter.deprecated_ops.doc.svgdeselect_all
   */
  /**
   * Whether a document used SVGDeselectAll. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgdeselect_all(2471);

  /**
   * generated from use.counter.deprecated_ops.doc.svgfarthest_viewport_element
   */
  /**
   * Whether a document used SVGFarthestViewportElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgfarthest_viewport_element(2472);

  /**
   * generated from use.counter.deprecated_ops.doc.svgnearest_viewport_element
   */
  /**
   * Whether a document used SVGNearestViewportElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgnearest_viewport_element(2473);

  /**
   * generated from use.counter.deprecated_ops.doc.sync_xmlhttp_request_deprecated
   */
  /**
   * Whether a document used SyncXMLHttpRequestDeprecated. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sync_xmlhttp_request_deprecated(2474);

  /**
   * generated from use.counter.deprecated_ops.doc.use_of_capture_events
   */
  /**
   * Whether a document used UseOfCaptureEvents. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric use_of_capture_events(2475);

  /**
   * generated from use.counter.deprecated_ops.doc.use_of_release_events
   */
  /**
   * Whether a document used UseOfReleaseEvents. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric use_of_release_events(2476);

  /**
   * generated from use.counter.deprecated_ops.doc.webrtc_deprecated_prefix
   */
  /**
   * Whether a document used WebrtcDeprecatedPrefix. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webrtc_deprecated_prefix(2477);

  /**
   * generated from use.counter.deprecated_ops.doc.window__cc_ontrollers
   */
  /**
   * Whether a document used Window_Cc_ontrollers. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window__cc_ontrollers(2478);

  /**
   * generated from use.counter.deprecated_ops.doc.window_content_untrusted
   */
  /**
   * Whether a document used WindowContentUntrusted. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_content_untrusted(2479);

}
namespace use_counter_deprecated_ops_page {
  /**
   * generated from use.counter.deprecated_ops.page.ambient_light_event
   */
  /**
   * Whether a page used AmbientLightEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric ambient_light_event(2480);

  /**
   * generated from use.counter.deprecated_ops.page.app_cache
   */
  /**
   * Whether a page used AppCache. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric app_cache(2481);

  /**
   * generated from use.counter.deprecated_ops.page.components
   */
  /**
   * Whether a page used Components. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric components(2482);

  /**
   * generated from use.counter.deprecated_ops.page.create_image_bitmap_canvas_rendering_context2_d
   */
  /**
   * Whether a page used CreateImageBitmapCanvasRenderingContext2D. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric create_image_bitmap_canvas_rendering_context2_d(2483);

  /**
   * generated from use.counter.deprecated_ops.page.deprecated_testing_attribute
   */
  /**
   * Whether a page used DeprecatedTestingAttribute. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_attribute(2484);

  /**
   * generated from use.counter.deprecated_ops.page.deprecated_testing_interface
   */
  /**
   * Whether a page used DeprecatedTestingInterface. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_interface(2485);

  /**
   * generated from use.counter.deprecated_ops.page.deprecated_testing_method
   */
  /**
   * Whether a page used DeprecatedTestingMethod. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_method(2486);

  /**
   * generated from use.counter.deprecated_ops.page.document_release_capture
   */
  /**
   * Whether a page used DocumentReleaseCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_release_capture(2487);

  /**
   * generated from use.counter.deprecated_ops.page.domattr_modified
   */
  /**
   * Whether a page used DOMAttrModified. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domattr_modified(2488);

  /**
   * generated from use.counter.deprecated_ops.page.domcharacter_data_modified
   */
  /**
   * Whether a page used DOMCharacterDataModified. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domcharacter_data_modified(2489);

  /**
   * generated from use.counter.deprecated_ops.page.domnode_inserted
   */
  /**
   * Whether a page used DOMNodeInserted. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domnode_inserted(2490);

  /**
   * generated from use.counter.deprecated_ops.page.domnode_inserted_into_document
   */
  /**
   * Whether a page used DOMNodeInsertedIntoDocument. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domnode_inserted_into_document(2491);

  /**
   * generated from use.counter.deprecated_ops.page.domnode_removed
   */
  /**
   * Whether a page used DOMNodeRemoved. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domnode_removed(2492);

  /**
   * generated from use.counter.deprecated_ops.page.domnode_removed_from_document
   */
  /**
   * Whether a page used DOMNodeRemovedFromDocument. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domnode_removed_from_document(2493);

  /**
   * generated from use.counter.deprecated_ops.page.domquad_bounds_attr
   */
  /**
   * Whether a page used DOMQuadBoundsAttr. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domquad_bounds_attr(2494);

  /**
   * generated from use.counter.deprecated_ops.page.domsubtree_modified
   */
  /**
   * Whether a page used DOMSubtreeModified. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domsubtree_modified(2495);

  /**
   * generated from use.counter.deprecated_ops.page.draw_window_canvas_rendering_context2_d
   */
  /**
   * Whether a page used DrawWindowCanvasRenderingContext2D. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric draw_window_canvas_rendering_context2_d(2496);

  /**
   * generated from use.counter.deprecated_ops.page.element_release_capture
   */
  /**
   * Whether a page used ElementReleaseCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_release_capture(2497);

  /**
   * generated from use.counter.deprecated_ops.page.element_set_capture
   */
  /**
   * Whether a page used ElementSetCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_set_capture(2498);

  /**
   * generated from use.counter.deprecated_ops.page.external__add_search_provider
   */
  /**
   * Whether a page used External_AddSearchProvider. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric external__add_search_provider(2499);

  /**
   * generated from use.counter.deprecated_ops.page.form_submission_untrusted_event
   */
  /**
   * Whether a page used FormSubmissionUntrustedEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric form_submission_untrusted_event(2500);

  /**
   * generated from use.counter.deprecated_ops.page.idbobject_store_create_index_locale
   */
  /**
   * Whether a page used IDBObjectStoreCreateIndexLocale. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric idbobject_store_create_index_locale(2501);

  /**
   * generated from use.counter.deprecated_ops.page.idbopen_dboptions__storage_type
   */
  /**
   * Whether a page used IDBOpenDBOptions_StorageType. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric idbopen_dboptions__storage_type(2502);

  /**
   * generated from use.counter.deprecated_ops.page.image_bitmap_rendering_context__transfer_image_bitmap
   */
  /**
   * Whether a page used ImageBitmapRenderingContext_TransferImageBitmap. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric image_bitmap_rendering_context__transfer_image_bitmap(2503);

  /**
   * generated from use.counter.deprecated_ops.page.import_xulinto_content
   */
  /**
   * Whether a page used ImportXULIntoContent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric import_xulinto_content(2504);

  /**
   * generated from use.counter.deprecated_ops.page.init_mouse_event
   */
  /**
   * Whether a page used InitMouseEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric init_mouse_event(2505);

  /**
   * generated from use.counter.deprecated_ops.page.init_nsmouse_event
   */
  /**
   * Whether a page used InitNSMouseEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric init_nsmouse_event(2506);

  /**
   * generated from use.counter.deprecated_ops.page.install_trigger_deprecated
   */
  /**
   * Whether a page used InstallTriggerDeprecated. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric install_trigger_deprecated(2507);

  /**
   * generated from use.counter.deprecated_ops.page.install_trigger_install_deprecated
   */
  /**
   * Whether a page used InstallTriggerInstallDeprecated. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric install_trigger_install_deprecated(2508);

  /**
   * generated from use.counter.deprecated_ops.page.lenient_setter
   */
  /**
   * Whether a page used LenientSetter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric lenient_setter(2509);

  /**
   * generated from use.counter.deprecated_ops.page.lenient_this
   */
  /**
   * Whether a page used LenientThis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric lenient_this(2510);

  /**
   * generated from use.counter.deprecated_ops.page.math_ml__deprecated_math_space_value2
   */
  /**
   * Whether a page used MathML_DeprecatedMathSpaceValue2. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_math_space_value2(2511);

  /**
   * generated from use.counter.deprecated_ops.page.math_ml__deprecated_math_variant
   */
  /**
   * Whether a page used MathML_DeprecatedMathVariant. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_math_variant(2512);

  /**
   * generated from use.counter.deprecated_ops.page.math_ml__deprecated_stixgeneral_operator_stretching
   */
  /**
   * Whether a page used MathML_DeprecatedStixgeneralOperatorStretching. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_stixgeneral_operator_stretching(2513);

  /**
   * generated from use.counter.deprecated_ops.page.motion_event
   */
  /**
   * Whether a page used MotionEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric motion_event(2514);

  /**
   * generated from use.counter.deprecated_ops.page.mouse_event__moz_pressure
   */
  /**
   * Whether a page used MouseEvent_MozPressure. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mouse_event__moz_pressure(2515);

  /**
   * generated from use.counter.deprecated_ops.page.moz_input_source
   */
  /**
   * Whether a page used MozInputSource. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric moz_input_source(2516);

  /**
   * generated from use.counter.deprecated_ops.page.moz_request_full_screen_deprecated_prefix
   */
  /**
   * Whether a page used MozRequestFullScreenDeprecatedPrefix. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric moz_request_full_screen_deprecated_prefix(2517);

  /**
   * generated from use.counter.deprecated_ops.page.mozfullscreenchange_deprecated_prefix
   */
  /**
   * Whether a page used MozfullscreenchangeDeprecatedPrefix. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mozfullscreenchange_deprecated_prefix(2518);

  /**
   * generated from use.counter.deprecated_ops.page.mozfullscreenerror_deprecated_prefix
   */
  /**
   * Whether a page used MozfullscreenerrorDeprecatedPrefix. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mozfullscreenerror_deprecated_prefix(2519);

  /**
   * generated from use.counter.deprecated_ops.page.navigator_get_user_media
   */
  /**
   * Whether a page used NavigatorGetUserMedia. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_get_user_media(2520);

  /**
   * generated from use.counter.deprecated_ops.page.node_iterator_detach
   */
  /**
   * Whether a page used NodeIteratorDetach. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric node_iterator_detach(2521);

  /**
   * generated from use.counter.deprecated_ops.page.offscreen_canvas_to_blob
   */
  /**
   * Whether a page used OffscreenCanvasToBlob. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric offscreen_canvas_to_blob(2522);

  /**
   * generated from use.counter.deprecated_ops.page.orientation_event
   */
  /**
   * Whether a page used OrientationEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric orientation_event(2523);

  /**
   * generated from use.counter.deprecated_ops.page.proximity_event
   */
  /**
   * Whether a page used ProximityEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric proximity_event(2524);

  /**
   * generated from use.counter.deprecated_ops.page.rtcpeer_connection_get_streams
   */
  /**
   * Whether a page used RTCPeerConnectionGetStreams. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric rtcpeer_connection_get_streams(2525);

  /**
   * generated from use.counter.deprecated_ops.page.svgdeselect_all
   */
  /**
   * Whether a page used SVGDeselectAll. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgdeselect_all(2526);

  /**
   * generated from use.counter.deprecated_ops.page.svgfarthest_viewport_element
   */
  /**
   * Whether a page used SVGFarthestViewportElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgfarthest_viewport_element(2527);

  /**
   * generated from use.counter.deprecated_ops.page.svgnearest_viewport_element
   */
  /**
   * Whether a page used SVGNearestViewportElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgnearest_viewport_element(2528);

  /**
   * generated from use.counter.deprecated_ops.page.sync_xmlhttp_request_deprecated
   */
  /**
   * Whether a page used SyncXMLHttpRequestDeprecated. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sync_xmlhttp_request_deprecated(2529);

  /**
   * generated from use.counter.deprecated_ops.page.use_of_capture_events
   */
  /**
   * Whether a page used UseOfCaptureEvents. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric use_of_capture_events(2530);

  /**
   * generated from use.counter.deprecated_ops.page.use_of_release_events
   */
  /**
   * Whether a page used UseOfReleaseEvents. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric use_of_release_events(2531);

  /**
   * generated from use.counter.deprecated_ops.page.webrtc_deprecated_prefix
   */
  /**
   * Whether a page used WebrtcDeprecatedPrefix. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webrtc_deprecated_prefix(2532);

  /**
   * generated from use.counter.deprecated_ops.page.window__cc_ontrollers
   */
  /**
   * Whether a page used Window_Cc_ontrollers. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window__cc_ontrollers(2533);

  /**
   * generated from use.counter.deprecated_ops.page.window_content_untrusted
   */
  /**
   * Whether a page used WindowContentUntrusted. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_content_untrusted(2534);

}
namespace use_counter_doc {
  /**
   * generated from use.counter.doc.clipboard_read
   */
  /**
   * Whether a document called called Clipboard.read. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_read(2535);

  /**
   * generated from use.counter.doc.clipboard_readtext
   */
  /**
   * Whether a document called called Clipboard.readText. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_readtext(2536);

  /**
   * generated from use.counter.doc.clipboard_write
   */
  /**
   * Whether a document called called Clipboard.write. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_write(2537);

  /**
   * generated from use.counter.doc.components_shim_resolved
   */
  /**
   * Whether a document resolves the components shim.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric components_shim_resolved(2538);

  /**
   * generated from use.counter.doc.console_assert
   */
  /**
   * Whether a document called called console.assert. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_assert(2539);

  /**
   * generated from use.counter.doc.console_clear
   */
  /**
   * Whether a document called called console.clear. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_clear(2540);

  /**
   * generated from use.counter.doc.console_count
   */
  /**
   * Whether a document called called console.count. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_count(2541);

  /**
   * generated from use.counter.doc.console_countreset
   */
  /**
   * Whether a document called called console.countReset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_countreset(2542);

  /**
   * generated from use.counter.doc.console_debug
   */
  /**
   * Whether a document called called console.debug. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_debug(2543);

  /**
   * generated from use.counter.doc.console_dir
   */
  /**
   * Whether a document called called console.dir. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dir(2544);

  /**
   * generated from use.counter.doc.console_dirxml
   */
  /**
   * Whether a document called called console.dirxml. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dirxml(2545);

  /**
   * generated from use.counter.doc.console_error
   */
  /**
   * Whether a document called called console.error. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_error(2546);

  /**
   * generated from use.counter.doc.console_exception
   */
  /**
   * Whether a document called called console.exception. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_exception(2547);

  /**
   * generated from use.counter.doc.console_group
   */
  /**
   * Whether a document called called console.group. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_group(2548);

  /**
   * generated from use.counter.doc.console_groupcollapsed
   */
  /**
   * Whether a document called called console.groupCollapsed. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupcollapsed(2549);

  /**
   * generated from use.counter.doc.console_groupend
   */
  /**
   * Whether a document called called console.groupEnd. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupend(2550);

  /**
   * generated from use.counter.doc.console_info
   */
  /**
   * Whether a document called called console.info. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_info(2551);

  /**
   * generated from use.counter.doc.console_log
   */
  /**
   * Whether a document called called console.log. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_log(2552);

  /**
   * generated from use.counter.doc.console_profile
   */
  /**
   * Whether a document called called console.profile. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profile(2553);

  /**
   * generated from use.counter.doc.console_profileend
   */
  /**
   * Whether a document called called console.profileEnd. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profileend(2554);

  /**
   * generated from use.counter.doc.console_table
   */
  /**
   * Whether a document called called console.table. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_table(2555);

  /**
   * generated from use.counter.doc.console_time
   */
  /**
   * Whether a document called called console.time. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_time(2556);

  /**
   * generated from use.counter.doc.console_timeend
   */
  /**
   * Whether a document called called console.timeEnd. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timeend(2557);

  /**
   * generated from use.counter.doc.console_timelog
   */
  /**
   * Whether a document called called console.timeLog. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timelog(2558);

  /**
   * generated from use.counter.doc.console_timestamp
   */
  /**
   * Whether a document called called console.timeStamp. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timestamp(2559);

  /**
   * generated from use.counter.doc.console_trace
   */
  /**
   * Whether a document called called console.trace. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_trace(2560);

  /**
   * generated from use.counter.doc.console_warn
   */
  /**
   * Whether a document called called console.warn. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_warn(2561);

  /**
   * generated from use.counter.doc.customelementregistry_define
   */
  /**
   * Whether a document called called CustomElementRegistry.define. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric customelementregistry_define(2562);

  /**
   * generated from use.counter.doc.customized_builtin
   */
  /**
   * Whether a document registers a customized built-in element. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric customized_builtin(2563);

  /**
   * generated from use.counter.doc.datatransfer_addelement
   */
  /**
   * Whether a document called called DataTransfer.addElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_addelement(2564);

  /**
   * generated from use.counter.doc.datatransfer_mozcleardataat
   */
  /**
   * Whether a document called called DataTransfer.mozClearDataAt. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcleardataat(2565);

  /**
   * generated from use.counter.doc.datatransfer_mozcursor_getter
   */
  /**
   * Whether a document got DataTransfer.mozCursor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcursor_getter(2566);

  /**
   * generated from use.counter.doc.datatransfer_mozcursor_setter
   */
  /**
   * Whether a document set DataTransfer.mozCursor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcursor_setter(2567);

  /**
   * generated from use.counter.doc.datatransfer_mozgetdataat
   */
  /**
   * Whether a document called called DataTransfer.mozGetDataAt. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozgetdataat(2568);

  /**
   * generated from use.counter.doc.datatransfer_mozitemcount_getter
   */
  /**
   * Whether a document got DataTransfer.mozItemCount. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozitemcount_getter(2569);

  /**
   * generated from use.counter.doc.datatransfer_mozitemcount_setter
   */
  /**
   * Whether a document set DataTransfer.mozItemCount. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozitemcount_setter(2570);

  /**
   * generated from use.counter.doc.datatransfer_mozsetdataat
   */
  /**
   * Whether a document called called DataTransfer.mozSetDataAt. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsetdataat(2571);

  /**
   * generated from use.counter.doc.datatransfer_mozsourcenode_getter
   */
  /**
   * Whether a document got DataTransfer.mozSourceNode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsourcenode_getter(2572);

  /**
   * generated from use.counter.doc.datatransfer_mozsourcenode_setter
   */
  /**
   * Whether a document set DataTransfer.mozSourceNode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsourcenode_setter(2573);

  /**
   * generated from use.counter.doc.datatransfer_moztypesat
   */
  /**
   * Whether a document called called DataTransfer.mozTypesAt. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_moztypesat(2574);

  /**
   * generated from use.counter.doc.datatransfer_mozusercancelled_getter
   */
  /**
   * Whether a document got DataTransfer.mozUserCancelled. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozusercancelled_getter(2575);

  /**
   * generated from use.counter.doc.datatransfer_mozusercancelled_setter
   */
  /**
   * Whether a document set DataTransfer.mozUserCancelled. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozusercancelled_setter(2576);

  /**
   * generated from use.counter.doc.datatransferitem_webkitgetasentry
   */
  /**
   * Whether a document called called DataTransferItem.webkitGetAsEntry. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransferitem_webkitgetasentry(2577);

  /**
   * generated from use.counter.doc.document_caretrangefrompoint
   */
  /**
   * Whether a document called called Document.caretRangeFromPoint. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_caretrangefrompoint(2578);

  /**
   * generated from use.counter.doc.document_exec_command_content_read_only
   */
  /**
   * Whether a document calls execCommand with contentReadOnly. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_exec_command_content_read_only(2579);

  /**
   * generated from use.counter.doc.document_exitpictureinpicture
   */
  /**
   * Whether a document called called Document.exitPictureInPicture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_exitpictureinpicture(2580);

  /**
   * generated from use.counter.doc.document_featurepolicy
   */
  /**
   * Whether a document called called Document.featurePolicy. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_featurepolicy(2581);

  /**
   * generated from use.counter.doc.document_mozsetimageelement
   */
  /**
   * Whether a document called called Document.mozSetImageElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_mozsetimageelement(2582);

  /**
   * generated from use.counter.doc.document_onbeforecopy
   */
  /**
   * Whether a document called called Document.onbeforecopy. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforecopy(2583);

  /**
   * generated from use.counter.doc.document_onbeforecut
   */
  /**
   * Whether a document called called Document.onbeforecut. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforecut(2584);

  /**
   * generated from use.counter.doc.document_onbeforepaste
   */
  /**
   * Whether a document called called Document.onbeforepaste. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforepaste(2585);

  /**
   * generated from use.counter.doc.document_oncancel
   */
  /**
   * Whether a document called called Document.oncancel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_oncancel(2586);

  /**
   * generated from use.counter.doc.document_onfreeze
   */
  /**
   * Whether a document called called Document.onfreeze. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onfreeze(2587);

  /**
   * generated from use.counter.doc.document_onmousewheel
   */
  /**
   * Whether a document called called Document.onmousewheel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onmousewheel(2588);

  /**
   * generated from use.counter.doc.document_onresume
   */
  /**
   * Whether a document called called Document.onresume. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onresume(2589);

  /**
   * generated from use.counter.doc.document_onsearch
   */
  /**
   * Whether a document called called Document.onsearch. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onsearch(2590);

  /**
   * generated from use.counter.doc.document_onwebkitfullscreenchange
   */
  /**
   * Whether a document called called Document.onwebkitfullscreenchange. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onwebkitfullscreenchange(2591);

  /**
   * generated from use.counter.doc.document_onwebkitfullscreenerror
   */
  /**
   * Whether a document called called Document.onwebkitfullscreenerror. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onwebkitfullscreenerror(2592);

  /**
   * generated from use.counter.doc.document_open
   */
  /**
   * Whether a document calls document.open in a way that creates a new Window
     * object. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric document_open(2593);

  /**
   * generated from use.counter.doc.document_pictureinpictureelement
   */
  /**
   * Whether a document called called Document.pictureInPictureElement. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_pictureinpictureelement(2594);

  /**
   * generated from use.counter.doc.document_pictureinpictureenabled
   */
  /**
   * Whether a document called called Document.pictureInPictureEnabled. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_pictureinpictureenabled(2595);

  /**
   * generated from use.counter.doc.document_query_command_state_or_value_content_read_only
   */
  /**
   * Whether a document calls queryCommandState or queryCommandValue with
     * contentReadOnly. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_state_or_value_content_read_only(2596);

  /**
   * generated from use.counter.doc.document_query_command_state_or_value_insert_br_on_return
   */
  /**
   * Whether a document calls queryCommandState or queryCommandValue with
     * insertBrOnReturn. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_state_or_value_insert_br_on_return(2597);

  /**
   * generated from use.counter.doc.document_query_command_supported_or_enabled_content_read_only
   */
  /**
   * Whether a document calls queryCommandSupported or queryCommandEnabled with
     * contentReadOnly. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_supported_or_enabled_content_read_only(2598);

  /**
   * generated from use.counter.doc.document_query_command_supported_or_enabled_insert_br_on_return
   */
  /**
   * Whether a document calls queryCommandSupported or queryCommandEnabled with
     * insertBrOnReturn. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_supported_or_enabled_insert_br_on_return(2599);

  /**
   * generated from use.counter.doc.document_registerelement
   */
  /**
   * Whether a document called called Document.registerElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_registerelement(2600);

  /**
   * generated from use.counter.doc.document_wasdiscarded
   */
  /**
   * Whether a document called called Document.wasDiscarded. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_wasdiscarded(2601);

  /**
   * generated from use.counter.doc.document_webkitcancelfullscreen
   */
  /**
   * Whether a document called called Document.webkitCancelFullScreen. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitcancelfullscreen(2602);

  /**
   * generated from use.counter.doc.document_webkitcurrentfullscreenelement
   */
  /**
   * Whether a document called called Document.webkitCurrentFullScreenElement.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric document_webkitcurrentfullscreenelement(2603);

  /**
   * generated from use.counter.doc.document_webkitexitfullscreen
   */
  /**
   * Whether a document called called Document.webkitExitFullscreen. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitexitfullscreen(2604);

  /**
   * generated from use.counter.doc.document_webkitfullscreenelement
   */
  /**
   * Whether a document called called Document.webkitFullscreenElement. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitfullscreenelement(2605);

  /**
   * generated from use.counter.doc.document_webkitfullscreenenabled
   */
  /**
   * Whether a document called called Document.webkitFullscreenEnabled. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitfullscreenenabled(2606);

  /**
   * generated from use.counter.doc.document_webkithidden
   */
  /**
   * Whether a document called called Document.webkitHidden. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkithidden(2607);

  /**
   * generated from use.counter.doc.document_webkitisfullscreen
   */
  /**
   * Whether a document called called Document.webkitIsFullScreen. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitisfullscreen(2608);

  /**
   * generated from use.counter.doc.document_webkitvisibilitystate
   */
  /**
   * Whether a document called called Document.webkitVisibilityState. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitvisibilitystate(2609);

  /**
   * generated from use.counter.doc.document_xmlencoding
   */
  /**
   * Whether a document called called Document.xmlEncoding. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlencoding(2610);

  /**
   * generated from use.counter.doc.document_xmlstandalone
   */
  /**
   * Whether a document called called Document.xmlStandalone. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlstandalone(2611);

  /**
   * generated from use.counter.doc.document_xmlversion
   */
  /**
   * Whether a document called called Document.xmlVersion. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlversion(2612);

  /**
   * generated from use.counter.doc.domparser_parsefromstring
   */
  /**
   * Whether a document called called DOMParser.parseFromString. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domparser_parsefromstring(2613);

  /**
   * generated from use.counter.doc.element_attachshadow
   */
  /**
   * Whether a document called called Element.attachShadow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_attachshadow(2614);

  /**
   * generated from use.counter.doc.element_computedstylemap
   */
  /**
   * Whether a document called called Element.computedStyleMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_computedstylemap(2615);

  /**
   * generated from use.counter.doc.element_onmousewheel
   */
  /**
   * Whether a document called called Element.onmousewheel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_onmousewheel(2616);

  /**
   * generated from use.counter.doc.element_releasecapture
   */
  /**
   * Whether a document called called Element.releaseCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_releasecapture(2617);

  /**
   * generated from use.counter.doc.element_releasepointercapture
   */
  /**
   * Whether a document called called Element.releasePointerCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_releasepointercapture(2618);

  /**
   * generated from use.counter.doc.element_scrollintoviewifneeded
   */
  /**
   * Whether a document called called Element.scrollIntoViewIfNeeded. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_scrollintoviewifneeded(2619);

  /**
   * generated from use.counter.doc.element_setcapture
   */
  /**
   * Whether a document called called Element.setCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_setcapture(2620);

  /**
   * generated from use.counter.doc.element_sethtml
   */
  /**
   * Whether a document called called Element.setHTML. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_sethtml(2621);

  /**
   * generated from use.counter.doc.element_setpointercapture
   */
  /**
   * Whether a document called called Element.setPointerCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_setpointercapture(2622);

  /**
   * generated from use.counter.doc.enumerate_devices_insec
   */
  /**
   * Whether a document calls MediaDevices.enumerateDevices from an insecure
     * context. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric enumerate_devices_insec(2623);

  /**
   * generated from use.counter.doc.enumerate_devices_unfocused
   */
  /**
   * Whether a document calls MediaDevices.enumerateDevices from a unfocused
     * document. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric enumerate_devices_unfocused(2624);

  /**
   * generated from use.counter.doc.fe_blend
   */
  /**
   * Whether a document uses the feBlend SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_blend(2625);

  /**
   * generated from use.counter.doc.fe_color_matrix
   */
  /**
   * Whether a document uses the feColorMatrix SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_color_matrix(2626);

  /**
   * generated from use.counter.doc.fe_component_transfer
   */
  /**
   * Whether a document uses the feComponentTransfer SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_component_transfer(2627);

  /**
   * generated from use.counter.doc.fe_composite
   */
  /**
   * Whether a document uses the feComposite SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_composite(2628);

  /**
   * generated from use.counter.doc.fe_convolve_matrix
   */
  /**
   * Whether a document uses the feConvolveMatrix SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_convolve_matrix(2629);

  /**
   * generated from use.counter.doc.fe_diffuse_lighting
   */
  /**
   * Whether a document uses the feDiffuseLighting SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_diffuse_lighting(2630);

  /**
   * generated from use.counter.doc.fe_displacement_map
   */
  /**
   * Whether a document uses the feDisplacementMap SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_displacement_map(2631);

  /**
   * generated from use.counter.doc.fe_flood
   */
  /**
   * Whether a document uses the feFlood SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_flood(2632);

  /**
   * generated from use.counter.doc.fe_gaussian_blur
   */
  /**
   * Whether a document uses the feGaussianBlur SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_gaussian_blur(2633);

  /**
   * generated from use.counter.doc.fe_image
   */
  /**
   * Whether a document uses the feImage SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_image(2634);

  /**
   * generated from use.counter.doc.fe_merge
   */
  /**
   * Whether a document uses the feMerge SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_merge(2635);

  /**
   * generated from use.counter.doc.fe_morphology
   */
  /**
   * Whether a document uses the feMorphology SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_morphology(2636);

  /**
   * generated from use.counter.doc.fe_offset
   */
  /**
   * Whether a document uses the feOffset SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_offset(2637);

  /**
   * generated from use.counter.doc.fe_specular_lighting
   */
  /**
   * Whether a document uses the feSpecularLighting SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_specular_lighting(2638);

  /**
   * generated from use.counter.doc.fe_tile
   */
  /**
   * Whether a document uses the feTile SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_tile(2639);

  /**
   * generated from use.counter.doc.fe_turbulence
   */
  /**
   * Whether a document uses the feTurbulence SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_turbulence(2640);

  /**
   * generated from use.counter.doc.filtered_cross_origin_iframe
   */
  /**
   * Whether a document cross-origin <iframe> within a CSS/SVG filter. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric filtered_cross_origin_iframe(2641);

  /**
   * generated from use.counter.doc.get_user_media_insec
   */
  /**
   * Whether a document calls MediaDevices.getUserMedia from an insecure context.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric get_user_media_insec(2642);

  /**
   * generated from use.counter.doc.get_user_media_unfocused
   */
  /**
   * Whether a document calls MediaDevices.getUserMedia from an unfocused document.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric get_user_media_unfocused(2643);

  /**
   * generated from use.counter.doc.htmlbuttonelement_popovertargetaction
   */
  /**
   * Whether a document called called HTMLButtonElement.popoverTargetAction. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlbuttonelement_popovertargetaction(2644);

  /**
   * generated from use.counter.doc.htmlbuttonelement_popovertargetelement
   */
  /**
   * Whether a document called called HTMLButtonElement.popoverTargetElement.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlbuttonelement_popovertargetelement(2645);

  /**
   * generated from use.counter.doc.htmldialogelement_show
   */
  /**
   * Whether a document called called HTMLDialogElement.show. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmldialogelement_show(2646);

  /**
   * generated from use.counter.doc.htmldocument_named_getter_hit
   */
  /**
   * Whether a document calls to the named getter on HTMLDocument that find
     * something via the name lookup. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmldocument_named_getter_hit(2647);

  /**
   * generated from use.counter.doc.htmlelement_attributestylemap
   */
  /**
   * Whether a document called called HTMLElement.attributeStyleMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_attributestylemap(2648);

  /**
   * generated from use.counter.doc.htmlelement_hidepopover
   */
  /**
   * Whether a document called called HTMLElement.hidePopover. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_hidepopover(2649);

  /**
   * generated from use.counter.doc.htmlelement_popover
   */
  /**
   * Whether a document called called HTMLElement.popover. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_popover(2650);

  /**
   * generated from use.counter.doc.htmlelement_showpopover
   */
  /**
   * Whether a document called called HTMLElement.showPopover. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_showpopover(2651);

  /**
   * generated from use.counter.doc.htmlelement_togglepopover
   */
  /**
   * Whether a document called called HTMLElement.togglePopover. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_togglepopover(2652);

  /**
   * generated from use.counter.doc.htmliframeelement_loading
   */
  /**
   * Whether a document called called HTMLIFrameElement.loading. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmliframeelement_loading(2653);

  /**
   * generated from use.counter.doc.htmlinputelement_capture
   */
  /**
   * Whether a document called called HTMLInputElement.capture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_capture(2654);

  /**
   * generated from use.counter.doc.htmlinputelement_incremental
   */
  /**
   * Whether a document called called HTMLInputElement.incremental. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_incremental(2655);

  /**
   * generated from use.counter.doc.htmlinputelement_onsearch
   */
  /**
   * Whether a document called called HTMLInputElement.onsearch. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_onsearch(2656);

  /**
   * generated from use.counter.doc.htmlinputelement_popovertargetaction
   */
  /**
   * Whether a document called called HTMLInputElement.popoverTargetAction. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_popovertargetaction(2657);

  /**
   * generated from use.counter.doc.htmlinputelement_popovertargetelement
   */
  /**
   * Whether a document called called HTMLInputElement.popoverTargetElement. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_popovertargetelement(2658);

  /**
   * generated from use.counter.doc.htmlinputelement_webkitdirectory
   */
  /**
   * Whether a document called called HTMLInputElement.webkitdirectory. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_webkitdirectory(2659);

  /**
   * generated from use.counter.doc.htmlinputelement_webkitentries
   */
  /**
   * Whether a document called called HTMLInputElement.webkitEntries. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_webkitentries(2660);

  /**
   * generated from use.counter.doc.htmlmediaelement_disableremoteplayback
   */
  /**
   * Whether a document called called HTMLMediaElement.disableRemotePlayback.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlmediaelement_disableremoteplayback(2661);

  /**
   * generated from use.counter.doc.htmlmediaelement_remote
   */
  /**
   * Whether a document called called HTMLMediaElement.remote. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlmediaelement_remote(2662);

  /**
   * generated from use.counter.doc.htmlvideoelement_cancelvideoframecallback
   */
  /**
   * Whether a document called called HTMLVideoElement.cancelVideoFrameCallback.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_cancelvideoframecallback(2663);

  /**
   * generated from use.counter.doc.htmlvideoelement_disablepictureinpicture
   */
  /**
   * Whether a document called called HTMLVideoElement.disablePictureInPicture.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_disablepictureinpicture(2664);

  /**
   * generated from use.counter.doc.htmlvideoelement_onenterpictureinpicture
   */
  /**
   * Whether a document called called HTMLVideoElement.onenterpictureinpicture.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_onenterpictureinpicture(2665);

  /**
   * generated from use.counter.doc.htmlvideoelement_onleavepictureinpicture
   */
  /**
   * Whether a document called called HTMLVideoElement.onleavepictureinpicture.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_onleavepictureinpicture(2666);

  /**
   * generated from use.counter.doc.htmlvideoelement_playsinline
   */
  /**
   * Whether a document called called HTMLVideoElement.playsInline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_playsinline(2667);

  /**
   * generated from use.counter.doc.htmlvideoelement_requestpictureinpicture
   */
  /**
   * Whether a document called called HTMLVideoElement.requestPictureInPicture.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_requestpictureinpicture(2668);

  /**
   * generated from use.counter.doc.htmlvideoelement_requestvideoframecallback
   */
  /**
   * Whether a document called called HTMLVideoElement.requestVideoFrameCallback.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_requestvideoframecallback(2669);

  /**
   * generated from use.counter.doc.imagedata_colorspace
   */
  /**
   * Whether a document called called ImageData.colorSpace. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric imagedata_colorspace(2670);

  /**
   * generated from use.counter.doc.js_asmjs
   */
  /**
   * Whether a document uses asm.js. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric js_asmjs(2671);

  /**
   * generated from use.counter.doc.js_is_htmldda_fuse
   */
  /**
   * Whether a document has used the document.all getter (popping the
     * EmulatesUndefined Fuse). Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric js_is_htmldda_fuse(2672);

  /**
   * generated from use.counter.doc.js_optimize_get_iterator_fuse
   */
  /**
   * Whether a document has modified any builtins such that the GetIterator fuse is
     * popped. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric js_optimize_get_iterator_fuse(2673);

  /**
   * generated from use.counter.doc.js_wasm
   */
  /**
   * Whether a document uses WebAssembly. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric js_wasm(2674);

  /**
   * generated from use.counter.doc.js_wasm_legacy_exceptions
   */
  /**
   * Whether a document uses WebAssembly legacy exception-handling. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric js_wasm_legacy_exceptions(2675);

  /**
   * generated from use.counter.doc.location_ancestororigins
   */
  /**
   * Whether a document called called Location.ancestorOrigins. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric location_ancestororigins(2676);

  /**
   * generated from use.counter.doc.mediadevices_enumeratedevices
   */
  /**
   * Whether a document called called MediaDevices.enumerateDevices. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_enumeratedevices(2677);

  /**
   * generated from use.counter.doc.mediadevices_getdisplaymedia
   */
  /**
   * Whether a document called called MediaDevices.getDisplayMedia. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_getdisplaymedia(2678);

  /**
   * generated from use.counter.doc.mediadevices_getusermedia
   */
  /**
   * Whether a document called called MediaDevices.getUserMedia. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_getusermedia(2679);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_audio_failure
   */
  /**
   * Whether a document includes a mixed content audio element that does not load..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_audio_failure(2680);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_audio_success
   */
  /**
   * Whether a document includes a mixed content audio element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_audio_success(2681);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_image_failure
   */
  /**
   * Whether a document includes a mixed content img element that does not load..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_image_failure(2682);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_image_success
   */
  /**
   * Whether a document includes a mixed content img element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_image_success(2683);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_video_failure
   */
  /**
   * Whether a document includes a mixed content video element that does not laod..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_video_failure(2684);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_video_success
   */
  /**
   * Whether a document includes a mixed content video element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_video_success(2685);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_audio_failure
   */
  /**
   * Whether a document includes a mixed content audio element that does not load..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_audio_failure(2686);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_audio_success
   */
  /**
   * Whether a document includes a mixed content audio element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_audio_success(2687);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_image_failure
   */
  /**
   * Whether a document includes a mixed content img element that does not load..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_image_failure(2688);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_image_success
   */
  /**
   * Whether a document includes a mixed content img element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_image_success(2689);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_video_failure
   */
  /**
   * Whether a document includes a mixed content video element that does not laod..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_video_failure(2690);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_video_success
   */
  /**
   * Whether a document includes a mixed content video element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_video_success(2691);

  /**
   * generated from use.counter.doc.mls_deriveexporter
   */
  /**
   * Whether a document called called MLS.deriveExporter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_deriveexporter(2692);

  /**
   * generated from use.counter.doc.mls_generatecredentialbasic
   */
  /**
   * Whether a document called called MLS.generateCredentialBasic. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatecredentialbasic(2693);

  /**
   * generated from use.counter.doc.mls_generatekeypackage
   */
  /**
   * Whether a document called called MLS.generateKeyPackage. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatekeypackage(2694);

  /**
   * generated from use.counter.doc.mls_generatesignaturekeypair
   */
  /**
   * Whether a document called called MLS.generateSignatureKeypair. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatesignaturekeypair(2695);

  /**
   * generated from use.counter.doc.mls_groupadd
   */
  /**
   * Whether a document called called MLS.groupAdd. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupadd(2696);

  /**
   * generated from use.counter.doc.mls_groupclose
   */
  /**
   * Whether a document called called MLS.groupClose. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupclose(2697);

  /**
   * generated from use.counter.doc.mls_groupcreate
   */
  /**
   * Whether a document called called MLS.groupCreate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupcreate(2698);

  /**
   * generated from use.counter.doc.mls_groupjoin
   */
  /**
   * Whether a document called called MLS.groupJoin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupjoin(2699);

  /**
   * generated from use.counter.doc.mls_groupmembers
   */
  /**
   * Whether a document called called MLS.groupMembers. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupmembers(2700);

  /**
   * generated from use.counter.doc.mls_groupproposeadd
   */
  /**
   * Whether a document called called MLS.groupProposeAdd. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupproposeadd(2701);

  /**
   * generated from use.counter.doc.mls_groupproposeremove
   */
  /**
   * Whether a document called called MLS.groupProposeRemove. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupproposeremove(2702);

  /**
   * generated from use.counter.doc.mls_groupremove
   */
  /**
   * Whether a document called called MLS.groupRemove. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupremove(2703);

  /**
   * generated from use.counter.doc.mls_receive
   */
  /**
   * Whether a document called called MLS.receive. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_receive(2704);

  /**
   * generated from use.counter.doc.mls_send
   */
  /**
   * Whether a document called called MLS.send. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_send(2705);

  /**
   * generated from use.counter.doc.mls_statedelete
   */
  /**
   * Whether a document called called MLS.stateDelete. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_statedelete(2706);

  /**
   * generated from use.counter.doc.mls_statedeletegroup
   */
  /**
   * Whether a document called called MLS.stateDeleteGroup. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_statedeletegroup(2707);

  /**
   * generated from use.counter.doc.moz_get_user_media_insec
   */
  /**
   * Whether a document calls Navigator.mozGetUserMedia from an insecure context.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric moz_get_user_media_insec(2708);

  /**
   * generated from use.counter.doc.navigator_canshare
   */
  /**
   * Whether a document called called Navigator.canShare. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_canshare(2709);

  /**
   * generated from use.counter.doc.navigator_clearappbadge
   */
  /**
   * Whether a document called called Navigator.clearAppBadge. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_clearappbadge(2710);

  /**
   * generated from use.counter.doc.navigator_mozgetusermedia
   */
  /**
   * Whether a document called called Navigator.mozGetUserMedia. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_mozgetusermedia(2711);

  /**
   * generated from use.counter.doc.navigator_setappbadge
   */
  /**
   * Whether a document called called Navigator.setAppBadge. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_setappbadge(2712);

  /**
   * generated from use.counter.doc.navigator_share
   */
  /**
   * Whether a document called called Navigator.share. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_share(2713);

  /**
   * generated from use.counter.doc.navigator_useractivation
   */
  /**
   * Whether a document called called Navigator.userActivation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_useractivation(2714);

  /**
   * generated from use.counter.doc.navigator_wakelock
   */
  /**
   * Whether a document called called Navigator.wakeLock. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_wakelock(2715);

  /**
   * generated from use.counter.doc.ondommousescroll
   */
  /**
   * Whether a document sets DOMMouseScroll event listener. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric ondommousescroll(2716);

  /**
   * generated from use.counter.doc.onmozmousepixelscroll
   */
  /**
   * Whether a document sets MozMousePixelScroll event listener. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onmozmousepixelscroll(2717);

  /**
   * generated from use.counter.doc.onoverflow
   */
  /**
   * Whether a document sets an element onoverflow event listener. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onoverflow(2718);

  /**
   * generated from use.counter.doc.onunderflow
   */
  /**
   * Whether a document sets an element onunderflow event listener. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onunderflow(2719);

  /**
   * generated from use.counter.doc.percentage_stroke_width_in_svg
   */
  /**
   * Whether a document whether percentage stroke-width is used in SVG elements
     * (excluding <text>). Compare against `use.counter.content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric percentage_stroke_width_in_svg(2720);

  /**
   * generated from use.counter.doc.percentage_stroke_width_in_svgtext
   */
  /**
   * Whether a document whether percentage stroke-width is used in SVG <text>.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric percentage_stroke_width_in_svgtext(2721);

  /**
   * generated from use.counter.doc.private_browsing_caches_delete
   */
  /**
   * Whether a document calls caches.delete in Private Browsing Mode. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_delete(2722);

  /**
   * generated from use.counter.doc.private_browsing_caches_has
   */
  /**
   * Whether a document calls caches.has in Private Browsing Mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_has(2723);

  /**
   * generated from use.counter.doc.private_browsing_caches_keys
   */
  /**
   * Whether a document calls caches.keys in Private Browsing Mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_keys(2724);

  /**
   * generated from use.counter.doc.private_browsing_caches_match
   */
  /**
   * Whether a document calls caches.match in Private Browsing Mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_match(2725);

  /**
   * generated from use.counter.doc.private_browsing_caches_open
   */
  /**
   * Whether a document calls caches.open in Private Browsing Mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_open(2726);

  /**
   * generated from use.counter.doc.private_browsing_idbfactory_delete_database
   */
  /**
   * Whether a document calls indexedDB.deleteDatabase in Private Browsing Mode.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_delete_database(2727);

  /**
   * generated from use.counter.doc.private_browsing_idbfactory_open
   */
  /**
   * Whether a document calls indexedDB.open in Private Browsing Mode. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_open(2728);

  /**
   * generated from use.counter.doc.private_browsing_navigator_service_worker
   */
  /**
   * Whether a document accesses navigator.serviceWorker in Private Browsing Mode.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_navigator_service_worker(2729);

  /**
   * generated from use.counter.doc.pushmanager_subscribe
   */
  /**
   * Whether a document called called PushManager.subscribe. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushmanager_subscribe(2730);

  /**
   * generated from use.counter.doc.pushsubscription_unsubscribe
   */
  /**
   * Whether a document called called PushSubscription.unsubscribe. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushsubscription_unsubscribe(2731);

  /**
   * generated from use.counter.doc.range_createcontextualfragment
   */
  /**
   * Whether a document called called Range.createContextualFragment. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric range_createcontextualfragment(2732);

  /**
   * generated from use.counter.doc.sanitizer_constructor
   */
  /**
   * Whether a document called called Sanitizer.constructor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sanitizer_constructor(2733);

  /**
   * generated from use.counter.doc.sanitizer_sanitize
   */
  /**
   * Whether a document called called Sanitizer.sanitize. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sanitizer_sanitize(2734);

  /**
   * generated from use.counter.doc.scheduler_posttask
   */
  /**
   * Whether a document called called Scheduler.postTask. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric scheduler_posttask(2735);

  /**
   * generated from use.counter.doc.shadowroot_pictureinpictureelement
   */
  /**
   * Whether a document called called ShadowRoot.pictureInPictureElement. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric shadowroot_pictureinpictureelement(2736);

  /**
   * generated from use.counter.doc.svgsvgelement_currentscale_getter
   */
  /**
   * Whether a document got SVGSVGElement.currentScale. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_currentscale_getter(2737);

  /**
   * generated from use.counter.doc.svgsvgelement_currentscale_setter
   */
  /**
   * Whether a document set SVGSVGElement.currentScale. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_currentscale_setter(2738);

  /**
   * generated from use.counter.doc.svgsvgelement_getelementbyid
   */
  /**
   * Whether a document called called SVGSVGElement.getElementById. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_getelementbyid(2739);

  /**
   * generated from use.counter.doc.window_absoluteorientationsensor
   */
  /**
   * Whether a document called called Window.AbsoluteOrientationSensor. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_absoluteorientationsensor(2740);

  /**
   * generated from use.counter.doc.window_accelerometer
   */
  /**
   * Whether a document called called Window.Accelerometer. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_accelerometer(2741);

  /**
   * generated from use.counter.doc.window_backgroundfetchmanager
   */
  /**
   * Whether a document called called Window.BackgroundFetchManager. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchmanager(2742);

  /**
   * generated from use.counter.doc.window_backgroundfetchrecord
   */
  /**
   * Whether a document called called Window.BackgroundFetchRecord. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchrecord(2743);

  /**
   * generated from use.counter.doc.window_backgroundfetchregistration
   */
  /**
   * Whether a document called called Window.BackgroundFetchRegistration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchregistration(2744);

  /**
   * generated from use.counter.doc.window_beforeinstallpromptevent
   */
  /**
   * Whether a document called called Window.BeforeInstallPromptEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_beforeinstallpromptevent(2745);

  /**
   * generated from use.counter.doc.window_bluetooth
   */
  /**
   * Whether a document called called Window.Bluetooth. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetooth(2746);

  /**
   * generated from use.counter.doc.window_bluetoothcharacteristicproperties
   */
  /**
   * Whether a document called called Window.BluetoothCharacteristicProperties.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_bluetoothcharacteristicproperties(2747);

  /**
   * generated from use.counter.doc.window_bluetoothdevice
   */
  /**
   * Whether a document called called Window.BluetoothDevice. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothdevice(2748);

  /**
   * generated from use.counter.doc.window_bluetoothremotegattcharacteristic
   */
  /**
   * Whether a document called called Window.BluetoothRemoteGATTCharacteristic.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattcharacteristic(2749);

  /**
   * generated from use.counter.doc.window_bluetoothremotegattdescriptor
   */
  /**
   * Whether a document called called Window.BluetoothRemoteGATTDescriptor. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattdescriptor(2750);

  /**
   * generated from use.counter.doc.window_bluetoothremotegattserver
   */
  /**
   * Whether a document called called Window.BluetoothRemoteGATTServer. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattserver(2751);

  /**
   * generated from use.counter.doc.window_bluetoothremotegattservice
   */
  /**
   * Whether a document called called Window.BluetoothRemoteGATTService. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattservice(2752);

  /**
   * generated from use.counter.doc.window_bluetoothuuid
   */
  /**
   * Whether a document called called Window.BluetoothUUID. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothuuid(2753);

  /**
   * generated from use.counter.doc.window_canvascapturemediastreamtrack
   */
  /**
   * Whether a document called called Window.CanvasCaptureMediaStreamTrack. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_canvascapturemediastreamtrack(2754);

  /**
   * generated from use.counter.doc.window_chrome
   */
  /**
   * Whether a document called called Window.chrome. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_chrome(2755);

  /**
   * generated from use.counter.doc.window_clipboarditem
   */
  /**
   * Whether a document called called Window.ClipboardItem. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_clipboarditem(2756);

  /**
   * generated from use.counter.doc.window_cssimagevalue
   */
  /**
   * Whether a document called called Window.CSSImageValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssimagevalue(2757);

  /**
   * generated from use.counter.doc.window_csskeywordvalue
   */
  /**
   * Whether a document called called Window.CSSKeywordValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csskeywordvalue(2758);

  /**
   * generated from use.counter.doc.window_cssmathclamp
   */
  /**
   * Whether a document called called Window.CSSMathClamp. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathclamp(2759);

  /**
   * generated from use.counter.doc.window_cssmathinvert
   */
  /**
   * Whether a document called called Window.CSSMathInvert. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathinvert(2760);

  /**
   * generated from use.counter.doc.window_cssmathmax
   */
  /**
   * Whether a document called called Window.CSSMathMax. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathmax(2761);

  /**
   * generated from use.counter.doc.window_cssmathmin
   */
  /**
   * Whether a document called called Window.CSSMathMin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathmin(2762);

  /**
   * generated from use.counter.doc.window_cssmathnegate
   */
  /**
   * Whether a document called called Window.CSSMathNegate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathnegate(2763);

  /**
   * generated from use.counter.doc.window_cssmathproduct
   */
  /**
   * Whether a document called called Window.CSSMathProduct. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathproduct(2764);

  /**
   * generated from use.counter.doc.window_cssmathsum
   */
  /**
   * Whether a document called called Window.CSSMathSum. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathsum(2765);

  /**
   * generated from use.counter.doc.window_cssmathvalue
   */
  /**
   * Whether a document called called Window.CSSMathValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathvalue(2766);

  /**
   * generated from use.counter.doc.window_cssmatrixcomponent
   */
  /**
   * Whether a document called called Window.CSSMatrixComponent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmatrixcomponent(2767);

  /**
   * generated from use.counter.doc.window_cssnumericarray
   */
  /**
   * Whether a document called called Window.CSSNumericArray. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssnumericarray(2768);

  /**
   * generated from use.counter.doc.window_cssnumericvalue
   */
  /**
   * Whether a document called called Window.CSSNumericValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssnumericvalue(2769);

  /**
   * generated from use.counter.doc.window_cssperspective
   */
  /**
   * Whether a document called called Window.CSSPerspective. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssperspective(2770);

  /**
   * generated from use.counter.doc.window_csspositionvalue
   */
  /**
   * Whether a document called called Window.CSSPositionValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csspositionvalue(2771);

  /**
   * generated from use.counter.doc.window_csspropertyrule
   */
  /**
   * Whether a document called called Window.CSSPropertyRule. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csspropertyrule(2772);

  /**
   * generated from use.counter.doc.window_cssrotate
   */
  /**
   * Whether a document called called Window.CSSRotate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssrotate(2773);

  /**
   * generated from use.counter.doc.window_cssscale
   */
  /**
   * Whether a document called called Window.CSSScale. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssscale(2774);

  /**
   * generated from use.counter.doc.window_cssskew
   */
  /**
   * Whether a document called called Window.CSSSkew. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskew(2775);

  /**
   * generated from use.counter.doc.window_cssskewx
   */
  /**
   * Whether a document called called Window.CSSSkewX. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskewx(2776);

  /**
   * generated from use.counter.doc.window_cssskewy
   */
  /**
   * Whether a document called called Window.CSSSkewY. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskewy(2777);

  /**
   * generated from use.counter.doc.window_cssstylevalue
   */
  /**
   * Whether a document called called Window.CSSStyleValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssstylevalue(2778);

  /**
   * generated from use.counter.doc.window_csstransformcomponent
   */
  /**
   * Whether a document called called Window.CSSTransformComponent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstransformcomponent(2779);

  /**
   * generated from use.counter.doc.window_csstransformvalue
   */
  /**
   * Whether a document called called Window.CSSTransformValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstransformvalue(2780);

  /**
   * generated from use.counter.doc.window_csstranslate
   */
  /**
   * Whether a document called called Window.CSSTranslate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstranslate(2781);

  /**
   * generated from use.counter.doc.window_cssunitvalue
   */
  /**
   * Whether a document called called Window.CSSUnitValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssunitvalue(2782);

  /**
   * generated from use.counter.doc.window_cssunparsedvalue
   */
  /**
   * Whether a document called called Window.CSSUnparsedValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssunparsedvalue(2783);

  /**
   * generated from use.counter.doc.window_cssvariablereferencevalue
   */
  /**
   * Whether a document called called Window.CSSVariableReferenceValue. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssvariablereferencevalue(2784);

  /**
   * generated from use.counter.doc.window_defaultstatus
   */
  /**
   * Whether a document called called Window.defaultStatus. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_defaultstatus(2785);

  /**
   * generated from use.counter.doc.window_devicemotioneventacceleration
   */
  /**
   * Whether a document called called Window.DeviceMotionEventAcceleration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_devicemotioneventacceleration(2786);

  /**
   * generated from use.counter.doc.window_devicemotioneventrotationrate
   */
  /**
   * Whether a document called called Window.DeviceMotionEventRotationRate. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_devicemotioneventrotationrate(2787);

  /**
   * generated from use.counter.doc.window_domerror
   */
  /**
   * Whether a document called called Window.DOMError. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_domerror(2788);

  /**
   * generated from use.counter.doc.window_encodedvideochunk
   */
  /**
   * Whether a document called called Window.EncodedVideoChunk. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_encodedvideochunk(2789);

  /**
   * generated from use.counter.doc.window_enterpictureinpictureevent
   */
  /**
   * Whether a document called called Window.EnterPictureInPictureEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_enterpictureinpictureevent(2790);

  /**
   * generated from use.counter.doc.window_external
   */
  /**
   * Whether a document called called Window.External. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_external(2791);

  /**
   * generated from use.counter.doc.window_federatedcredential
   */
  /**
   * Whether a document called called Window.FederatedCredential. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_federatedcredential(2792);

  /**
   * generated from use.counter.doc.window_gyroscope
   */
  /**
   * Whether a document called called Window.Gyroscope. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_gyroscope(2793);

  /**
   * generated from use.counter.doc.window_htmlcontentelement
   */
  /**
   * Whether a document called called Window.HTMLContentElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_htmlcontentelement(2794);

  /**
   * generated from use.counter.doc.window_htmlshadowelement
   */
  /**
   * Whether a document called called Window.HTMLShadowElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_htmlshadowelement(2795);

  /**
   * generated from use.counter.doc.window_imagecapture
   */
  /**
   * Whether a document called called Window.ImageCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_imagecapture(2796);

  /**
   * generated from use.counter.doc.window_inputdevicecapabilities
   */
  /**
   * Whether a document called called Window.InputDeviceCapabilities. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_inputdevicecapabilities(2797);

  /**
   * generated from use.counter.doc.window_inputdeviceinfo
   */
  /**
   * Whether a document called called Window.InputDeviceInfo. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_inputdeviceinfo(2798);

  /**
   * generated from use.counter.doc.window_keyboard
   */
  /**
   * Whether a document called called Window.Keyboard. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_keyboard(2799);

  /**
   * generated from use.counter.doc.window_keyboardlayoutmap
   */
  /**
   * Whether a document called called Window.KeyboardLayoutMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_keyboardlayoutmap(2800);

  /**
   * generated from use.counter.doc.window_linearaccelerationsensor
   */
  /**
   * Whether a document called called Window.LinearAccelerationSensor. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_linearaccelerationsensor(2801);

  /**
   * generated from use.counter.doc.window_mediasettingsrange
   */
  /**
   * Whether a document called called Window.MediaSettingsRange. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_mediasettingsrange(2802);

  /**
   * generated from use.counter.doc.window_midiaccess
   */
  /**
   * Whether a document called called Window.MIDIAccess. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiaccess(2803);

  /**
   * generated from use.counter.doc.window_midiconnectionevent
   */
  /**
   * Whether a document called called Window.MIDIConnectionEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiconnectionevent(2804);

  /**
   * generated from use.counter.doc.window_midiinput
   */
  /**
   * Whether a document called called Window.MIDIInput. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiinput(2805);

  /**
   * generated from use.counter.doc.window_midiinputmap
   */
  /**
   * Whether a document called called Window.MIDIInputMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiinputmap(2806);

  /**
   * generated from use.counter.doc.window_midimessageevent
   */
  /**
   * Whether a document called called Window.MIDIMessageEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midimessageevent(2807);

  /**
   * generated from use.counter.doc.window_midioutput
   */
  /**
   * Whether a document called called Window.MIDIOutput. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midioutput(2808);

  /**
   * generated from use.counter.doc.window_midioutputmap
   */
  /**
   * Whether a document called called Window.MIDIOutputMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midioutputmap(2809);

  /**
   * generated from use.counter.doc.window_midiport
   */
  /**
   * Whether a document called called Window.MIDIPort. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiport(2810);

  /**
   * generated from use.counter.doc.window_networkinformation
   */
  /**
   * Whether a document called called Window.NetworkInformation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_networkinformation(2811);

  /**
   * generated from use.counter.doc.window_offscreenbuffering
   */
  /**
   * Whether a document called called Window.offscreenBuffering. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_offscreenbuffering(2812);

  /**
   * generated from use.counter.doc.window_onbeforeinstallprompt
   */
  /**
   * Whether a document called called Window.onbeforeinstallprompt. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onbeforeinstallprompt(2813);

  /**
   * generated from use.counter.doc.window_oncancel
   */
  /**
   * Whether a document called called Window.oncancel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_oncancel(2814);

  /**
   * generated from use.counter.doc.window_onmousewheel
   */
  /**
   * Whether a document called called Window.onmousewheel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onmousewheel(2815);

  /**
   * generated from use.counter.doc.window_onorientationchange
   */
  /**
   * Whether a document called called Window.onorientationchange. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onorientationchange(2816);

  /**
   * generated from use.counter.doc.window_onsearch
   */
  /**
   * Whether a document called called Window.onsearch. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onsearch(2817);

  /**
   * generated from use.counter.doc.window_onselectionchange
   */
  /**
   * Whether a document called called Window.onselectionchange. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onselectionchange(2818);

  /**
   * generated from use.counter.doc.window_open_empty_url
   */
  /**
   * Whether a document calls window.open with an empty url argument. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_open_empty_url(2819);

  /**
   * generated from use.counter.doc.window_opendatabase
   */
  /**
   * Whether a document called called Window.openDatabase. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_opendatabase(2820);

  /**
   * generated from use.counter.doc.window_orientation
   */
  /**
   * Whether a document called called Window.orientation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_orientation(2821);

  /**
   * generated from use.counter.doc.window_orientationsensor
   */
  /**
   * Whether a document called called Window.OrientationSensor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_orientationsensor(2822);

  /**
   * generated from use.counter.doc.window_overconstrainederror
   */
  /**
   * Whether a document called called Window.OverconstrainedError. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_overconstrainederror(2823);

  /**
   * generated from use.counter.doc.window_passwordcredential
   */
  /**
   * Whether a document called called Window.PasswordCredential. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_passwordcredential(2824);

  /**
   * generated from use.counter.doc.window_paymentaddress
   */
  /**
   * Whether a document called called Window.PaymentAddress. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentaddress(2825);

  /**
   * generated from use.counter.doc.window_paymentinstruments
   */
  /**
   * Whether a document called called Window.PaymentInstruments. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentinstruments(2826);

  /**
   * generated from use.counter.doc.window_paymentmanager
   */
  /**
   * Whether a document called called Window.PaymentManager. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentmanager(2827);

  /**
   * generated from use.counter.doc.window_paymentmethodchangeevent
   */
  /**
   * Whether a document called called Window.PaymentMethodChangeEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentmethodchangeevent(2828);

  /**
   * generated from use.counter.doc.window_paymentrequest
   */
  /**
   * Whether a document called called Window.PaymentRequest. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentrequest(2829);

  /**
   * generated from use.counter.doc.window_paymentrequestupdateevent
   */
  /**
   * Whether a document called called Window.PaymentRequestUpdateEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentrequestupdateevent(2830);

  /**
   * generated from use.counter.doc.window_paymentresponse
   */
  /**
   * Whether a document called called Window.PaymentResponse. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentresponse(2831);

  /**
   * generated from use.counter.doc.window_performancelongtasktiming
   */
  /**
   * Whether a document called called Window.PerformanceLongTaskTiming. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_performancelongtasktiming(2832);

  /**
   * generated from use.counter.doc.window_photocapabilities
   */
  /**
   * Whether a document called called Window.PhotoCapabilities. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_photocapabilities(2833);

  /**
   * generated from use.counter.doc.window_pictureinpictureevent
   */
  /**
   * Whether a document called called Window.PictureInPictureEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_pictureinpictureevent(2834);

  /**
   * generated from use.counter.doc.window_pictureinpicturewindow
   */
  /**
   * Whether a document called called Window.PictureInPictureWindow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_pictureinpicturewindow(2835);

  /**
   * generated from use.counter.doc.window_presentation
   */
  /**
   * Whether a document called called Window.Presentation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentation(2836);

  /**
   * generated from use.counter.doc.window_presentationavailability
   */
  /**
   * Whether a document called called Window.PresentationAvailability. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationavailability(2837);

  /**
   * generated from use.counter.doc.window_presentationconnection
   */
  /**
   * Whether a document called called Window.PresentationConnection. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationconnection(2838);

  /**
   * generated from use.counter.doc.window_presentationconnectionavailableevent
   */
  /**
   * Whether a document called called Window.PresentationConnectionAvailableEvent.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_presentationconnectionavailableevent(2839);

  /**
   * generated from use.counter.doc.window_presentationconnectioncloseevent
   */
  /**
   * Whether a document called called Window.PresentationConnectionCloseEvent.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_presentationconnectioncloseevent(2840);

  /**
   * generated from use.counter.doc.window_presentationconnectionlist
   */
  /**
   * Whether a document called called Window.PresentationConnectionList. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationconnectionlist(2841);

  /**
   * generated from use.counter.doc.window_presentationreceiver
   */
  /**
   * Whether a document called called Window.PresentationReceiver. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationreceiver(2842);

  /**
   * generated from use.counter.doc.window_presentationrequest
   */
  /**
   * Whether a document called called Window.PresentationRequest. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationrequest(2843);

  /**
   * generated from use.counter.doc.window_relativeorientationsensor
   */
  /**
   * Whether a document called called Window.RelativeOrientationSensor. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_relativeorientationsensor(2844);

  /**
   * generated from use.counter.doc.window_remoteplayback
   */
  /**
   * Whether a document called called Window.RemotePlayback. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_remoteplayback(2845);

  /**
   * generated from use.counter.doc.window_report
   */
  /**
   * Whether a document called called Window.Report. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_report(2846);

  /**
   * generated from use.counter.doc.window_reportbody
   */
  /**
   * Whether a document called called Window.ReportBody. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_reportbody(2847);

  /**
   * generated from use.counter.doc.window_reportingobserver
   */
  /**
   * Whether a document called called Window.ReportingObserver. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_reportingobserver(2848);

  /**
   * generated from use.counter.doc.window_rtcerror
   */
  /**
   * Whether a document called called Window.RTCError. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcerror(2849);

  /**
   * generated from use.counter.doc.window_rtcerrorevent
   */
  /**
   * Whether a document called called Window.RTCErrorEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcerrorevent(2850);

  /**
   * generated from use.counter.doc.window_rtcicetransport
   */
  /**
   * Whether a document called called Window.RTCIceTransport. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcicetransport(2851);

  /**
   * generated from use.counter.doc.window_rtcpeerconnectioniceerrorevent
   */
  /**
   * Whether a document called called Window.RTCPeerConnectionIceErrorEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcpeerconnectioniceerrorevent(2852);

  /**
   * generated from use.counter.doc.window_sensor
   */
  /**
   * Whether a document called called Window.Sensor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sensor(2853);

  /**
   * generated from use.counter.doc.window_sensorerrorevent
   */
  /**
   * Whether a document called called Window.SensorErrorEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sensorerrorevent(2854);

  /**
   * generated from use.counter.doc.window_sidebar_getter
   */
  /**
   * Whether a document got Window.sidebar. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sidebar_getter(2855);

  /**
   * generated from use.counter.doc.window_sidebar_setter
   */
  /**
   * Whether a document set Window.sidebar. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sidebar_setter(2856);

  /**
   * generated from use.counter.doc.window_speechrecognitionalternative
   */
  /**
   * Whether a document called called Window.SpeechRecognitionAlternative. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionalternative(2857);

  /**
   * generated from use.counter.doc.window_speechrecognitionresult
   */
  /**
   * Whether a document called called Window.SpeechRecognitionResult. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionresult(2858);

  /**
   * generated from use.counter.doc.window_speechrecognitionresultlist
   */
  /**
   * Whether a document called called Window.SpeechRecognitionResultList. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionresultlist(2859);

  /**
   * generated from use.counter.doc.window_stylemedia
   */
  /**
   * Whether a document called called Window.styleMedia. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylemedia(2860);

  /**
   * generated from use.counter.doc.window_stylepropertymap
   */
  /**
   * Whether a document called called Window.StylePropertyMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylepropertymap(2861);

  /**
   * generated from use.counter.doc.window_stylepropertymapreadonly
   */
  /**
   * Whether a document called called Window.StylePropertyMapReadOnly. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylepropertymapreadonly(2862);

  /**
   * generated from use.counter.doc.window_svgdiscardelement
   */
  /**
   * Whether a document called called Window.SVGDiscardElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_svgdiscardelement(2863);

  /**
   * generated from use.counter.doc.window_syncmanager
   */
  /**
   * Whether a document called called Window.SyncManager. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_syncmanager(2864);

  /**
   * generated from use.counter.doc.window_taskattributiontiming
   */
  /**
   * Whether a document called called Window.TaskAttributionTiming. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_taskattributiontiming(2865);

  /**
   * generated from use.counter.doc.window_textevent
   */
  /**
   * Whether a document called called Window.TextEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_textevent(2866);

  /**
   * generated from use.counter.doc.window_touch
   */
  /**
   * Whether a document called called Window.Touch. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touch(2867);

  /**
   * generated from use.counter.doc.window_touchevent
   */
  /**
   * Whether a document called called Window.TouchEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touchevent(2868);

  /**
   * generated from use.counter.doc.window_touchlist
   */
  /**
   * Whether a document called called Window.TouchList. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touchlist(2869);

  /**
   * generated from use.counter.doc.window_usb
   */
  /**
   * Whether a document called called Window.USB. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usb(2870);

  /**
   * generated from use.counter.doc.window_usbalternateinterface
   */
  /**
   * Whether a document called called Window.USBAlternateInterface. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbalternateinterface(2871);

  /**
   * generated from use.counter.doc.window_usbconfiguration
   */
  /**
   * Whether a document called called Window.USBConfiguration. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbconfiguration(2872);

  /**
   * generated from use.counter.doc.window_usbconnectionevent
   */
  /**
   * Whether a document called called Window.USBConnectionEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbconnectionevent(2873);

  /**
   * generated from use.counter.doc.window_usbdevice
   */
  /**
   * Whether a document called called Window.USBDevice. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbdevice(2874);

  /**
   * generated from use.counter.doc.window_usbendpoint
   */
  /**
   * Whether a document called called Window.USBEndpoint. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbendpoint(2875);

  /**
   * generated from use.counter.doc.window_usbinterface
   */
  /**
   * Whether a document called called Window.USBInterface. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbinterface(2876);

  /**
   * generated from use.counter.doc.window_usbintransferresult
   */
  /**
   * Whether a document called called Window.USBInTransferResult. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbintransferresult(2877);

  /**
   * generated from use.counter.doc.window_usbisochronousintransferpacket
   */
  /**
   * Whether a document called called Window.USBIsochronousInTransferPacket. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbisochronousintransferpacket(2878);

  /**
   * generated from use.counter.doc.window_usbisochronousintransferresult
   */
  /**
   * Whether a document called called Window.USBIsochronousInTransferResult. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbisochronousintransferresult(2879);

  /**
   * generated from use.counter.doc.window_usbisochronousouttransferpacket
   */
  /**
   * Whether a document called called Window.USBIsochronousOutTransferPacket.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousouttransferpacket(2880);

  /**
   * generated from use.counter.doc.window_usbisochronousouttransferresult
   */
  /**
   * Whether a document called called Window.USBIsochronousOutTransferResult.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousouttransferresult(2881);

  /**
   * generated from use.counter.doc.window_usbouttransferresult
   */
  /**
   * Whether a document called called Window.USBOutTransferResult. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbouttransferresult(2882);

  /**
   * generated from use.counter.doc.window_useractivation
   */
  /**
   * Whether a document called called Window.UserActivation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_useractivation(2883);

  /**
   * generated from use.counter.doc.window_videocolorspace
   */
  /**
   * Whether a document called called Window.VideoColorSpace. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videocolorspace(2884);

  /**
   * generated from use.counter.doc.window_videodecoder
   */
  /**
   * Whether a document called called Window.VideoDecoder. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videodecoder(2885);

  /**
   * generated from use.counter.doc.window_videoencoder
   */
  /**
   * Whether a document called called Window.VideoEncoder. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videoencoder(2886);

  /**
   * generated from use.counter.doc.window_videoframe
   */
  /**
   * Whether a document called called Window.VideoFrame. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videoframe(2887);

  /**
   * generated from use.counter.doc.window_wakelock
   */
  /**
   * Whether a document called called Window.WakeLock. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_wakelock(2888);

  /**
   * generated from use.counter.doc.window_wakelocksentinel
   */
  /**
   * Whether a document called called Window.WakeLockSentinel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_wakelocksentinel(2889);

  /**
   * generated from use.counter.doc.window_webkitcancelanimationframe
   */
  /**
   * Whether a document called called Window.webkitCancelAnimationFrame. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitcancelanimationframe(2890);

  /**
   * generated from use.counter.doc.window_webkitmediastream
   */
  /**
   * Whether a document called called Window.webkitMediaStream. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitmediastream(2891);

  /**
   * generated from use.counter.doc.window_webkitmutationobserver
   */
  /**
   * Whether a document called called Window.WebKitMutationObserver. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitmutationobserver(2892);

  /**
   * generated from use.counter.doc.window_webkitrequestanimationframe
   */
  /**
   * Whether a document called called Window.webkitRequestAnimationFrame. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitrequestanimationframe(2893);

  /**
   * generated from use.counter.doc.window_webkitrequestfilesystem
   */
  /**
   * Whether a document called called Window.webkitRequestFileSystem. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitrequestfilesystem(2894);

  /**
   * generated from use.counter.doc.window_webkitresolvelocalfilesystemurl
   */
  /**
   * Whether a document called called Window.webkitResolveLocalFileSystemURL.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_webkitresolvelocalfilesystemurl(2895);

  /**
   * generated from use.counter.doc.window_webkitrtcpeerconnection
   */
  /**
   * Whether a document called called Window.webkitRTCPeerConnection. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitrtcpeerconnection(2896);

  /**
   * generated from use.counter.doc.window_webkitspeechgrammar
   */
  /**
   * Whether a document called called Window.webkitSpeechGrammar. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechgrammar(2897);

  /**
   * generated from use.counter.doc.window_webkitspeechgrammarlist
   */
  /**
   * Whether a document called called Window.webkitSpeechGrammarList. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechgrammarlist(2898);

  /**
   * generated from use.counter.doc.window_webkitspeechrecognition
   */
  /**
   * Whether a document called called Window.webkitSpeechRecognition. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognition(2899);

  /**
   * generated from use.counter.doc.window_webkitspeechrecognitionerror
   */
  /**
   * Whether a document called called Window.webkitSpeechRecognitionError. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognitionerror(2900);

  /**
   * generated from use.counter.doc.window_webkitspeechrecognitionevent
   */
  /**
   * Whether a document called called Window.webkitSpeechRecognitionEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognitionevent(2901);

  /**
   * generated from use.counter.doc.window_webkitstorageinfo
   */
  /**
   * Whether a document called called Window.webkitStorageInfo. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitstorageinfo(2902);

  /**
   * generated from use.counter.doc.workernavigator_permissions
   */
  /**
   * Whether a document called called WorkerNavigator.permissions. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric workernavigator_permissions(2903);

  /**
   * generated from use.counter.doc.wr_filter_fallback
   */
  /**
   * Whether a document triggers the blob fallback for an SVG filter.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric wr_filter_fallback(2904);

  /**
   * generated from use.counter.doc.xslstylesheet
   */
  /**
   * Whether a document uses an XSL Stylesheet. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric xslstylesheet(2905);

  /**
   * generated from use.counter.doc.xsltprocessor_constructor
   */
  /**
   * Whether a document called called XSLTProcessor.constructor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric xsltprocessor_constructor(2906);

  /**
   * generated from use.counter.doc.you_tube_flash_embed
   */
  /**
   * Whether a document in <object> or <embed>. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric you_tube_flash_embed(2907);

}
namespace use_counter_page {
  /**
   * generated from use.counter.page.clipboard_read
   */
  /**
   * Whether a page called called Clipboard.read. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_read(2908);

  /**
   * generated from use.counter.page.clipboard_readtext
   */
  /**
   * Whether a page called called Clipboard.readText. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_readtext(2909);

  /**
   * generated from use.counter.page.clipboard_write
   */
  /**
   * Whether a page called called Clipboard.write. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_write(2910);

  /**
   * generated from use.counter.page.components_shim_resolved
   */
  /**
   * Whether a page resolves the components shim.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric components_shim_resolved(2911);

  /**
   * generated from use.counter.page.console_assert
   */
  /**
   * Whether a page called called console.assert. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_assert(2912);

  /**
   * generated from use.counter.page.console_clear
   */
  /**
   * Whether a page called called console.clear. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_clear(2913);

  /**
   * generated from use.counter.page.console_count
   */
  /**
   * Whether a page called called console.count. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_count(2914);

  /**
   * generated from use.counter.page.console_countreset
   */
  /**
   * Whether a page called called console.countReset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_countreset(2915);

  /**
   * generated from use.counter.page.console_debug
   */
  /**
   * Whether a page called called console.debug. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_debug(2916);

  /**
   * generated from use.counter.page.console_dir
   */
  /**
   * Whether a page called called console.dir. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dir(2917);

  /**
   * generated from use.counter.page.console_dirxml
   */
  /**
   * Whether a page called called console.dirxml. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dirxml(2918);

  /**
   * generated from use.counter.page.console_error
   */
  /**
   * Whether a page called called console.error. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_error(2919);

  /**
   * generated from use.counter.page.console_exception
   */
  /**
   * Whether a page called called console.exception. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_exception(2920);

  /**
   * generated from use.counter.page.console_group
   */
  /**
   * Whether a page called called console.group. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_group(2921);

  /**
   * generated from use.counter.page.console_groupcollapsed
   */
  /**
   * Whether a page called called console.groupCollapsed. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupcollapsed(2922);

  /**
   * generated from use.counter.page.console_groupend
   */
  /**
   * Whether a page called called console.groupEnd. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupend(2923);

  /**
   * generated from use.counter.page.console_info
   */
  /**
   * Whether a page called called console.info. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_info(2924);

  /**
   * generated from use.counter.page.console_log
   */
  /**
   * Whether a page called called console.log. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_log(2925);

  /**
   * generated from use.counter.page.console_profile
   */
  /**
   * Whether a page called called console.profile. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profile(2926);

  /**
   * generated from use.counter.page.console_profileend
   */
  /**
   * Whether a page called called console.profileEnd. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profileend(2927);

  /**
   * generated from use.counter.page.console_table
   */
  /**
   * Whether a page called called console.table. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_table(2928);

  /**
   * generated from use.counter.page.console_time
   */
  /**
   * Whether a page called called console.time. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_time(2929);

  /**
   * generated from use.counter.page.console_timeend
   */
  /**
   * Whether a page called called console.timeEnd. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timeend(2930);

  /**
   * generated from use.counter.page.console_timelog
   */
  /**
   * Whether a page called called console.timeLog. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timelog(2931);

  /**
   * generated from use.counter.page.console_timestamp
   */
  /**
   * Whether a page called called console.timeStamp. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timestamp(2932);

  /**
   * generated from use.counter.page.console_trace
   */
  /**
   * Whether a page called called console.trace. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_trace(2933);

  /**
   * generated from use.counter.page.console_warn
   */
  /**
   * Whether a page called called console.warn. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_warn(2934);

  /**
   * generated from use.counter.page.customelementregistry_define
   */
  /**
   * Whether a page called called CustomElementRegistry.define. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric customelementregistry_define(2935);

  /**
   * generated from use.counter.page.customized_builtin
   */
  /**
   * Whether a page registers a customized built-in element. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric customized_builtin(2936);

  /**
   * generated from use.counter.page.datatransfer_addelement
   */
  /**
   * Whether a page called called DataTransfer.addElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_addelement(2937);

  /**
   * generated from use.counter.page.datatransfer_mozcleardataat
   */
  /**
   * Whether a page called called DataTransfer.mozClearDataAt. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcleardataat(2938);

  /**
   * generated from use.counter.page.datatransfer_mozcursor_getter
   */
  /**
   * Whether a page got DataTransfer.mozCursor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcursor_getter(2939);

  /**
   * generated from use.counter.page.datatransfer_mozcursor_setter
   */
  /**
   * Whether a page set DataTransfer.mozCursor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcursor_setter(2940);

  /**
   * generated from use.counter.page.datatransfer_mozgetdataat
   */
  /**
   * Whether a page called called DataTransfer.mozGetDataAt. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozgetdataat(2941);

  /**
   * generated from use.counter.page.datatransfer_mozitemcount_getter
   */
  /**
   * Whether a page got DataTransfer.mozItemCount. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozitemcount_getter(2942);

  /**
   * generated from use.counter.page.datatransfer_mozitemcount_setter
   */
  /**
   * Whether a page set DataTransfer.mozItemCount. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozitemcount_setter(2943);

  /**
   * generated from use.counter.page.datatransfer_mozsetdataat
   */
  /**
   * Whether a page called called DataTransfer.mozSetDataAt. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsetdataat(2944);

  /**
   * generated from use.counter.page.datatransfer_mozsourcenode_getter
   */
  /**
   * Whether a page got DataTransfer.mozSourceNode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsourcenode_getter(2945);

  /**
   * generated from use.counter.page.datatransfer_mozsourcenode_setter
   */
  /**
   * Whether a page set DataTransfer.mozSourceNode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsourcenode_setter(2946);

  /**
   * generated from use.counter.page.datatransfer_moztypesat
   */
  /**
   * Whether a page called called DataTransfer.mozTypesAt. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_moztypesat(2947);

  /**
   * generated from use.counter.page.datatransfer_mozusercancelled_getter
   */
  /**
   * Whether a page got DataTransfer.mozUserCancelled. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozusercancelled_getter(2948);

  /**
   * generated from use.counter.page.datatransfer_mozusercancelled_setter
   */
  /**
   * Whether a page set DataTransfer.mozUserCancelled. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozusercancelled_setter(2949);

  /**
   * generated from use.counter.page.datatransferitem_webkitgetasentry
   */
  /**
   * Whether a page called called DataTransferItem.webkitGetAsEntry. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransferitem_webkitgetasentry(2950);

  /**
   * generated from use.counter.page.document_caretrangefrompoint
   */
  /**
   * Whether a page called called Document.caretRangeFromPoint. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_caretrangefrompoint(2951);

  /**
   * generated from use.counter.page.document_exec_command_content_read_only
   */
  /**
   * Whether a page calls execCommand with contentReadOnly. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_exec_command_content_read_only(2952);

  /**
   * generated from use.counter.page.document_exitpictureinpicture
   */
  /**
   * Whether a page called called Document.exitPictureInPicture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_exitpictureinpicture(2953);

  /**
   * generated from use.counter.page.document_featurepolicy
   */
  /**
   * Whether a page called called Document.featurePolicy. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_featurepolicy(2954);

  /**
   * generated from use.counter.page.document_mozsetimageelement
   */
  /**
   * Whether a page called called Document.mozSetImageElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_mozsetimageelement(2955);

  /**
   * generated from use.counter.page.document_onbeforecopy
   */
  /**
   * Whether a page called called Document.onbeforecopy. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforecopy(2956);

  /**
   * generated from use.counter.page.document_onbeforecut
   */
  /**
   * Whether a page called called Document.onbeforecut. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforecut(2957);

  /**
   * generated from use.counter.page.document_onbeforepaste
   */
  /**
   * Whether a page called called Document.onbeforepaste. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforepaste(2958);

  /**
   * generated from use.counter.page.document_oncancel
   */
  /**
   * Whether a page called called Document.oncancel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_oncancel(2959);

  /**
   * generated from use.counter.page.document_onfreeze
   */
  /**
   * Whether a page called called Document.onfreeze. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onfreeze(2960);

  /**
   * generated from use.counter.page.document_onmousewheel
   */
  /**
   * Whether a page called called Document.onmousewheel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onmousewheel(2961);

  /**
   * generated from use.counter.page.document_onresume
   */
  /**
   * Whether a page called called Document.onresume. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onresume(2962);

  /**
   * generated from use.counter.page.document_onsearch
   */
  /**
   * Whether a page called called Document.onsearch. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onsearch(2963);

  /**
   * generated from use.counter.page.document_onwebkitfullscreenchange
   */
  /**
   * Whether a page called called Document.onwebkitfullscreenchange. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onwebkitfullscreenchange(2964);

  /**
   * generated from use.counter.page.document_onwebkitfullscreenerror
   */
  /**
   * Whether a page called called Document.onwebkitfullscreenerror. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onwebkitfullscreenerror(2965);

  /**
   * generated from use.counter.page.document_open
   */
  /**
   * Whether a page calls document.open in a way that creates a new Window object.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric document_open(2966);

  /**
   * generated from use.counter.page.document_pictureinpictureelement
   */
  /**
   * Whether a page called called Document.pictureInPictureElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_pictureinpictureelement(2967);

  /**
   * generated from use.counter.page.document_pictureinpictureenabled
   */
  /**
   * Whether a page called called Document.pictureInPictureEnabled. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_pictureinpictureenabled(2968);

  /**
   * generated from use.counter.page.document_query_command_state_or_value_content_read_only
   */
  /**
   * Whether a page calls queryCommandState or queryCommandValue with
     * contentReadOnly. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_state_or_value_content_read_only(2969);

  /**
   * generated from use.counter.page.document_query_command_state_or_value_insert_br_on_return
   */
  /**
   * Whether a page calls queryCommandState or queryCommandValue with
     * insertBrOnReturn. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_state_or_value_insert_br_on_return(2970);

  /**
   * generated from use.counter.page.document_query_command_supported_or_enabled_content_read_only
   */
  /**
   * Whether a page calls queryCommandSupported or queryCommandEnabled with
     * contentReadOnly. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_supported_or_enabled_content_read_only(2971);

  /**
   * generated from use.counter.page.document_query_command_supported_or_enabled_insert_br_on_return
   */
  /**
   * Whether a page calls queryCommandSupported or queryCommandEnabled with
     * insertBrOnReturn. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_supported_or_enabled_insert_br_on_return(2972);

  /**
   * generated from use.counter.page.document_registerelement
   */
  /**
   * Whether a page called called Document.registerElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_registerelement(2973);

  /**
   * generated from use.counter.page.document_wasdiscarded
   */
  /**
   * Whether a page called called Document.wasDiscarded. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_wasdiscarded(2974);

  /**
   * generated from use.counter.page.document_webkitcancelfullscreen
   */
  /**
   * Whether a page called called Document.webkitCancelFullScreen. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitcancelfullscreen(2975);

  /**
   * generated from use.counter.page.document_webkitcurrentfullscreenelement
   */
  /**
   * Whether a page called called Document.webkitCurrentFullScreenElement. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric document_webkitcurrentfullscreenelement(2976);

  /**
   * generated from use.counter.page.document_webkitexitfullscreen
   */
  /**
   * Whether a page called called Document.webkitExitFullscreen. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitexitfullscreen(2977);

  /**
   * generated from use.counter.page.document_webkitfullscreenelement
   */
  /**
   * Whether a page called called Document.webkitFullscreenElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitfullscreenelement(2978);

  /**
   * generated from use.counter.page.document_webkitfullscreenenabled
   */
  /**
   * Whether a page called called Document.webkitFullscreenEnabled. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitfullscreenenabled(2979);

  /**
   * generated from use.counter.page.document_webkithidden
   */
  /**
   * Whether a page called called Document.webkitHidden. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkithidden(2980);

  /**
   * generated from use.counter.page.document_webkitisfullscreen
   */
  /**
   * Whether a page called called Document.webkitIsFullScreen. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitisfullscreen(2981);

  /**
   * generated from use.counter.page.document_webkitvisibilitystate
   */
  /**
   * Whether a page called called Document.webkitVisibilityState. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitvisibilitystate(2982);

  /**
   * generated from use.counter.page.document_xmlencoding
   */
  /**
   * Whether a page called called Document.xmlEncoding. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlencoding(2983);

  /**
   * generated from use.counter.page.document_xmlstandalone
   */
  /**
   * Whether a page called called Document.xmlStandalone. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlstandalone(2984);

  /**
   * generated from use.counter.page.document_xmlversion
   */
  /**
   * Whether a page called called Document.xmlVersion. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlversion(2985);

  /**
   * generated from use.counter.page.domparser_parsefromstring
   */
  /**
   * Whether a page called called DOMParser.parseFromString. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domparser_parsefromstring(2986);

  /**
   * generated from use.counter.page.element_attachshadow
   */
  /**
   * Whether a page called called Element.attachShadow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_attachshadow(2987);

  /**
   * generated from use.counter.page.element_computedstylemap
   */
  /**
   * Whether a page called called Element.computedStyleMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_computedstylemap(2988);

  /**
   * generated from use.counter.page.element_onmousewheel
   */
  /**
   * Whether a page called called Element.onmousewheel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_onmousewheel(2989);

  /**
   * generated from use.counter.page.element_releasecapture
   */
  /**
   * Whether a page called called Element.releaseCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_releasecapture(2990);

  /**
   * generated from use.counter.page.element_releasepointercapture
   */
  /**
   * Whether a page called called Element.releasePointerCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_releasepointercapture(2991);

  /**
   * generated from use.counter.page.element_scrollintoviewifneeded
   */
  /**
   * Whether a page called called Element.scrollIntoViewIfNeeded. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_scrollintoviewifneeded(2992);

  /**
   * generated from use.counter.page.element_setcapture
   */
  /**
   * Whether a page called called Element.setCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_setcapture(2993);

  /**
   * generated from use.counter.page.element_sethtml
   */
  /**
   * Whether a page called called Element.setHTML. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_sethtml(2994);

  /**
   * generated from use.counter.page.element_setpointercapture
   */
  /**
   * Whether a page called called Element.setPointerCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_setpointercapture(2995);

  /**
   * generated from use.counter.page.enumerate_devices_insec
   */
  /**
   * Whether a page calls MediaDevices.enumerateDevices from an insecure context.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric enumerate_devices_insec(2996);

  /**
   * generated from use.counter.page.enumerate_devices_unfocused
   */
  /**
   * Whether a page calls MediaDevices.enumerateDevices from a unfocused document.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric enumerate_devices_unfocused(2997);

  /**
   * generated from use.counter.page.fe_blend
   */
  /**
   * Whether a page uses the feBlend SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_blend(2998);

  /**
   * generated from use.counter.page.fe_color_matrix
   */
  /**
   * Whether a page uses the feColorMatrix SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_color_matrix(2999);

  /**
   * generated from use.counter.page.fe_component_transfer
   */
  /**
   * Whether a page uses the feComponentTransfer SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_component_transfer(3000);

  /**
   * generated from use.counter.page.fe_composite
   */
  /**
   * Whether a page uses the feComposite SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_composite(3001);

  /**
   * generated from use.counter.page.fe_convolve_matrix
   */
  /**
   * Whether a page uses the feConvolveMatrix SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_convolve_matrix(3002);

  /**
   * generated from use.counter.page.fe_diffuse_lighting
   */
  /**
   * Whether a page uses the feDiffuseLighting SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_diffuse_lighting(3003);

  /**
   * generated from use.counter.page.fe_displacement_map
   */
  /**
   * Whether a page uses the feDisplacementMap SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_displacement_map(3004);

  /**
   * generated from use.counter.page.fe_flood
   */
  /**
   * Whether a page uses the feFlood SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_flood(3005);

  /**
   * generated from use.counter.page.fe_gaussian_blur
   */
  /**
   * Whether a page uses the feGaussianBlur SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_gaussian_blur(3006);

  /**
   * generated from use.counter.page.fe_image
   */
  /**
   * Whether a page uses the feImage SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_image(3007);

  /**
   * generated from use.counter.page.fe_merge
   */
  /**
   * Whether a page uses the feMerge SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_merge(3008);

  /**
   * generated from use.counter.page.fe_morphology
   */
  /**
   * Whether a page uses the feMorphology SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_morphology(3009);

  /**
   * generated from use.counter.page.fe_offset
   */
  /**
   * Whether a page uses the feOffset SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_offset(3010);

  /**
   * generated from use.counter.page.fe_specular_lighting
   */
  /**
   * Whether a page uses the feSpecularLighting SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_specular_lighting(3011);

  /**
   * generated from use.counter.page.fe_tile
   */
  /**
   * Whether a page uses the feTile SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_tile(3012);

  /**
   * generated from use.counter.page.fe_turbulence
   */
  /**
   * Whether a page uses the feTurbulence SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_turbulence(3013);

  /**
   * generated from use.counter.page.filtered_cross_origin_iframe
   */
  /**
   * Whether a page cross-origin <iframe> within a CSS/SVG filter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric filtered_cross_origin_iframe(3014);

  /**
   * generated from use.counter.page.get_user_media_insec
   */
  /**
   * Whether a page calls MediaDevices.getUserMedia from an insecure context.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric get_user_media_insec(3015);

  /**
   * generated from use.counter.page.get_user_media_unfocused
   */
  /**
   * Whether a page calls MediaDevices.getUserMedia from an unfocused document.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric get_user_media_unfocused(3016);

  /**
   * generated from use.counter.page.htmlbuttonelement_popovertargetaction
   */
  /**
   * Whether a page called called HTMLButtonElement.popoverTargetAction. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlbuttonelement_popovertargetaction(3017);

  /**
   * generated from use.counter.page.htmlbuttonelement_popovertargetelement
   */
  /**
   * Whether a page called called HTMLButtonElement.popoverTargetElement. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlbuttonelement_popovertargetelement(3018);

  /**
   * generated from use.counter.page.htmldialogelement_show
   */
  /**
   * Whether a page called called HTMLDialogElement.show. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmldialogelement_show(3019);

  /**
   * generated from use.counter.page.htmldocument_named_getter_hit
   */
  /**
   * Whether a page calls to the named getter on HTMLDocument that find something
     * via the name lookup. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmldocument_named_getter_hit(3020);

  /**
   * generated from use.counter.page.htmlelement_attributestylemap
   */
  /**
   * Whether a page called called HTMLElement.attributeStyleMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_attributestylemap(3021);

  /**
   * generated from use.counter.page.htmlelement_hidepopover
   */
  /**
   * Whether a page called called HTMLElement.hidePopover. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_hidepopover(3022);

  /**
   * generated from use.counter.page.htmlelement_popover
   */
  /**
   * Whether a page called called HTMLElement.popover. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_popover(3023);

  /**
   * generated from use.counter.page.htmlelement_showpopover
   */
  /**
   * Whether a page called called HTMLElement.showPopover. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_showpopover(3024);

  /**
   * generated from use.counter.page.htmlelement_togglepopover
   */
  /**
   * Whether a page called called HTMLElement.togglePopover. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_togglepopover(3025);

  /**
   * generated from use.counter.page.htmliframeelement_loading
   */
  /**
   * Whether a page called called HTMLIFrameElement.loading. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmliframeelement_loading(3026);

  /**
   * generated from use.counter.page.htmlinputelement_capture
   */
  /**
   * Whether a page called called HTMLInputElement.capture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_capture(3027);

  /**
   * generated from use.counter.page.htmlinputelement_incremental
   */
  /**
   * Whether a page called called HTMLInputElement.incremental. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_incremental(3028);

  /**
   * generated from use.counter.page.htmlinputelement_onsearch
   */
  /**
   * Whether a page called called HTMLInputElement.onsearch. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_onsearch(3029);

  /**
   * generated from use.counter.page.htmlinputelement_popovertargetaction
   */
  /**
   * Whether a page called called HTMLInputElement.popoverTargetAction. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlinputelement_popovertargetaction(3030);

  /**
   * generated from use.counter.page.htmlinputelement_popovertargetelement
   */
  /**
   * Whether a page called called HTMLInputElement.popoverTargetElement. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlinputelement_popovertargetelement(3031);

  /**
   * generated from use.counter.page.htmlinputelement_webkitdirectory
   */
  /**
   * Whether a page called called HTMLInputElement.webkitdirectory. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_webkitdirectory(3032);

  /**
   * generated from use.counter.page.htmlinputelement_webkitentries
   */
  /**
   * Whether a page called called HTMLInputElement.webkitEntries. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_webkitentries(3033);

  /**
   * generated from use.counter.page.htmlmediaelement_disableremoteplayback
   */
  /**
   * Whether a page called called HTMLMediaElement.disableRemotePlayback. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlmediaelement_disableremoteplayback(3034);

  /**
   * generated from use.counter.page.htmlmediaelement_remote
   */
  /**
   * Whether a page called called HTMLMediaElement.remote. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlmediaelement_remote(3035);

  /**
   * generated from use.counter.page.htmlvideoelement_cancelvideoframecallback
   */
  /**
   * Whether a page called called HTMLVideoElement.cancelVideoFrameCallback. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_cancelvideoframecallback(3036);

  /**
   * generated from use.counter.page.htmlvideoelement_disablepictureinpicture
   */
  /**
   * Whether a page called called HTMLVideoElement.disablePictureInPicture. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_disablepictureinpicture(3037);

  /**
   * generated from use.counter.page.htmlvideoelement_onenterpictureinpicture
   */
  /**
   * Whether a page called called HTMLVideoElement.onenterpictureinpicture. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_onenterpictureinpicture(3038);

  /**
   * generated from use.counter.page.htmlvideoelement_onleavepictureinpicture
   */
  /**
   * Whether a page called called HTMLVideoElement.onleavepictureinpicture. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_onleavepictureinpicture(3039);

  /**
   * generated from use.counter.page.htmlvideoelement_playsinline
   */
  /**
   * Whether a page called called HTMLVideoElement.playsInline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_playsinline(3040);

  /**
   * generated from use.counter.page.htmlvideoelement_requestpictureinpicture
   */
  /**
   * Whether a page called called HTMLVideoElement.requestPictureInPicture. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_requestpictureinpicture(3041);

  /**
   * generated from use.counter.page.htmlvideoelement_requestvideoframecallback
   */
  /**
   * Whether a page called called HTMLVideoElement.requestVideoFrameCallback.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_requestvideoframecallback(3042);

  /**
   * generated from use.counter.page.imagedata_colorspace
   */
  /**
   * Whether a page called called ImageData.colorSpace. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric imagedata_colorspace(3043);

  /**
   * generated from use.counter.page.js_asmjs
   */
  /**
   * Whether a page uses asm.js. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric js_asmjs(3044);

  /**
   * generated from use.counter.page.js_is_htmldda_fuse
   */
  /**
   * Whether a page has used the document.all getter (popping the EmulatesUndefined
     * Fuse). Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric js_is_htmldda_fuse(3045);

  /**
   * generated from use.counter.page.js_optimize_get_iterator_fuse
   */
  /**
   * Whether a page has modified any builtins such that the GetIterator fuse is
     * popped. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric js_optimize_get_iterator_fuse(3046);

  /**
   * generated from use.counter.page.js_wasm
   */
  /**
   * Whether a page uses WebAssembly. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric js_wasm(3047);

  /**
   * generated from use.counter.page.js_wasm_legacy_exceptions
   */
  /**
   * Whether a page uses WebAssembly legacy exception-handling. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric js_wasm_legacy_exceptions(3048);

  /**
   * generated from use.counter.page.location_ancestororigins
   */
  /**
   * Whether a page called called Location.ancestorOrigins. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric location_ancestororigins(3049);

  /**
   * generated from use.counter.page.mediadevices_enumeratedevices
   */
  /**
   * Whether a page called called MediaDevices.enumerateDevices. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_enumeratedevices(3050);

  /**
   * generated from use.counter.page.mediadevices_getdisplaymedia
   */
  /**
   * Whether a page called called MediaDevices.getDisplayMedia. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_getdisplaymedia(3051);

  /**
   * generated from use.counter.page.mediadevices_getusermedia
   */
  /**
   * Whether a page called called MediaDevices.getUserMedia. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_getusermedia(3052);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_audio_failure
   */
  /**
   * Whether a page includes a mixed content audio element that does not load..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_audio_failure(3053);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_audio_success
   */
  /**
   * Whether a page includes a mixed content audio element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_audio_success(3054);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_image_failure
   */
  /**
   * Whether a page includes a mixed content img element that does not load..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_image_failure(3055);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_image_success
   */
  /**
   * Whether a page includes a mixed content img element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_image_success(3056);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_video_failure
   */
  /**
   * Whether a page includes a mixed content video element that does not laod..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_video_failure(3057);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_video_success
   */
  /**
   * Whether a page includes a mixed content video element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_video_success(3058);

  /**
   * generated from use.counter.page.mixed_content_upgraded_audio_failure
   */
  /**
   * Whether a page includes a mixed content audio element that does not load..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_audio_failure(3059);

  /**
   * generated from use.counter.page.mixed_content_upgraded_audio_success
   */
  /**
   * Whether a page includes a mixed content audio element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_audio_success(3060);

  /**
   * generated from use.counter.page.mixed_content_upgraded_image_failure
   */
  /**
   * Whether a page includes a mixed content img element that does not load..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_image_failure(3061);

  /**
   * generated from use.counter.page.mixed_content_upgraded_image_success
   */
  /**
   * Whether a page includes a mixed content img element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_image_success(3062);

  /**
   * generated from use.counter.page.mixed_content_upgraded_video_failure
   */
  /**
   * Whether a page includes a mixed content video element that does not laod..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_video_failure(3063);

  /**
   * generated from use.counter.page.mixed_content_upgraded_video_success
   */
  /**
   * Whether a page includes a mixed content video element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_video_success(3064);

  /**
   * generated from use.counter.page.mls_deriveexporter
   */
  /**
   * Whether a page called called MLS.deriveExporter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_deriveexporter(3065);

  /**
   * generated from use.counter.page.mls_generatecredentialbasic
   */
  /**
   * Whether a page called called MLS.generateCredentialBasic. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatecredentialbasic(3066);

  /**
   * generated from use.counter.page.mls_generatekeypackage
   */
  /**
   * Whether a page called called MLS.generateKeyPackage. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatekeypackage(3067);

  /**
   * generated from use.counter.page.mls_generatesignaturekeypair
   */
  /**
   * Whether a page called called MLS.generateSignatureKeypair. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatesignaturekeypair(3068);

  /**
   * generated from use.counter.page.mls_groupadd
   */
  /**
   * Whether a page called called MLS.groupAdd. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupadd(3069);

  /**
   * generated from use.counter.page.mls_groupclose
   */
  /**
   * Whether a page called called MLS.groupClose. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupclose(3070);

  /**
   * generated from use.counter.page.mls_groupcreate
   */
  /**
   * Whether a page called called MLS.groupCreate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupcreate(3071);

  /**
   * generated from use.counter.page.mls_groupjoin
   */
  /**
   * Whether a page called called MLS.groupJoin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupjoin(3072);

  /**
   * generated from use.counter.page.mls_groupmembers
   */
  /**
   * Whether a page called called MLS.groupMembers. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupmembers(3073);

  /**
   * generated from use.counter.page.mls_groupproposeadd
   */
  /**
   * Whether a page called called MLS.groupProposeAdd. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupproposeadd(3074);

  /**
   * generated from use.counter.page.mls_groupproposeremove
   */
  /**
   * Whether a page called called MLS.groupProposeRemove. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupproposeremove(3075);

  /**
   * generated from use.counter.page.mls_groupremove
   */
  /**
   * Whether a page called called MLS.groupRemove. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupremove(3076);

  /**
   * generated from use.counter.page.mls_receive
   */
  /**
   * Whether a page called called MLS.receive. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_receive(3077);

  /**
   * generated from use.counter.page.mls_send
   */
  /**
   * Whether a page called called MLS.send. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_send(3078);

  /**
   * generated from use.counter.page.mls_statedelete
   */
  /**
   * Whether a page called called MLS.stateDelete. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_statedelete(3079);

  /**
   * generated from use.counter.page.mls_statedeletegroup
   */
  /**
   * Whether a page called called MLS.stateDeleteGroup. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_statedeletegroup(3080);

  /**
   * generated from use.counter.page.moz_get_user_media_insec
   */
  /**
   * Whether a page calls Navigator.mozGetUserMedia from an insecure context.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric moz_get_user_media_insec(3081);

  /**
   * generated from use.counter.page.navigator_canshare
   */
  /**
   * Whether a page called called Navigator.canShare. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_canshare(3082);

  /**
   * generated from use.counter.page.navigator_clearappbadge
   */
  /**
   * Whether a page called called Navigator.clearAppBadge. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_clearappbadge(3083);

  /**
   * generated from use.counter.page.navigator_mozgetusermedia
   */
  /**
   * Whether a page called called Navigator.mozGetUserMedia. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_mozgetusermedia(3084);

  /**
   * generated from use.counter.page.navigator_setappbadge
   */
  /**
   * Whether a page called called Navigator.setAppBadge. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_setappbadge(3085);

  /**
   * generated from use.counter.page.navigator_share
   */
  /**
   * Whether a page called called Navigator.share. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_share(3086);

  /**
   * generated from use.counter.page.navigator_useractivation
   */
  /**
   * Whether a page called called Navigator.userActivation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_useractivation(3087);

  /**
   * generated from use.counter.page.navigator_wakelock
   */
  /**
   * Whether a page called called Navigator.wakeLock. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_wakelock(3088);

  /**
   * generated from use.counter.page.ondommousescroll
   */
  /**
   * Whether a page sets DOMMouseScroll event listener. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric ondommousescroll(3089);

  /**
   * generated from use.counter.page.onmozmousepixelscroll
   */
  /**
   * Whether a page sets MozMousePixelScroll event listener. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onmozmousepixelscroll(3090);

  /**
   * generated from use.counter.page.onoverflow
   */
  /**
   * Whether a page sets an element onoverflow event listener. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onoverflow(3091);

  /**
   * generated from use.counter.page.onunderflow
   */
  /**
   * Whether a page sets an element onunderflow event listener. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onunderflow(3092);

  /**
   * generated from use.counter.page.percentage_stroke_width_in_svg
   */
  /**
   * Whether a page whether percentage stroke-width is used in SVG elements
     * (excluding <text>). Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric percentage_stroke_width_in_svg(3093);

  /**
   * generated from use.counter.page.percentage_stroke_width_in_svgtext
   */
  /**
   * Whether a page whether percentage stroke-width is used in SVG <text>. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric percentage_stroke_width_in_svgtext(3094);

  /**
   * generated from use.counter.page.private_browsing_caches_delete
   */
  /**
   * Whether a page calls caches.delete in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_delete(3095);

  /**
   * generated from use.counter.page.private_browsing_caches_has
   */
  /**
   * Whether a page calls caches.has in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_has(3096);

  /**
   * generated from use.counter.page.private_browsing_caches_keys
   */
  /**
   * Whether a page calls caches.keys in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_keys(3097);

  /**
   * generated from use.counter.page.private_browsing_caches_match
   */
  /**
   * Whether a page calls caches.match in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_match(3098);

  /**
   * generated from use.counter.page.private_browsing_caches_open
   */
  /**
   * Whether a page calls caches.open in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_open(3099);

  /**
   * generated from use.counter.page.private_browsing_idbfactory_delete_database
   */
  /**
   * Whether a page calls indexedDB.deleteDatabase in Private Browsing Mode. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_delete_database(3100);

  /**
   * generated from use.counter.page.private_browsing_idbfactory_open
   */
  /**
   * Whether a page calls indexedDB.open in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_open(3101);

  /**
   * generated from use.counter.page.private_browsing_navigator_service_worker
   */
  /**
   * Whether a page accesses navigator.serviceWorker in Private Browsing Mode.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_navigator_service_worker(3102);

  /**
   * generated from use.counter.page.pushmanager_subscribe
   */
  /**
   * Whether a page called called PushManager.subscribe. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushmanager_subscribe(3103);

  /**
   * generated from use.counter.page.pushsubscription_unsubscribe
   */
  /**
   * Whether a page called called PushSubscription.unsubscribe. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushsubscription_unsubscribe(3104);

  /**
   * generated from use.counter.page.range_createcontextualfragment
   */
  /**
   * Whether a page called called Range.createContextualFragment. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric range_createcontextualfragment(3105);

  /**
   * generated from use.counter.page.sanitizer_constructor
   */
  /**
   * Whether a page called called Sanitizer.constructor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sanitizer_constructor(3106);

  /**
   * generated from use.counter.page.sanitizer_sanitize
   */
  /**
   * Whether a page called called Sanitizer.sanitize. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sanitizer_sanitize(3107);

  /**
   * generated from use.counter.page.scheduler_posttask
   */
  /**
   * Whether a page called called Scheduler.postTask. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric scheduler_posttask(3108);

  /**
   * generated from use.counter.page.shadowroot_pictureinpictureelement
   */
  /**
   * Whether a page called called ShadowRoot.pictureInPictureElement. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric shadowroot_pictureinpictureelement(3109);

  /**
   * generated from use.counter.page.svgsvgelement_currentscale_getter
   */
  /**
   * Whether a page got SVGSVGElement.currentScale. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_currentscale_getter(3110);

  /**
   * generated from use.counter.page.svgsvgelement_currentscale_setter
   */
  /**
   * Whether a page set SVGSVGElement.currentScale. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_currentscale_setter(3111);

  /**
   * generated from use.counter.page.svgsvgelement_getelementbyid
   */
  /**
   * Whether a page called called SVGSVGElement.getElementById. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_getelementbyid(3112);

  /**
   * generated from use.counter.page.window_absoluteorientationsensor
   */
  /**
   * Whether a page called called Window.AbsoluteOrientationSensor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_absoluteorientationsensor(3113);

  /**
   * generated from use.counter.page.window_accelerometer
   */
  /**
   * Whether a page called called Window.Accelerometer. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_accelerometer(3114);

  /**
   * generated from use.counter.page.window_backgroundfetchmanager
   */
  /**
   * Whether a page called called Window.BackgroundFetchManager. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchmanager(3115);

  /**
   * generated from use.counter.page.window_backgroundfetchrecord
   */
  /**
   * Whether a page called called Window.BackgroundFetchRecord. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchrecord(3116);

  /**
   * generated from use.counter.page.window_backgroundfetchregistration
   */
  /**
   * Whether a page called called Window.BackgroundFetchRegistration. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchregistration(3117);

  /**
   * generated from use.counter.page.window_beforeinstallpromptevent
   */
  /**
   * Whether a page called called Window.BeforeInstallPromptEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_beforeinstallpromptevent(3118);

  /**
   * generated from use.counter.page.window_bluetooth
   */
  /**
   * Whether a page called called Window.Bluetooth. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetooth(3119);

  /**
   * generated from use.counter.page.window_bluetoothcharacteristicproperties
   */
  /**
   * Whether a page called called Window.BluetoothCharacteristicProperties. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_bluetoothcharacteristicproperties(3120);

  /**
   * generated from use.counter.page.window_bluetoothdevice
   */
  /**
   * Whether a page called called Window.BluetoothDevice. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothdevice(3121);

  /**
   * generated from use.counter.page.window_bluetoothremotegattcharacteristic
   */
  /**
   * Whether a page called called Window.BluetoothRemoteGATTCharacteristic. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattcharacteristic(3122);

  /**
   * generated from use.counter.page.window_bluetoothremotegattdescriptor
   */
  /**
   * Whether a page called called Window.BluetoothRemoteGATTDescriptor. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattdescriptor(3123);

  /**
   * generated from use.counter.page.window_bluetoothremotegattserver
   */
  /**
   * Whether a page called called Window.BluetoothRemoteGATTServer. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattserver(3124);

  /**
   * generated from use.counter.page.window_bluetoothremotegattservice
   */
  /**
   * Whether a page called called Window.BluetoothRemoteGATTService. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattservice(3125);

  /**
   * generated from use.counter.page.window_bluetoothuuid
   */
  /**
   * Whether a page called called Window.BluetoothUUID. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothuuid(3126);

  /**
   * generated from use.counter.page.window_canvascapturemediastreamtrack
   */
  /**
   * Whether a page called called Window.CanvasCaptureMediaStreamTrack. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_canvascapturemediastreamtrack(3127);

  /**
   * generated from use.counter.page.window_chrome
   */
  /**
   * Whether a page called called Window.chrome. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_chrome(3128);

  /**
   * generated from use.counter.page.window_clipboarditem
   */
  /**
   * Whether a page called called Window.ClipboardItem. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_clipboarditem(3129);

  /**
   * generated from use.counter.page.window_cssimagevalue
   */
  /**
   * Whether a page called called Window.CSSImageValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssimagevalue(3130);

  /**
   * generated from use.counter.page.window_csskeywordvalue
   */
  /**
   * Whether a page called called Window.CSSKeywordValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csskeywordvalue(3131);

  /**
   * generated from use.counter.page.window_cssmathclamp
   */
  /**
   * Whether a page called called Window.CSSMathClamp. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathclamp(3132);

  /**
   * generated from use.counter.page.window_cssmathinvert
   */
  /**
   * Whether a page called called Window.CSSMathInvert. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathinvert(3133);

  /**
   * generated from use.counter.page.window_cssmathmax
   */
  /**
   * Whether a page called called Window.CSSMathMax. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathmax(3134);

  /**
   * generated from use.counter.page.window_cssmathmin
   */
  /**
   * Whether a page called called Window.CSSMathMin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathmin(3135);

  /**
   * generated from use.counter.page.window_cssmathnegate
   */
  /**
   * Whether a page called called Window.CSSMathNegate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathnegate(3136);

  /**
   * generated from use.counter.page.window_cssmathproduct
   */
  /**
   * Whether a page called called Window.CSSMathProduct. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathproduct(3137);

  /**
   * generated from use.counter.page.window_cssmathsum
   */
  /**
   * Whether a page called called Window.CSSMathSum. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathsum(3138);

  /**
   * generated from use.counter.page.window_cssmathvalue
   */
  /**
   * Whether a page called called Window.CSSMathValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathvalue(3139);

  /**
   * generated from use.counter.page.window_cssmatrixcomponent
   */
  /**
   * Whether a page called called Window.CSSMatrixComponent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmatrixcomponent(3140);

  /**
   * generated from use.counter.page.window_cssnumericarray
   */
  /**
   * Whether a page called called Window.CSSNumericArray. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssnumericarray(3141);

  /**
   * generated from use.counter.page.window_cssnumericvalue
   */
  /**
   * Whether a page called called Window.CSSNumericValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssnumericvalue(3142);

  /**
   * generated from use.counter.page.window_cssperspective
   */
  /**
   * Whether a page called called Window.CSSPerspective. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssperspective(3143);

  /**
   * generated from use.counter.page.window_csspositionvalue
   */
  /**
   * Whether a page called called Window.CSSPositionValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csspositionvalue(3144);

  /**
   * generated from use.counter.page.window_csspropertyrule
   */
  /**
   * Whether a page called called Window.CSSPropertyRule. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csspropertyrule(3145);

  /**
   * generated from use.counter.page.window_cssrotate
   */
  /**
   * Whether a page called called Window.CSSRotate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssrotate(3146);

  /**
   * generated from use.counter.page.window_cssscale
   */
  /**
   * Whether a page called called Window.CSSScale. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssscale(3147);

  /**
   * generated from use.counter.page.window_cssskew
   */
  /**
   * Whether a page called called Window.CSSSkew. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskew(3148);

  /**
   * generated from use.counter.page.window_cssskewx
   */
  /**
   * Whether a page called called Window.CSSSkewX. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskewx(3149);

  /**
   * generated from use.counter.page.window_cssskewy
   */
  /**
   * Whether a page called called Window.CSSSkewY. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskewy(3150);

  /**
   * generated from use.counter.page.window_cssstylevalue
   */
  /**
   * Whether a page called called Window.CSSStyleValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssstylevalue(3151);

  /**
   * generated from use.counter.page.window_csstransformcomponent
   */
  /**
   * Whether a page called called Window.CSSTransformComponent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstransformcomponent(3152);

  /**
   * generated from use.counter.page.window_csstransformvalue
   */
  /**
   * Whether a page called called Window.CSSTransformValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstransformvalue(3153);

  /**
   * generated from use.counter.page.window_csstranslate
   */
  /**
   * Whether a page called called Window.CSSTranslate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstranslate(3154);

  /**
   * generated from use.counter.page.window_cssunitvalue
   */
  /**
   * Whether a page called called Window.CSSUnitValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssunitvalue(3155);

  /**
   * generated from use.counter.page.window_cssunparsedvalue
   */
  /**
   * Whether a page called called Window.CSSUnparsedValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssunparsedvalue(3156);

  /**
   * generated from use.counter.page.window_cssvariablereferencevalue
   */
  /**
   * Whether a page called called Window.CSSVariableReferenceValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssvariablereferencevalue(3157);

  /**
   * generated from use.counter.page.window_defaultstatus
   */
  /**
   * Whether a page called called Window.defaultStatus. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_defaultstatus(3158);

  /**
   * generated from use.counter.page.window_devicemotioneventacceleration
   */
  /**
   * Whether a page called called Window.DeviceMotionEventAcceleration. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_devicemotioneventacceleration(3159);

  /**
   * generated from use.counter.page.window_devicemotioneventrotationrate
   */
  /**
   * Whether a page called called Window.DeviceMotionEventRotationRate. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_devicemotioneventrotationrate(3160);

  /**
   * generated from use.counter.page.window_domerror
   */
  /**
   * Whether a page called called Window.DOMError. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_domerror(3161);

  /**
   * generated from use.counter.page.window_encodedvideochunk
   */
  /**
   * Whether a page called called Window.EncodedVideoChunk. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_encodedvideochunk(3162);

  /**
   * generated from use.counter.page.window_enterpictureinpictureevent
   */
  /**
   * Whether a page called called Window.EnterPictureInPictureEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_enterpictureinpictureevent(3163);

  /**
   * generated from use.counter.page.window_external
   */
  /**
   * Whether a page called called Window.External. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_external(3164);

  /**
   * generated from use.counter.page.window_federatedcredential
   */
  /**
   * Whether a page called called Window.FederatedCredential. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_federatedcredential(3165);

  /**
   * generated from use.counter.page.window_gyroscope
   */
  /**
   * Whether a page called called Window.Gyroscope. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_gyroscope(3166);

  /**
   * generated from use.counter.page.window_htmlcontentelement
   */
  /**
   * Whether a page called called Window.HTMLContentElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_htmlcontentelement(3167);

  /**
   * generated from use.counter.page.window_htmlshadowelement
   */
  /**
   * Whether a page called called Window.HTMLShadowElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_htmlshadowelement(3168);

  /**
   * generated from use.counter.page.window_imagecapture
   */
  /**
   * Whether a page called called Window.ImageCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_imagecapture(3169);

  /**
   * generated from use.counter.page.window_inputdevicecapabilities
   */
  /**
   * Whether a page called called Window.InputDeviceCapabilities. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_inputdevicecapabilities(3170);

  /**
   * generated from use.counter.page.window_inputdeviceinfo
   */
  /**
   * Whether a page called called Window.InputDeviceInfo. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_inputdeviceinfo(3171);

  /**
   * generated from use.counter.page.window_keyboard
   */
  /**
   * Whether a page called called Window.Keyboard. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_keyboard(3172);

  /**
   * generated from use.counter.page.window_keyboardlayoutmap
   */
  /**
   * Whether a page called called Window.KeyboardLayoutMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_keyboardlayoutmap(3173);

  /**
   * generated from use.counter.page.window_linearaccelerationsensor
   */
  /**
   * Whether a page called called Window.LinearAccelerationSensor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_linearaccelerationsensor(3174);

  /**
   * generated from use.counter.page.window_mediasettingsrange
   */
  /**
   * Whether a page called called Window.MediaSettingsRange. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_mediasettingsrange(3175);

  /**
   * generated from use.counter.page.window_midiaccess
   */
  /**
   * Whether a page called called Window.MIDIAccess. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiaccess(3176);

  /**
   * generated from use.counter.page.window_midiconnectionevent
   */
  /**
   * Whether a page called called Window.MIDIConnectionEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiconnectionevent(3177);

  /**
   * generated from use.counter.page.window_midiinput
   */
  /**
   * Whether a page called called Window.MIDIInput. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiinput(3178);

  /**
   * generated from use.counter.page.window_midiinputmap
   */
  /**
   * Whether a page called called Window.MIDIInputMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiinputmap(3179);

  /**
   * generated from use.counter.page.window_midimessageevent
   */
  /**
   * Whether a page called called Window.MIDIMessageEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midimessageevent(3180);

  /**
   * generated from use.counter.page.window_midioutput
   */
  /**
   * Whether a page called called Window.MIDIOutput. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midioutput(3181);

  /**
   * generated from use.counter.page.window_midioutputmap
   */
  /**
   * Whether a page called called Window.MIDIOutputMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midioutputmap(3182);

  /**
   * generated from use.counter.page.window_midiport
   */
  /**
   * Whether a page called called Window.MIDIPort. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiport(3183);

  /**
   * generated from use.counter.page.window_networkinformation
   */
  /**
   * Whether a page called called Window.NetworkInformation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_networkinformation(3184);

  /**
   * generated from use.counter.page.window_offscreenbuffering
   */
  /**
   * Whether a page called called Window.offscreenBuffering. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_offscreenbuffering(3185);

  /**
   * generated from use.counter.page.window_onbeforeinstallprompt
   */
  /**
   * Whether a page called called Window.onbeforeinstallprompt. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onbeforeinstallprompt(3186);

  /**
   * generated from use.counter.page.window_oncancel
   */
  /**
   * Whether a page called called Window.oncancel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_oncancel(3187);

  /**
   * generated from use.counter.page.window_onmousewheel
   */
  /**
   * Whether a page called called Window.onmousewheel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onmousewheel(3188);

  /**
   * generated from use.counter.page.window_onorientationchange
   */
  /**
   * Whether a page called called Window.onorientationchange. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onorientationchange(3189);

  /**
   * generated from use.counter.page.window_onsearch
   */
  /**
   * Whether a page called called Window.onsearch. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onsearch(3190);

  /**
   * generated from use.counter.page.window_onselectionchange
   */
  /**
   * Whether a page called called Window.onselectionchange. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onselectionchange(3191);

  /**
   * generated from use.counter.page.window_open_empty_url
   */
  /**
   * Whether a page calls window.open with an empty url argument. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_open_empty_url(3192);

  /**
   * generated from use.counter.page.window_opendatabase
   */
  /**
   * Whether a page called called Window.openDatabase. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_opendatabase(3193);

  /**
   * generated from use.counter.page.window_orientation
   */
  /**
   * Whether a page called called Window.orientation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_orientation(3194);

  /**
   * generated from use.counter.page.window_orientationsensor
   */
  /**
   * Whether a page called called Window.OrientationSensor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_orientationsensor(3195);

  /**
   * generated from use.counter.page.window_overconstrainederror
   */
  /**
   * Whether a page called called Window.OverconstrainedError. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_overconstrainederror(3196);

  /**
   * generated from use.counter.page.window_passwordcredential
   */
  /**
   * Whether a page called called Window.PasswordCredential. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_passwordcredential(3197);

  /**
   * generated from use.counter.page.window_paymentaddress
   */
  /**
   * Whether a page called called Window.PaymentAddress. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentaddress(3198);

  /**
   * generated from use.counter.page.window_paymentinstruments
   */
  /**
   * Whether a page called called Window.PaymentInstruments. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentinstruments(3199);

  /**
   * generated from use.counter.page.window_paymentmanager
   */
  /**
   * Whether a page called called Window.PaymentManager. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentmanager(3200);

  /**
   * generated from use.counter.page.window_paymentmethodchangeevent
   */
  /**
   * Whether a page called called Window.PaymentMethodChangeEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentmethodchangeevent(3201);

  /**
   * generated from use.counter.page.window_paymentrequest
   */
  /**
   * Whether a page called called Window.PaymentRequest. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentrequest(3202);

  /**
   * generated from use.counter.page.window_paymentrequestupdateevent
   */
  /**
   * Whether a page called called Window.PaymentRequestUpdateEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentrequestupdateevent(3203);

  /**
   * generated from use.counter.page.window_paymentresponse
   */
  /**
   * Whether a page called called Window.PaymentResponse. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentresponse(3204);

  /**
   * generated from use.counter.page.window_performancelongtasktiming
   */
  /**
   * Whether a page called called Window.PerformanceLongTaskTiming. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_performancelongtasktiming(3205);

  /**
   * generated from use.counter.page.window_photocapabilities
   */
  /**
   * Whether a page called called Window.PhotoCapabilities. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_photocapabilities(3206);

  /**
   * generated from use.counter.page.window_pictureinpictureevent
   */
  /**
   * Whether a page called called Window.PictureInPictureEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_pictureinpictureevent(3207);

  /**
   * generated from use.counter.page.window_pictureinpicturewindow
   */
  /**
   * Whether a page called called Window.PictureInPictureWindow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_pictureinpicturewindow(3208);

  /**
   * generated from use.counter.page.window_presentation
   */
  /**
   * Whether a page called called Window.Presentation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentation(3209);

  /**
   * generated from use.counter.page.window_presentationavailability
   */
  /**
   * Whether a page called called Window.PresentationAvailability. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationavailability(3210);

  /**
   * generated from use.counter.page.window_presentationconnection
   */
  /**
   * Whether a page called called Window.PresentationConnection. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationconnection(3211);

  /**
   * generated from use.counter.page.window_presentationconnectionavailableevent
   */
  /**
   * Whether a page called called Window.PresentationConnectionAvailableEvent.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationconnectionavailableevent(3212);

  /**
   * generated from use.counter.page.window_presentationconnectioncloseevent
   */
  /**
   * Whether a page called called Window.PresentationConnectionCloseEvent. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_presentationconnectioncloseevent(3213);

  /**
   * generated from use.counter.page.window_presentationconnectionlist
   */
  /**
   * Whether a page called called Window.PresentationConnectionList. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationconnectionlist(3214);

  /**
   * generated from use.counter.page.window_presentationreceiver
   */
  /**
   * Whether a page called called Window.PresentationReceiver. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationreceiver(3215);

  /**
   * generated from use.counter.page.window_presentationrequest
   */
  /**
   * Whether a page called called Window.PresentationRequest. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationrequest(3216);

  /**
   * generated from use.counter.page.window_relativeorientationsensor
   */
  /**
   * Whether a page called called Window.RelativeOrientationSensor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_relativeorientationsensor(3217);

  /**
   * generated from use.counter.page.window_remoteplayback
   */
  /**
   * Whether a page called called Window.RemotePlayback. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_remoteplayback(3218);

  /**
   * generated from use.counter.page.window_report
   */
  /**
   * Whether a page called called Window.Report. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_report(3219);

  /**
   * generated from use.counter.page.window_reportbody
   */
  /**
   * Whether a page called called Window.ReportBody. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_reportbody(3220);

  /**
   * generated from use.counter.page.window_reportingobserver
   */
  /**
   * Whether a page called called Window.ReportingObserver. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_reportingobserver(3221);

  /**
   * generated from use.counter.page.window_rtcerror
   */
  /**
   * Whether a page called called Window.RTCError. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcerror(3222);

  /**
   * generated from use.counter.page.window_rtcerrorevent
   */
  /**
   * Whether a page called called Window.RTCErrorEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcerrorevent(3223);

  /**
   * generated from use.counter.page.window_rtcicetransport
   */
  /**
   * Whether a page called called Window.RTCIceTransport. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcicetransport(3224);

  /**
   * generated from use.counter.page.window_rtcpeerconnectioniceerrorevent
   */
  /**
   * Whether a page called called Window.RTCPeerConnectionIceErrorEvent. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_rtcpeerconnectioniceerrorevent(3225);

  /**
   * generated from use.counter.page.window_sensor
   */
  /**
   * Whether a page called called Window.Sensor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sensor(3226);

  /**
   * generated from use.counter.page.window_sensorerrorevent
   */
  /**
   * Whether a page called called Window.SensorErrorEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sensorerrorevent(3227);

  /**
   * generated from use.counter.page.window_sidebar_getter
   */
  /**
   * Whether a page got Window.sidebar. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sidebar_getter(3228);

  /**
   * generated from use.counter.page.window_sidebar_setter
   */
  /**
   * Whether a page set Window.sidebar. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sidebar_setter(3229);

  /**
   * generated from use.counter.page.window_speechrecognitionalternative
   */
  /**
   * Whether a page called called Window.SpeechRecognitionAlternative. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionalternative(3230);

  /**
   * generated from use.counter.page.window_speechrecognitionresult
   */
  /**
   * Whether a page called called Window.SpeechRecognitionResult. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionresult(3231);

  /**
   * generated from use.counter.page.window_speechrecognitionresultlist
   */
  /**
   * Whether a page called called Window.SpeechRecognitionResultList. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionresultlist(3232);

  /**
   * generated from use.counter.page.window_stylemedia
   */
  /**
   * Whether a page called called Window.styleMedia. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylemedia(3233);

  /**
   * generated from use.counter.page.window_stylepropertymap
   */
  /**
   * Whether a page called called Window.StylePropertyMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylepropertymap(3234);

  /**
   * generated from use.counter.page.window_stylepropertymapreadonly
   */
  /**
   * Whether a page called called Window.StylePropertyMapReadOnly. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylepropertymapreadonly(3235);

  /**
   * generated from use.counter.page.window_svgdiscardelement
   */
  /**
   * Whether a page called called Window.SVGDiscardElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_svgdiscardelement(3236);

  /**
   * generated from use.counter.page.window_syncmanager
   */
  /**
   * Whether a page called called Window.SyncManager. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_syncmanager(3237);

  /**
   * generated from use.counter.page.window_taskattributiontiming
   */
  /**
   * Whether a page called called Window.TaskAttributionTiming. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_taskattributiontiming(3238);

  /**
   * generated from use.counter.page.window_textevent
   */
  /**
   * Whether a page called called Window.TextEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_textevent(3239);

  /**
   * generated from use.counter.page.window_touch
   */
  /**
   * Whether a page called called Window.Touch. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touch(3240);

  /**
   * generated from use.counter.page.window_touchevent
   */
  /**
   * Whether a page called called Window.TouchEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touchevent(3241);

  /**
   * generated from use.counter.page.window_touchlist
   */
  /**
   * Whether a page called called Window.TouchList. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touchlist(3242);

  /**
   * generated from use.counter.page.window_usb
   */
  /**
   * Whether a page called called Window.USB. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usb(3243);

  /**
   * generated from use.counter.page.window_usbalternateinterface
   */
  /**
   * Whether a page called called Window.USBAlternateInterface. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbalternateinterface(3244);

  /**
   * generated from use.counter.page.window_usbconfiguration
   */
  /**
   * Whether a page called called Window.USBConfiguration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbconfiguration(3245);

  /**
   * generated from use.counter.page.window_usbconnectionevent
   */
  /**
   * Whether a page called called Window.USBConnectionEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbconnectionevent(3246);

  /**
   * generated from use.counter.page.window_usbdevice
   */
  /**
   * Whether a page called called Window.USBDevice. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbdevice(3247);

  /**
   * generated from use.counter.page.window_usbendpoint
   */
  /**
   * Whether a page called called Window.USBEndpoint. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbendpoint(3248);

  /**
   * generated from use.counter.page.window_usbinterface
   */
  /**
   * Whether a page called called Window.USBInterface. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbinterface(3249);

  /**
   * generated from use.counter.page.window_usbintransferresult
   */
  /**
   * Whether a page called called Window.USBInTransferResult. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbintransferresult(3250);

  /**
   * generated from use.counter.page.window_usbisochronousintransferpacket
   */
  /**
   * Whether a page called called Window.USBIsochronousInTransferPacket. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousintransferpacket(3251);

  /**
   * generated from use.counter.page.window_usbisochronousintransferresult
   */
  /**
   * Whether a page called called Window.USBIsochronousInTransferResult. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousintransferresult(3252);

  /**
   * generated from use.counter.page.window_usbisochronousouttransferpacket
   */
  /**
   * Whether a page called called Window.USBIsochronousOutTransferPacket. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousouttransferpacket(3253);

  /**
   * generated from use.counter.page.window_usbisochronousouttransferresult
   */
  /**
   * Whether a page called called Window.USBIsochronousOutTransferResult. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousouttransferresult(3254);

  /**
   * generated from use.counter.page.window_usbouttransferresult
   */
  /**
   * Whether a page called called Window.USBOutTransferResult. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbouttransferresult(3255);

  /**
   * generated from use.counter.page.window_useractivation
   */
  /**
   * Whether a page called called Window.UserActivation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_useractivation(3256);

  /**
   * generated from use.counter.page.window_videocolorspace
   */
  /**
   * Whether a page called called Window.VideoColorSpace. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videocolorspace(3257);

  /**
   * generated from use.counter.page.window_videodecoder
   */
  /**
   * Whether a page called called Window.VideoDecoder. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videodecoder(3258);

  /**
   * generated from use.counter.page.window_videoencoder
   */
  /**
   * Whether a page called called Window.VideoEncoder. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videoencoder(3259);

  /**
   * generated from use.counter.page.window_videoframe
   */
  /**
   * Whether a page called called Window.VideoFrame. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videoframe(3260);

  /**
   * generated from use.counter.page.window_wakelock
   */
  /**
   * Whether a page called called Window.WakeLock. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_wakelock(3261);

  /**
   * generated from use.counter.page.window_wakelocksentinel
   */
  /**
   * Whether a page called called Window.WakeLockSentinel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_wakelocksentinel(3262);

  /**
   * generated from use.counter.page.window_webkitcancelanimationframe
   */
  /**
   * Whether a page called called Window.webkitCancelAnimationFrame. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitcancelanimationframe(3263);

  /**
   * generated from use.counter.page.window_webkitmediastream
   */
  /**
   * Whether a page called called Window.webkitMediaStream. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitmediastream(3264);

  /**
   * generated from use.counter.page.window_webkitmutationobserver
   */
  /**
   * Whether a page called called Window.WebKitMutationObserver. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitmutationobserver(3265);

  /**
   * generated from use.counter.page.window_webkitrequestanimationframe
   */
  /**
   * Whether a page called called Window.webkitRequestAnimationFrame. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_webkitrequestanimationframe(3266);

  /**
   * generated from use.counter.page.window_webkitrequestfilesystem
   */
  /**
   * Whether a page called called Window.webkitRequestFileSystem. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitrequestfilesystem(3267);

  /**
   * generated from use.counter.page.window_webkitresolvelocalfilesystemurl
   */
  /**
   * Whether a page called called Window.webkitResolveLocalFileSystemURL. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_webkitresolvelocalfilesystemurl(3268);

  /**
   * generated from use.counter.page.window_webkitrtcpeerconnection
   */
  /**
   * Whether a page called called Window.webkitRTCPeerConnection. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitrtcpeerconnection(3269);

  /**
   * generated from use.counter.page.window_webkitspeechgrammar
   */
  /**
   * Whether a page called called Window.webkitSpeechGrammar. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechgrammar(3270);

  /**
   * generated from use.counter.page.window_webkitspeechgrammarlist
   */
  /**
   * Whether a page called called Window.webkitSpeechGrammarList. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechgrammarlist(3271);

  /**
   * generated from use.counter.page.window_webkitspeechrecognition
   */
  /**
   * Whether a page called called Window.webkitSpeechRecognition. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognition(3272);

  /**
   * generated from use.counter.page.window_webkitspeechrecognitionerror
   */
  /**
   * Whether a page called called Window.webkitSpeechRecognitionError. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognitionerror(3273);

  /**
   * generated from use.counter.page.window_webkitspeechrecognitionevent
   */
  /**
   * Whether a page called called Window.webkitSpeechRecognitionEvent. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognitionevent(3274);

  /**
   * generated from use.counter.page.window_webkitstorageinfo
   */
  /**
   * Whether a page called called Window.webkitStorageInfo. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitstorageinfo(3275);

  /**
   * generated from use.counter.page.workernavigator_permissions
   */
  /**
   * Whether a page called called WorkerNavigator.permissions. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric workernavigator_permissions(3276);

  /**
   * generated from use.counter.page.wr_filter_fallback
   */
  /**
   * Whether a page triggers the blob fallback for an SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric wr_filter_fallback(3277);

  /**
   * generated from use.counter.page.xslstylesheet
   */
  /**
   * Whether a page uses an XSL Stylesheet. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric xslstylesheet(3278);

  /**
   * generated from use.counter.page.xsltprocessor_constructor
   */
  /**
   * Whether a page called called XSLTProcessor.constructor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric xsltprocessor_constructor(3279);

  /**
   * generated from use.counter.page.you_tube_flash_embed
   */
  /**
   * Whether a page in <object> or <embed>. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric you_tube_flash_embed(3280);

}
namespace use_counter_worker_dedicated {
  /**
   * generated from use.counter.worker.dedicated.console_assert
   */
  /**
   * Whether a dedicated worker called called console.assert. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_assert(3281);

  /**
   * generated from use.counter.worker.dedicated.console_clear
   */
  /**
   * Whether a dedicated worker called called console.clear. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_clear(3282);

  /**
   * generated from use.counter.worker.dedicated.console_count
   */
  /**
   * Whether a dedicated worker called called console.count. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_count(3283);

  /**
   * generated from use.counter.worker.dedicated.console_countreset
   */
  /**
   * Whether a dedicated worker called called console.countReset. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_countreset(3284);

  /**
   * generated from use.counter.worker.dedicated.console_debug
   */
  /**
   * Whether a dedicated worker called called console.debug. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_debug(3285);

  /**
   * generated from use.counter.worker.dedicated.console_dir
   */
  /**
   * Whether a dedicated worker called called console.dir. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dir(3286);

  /**
   * generated from use.counter.worker.dedicated.console_dirxml
   */
  /**
   * Whether a dedicated worker called called console.dirxml. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dirxml(3287);

  /**
   * generated from use.counter.worker.dedicated.console_error
   */
  /**
   * Whether a dedicated worker called called console.error. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_error(3288);

  /**
   * generated from use.counter.worker.dedicated.console_exception
   */
  /**
   * Whether a dedicated worker called called console.exception. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_exception(3289);

  /**
   * generated from use.counter.worker.dedicated.console_group
   */
  /**
   * Whether a dedicated worker called called console.group. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_group(3290);

  /**
   * generated from use.counter.worker.dedicated.console_groupcollapsed
   */
  /**
   * Whether a dedicated worker called called console.groupCollapsed. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupcollapsed(3291);

  /**
   * generated from use.counter.worker.dedicated.console_groupend
   */
  /**
   * Whether a dedicated worker called called console.groupEnd. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupend(3292);

  /**
   * generated from use.counter.worker.dedicated.console_info
   */
  /**
   * Whether a dedicated worker called called console.info. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_info(3293);

  /**
   * generated from use.counter.worker.dedicated.console_log
   */
  /**
   * Whether a dedicated worker called called console.log. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_log(3294);

  /**
   * generated from use.counter.worker.dedicated.console_profile
   */
  /**
   * Whether a dedicated worker called called console.profile. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profile(3295);

  /**
   * generated from use.counter.worker.dedicated.console_profileend
   */
  /**
   * Whether a dedicated worker called called console.profileEnd. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profileend(3296);

  /**
   * generated from use.counter.worker.dedicated.console_table
   */
  /**
   * Whether a dedicated worker called called console.table. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_table(3297);

  /**
   * generated from use.counter.worker.dedicated.console_time
   */
  /**
   * Whether a dedicated worker called called console.time. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_time(3298);

  /**
   * generated from use.counter.worker.dedicated.console_timeend
   */
  /**
   * Whether a dedicated worker called called console.timeEnd. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timeend(3299);

  /**
   * generated from use.counter.worker.dedicated.console_timelog
   */
  /**
   * Whether a dedicated worker called called console.timeLog. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timelog(3300);

  /**
   * generated from use.counter.worker.dedicated.console_timestamp
   */
  /**
   * Whether a dedicated worker called called console.timeStamp. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timestamp(3301);

  /**
   * generated from use.counter.worker.dedicated.console_trace
   */
  /**
   * Whether a dedicated worker called called console.trace. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_trace(3302);

  /**
   * generated from use.counter.worker.dedicated.console_warn
   */
  /**
   * Whether a dedicated worker called called console.warn. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_warn(3303);

  /**
   * generated from use.counter.worker.dedicated.mls_deriveexporter
   */
  /**
   * Whether a dedicated worker called called MLS.deriveExporter. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_deriveexporter(3304);

  /**
   * generated from use.counter.worker.dedicated.mls_generatecredentialbasic
   */
  /**
   * Whether a dedicated worker called called MLS.generateCredentialBasic. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatecredentialbasic(3305);

  /**
   * generated from use.counter.worker.dedicated.mls_generatekeypackage
   */
  /**
   * Whether a dedicated worker called called MLS.generateKeyPackage. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatekeypackage(3306);

  /**
   * generated from use.counter.worker.dedicated.mls_generatesignaturekeypair
   */
  /**
   * Whether a dedicated worker called called MLS.generateSignatureKeypair. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatesignaturekeypair(3307);

  /**
   * generated from use.counter.worker.dedicated.mls_groupadd
   */
  /**
   * Whether a dedicated worker called called MLS.groupAdd. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupadd(3308);

  /**
   * generated from use.counter.worker.dedicated.mls_groupclose
   */
  /**
   * Whether a dedicated worker called called MLS.groupClose. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupclose(3309);

  /**
   * generated from use.counter.worker.dedicated.mls_groupcreate
   */
  /**
   * Whether a dedicated worker called called MLS.groupCreate. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupcreate(3310);

  /**
   * generated from use.counter.worker.dedicated.mls_groupjoin
   */
  /**
   * Whether a dedicated worker called called MLS.groupJoin. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupjoin(3311);

  /**
   * generated from use.counter.worker.dedicated.mls_groupmembers
   */
  /**
   * Whether a dedicated worker called called MLS.groupMembers. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupmembers(3312);

  /**
   * generated from use.counter.worker.dedicated.mls_groupproposeadd
   */
  /**
   * Whether a dedicated worker called called MLS.groupProposeAdd. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupproposeadd(3313);

  /**
   * generated from use.counter.worker.dedicated.mls_groupproposeremove
   */
  /**
   * Whether a dedicated worker called called MLS.groupProposeRemove. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupproposeremove(3314);

  /**
   * generated from use.counter.worker.dedicated.mls_groupremove
   */
  /**
   * Whether a dedicated worker called called MLS.groupRemove. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupremove(3315);

  /**
   * generated from use.counter.worker.dedicated.mls_receive
   */
  /**
   * Whether a dedicated worker called called MLS.receive. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_receive(3316);

  /**
   * generated from use.counter.worker.dedicated.mls_send
   */
  /**
   * Whether a dedicated worker called called MLS.send. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_send(3317);

  /**
   * generated from use.counter.worker.dedicated.mls_statedelete
   */
  /**
   * Whether a dedicated worker called called MLS.stateDelete. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_statedelete(3318);

  /**
   * generated from use.counter.worker.dedicated.mls_statedeletegroup
   */
  /**
   * Whether a dedicated worker called called MLS.stateDeleteGroup. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_statedeletegroup(3319);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_caches_delete
   */
  /**
   * Whether a dedicated worker calls caches.delete in Private Browsing Mode.
     * Compare against `use.counter.dedicated_workers_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_delete(3320);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_caches_has
   */
  /**
   * Whether a dedicated worker calls caches.has in Private Browsing Mode. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_has(3321);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_caches_keys
   */
  /**
   * Whether a dedicated worker calls caches.keys in Private Browsing Mode. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_keys(3322);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_caches_match
   */
  /**
   * Whether a dedicated worker calls caches.match in Private Browsing Mode. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_match(3323);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_caches_open
   */
  /**
   * Whether a dedicated worker calls caches.open in Private Browsing Mode. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_open(3324);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_idbfactory_delete_database
   */
  /**
   * Whether a dedicated worker calls indexedDB.deleteDatabase in Private Browsing
     * Mode. Compare against `use.counter.dedicated_workers_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_delete_database(3325);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_idbfactory_open
   */
  /**
   * Whether a dedicated worker calls indexedDB.open in Private Browsing Mode.
     * Compare against `use.counter.dedicated_workers_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_open(3326);

  /**
   * generated from use.counter.worker.dedicated.pushmanager_subscribe
   */
  /**
   * Whether a dedicated worker called called PushManager.subscribe. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushmanager_subscribe(3327);

  /**
   * generated from use.counter.worker.dedicated.pushsubscription_unsubscribe
   */
  /**
   * Whether a dedicated worker called called PushSubscription.unsubscribe. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushsubscription_unsubscribe(3328);

  /**
   * generated from use.counter.worker.dedicated.scheduler_posttask
   */
  /**
   * Whether a dedicated worker called called Scheduler.postTask. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric scheduler_posttask(3329);

}
namespace use_counter_worker_service {
  /**
   * generated from use.counter.worker.service.console_assert
   */
  /**
   * Whether a service worker called called console.assert. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_assert(3330);

  /**
   * generated from use.counter.worker.service.console_clear
   */
  /**
   * Whether a service worker called called console.clear. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_clear(3331);

  /**
   * generated from use.counter.worker.service.console_count
   */
  /**
   * Whether a service worker called called console.count. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_count(3332);

  /**
   * generated from use.counter.worker.service.console_countreset
   */
  /**
   * Whether a service worker called called console.countReset. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_countreset(3333);

  /**
   * generated from use.counter.worker.service.console_debug
   */
  /**
   * Whether a service worker called called console.debug. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_debug(3334);

  /**
   * generated from use.counter.worker.service.console_dir
   */
  /**
   * Whether a service worker called called console.dir. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dir(3335);

  /**
   * generated from use.counter.worker.service.console_dirxml
   */
  /**
   * Whether a service worker called called console.dirxml. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dirxml(3336);

  /**
   * generated from use.counter.worker.service.console_error
   */
  /**
   * Whether a service worker called called console.error. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_error(3337);

  /**
   * generated from use.counter.worker.service.console_exception
   */
  /**
   * Whether a service worker called called console.exception. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_exception(3338);

  /**
   * generated from use.counter.worker.service.console_group
   */
  /**
   * Whether a service worker called called console.group. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_group(3339);

  /**
   * generated from use.counter.worker.service.console_groupcollapsed
   */
  /**
   * Whether a service worker called called console.groupCollapsed. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupcollapsed(3340);

  /**
   * generated from use.counter.worker.service.console_groupend
   */
  /**
   * Whether a service worker called called console.groupEnd. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupend(3341);

  /**
   * generated from use.counter.worker.service.console_info
   */
  /**
   * Whether a service worker called called console.info. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_info(3342);

  /**
   * generated from use.counter.worker.service.console_log
   */
  /**
   * Whether a service worker called called console.log. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_log(3343);

  /**
   * generated from use.counter.worker.service.console_profile
   */
  /**
   * Whether a service worker called called console.profile. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profile(3344);

  /**
   * generated from use.counter.worker.service.console_profileend
   */
  /**
   * Whether a service worker called called console.profileEnd. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profileend(3345);

  /**
   * generated from use.counter.worker.service.console_table
   */
  /**
   * Whether a service worker called called console.table. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_table(3346);

  /**
   * generated from use.counter.worker.service.console_time
   */
  /**
   * Whether a service worker called called console.time. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_time(3347);

  /**
   * generated from use.counter.worker.service.console_timeend
   */
  /**
   * Whether a service worker called called console.timeEnd. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timeend(3348);

  /**
   * generated from use.counter.worker.service.console_timelog
   */
  /**
   * Whether a service worker called called console.timeLog. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timelog(3349);

  /**
   * generated from use.counter.worker.service.console_timestamp
   */
  /**
   * Whether a service worker called called console.timeStamp. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timestamp(3350);

  /**
   * generated from use.counter.worker.service.console_trace
   */
  /**
   * Whether a service worker called called console.trace. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_trace(3351);

  /**
   * generated from use.counter.worker.service.console_warn
   */
  /**
   * Whether a service worker called called console.warn. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_warn(3352);

  /**
   * generated from use.counter.worker.service.mls_deriveexporter
   */
  /**
   * Whether a service worker called called MLS.deriveExporter. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_deriveexporter(3353);

  /**
   * generated from use.counter.worker.service.mls_generatecredentialbasic
   */
  /**
   * Whether a service worker called called MLS.generateCredentialBasic. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatecredentialbasic(3354);

  /**
   * generated from use.counter.worker.service.mls_generatekeypackage
   */
  /**
   * Whether a service worker called called MLS.generateKeyPackage. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatekeypackage(3355);

  /**
   * generated from use.counter.worker.service.mls_generatesignaturekeypair
   */
  /**
   * Whether a service worker called called MLS.generateSignatureKeypair. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatesignaturekeypair(3356);

  /**
   * generated from use.counter.worker.service.mls_groupadd
   */
  /**
   * Whether a service worker called called MLS.groupAdd. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupadd(3357);

  /**
   * generated from use.counter.worker.service.mls_groupclose
   */
  /**
   * Whether a service worker called called MLS.groupClose. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupclose(3358);

  /**
   * generated from use.counter.worker.service.mls_groupcreate
   */
  /**
   * Whether a service worker called called MLS.groupCreate. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupcreate(3359);

  /**
   * generated from use.counter.worker.service.mls_groupjoin
   */
  /**
   * Whether a service worker called called MLS.groupJoin. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupjoin(3360);

  /**
   * generated from use.counter.worker.service.mls_groupmembers
   */
  /**
   * Whether a service worker called called MLS.groupMembers. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupmembers(3361);

  /**
   * generated from use.counter.worker.service.mls_groupproposeadd
   */
  /**
   * Whether a service worker called called MLS.groupProposeAdd. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupproposeadd(3362);

  /**
   * generated from use.counter.worker.service.mls_groupproposeremove
   */
  /**
   * Whether a service worker called called MLS.groupProposeRemove. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupproposeremove(3363);

  /**
   * generated from use.counter.worker.service.mls_groupremove
   */
  /**
   * Whether a service worker called called MLS.groupRemove. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupremove(3364);

  /**
   * generated from use.counter.worker.service.mls_receive
   */
  /**
   * Whether a service worker called called MLS.receive. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_receive(3365);

  /**
   * generated from use.counter.worker.service.mls_send
   */
  /**
   * Whether a service worker called called MLS.send. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_send(3366);

  /**
   * generated from use.counter.worker.service.mls_statedelete
   */
  /**
   * Whether a service worker called called MLS.stateDelete. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_statedelete(3367);

  /**
   * generated from use.counter.worker.service.mls_statedeletegroup
   */
  /**
   * Whether a service worker called called MLS.stateDeleteGroup. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_statedeletegroup(3368);

  /**
   * generated from use.counter.worker.service.private_browsing_caches_delete
   */
  /**
   * Whether a service worker calls caches.delete in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_delete(3369);

  /**
   * generated from use.counter.worker.service.private_browsing_caches_has
   */
  /**
   * Whether a service worker calls caches.has in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_has(3370);

  /**
   * generated from use.counter.worker.service.private_browsing_caches_keys
   */
  /**
   * Whether a service worker calls caches.keys in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_keys(3371);

  /**
   * generated from use.counter.worker.service.private_browsing_caches_match
   */
  /**
   * Whether a service worker calls caches.match in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_match(3372);

  /**
   * generated from use.counter.worker.service.private_browsing_caches_open
   */
  /**
   * Whether a service worker calls caches.open in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_open(3373);

  /**
   * generated from use.counter.worker.service.private_browsing_idbfactory_delete_database
   */
  /**
   * Whether a service worker calls indexedDB.deleteDatabase in Private Browsing
     * Mode. Compare against `use.counter.service_workers_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_delete_database(3374);

  /**
   * generated from use.counter.worker.service.private_browsing_idbfactory_open
   */
  /**
   * Whether a service worker calls indexedDB.open in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_open(3375);

  /**
   * generated from use.counter.worker.service.pushmanager_subscribe
   */
  /**
   * Whether a service worker called called PushManager.subscribe. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushmanager_subscribe(3376);

  /**
   * generated from use.counter.worker.service.pushsubscription_unsubscribe
   */
  /**
   * Whether a service worker called called PushSubscription.unsubscribe. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushsubscription_unsubscribe(3377);

  /**
   * generated from use.counter.worker.service.scheduler_posttask
   */
  /**
   * Whether a service worker called called Scheduler.postTask. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric scheduler_posttask(3378);

}
namespace use_counter_worker_shared {
  /**
   * generated from use.counter.worker.shared.console_assert
   */
  /**
   * Whether a shared worker called called console.assert. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_assert(3379);

  /**
   * generated from use.counter.worker.shared.console_clear
   */
  /**
   * Whether a shared worker called called console.clear. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_clear(3380);

  /**
   * generated from use.counter.worker.shared.console_count
   */
  /**
   * Whether a shared worker called called console.count. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_count(3381);

  /**
   * generated from use.counter.worker.shared.console_countreset
   */
  /**
   * Whether a shared worker called called console.countReset. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_countreset(3382);

  /**
   * generated from use.counter.worker.shared.console_debug
   */
  /**
   * Whether a shared worker called called console.debug. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_debug(3383);

  /**
   * generated from use.counter.worker.shared.console_dir
   */
  /**
   * Whether a shared worker called called console.dir. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dir(3384);

  /**
   * generated from use.counter.worker.shared.console_dirxml
   */
  /**
   * Whether a shared worker called called console.dirxml. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dirxml(3385);

  /**
   * generated from use.counter.worker.shared.console_error
   */
  /**
   * Whether a shared worker called called console.error. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_error(3386);

  /**
   * generated from use.counter.worker.shared.console_exception
   */
  /**
   * Whether a shared worker called called console.exception. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_exception(3387);

  /**
   * generated from use.counter.worker.shared.console_group
   */
  /**
   * Whether a shared worker called called console.group. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_group(3388);

  /**
   * generated from use.counter.worker.shared.console_groupcollapsed
   */
  /**
   * Whether a shared worker called called console.groupCollapsed. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupcollapsed(3389);

  /**
   * generated from use.counter.worker.shared.console_groupend
   */
  /**
   * Whether a shared worker called called console.groupEnd. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupend(3390);

  /**
   * generated from use.counter.worker.shared.console_info
   */
  /**
   * Whether a shared worker called called console.info. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_info(3391);

  /**
   * generated from use.counter.worker.shared.console_log
   */
  /**
   * Whether a shared worker called called console.log. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_log(3392);

  /**
   * generated from use.counter.worker.shared.console_profile
   */
  /**
   * Whether a shared worker called called console.profile. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profile(3393);

  /**
   * generated from use.counter.worker.shared.console_profileend
   */
  /**
   * Whether a shared worker called called console.profileEnd. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profileend(3394);

  /**
   * generated from use.counter.worker.shared.console_table
   */
  /**
   * Whether a shared worker called called console.table. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_table(3395);

  /**
   * generated from use.counter.worker.shared.console_time
   */
  /**
   * Whether a shared worker called called console.time. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_time(3396);

  /**
   * generated from use.counter.worker.shared.console_timeend
   */
  /**
   * Whether a shared worker called called console.timeEnd. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timeend(3397);

  /**
   * generated from use.counter.worker.shared.console_timelog
   */
  /**
   * Whether a shared worker called called console.timeLog. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timelog(3398);

  /**
   * generated from use.counter.worker.shared.console_timestamp
   */
  /**
   * Whether a shared worker called called console.timeStamp. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timestamp(3399);

  /**
   * generated from use.counter.worker.shared.console_trace
   */
  /**
   * Whether a shared worker called called console.trace. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_trace(3400);

  /**
   * generated from use.counter.worker.shared.console_warn
   */
  /**
   * Whether a shared worker called called console.warn. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_warn(3401);

  /**
   * generated from use.counter.worker.shared.mls_deriveexporter
   */
  /**
   * Whether a shared worker called called MLS.deriveExporter. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_deriveexporter(3402);

  /**
   * generated from use.counter.worker.shared.mls_generatecredentialbasic
   */
  /**
   * Whether a shared worker called called MLS.generateCredentialBasic. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatecredentialbasic(3403);

  /**
   * generated from use.counter.worker.shared.mls_generatekeypackage
   */
  /**
   * Whether a shared worker called called MLS.generateKeyPackage. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatekeypackage(3404);

  /**
   * generated from use.counter.worker.shared.mls_generatesignaturekeypair
   */
  /**
   * Whether a shared worker called called MLS.generateSignatureKeypair. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_generatesignaturekeypair(3405);

  /**
   * generated from use.counter.worker.shared.mls_groupadd
   */
  /**
   * Whether a shared worker called called MLS.groupAdd. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupadd(3406);

  /**
   * generated from use.counter.worker.shared.mls_groupclose
   */
  /**
   * Whether a shared worker called called MLS.groupClose. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupclose(3407);

  /**
   * generated from use.counter.worker.shared.mls_groupcreate
   */
  /**
   * Whether a shared worker called called MLS.groupCreate. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupcreate(3408);

  /**
   * generated from use.counter.worker.shared.mls_groupjoin
   */
  /**
   * Whether a shared worker called called MLS.groupJoin. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupjoin(3409);

  /**
   * generated from use.counter.worker.shared.mls_groupmembers
   */
  /**
   * Whether a shared worker called called MLS.groupMembers. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupmembers(3410);

  /**
   * generated from use.counter.worker.shared.mls_groupproposeadd
   */
  /**
   * Whether a shared worker called called MLS.groupProposeAdd. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupproposeadd(3411);

  /**
   * generated from use.counter.worker.shared.mls_groupproposeremove
   */
  /**
   * Whether a shared worker called called MLS.groupProposeRemove. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupproposeremove(3412);

  /**
   * generated from use.counter.worker.shared.mls_groupremove
   */
  /**
   * Whether a shared worker called called MLS.groupRemove. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_groupremove(3413);

  /**
   * generated from use.counter.worker.shared.mls_receive
   */
  /**
   * Whether a shared worker called called MLS.receive. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_receive(3414);

  /**
   * generated from use.counter.worker.shared.mls_send
   */
  /**
   * Whether a shared worker called called MLS.send. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_send(3415);

  /**
   * generated from use.counter.worker.shared.mls_statedelete
   */
  /**
   * Whether a shared worker called called MLS.stateDelete. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_statedelete(3416);

  /**
   * generated from use.counter.worker.shared.mls_statedeletegroup
   */
  /**
   * Whether a shared worker called called MLS.stateDeleteGroup. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mls_statedeletegroup(3417);

  /**
   * generated from use.counter.worker.shared.private_browsing_caches_delete
   */
  /**
   * Whether a shared worker calls caches.delete in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_delete(3418);

  /**
   * generated from use.counter.worker.shared.private_browsing_caches_has
   */
  /**
   * Whether a shared worker calls caches.has in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_has(3419);

  /**
   * generated from use.counter.worker.shared.private_browsing_caches_keys
   */
  /**
   * Whether a shared worker calls caches.keys in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_keys(3420);

  /**
   * generated from use.counter.worker.shared.private_browsing_caches_match
   */
  /**
   * Whether a shared worker calls caches.match in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_match(3421);

  /**
   * generated from use.counter.worker.shared.private_browsing_caches_open
   */
  /**
   * Whether a shared worker calls caches.open in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_open(3422);

  /**
   * generated from use.counter.worker.shared.private_browsing_idbfactory_delete_database
   */
  /**
   * Whether a shared worker calls indexedDB.deleteDatabase in Private Browsing
     * Mode. Compare against `use.counter.shared_workers_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_delete_database(3423);

  /**
   * generated from use.counter.worker.shared.private_browsing_idbfactory_open
   */
  /**
   * Whether a shared worker calls indexedDB.open in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_open(3424);

  /**
   * generated from use.counter.worker.shared.pushmanager_subscribe
   */
  /**
   * Whether a shared worker called called PushManager.subscribe. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushmanager_subscribe(3425);

  /**
   * generated from use.counter.worker.shared.pushsubscription_unsubscribe
   */
  /**
   * Whether a shared worker called called PushSubscription.unsubscribe. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushsubscription_unsubscribe(3426);

  /**
   * generated from use.counter.worker.shared.scheduler_posttask
   */
  /**
   * Whether a shared worker called called Scheduler.postTask. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric scheduler_posttask(3427);

}
namespace geolocation {
  /**
   * generated from geolocation.accuracy
   */
  /**
   * Accuracy returned by the Geolocation API
   */
  constexpr impl::CustomDistributionMetric accuracy(3428);

  /**
   * generated from geolocation.fallback
   */
  enum class FallbackLabel: uint16_t {
      eNone = 0,
      eOnError = 1,
      eOnTimeout = 2,
      e__Other__,
    };
  /**
   * Whether the default provider falled back to NetworkGeolocationProvider.
   */
  constexpr impl::Labeled<impl::CounterMetric, FallbackLabel> fallback(3429);

  /**
   * generated from geolocation.linux_provider
   */
  enum class LinuxProviderLabel: uint16_t {
      eNone = 0,
      ePortal = 1,
      eGeoclue = 2,
      e__Other__,
    };
  /**
   * Which system provider are we using on Linux
   */
  constexpr impl::Labeled<impl::BooleanMetric, LinuxProviderLabel> linux_provider(3430);

  /**
   * generated from geolocation.request_result
   */
  enum class RequestResultLabel: uint16_t {
      eSuccess = 0,
      ePermissionDenied = 1,
      ePositionUnavailable = 2,
      eTimeout = 3,
      e__Other__,
    };
  /**
   * The result for each geolocation request. Success label will only happen once
     * for each request, even if it's a watch request.
   */
  constexpr impl::Labeled<impl::CounterMetric, RequestResultLabel> request_result(3431);

}
namespace localstorage_database {
  /**
   * generated from localstorage.database.request_allow_to_close_response_time
   */
  /**
   * Time it took between sending PBackgroundLSDatabase::RequestAllowToClose and
     * receiving PBackgroundLSDatabase::AllowToClose message. These messages are
     * issued when QuotaManager is shutting down or is aborting operations for a
     * particular origin or process.
   */
  constexpr impl::TimingDistributionMetric request_allow_to_close_response_time(3432);

}
namespace ls_preparedatastore {
  /**
   * generated from ls.preparedatastore.processing_time
   */
  /**
   * Time it took for the parent process to prepare a Datastore. This duration can
     * be significantly affected by Datastore preloading, which is triggered when a
     * page begins to load. When a Datastore is already preloaded, the preparation is
     * usually fast since it doesn't need to do any I/O. If an error occurs, the time
     * is not recorded. In future, we might want to introduce additional separate
     * metrics for different types of datastore preparations (data needs to be loaded
     * from disk, data already available, etc.)
   */
  constexpr impl::TimingDistributionMetric processing_time(3433);

}
namespace ls_preparelsdatabase {
  /**
   * generated from ls.preparelsdatabase.processing_time
   */
  /**
   * Time it took for the content process to fully prepare a new LSDatabase,
     * including any time required to prepare a Datastore in the parent. This duration
     * can be significantly affected by Datastore preloading, which is triggered when
     * a page begins to load. If an error occurs, the time is not recorded.
   */
  constexpr impl::TimingDistributionMetric processing_time(3434);

}
namespace ls_request {
  /**
   * generated from ls.request.recv_cancellation
   */
  /**
   * Upticks whenever a LS request cancellation message is received. This includes
     * requests for ensuring either LSDatabase or LSObserver in the child.
   */
  constexpr impl::CounterMetric recv_cancellation(3435);

  /**
   * generated from ls.request.send_cancellation
   */
  /**
   * Upticks whenever a LS request cancellation message is sent. This includes
     * requests for ensuring either LSDatabase or LSObserver.
   */
  constexpr impl::CounterMetric send_cancellation(3436);

}
namespace mediadrm {
  /**
   * generated from mediadrm.decryption
   */
  enum class DecryptionLabel: uint16_t {
      eHasHardwareDecryption = 0,
      eHasHardwareClearlead = 1,
      eHasSoftwareClearlead = 2,
      eHasHdcp22Plus = 3,
      eHasWmf = 4,
      e__Other__,
    };
  /**
   * Record the statuses related with the media decryption.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DecryptionLabel> decryption(3437);

  /**
   * generated from mediadrm.eme_playback
   */
    struct EmePlaybackExtra {
      mozilla::Maybe<nsCString> keySystem;
      mozilla::Maybe<uint32_t> playedTime;
      mozilla::Maybe<nsCString> resolution;
      mozilla::Maybe<nsCString> videoCodec;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (keySystem) {
          extraKeys.AppendElement()->AssignASCII("key_system");
          extraValues.EmplaceBack(keySystem.value());
        }
        if (playedTime) {
          extraKeys.AppendElement()->AssignASCII("played_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", playedTime.value()));
        }
        if (resolution) {
          extraKeys.AppendElement()->AssignASCII("resolution");
          extraValues.EmplaceBack(resolution.value());
        }
        if (videoCodec) {
          extraKeys.AppendElement()->AssignASCII("video_codec");
          extraValues.EmplaceBack(videoCodec.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record the EME play time with the video codec and resolutions.
   */
  constexpr impl::EventMetric<EmePlaybackExtra> eme_playback(3438);

}
namespace hls {
  /**
   * generated from hls.canplay_requested
   */
  /**
   * Record when a page requests canPlayType for a HLS media type.
   */
  constexpr impl::CounterMetric canplay_requested(3439);

  /**
   * generated from hls.canplay_supported
   */
  /**
   * Record when a canPlayType request supports HLS.
   */
  constexpr impl::CounterMetric canplay_supported(3440);

  /**
   * generated from hls.media_load
   */
    struct MediaLoadExtra {
      mozilla::Maybe<nsCString> mediaExtension;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (mediaExtension) {
          extraKeys.AppendElement()->AssignASCII("media_extension");
          extraValues.EmplaceBack(mediaExtension.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record the information about the HLS playback on Android using ExoPlayer. The
     * value of this event contains the media format.
   */
  constexpr impl::EventMetric<MediaLoadExtra> media_load(3441);

}
namespace gmp {
  /**
   * generated from gmp.update_xml_fetch_result
   */
  enum class UpdateXmlFetchResultLabel: uint16_t {
      eCertPinSuccess = 0,
      eCertPinNetRequestError = 1,
      eCertPinNetTimeout = 2,
      eCertPinAbort = 3,
      eCertPinMissingData = 4,
      eCertPinFailed = 5,
      eCertPinInvalid = 6,
      eCertPinXmlParseError = 7,
      eCertPinUnknownError = 8,
      eContentSigSuccess = 9,
      eContentSigNetRequestError = 10,
      eContentSigNetTimeout = 11,
      eContentSigAbort = 12,
      eContentSigMissingData = 13,
      eContentSigFailed = 14,
      eContentSigInvalid = 15,
      eContentSigXmlParseError = 16,
      eContentSigUnknownError = 17,
      e__Other__,
    };
  /**
   * The result of Gecko fetching an update.xml from Balrog. This captures 3
     * different data points: success or failure of the request, if cert pinning or
     * content signatures were used to verify the result, and the reason for failure,
     * if the request failed.
   */
  constexpr impl::Labeled<impl::CounterMetric, UpdateXmlFetchResultLabel> update_xml_fetch_result(3442);

}
namespace media {
  /**
   * generated from media.element_in_page_count
   */
  /**
   * The number of times a document hierarchy contained at least one
     * HTMLMediaElement. In addition, the telemetry probe
     * 'MIXED_CONTENT_UNBLOCK_COUNTER' records the total number of loaded top level
     * content documents, which can help us calculate the result of the percentage of
     * documents using media. This metric was generated to correspond to the Legacy
     * Telemetry scalar media.element_in_page_count.
   */
  constexpr impl::CounterMetric element_in_page_count(3443);

  /**
   * generated from media.error
   */
    struct ErrorExtra {
      mozilla::Maybe<nsCString> errorName;
      mozilla::Maybe<nsCString> errorType;
      mozilla::Maybe<nsCString> keySystem;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (errorName) {
          extraKeys.AppendElement()->AssignASCII("error_name");
          extraValues.EmplaceBack(errorName.value());
        }
        if (errorType) {
          extraKeys.AppendElement()->AssignASCII("error_type");
          extraValues.EmplaceBack(errorType.value());
        }
        if (keySystem) {
          extraKeys.AppendElement()->AssignASCII("key_system");
          extraValues.EmplaceBack(keySystem.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record the error details happened on a media element.
   */
  constexpr impl::EventMetric<ErrorExtra> error(3444);

  /**
   * generated from media.video_hardware_decoding_support
   */
  /**
   * Record whether hardware decoding is supported for the specific video codec. The
     * key is the type of video codec, eg. video/vp9. This metric was generated to
     * correspond to the Legacy Telemetry scalar
     * media.video_hardware_decoding_support.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> video_hardware_decoding_support(3445);

  /**
   * generated from media.video_hd_hardware_decoding_support
   */
  /**
   * Record whether hardware decoding is supported for the specific video codec,
     * this only records video in HD (1280*720) or higher resultion. The key is the
     * type of video codec, eg. video/vp9. This metric was generated to correspond to
     * the Legacy Telemetry scalar media.video_hd_hardware_decoding_support.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> video_hd_hardware_decoding_support(3446);

}
namespace media_audio {
  /**
   * generated from media.audio.backend
   */
  enum class BackendLabel: uint16_t {
      eUnknown = 0,
      eAudiounit = 1,
      eAudiounitRust = 2,
      eAaudio = 3,
      eOpensl = 4,
      eWasapi = 5,
      eWinmm = 6,
      eAlsa = 7,
      eJack = 8,
      eOss = 9,
      ePulse = 10,
      ePulseRust = 11,
      eSndio = 12,
      eSunaudio = 13,
      e__Other__,
    };
  /**
   * The operating system audio backend (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, BackendLabel> backend(3447);

  /**
   * generated from media.audio.init_failure
   */
  enum class InitFailureLabel: uint16_t {
      eFirst = 0,
      eOther = 1,
      e__Other__,
    };
  /**
   * Failure occurs when initializing the audio stream. (Migrated from the geckoview
     * metric of the same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, InitFailureLabel> init_failure(3448);

}
namespace media_playback {
  /**
   * generated from media.playback.decode_error
   */
    struct DecodeErrorExtra {
      mozilla::Maybe<nsCString> decoderName;
      mozilla::Maybe<nsCString> errorName;
      mozilla::Maybe<bool> isHardwareAccelerated;
      mozilla::Maybe<nsCString> keySystem;
      mozilla::Maybe<nsCString> mimeType;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (decoderName) {
          extraKeys.AppendElement()->AssignASCII("decoder_name");
          extraValues.EmplaceBack(decoderName.value());
        }
        if (errorName) {
          extraKeys.AppendElement()->AssignASCII("error_name");
          extraValues.EmplaceBack(errorName.value());
        }
        if (isHardwareAccelerated) {
          extraKeys.AppendElement()->AssignASCII("is_hardware_accelerated");
          extraValues.AppendElement()->AssignASCII(isHardwareAccelerated.value() ? "true" : "false");
        }
        if (keySystem) {
          extraKeys.AppendElement()->AssignASCII("key_system");
          extraValues.EmplaceBack(keySystem.value());
        }
        if (mimeType) {
          extraKeys.AppendElement()->AssignASCII("mime_type");
          extraValues.EmplaceBack(mimeType.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record the decode error details.
   */
  constexpr impl::EventMetric<DecodeErrorExtra> decode_error(3449);

  /**
   * generated from media.playback.device_hardware_decoder_support
   */
  enum class DeviceHardwareDecoderSupportLabel: uint16_t {
      eH264 = 0,
      eVp8 = 1,
      eVp9 = 2,
      eAv1 = 3,
      eHevc = 4,
      e__Other__,
    };
  /**
   * The results of hardware decoder support for different video codecs. True means
     * that codec can be decoded by hardware on user's device.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DeviceHardwareDecoderSupportLabel> device_hardware_decoder_support(3450);

  /**
   * generated from media.playback.first_frame_loaded
   */
    struct FirstFrameLoadedExtra {
      mozilla::Maybe<uint32_t> bufferingTime;
      mozilla::Maybe<uint32_t> firstFrameLoadedTime;
      mozilla::Maybe<bool> hlsDecoder;
      mozilla::Maybe<bool> isHardwareDecoding;
      mozilla::Maybe<nsCString> keySystem;
      mozilla::Maybe<uint32_t> metadataLoadedTime;
      mozilla::Maybe<nsCString> playbackType;
      mozilla::Maybe<nsCString> resolution;
      mozilla::Maybe<uint32_t> totalWaitingDataTime;
      mozilla::Maybe<nsCString> videoCodec;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (bufferingTime) {
          extraKeys.AppendElement()->AssignASCII("buffering_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", bufferingTime.value()));
        }
        if (firstFrameLoadedTime) {
          extraKeys.AppendElement()->AssignASCII("first_frame_loaded_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", firstFrameLoadedTime.value()));
        }
        if (hlsDecoder) {
          extraKeys.AppendElement()->AssignASCII("hls_decoder");
          extraValues.AppendElement()->AssignASCII(hlsDecoder.value() ? "true" : "false");
        }
        if (isHardwareDecoding) {
          extraKeys.AppendElement()->AssignASCII("is_hardware_decoding");
          extraValues.AppendElement()->AssignASCII(isHardwareDecoding.value() ? "true" : "false");
        }
        if (keySystem) {
          extraKeys.AppendElement()->AssignASCII("key_system");
          extraValues.EmplaceBack(keySystem.value());
        }
        if (metadataLoadedTime) {
          extraKeys.AppendElement()->AssignASCII("metadata_loaded_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", metadataLoadedTime.value()));
        }
        if (playbackType) {
          extraKeys.AppendElement()->AssignASCII("playback_type");
          extraValues.EmplaceBack(playbackType.value());
        }
        if (resolution) {
          extraKeys.AppendElement()->AssignASCII("resolution");
          extraValues.EmplaceBack(resolution.value());
        }
        if (totalWaitingDataTime) {
          extraKeys.AppendElement()->AssignASCII("total_waiting_data_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", totalWaitingDataTime.value()));
        }
        if (videoCodec) {
          extraKeys.AppendElement()->AssignASCII("video_codec");
          extraValues.EmplaceBack(videoCodec.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The time that the media pipeline takes to load the first video frame.
   */
  constexpr impl::EventMetric<FirstFrameLoadedExtra> first_frame_loaded(3451);

  /**
   * generated from media.playback.not_supported_video_per_mime_type
   */
  /**
   * Count the amount of times where video playback is failed to start due to the
     * mime type is not supported by Firefox. The result is accumulated per mime type,
     * eg. video/hevc.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> not_supported_video_per_mime_type(3452);

}
namespace mfcdm {
  /**
   * generated from mfcdm.eme_playback
   */
    struct EmePlaybackExtra {
      mozilla::Maybe<uint32_t> droppedFrames;
      mozilla::Maybe<nsCString> keySystem;
      mozilla::Maybe<uint32_t> playedTime;
      mozilla::Maybe<uint32_t> renderedFrames;
      mozilla::Maybe<nsCString> resolution;
      mozilla::Maybe<nsCString> videoCodec;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (droppedFrames) {
          extraKeys.AppendElement()->AssignASCII("dropped_frames");
          extraValues.EmplaceBack(nsPrintfCString("%d", droppedFrames.value()));
        }
        if (keySystem) {
          extraKeys.AppendElement()->AssignASCII("key_system");
          extraValues.EmplaceBack(keySystem.value());
        }
        if (playedTime) {
          extraKeys.AppendElement()->AssignASCII("played_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", playedTime.value()));
        }
        if (renderedFrames) {
          extraKeys.AppendElement()->AssignASCII("rendered_frames");
          extraValues.EmplaceBack(nsPrintfCString("%d", renderedFrames.value()));
        }
        if (resolution) {
          extraKeys.AppendElement()->AssignASCII("resolution");
          extraValues.EmplaceBack(resolution.value());
        }
        if (videoCodec) {
          extraKeys.AppendElement()->AssignASCII("video_codec");
          extraValues.EmplaceBack(videoCodec.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record the information about the EME playback when using the media engine. The
     * value of this event is the key system name.
   */
  constexpr impl::EventMetric<EmePlaybackExtra> eme_playback(3453);

  /**
   * generated from mfcdm.error
   */
    struct ErrorExtra {
      mozilla::Maybe<nsCString> audioCodec;
      mozilla::Maybe<nsCString> currentState;
      mozilla::Maybe<nsCString> errorName;
      mozilla::Maybe<nsCString> keySystem;
      mozilla::Maybe<nsCString> resolution;
      mozilla::Maybe<nsCString> videoCodec;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (audioCodec) {
          extraKeys.AppendElement()->AssignASCII("audio_codec");
          extraValues.EmplaceBack(audioCodec.value());
        }
        if (currentState) {
          extraKeys.AppendElement()->AssignASCII("current_state");
          extraValues.EmplaceBack(currentState.value());
        }
        if (errorName) {
          extraKeys.AppendElement()->AssignASCII("error_name");
          extraValues.EmplaceBack(errorName.value());
        }
        if (keySystem) {
          extraKeys.AppendElement()->AssignASCII("key_system");
          extraValues.EmplaceBack(keySystem.value());
        }
        if (resolution) {
          extraKeys.AppendElement()->AssignASCII("resolution");
          extraValues.EmplaceBack(resolution.value());
        }
        if (videoCodec) {
          extraKeys.AppendElement()->AssignASCII("video_codec");
          extraValues.EmplaceBack(videoCodec.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record the error or crash happened while using the media engine playback. The
     * value of this event is the name of error. This probe covers both EME and non-
     * EME playback.
   */
  constexpr impl::EventMetric<ErrorExtra> error(3454);

}
namespace codec_stats {
  /**
   * generated from codec.stats.audio_preferred_codec
   */
  /**
   * Counts the preferred audio codec being signaled to us to identify preferred
     * audio codec.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> audio_preferred_codec(3455);

  /**
   * generated from codec.stats.other_fec_signaled
   */
  /**
   * Count how many other fec options are being offered.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> other_fec_signaled(3456);

  /**
   * generated from codec.stats.ulpfec_negotiated
   */
  enum class UlpfecNegotiatedLabel: uint16_t {
      eNegotiated = 0,
      eNotNegotiated = 1,
      e__Other__,
    };
  /**
   * Counts the number of times that ulpfec is negotiated or not negotiated on the
     * first negotiation for each video transceiver.
   */
  constexpr impl::Labeled<impl::CounterMetric, UlpfecNegotiatedLabel> ulpfec_negotiated(3457);

  /**
   * generated from codec.stats.video_preferred_codec
   */
  /**
   * Counts the preferred video codec being signaled to us to identify preferred
     * video codec.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> video_preferred_codec(3458);

}
namespace rtcrtpsender {
  /**
   * generated from rtcrtpsender.count
   */
  /**
   * The number of RTCRtpSenders created.
   */
  constexpr impl::DenominatorMetric count(3459);

  /**
   * generated from rtcrtpsender.count_setparameters_compat
   */
  /**
   * The number of RTCRtpSenders created that use the compatibility mode for
     * setParameters.
   */
  constexpr impl::DenominatorMetric count_setparameters_compat(3460);

  /**
   * generated from rtcrtpsender.used_sendencodings
   */
  /**
   * The proportion of RTCRtpSenders that were created by an addTransceivers call
     * that was passed a sendEncodings.
   */
  constexpr impl::NumeratorMetric used_sendencodings(3461);

}
namespace rtcrtpsender_setparameters {
  /**
   * generated from rtcrtpsender.setparameters.fail_length_changed
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that attempted to change the number of encodings.
   */
  constexpr impl::NumeratorMetric fail_length_changed(3462);

  /**
   * generated from rtcrtpsender.setparameters.fail_no_encodings
   */
  /**
   * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have thrown an error at least once about a setParameters call that had no
     * encodings (we do not measure this against the general population of
     * RTCRtpSenders, since without the compat mode this failure is never observed,
     * because it fails the length change check).
   */
  constexpr impl::NumeratorMetric fail_no_encodings(3463);

  /**
   * generated from rtcrtpsender.setparameters.fail_no_getparameters
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call because [[LastReturnedParameters]] was not set. (ie; there
     * was not a recent enough call to getParameters)
   */
  constexpr impl::NumeratorMetric fail_no_getparameters(3464);

  /**
   * generated from rtcrtpsender.setparameters.fail_no_transactionid
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that did not set the transactionId field.
   */
  constexpr impl::NumeratorMetric fail_no_transactionid(3465);

  /**
   * generated from rtcrtpsender.setparameters.fail_other
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that had no encodings.
   */
  constexpr impl::NumeratorMetric fail_other(3466);

  /**
   * generated from rtcrtpsender.setparameters.fail_rid_changed
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that attempted to change the rid on an encoding (note that
     * we only check this if the encoding count did not change, see
     * fail_length_changed).
   */
  constexpr impl::NumeratorMetric fail_rid_changed(3467);

  /**
   * generated from rtcrtpsender.setparameters.fail_stale_transactionid
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that used a stale transaction id.
   */
  constexpr impl::NumeratorMetric fail_stale_transactionid(3468);

  /**
   * generated from rtcrtpsender.setparameters.warn_length_changed
   */
  /**
   * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have warned at least once about a setParameters call that attempted to
     * change the number of encodings.
   */
  constexpr impl::NumeratorMetric warn_length_changed(3469);

  /**
   * generated from rtcrtpsender.setparameters.warn_no_getparameters
   */
  /**
   * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have warned at least once about a setParameters call because
     * [[LastReturnedParameters]] was not set.  (ie; there was not a recent enough
     * call to getParameters)
   */
  constexpr impl::NumeratorMetric warn_no_getparameters(3470);

  /**
   * generated from rtcrtpsender.setparameters.warn_no_transactionid
   */
  /**
   * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have warned at least once about a setParameters call that did not set the
     * transactionId field.
   */
  constexpr impl::NumeratorMetric warn_no_transactionid(3471);

}
namespace webrtc_video {
  /**
   * generated from webrtc.video.recv_codec_used
   */
  /**
   * The video codec used for receiving video on a WebRTC call. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * webrtc.video.recv_codec_used.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> recv_codec_used(3472);

  /**
   * generated from webrtc.video.send_codec_used
   */
  /**
   * The video codec used for sending video on a WebRTC call. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * webrtc.video.send_codec_used.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> send_codec_used(3473);

}
namespace webrtcdtls {
  /**
   * generated from webrtcdtls.cipher
   */
  /**
   * The CipherSuite used for each webrtc DTLS connection, as a string
     * representation of the CipherSuite's ID in 4 hex digits (eg;
     * TLS_DHE_RSA_WITH_AES_128_CBC_SHA would be "0x0033")
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> cipher(3474);

  /**
   * generated from webrtcdtls.client_handshake_result
   */
  /**
   * The result of each webrtc client DTLS handshake as a string containing either
     * the name of the error code (eg; SSL_ERROR_BAD_CERTIFICATE), SUCCESS for
     * successful handshakes, ALPN_FAILURE when ALPN negotiation fails, or
     * CERT_FAILURE when cert validation fails.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> client_handshake_result(3475);

  /**
   * generated from webrtcdtls.client_handshake_started_counter
   */
  /**
   * The number of webrtc transports that have started a DTLS handshake as the
     * client.
   */
  constexpr impl::CounterMetric client_handshake_started_counter(3476);

  /**
   * generated from webrtcdtls.protocol_version
   */
  /**
   * The version of DTLS used for each webrtc connection. Can be 1.0, 1.2, or 1.3
     * (there is no 1.1 version of DTLS)
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> protocol_version(3477);

  /**
   * generated from webrtcdtls.server_handshake_result
   */
  /**
   * The result of each webrtc server DTLS handshake, as the name of the error code
     * (eg; SSL_ERROR_BAD_CERTIFICATE), the empty string for successful handshakes,
     * ALPN_FAILURE when ALPN negotiation fails, or CERT_FAILURE when cert validation
     * fails.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> server_handshake_result(3478);

  /**
   * generated from webrtcdtls.server_handshake_started_counter
   */
  /**
   * The number of webrtc transports that have started a DTLS handshake as the
     * server.
   */
  constexpr impl::CounterMetric server_handshake_started_counter(3479);

  /**
   * generated from webrtcdtls.srtp_cipher
   */
  /**
   * The SRTPProtectionProfile (see RFC 5764) used for each webrtc SRTP connection,
     * as a string representation of the SRTPProtectionProfile's ID in 4 hex digits
     * (eg; SRTP_AES128_CM_HMAC_SHA1_80 would be "0x0001")
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> srtp_cipher(3480);

}
namespace dom_contentprocess {
  /**
   * generated from dom.contentprocess.build_id_mismatch
   */
  /**
   * The number of times the about:restartrequired page appeared due to a buildID
     * mismatch between the parent and the content processes. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * dom.contentprocess.buildID_mismatch.
   */
  constexpr impl::CounterMetric build_id_mismatch(3481);

  /**
   * generated from dom.contentprocess.build_id_mismatch_false_positive
   */
  /**
   * The number of times a process crashed early but we could verify it was not
     * because of buildID mismatch between the parent and the content processes. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * dom.contentprocess.buildID_mismatch_false_positive.
   */
  constexpr impl::CounterMetric build_id_mismatch_false_positive(3482);

  /**
   * generated from dom.contentprocess.os_priority_change_considered
   */
  /**
   * The number of times we've had the opportunity to change content process
     * priority due to a tab switch or a tab being opened. This metric was generated
     * to correspond to the Legacy Telemetry scalar
     * dom.contentprocess.os_priority_change_considered.
   */
  constexpr impl::CounterMetric os_priority_change_considered(3483);

  /**
   * generated from dom.contentprocess.os_priority_lowered
   */
  /**
   * The number of times a content process has had its OS priority lowered due to
     * only containing background tabs without audible media playing. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * dom.contentprocess.os_priority_lowered.
   */
  constexpr impl::CounterMetric os_priority_lowered(3484);

  /**
   * generated from dom.contentprocess.os_priority_raised
   */
  /**
   * The number of times a content process has had its OS priority raised due to
     * containing at least one foregrounded tab, or a tab with audible media has
     * started playing in it. This metric was generated to correspond to the Legacy
     * Telemetry scalar dom.contentprocess.os_priority_raised.
   */
  constexpr impl::CounterMetric os_priority_raised(3485);

}
namespace dom_parentprocess {
  /**
   * generated from dom.parentprocess.private_window_used
   */
  /**
   * Whether a private browsing window has been used in the session. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * dom.parentprocess.private_window_used.
   */
  constexpr impl::BooleanMetric private_window_used(3486);

  /**
   * generated from dom.parentprocess.process_launch_errors
   */
  /**
   * Collect precise set of error code and calling site upon process creation
     * failure path. This metric was generated to correspond to the Legacy Telemetry
     * scalar dom.parentprocess.process_launch_errors.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> process_launch_errors(3487);

}
namespace javascript_pageload {
  /**
   * generated from javascript.pageload.baseline_compile_time
   */
  /**
   * Time spent during page load baseline compiling Javascript in ms. (Migrated from
     * the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric baseline_compile_time(3488);

  /**
   * generated from javascript.pageload.delazification_time
   */
  /**
   * Time spent during page load delazifying Javascript in ms. (Migrated from the
     * geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric delazification_time(3489);

  /**
   * generated from javascript.pageload.execution_time
   */
  /**
   * Time spent during page load executing Javascript in ms. (Migrated from the
     * geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric execution_time(3490);

  /**
   * generated from javascript.pageload.gc_time
   */
  /**
   * Time spent during page load in the GC in ms. (Migrated from the geckoview
     * metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric gc_time(3491);

  /**
   * generated from javascript.pageload.parse_time
   */
  /**
   * Time spent during page load syntax parsing JS scripts on the main thread in ms.
     * (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric parse_time(3492);

  /**
   * generated from javascript.pageload.protect_time
   */
  /**
   * Time spent during page load protecting JIT executable memory. (Migrated from
     * the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric protect_time(3493);

  /**
   * generated from javascript.pageload.xdr_encode_time
   */
  /**
   * Time spent during page load XDR encoding Javascript in ms. (Migrated from the
     * geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric xdr_encode_time(3494);

}
namespace mathml {
  /**
   * generated from mathml.doc_count
   */
  /**
   * The number of documents that contained enabled MathML elements. This metric was
     * generated to correspond to the Legacy Telemetry scalar mathml.doc_count.
   */
  constexpr impl::CounterMetric doc_count(3495);

}
namespace perf {
  /**
   * generated from perf.largest_contentful_paint
   */
  /**
   * Time from navigation start to largest contentful paint.
   */
  constexpr impl::TimingDistributionMetric largest_contentful_paint(3496);

  /**
   * generated from perf.largest_contentful_paint_from_response_start
   */
  /**
   * Time from response start to largest contentful paint.
   */
  constexpr impl::TimingDistributionMetric largest_contentful_paint_from_response_start(3497);

  /**
   * generated from perf.page_load
   */
    struct PageLoadExtra {
      mozilla::Maybe<uint32_t> dnsLookupTime;
      mozilla::Maybe<uint32_t> fcpTime;
      mozilla::Maybe<uint32_t> features;
      mozilla::Maybe<uint32_t> httpVer;
      mozilla::Maybe<uint32_t> jsExecTime;
      mozilla::Maybe<uint32_t> lcpTime;
      mozilla::Maybe<uint32_t> loadTime;
      mozilla::Maybe<nsCString> loadType;
      mozilla::Maybe<uint32_t> redirectCount;
      mozilla::Maybe<uint32_t> redirectTime;
      mozilla::Maybe<uint32_t> responseTime;
      mozilla::Maybe<bool> sameOriginNav;
      mozilla::Maybe<uint32_t> timeToRequestStart;
      mozilla::Maybe<nsCString> trrDomain;
      mozilla::Maybe<bool> usingWebdriver;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (dnsLookupTime) {
          extraKeys.AppendElement()->AssignASCII("dns_lookup_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", dnsLookupTime.value()));
        }
        if (fcpTime) {
          extraKeys.AppendElement()->AssignASCII("fcp_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", fcpTime.value()));
        }
        if (features) {
          extraKeys.AppendElement()->AssignASCII("features");
          extraValues.EmplaceBack(nsPrintfCString("%d", features.value()));
        }
        if (httpVer) {
          extraKeys.AppendElement()->AssignASCII("http_ver");
          extraValues.EmplaceBack(nsPrintfCString("%d", httpVer.value()));
        }
        if (jsExecTime) {
          extraKeys.AppendElement()->AssignASCII("js_exec_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", jsExecTime.value()));
        }
        if (lcpTime) {
          extraKeys.AppendElement()->AssignASCII("lcp_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", lcpTime.value()));
        }
        if (loadTime) {
          extraKeys.AppendElement()->AssignASCII("load_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", loadTime.value()));
        }
        if (loadType) {
          extraKeys.AppendElement()->AssignASCII("load_type");
          extraValues.EmplaceBack(loadType.value());
        }
        if (redirectCount) {
          extraKeys.AppendElement()->AssignASCII("redirect_count");
          extraValues.EmplaceBack(nsPrintfCString("%d", redirectCount.value()));
        }
        if (redirectTime) {
          extraKeys.AppendElement()->AssignASCII("redirect_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", redirectTime.value()));
        }
        if (responseTime) {
          extraKeys.AppendElement()->AssignASCII("response_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", responseTime.value()));
        }
        if (sameOriginNav) {
          extraKeys.AppendElement()->AssignASCII("same_origin_nav");
          extraValues.AppendElement()->AssignASCII(sameOriginNav.value() ? "true" : "false");
        }
        if (timeToRequestStart) {
          extraKeys.AppendElement()->AssignASCII("time_to_request_start");
          extraValues.EmplaceBack(nsPrintfCString("%d", timeToRequestStart.value()));
        }
        if (trrDomain) {
          extraKeys.AppendElement()->AssignASCII("trr_domain");
          extraValues.EmplaceBack(trrDomain.value());
        }
        if (usingWebdriver) {
          extraKeys.AppendElement()->AssignASCII("using_webdriver");
          extraValues.AppendElement()->AssignASCII(usingWebdriver.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a top level content document has been loaded.
   */
  constexpr impl::EventMetric<PageLoadExtra> page_load(3498);

}
namespace performance_pageload {
  /**
   * generated from performance.pageload.fcp
   */
  /**
   * The time between navigationStart and the first contentful paint of a foreground
     * http or https root content document, in milliseconds. The contentful paint
     * timestamp is taken during display list building and does not include
     * rasterization or compositing of that paint. (Migrated from the geckoview metric
     * of the same name).
   */
  constexpr impl::TimingDistributionMetric fcp(3499);

  /**
   * generated from performance.pageload.fcp_responsestart
   */
  /**
   * The time between responseStart and the first contentful paint of a foreground
     * http or https root content document, in milliseconds. The contentful paint
     * timestamp is taken during display list building and does not include
     * rasterization or compositing of that paint. (Migrated from the geckoview metric
     * of the same name).
   */
  constexpr impl::TimingDistributionMetric fcp_responsestart(3500);

  /**
   * generated from performance.pageload.h3p_fcp_with_priority
   */
  /**
   * The time between navigationStart and the first contentful paint of a foreground
     * http or https root content document, in milliseconds. The contentful paint
     * timestamp is taken during display list building and does not include
     * rasterization or compositing of that paint. This is collected only on page load
     * where the main document uses HTTP3. A "priority" header has been received.
   */
  constexpr impl::TimingDistributionMetric h3p_fcp_with_priority(3501);

  /**
   * generated from performance.pageload.http3_fcp_http3
   */
  /**
   * The time between navigationStart and the first contentful paint of a foreground
     * http or https root content document, in milliseconds. The contentful paint
     * timestamp is taken during display list building and does not include
     * rasterization or compositing of that paint. This is collected only on page load
     * where the main document uses or suppports HTTP3.
   */
  constexpr impl::TimingDistributionMetric http3_fcp_http3(3502);

  /**
   * generated from performance.pageload.http3_fcp_supports_http3
   */
  /**
   * The time between navigationStart and the first contentful paint of a foreground
     * http or https root content document, in milliseconds. The contentful paint
     * timestamp is taken during display list building and does not include
     * rasterization or compositing of that paint. This is collected only on page load
     * where the main document supports but is not using HTTP3.
   */
  constexpr impl::TimingDistributionMetric http3_fcp_supports_http3(3503);

  /**
   * generated from performance.pageload.http3_fcp_without_priority
   */
  /**
   * The time between navigationStart and the first contentful paint of a foreground
     * http or https root content document, in milliseconds. The contentful paint
     * timestamp is taken during display list building and does not include
     * rasterization or compositing of that paint. This is collected only on page load
     * where the main document uses HTTP3. A "priority" header has not been received.
   */
  constexpr impl::TimingDistributionMetric http3_fcp_without_priority(3504);

  /**
   * generated from performance.pageload.load_time
   */
  /**
   * Time in milliseconds from navigationStart to loadEventStart for the foreground
     * http or https root content document. (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::TimingDistributionMetric load_time(3505);

  /**
   * generated from performance.pageload.load_time_responsestart
   */
  /**
   * Time in milliseconds from responseStart to loadEventStart for the foreground
     * http or https root content document. (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::TimingDistributionMetric load_time_responsestart(3506);

  /**
   * generated from performance.pageload.async_sheet_load
   */
  /**
   * Time spent in milliseconds since a style sheet started loading async until it
     * finished.
   */
  constexpr impl::TimingDistributionMetric async_sheet_load(3507);

}
namespace performance_time {
  /**
   * generated from performance.time.dom_complete
   */
  /**
   * Time from navigationStart to domComplete as per the W3C Performance Timing API.
     * (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric dom_complete(3508);

  /**
   * generated from performance.time.dom_content_loaded_end
   */
  /**
   * Time from navigationStart to domContentLoadedEventEnd as per the W3C
     * Performance Timing API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric dom_content_loaded_end(3509);

  /**
   * generated from performance.time.dom_content_loaded_start
   */
  /**
   * Time from navigationStart to domContentLoadedEventStart as per the W3C
     * Performance Timing API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric dom_content_loaded_start(3510);

  /**
   * generated from performance.time.dom_interactive
   */
  /**
   * Time from navigationStart to domInteractive as per the W3C Performance Timing
     * API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric dom_interactive(3511);

  /**
   * generated from performance.time.load_event_end
   */
  /**
   * Time from navigationStart to loadEventEnd as per the W3C Performance Timing
     * API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric load_event_end(3512);

  /**
   * generated from performance.time.load_event_start
   */
  /**
   * Time from navigationStart to loadEventStart as per the W3C Performance Timing
     * API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric load_event_start(3513);

  /**
   * generated from performance.time.response_start
   */
  /**
   * Time from navigationStart to responseStart as per the W3C Performance Timing
     * API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric response_start(3514);

}
namespace web_notification {
  /**
   * generated from web_notification.insecure_context_permission_request
   */
  /**
   * Whether we saw a permission request from an insecure context.
   */
  constexpr impl::CounterMetric insecure_context_permission_request(3515);

  /**
   * generated from web_notification.permission_origin
   */
  enum class PermissionOriginLabel: uint16_t {
      eFirstParty = 0,
      eThirdParty = 1,
      eNestedFirstParty = 2,
      e__Other__,
    };
  /**
   * The category of the origin that retrieves Notification.permission.
   */
  constexpr impl::Labeled<impl::CounterMetric, PermissionOriginLabel> permission_origin(3516);

  /**
   * generated from web_notification.request_permission_origin
   */
  enum class RequestPermissionOriginLabel: uint16_t {
      eFirstParty = 0,
      eThirdParty = 1,
      eNestedFirstParty = 2,
      e__Other__,
    };
  /**
   * The category of the origin that calls Notification.requestPermission().
   */
  constexpr impl::Labeled<impl::CounterMetric, RequestPermissionOriginLabel> request_permission_origin(3517);

  /**
   * generated from web_notification.show_origin
   */
  enum class ShowOriginLabel: uint16_t {
      eFirstParty = 0,
      eThirdParty = 1,
      eNestedFirstParty = 2,
      e__Other__,
    };
  /**
   * The category of the origin that calls new Notification/showNotification().
   */
  constexpr impl::Labeled<impl::CounterMetric, ShowOriginLabel> show_origin(3518);

}
namespace web_push {
  /**
   * generated from web_push.content_encoding
   */
  enum class ContentEncodingLabel: uint16_t {
      eAes128gcm = 0,
      eAesgcm = 1,
      e__Other__,
    };
  /**
   * Which content encoding is being used for push.
   */
  constexpr impl::Labeled<impl::CounterMetric, ContentEncodingLabel> content_encoding(3519);

  /**
   * generated from web_push.detected_duplicated_message_ids
   */
  /**
   * Counts the duplicated IDs from the server. The ability to detect depends on the
     * pref `dom.push.maxRecentMessageIDsPerSubscription`.
   */
  constexpr impl::CounterMetric detected_duplicated_message_ids(3520);

  /**
   * generated from web_push.error_code
   */
  enum class ErrorCodeLabel: uint16_t {
      eDecryptionError = 0,
      eNotDelivered = 1,
      eUncaughtException = 2,
      eUnhandledRejection = 3,
      eInternalError = 4,
      e__Other__,
    };
  /**
   * The code indicating why the push message couldn't be processed.
   */
  constexpr impl::Labeled<impl::CounterMetric, ErrorCodeLabel> error_code(3521);

}
namespace dom_quota_try {
  /**
   * generated from dom.quota.try.error_step
   */
    struct ErrorStepExtra {
      mozilla::Maybe<nsCString> context;
      mozilla::Maybe<nsCString> frameId;
      mozilla::Maybe<nsCString> processId;
      mozilla::Maybe<nsCString> result;
      mozilla::Maybe<uint32_t> seq;
      mozilla::Maybe<nsCString> severity;
      mozilla::Maybe<nsCString> sourceFile;
      mozilla::Maybe<uint32_t> sourceLine;
      mozilla::Maybe<nsCString> stackId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (context) {
          extraKeys.AppendElement()->AssignASCII("context");
          extraValues.EmplaceBack(context.value());
        }
        if (frameId) {
          extraKeys.AppendElement()->AssignASCII("frame_id");
          extraValues.EmplaceBack(frameId.value());
        }
        if (processId) {
          extraKeys.AppendElement()->AssignASCII("process_id");
          extraValues.EmplaceBack(processId.value());
        }
        if (result) {
          extraKeys.AppendElement()->AssignASCII("result");
          extraValues.EmplaceBack(result.value());
        }
        if (seq) {
          extraKeys.AppendElement()->AssignASCII("seq");
          extraValues.EmplaceBack(nsPrintfCString("%d", seq.value()));
        }
        if (severity) {
          extraKeys.AppendElement()->AssignASCII("severity");
          extraValues.EmplaceBack(severity.value());
        }
        if (sourceFile) {
          extraKeys.AppendElement()->AssignASCII("source_file");
          extraValues.EmplaceBack(sourceFile.value());
        }
        if (sourceLine) {
          extraKeys.AppendElement()->AssignASCII("source_line");
          extraValues.EmplaceBack(nsPrintfCString("%d", sourceLine.value()));
        }
        if (stackId) {
          extraKeys.AppendElement()->AssignASCII("stack_id");
          extraValues.EmplaceBack(stackId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * An event recorded on an error of the quota manager or its clients. Since errors
     * are usually propagated up the call chain, all such propagation steps are
     * recorded for an error. This is only active during specific contexts, in
     * particular during storage initialization. No dynamic data is included in the
     * event beyond the error code which will be added through Bug 1670555. This event
     * was generated to correspond to the Legacy Telemetry event
     * dom.quota.try.error#step.
   */
  constexpr impl::EventMetric<ErrorStepExtra> error_step(3522);

}
namespace quotamanager_initialize_repository {
  /**
   * generated from quotamanager.initialize.repository.number_of_iterations
   */
  enum class NumberOfIterationsLabel: uint16_t {
      ePersistent = 0,
      eTemporary = 1,
      eDefault = 2,
      ePrivate = 3,
      e__Other__,
    };
  /**
   * This metric logs the count of directory entries iterated within the
     * QuotaManager::InitializeRepository function for each repository type. Each
     * instance of this metric is labeled with one of three repository types:
     * "persistent", "temporary" or "default" (there's also "private" repository but
     * that should never be iterated by the function). The main purpose is to track
     * and analyze iteration counts during the initialization process of each
     * repository type, helping to identify performance trends or potential
     * inefficiencies across these repositories. This can provide insight into the
     * impacts of specific code changes, including potential optimizations or
     * regressions.
   */
  constexpr impl::Labeled<impl::CustomDistributionMetric, NumberOfIterationsLabel> number_of_iterations(3523);

}
namespace httpsfirst {
  /**
   * generated from httpsfirst.downgrade_time
   */
  /**
   * If a HTTPS-First (`dom.security.https_first` enabled) upgrade isn't successful,
     * measures the timespan between the navigation start and the downgrade.
   */
  constexpr impl::TimingDistributionMetric downgrade_time(3524);

  /**
   * generated from httpsfirst.downgrade_time_schemeless
   */
  /**
   * If a schemeless HTTPS-First (`dom.security.https_first` disabled, but load
     * marked as schemeless) upgrade isn't successful, measures the timespan between
     * the navigation start and the downgrade.
   */
  constexpr impl::TimingDistributionMetric downgrade_time_schemeless(3525);

  /**
   * generated from httpsfirst.downgraded
   */
  /**
   * How many regular HTTPS-First (`dom.security.https_first` enabled) upgrades fail
     * and get downgraded again.
   */
  constexpr impl::DenominatorMetric downgraded(3526);

  /**
   * generated from httpsfirst.downgraded_on_timer
   */
  /**
   * How many HTTPS-First (`dom.security.https_first` enabled) upgrades get
     * downgraded again because the HTTP request fired after 3s received a answer
     * faster than the HTTPS request.
   */
  constexpr impl::NumeratorMetric downgraded_on_timer(3527);

  /**
   * generated from httpsfirst.downgraded_on_timer_schemeless
   */
  /**
   * How many of schemeless HTTPS-First (`dom.security.https_first` disabled, but
     * load marked as schemeless) upgrades get downgraded again because the HTTP
     * request fired after 3s received a answer faster than the HTTPS request
   */
  constexpr impl::NumeratorMetric downgraded_on_timer_schemeless(3528);

  /**
   * generated from httpsfirst.downgraded_schemeless
   */
  /**
   * How many schemeless HTTPS-First (`dom.security.https_first` disabled, but load
     * marked as schemeless) upgrades fail and get downgraded again.
   */
  constexpr impl::DenominatorMetric downgraded_schemeless(3529);

  /**
   * generated from httpsfirst.upgraded
   */
  /**
   * Counts how often a load is successfully upgraded to HTTPS because of HTTPS-
     * First (`dom.security.https_first` enabled). This does not include loads that
     * get downgraded again.
   */
  constexpr impl::CounterMetric upgraded(3530);

  /**
   * generated from httpsfirst.upgraded_schemeless
   */
  /**
   * Counts how often a load is successfully upgraded to HTTPS because of schemeless
     * HTTPS-First (`dom.security.https_first` disabled, but load marked as
     * schemeless). This does not include loads that get downgraded again.
   */
  constexpr impl::CounterMetric upgraded_schemeless(3531);

}
namespace webauthn_create {
  /**
   * generated from webauthn_create.authenticator_attachment
   */
  enum class AuthenticatorAttachmentLabel: uint16_t {
      eCrossPlatform = 0,
      ePlatform = 1,
      eUnknown = 2,
      e__Other__,
    };
  /**
   * The number of successfully created credentials by authenticator attachment
     * modality.
   */
  constexpr impl::Labeled<impl::CounterMetric, AuthenticatorAttachmentLabel> authenticator_attachment(3532);

  /**
   * generated from webauthn_create.failure
   */
  /**
   * The total number of failed calls to navigator.credentials.create.
   */
  constexpr impl::CounterMetric failure(3533);

  /**
   * generated from webauthn_create.passkey
   */
  /**
   * The number of client-side discoverable credentials (passkeys) created.
   */
  constexpr impl::CounterMetric passkey(3534);

  /**
   * generated from webauthn_create.success
   */
  /**
   * The total number of successful calls to navigator.credentials.create.
   */
  constexpr impl::CounterMetric success(3535);

}
namespace webauthn_get {
  /**
   * generated from webauthn_get.authenticator_attachment
   */
  enum class AuthenticatorAttachmentLabel: uint16_t {
      eCrossPlatform = 0,
      ePlatform = 1,
      eUnknown = 2,
      e__Other__,
    };
  /**
   * The number of successfully asserted credentials by authenticator attachment
     * modality.
   */
  constexpr impl::Labeled<impl::CounterMetric, AuthenticatorAttachmentLabel> authenticator_attachment(3536);

  /**
   * generated from webauthn_get.failure
   */
  /**
   * The total number of failed calls to navigator.credentials.get.
   */
  constexpr impl::CounterMetric failure(3537);

  /**
   * generated from webauthn_get.success
   */
  /**
   * The total number of successful calls to navigator.credentials.get.
   */
  constexpr impl::CounterMetric success(3538);

}
namespace gfx {
  /**
   * generated from gfx.composite_time
   */
  /**
   * The time taken to composite a frame. On non-webrender this is the time taken in
     * `CompositorBridgeParent::CompositeToTarget()`. On webrender, this is the time
     * taken from the start of `WebRenderBridgeParent::CompositeToTarget()`, until the
     * render thread has rendered the frame (in `RenderThread::HandleFrameOneDoc()`).
     * (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric composite_time(3539);

  /**
   * generated from gfx.linux_window_protocol
   */
  /**
   * Windowing protocol on Linux. Can be Wayland, WaylandDRM, XWayland, or X11 This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * gfx.linux_window_protocol.
   */
  constexpr impl::StringMetric linux_window_protocol(3540);

  /**
   * generated from gfx.os_compositor
   */
  /**
   * Boolean indicating whether the os compositor is being used by WebRender. Only
     * collected in the first subsession. This metric was generated to correspond to
     * the Legacy Telemetry scalar gfx.os_compositor.
   */
  constexpr impl::BooleanMetric os_compositor(3541);

  /**
   * generated from gfx.scroll_present_latency
   */
  /**
   * Time between receiving a scroll event on the event loop and compositing its
     * result onto the screen (ms). (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::TimingDistributionMetric scroll_present_latency(3542);

  /**
   * generated from gfx.skipped_composites
   */
  /**
   * Number of skipped composites, happening when rendering is too slow to keep up
     * with content. This metric was generated to correspond to the Legacy Telemetry
     * scalar gfx.skipped_composites.
   */
  constexpr impl::CounterMetric skipped_composites(3543);

  /**
   * generated from gfx.supports_hdr
   */
  /**
   * Does the hardware support accurate display of HDR content This metric was
     * generated to correspond to the Legacy Telemetry scalar gfx.supports_hdr.
   */
  constexpr impl::BooleanMetric supports_hdr(3544);

}
namespace gfx_adapter_primary {
  /**
   * generated from gfx.adapter.primary.description
   */
  /**
   * Long form description of the Graphics adapter (Migrated from the geckoview
     * metric of the same name).
   */
  constexpr impl::StringMetric description(3545);

  /**
   * generated from gfx.adapter.primary.device_id
   */
  /**
   * Graphics adapter device identification (Migrated from the geckoview metric of
     * the same name).
   */
  constexpr impl::StringMetric device_id(3546);

  /**
   * generated from gfx.adapter.primary.driver_date
   */
  /**
   * Graphics adapter driver date (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::StringMetric driver_date(3547);

  /**
   * generated from gfx.adapter.primary.driver_files
   */
  /**
   * List of graphics adapter driver files (Migrated from the geckoview metric of
     * the same name).
   */
  constexpr impl::StringMetric driver_files(3548);

  /**
   * generated from gfx.adapter.primary.driver_vendor
   */
  /**
   * Graphics adapter driver vendor identification (Migrated from the geckoview
     * metric of the same name).
   */
  constexpr impl::StringMetric driver_vendor(3549);

  /**
   * generated from gfx.adapter.primary.driver_version
   */
  /**
   * Graphics adapter driver version (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::StringMetric driver_version(3550);

  /**
   * generated from gfx.adapter.primary.ram
   */
  /**
   * Graphics adapter dedicated memory (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::QuantityMetric ram(3551);

  /**
   * generated from gfx.adapter.primary.subsystem_id
   */
  /**
   * Graphics adapter subsystem identification (Migrated from the geckoview metric
     * of the same name).
   */
  constexpr impl::StringMetric subsystem_id(3552);

  /**
   * generated from gfx.adapter.primary.vendor_id
   */
  /**
   * Graphics adapter vendor identification (Migrated from the geckoview metric of
     * the same name).
   */
  constexpr impl::StringMetric vendor_id(3553);

}
namespace gfx_checkerboard {
  /**
   * generated from gfx.checkerboard.duration
   */
  /**
   * The duration of a checkerboard event. Checkerboarding is when painting has not
     * kept up with asynchronous panning and zooming so the compositor has to display
     * a "checkerboard pattern" (or in practice, the background color) rather than the
     * actual page content. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric duration(3554);

  /**
   * generated from gfx.checkerboard.peak_pixel_count
   */
  /**
   * The peak number of CSS pixels that checkerboarded during a checkerboard event.
     * The minimum value of the largest histogram bucket is the size of a 4k display
     * with maximum APZ zooming. (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::CustomDistributionMetric peak_pixel_count(3555);

  /**
   * generated from gfx.checkerboard.potential_duration
   */
  /**
   * The total amount of time that we could reasonably be checkerboarding. This is
     * the union of two possibly-intersecting sets of time periods: The first set is
     * that in which checkerboarding was actually happening, since by definition it
     * could potentially be happening. The second set is that in which the APZC is
     * actively transforming content in the compositor, since it could potentially
     * transform it so as to display checkerboarding to the user. Combined with other
     * information, this allows us to meaningfully say how frequently users actually
     * enncounters checkerboarding. (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::TimingDistributionMetric potential_duration(3556);

  /**
   * generated from gfx.checkerboard.severity
   */
  /**
   * An opaque measurement of the severity of a checkerboard event. This doesn't
     * have units, it's just useful for comparing two checkerboard events to see which
     * one is worse, for some implementation-specific definition of "worse". The
     * larger the value, the worse the checkerboarding. (Migrated from the geckoview
     * metric of the same name).
   */
  constexpr impl::CustomDistributionMetric severity(3557);

}
namespace gfx_content {
  /**
   * generated from gfx.content.full_paint_time
   */
  /**
   * Time spent in the full paint pipeline for content until it's ready for
     * composition. For non-webrender this includes `paint_time`, plus rasterization
     * if OMTP is enabled. For webrender, this includes `paint_time`, plus scene
     * building time. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric full_paint_time(3558);

  /**
   * generated from gfx.content.paint_time
   */
  /**
   * Time spent in the main-thread paint pipeline for content. For non-webrender,
     * this includes display list building, layer building, and when OMTP is disabled,
     * rasterization. For webrender, this includes display list building, and
     * webrender display list building. (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::TimingDistributionMetric paint_time(3559);

}
namespace gfx_content_frame_time {
  /**
   * generated from gfx.content.frame_time.from_paint
   */
  /**
   * The time, in percentage of a vsync interval, spent from beginning a paint in
     * the content process until that frame is presented in the compositor. (Migrated
     * from the geckoview metric of the same name).
   */
  constexpr impl::CustomDistributionMetric from_paint(3560);

  /**
   * generated from gfx.content.frame_time.from_vsync
   */
  /**
   * The time, in percentage of a vsync interval, spent from the vsync that started
     * a paint in the content process until that frame is presented in the compositor.
     * (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::CustomDistributionMetric from_vsync(3561);

  /**
   * generated from gfx.content.frame_time.reason
   */
  enum class ReasonLabel: uint16_t {
      eOnTime = 0,
      eNoVsync = 1,
      eMissedComposite = 2,
      eSlowComposite = 3,
      eMissedCompositeMid = 4,
      eMissedCompositeLong = 5,
      eMissedCompositeLow = 6,
      eNoVsyncNoId = 7,
      e__Other__,
    };
  /**
   * The reason that `gfx.content.frame_time.from_paint` recorded a slow (>200ms)
     * result, if any. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, ReasonLabel> reason(3562);

  /**
   * generated from gfx.content.frame_time.with_svg
   */
  /**
   * The time, in percentage of a vsync interval, spent from beginning a paint in
     * the content process until that frame is presented in the compositor, for frames
     * that contained an SVG to be drawn by webrender. (Migrated from the geckoview
     * metric of the same name).
   */
  constexpr impl::CustomDistributionMetric with_svg(3563);

  /**
   * generated from gfx.content.frame_time.without_resource_upload
   */
  /**
   * The time, in percentage of a vsync interval, spent from beginning a paint in
     * the content process until that frame is presented in the compositor by
     * webrender, excluding time spent uploading resources. (Migrated from the
     * geckoview metric of the same name).
   */
  constexpr impl::CustomDistributionMetric without_resource_upload(3564);

  /**
   * generated from gfx.content.frame_time.without_upload
   */
  /**
   * The time, in percentage of a vsync interval, spent from beginning a paint in
     * the content process until that frame is presented in the compositor by
     * webrender, excluding time spent uploading any content. (Migrated from the
     * geckoview metric of the same name).
   */
  constexpr impl::CustomDistributionMetric without_upload(3565);

}
namespace gfx_display {
  /**
   * generated from gfx.display.count
   */
  /**
   * Amount of displays connected to the device (Migrated from the geckoview metric
     * of the same name).
   */
  constexpr impl::QuantityMetric count(3566);

  /**
   * generated from gfx.display.primary_height
   */
  /**
   * Height of the primary display, takes device rotation into account. (Migrated
     * from the geckoview metric of the same name).
   */
  constexpr impl::QuantityMetric primary_height(3567);

  /**
   * generated from gfx.display.primary_width
   */
  /**
   * Width of the primary display, takes device rotation into account. (Migrated
     * from the geckoview metric of the same name).
   */
  constexpr impl::QuantityMetric primary_width(3568);

}
namespace gfx_feature {
  /**
   * generated from gfx.feature.webrender
   */
  /**
   * Whether webrender is enabled or disabled, and why. (Migrated from the geckoview
     * metric of the same name).
   */
  constexpr impl::StringMetric webrender(3569);

}
namespace gfx_hdr {
  /**
   * generated from gfx.hdr.windows_display_colorspace_bitfield
   */
  /**
   * A bitfield representation of the available DXGI color spaces of the connected
     * displays on Windows. See (https://docs.microsoft.com/en-
     * us/windows/desktop/api/dxgicommon/ne-dxgicommon- dxgi_color_space_type) for
     * definitions of color spaces. Each N'th bit of this scalar indicates whether the
     * DXGI color space with index 'N' is available on at least one connected monitor.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * gfx.hdr.windows_display_colorspace_bitfield.
   */
  constexpr impl::QuantityMetric windows_display_colorspace_bitfield(3570);

}
namespace gfx_status {
  /**
   * generated from gfx.status.compositor
   */
  /**
   * Name of the graphics compositor in use. Possible values are "opengl, d3d11,
     * client, webrender or basic" (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::StringMetric compositor(3571);

  /**
   * generated from gfx.status.headless
   */
  /**
   * Boolean indicated whether graphics is running in headless (no display) mode
     * (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::BooleanMetric headless(3572);

  /**
   * generated from gfx.status.last_compositor_gecko_version
   */
  /**
   * The gecko version at the last time a compositor was initialized, and therefore
     * when gfx_status_compositor was last updated. Due to gfx_status_compositor's
     * user lifetime we see lots of unexpected values for the current gecko version.
     * We believe this is because the user has not opened a tab since they were
     * updated to a version where webrender should be enabled on their device. This
     * can be used to verify that theory. (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::StringMetric last_compositor_gecko_version(3573);

}
namespace gpu_process {
  /**
   * generated from gpu_process.crash_fallbacks
   */
  enum class CrashFallbacksLabel: uint16_t {
      eNone = 0,
      eDecodingDisabled = 1,
      eDisabled = 2,
      e__Other__,
    };
  /**
   * How often we use different fallbacks when the GPU process crashes
   */
  constexpr impl::Labeled<impl::CounterMetric, CrashFallbacksLabel> crash_fallbacks(3574);

  /**
   * generated from gpu_process.feature_status
   */
  /**
   * Current status of the GPU process feature
   */
  constexpr impl::StringMetric feature_status(3575);

  /**
   * generated from gpu_process.total_launch_attempts
   */
  /**
   * The number of total GPU process launch attempts.
   */
  constexpr impl::QuantityMetric total_launch_attempts(3576);

  /**
   * generated from gpu_process.unstable_launch_attempts
   */
  /**
   * The number of consecutive unstable launch attempts.
   */
  constexpr impl::QuantityMetric unstable_launch_attempts(3577);

}
namespace paint {
  /**
   * generated from paint.build_displaylist_time
   */
  /**
   * The time to build a Gecko display list.
   */
  constexpr impl::TimingDistributionMetric build_displaylist_time(3578);

}
namespace wr {
  /**
   * generated from wr.framebuild_time
   */
  /**
   * The time to rasterize glyphs for consumption by WebRender.
   */
  constexpr impl::TimingDistributionMetric framebuild_time(3579);

  /**
   * generated from wr.gpu_wait_time
   */
  /**
   * The time spent waiting for the GPU to complete previously issued drawing
     * commands.
   */
  constexpr impl::TimingDistributionMetric gpu_wait_time(3580);

  /**
   * generated from wr.rasterize_blobs_time
   */
  /**
   * The time to rasterize blobs for consumption by WebRender.
   */
  constexpr impl::TimingDistributionMetric rasterize_blobs_time(3581);

  /**
   * generated from wr.rasterize_glyphs_time
   */
  /**
   * The time to rasterize glyphs for consumption by WebRender.
   */
  constexpr impl::TimingDistributionMetric rasterize_glyphs_time(3582);

  /**
   * generated from wr.renderer_time
   */
  /**
   * WebRender renderer time.
   */
  constexpr impl::TimingDistributionMetric renderer_time(3583);

  /**
   * generated from wr.renderer_time_no_sc
   */
  /**
   * WebRender renderer time excluding frames in which shader compilation took
     * place.
   */
  constexpr impl::TimingDistributionMetric renderer_time_no_sc(3584);

  /**
   * generated from wr.scenebuild_time
   */
  /**
   * WebRender scene build time.
   */
  constexpr impl::TimingDistributionMetric scenebuild_time(3585);

  /**
   * generated from wr.sceneswap_time
   */
  /**
   * WebRender scene swap time.
   */
  constexpr impl::TimingDistributionMetric sceneswap_time(3586);

  /**
   * generated from wr.texture_cache_update_time
   */
  /**
   * Time taken by WebRender to update the texture cache.
   */
  constexpr impl::TimingDistributionMetric texture_cache_update_time(3587);

  /**
   * generated from wr.time_to_frame_build
   */
  /**
   * Time elapsed between the construction of a transaction and the associated frame
     * build beginning.
   */
  constexpr impl::TimingDistributionMetric time_to_frame_build(3588);

  /**
   * generated from wr.time_to_render_start
   */
  /**
   * Time elapsed between the construction of a frame and the start of rendering.
   */
  constexpr impl::TimingDistributionMetric time_to_render_start(3589);

}
namespace avif {
  /**
   * generated from avif.a1lx
   */
  enum class A1lxLabel: uint16_t {
      ePresent = 0,
      eAbsent = 1,
      e__Other__,
    };
  /**
   * AV1LayeredImageIndexingProperty (a1lx). (Migrated from the geckoview metric of
     * the same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, A1lxLabel> a1lx(3590);

  /**
   * generated from avif.a1op
   */
  enum class A1opLabel: uint16_t {
      ePresent = 0,
      eAbsent = 1,
      e__Other__,
    };
  /**
   * AVIF OperatingPointSelectorProperty (a1op). (Migrated from the geckoview metric
     * of the same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, A1opLabel> a1op(3591);

  /**
   * generated from avif.alpha
   */
  enum class AlphaLabel: uint16_t {
      eAbsent = 0,
      ePresent = 1,
      e__Other__,
    };
  /**
   * AVIF alpha plane. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, AlphaLabel> alpha(3592);

  /**
   * generated from avif.aom_decode_error
   */
  enum class AomDecodeErrorLabel: uint16_t {
      eError = 0,
      eMemError = 1,
      eAbiMismatch = 2,
      eIncapable = 3,
      eUnsupBitstream = 4,
      eUnsupFeature = 5,
      eCorruptFrame = 6,
      eInvalidParam = 7,
      e__Other__,
    };
  /**
   * Image-decode Error from AOM decoder (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, AomDecodeErrorLabel> aom_decode_error(3593);

  /**
   * generated from avif.bit_depth
   */
  enum class BitDepthLabel: uint16_t {
      eColor8 = 0,
      eColor10 = 1,
      eColor12 = 2,
      eColor16 = 3,
      eUnknown = 4,
      e__Other__,
    };
  /**
   * Bits per pixel of AVIF image. (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::Labeled<impl::CounterMetric, BitDepthLabel> bit_depth(3594);

  /**
   * generated from avif.cicp_cp
   */
  enum class CicpCpLabel: uint16_t {
      eReserved = 0,
      eBt709 = 1,
      eUnspecified = 2,
      eReserved3 = 3,
      eBt470m = 4,
      eBt470bg = 5,
      eBt601 = 6,
      eSmpte240 = 7,
      eGenericFilm = 8,
      eBt2020 = 9,
      eXyz = 10,
      eSmpte431 = 11,
      eSmpte432 = 12,
      eReserved13 = 13,
      eReserved14 = 14,
      eReserved15 = 15,
      eReserved16 = 16,
      eReserved17 = 17,
      eReserved18 = 18,
      eReserved19 = 19,
      eReserved20 = 20,
      eReserved21 = 21,
      eEbu3213 = 22,
      eReservedRest = 23,
      e__Other__,
    };
  /**
   * AVIF CICP colour primaries. (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::Labeled<impl::CounterMetric, CicpCpLabel> cicp_cp(3595);

  /**
   * generated from avif.cicp_mc
   */
  enum class CicpMcLabel: uint16_t {
      eIdentity = 0,
      eBt709 = 1,
      eUnspecified = 2,
      eReserved = 3,
      eFcc = 4,
      eBt470bg = 5,
      eBt601 = 6,
      eSmpte240 = 7,
      eYcgco = 8,
      eBt2020Ncl = 9,
      eBt2020Cl = 10,
      eSmpte2085 = 11,
      eChromatNcl = 12,
      eChromatCl = 13,
      eIctcp = 14,
      eReservedRest = 15,
      e__Other__,
    };
  /**
   * AVIF CICP transfer characteristics. (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, CicpMcLabel> cicp_mc(3596);

  /**
   * generated from avif.cicp_tc
   */
  enum class CicpTcLabel: uint16_t {
      eReserved = 0,
      eBt709 = 1,
      eUnspecified = 2,
      eReserved3 = 3,
      eBt470m = 4,
      eBt470bg = 5,
      eBt601 = 6,
      eSmpte240 = 7,
      eLinear = 8,
      eLog100 = 9,
      eLog100Sqrt10 = 10,
      eIec61966 = 11,
      eBt1361 = 12,
      eSrgb = 13,
      eBt202010bit = 14,
      eBt202012bit = 15,
      eSmpte2084 = 16,
      eSmpte428 = 17,
      eHlg = 18,
      eReservedRest = 19,
      e__Other__,
    };
  /**
   * AVIF CICP transfer characteristics. (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, CicpTcLabel> cicp_tc(3597);

  /**
   * generated from avif.clap
   */
  enum class ClapLabel: uint16_t {
      ePresent = 0,
      eAbsent = 1,
      e__Other__,
    };
  /**
   * AVIF CleanApertureBox (clap). (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::Labeled<impl::CounterMetric, ClapLabel> clap(3598);

  /**
   * generated from avif.colr
   */
  enum class ColrLabel: uint16_t {
      eNclx = 0,
      eIcc = 1,
      eAbsent = 2,
      eBoth = 3,
      e__Other__,
    };
  /**
   * AVIF colour information type. (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::Labeled<impl::CounterMetric, ColrLabel> colr(3599);

  /**
   * generated from avif.dav1d_get_picture_return_value
   */
    struct Dav1dGetPictureReturnValueExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Return value from dav1d_get_picture This event was generated to correspond to
     * the Legacy Telemetry event avif.dav1d_get_picture#return_value.
   */
  constexpr impl::EventMetric<Dav1dGetPictureReturnValueExtra> dav1d_get_picture_return_value(3600);

  /**
   * generated from avif.decode_result
   */
  enum class DecodeResultLabel: uint16_t {
      eSuccess = 0,
      eParseError = 1,
      eNoPrimaryItem = 2,
      eDecodeError = 3,
      eSizeOverflow = 4,
      eOutOfMemory = 5,
      ePipeInitError = 6,
      eWriteBufferError = 7,
      eAlphaYSzMismatch = 8,
      eAlphaYBpcMismatch = 9,
      eIspeMismatch = 10,
      eRenderSizeMismatch = 11,
      eFrameSizeChanged = 12,
      eInvalidCicp = 13,
      eInvalidParseStatus = 14,
      eMissingBrand = 15,
      eFtypNotFirst = 16,
      eNoImage = 17,
      eMultipleMoov = 18,
      eNoMoov = 19,
      eLselNoEssential = 20,
      eA1opNoEssential = 21,
      eA1lxEssential = 22,
      eTxformNoEssential = 23,
      eImageItemType = 24,
      eItemTypeMissing = 25,
      eConstructionMethod = 26,
      eItemLocNotFound = 27,
      eNoItemDataBox = 28,
      eNoSamples = 29,
      eConvertycbcrFailure = 30,
      eUncategorized = 31,
      e__Other__,
    };
  /**
   * Decode result of AVIF image. (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::Labeled<impl::CounterMetric, DecodeResultLabel> decode_result(3601);

  /**
   * generated from avif.decoder
   */
  enum class DecoderLabel: uint16_t {
      eDav1d = 0,
      eAom = 1,
      e__Other__,
    };
  /**
   * Decoder of AVIF image. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, DecoderLabel> decoder(3602);

  /**
   * generated from avif.grid
   */
  enum class GridLabel: uint16_t {
      ePresent = 0,
      eAbsent = 1,
      e__Other__,
    };
  /**
   * AVIF AVIF grid-based image. (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::Labeled<impl::CounterMetric, GridLabel> grid(3603);

  /**
   * generated from avif.ipro
   */
  enum class IproLabel: uint16_t {
      ePresent = 0,
      eAbsent = 1,
      e__Other__,
    };
  /**
   * AVIF ItemProtectionBox (ipro). (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::Labeled<impl::CounterMetric, IproLabel> ipro(3604);

  /**
   * generated from avif.ispe
   */
  enum class IspeLabel: uint16_t {
      eValid = 0,
      eAbsent = 1,
      eBitstreamMismatch = 2,
      e__Other__,
    };
  /**
   * AVIF spatial extents (image size). (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, IspeLabel> ispe(3605);

  /**
   * generated from avif.lsel
   */
  enum class LselLabel: uint16_t {
      ePresent = 0,
      eAbsent = 1,
      e__Other__,
    };
  /**
   * AVIF LayerSelectorProperty (lsel). (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, LselLabel> lsel(3606);

  /**
   * generated from avif.pasp
   */
  enum class PaspLabel: uint16_t {
      eAbsent = 0,
      eSquare = 1,
      eNonsquare = 2,
      eInvalid = 3,
      e__Other__,
    };
  /**
   * AVIF pixel aspect ratio. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, PaspLabel> pasp(3607);

  /**
   * generated from avif.pixi
   */
  enum class PixiLabel: uint16_t {
      eValid = 0,
      eAbsent = 1,
      eBitstreamMismatch = 2,
      e__Other__,
    };
  /**
   * AVIF pixel information (bits per channel). (Migrated from the geckoview metric
     * of the same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, PixiLabel> pixi(3608);

  /**
   * generated from avif.yuv_color_space
   */
  enum class YuvColorSpaceLabel: uint16_t {
      eBt601 = 0,
      eBt709 = 1,
      eBt2020 = 2,
      eIdentity = 3,
      eUnknown = 4,
      e__Other__,
    };
  /**
   * YUV color space of AVIF image. (Migrated from the geckoview metric of the same
     * name).
   */
  constexpr impl::Labeled<impl::CounterMetric, YuvColorSpaceLabel> yuv_color_space(3609);

}
namespace javascript_gc {
  /**
   * generated from javascript.gc.animation
   */
  /**
   * Time spent running JS GC when animating.
   */
  constexpr impl::TimingDistributionMetric animation(3610);

  /**
   * generated from javascript.gc.budget
   */
  /**
   * Requested GC slice budget.
   */
  constexpr impl::TimingDistributionMetric budget(3611);

  /**
   * generated from javascript.gc.budget_overrun
   */
  /**
   * How long a GC slice ran over its budget.
   */
  constexpr impl::TimingDistributionMetric budget_overrun(3612);

  /**
   * generated from javascript.gc.compact_time
   */
  /**
   * The time spent in the compact phase. (Migrated from the geckoview metric of the
     * same name.)
   */
  constexpr impl::TimingDistributionMetric compact_time(3613);

  /**
   * generated from javascript.gc.mark_gray
   */
  /**
   * Time spent marking gray GC objects.
   */
  constexpr impl::TimingDistributionMetric mark_gray(3614);

  /**
   * generated from javascript.gc.mark_roots_time
   */
  /**
   * The time spent marking GC roots. (Migrated from the geckoview metric of the
     * same name.)
   */
  constexpr impl::TimingDistributionMetric mark_roots_time(3615);

  /**
   * generated from javascript.gc.mark_time
   */
  /**
   * The time spent in the mark phase. (Migrated from the geckoview metric of the
     * same name.)
   */
  constexpr impl::TimingDistributionMetric mark_time(3616);

  /**
   * generated from javascript.gc.mark_weak
   */
  /**
   * Time spent marking GC objects held live through weakmaps.
   */
  constexpr impl::TimingDistributionMetric mark_weak(3617);

  /**
   * generated from javascript.gc.max_pause
   */
  /**
   * Longest GC slice in a GC.
   */
  constexpr impl::TimingDistributionMetric max_pause(3618);

  /**
   * generated from javascript.gc.minor_time
   */
  /**
   * The time taked by a minor (nursery) collection. (Migrated from the geckoview
     * metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric minor_time(3619);

  /**
   * generated from javascript.gc.prepare_time
   */
  /**
   * The time spent in the preparation phase. (Migrated from the geckoview metric of
     * the same name.)
   */
  constexpr impl::TimingDistributionMetric prepare_time(3620);

  /**
   * generated from javascript.gc.slice_time
   */
  /**
   * The time spent running a GC slice. (Migrated from the geckoview metric of the
     * same name.)
   */
  constexpr impl::TimingDistributionMetric slice_time(3621);

  /**
   * generated from javascript.gc.sweep_time
   */
  /**
   * The time spent in the sweep phase. (Migrated from the geckoview metric of the
     * same name.)
   */
  constexpr impl::TimingDistributionMetric sweep_time(3622);

  /**
   * generated from javascript.gc.task_start_delay
   */
  /**
   * Delay between queuing a GC task and the task starting.
   */
  constexpr impl::TimingDistributionMetric task_start_delay(3623);

  /**
   * generated from javascript.gc.time_between
   */
  /**
   * Time spent in between garbage collections for the main runtime.
   */
  constexpr impl::TimingDistributionMetric time_between(3624);

  /**
   * generated from javascript.gc.time_between_slices
   */
  /**
   * Time spent in between garbage collections for the main runtime.
   */
  constexpr impl::TimingDistributionMetric time_between_slices(3625);

  /**
   * generated from javascript.gc.total_time
   */
  /**
   * The total time taken by a major collection. (Migrated from the geckoview metric
     * of the same name.)
   */
  constexpr impl::TimingDistributionMetric total_time(3626);

}
namespace javascript_ion {
  /**
   * generated from javascript.ion.compile_time
   */
  /**
   * Time in microseconds of an Ion compilation.
   */
  constexpr impl::TimingDistributionMetric compile_time(3627);

}
namespace performance_clone_deserialize {
  /**
   * generated from performance.clone.deserialize.items
   */
  /**
   * Size of deserialized data, in items
   */
  constexpr impl::CustomDistributionMetric items(3628);

  /**
   * generated from performance.clone.deserialize.size
   */
  /**
   * Size of deserialized data, in bytes
   */
  constexpr impl::MemoryDistributionMetric size(3629);

  /**
   * generated from performance.clone.deserialize.time
   */
  /**
   * Time spent deserializing structured data
   */
  constexpr impl::TimingDistributionMetric time(3630);

}
namespace script_preloader {
  /**
   * generated from script.preloader.mainthread_recompile
   */
  /**
   * How many times we ended up recompiling a script from the script preloader on
     * the main thread. This metric was generated to correspond to the Legacy
     * Telemetry scalar script.preloader.mainthread_recompile.
   */
  constexpr impl::CounterMetric mainthread_recompile(3631);

}
namespace slow_script_warning {
  /**
   * generated from slow_script_warning.shown_browser
   */
    struct ShownBrowserExtra {
      mozilla::Maybe<nsCString> hangDuration;
      mozilla::Maybe<nsCString> uriType;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hangDuration) {
          extraKeys.AppendElement()->AssignASCII("hang_duration");
          extraValues.EmplaceBack(hangDuration.value());
        }
        if (uriType) {
          extraKeys.AppendElement()->AssignASCII("uri_type");
          extraValues.EmplaceBack(uriType.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a slow script hang is resolved. This event was generated to
     * correspond to the Legacy Telemetry event slow_script_warning.shown#browser.
   */
  constexpr impl::EventMetric<ShownBrowserExtra> shown_browser(3632);

  /**
   * generated from slow_script_warning.shown_content
   */
    struct ShownContentExtra {
      mozilla::Maybe<nsCString> endReason;
      mozilla::Maybe<nsCString> hangDuration;
      mozilla::Maybe<uint32_t> nTabDeselect;
      mozilla::Maybe<nsCString> uptime;
      mozilla::Maybe<nsCString> uriType;
      mozilla::Maybe<uint32_t> waitCount;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (endReason) {
          extraKeys.AppendElement()->AssignASCII("end_reason");
          extraValues.EmplaceBack(endReason.value());
        }
        if (hangDuration) {
          extraKeys.AppendElement()->AssignASCII("hang_duration");
          extraValues.EmplaceBack(hangDuration.value());
        }
        if (nTabDeselect) {
          extraKeys.AppendElement()->AssignASCII("n_tab_deselect");
          extraValues.EmplaceBack(nsPrintfCString("%d", nTabDeselect.value()));
        }
        if (uptime) {
          extraKeys.AppendElement()->AssignASCII("uptime");
          extraValues.EmplaceBack(uptime.value());
        }
        if (uriType) {
          extraKeys.AppendElement()->AssignASCII("uri_type");
          extraValues.EmplaceBack(uriType.value());
        }
        if (waitCount) {
          extraKeys.AppendElement()->AssignASCII("wait_count");
          extraValues.EmplaceBack(nsPrintfCString("%d", waitCount.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a slow script hang is resolved. This event was generated to
     * correspond to the Legacy Telemetry event slow_script_warning.shown#content.
   */
  constexpr impl::EventMetric<ShownContentExtra> shown_content(3633);

}
namespace geckoview {
  /**
   * generated from geckoview.content_process_lifetime
   */
  /**
   * The uptime of content processes. (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::TimingDistributionMetric content_process_lifetime(3634);

  /**
   * generated from geckoview.document_site_origins
   */
  /**
   * When a document is loaded, report the number of [site
     * origins](https://searchfox.org/ mozilla-central/rev/
     * 3300072e993ae05d50d5c63d815260367eaf9179/ caps/nsIPrincipal.idl#264) of the
     * entire browser if it has been at least 5 minutes since last time we collect
     * this data. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::CustomDistributionMetric document_site_origins(3635);

  /**
   * generated from geckoview.page_load_progress_time
   */
  /**
   * Time between page load progress starts (0) and completion (100). (Migrated from
     * the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric page_load_progress_time(3636);

  /**
   * generated from geckoview.page_load_time
   */
  /**
   * The time taken to load a page. This includes all static contents, no dynamic
     * content. Loading of about: pages is not counted. Back back navigation
     * (sometimes via BFCache) is included which is a source of bimodality due to the
     * <50ms load times. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric page_load_time(3637);

  /**
   * generated from geckoview.page_reload_time
   */
  /**
   * Time taken to reload a page. This includes all static contents, no dynamic
     * content. Loading of about: pages is not counted. (Migrated from the geckoview
     * metric of the same name).
   */
  constexpr impl::TimingDistributionMetric page_reload_time(3638);

  /**
   * generated from geckoview.per_document_site_origins
   */
  /**
   * When a document is unloaded, report the highest number of [site
     * origins](https://searchfox.org/ mozilla-central/rev/
     * 3300072e993ae05d50d5c63d815260367eaf9179/ caps/nsIPrincipal.idl#264) loaded
     * simultaneously in that document. (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::CustomDistributionMetric per_document_site_origins(3639);

  /**
   * generated from geckoview.startup_runtime
   */
  /**
   * The time taken to initialize GeckoRuntime. (Migrated from the geckoview metric
     * of the same name).
   */
  constexpr impl::TimingDistributionMetric startup_runtime(3640);

}
namespace zero_byte_load {
  /**
   * generated from zero_byte_load.load_css
   */
    struct LoadCssExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#css.
   */
  constexpr impl::EventMetric<LoadCssExtra> load_css(3641);

  /**
   * generated from zero_byte_load.load_dtd
   */
    struct LoadDtdExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#dtd.
   */
  constexpr impl::EventMetric<LoadDtdExtra> load_dtd(3642);

  /**
   * generated from zero_byte_load.load_ftl
   */
    struct LoadFtlExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#ftl.
   */
  constexpr impl::EventMetric<LoadFtlExtra> load_ftl(3643);

  /**
   * generated from zero_byte_load.load_html
   */
    struct LoadHtmlExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#html.
   */
  constexpr impl::EventMetric<LoadHtmlExtra> load_html(3644);

  /**
   * generated from zero_byte_load.load_js
   */
    struct LoadJsExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#js.
   */
  constexpr impl::EventMetric<LoadJsExtra> load_js(3645);

  /**
   * generated from zero_byte_load.load_json
   */
    struct LoadJsonExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#json.
   */
  constexpr impl::EventMetric<LoadJsonExtra> load_json(3646);

  /**
   * generated from zero_byte_load.load_others
   */
    struct LoadOthersExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#others.
   */
  constexpr impl::EventMetric<LoadOthersExtra> load_others(3647);

  /**
   * generated from zero_byte_load.load_png
   */
    struct LoadPngExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#png.
   */
  constexpr impl::EventMetric<LoadPngExtra> load_png(3648);

  /**
   * generated from zero_byte_load.load_properties
   */
    struct LoadPropertiesExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#properties.
   */
  constexpr impl::EventMetric<LoadPropertiesExtra> load_properties(3649);

  /**
   * generated from zero_byte_load.load_svg
   */
    struct LoadSvgExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#svg.
   */
  constexpr impl::EventMetric<LoadSvgExtra> load_svg(3650);

  /**
   * generated from zero_byte_load.load_xhtml
   */
    struct LoadXhtmlExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#xhtml.
   */
  constexpr impl::EventMetric<LoadXhtmlExtra> load_xhtml(3651);

  /**
   * generated from zero_byte_load.load_xml
   */
    struct LoadXmlExtra {
      mozilla::Maybe<bool> cancelled;
      mozilla::Maybe<nsCString> fileName;
      mozilla::Maybe<nsCString> status;
      mozilla::Maybe<bool> sync;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (cancelled) {
          extraKeys.AppendElement()->AssignASCII("cancelled");
          extraValues.AppendElement()->AssignASCII(cancelled.value() ? "true" : "false");
        }
        if (fileName) {
          extraKeys.AppendElement()->AssignASCII("file_name");
          extraValues.EmplaceBack(fileName.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.AppendElement()->AssignASCII(sync.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Collection of zero_byte_load events as part of the Yellow Screen of Death
     * analysis. When a file is loaded synchronously, this event gets recorded in
     * nsJARChannel::Open if the content length is zero. For asynchronous loads, this
     * event gets recorded in onStopRequest. Note that when the load has been
     * cancelled, the consumer could already receive some data, so this event also
     * captures non-zero-byte loads. This event was generated to correspond to the
     * Legacy Telemetry event zero_byte_load.load#xml.
   */
  constexpr impl::EventMetric<LoadXmlExtra> load_xml(3652);

}
namespace preferences {
  /**
   * generated from preferences.prefs_file_was_invalid
   */
  /**
   * Set to true if a failure occurred reading profile/prefs.js. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * preferences.prefs_file_was_invalid.
   */
  constexpr impl::BooleanMetric prefs_file_was_invalid(3653);

}
namespace network_dns {
  /**
   * generated from network.dns.trr_confirmation_context
   */
    struct TrrConfirmationContextExtra {
      mozilla::Maybe<uint32_t> attemptcount;
      mozilla::Maybe<nsCString> captiveportal;
      mozilla::Maybe<nsCString> contextreason;
      mozilla::Maybe<nsCString> failedlookups;
      mozilla::Maybe<nsCString> networkid;
      mozilla::Maybe<nsCString> results;
      mozilla::Maybe<nsCString> time;
      mozilla::Maybe<nsCString> trigger;
      mozilla::Maybe<uint32_t> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (attemptcount) {
          extraKeys.AppendElement()->AssignASCII("attemptCount");
          extraValues.EmplaceBack(nsPrintfCString("%d", attemptcount.value()));
        }
        if (captiveportal) {
          extraKeys.AppendElement()->AssignASCII("captivePortal");
          extraValues.EmplaceBack(captiveportal.value());
        }
        if (contextreason) {
          extraKeys.AppendElement()->AssignASCII("contextReason");
          extraValues.EmplaceBack(contextreason.value());
        }
        if (failedlookups) {
          extraKeys.AppendElement()->AssignASCII("failedLookups");
          extraValues.EmplaceBack(failedlookups.value());
        }
        if (networkid) {
          extraKeys.AppendElement()->AssignASCII("networkID");
          extraValues.EmplaceBack(networkid.value());
        }
        if (results) {
          extraKeys.AppendElement()->AssignASCII("results");
          extraValues.EmplaceBack(results.value());
        }
        if (time) {
          extraKeys.AppendElement()->AssignASCII("time");
          extraValues.EmplaceBack(time.value());
        }
        if (trigger) {
          extraKeys.AppendElement()->AssignASCII("trigger");
          extraValues.EmplaceBack(trigger.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(nsPrintfCString("%d", value.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This telemetry records the status of the TRR confirmation across. The value of
     * the event is one of:   "ok"   "trying" This event was generated to correspond
     * to the Legacy Telemetry event network.dns.trrConfirmation#context.
   */
  constexpr impl::EventMetric<TrrConfirmationContextExtra> trr_confirmation_context(3654);

}
namespace network_sso {
  /**
   * generated from network.sso.entra_success
   */
  enum class EntraSuccessLabel: uint16_t {
      eSuccess = 0,
      eDeviceHeadersMissing = 1,
      ePrtHeadersMissing = 2,
      eBothHeadersMissing = 3,
      eInvalidCookie = 4,
      eNoCredential = 5,
      eBrokerError = 6,
      eInvalidControllerSetup = 7,
      e__Other__,
    };
  /**
   * Counts how often Entra SSO succeeded/failed (macOS only). Labels are ordered in
     * reverse chronological relation to SSO success, meaning the labels higher up are
     * closer to the SSO success. device_headers_missing: only device_headers is
     * missing in the SSO cookie. prt_headers_missing: only prt_headers is missing in
     * the SSO cookie. both_headers_missing: both prt_headers and device_headers are
     * missing in the SSO cookie. invalid_cookie: Failed to parse SSO cookie (could be
     * a null cookie/format is incorrect). no_credential:
     * ASAuthorizationSingleSignOnCredential is not present broker_error: An error
     * from Microsoft's broker. invalid_controller_setup: ASAuthorizationController is
     * setup incorrectly.
   */
  constexpr impl::Labeled<impl::CounterMetric, EntraSuccessLabel> entra_success(3655);

  /**
   * generated from network.sso.total_entra_uses
   */
  /**
   * Counts how often Entra SSO is used (macOS only).
   */
  constexpr impl::CounterMetric total_entra_uses(3656);

}
namespace netwerk {
  /**
   * generated from netwerk.http3_0rtt_state
   */
  enum class Http30rttStateLabel: uint16_t {
      eNotUsed = 0,
      eSucceeded = 1,
      eRejected = 2,
      eConnError = 3,
      eConnClosedByNecko = 4,
      e__Other__,
    };
  /**
   * Gather the outcome of 0-RTT usage: - "not_used": 0RTT_NOT_USED - "succeeded":
     * 0RTT_USED_SUCCESS - "rejected": 0RTT_USED_REJECT - "conn_error":
     * 0RTT_USED_CONN_ERROR - "conn_closed_by_necko": 0RTT_CONN_CLOSED_BY_NECKO
   */
  constexpr impl::Labeled<impl::CounterMetric, Http30rttStateLabel> http3_0rtt_state(3657);

  /**
   * generated from netwerk.http3_0rtt_state_duration
   */
  enum class Http30rttStateDurationLabel: uint16_t {
      eSucceeded = 0,
      eRejected = 1,
      eConnError = 2,
      eConnClosedByNecko = 3,
      eNotUsed = 4,
      e__Other__,
    };
  /**
   * The time a connection was in the 0-RTT state
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, Http30rttStateDurationLabel> http3_0rtt_state_duration(3658);

  /**
   * generated from netwerk.http3_time_to_reuse_idle_connection
   */
  enum class Http3TimeToReuseIdleConnectionLabel: uint16_t {
      eSucceeded = 0,
      eFailed = 1,
      e__Other__,
    };
  /**
   * The time to reuse an idle connection in HTTP3 (ms); keyed by the transaction
     * reusing an idle connection has succeeded or failed
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, Http3TimeToReuseIdleConnectionLabel> http3_time_to_reuse_idle_connection(3659);

  /**
   * generated from netwerk.parent_connect_timeout
   */
  /**
   * Counts how often the parent-connect-timeout timer is necessary to clear up
     * EarlyHintPreloader
   */
  constexpr impl::CounterMetric parent_connect_timeout(3660);

}
namespace network {
  /**
   * generated from network.byte_range_request
   */
  enum class ByteRangeRequestLabel: uint16_t {
      eCacheable = 0,
      eNotCacheable = 1,
      e__Other__,
    };
  /**
   * Counts of cacheable/non-cacheable byte-range requests
   */
  constexpr impl::Labeled<impl::CounterMetric, ByteRangeRequestLabel> byte_range_request(3661);

  /**
   * generated from network.cache_hit_miss_stat_per_cache_size
   */
  /**
   * Hit/Miss count split by cache size in file count Hit 0-5000, Miss 0-5000, Hit
     * 5001-10000, ...
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> cache_hit_miss_stat_per_cache_size(3662);

  /**
   * generated from network.cache_hit_rate_per_cache_size
   */
  /**
   * Hit rate for a specific cache size in file count. The hit rate is split into 20
     * buckets. The key is the cacheSize (20 buckets) and the value is between 0 and
     * 100.
   */
  constexpr impl::Labeled<impl::CustomDistributionMetric, DynamicLabel> cache_hit_rate_per_cache_size(3663);

  /**
   * generated from network.cache_hit_time
   */
  /**
   * Time to open existing cache entry file. (Migrated from the geckoview metric of
     * the same name).
   */
  constexpr impl::TimingDistributionMetric cache_hit_time(3664);

  /**
   * generated from network.cache_miss_time
   */
  /**
   * Time spent to find out a cache entry file is missing. (Migrated from the
     * geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric cache_miss_time(3665);

  /**
   * generated from network.cache_read_time
   */
  /**
   * In the HTTP page channel, time from connection cache read start to cache read
     * end. Corresponds to Legacy histogram HTTP_PAGE_CACHE_READ_TIME_V2 in Desktop.
   */
  constexpr impl::TimingDistributionMetric cache_read_time(3666);

  /**
   * generated from network.complete_load
   */
  /**
   * In the HTTP page channel, time from connection open to complete load (cache
     * read end/until the last byte received) Corresponds to Legacy histogram
     * HTTP_PAGE_COMPLETE_LOAD_V2 in Desktop.
   */
  constexpr impl::TimingDistributionMetric complete_load(3667);

  /**
   * generated from network.complete_load_cached
   */
  /**
   * In the HTTP page channel, time from connection open to cache read end.
     * Corresponds to Legacy histogram HTTP_PAGE_COMPLETE_LOAD_CACHED_V2 in Desktop.
   */
  constexpr impl::TimingDistributionMetric complete_load_cached(3668);

  /**
   * generated from network.complete_load_net
   */
  /**
   * In the HTTP page channel, time from connection open to the last byte received.
     * Corresponds to Legacy histogram HTTP_PAGE_COMPLETE_LOAD_NET_V2 in Desktop.
   */
  constexpr impl::TimingDistributionMetric complete_load_net(3669);

  /**
   * generated from network.cors_authorization_header
   */
  enum class CorsAuthorizationHeaderLabel: uint16_t {
      eAllowed = 0,
      eDisallowed = 1,
      eCoveredByWildcard = 2,
      e__Other__,
    };
  /**
   * Count how many times we see `Authorization` header in `Access-Control-Request-
     * Headers` header and the possible outcomes.
   */
  constexpr impl::Labeled<impl::CounterMetric, CorsAuthorizationHeaderLabel> cors_authorization_header(3670);

  /**
   * generated from network.dns_end
   */
  /**
   * In the HTTP page channel, time from the DNS request being issued to the
     * response. Corresponds to Legacy histogram HTTP_PAGE_DNS_LOOKUP_TIME in Desktop.
     * (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric dns_end(3671);

  /**
   * generated from network.dns_start
   */
  /**
   * In the HTTP page channel, time from connection open to the DNS request being
     * issued. Corresponds to Legacy histogram HTTP_PAGE_DNS_ISSUE_TIME in Desktop.
     * (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric dns_start(3672);

  /**
   * generated from network.first_from_cache
   */
  /**
   * In the HTTP page channel, time from connection open to cache read start.
     * Corresponds to Legacy histogram HTTP_PAGE_OPEN_TO_FIRST_FROM_CACHE_V2 in
     * Desktop.
   */
  constexpr impl::TimingDistributionMetric first_from_cache(3673);

  /**
   * generated from network.first_sent_to_last_received
   */
  /**
   * In the HTTP page channel, time from first byte of request sent to the last byte
     * received. Corresponds to Legacy histogram HTTP_PAGE_FIRST_SENT_TO_LAST_RECEIVED
     * in Desktop. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric first_sent_to_last_received(3674);

  /**
   * generated from network.font_download_end
   */
  /**
   * Time after navigationStart that all webfont downloads are completed. (Migrated
     * from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric font_download_end(3675);

  /**
   * generated from network.http3_avg_read_interval
   */
  enum class Http3AvgReadIntervalLabel: uint16_t {
      eCloudflare = 0,
      eOthers = 1,
      e__Other__,
    };
  /**
   * The average time between read operations in a HTTP/3 connection, keyed by the
     * server header
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, Http3AvgReadIntervalLabel> http3_avg_read_interval(3676);

  /**
   * generated from network.http3_complete_load
   */
  enum class Http3CompleteLoadLabel: uint16_t {
      eUsesHttp3Page = 0,
      eUsesHttp3Sub = 1,
      eSupportsHttp3Page = 2,
      eSupportsHttp3Sub = 3,
      e__Other__,
    };
  /**
   * In the HTTP channel (keys: uses_http3_page, uses_http3_sub,
     * supports_http3_page, supports_http3_sub), overall load time
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, Http3CompleteLoadLabel> http3_complete_load(3677);

  /**
   * generated from network.http3_first_sent_to_last_received
   */
  enum class Http3FirstSentToLastReceivedLabel: uint16_t {
      eUsesHttp3Page = 0,
      eUsesHttp3Sub = 1,
      eSupportsHttp3Page = 2,
      eSupportsHttp3Sub = 3,
      e__Other__,
    };
  /**
   * In the HTTP channel (keys: uses_http3_page, uses_http3_sub,
     * supports_http3_page, supports_http3_sub), time from first byte of request sent
     * to last byte of response received
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, Http3FirstSentToLastReceivedLabel> http3_first_sent_to_last_received(3678);

  /**
   * generated from network.http3_open_to_first_received
   */
  enum class Http3OpenToFirstReceivedLabel: uint16_t {
      eUsesHttp3Page = 0,
      eUsesHttp3Sub = 1,
      eSupportsHttp3Page = 2,
      eSupportsHttp3Sub = 3,
      e__Other__,
    };
  /**
   * In the HTTP channel (keys: uses_http3_page, uses_http3_sub,
     * supports_http3_page, supports_http3_sub), time from open to first byte of reply
     * received
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, Http3OpenToFirstReceivedLabel> http3_open_to_first_received(3679);

  /**
   * generated from network.http3_open_to_first_sent
   */
  enum class Http3OpenToFirstSentLabel: uint16_t {
      eUsesHttp3Page = 0,
      eUsesHttp3Sub = 1,
      eSupportsHttp3Page = 2,
      eSupportsHttp3Sub = 3,
      e__Other__,
    };
  /**
   * In the HTTP channel (keys: uses_http3_page, uses_http3_sub,
     * supports_http3_page, supports_http3_sub), time from open to first byte of
     * request
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, Http3OpenToFirstSentLabel> http3_open_to_first_sent(3680);

  /**
   * generated from network.http3_tls_handshake
   */
  enum class Http3TlsHandshakeLabel: uint16_t {
      eUsesHttp3Page = 0,
      eUsesHttp3Sub = 1,
      eSupportsHttp3Page = 2,
      eSupportsHttp3Sub = 3,
      e__Other__,
    };
  /**
   * In the HTTP channel (keys: uses_http3_page, uses_http3_sub,
     * supports_http3_page, supports_http3_sub), time from secure connection start
     * (after TCP SYN) to ready for HTTP
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, Http3TlsHandshakeLabel> http3_tls_handshake(3681);

  /**
   * generated from network.http_revalidation
   */
  /**
   * In the HTTP page channel, time for positive cache validation Corresponds to
     * Legacy histogram HTTP_PAGE_REVALIDATION in Desktop.
   */
  constexpr impl::TimingDistributionMetric http_revalidation(3682);

  /**
   * generated from network.open_to_first_received
   */
  /**
   * In the HTTP subitem channel,time from connection open to the first byte
     * received. Corresponds to Legacy histogram HTTP_PAGE_OPEN_TO_FIRST_RECEIVED in
     * Desktop. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric open_to_first_received(3683);

  /**
   * generated from network.open_to_first_sent
   */
  /**
   * In the HTTP page channel, time from connection open to the first byte of requst
     * sent. Corresponds to Legacy histogram HTTP_PAGE_OPEN_TO_FIRST_SENT in Desktop.
     * (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric open_to_first_sent(3684);

  /**
   * generated from network.sub_cache_read_time
   */
  /**
   * In the HTTP subitem channel, time from connection cache read start to cache
     * read end. Corresponds to Legacy histogram HTTP_SUB_CACHE_READ_TIME_V2 in
     * Desktop.
   */
  constexpr impl::TimingDistributionMetric sub_cache_read_time(3685);

  /**
   * generated from network.sub_complete_load
   */
  /**
   * In the HTTP subitem channel, time from connection open to complete load (cache
     * read end/until the last byte received) Corresponds to Legacy histogram
     * HTTP_SUB_COMPLETE_LOAD_V2 in Desktop.
   */
  constexpr impl::TimingDistributionMetric sub_complete_load(3686);

  /**
   * generated from network.sub_complete_load_cached
   */
  /**
   * In the HTTP subitem channel, time from connection open to cache read end.
     * Corresponds to Legacy histogram HTTP_SUB_COMPLETE_LOAD_CACHED_V2 in Desktop.
   */
  constexpr impl::TimingDistributionMetric sub_complete_load_cached(3687);

  /**
   * generated from network.sub_complete_load_net
   */
  /**
   * In the HTTP subitem channel, time from connection open to the last byte
     * received. Corresponds to Legacy histogram HTTP_SUB_COMPLETE_LOAD_NET_V2 in
     * Desktop.
   */
  constexpr impl::TimingDistributionMetric sub_complete_load_net(3688);

  /**
   * generated from network.sub_dns_end
   */
  /**
   * In the HTTP subitem channel, time from the DNS request being issued to the
     * response. Corresponds to Legacy histogram HTTP_SUB_DNS_LOOKUP_TIME in Desktop.
     * (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric sub_dns_end(3689);

  /**
   * generated from network.sub_dns_start
   */
  /**
   * In the HTTP subitem channel, time from connection open to the DNS request being
     * issued. Corresponds to Legacy histogram HTTP_SUB_DNS_ISSUE_TIME in Desktop.
     * (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric sub_dns_start(3690);

  /**
   * generated from network.sub_first_from_cache
   */
  /**
   * In the HTTP subitem channel, time from connection open to cache read start.
     * Corresponds to Legacy histogram HTTP_SUB_OPEN_TO_FIRST_FROM_CACHE_V2 in
     * Desktop.
   */
  constexpr impl::TimingDistributionMetric sub_first_from_cache(3691);

  /**
   * generated from network.sub_first_sent_to_last_received
   */
  /**
   * In the HTTP subitem channel, time from first byte of request sent to the last
     * byte received. Corresponds to Legacy histogram
     * HTTP_SUB_FIRST_SENT_TO_LAST_RECEIVED in Desktop. (Migrated from the geckoview
     * metric of the same name).
   */
  constexpr impl::TimingDistributionMetric sub_first_sent_to_last_received(3692);

  /**
   * generated from network.sub_http_revalidation
   */
  /**
   * In the HTTP subitem channel, time for positive cache validation Corresponds to
     * Legacy histogram HTTP_SUB_REVALIDATION in Desktop.
   */
  constexpr impl::TimingDistributionMetric sub_http_revalidation(3693);

  /**
   * generated from network.sub_open_to_first_received
   */
  /**
   * In the HTTP subitem channel, time from connection open to the first byte
     * received. Corresponds to Legacy histogram HTTP_SUB_OPEN_TO_FIRST_RECEIVED in
     * Desktop. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric sub_open_to_first_received(3694);

  /**
   * generated from network.sub_open_to_first_sent
   */
  /**
   * In the HTTP subitem channel, time from connection open to the first byte of
     * requst sent. Corresponds to Legacy histogram HTTP_SUB_OPEN_TO_FIRST_SENT in
     * Desktop. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric sub_open_to_first_sent(3695);

  /**
   * generated from network.sub_tcp_connection
   */
  /**
   * In the HTTP subitem channel, time from the TCP SYN packet is received to the
     * connection is established and ready for HTTP. Corresponds to Legacy histogram
     * HTTP_SUB_TCP_CONNECTION_2 in Desktop (Migrated from the geckoview metric of the
     * same name).
   */
  constexpr impl::TimingDistributionMetric sub_tcp_connection(3696);

  /**
   * generated from network.sub_tls_handshake
   */
  /**
   * In the HTTP subitem channel, time from after the TCP SYN packet is received to
     * the secure connection is established and ready for HTTP. Corresponds to Legacy
     * histogram HTTP_SUB_TLS_HANDSHAKE in Desktop. (Migrated from the geckoview
     * metric of the same name).
   */
  constexpr impl::TimingDistributionMetric sub_tls_handshake(3697);

  /**
   * generated from network.sup_http3_tcp_connection
   */
  enum class SupHttp3TcpConnectionLabel: uint16_t {
      eSupportsHttp3Page = 0,
      eSupportsHttp3Sub = 1,
      e__Other__,
    };
  /**
   * In the HTTP channel (keys: supports_http3_page, supports_http3_sub), time from
     * TCP SYN to ready for HTTP
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, SupHttp3TcpConnectionLabel> sup_http3_tcp_connection(3698);

  /**
   * generated from network.system_channel_addon_status
   */
  enum class SystemChannelAddonStatusLabel: uint16_t {
      eOk = 0,
      eOffline = 1,
      eConnectivity = 2,
      eDns = 3,
      eConnectFail = 4,
      eTlsFail = 5,
      eHttpStatus = 6,
      eCancel = 7,
      eTimeout = 8,
      eReset = 9,
      eRefused = 10,
      ePartial = 11,
      eOther = 12,
      e__Other__,
    };
  /**
   * Counts the status of succeeded and failed requests to addons.mozilla.org
   */
  constexpr impl::Labeled<impl::CounterMetric, SystemChannelAddonStatusLabel> system_channel_addon_status(3699);

  /**
   * generated from network.system_channel_addonversion_status
   */
  enum class SystemChannelAddonversionStatusLabel: uint16_t {
      eOk = 0,
      eOffline = 1,
      eConnectivity = 2,
      eDns = 3,
      eConnectFail = 4,
      eTlsFail = 5,
      eHttpStatus = 6,
      eCancel = 7,
      eTimeout = 8,
      eReset = 9,
      eRefused = 10,
      ePartial = 11,
      eOther = 12,
      e__Other__,
    };
  /**
   * Counts the status of succeeded and failed requests to *.addons.mozilla.org
   */
  constexpr impl::Labeled<impl::CounterMetric, SystemChannelAddonversionStatusLabel> system_channel_addonversion_status(3700);

  /**
   * generated from network.system_channel_other_status
   */
  enum class SystemChannelOtherStatusLabel: uint16_t {
      eOk = 0,
      eOffline = 1,
      eConnectivity = 2,
      eDns = 3,
      eConnectFail = 4,
      eTlsFail = 5,
      eHttpStatus = 6,
      eCancel = 7,
      eTimeout = 8,
      eReset = 9,
      eRefused = 10,
      ePartial = 11,
      eOther = 12,
      e__Other__,
    };
  /**
   * Counts the status of succeeded and failed requests to other mozilla.org domains
   */
  constexpr impl::Labeled<impl::CounterMetric, SystemChannelOtherStatusLabel> system_channel_other_status(3701);

  /**
   * generated from network.system_channel_remote_settings_status
   */
  enum class SystemChannelRemoteSettingsStatusLabel: uint16_t {
      eOk = 0,
      eOffline = 1,
      eConnectivity = 2,
      eDns = 3,
      eConnectFail = 4,
      eTlsFail = 5,
      eHttpStatus = 6,
      eCancel = 7,
      eTimeout = 8,
      eReset = 9,
      eRefused = 10,
      ePartial = 11,
      eOther = 12,
      e__Other__,
    };
  /**
   * Counts the status of succeeded and failed requests to
     * firefox.settings.services.mozilla.com
   */
  constexpr impl::Labeled<impl::CounterMetric, SystemChannelRemoteSettingsStatusLabel> system_channel_remote_settings_status(3702);

  /**
   * generated from network.system_channel_success_or_failure
   */
  enum class SystemChannelSuccessOrFailureLabel: uint16_t {
      eOk = 0,
      eOffline = 1,
      eConnectivity = 2,
      eDns = 3,
      eConnectFail = 4,
      eTlsFail = 5,
      eHttpStatus = 6,
      eCancel = 7,
      eTimeout = 8,
      eReset = 9,
      eRefused = 10,
      ePartial = 11,
      eOther = 12,
      e__Other__,
    };
  /**
   * Counts the number of succeeded and failed channels with a system principal to a
     * mozilla domain. Label contains ok or failure reason.
   */
  constexpr impl::Labeled<impl::CounterMetric, SystemChannelSuccessOrFailureLabel> system_channel_success_or_failure(3703);

  /**
   * generated from network.system_channel_telemetry_status
   */
  enum class SystemChannelTelemetryStatusLabel: uint16_t {
      eOk = 0,
      eOffline = 1,
      eConnectivity = 2,
      eDns = 3,
      eConnectFail = 4,
      eTlsFail = 5,
      eHttpStatus = 6,
      eCancel = 7,
      eTimeout = 8,
      eReset = 9,
      eRefused = 10,
      ePartial = 11,
      eOther = 12,
      e__Other__,
    };
  /**
   * Counts the status of succeeded and failed requests to
     * incoming.telemetry.mozilla.org
   */
  constexpr impl::Labeled<impl::CounterMetric, SystemChannelTelemetryStatusLabel> system_channel_telemetry_status(3704);

  /**
   * generated from network.system_channel_update_status
   */
  enum class SystemChannelUpdateStatusLabel: uint16_t {
      eOk = 0,
      eOffline = 1,
      eConnectivity = 2,
      eDns = 3,
      eConnectFail = 4,
      eTlsFail = 5,
      eHttpStatus = 6,
      eCancel = 7,
      eTimeout = 8,
      eReset = 9,
      eRefused = 10,
      ePartial = 11,
      eOther = 12,
      e__Other__,
    };
  /**
   * Counts the status of succeeded and failed requests to aus5.mozilla.org
   */
  constexpr impl::Labeled<impl::CounterMetric, SystemChannelUpdateStatusLabel> system_channel_update_status(3705);

  /**
   * generated from network.tcp_connection
   */
  /**
   * In the HTTP page channel, time from the TCP SYN packet is received to the
     * connection is established and ready for HTTP. Corresponds to Legacy histogram
     * HTTP_PAGE_TCP_CONNECTION_2 in Desktop (Migrated from the geckoview metric of
     * the same name).
   */
  constexpr impl::TimingDistributionMetric tcp_connection(3706);

  /**
   * generated from network.tls_early_data_accepted
   */
  enum class TlsEarlyDataAcceptedLabel: uint16_t {
      eAccepted = 0,
      eRejected = 1,
      e__Other__,
    };
  /**
   * TLS early data was used and it was accepted or rejected by the remote host.
   */
  constexpr impl::Labeled<impl::CounterMetric, TlsEarlyDataAcceptedLabel> tls_early_data_accepted(3707);

  /**
   * generated from network.tls_early_data_bytes_written
   */
  /**
   * Amount of bytes sent using TLS early data at the start of a TLS connection for
     * a given channel.
   */
  constexpr impl::CustomDistributionMetric tls_early_data_bytes_written(3708);

  /**
   * generated from network.tls_early_data_negotiated
   */
  enum class TlsEarlyDataNegotiatedLabel: uint16_t {
      eNotAvailable = 0,
      eAvailableAndUsed = 1,
      eAvailableButNotUsed = 2,
      e__Other__,
    };
  /**
   * Sending TLS early data was not possible, possible and used, or possible but not
     * used.
   */
  constexpr impl::Labeled<impl::CounterMetric, TlsEarlyDataNegotiatedLabel> tls_early_data_negotiated(3709);

  /**
   * generated from network.tls_handshake
   */
  /**
   * In the HTTP page channel, time from after the TCP SYN packet is received to the
     * secure connection is established and ready for HTTP. Corresponds to Legacy
     * histogram HTTP_PAGE_TLS_HANDSHAKE in Desktop. (Migrated from the geckoview
     * metric of the same name).
   */
  constexpr impl::TimingDistributionMetric tls_handshake(3710);

}
namespace opaque_response_blocking {
  /**
   * generated from opaque.response.blocking.cross_origin_opaque_response_count
   */
  /**
   * The number of loads of cross origin opaque resources. This metric was generated
     * to correspond to the Legacy Telemetry scalar
     * opaque.response.blocking.cross_origin_opaque_response_count.
   */
  constexpr impl::CounterMetric cross_origin_opaque_response_count(3711);

  /**
   * generated from opaque.response.blocking.javascript_validation_count
   */
  /**
   * The number of times we run the JS validator. This metric was generated to
     * correspond to the Legacy Telemetry scalar
     * opaque.response.blocking.javascript_validation_count.
   */
  constexpr impl::CounterMetric javascript_validation_count(3712);

}
namespace parsing {
  /**
   * generated from parsing.svg_unusual_pcdata
   */
  /**
   * The rate of svg elements that have child elements during parsing, where their
     * HTML counterpart would not have children.
   */
  constexpr impl::RateMetric svg_unusual_pcdata(3713);

}
namespace ysod {
  /**
   * generated from ysod.shown_ysod
   */
    struct ShownYsodExtra {
      mozilla::Maybe<nsCString> destroyed;
      mozilla::Maybe<uint32_t> errorCode;
      mozilla::Maybe<bool> hidden;
      mozilla::Maybe<nsCString> lastLine;
      mozilla::Maybe<uint32_t> lastLineLen;
      mozilla::Maybe<nsCString> location;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (destroyed) {
          extraKeys.AppendElement()->AssignASCII("destroyed");
          extraValues.EmplaceBack(destroyed.value());
        }
        if (errorCode) {
          extraKeys.AppendElement()->AssignASCII("error_code");
          extraValues.EmplaceBack(nsPrintfCString("%d", errorCode.value()));
        }
        if (hidden) {
          extraKeys.AppendElement()->AssignASCII("hidden");
          extraValues.AppendElement()->AssignASCII(hidden.value() ? "true" : "false");
        }
        if (lastLine) {
          extraKeys.AppendElement()->AssignASCII("last_line");
          extraValues.EmplaceBack(lastLine.value());
        }
        if (lastLineLen) {
          extraKeys.AppendElement()->AssignASCII("last_line_len");
          extraValues.EmplaceBack(nsPrintfCString("%d", lastLineLen.value()));
        }
        if (location) {
          extraKeys.AppendElement()->AssignASCII("location");
          extraValues.EmplaceBack(location.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This event is recorded only for Firefox UI documents (chrome). Recorded when a
     * Yellow Screen of Death is shown. The `value` is a url on which the error
     * happened. Yellow Screen of Death happens when XML or XHTML document encounters
     * a parsing error. It is commonly a result of the document being malformed or
     * missing DTD entity. This data should be reviewed periodically for urls that
     * error frequently. This event was generated to correspond to the Legacy
     * Telemetry event ysod.shown#ysod.
   */
  constexpr impl::EventMetric<ShownYsodExtra> shown_ysod(3714);

}
namespace cert_signature_cache {
  /**
   * generated from cert_signature_cache.hits
   */
  /**
   * How often a certificate signature to be verified is in the cache already.
   */
  constexpr impl::NumeratorMetric hits(3715);

  /**
   * generated from cert_signature_cache.total
   */
  /**
   * How many certificate signature verifications are performed.
   */
  constexpr impl::DenominatorMetric total(3716);

}
namespace cert_trust_cache {
  /**
   * generated from cert_trust_cache.hits
   */
  /**
   * How often a certificate's trust is in the cache already.
   */
  constexpr impl::NumeratorMetric hits(3717);

  /**
   * generated from cert_trust_cache.total
   */
  /**
   * How many certificate trust lookups are performed.
   */
  constexpr impl::DenominatorMetric total(3718);

}
namespace cert_verifier {
  /**
   * generated from cert_verifier.cert_revocation_mechanisms
   */
  enum class CertRevocationMechanismsLabel: uint16_t {
      eCrlite = 0,
      eStapledocsp = 1,
      eCachedocsp = 2,
      eOcsp = 3,
      eOnecrl = 4,
      eShortvalidity = 5,
      e__Other__,
    };
  /**
   * Which revocation checking mechanisms were used in a TLS handshake?
   */
  constexpr impl::Labeled<impl::CounterMetric, CertRevocationMechanismsLabel> cert_revocation_mechanisms(3719);

  /**
   * generated from cert_verifier.crlite_status
   */
  enum class CrliteStatusLabel: uint16_t {
      eNoFilter = 0,
      eNotCovered = 1,
      eNotEnrolled = 2,
      eNotRevoked = 3,
      eRevokedInFilter = 4,
      eRevokedInStash = 5,
      e__Other__,
    };
  /**
   * Counts the number of times different CRLite statuses were returned.
   */
  constexpr impl::Labeled<impl::CounterMetric, CrliteStatusLabel> crlite_status(3720);

  /**
   * generated from cert_verifier.crlite_vs_ocsp_result
   */
  enum class CrliteVsOcspResultLabel: uint16_t {
      eCrliterevocspfail = 0,
      eCrliterevocspok = 1,
      eCrliterevocsprev = 2,
      eCrliterevocspunk = 3,
      eCrliterevocspsoft = 4,
      e__Other__,
    };
  /**
   * The OCSP result when CRLite claims a certificate is revoked.
   */
  constexpr impl::Labeled<impl::CounterMetric, CrliteVsOcspResultLabel> crlite_vs_ocsp_result(3721);

  /**
   * generated from cert_verifier.trust_obj_count
   */
  /**
   * The total number of trust objects in cert9.db
   */
  constexpr impl::QuantityMetric trust_obj_count(3722);

}
namespace sct_signature_cache {
  /**
   * generated from sct_signature_cache.hits
   */
  /**
   * How often an SCT signature to be verified is in the cache already.
   */
  constexpr impl::NumeratorMetric hits(3723);

  /**
   * generated from sct_signature_cache.total
   */
  /**
   * How many SCT signature verifications are performed.
   */
  constexpr impl::DenominatorMetric total(3724);

}
namespace cert_compression {
  /**
   * generated from cert_compression.failures
   */
  enum class FailuresLabel: uint16_t {
      eZlib = 0,
      eBrotli = 1,
      eZstd = 2,
      e__Other__,
    };
  /**
   * The number of times each certificate compression algorithm returned an error.
   */
  constexpr impl::Labeled<impl::CounterMetric, FailuresLabel> failures(3725);

}
namespace cert_storage {
  /**
   * generated from cert_storage.memory
   */
  /**
   * Heap memory used by cert_storage.
   */
  constexpr impl::MemoryDistributionMetric memory(3726);

}
namespace cert_verification_time {
  /**
   * generated from cert_verification_time.failure
   */
  /**
   * The time it takes to fail to verify a certificate in a TLS handshake.
   */
  constexpr impl::TimingDistributionMetric failure(3727);

  /**
   * generated from cert_verification_time.success
   */
  /**
   * The time it takes to successfully verify a certificate in a TLS handshake.
   */
  constexpr impl::TimingDistributionMetric success(3728);

}
namespace data_storage {
  /**
   * generated from data_storage.alternate_services
   */
  /**
   * The number of entries stored in the AlternateServices nsIDataStorage
   */
  constexpr impl::QuantityMetric alternate_services(3729);

  /**
   * generated from data_storage.client_auth_remember_list
   */
  /**
   * The number of entries stored in the ClientAuthRememberList nsIDataStorage
   */
  constexpr impl::QuantityMetric client_auth_remember_list(3730);

  /**
   * generated from data_storage.site_security_service_state
   */
  /**
   * The number of entries stored in the SiteSecurityServiceState nsIDataStorage
   */
  constexpr impl::QuantityMetric site_security_service_state(3731);

}
namespace ocsp_request_time {
  /**
   * generated from ocsp_request_time.cancel
   */
  /**
   * The time it takes to make an OCSP request that was cancelled.
   */
  constexpr impl::TimingDistributionMetric cancel(3732);

  /**
   * generated from ocsp_request_time.failure
   */
  /**
   * The time it takes to make an OCSP request that failed.
   */
  constexpr impl::TimingDistributionMetric failure(3733);

  /**
   * generated from ocsp_request_time.success
   */
  /**
   * The time it takes to make an OCSP request that succeeded.
   */
  constexpr impl::TimingDistributionMetric success(3734);

}
namespace pkcs11 {
  /**
   * generated from pkcs11.third_party_modules_loaded
   */
  /**
   * The number of third-party PKCS#11 modules loaded.
   */
  constexpr impl::QuantityMetric third_party_modules_loaded(3735);

}
namespace tls {
  /**
   * generated from tls.certificate_verifications
   */
  /**
   * The total number of successful TLS server certificate verifications.
   */
  constexpr impl::DenominatorMetric certificate_verifications(3736);

  /**
   * generated from tls.xyber_intolerance_reason
   */
  enum class XyberIntoleranceReasonLabel: uint16_t {
      ePrConnectResetError = 0,
      ePrEndOfFileError = 1,
      eSslErrorBadHandshakeHashValue = 2,
      eSslErrorBadMacAlert = 3,
      eSslErrorBadMacRead = 4,
      eSslErrorDecodeErrorAlert = 5,
      eSslErrorHandshakeFailed = 6,
      eSslErrorHandshakeFailureAlert = 7,
      eSslErrorHandshakeUnexpectedAlert = 8,
      eSslErrorIllegalParameterAlert = 9,
      eSslErrorInternalErrorAlert = 10,
      eSslErrorKeyExchangeFailure = 11,
      eSslErrorNoCypherOverlap = 12,
      eSslErrorProtocolVersionAlert = 13,
      eSslErrorRxUnexpectedRecordType = 14,
      eSslErrorRxMalformedHybridKeyShare = 15,
      eSslErrorUnsupportedVersion = 16,
      e__Other__,
    };
  /**
   * The error that was returned from a failed TLS 1.3 handshake in which the client
     * sent a mlkem768x25519 key share (see tlsIntoleranceTelemetryBucket() in
     * nsNSSIOLayer.cpp).
   */
  constexpr impl::Labeled<impl::CounterMetric, XyberIntoleranceReasonLabel> xyber_intolerance_reason(3737);

}
namespace verification_used_cert_from {
  /**
   * generated from verification_used_cert_from.built_in_roots_module
   */
  /**
   * How many successfully-built certificate chains used a certificate from the
     * built-in roots module.
   */
  constexpr impl::NumeratorMetric built_in_roots_module(3738);

  /**
   * generated from verification_used_cert_from.nss_cert_db
   */
  /**
   * How many successfully-built certificate chains used a certificate from the NSS
     * cert DB.
   */
  constexpr impl::NumeratorMetric nss_cert_db(3739);

  /**
   * generated from verification_used_cert_from.preloaded_intermediates
   */
  /**
   * How many successfully-built certificate chains used a certificate from
     * preloaded intermediates.
   */
  constexpr impl::NumeratorMetric preloaded_intermediates(3740);

  /**
   * generated from verification_used_cert_from.third_party_certificates
   */
  /**
   * How many successfully-built certificate chains used a third-party certificate
     * from the OS.
   */
  constexpr impl::NumeratorMetric third_party_certificates(3741);

  /**
   * generated from verification_used_cert_from.tls_handshake
   */
  /**
   * How many successfully-built certificate chains used a certificate from the TLS
     * handshake.
   */
  constexpr impl::NumeratorMetric tls_handshake(3742);

}
namespace uptake_remotecontent_result {
  /**
   * generated from uptake.remotecontent.result.uptake_normandy
   */
    struct UptakeNormandyExtra {
      mozilla::Maybe<nsCString> age;
      mozilla::Maybe<nsCString> duration;
      mozilla::Maybe<nsCString> errorname;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> timestamp;
      mozilla::Maybe<nsCString> trigger;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (age) {
          extraKeys.AppendElement()->AssignASCII("age");
          extraValues.EmplaceBack(age.value());
        }
        if (duration) {
          extraKeys.AppendElement()->AssignASCII("duration");
          extraValues.EmplaceBack(duration.value());
        }
        if (errorname) {
          extraKeys.AppendElement()->AssignASCII("errorName");
          extraValues.EmplaceBack(errorname.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (timestamp) {
          extraKeys.AppendElement()->AssignASCII("timestamp");
          extraValues.EmplaceBack(timestamp.value());
        }
        if (trigger) {
          extraKeys.AppendElement()->AssignASCII("trigger");
          extraValues.EmplaceBack(trigger.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Was the remote content successfully pulled? This uptake telemetry allows to
     * monitor the behaviour of our clients when it comes to fetching data from remote
     * servers. This helps defect-detection and allow observation of the proportion of
     * success among clients and sources, the distribution of error causes, and its
     * evolution over time. This event was generated to correspond to the Legacy
     * Telemetry event uptake.remotecontent.result.uptake#normandy.
   */
  constexpr impl::EventMetric<UptakeNormandyExtra> uptake_normandy(3743);

  /**
   * generated from uptake.remotecontent.result.uptake_remotesettings
   */
    struct UptakeRemotesettingsExtra {
      mozilla::Maybe<nsCString> age;
      mozilla::Maybe<nsCString> duration;
      mozilla::Maybe<nsCString> errorname;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> timestamp;
      mozilla::Maybe<nsCString> trigger;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (age) {
          extraKeys.AppendElement()->AssignASCII("age");
          extraValues.EmplaceBack(age.value());
        }
        if (duration) {
          extraKeys.AppendElement()->AssignASCII("duration");
          extraValues.EmplaceBack(duration.value());
        }
        if (errorname) {
          extraKeys.AppendElement()->AssignASCII("errorName");
          extraValues.EmplaceBack(errorname.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (timestamp) {
          extraKeys.AppendElement()->AssignASCII("timestamp");
          extraValues.EmplaceBack(timestamp.value());
        }
        if (trigger) {
          extraKeys.AppendElement()->AssignASCII("trigger");
          extraValues.EmplaceBack(trigger.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Was the remote content successfully pulled? This uptake telemetry allows to
     * monitor the behaviour of our clients when it comes to fetching data from remote
     * servers. This helps defect-detection and allow observation of the proportion of
     * success among clients and sources, the distribution of error causes, and its
     * evolution over time. This event was generated to correspond to the Legacy
     * Telemetry event uptake.remotecontent.result.uptake#remotesettings.
   */
  constexpr impl::EventMetric<UptakeRemotesettingsExtra> uptake_remotesettings(3744);

}
namespace client_association {
  /**
   * generated from client_association.legacy_client_id
   */
  /**
   * The legacy Telemetry client ID associated with this user profile.
   */
  constexpr impl::UuidMetric legacy_client_id(3745);

  /**
   * generated from client_association.uid
   */
  /**
   * The Mozilla Account UID associated with the user.
   */
  constexpr impl::StringMetric uid(3746);

}
namespace fxa {
  /**
   * generated from fxa.connect_account
   */
    struct ConnectAccountExtra {
      mozilla::Maybe<nsCString> fxa;
      mozilla::Maybe<nsCString> sync;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxa) {
          extraKeys.AppendElement()->AssignASCII("fxa");
          extraValues.EmplaceBack(fxa.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.EmplaceBack(sync.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records when a Firefox Account, or a Firefox Account service, is explicitly
     * connected from the browser via an intentional user action. This event was
     * generated to correspond to the Legacy Telemetry event fxa.connect#account.
   */
  constexpr impl::EventMetric<ConnectAccountExtra> connect_account(3747);

  /**
   * generated from fxa.disconnect_account
   */
    struct DisconnectAccountExtra {
      mozilla::Maybe<nsCString> fxa;
      mozilla::Maybe<nsCString> sync;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxa) {
          extraKeys.AppendElement()->AssignASCII("fxa");
          extraValues.EmplaceBack(fxa.value());
        }
        if (sync) {
          extraKeys.AppendElement()->AssignASCII("sync");
          extraValues.EmplaceBack(sync.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records when a Firefox Account, or a Firefox Account service, is explicitly
     * disconnected from the browser via an intentional user action. This event was
     * generated to correspond to the Legacy Telemetry event fxa.disconnect#account.
   */
  constexpr impl::EventMetric<DisconnectAccountExtra> disconnect_account(3748);

}
namespace fxa_app_menu {
  /**
   * generated from fxa_app_menu.click_account_settings
   */
    struct ClickAccountSettingsExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#account_settings.
   */
  constexpr impl::EventMetric<ClickAccountSettingsExtra> click_account_settings(3749);

  /**
   * generated from fxa_app_menu.click_cad
   */
    struct ClickCadExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#cad.
   */
  constexpr impl::EventMetric<ClickCadExtra> click_cad(3750);

  /**
   * generated from fxa_app_menu.click_login
   */
    struct ClickLoginExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#login.
   */
  constexpr impl::EventMetric<ClickLoginExtra> click_login(3751);

  /**
   * generated from fxa_app_menu.click_monitor_cta
   */
    struct ClickMonitorCtaExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#monitor_cta.
   */
  constexpr impl::EventMetric<ClickMonitorCtaExtra> click_monitor_cta(3752);

  /**
   * generated from fxa_app_menu.click_open_monitor
   */
    struct ClickOpenMonitorExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#open_monitor.
   */
  constexpr impl::EventMetric<ClickOpenMonitorExtra> click_open_monitor(3753);

  /**
   * generated from fxa_app_menu.click_open_send
   */
    struct ClickOpenSendExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#open_send.
   */
  constexpr impl::EventMetric<ClickOpenSendExtra> click_open_send(3754);

  /**
   * generated from fxa_app_menu.click_relay_cta
   */
    struct ClickRelayCtaExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#relay_cta.
   */
  constexpr impl::EventMetric<ClickRelayCtaExtra> click_relay_cta(3755);

  /**
   * generated from fxa_app_menu.click_send_tab
   */
    struct ClickSendTabExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#send_tab.
   */
  constexpr impl::EventMetric<ClickSendTabExtra> click_send_tab(3756);

  /**
   * generated from fxa_app_menu.click_sync_cta
   */
    struct ClickSyncCtaExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#sync_cta.
   */
  constexpr impl::EventMetric<ClickSyncCtaExtra> click_sync_cta(3757);

  /**
   * generated from fxa_app_menu.click_sync_now
   */
    struct ClickSyncNowExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#sync_now.
   */
  constexpr impl::EventMetric<ClickSyncNowExtra> click_sync_now(3758);

  /**
   * generated from fxa_app_menu.click_sync_settings
   */
    struct ClickSyncSettingsExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#sync_settings.
   */
  constexpr impl::EventMetric<ClickSyncSettingsExtra> click_sync_settings(3759);

  /**
   * generated from fxa_app_menu.click_sync_tabs
   */
    struct ClickSyncTabsExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#sync_tabs.
   */
  constexpr impl::EventMetric<ClickSyncTabsExtra> click_sync_tabs(3760);

  /**
   * generated from fxa_app_menu.click_sync_tabs_sidebar
   */
    struct ClickSyncTabsSidebarExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#sync_tabs_sidebar.
   */
  constexpr impl::EventMetric<ClickSyncTabsSidebarExtra> click_sync_tabs_sidebar(3761);

  /**
   * generated from fxa_app_menu.click_toolbar_icon
   */
    struct ClickToolbarIconExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#toolbar_icon.
   */
  constexpr impl::EventMetric<ClickToolbarIconExtra> click_toolbar_icon(3762);

  /**
   * generated from fxa_app_menu.click_unver_sync_settings
   */
    struct ClickUnverSyncSettingsExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#unver_sync_settings.
   */
  constexpr impl::EventMetric<ClickUnverSyncSettingsExtra> click_unver_sync_settings(3763);

  /**
   * generated from fxa_app_menu.click_vpn_cta
   */
    struct ClickVpnCtaExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA menu in the app (hamburger) menu
     * This event was generated to correspond to the Legacy Telemetry event
     * fxa_app_menu.click#vpn_cta.
   */
  constexpr impl::EventMetric<ClickVpnCtaExtra> click_vpn_cta(3764);

}
namespace fxa_avatar_menu {
  /**
   * generated from fxa_avatar_menu.click_account_settings
   */
    struct ClickAccountSettingsExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#account_settings.
   */
  constexpr impl::EventMetric<ClickAccountSettingsExtra> click_account_settings(3765);

  /**
   * generated from fxa_avatar_menu.click_cad
   */
    struct ClickCadExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#cad.
   */
  constexpr impl::EventMetric<ClickCadExtra> click_cad(3766);

  /**
   * generated from fxa_avatar_menu.click_login
   */
    struct ClickLoginExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#login.
   */
  constexpr impl::EventMetric<ClickLoginExtra> click_login(3767);

  /**
   * generated from fxa_avatar_menu.click_monitor_cta
   */
    struct ClickMonitorCtaExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#monitor_cta.
   */
  constexpr impl::EventMetric<ClickMonitorCtaExtra> click_monitor_cta(3768);

  /**
   * generated from fxa_avatar_menu.click_open_monitor
   */
    struct ClickOpenMonitorExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#open_monitor.
   */
  constexpr impl::EventMetric<ClickOpenMonitorExtra> click_open_monitor(3769);

  /**
   * generated from fxa_avatar_menu.click_open_send
   */
    struct ClickOpenSendExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#open_send.
   */
  constexpr impl::EventMetric<ClickOpenSendExtra> click_open_send(3770);

  /**
   * generated from fxa_avatar_menu.click_relay_cta
   */
    struct ClickRelayCtaExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#relay_cta.
   */
  constexpr impl::EventMetric<ClickRelayCtaExtra> click_relay_cta(3771);

  /**
   * generated from fxa_avatar_menu.click_send_tab
   */
    struct ClickSendTabExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#send_tab.
   */
  constexpr impl::EventMetric<ClickSendTabExtra> click_send_tab(3772);

  /**
   * generated from fxa_avatar_menu.click_sync_cta
   */
    struct ClickSyncCtaExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#sync_cta.
   */
  constexpr impl::EventMetric<ClickSyncCtaExtra> click_sync_cta(3773);

  /**
   * generated from fxa_avatar_menu.click_sync_now
   */
    struct ClickSyncNowExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#sync_now.
   */
  constexpr impl::EventMetric<ClickSyncNowExtra> click_sync_now(3774);

  /**
   * generated from fxa_avatar_menu.click_sync_settings
   */
    struct ClickSyncSettingsExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#sync_settings.
   */
  constexpr impl::EventMetric<ClickSyncSettingsExtra> click_sync_settings(3775);

  /**
   * generated from fxa_avatar_menu.click_sync_tabs
   */
    struct ClickSyncTabsExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#sync_tabs.
   */
  constexpr impl::EventMetric<ClickSyncTabsExtra> click_sync_tabs(3776);

  /**
   * generated from fxa_avatar_menu.click_sync_tabs_sidebar
   */
    struct ClickSyncTabsSidebarExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#sync_tabs_sidebar.
   */
  constexpr impl::EventMetric<ClickSyncTabsSidebarExtra> click_sync_tabs_sidebar(3777);

  /**
   * generated from fxa_avatar_menu.click_toolbar_icon
   */
    struct ClickToolbarIconExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#toolbar_icon.
   */
  constexpr impl::EventMetric<ClickToolbarIconExtra> click_toolbar_icon(3778);

  /**
   * generated from fxa_avatar_menu.click_unver_sync_settings
   */
    struct ClickUnverSyncSettingsExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#unver_sync_settings.
   */
  constexpr impl::EventMetric<ClickUnverSyncSettingsExtra> click_unver_sync_settings(3779);

  /**
   * generated from fxa_avatar_menu.click_vpn_cta
   */
    struct ClickVpnCtaExtra {
      mozilla::Maybe<nsCString> fxaAvatar;
      mozilla::Maybe<nsCString> fxaStatus;
      mozilla::Maybe<nsCString> fxaSyncOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fxaAvatar) {
          extraKeys.AppendElement()->AssignASCII("fxa_avatar");
          extraValues.EmplaceBack(fxaAvatar.value());
        }
        if (fxaStatus) {
          extraKeys.AppendElement()->AssignASCII("fxa_status");
          extraValues.EmplaceBack(fxaStatus.value());
        }
        if (fxaSyncOn) {
          extraKeys.AppendElement()->AssignASCII("fxa_sync_on");
          extraValues.EmplaceBack(fxaSyncOn.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded on interactions with the FxA avatar menu on the toolbar This
     * event was generated to correspond to the Legacy Telemetry event
     * fxa_avatar_menu.click#vpn_cta.
   */
  constexpr impl::EventMetric<ClickVpnCtaExtra> click_vpn_cta(3780);

}
namespace sync_merge_dialog {
  /**
   * generated from sync_merge_dialog.clicked
   */
    struct ClickedExtra {
      mozilla::Maybe<nsCString> optionClicked;
      mozilla::Maybe<nsCString> variantShown;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (optionClicked) {
          extraKeys.AppendElement()->AssignASCII("option_clicked");
          extraValues.EmplaceBack(optionClicked.value());
        }
        if (variantShown) {
          extraKeys.AppendElement()->AssignASCII("variant_shown");
          extraValues.EmplaceBack(variantShown.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Event to record that showed the user a warning for potentially merging data
     * from multiple accounts and recorded
   */
  constexpr impl::EventMetric<ClickedExtra> clicked(3781);

}
namespace bounce_tracking_protection {
  /**
   * generated from bounce.tracking.protection.mode
   */
  /**
   * Records the pref value of privacy.bounceTrackingProtection.mode. Values are any
     * of nsIBounceTrackingProtection#Modes.
   */
  constexpr impl::QuantityMetric mode(3782);

  /**
   * generated from bounce.tracking.protection.num_hosts_per_purge_run
   */
  /**
   * Number of bounce trackers purged successfully per scheduled purge.
   */
  constexpr impl::CustomDistributionMetric num_hosts_per_purge_run(3783);

  /**
   * generated from bounce.tracking.protection.purge_action
   */
    struct PurgeActionExtra {
      mozilla::Maybe<uint32_t> bounceTime;
      mozilla::Maybe<bool> isDryRun;
      mozilla::Maybe<nsCString> siteHost;
      mozilla::Maybe<bool> success;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (bounceTime) {
          extraKeys.AppendElement()->AssignASCII("bounce_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", bounceTime.value()));
        }
        if (isDryRun) {
          extraKeys.AppendElement()->AssignASCII("is_dry_run");
          extraValues.AppendElement()->AssignASCII(isDryRun.value() ? "true" : "false");
        }
        if (siteHost) {
          extraKeys.AppendElement()->AssignASCII("site_host");
          extraValues.EmplaceBack(siteHost.value());
        }
        if (success) {
          extraKeys.AppendElement()->AssignASCII("success");
          extraValues.AppendElement()->AssignASCII(success.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Dispatched whenever a bounce tracker site is purged.
   */
  constexpr impl::EventMetric<PurgeActionExtra> purge_action(3784);

  /**
   * generated from bounce.tracking.protection.purge_count
   */
  enum class PurgeCountLabel: uint16_t {
      eSuccess = 0,
      eFailure = 1,
      eDry = 2,
      e__Other__,
    };
  /**
   * Counts how often we purge trackers. Giving a high level overview about the
     * effectivness of bounce tracking protection. Allows determining error rate with
     * failure/success label. When in dry mode, we count the purges that would have
     * happened under the dry label.
   */
  constexpr impl::Labeled<impl::CounterMetric, PurgeCountLabel> purge_count(3785);

  /**
   * generated from bounce.tracking.protection.purge_count_classified_tracker
   */
  /**
   * Counts sites purged from BTP that are classified as trackers as part of the
     * following lists: [emailtracking-protection, fingerprinting-protection,
     * socialtracking-protection, tracking-protection]
   */
  constexpr impl::CounterMetric purge_count_classified_tracker(3786);

  /**
   * generated from bounce.tracking.protection.purge_duration
   */
  /**
   * For every purge that is scheduled, we call the ClearDataService to purge
     * persistent storage for each detected bounce tracker. This may do some blocking
     * work on main thread and dispatch some cleanups to other threads. Collect
     * telemetry on how long it takes to clear in the wild to determine whether we
     * need to improve performance here.
   */
  constexpr impl::TimingDistributionMetric purge_duration(3787);

}
namespace image_input_telemetry {
  /**
   * generated from image.input.telemetry.image_input
   */
    struct ImageInputExtra {
      mozilla::Maybe<nsCString> imageType;
      mozilla::Maybe<nsCString> inputType;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (imageType) {
          extraKeys.AppendElement()->AssignASCII("image_type");
          extraValues.EmplaceBack(imageType.value());
        }
        if (inputType) {
          extraKeys.AppendElement()->AssignASCII("input_type");
          extraValues.EmplaceBack(inputType.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Type of user image file(s) input and browser input type and platform.
   */
  constexpr impl::EventMetric<ImageInputExtra> image_input(3788);

}
namespace contentblocking {
  /**
   * generated from contentblocking.category
   */
  /**
   * This scalar reports the value of the content blocking category pref (0 =
     * "standard", 1 = "strict", 2 = "custom", 3 = some other value, this is not
     * supported). This metric was generated to correspond to the Legacy Telemetry
     * scalar contentblocking.category.
   */
  constexpr impl::QuantityMetric category(3789);

  /**
   * generated from contentblocking.cryptomining_blocking_enabled
   */
  /**
   * True if cryptominer blocking is enabled globally at startup. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * contentblocking.cryptomining_blocking_enabled.
   */
  constexpr impl::BooleanMetric cryptomining_blocking_enabled(3790);

  /**
   * generated from contentblocking.fingerprinting_blocking_enabled
   */
  /**
   * True if fingerprinter blocking is enabled globally at startup. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * contentblocking.fingerprinting_blocking_enabled.
   */
  constexpr impl::BooleanMetric fingerprinting_blocking_enabled(3791);

  /**
   * generated from contentblocking.trackers_blocked_count
   */
  /**
   * A count of the number of tracking events blocked. This metric was generated to
     * correspond to the Legacy Telemetry scalar
     * contentblocking.trackers_blocked_count.
   */
  constexpr impl::CounterMetric trackers_blocked_count(3792);

}
namespace background_tasks_rmdir_base {
  /**
   * generated from background_tasks.rmdir.base.elapsed_ms
   */
  /**
   * The amount of time the task took for removing the directories.
   */
  constexpr impl::QuantityMetric elapsed_ms(3793);

  /**
   * generated from background_tasks.rmdir.base.metric_base
   */
  /**
   * The base metric template for removeDirectory.
   */
  constexpr impl::EventMetric<NoExtraKeys> metric_base(3794);

  /**
   * generated from background_tasks.rmdir.base.removal_count
   */
  /**
   * The number of the removed entries at each call, even if the target directory
     * itself couldn't be removed.
   */
  constexpr impl::QuantityMetric removal_count(3795);

  /**
   * generated from background_tasks.rmdir.base.retry_count
   */
  /**
   * The number of retries before the task started removing the child directory.
     * This can happen when the target directory doesn't exist.
   */
  constexpr impl::QuantityMetric retry_count(3796);

  /**
   * generated from background_tasks.rmdir.base.succeeded
   */
  /**
   * Whether the target directory removal succeeded.
   */
  constexpr impl::BooleanMetric succeeded(3797);

  /**
   * generated from background_tasks.rmdir.base.suffix_ever_failed
   */
  /**
   * Whether removing the suffixed directories ever failed.
   */
  constexpr impl::BooleanMetric suffix_ever_failed(3798);

  /**
   * generated from background_tasks.rmdir.base.suffix_removal_count
   */
  /**
   * The number of the removed entries of the suffixed directories.
   */
  constexpr impl::QuantityMetric suffix_removal_count(3799);

  /**
   * generated from background_tasks.rmdir.base.was_first
   */
  /**
   * Whether this task is the first one removing the directory.
   */
  constexpr impl::BooleanMetric was_first(3800);

}
namespace background_tasks_rmdir_http_cache {
  /**
   * generated from background_tasks.rmdir.http_cache.elapsed_ms
   */
  /**
   * The amount of time the task took for removing the directories.
   */
  constexpr impl::QuantityMetric elapsed_ms(3801);

  /**
   * generated from background_tasks.rmdir.http_cache.metric_base
   */
  /**
   * The base metric template for removeDirectory.
   */
  constexpr impl::EventMetric<NoExtraKeys> metric_base(3802);

  /**
   * generated from background_tasks.rmdir.http_cache.removal_count
   */
  /**
   * The number of the removed entries at each call, even if the target directory
     * itself couldn't be removed.
   */
  constexpr impl::QuantityMetric removal_count(3803);

  /**
   * generated from background_tasks.rmdir.http_cache.retry_count
   */
  /**
   * The number of retries before the task started removing the child directory.
     * This can happen when the target directory doesn't exist.
   */
  constexpr impl::QuantityMetric retry_count(3804);

  /**
   * generated from background_tasks.rmdir.http_cache.succeeded
   */
  /**
   * Whether the target directory removal succeeded.
   */
  constexpr impl::BooleanMetric succeeded(3805);

  /**
   * generated from background_tasks.rmdir.http_cache.suffix_ever_failed
   */
  /**
   * Whether removing the suffixed directories ever failed.
   */
  constexpr impl::BooleanMetric suffix_ever_failed(3806);

  /**
   * generated from background_tasks.rmdir.http_cache.suffix_removal_count
   */
  /**
   * The number of the removed entries of the suffixed directories.
   */
  constexpr impl::QuantityMetric suffix_removal_count(3807);

  /**
   * generated from background_tasks.rmdir.http_cache.was_first
   */
  /**
   * Whether this task is the first one removing the directory.
   */
  constexpr impl::BooleanMetric was_first(3808);

}
namespace background_tasks_rmdir_quota {
  /**
   * generated from background_tasks.rmdir.quota.elapsed_ms
   */
  /**
   * The amount of time the task took for removing the directories.
   */
  constexpr impl::QuantityMetric elapsed_ms(3809);

  /**
   * generated from background_tasks.rmdir.quota.metric_base
   */
  /**
   * The base metric template for removeDirectory.
   */
  constexpr impl::EventMetric<NoExtraKeys> metric_base(3810);

  /**
   * generated from background_tasks.rmdir.quota.removal_count
   */
  /**
   * The number of the removed entries at each call, even if the target directory
     * itself couldn't be removed.
   */
  constexpr impl::QuantityMetric removal_count(3811);

  /**
   * generated from background_tasks.rmdir.quota.retry_count
   */
  /**
   * The number of retries before the task started removing the child directory.
     * This can happen when the target directory doesn't exist.
   */
  constexpr impl::QuantityMetric retry_count(3812);

  /**
   * generated from background_tasks.rmdir.quota.succeeded
   */
  /**
   * Whether the target directory removal succeeded.
   */
  constexpr impl::BooleanMetric succeeded(3813);

  /**
   * generated from background_tasks.rmdir.quota.suffix_ever_failed
   */
  /**
   * Whether removing the suffixed directories ever failed.
   */
  constexpr impl::BooleanMetric suffix_ever_failed(3814);

  /**
   * generated from background_tasks.rmdir.quota.suffix_removal_count
   */
  /**
   * The number of the removed entries of the suffixed directories.
   */
  constexpr impl::QuantityMetric suffix_removal_count(3815);

  /**
   * generated from background_tasks.rmdir.quota.was_first
   */
  /**
   * Whether this task is the first one removing the directory.
   */
  constexpr impl::BooleanMetric was_first(3816);

}
namespace captcha_detection {
  /**
   * generated from captcha_detection.arkoselabs_pc
   */
  /**
   * How many times the ArkoseLabs challenge was successfully completed.
   */
  constexpr impl::CounterMetric arkoselabs_pc(3817);

  /**
   * generated from captcha_detection.arkoselabs_pc_pbm
   */
  /**
   * How many times the ArkoseLabs challenge was successfully completed.
   */
  constexpr impl::CounterMetric arkoselabs_pc_pbm(3818);

  /**
   * generated from captcha_detection.arkoselabs_pf
   */
  /**
   * How many times the ArkoseLabs challenge was failed.
   */
  constexpr impl::CounterMetric arkoselabs_pf(3819);

  /**
   * generated from captcha_detection.arkoselabs_pf_pbm
   */
  /**
   * How many times the ArkoseLabs challenge was failed.
   */
  constexpr impl::CounterMetric arkoselabs_pf_pbm(3820);

  /**
   * generated from captcha_detection.arkoselabs_ps
   */
  /**
   * How many times the ArkoseLabs challenge was shown.
   */
  constexpr impl::CounterMetric arkoselabs_ps(3821);

  /**
   * generated from captcha_detection.arkoselabs_ps_pbm
   */
  /**
   * How many times the ArkoseLabs challenge was shown.
   */
  constexpr impl::CounterMetric arkoselabs_ps_pbm(3822);

  /**
   * generated from captcha_detection.arkoselabs_solutions_required
   */
  /**
   * The number of solutions required to complete the ArkoseLabs challenge.
   */
  constexpr impl::CustomDistributionMetric arkoselabs_solutions_required(3823);

  /**
   * generated from captcha_detection.arkoselabs_solutions_required_pbm
   */
  /**
   * The number of solutions required to complete the ArkoseLabs challenge.
   */
  constexpr impl::CustomDistributionMetric arkoselabs_solutions_required_pbm(3824);

  /**
   * generated from captcha_detection.awswaf_pc
   */
  /**
   * How many times the AWS WAF challenge was successfully completed.
   */
  constexpr impl::CounterMetric awswaf_pc(3825);

  /**
   * generated from captcha_detection.awswaf_pc_pbm
   */
  /**
   * How many times the AWS WAF challenge was successfully completed.
   */
  constexpr impl::CounterMetric awswaf_pc_pbm(3826);

  /**
   * generated from captcha_detection.awswaf_pf
   */
  /**
   * How many times the AWS WAF challenge was failed.
   */
  constexpr impl::CounterMetric awswaf_pf(3827);

  /**
   * generated from captcha_detection.awswaf_pf_pbm
   */
  /**
   * How many times the AWS WAF challenge was failed.
   */
  constexpr impl::CounterMetric awswaf_pf_pbm(3828);

  /**
   * generated from captcha_detection.awswaf_ps
   */
  /**
   * How many times the AWS WAF challenge was shown.
   */
  constexpr impl::CounterMetric awswaf_ps(3829);

  /**
   * generated from captcha_detection.awswaf_ps_pbm
   */
  /**
   * How many times the AWS WAF challenge was shown.
   */
  constexpr impl::CounterMetric awswaf_ps_pbm(3830);

  /**
   * generated from captcha_detection.awswaf_solutions_required
   */
  /**
   * The number of solutions required to complete the AWS WAF challenge.
   */
  constexpr impl::CustomDistributionMetric awswaf_solutions_required(3831);

  /**
   * generated from captcha_detection.awswaf_solutions_required_pbm
   */
  /**
   * The number of solutions required to complete the AWS WAF challenge.
   */
  constexpr impl::CustomDistributionMetric awswaf_solutions_required_pbm(3832);

  /**
   * generated from captcha_detection.cloudflare_turnstile_cc
   */
  /**
   * Number of times the Cloudflare Turnstile challenge was successfully completed
     * since last ping submission.
   */
  constexpr impl::CounterMetric cloudflare_turnstile_cc(3833);

  /**
   * generated from captcha_detection.cloudflare_turnstile_cc_pbm
   */
  /**
   * Number of times the Cloudflare Turnstile challenge was successfully completed
     * since last ping submission.
   */
  constexpr impl::CounterMetric cloudflare_turnstile_cc_pbm(3834);

  /**
   * generated from captcha_detection.cloudflare_turnstile_cf
   */
  /**
   * Number of times the Cloudflare Turnstile challenge was failed since last ping
     * submission.
   */
  constexpr impl::CounterMetric cloudflare_turnstile_cf(3835);

  /**
   * generated from captcha_detection.cloudflare_turnstile_cf_pbm
   */
  /**
   * Number of times the Cloudflare Turnstile challenge was failed since last ping
     * submission.
   */
  constexpr impl::CounterMetric cloudflare_turnstile_cf_pbm(3836);

  /**
   * generated from captcha_detection.datadome_bl
   */
  /**
   * How many times the Datadome blocked a user.
   */
  constexpr impl::CounterMetric datadome_bl(3837);

  /**
   * generated from captcha_detection.datadome_bl_pbm
   */
  /**
   * How many times the Datadome blocked a user.
   */
  constexpr impl::CounterMetric datadome_bl_pbm(3838);

  /**
   * generated from captcha_detection.datadome_pc
   */
  /**
   * How many times the user passed a Datadome puzzle.
   */
  constexpr impl::CounterMetric datadome_pc(3839);

  /**
   * generated from captcha_detection.datadome_pc_pbm
   */
  /**
   * How many times the user completed a Datadome puzzle.
   */
  constexpr impl::CounterMetric datadome_pc_pbm(3840);

  /**
   * generated from captcha_detection.datadome_ps
   */
  /**
   * The number of times the Datadome puzzle was shown.
   */
  constexpr impl::CounterMetric datadome_ps(3841);

  /**
   * generated from captcha_detection.datadome_ps_pbm
   */
  /**
   * The number of times the Datadome puzzle was shown.
   */
  constexpr impl::CounterMetric datadome_ps_pbm(3842);

  /**
   * generated from captcha_detection.google_recaptcha_v2_ac
   */
  /**
   * Number of times the user completed a Google reCAPTCHA v2 challenge
     * automatically since last ping submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_ac(3843);

  /**
   * generated from captcha_detection.google_recaptcha_v2_ac_pbm
   */
  /**
   * Number of times the user completed a Google reCAPTCHA v2 challenge
     * automatically since last ping submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_ac_pbm(3844);

  /**
   * generated from captcha_detection.google_recaptcha_v2_pc
   */
  /**
   * Number of times the user completed a Google reCAPTCHA v2 puzzle since last ping
     * submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_pc(3845);

  /**
   * generated from captcha_detection.google_recaptcha_v2_pc_pbm
   */
  /**
   * Number of times the user completed a Google reCAPTCHA v2 puzzle since last ping
     * submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_pc_pbm(3846);

  /**
   * generated from captcha_detection.google_recaptcha_v2_ps
   */
  /**
   * Number of times the user has seen a Google reCAPTCHA v2 puzzle since last ping
     * submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_ps(3847);

  /**
   * generated from captcha_detection.google_recaptcha_v2_ps_pbm
   */
  /**
   * Number of times the user has seen a Google reCAPTCHA v2 puzzle since last ping
     * submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_ps_pbm(3848);

  /**
   * generated from captcha_detection.hcaptcha_ac
   */
  /**
   * Number of times the user completed an hCaptcha challenge automatically.
   */
  constexpr impl::CounterMetric hcaptcha_ac(3849);

  /**
   * generated from captcha_detection.hcaptcha_ac_pbm
   */
  /**
   * Number of times the user completed an hCaptcha challenge automatically.
   */
  constexpr impl::CounterMetric hcaptcha_ac_pbm(3850);

  /**
   * generated from captcha_detection.hcaptcha_pc
   */
  /**
   * Number of times the user completed an hCaptcha puzzle.
   */
  constexpr impl::CounterMetric hcaptcha_pc(3851);

  /**
   * generated from captcha_detection.hcaptcha_pc_pbm
   */
  /**
   * Number of times the user completed an hCaptcha puzzle.
   */
  constexpr impl::CounterMetric hcaptcha_pc_pbm(3852);

  /**
   * generated from captcha_detection.hcaptcha_ps
   */
  /**
   * Number of times the hCaptcha puzzle was shown.
   */
  constexpr impl::CounterMetric hcaptcha_ps(3853);

  /**
   * generated from captcha_detection.hcaptcha_ps_pbm
   */
  /**
   * Number of times the hCaptcha puzzle was shown.
   */
  constexpr impl::CounterMetric hcaptcha_ps_pbm(3854);

  /**
   * generated from captcha_detection.network_cookie_cookiebehavior
   */
  /**
   * The user's cookie behavior setting at the time of data collection.
   */
  constexpr impl::StringMetric network_cookie_cookiebehavior(3855);

  /**
   * generated from captcha_detection.network_cookie_cookiebehavior_optinpartitioning
   */
  /**
   * Whether the user has enabled cookie partitioning at the time of data
     * collection.
   */
  constexpr impl::BooleanMetric network_cookie_cookiebehavior_optinpartitioning(3856);

  /**
   * generated from captcha_detection.network_cookie_cookiebehavior_optinpartitioning_pbm
   */
  /**
   * Whether the user has enabled cookie partioning in PBM at the time of data
     * collection.
   */
  constexpr impl::BooleanMetric network_cookie_cookiebehavior_optinpartitioning_pbm(3857);

  /**
   * generated from captcha_detection.privacy_fingerprintingprotection
   */
  /**
   * Whether the user has enabled suspected fingerprinters protection at the time of
     * data collection.
   */
  constexpr impl::BooleanMetric privacy_fingerprintingprotection(3858);

  /**
   * generated from captcha_detection.privacy_fingerprintingprotection_pbm
   */
  /**
   * Whether the user has enabled suspected fingerprinters protection in PBM at the
     * time of data collection.
   */
  constexpr impl::BooleanMetric privacy_fingerprintingprotection_pbm(3859);

  /**
   * generated from captcha_detection.privacy_resistfingerprinting
   */
  /**
   * Whether the user has enabled resist fingerprinting at the time of data
     * collection.
   */
  constexpr impl::BooleanMetric privacy_resistfingerprinting(3860);

  /**
   * generated from captcha_detection.privacy_resistfingerprinting_pbmode
   */
  /**
   * Whether the user has enabled resist fingerprinting in PBM at the time of data
     * collection.
   */
  constexpr impl::BooleanMetric privacy_resistfingerprinting_pbmode(3861);

  /**
   * generated from captcha_detection.privacy_trackingprotection_cryptomining_enabled
   */
  /**
   * Whether the user has enabled cryptomining protection at the time of data
     * collection.
   */
  constexpr impl::BooleanMetric privacy_trackingprotection_cryptomining_enabled(3862);

  /**
   * generated from captcha_detection.privacy_trackingprotection_enabled
   */
  /**
   * Whether the user has enabled tracking protection at the time of data
     * collection.
   */
  constexpr impl::BooleanMetric privacy_trackingprotection_enabled(3863);

  /**
   * generated from captcha_detection.privacy_trackingprotection_fingerprinting_enabled
   */
  /**
   * Whether the user has enabled known fingerprinters protection at the time of
     * data collection.
   */
  constexpr impl::BooleanMetric privacy_trackingprotection_fingerprinting_enabled(3864);

  /**
   * generated from captcha_detection.privacy_trackingprotection_pbm_enabled
   */
  /**
   * Whether the user has enabled tracking protection in PBM at the time of data
     * collection.
   */
  constexpr impl::BooleanMetric privacy_trackingprotection_pbm_enabled(3865);

}
namespace relevancy_classify {
  /**
   * generated from relevancy.classify.duration
   */
  /**
   * Record the duration (in ms) of a successful classification.
   */
  constexpr impl::TimingDistributionMetric duration(3866);

  /**
   * generated from relevancy.classify.fail
   */
    struct FailExtra {
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record an event of a failed / aborted user interest classification.
   */
  constexpr impl::EventMetric<FailExtra> fail(3867);

  /**
   * generated from relevancy.classify.succeed
   */
    struct SucceedExtra {
      mozilla::Maybe<uint32_t> inputClassifiedSize;
      mozilla::Maybe<uint32_t> inputInconclusiveSize;
      mozilla::Maybe<uint32_t> inputSize;
      mozilla::Maybe<uint32_t> interestTop1Hits;
      mozilla::Maybe<uint32_t> interestTop2Hits;
      mozilla::Maybe<uint32_t> interestTop3Hits;
      mozilla::Maybe<uint32_t> outputInterestSize;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (inputClassifiedSize) {
          extraKeys.AppendElement()->AssignASCII("input_classified_size");
          extraValues.EmplaceBack(nsPrintfCString("%d", inputClassifiedSize.value()));
        }
        if (inputInconclusiveSize) {
          extraKeys.AppendElement()->AssignASCII("input_inconclusive_size");
          extraValues.EmplaceBack(nsPrintfCString("%d", inputInconclusiveSize.value()));
        }
        if (inputSize) {
          extraKeys.AppendElement()->AssignASCII("input_size");
          extraValues.EmplaceBack(nsPrintfCString("%d", inputSize.value()));
        }
        if (interestTop1Hits) {
          extraKeys.AppendElement()->AssignASCII("interest_top_1_hits");
          extraValues.EmplaceBack(nsPrintfCString("%d", interestTop1Hits.value()));
        }
        if (interestTop2Hits) {
          extraKeys.AppendElement()->AssignASCII("interest_top_2_hits");
          extraValues.EmplaceBack(nsPrintfCString("%d", interestTop2Hits.value()));
        }
        if (interestTop3Hits) {
          extraKeys.AppendElement()->AssignASCII("interest_top_3_hits");
          extraValues.EmplaceBack(nsPrintfCString("%d", interestTop3Hits.value()));
        }
        if (outputInterestSize) {
          extraKeys.AppendElement()->AssignASCII("output_interest_size");
          extraValues.EmplaceBack(nsPrintfCString("%d", outputInterestSize.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record an event of a successful user interest classification.
   */
  constexpr impl::EventMetric<SucceedExtra> succeed(3868);

}
namespace cookie_banners {
  /**
   * generated from cookie.banners.google_gdpr_choice_cookie
   */
  /**
   * Records the GDPR choice on Google Search based on the "SOCS" cookie of the
     * Google Search domains. The value could be "Accept", "Reject" or "Custom". We
     * use the label to record different choices on different Google domains. We only
     * collect this if the default search engine is Google.
   */
  constexpr impl::Labeled<impl::StringMetric, DynamicLabel> google_gdpr_choice_cookie(3869);

  /**
   * generated from cookie.banners.google_gdpr_choice_cookie_event
   */
    struct GoogleGdprChoiceCookieEventExtra {
      mozilla::Maybe<nsCString> choice;
      mozilla::Maybe<nsCString> region;
      mozilla::Maybe<nsCString> searchDomain;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (choice) {
          extraKeys.AppendElement()->AssignASCII("choice");
          extraValues.EmplaceBack(choice.value());
        }
        if (region) {
          extraKeys.AppendElement()->AssignASCII("region");
          extraValues.EmplaceBack(region.value());
        }
        if (searchDomain) {
          extraKeys.AppendElement()->AssignASCII("search_domain");
          extraValues.EmplaceBack(searchDomain.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded whenever a GDPR choice is made on a Google Search page. We assess the
     * "SOCS" cookie to know the GDPR choice.
   */
  constexpr impl::EventMetric<GoogleGdprChoiceCookieEventExtra> google_gdpr_choice_cookie_event(3870);

  /**
   * generated from cookie.banners.google_gdpr_choice_cookie_event_pbm
   */
    struct GoogleGdprChoiceCookieEventPbmExtra {
      mozilla::Maybe<nsCString> choice;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (choice) {
          extraKeys.AppendElement()->AssignASCII("choice");
          extraValues.EmplaceBack(choice.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded whenever a GDPR choice is made on a Google Search page on private
     * browsing windows. We assess the "SOCS" cookie to know the GDPR choice.
   */
  constexpr impl::EventMetric<GoogleGdprChoiceCookieEventPbmExtra> google_gdpr_choice_cookie_event_pbm(3871);

  /**
   * generated from cookie.banners.normal_window_service_mode
   */
  enum class NormalWindowServiceModeLabel: uint16_t {
      eDisabled = 0,
      eReject = 1,
      eRejectOrAccept = 2,
      eInvalid = 3,
      e__Other__,
    };
  /**
   * The pref value of the cookie banner service mode for normal windows.
   */
  constexpr impl::Labeled<impl::BooleanMetric, NormalWindowServiceModeLabel> normal_window_service_mode(3872);

  /**
   * generated from cookie.banners.private_window_service_mode
   */
  enum class PrivateWindowServiceModeLabel: uint16_t {
      eDisabled = 0,
      eReject = 1,
      eRejectOrAccept = 2,
      eInvalid = 3,
      e__Other__,
    };
  /**
   * The pref value of the cookie banner service mode for private windows.
   */
  constexpr impl::Labeled<impl::BooleanMetric, PrivateWindowServiceModeLabel> private_window_service_mode(3873);

  /**
   * generated from cookie.banners.service_detect_only
   */
  /**
   * Tracks the value of the cookiebanners.service.detectOnly pref.
   */
  constexpr impl::BooleanMetric service_detect_only(3874);

}
namespace crash {
  /**
   * generated from crash.app_build
   */
  /**
   * The build id of the application. This may differ from `client_info` because a
     * main process crash may be reported later by a different (e.g. updated) client.
   */
  constexpr impl::StringMetric app_build(3875);

  /**
   * generated from crash.app_channel
   */
  /**
   * The release channel of the application. This may differ from `client_info`
     * because a main process crash may be reported later by a different (e.g.
     * updated) client.
   */
  constexpr impl::StringMetric app_channel(3876);

  /**
   * generated from crash.app_display_version
   */
  /**
   * The version of the application. This may differ from `client_info` because a
     * main process crash may be reported later by a different (e.g. updated) client.
   */
  constexpr impl::StringMetric app_display_version(3877);


  /**
   * generated from crash.background_task_name
   */
  /**
   * The name of the background task if launched as one.
   */
  constexpr impl::StringMetric background_task_name(3879);

  /**
   * generated from crash.event_loop_nesting_level
   */
  /**
   * Indicates the nesting level of the event loop.
   */
  constexpr impl::QuantityMetric event_loop_nesting_level(3880);

  /**
   * generated from crash.font_name
   */
  /**
   * The font family name that is being loaded when the crash occurred.
   */
  constexpr impl::StringMetric font_name(3881);

  /**
   * generated from crash.gpu_process_launch
   */
  /**
   * The number of times that the GPU process was launched.
   */
  constexpr impl::QuantityMetric gpu_process_launch(3882);

  /**
   * generated from crash.ipc_channel_error
   */
  /**
   * The error reason for an ipc-based content crash.
   */
  constexpr impl::StringMetric ipc_channel_error(3883);

  /**
   * generated from crash.is_garbage_collecting
   */
  /**
   * Indicates that the crash occurred while the garbage collector was running.
   */
  constexpr impl::BooleanMetric is_garbage_collecting(3884);

  /**
   * generated from crash.main_thread_runnable_name
   */
  /**
   * Name of the currently executing `nsIRunnable` on the main thread. Nightly-only.
   */
  constexpr impl::StringMetric main_thread_runnable_name(3885);

  /**
   * generated from crash.minidump_sha256_hash
   */
  /**
   * The SHA256 hash of the associated minidump file, if any.
   */
  constexpr impl::StringMetric minidump_sha256_hash(3886);

  /**
   * generated from crash.moz_crash_reason
   */
  /**
   * Contains the string passed to `MOZ_CRASH()`.
   */
  constexpr impl::StringMetric moz_crash_reason(3887);

  /**
   * generated from crash.process_type
   */
  /**
   * The type of process that experienced a crash. See the full list of options
     * [here](https://firefox-source-
     * docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#process-
     * types).
   */
  constexpr impl::StringMetric process_type(3888);

  /**
   * generated from crash.profiler_child_shutdown_phase
   */
  /**
   * The shutdown phase of the profiler.
   */
  constexpr impl::StringMetric profiler_child_shutdown_phase(3889);


  /**
   * generated from crash.remote_type
   */
  /**
   * The type of the content process. See the full list of options
     * [here](https://firefox-source-
     * docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#remote-
     * process-types).
   */
  constexpr impl::StringMetric remote_type(3891);

  /**
   * generated from crash.shutdown_progress
   */
  /**
   * The shutdown phase in which the crash occurred.
   */
  constexpr impl::StringMetric shutdown_progress(3892);


  /**
   * generated from crash.startup
   */
  /**
   * If true, the crash occurred during process startup.
   */
  constexpr impl::BooleanMetric startup(3894);

  /**
   * generated from crash.time
   */
  /**
   * The time at which the crash occurred.
   */
  constexpr impl::DatetimeMetric time(3895);

  /**
   * generated from crash.utility_actors_name
   */
  /**
   * List of IPC actor names running on a utility process instance (if the crashing
     * process was a utility process).
   */
  constexpr impl::StringListMetric utility_actors_name(3896);

}
namespace crash_windows {
  /**
   * generated from crash.windows.error_reporting
   */
  /**
   * Indicates if the crash was intercepted by the Windows Error Reporting runtime
     * exception module.
   */
  constexpr impl::BooleanMetric error_reporting(3897);

  /**
   * generated from crash.windows.file_dialog_error_code
   */
  /**
   * The HRESULT returned from a Win32 system call leading to termination of the
     * file-dialog utility process. MozCrashReason is expected to provide context for
     * the value.
   */
  constexpr impl::StringMetric file_dialog_error_code(3898);

}
namespace crash_submission {
  /**
   * generated from crash_submission.channel_status
   */
  /**
   * Collecting XHR channel status on error code when statusCode == 0.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> channel_status(3899);

  /**
   * generated from crash_submission.collector_errors
   */
  /**
   * Amount and error name reported when performing crash submission.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> collector_errors(3900);

  /**
   * generated from crash_submission.failure
   */
  /**
   * Number of failed crash report submissions
   */
  constexpr impl::CounterMetric failure(3901);

  /**
   * generated from crash_submission.pending
   */
  /**
   * Number of pending crash report submissions
   */
  constexpr impl::CounterMetric pending(3902);

  /**
   * generated from crash_submission.success
   */
  /**
   * Number of successfull crash report submissions
   */
  constexpr impl::CounterMetric success(3903);

}
namespace dll_blocklist {
  /**
   * generated from dll_blocklist.init_failed
   */
  /**
   * Indicates whether initialization of the DLL blocklist failed.
   */
  constexpr impl::BooleanMetric init_failed(3904);

  /**
   * generated from dll_blocklist.list
   */
  /**
   * A list of blocked DLLs.
   */
  constexpr impl::StringListMetric list(3905);

  /**
   * generated from dll_blocklist.user32_loaded_before
   */
  /**
   * Indicates whether `user32.dll` was loaded before the DLL blocklist was
     * initialized.
   */
  constexpr impl::BooleanMetric user32_loaded_before(3906);

}
namespace environment {
  /**
   * generated from environment.experimental_features
   */
  /**
   * Specifies the enabled experimental features from
     * about:preferences#experimental.
   */
  constexpr impl::StringListMetric experimental_features(3907);

  /**
   * generated from environment.headless_mode
   */
  /**
   * Whether the app was invoked in headless mode via `--headless` or
     * `--backgroundtask`.
   */
  constexpr impl::BooleanMetric headless_mode(3908);

  /**
   * generated from environment.uptime
   */
  /**
   * The start time of the application.
   */
  constexpr impl::TimespanMetric uptime(3909);

}
namespace memory {
  /**
   * generated from memory.available_commit
   */
  /**
   * Available commit size.
   */
  constexpr impl::QuantityMetric available_commit(3910);

  /**
   * generated from memory.available_physical
   */
  /**
   * Available physical memory.
   */
  constexpr impl::QuantityMetric available_physical(3911);

  /**
   * generated from memory.available_swap
   */
  /**
   * Available swap memory.
   */
  constexpr impl::QuantityMetric available_swap(3912);

  /**
   * generated from memory.available_virtual
   */
  /**
   * Available virtual memory.
   */
  constexpr impl::QuantityMetric available_virtual(3913);

  /**
   * generated from memory.low_physical
   */
  /**
   * The number of times the available memory tracker has detected that free
     * physical memory is running low.
   */
  constexpr impl::QuantityMetric low_physical(3914);

  /**
   * generated from memory.oom_allocation_size
   */
  /**
   * The size of the allocation that caused on OOM crash.
   */
  constexpr impl::QuantityMetric oom_allocation_size(3915);

  /**
   * generated from memory.purgeable_physical
   */
  /**
   * The amount of memory that can be deallocated by the OS in case of memory
     * pressure.
   */
  constexpr impl::QuantityMetric purgeable_physical(3916);

  /**
   * generated from memory.system_use_percentage
   */
  /**
   * The percentage of memory in use.
   */
  constexpr impl::QuantityMetric system_use_percentage(3917);

  /**
   * generated from memory.texture
   */
  /**
   * The amount of memory used in textures.
   */
  constexpr impl::QuantityMetric texture(3918);

  /**
   * generated from memory.total_page_file
   */
  /**
   * The total page file size.
   */
  constexpr impl::QuantityMetric total_page_file(3919);

  /**
   * generated from memory.total_physical
   */
  /**
   * The total physical memory.
   */
  constexpr impl::QuantityMetric total_physical(3920);

  /**
   * generated from memory.total_virtual
   */
  /**
   * The total virtual memory.
   */
  constexpr impl::QuantityMetric total_virtual(3921);

}
namespace windows {
  /**
   * generated from windows.package_family_name
   */
  /**
   * The Package Family Name of Firefox, if installed through an MSIX package.
   */
  constexpr impl::StringMetric package_family_name(3922);

}
namespace policies {
  /**
   * generated from policies.count
   */
  /**
   * A uint with the number of active enterprise policies, collected once at
     * startup. This metric was generated to correspond to the Legacy Telemetry scalar
     * policies.count.
   */
  constexpr impl::QuantityMetric count(3923);

  /**
   * generated from policies.is_enterprise
   */
  /**
   * Attempt to determine if the user is an enterprise user based on various
     * signals. This metric was generated to correspond to the Legacy Telemetry scalar
     * policies.is_enterprise.
   */
  constexpr impl::BooleanMetric is_enterprise(3924);

}
namespace extensions {
  /**
   * generated from extensions.process_event
   */
  enum class ProcessEventLabel: uint16_t {
      eCrashedBg = 0,
      eCrashedFg = 1,
      eCreatedBg = 2,
      eCreatedFg = 3,
      eCrashedOverThresholdBg = 4,
      eCrashedOverThresholdFg = 5,
      e__Other__,
    };
  /**
   * Counters for how many times the extension process has crashed or been created.
     * The labels with "_fg" / "_bg" suffixes are only recorded in Android builds,
     * while the "created" and "crashed" labels are recorded on both Desktop and
     * Android
     * builds.
   */
  constexpr impl::Labeled<impl::CounterMetric, ProcessEventLabel> process_event(3925);

  /**
   * generated from extensions.startup_cache_load_time
   */
  /**
   * Time to load and deserialize the extensions startupCache data.
   */
  constexpr impl::TimespanMetric startup_cache_load_time(3926);

  /**
   * generated from extensions.startup_cache_read_errors
   */
  /**
   * The number of times an unexpected error has been raised while reading
     * the extensions StartupCache file.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> startup_cache_read_errors(3927);

  /**
   * generated from extensions.startup_cache_write_bytelength
   */
  /**
   * The amount of bytes written to the extensions StartupCache file.
   */
  constexpr impl::QuantityMetric startup_cache_write_bytelength(3928);

  /**
   * generated from extensions.use_remote_policy
   */
  /**
   * Corresponds to the value of `WebExtensionPolicy.useRemoteWebExtensions`.
   */
  constexpr impl::BooleanMetric use_remote_policy(3929);

  /**
   * generated from extensions.use_remote_pref
   */
  /**
   * Corresponds to the value of `extensions.webextensions.remote` pref.
   */
  constexpr impl::BooleanMetric use_remote_pref(3930);

}
namespace extensions_apis_dnr {
  /**
   * generated from extensions.apis.dnr.evaluate_rules_count_max
   */
  /**
   * Max amount of DNR rules being evaluated.
   */
  constexpr impl::QuantityMetric evaluate_rules_count_max(3931);

  /**
   * generated from extensions.apis.dnr.evaluate_rules_time
   */
  /**
   * Amount of time it takes to evaluate DNR rules for one network request.
   */
  constexpr impl::TimingDistributionMetric evaluate_rules_time(3932);

  /**
   * generated from extensions.apis.dnr.startup_cache_entries
   */
  enum class StartupCacheEntriesLabel: uint16_t {
      eHit = 0,
      eMiss = 1,
      e__Other__,
    };
  /**
   * Counters for startup cache data hits or misses on initializating
     * DNR rules for extensions loaded on application startup.
   */
  constexpr impl::Labeled<impl::CounterMetric, StartupCacheEntriesLabel> startup_cache_entries(3933);

  /**
   * generated from extensions.apis.dnr.startup_cache_read_size
   */
  /**
   * Amount of data read from the DNR startup cache file.
   */
  constexpr impl::MemoryDistributionMetric startup_cache_read_size(3934);

  /**
   * generated from extensions.apis.dnr.startup_cache_read_time
   */
  /**
   * Amount of time it takes to read data into the DNR startup cache file.
   */
  constexpr impl::TimingDistributionMetric startup_cache_read_time(3935);

  /**
   * generated from extensions.apis.dnr.startup_cache_write_size
   */
  /**
   * Amount of data written to the DNR startup cache file.
   */
  constexpr impl::MemoryDistributionMetric startup_cache_write_size(3936);

  /**
   * generated from extensions.apis.dnr.startup_cache_write_time
   */
  /**
   * Amount of time it takes to write data into the DNR startup cache file.
   */
  constexpr impl::TimingDistributionMetric startup_cache_write_time(3937);

  /**
   * generated from extensions.apis.dnr.validate_rules_time
   */
  /**
   * Amount of time it takes to validate DNR rules of individual ruleset
     * when dynamic or static rulesets have been loaded from disk.
   */
  constexpr impl::TimingDistributionMetric validate_rules_time(3938);

}
namespace extensions_counters {
  /**
   * generated from extensions.counters.browser_action_preload_result
   */
  enum class BrowserActionPreloadResultLabel: uint16_t {
      ePopupshown = 0,
      eClearafterhover = 1,
      eClearaftermousedown = 2,
      e__Other__,
    };
  /**
   * Number of times an event page hit the idle timeout and results in one of the
     * labels.
   */
  constexpr impl::Labeled<impl::CounterMetric, BrowserActionPreloadResultLabel> browser_action_preload_result(3939);

  /**
   * generated from extensions.counters.event_page_idle_result
   */
  enum class EventPageIdleResultLabel: uint16_t {
      eSuspend = 0,
      eResetOther = 1,
      eResetEvent = 2,
      eResetListeners = 3,
      eResetNativeapp = 4,
      eResetStreamfilter = 5,
      eResetParentapicall = 6,
      ePermissionsRequest = 7,
      eLaunchwebauthflow = 8,
      e__Other__,
    };
  /**
   * Number of times an event page hit the idle timeout and results in one of the
     * labels.
   */
  constexpr impl::Labeled<impl::CounterMetric, EventPageIdleResultLabel> event_page_idle_result(3940);

}
namespace extensions_data {
  /**
   * generated from extensions.data.migrate_result
   */
    struct MigrateResultExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> backend;
      mozilla::Maybe<nsCString> dataMigrated;
      mozilla::Maybe<nsCString> errorName;
      mozilla::Maybe<nsCString> hasJsonfile;
      mozilla::Maybe<nsCString> hasOlddata;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (backend) {
          extraKeys.AppendElement()->AssignASCII("backend");
          extraValues.EmplaceBack(backend.value());
        }
        if (dataMigrated) {
          extraKeys.AppendElement()->AssignASCII("data_migrated");
          extraValues.EmplaceBack(dataMigrated.value());
        }
        if (errorName) {
          extraKeys.AppendElement()->AssignASCII("error_name");
          extraValues.EmplaceBack(errorName.value());
        }
        if (hasJsonfile) {
          extraKeys.AppendElement()->AssignASCII("has_jsonfile");
          extraValues.EmplaceBack(hasJsonfile.value());
        }
        if (hasOlddata) {
          extraKeys.AppendElement()->AssignASCII("has_olddata");
          extraValues.EmplaceBack(hasOlddata.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are sent when an extension is migrating its data to the new
     * IndexedDB backend.
   */
  constexpr impl::EventMetric<MigrateResultExtra> migrate_result(3941);

  /**
   * generated from extensions.data.storage_local_error
   */
    struct StorageLocalErrorExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> errorName;
      mozilla::Maybe<nsCString> method;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (errorName) {
          extraKeys.AppendElement()->AssignASCII("error_name");
          extraValues.EmplaceBack(errorName.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are collected when an extension triggers an unexpected error
     * while running a storage.local API call (e.g. because of some underlying
     * QuotaManager and/or IndexedDB error).
   */
  constexpr impl::EventMetric<StorageLocalErrorExtra> storage_local_error(3942);

  /**
   * generated from extensions.data.sync_usage_quotas
   */
    struct SyncUsageQuotasExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> backend;
      mozilla::Maybe<uint32_t> itemsCount;
      mozilla::Maybe<uint32_t> itemsOverQuota;
      mozilla::Maybe<uint32_t> totalSizeBytes;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (backend) {
          extraKeys.AppendElement()->AssignASCII("backend");
          extraValues.EmplaceBack(backend.value());
        }
        if (itemsCount) {
          extraKeys.AppendElement()->AssignASCII("items_count");
          extraValues.EmplaceBack(nsPrintfCString("%d", itemsCount.value()));
        }
        if (itemsOverQuota) {
          extraKeys.AppendElement()->AssignASCII("items_over_quota");
          extraValues.EmplaceBack(nsPrintfCString("%d", itemsOverQuota.value()));
        }
        if (totalSizeBytes) {
          extraKeys.AppendElement()->AssignASCII("total_size_bytes");
          extraValues.EmplaceBack(nsPrintfCString("%d", totalSizeBytes.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record the basic stat about usage, and are collected the
     * first time an extension uses the sync storage API during a session.
   */
  constexpr impl::EventMetric<SyncUsageQuotasExtra> sync_usage_quotas(3943);

}
namespace extensions_timing {
  /**
   * generated from extensions.timing.background_page_load
   */
  /**
   * Amount of time it takes to load a WebExtensions background page, from when the
     * build function is called to when the page has finished processing the onload
     * event.
   */
  constexpr impl::TimingDistributionMetric background_page_load(3944);

  /**
   * generated from extensions.timing.browser_action_popup_open
   */
  /**
   * Amount of time it takes for a BrowserAction popup to open.
   */
  constexpr impl::TimingDistributionMetric browser_action_popup_open(3945);

  /**
   * generated from extensions.timing.content_script_injection
   */
  /**
   * Amount of time it takes for content scripts from a WebExtension to be injected
     * into a window.
   */
  constexpr impl::TimingDistributionMetric content_script_injection(3946);

  /**
   * generated from extensions.timing.event_page_running_time
   */
  /**
   * Amount of time (keyed by addon id) that an event page has been running before
     * being suspended,
     * or the entire addon shutdown.
   */
  constexpr impl::CustomDistributionMetric event_page_running_time(3947);

  /**
   * generated from extensions.timing.extension_startup
   */
  /**
   * Amount of time it takes for a WebExtension to start up, from when the
     * startup function is called to when the startup promise resolves.
   */
  constexpr impl::TimingDistributionMetric extension_startup(3948);

  /**
   * generated from extensions.timing.page_action_popup_open
   */
  /**
   * Amount of time it takes for a PageAction popup to open.
   */
  constexpr impl::TimingDistributionMetric page_action_popup_open(3949);

  /**
   * generated from extensions.timing.storage_local_get_idb
   */
  /**
   * Amount of time it takes to perform a get via storage.local using the IndexedDB
     * backend.
   */
  constexpr impl::TimingDistributionMetric storage_local_get_idb(3950);

  /**
   * generated from extensions.timing.storage_local_set_idb
   */
  /**
   * Amount of time it takes to perform a set via storage.local using the Indexed
     * backend.
   */
  constexpr impl::TimingDistributionMetric storage_local_set_idb(3951);

}
namespace address {
  /**
   * generated from address.add_manage
   */
    struct AddManageExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for address autofill preferences management UI. This event
     * was generated to correspond to the Legacy Telemetry event address.add#manage.
   */
  constexpr impl::EventMetric<AddManageExtra> add_manage(3952);

  /**
   * generated from address.cancel_capture_doorhanger
   */
    struct CancelCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.cancel#capture_doorhanger.
   */
  constexpr impl::EventMetric<CancelCaptureDoorhangerExtra> cancel_capture_doorhanger(3953);

  /**
   * generated from address.cancel_edit_doorhanger
   */
    struct CancelEditDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.cancel#edit_doorhanger.
   */
  constexpr impl::EventMetric<CancelEditDoorhangerExtra> cancel_edit_doorhanger(3954);

  /**
   * generated from address.cancel_update_doorhanger
   */
    struct CancelUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.cancel#update_doorhanger.
   */
  constexpr impl::EventMetric<CancelUpdateDoorhangerExtra> cancel_update_doorhanger(3955);

  /**
   * generated from address.cleared_address_form
   */
    struct ClearedAddressFormExtra {
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a form is cleared. Using field_name to record the field that
     * triggers this event
     * This event was generated to correspond to the Legacy Telemetry event
     * address.cleared#address_form.
   */
  constexpr impl::EventMetric<ClearedAddressFormExtra> cleared_address_form(3956);

  /**
   * generated from address.delete_manage
   */
    struct DeleteManageExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for address autofill preferences management UI. This event
     * was generated to correspond to the Legacy Telemetry event
     * address.delete#manage.
   */
  constexpr impl::EventMetric<DeleteManageExtra> delete_manage(3957);

  /**
   * generated from address.detected_address_form
   */
    struct DetectedAddressFormExtra {
      mozilla::Maybe<nsCString> addressLevel1;
      mozilla::Maybe<nsCString> addressLevel2;
      mozilla::Maybe<nsCString> addressLine1;
      mozilla::Maybe<nsCString> addressLine2;
      mozilla::Maybe<nsCString> addressLine3;
      mozilla::Maybe<nsCString> country;
      mozilla::Maybe<nsCString> postalCode;
      mozilla::Maybe<nsCString> streetAddress;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addressLevel1) {
          extraKeys.AppendElement()->AssignASCII("address_level1");
          extraValues.EmplaceBack(addressLevel1.value());
        }
        if (addressLevel2) {
          extraKeys.AppendElement()->AssignASCII("address_level2");
          extraValues.EmplaceBack(addressLevel2.value());
        }
        if (addressLine1) {
          extraKeys.AppendElement()->AssignASCII("address_line1");
          extraValues.EmplaceBack(addressLine1.value());
        }
        if (addressLine2) {
          extraKeys.AppendElement()->AssignASCII("address_line2");
          extraValues.EmplaceBack(addressLine2.value());
        }
        if (addressLine3) {
          extraKeys.AppendElement()->AssignASCII("address_line3");
          extraValues.EmplaceBack(addressLine3.value());
        }
        if (country) {
          extraKeys.AppendElement()->AssignASCII("country");
          extraValues.EmplaceBack(country.value());
        }
        if (postalCode) {
          extraKeys.AppendElement()->AssignASCII("postal_code");
          extraValues.EmplaceBack(postalCode.value());
        }
        if (streetAddress) {
          extraKeys.AppendElement()->AssignASCII("street_address");
          extraValues.EmplaceBack(streetAddress.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a form is recognized as an address form. The possible values in
     * the extra_keys are "true", "false", or 0. When the value is "true", the field
     * is identified via autocomplete attribute. When the value is "false", the field
     * is not detected in the form. When the value is an 0, then the field is
     * identified by regexp-based heuristic.
     * This event was generated to correspond to the Legacy Telemetry event
     * address.detected#address_form.
   */
  constexpr impl::EventMetric<DetectedAddressFormExtra> detected_address_form(3958);

  /**
   * generated from address.detected_address_form_ext
   */
    struct DetectedAddressFormExtExtra {
      mozilla::Maybe<nsCString> additionalName;
      mozilla::Maybe<nsCString> email;
      mozilla::Maybe<nsCString> familyName;
      mozilla::Maybe<nsCString> givenName;
      mozilla::Maybe<nsCString> name;
      mozilla::Maybe<nsCString> organization;
      mozilla::Maybe<nsCString> tel;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (additionalName) {
          extraKeys.AppendElement()->AssignASCII("additional_name");
          extraValues.EmplaceBack(additionalName.value());
        }
        if (email) {
          extraKeys.AppendElement()->AssignASCII("email");
          extraValues.EmplaceBack(email.value());
        }
        if (familyName) {
          extraKeys.AppendElement()->AssignASCII("family_name");
          extraValues.EmplaceBack(familyName.value());
        }
        if (givenName) {
          extraKeys.AppendElement()->AssignASCII("given_name");
          extraValues.EmplaceBack(givenName.value());
        }
        if (name) {
          extraKeys.AppendElement()->AssignASCII("name");
          extraValues.EmplaceBack(name.value());
        }
        if (organization) {
          extraKeys.AppendElement()->AssignASCII("organization");
          extraValues.EmplaceBack(organization.value());
        }
        if (tel) {
          extraKeys.AppendElement()->AssignASCII("tel");
          extraValues.EmplaceBack(tel.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Address has too many fields so we cannot cover them all in the above
     * `address_form` telemetry This telemetry is used to record address fields that
     * are not listed in `address_form` This event was generated to correspond to the
     * Legacy Telemetry event address.detected#address_form_ext.
   */
  constexpr impl::EventMetric<DetectedAddressFormExtExtra> detected_address_form_ext(3959);

  /**
   * generated from address.disable_capture_doorhanger
   */
    struct DisableCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.disable#capture_doorhanger.
   */
  constexpr impl::EventMetric<DisableCaptureDoorhangerExtra> disable_capture_doorhanger(3960);

  /**
   * generated from address.disable_edit_doorhanger
   */
    struct DisableEditDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.disable#edit_doorhanger.
   */
  constexpr impl::EventMetric<DisableEditDoorhangerExtra> disable_edit_doorhanger(3961);

  /**
   * generated from address.disable_update_doorhanger
   */
    struct DisableUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.disable#update_doorhanger.
   */
  constexpr impl::EventMetric<DisableUpdateDoorhangerExtra> disable_update_doorhanger(3962);

  /**
   * generated from address.edit_manage
   */
    struct EditManageExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for address autofill preferences management UI. This event
     * was generated to correspond to the Legacy Telemetry event address.edit#manage.
   */
  constexpr impl::EventMetric<EditManageExtra> edit_manage(3963);

  /**
   * generated from address.filled_address_form
   */
    struct FilledAddressFormExtra {
      mozilla::Maybe<nsCString> addressLevel1;
      mozilla::Maybe<nsCString> addressLevel2;
      mozilla::Maybe<nsCString> addressLine1;
      mozilla::Maybe<nsCString> addressLine2;
      mozilla::Maybe<nsCString> addressLine3;
      mozilla::Maybe<nsCString> country;
      mozilla::Maybe<nsCString> postalCode;
      mozilla::Maybe<nsCString> streetAddress;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addressLevel1) {
          extraKeys.AppendElement()->AssignASCII("address_level1");
          extraValues.EmplaceBack(addressLevel1.value());
        }
        if (addressLevel2) {
          extraKeys.AppendElement()->AssignASCII("address_level2");
          extraValues.EmplaceBack(addressLevel2.value());
        }
        if (addressLine1) {
          extraKeys.AppendElement()->AssignASCII("address_line1");
          extraValues.EmplaceBack(addressLine1.value());
        }
        if (addressLine2) {
          extraKeys.AppendElement()->AssignASCII("address_line2");
          extraValues.EmplaceBack(addressLine2.value());
        }
        if (addressLine3) {
          extraKeys.AppendElement()->AssignASCII("address_line3");
          extraValues.EmplaceBack(addressLine3.value());
        }
        if (country) {
          extraKeys.AppendElement()->AssignASCII("country");
          extraValues.EmplaceBack(country.value());
        }
        if (postalCode) {
          extraKeys.AppendElement()->AssignASCII("postal_code");
          extraValues.EmplaceBack(postalCode.value());
        }
        if (streetAddress) {
          extraKeys.AppendElement()->AssignASCII("street_address");
          extraValues.EmplaceBack(streetAddress.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a form is autofiled. Possible values are `filled`, `not_filled`,
     * `user_filled` or `unavailable`.
     * This event was generated to correspond to the Legacy Telemetry event
     * address.filled#address_form.
   */
  constexpr impl::EventMetric<FilledAddressFormExtra> filled_address_form(3964);

  /**
   * generated from address.filled_address_form_ext
   */
    struct FilledAddressFormExtExtra {
      mozilla::Maybe<nsCString> additionalName;
      mozilla::Maybe<nsCString> email;
      mozilla::Maybe<nsCString> familyName;
      mozilla::Maybe<nsCString> givenName;
      mozilla::Maybe<nsCString> name;
      mozilla::Maybe<nsCString> organization;
      mozilla::Maybe<nsCString> tel;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (additionalName) {
          extraKeys.AppendElement()->AssignASCII("additional_name");
          extraValues.EmplaceBack(additionalName.value());
        }
        if (email) {
          extraKeys.AppendElement()->AssignASCII("email");
          extraValues.EmplaceBack(email.value());
        }
        if (familyName) {
          extraKeys.AppendElement()->AssignASCII("family_name");
          extraValues.EmplaceBack(familyName.value());
        }
        if (givenName) {
          extraKeys.AppendElement()->AssignASCII("given_name");
          extraValues.EmplaceBack(givenName.value());
        }
        if (name) {
          extraKeys.AppendElement()->AssignASCII("name");
          extraValues.EmplaceBack(name.value());
        }
        if (organization) {
          extraKeys.AppendElement()->AssignASCII("organization");
          extraValues.EmplaceBack(organization.value());
        }
        if (tel) {
          extraKeys.AppendElement()->AssignASCII("tel");
          extraValues.EmplaceBack(tel.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Address has too many fields so we cannot cover them all in the above
     * `address_form` telemetry This telemetry is used to record address fields that
     * are not listed in `address_form` This event was generated to correspond to the
     * Legacy Telemetry event address.filled#address_form_ext.
   */
  constexpr impl::EventMetric<FilledAddressFormExtExtra> filled_address_form_ext(3965);

  /**
   * generated from address.filled_modified_address_form
   */
    struct FilledModifiedAddressFormExtra {
      mozilla::Maybe<nsCString> addressLevel1;
      mozilla::Maybe<nsCString> addressLevel2;
      mozilla::Maybe<nsCString> addressLine1;
      mozilla::Maybe<nsCString> addressLine2;
      mozilla::Maybe<nsCString> addressLine3;
      mozilla::Maybe<nsCString> country;
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> postalCode;
      mozilla::Maybe<nsCString> streetAddress;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addressLevel1) {
          extraKeys.AppendElement()->AssignASCII("address_level1");
          extraValues.EmplaceBack(addressLevel1.value());
        }
        if (addressLevel2) {
          extraKeys.AppendElement()->AssignASCII("address_level2");
          extraValues.EmplaceBack(addressLevel2.value());
        }
        if (addressLine1) {
          extraKeys.AppendElement()->AssignASCII("address_line1");
          extraValues.EmplaceBack(addressLine1.value());
        }
        if (addressLine2) {
          extraKeys.AppendElement()->AssignASCII("address_line2");
          extraValues.EmplaceBack(addressLine2.value());
        }
        if (addressLine3) {
          extraKeys.AppendElement()->AssignASCII("address_line3");
          extraValues.EmplaceBack(addressLine3.value());
        }
        if (country) {
          extraKeys.AppendElement()->AssignASCII("country");
          extraValues.EmplaceBack(country.value());
        }
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (postalCode) {
          extraKeys.AppendElement()->AssignASCII("postal_code");
          extraValues.EmplaceBack(postalCode.value());
        }
        if (streetAddress) {
          extraKeys.AppendElement()->AssignASCII("street_address");
          extraValues.EmplaceBack(streetAddress.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a field is autofilled and then modified by the user. Using
     * field_name to record the field that triggers this event.
     * This event was generated to correspond to the Legacy Telemetry event
     * address.filled_modified#address_form.
   */
  constexpr impl::EventMetric<FilledModifiedAddressFormExtra> filled_modified_address_form(3966);

  /**
   * generated from address.learn_more_capture_doorhanger
   */
    struct LearnMoreCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.learn_more#capture_doorhanger.
   */
  constexpr impl::EventMetric<LearnMoreCaptureDoorhangerExtra> learn_more_capture_doorhanger(3967);

  /**
   * generated from address.learn_more_edit_doorhanger
   */
    struct LearnMoreEditDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.learn_more#edit_doorhanger.
   */
  constexpr impl::EventMetric<LearnMoreEditDoorhangerExtra> learn_more_edit_doorhanger(3968);

  /**
   * generated from address.learn_more_update_doorhanger
   */
    struct LearnMoreUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.learn_more#update_doorhanger.
   */
  constexpr impl::EventMetric<LearnMoreUpdateDoorhangerExtra> learn_more_update_doorhanger(3969);

  /**
   * generated from address.popup_shown_address_form
   */
    struct PopupShownAddressFormExtra {
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when autofill popup is shown. Using field_name to record the field
     * that triggers this event.
     * This event was generated to correspond to the Legacy Telemetry event
     * address.popup_shown#address_form.
   */
  constexpr impl::EventMetric<PopupShownAddressFormExtra> popup_shown_address_form(3970);

  /**
   * generated from address.pref_capture_doorhanger
   */
    struct PrefCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.pref#capture_doorhanger.
   */
  constexpr impl::EventMetric<PrefCaptureDoorhangerExtra> pref_capture_doorhanger(3971);

  /**
   * generated from address.pref_edit_doorhanger
   */
    struct PrefEditDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.pref#edit_doorhanger.
   */
  constexpr impl::EventMetric<PrefEditDoorhangerExtra> pref_edit_doorhanger(3972);

  /**
   * generated from address.pref_update_doorhanger
   */
    struct PrefUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.pref#update_doorhanger.
   */
  constexpr impl::EventMetric<PrefUpdateDoorhangerExtra> pref_update_doorhanger(3973);

  /**
   * generated from address.save_capture_doorhanger
   */
    struct SaveCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.save#capture_doorhanger.
   */
  constexpr impl::EventMetric<SaveCaptureDoorhangerExtra> save_capture_doorhanger(3974);

  /**
   * generated from address.save_edit_doorhanger
   */
    struct SaveEditDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.save#edit_doorhanger.
   */
  constexpr impl::EventMetric<SaveEditDoorhangerExtra> save_edit_doorhanger(3975);

  /**
   * generated from address.save_update_doorhanger
   */
    struct SaveUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.save#update_doorhanger.
   */
  constexpr impl::EventMetric<SaveUpdateDoorhangerExtra> save_update_doorhanger(3976);

  /**
   * generated from address.show_capture_doorhanger
   */
    struct ShowCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.show#capture_doorhanger.
   */
  constexpr impl::EventMetric<ShowCaptureDoorhangerExtra> show_capture_doorhanger(3977);

  /**
   * generated from address.show_edit_doorhanger
   */
    struct ShowEditDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.show#edit_doorhanger.
   */
  constexpr impl::EventMetric<ShowEditDoorhangerExtra> show_edit_doorhanger(3978);

  /**
   * generated from address.show_entry_manage
   */
    struct ShowEntryManageExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for address autofill preferences management UI. This event
     * was generated to correspond to the Legacy Telemetry event
     * address.show_entry#manage.
   */
  constexpr impl::EventMetric<ShowEntryManageExtra> show_entry_manage(3979);

  /**
   * generated from address.show_manage
   */
    struct ShowManageExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for address autofill preferences management UI. This event
     * was generated to correspond to the Legacy Telemetry event address.show#manage.
   */
  constexpr impl::EventMetric<ShowManageExtra> show_manage(3980);

  /**
   * generated from address.show_update_doorhanger
   */
    struct ShowUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.show#update_doorhanger.
   */
  constexpr impl::EventMetric<ShowUpdateDoorhangerExtra> show_update_doorhanger(3981);

  /**
   * generated from address.submitted_address_form
   */
    struct SubmittedAddressFormExtra {
      mozilla::Maybe<nsCString> addressLevel1;
      mozilla::Maybe<nsCString> addressLevel2;
      mozilla::Maybe<nsCString> addressLine1;
      mozilla::Maybe<nsCString> addressLine2;
      mozilla::Maybe<nsCString> addressLine3;
      mozilla::Maybe<nsCString> country;
      mozilla::Maybe<nsCString> postalCode;
      mozilla::Maybe<nsCString> streetAddress;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addressLevel1) {
          extraKeys.AppendElement()->AssignASCII("address_level1");
          extraValues.EmplaceBack(addressLevel1.value());
        }
        if (addressLevel2) {
          extraKeys.AppendElement()->AssignASCII("address_level2");
          extraValues.EmplaceBack(addressLevel2.value());
        }
        if (addressLine1) {
          extraKeys.AppendElement()->AssignASCII("address_line1");
          extraValues.EmplaceBack(addressLine1.value());
        }
        if (addressLine2) {
          extraKeys.AppendElement()->AssignASCII("address_line2");
          extraValues.EmplaceBack(addressLine2.value());
        }
        if (addressLine3) {
          extraKeys.AppendElement()->AssignASCII("address_line3");
          extraValues.EmplaceBack(addressLine3.value());
        }
        if (country) {
          extraKeys.AppendElement()->AssignASCII("country");
          extraValues.EmplaceBack(country.value());
        }
        if (postalCode) {
          extraKeys.AppendElement()->AssignASCII("postal_code");
          extraValues.EmplaceBack(postalCode.value());
        }
        if (streetAddress) {
          extraKeys.AppendElement()->AssignASCII("street_address");
          extraValues.EmplaceBack(streetAddress.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a form is submitted. Possible values are `autofilled`,
     * `not_filled`, `user_filled` or `unavailable`.
     * This event was generated to correspond to the Legacy Telemetry event
     * address.submitted#address_form.
   */
  constexpr impl::EventMetric<SubmittedAddressFormExtra> submitted_address_form(3982);

  /**
   * generated from address.submitted_address_form_ext
   */
    struct SubmittedAddressFormExtExtra {
      mozilla::Maybe<nsCString> additionalName;
      mozilla::Maybe<nsCString> email;
      mozilla::Maybe<nsCString> familyName;
      mozilla::Maybe<nsCString> givenName;
      mozilla::Maybe<nsCString> name;
      mozilla::Maybe<nsCString> organization;
      mozilla::Maybe<nsCString> tel;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (additionalName) {
          extraKeys.AppendElement()->AssignASCII("additional_name");
          extraValues.EmplaceBack(additionalName.value());
        }
        if (email) {
          extraKeys.AppendElement()->AssignASCII("email");
          extraValues.EmplaceBack(email.value());
        }
        if (familyName) {
          extraKeys.AppendElement()->AssignASCII("family_name");
          extraValues.EmplaceBack(familyName.value());
        }
        if (givenName) {
          extraKeys.AppendElement()->AssignASCII("given_name");
          extraValues.EmplaceBack(givenName.value());
        }
        if (name) {
          extraKeys.AppendElement()->AssignASCII("name");
          extraValues.EmplaceBack(name.value());
        }
        if (organization) {
          extraKeys.AppendElement()->AssignASCII("organization");
          extraValues.EmplaceBack(organization.value());
        }
        if (tel) {
          extraKeys.AppendElement()->AssignASCII("tel");
          extraValues.EmplaceBack(tel.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Address has too many fields so we cannot cover them all in the above
     * `address_form` telemetry This telemetry is used to record address fields that
     * are not listed in `address_form` This event was generated to correspond to the
     * Legacy Telemetry event address.submitted#address_form_ext.
   */
  constexpr impl::EventMetric<SubmittedAddressFormExtExtra> submitted_address_form_ext(3983);

  /**
   * generated from address.update_capture_doorhanger
   */
    struct UpdateCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.update#capture_doorhanger.
   */
  constexpr impl::EventMetric<UpdateCaptureDoorhangerExtra> update_capture_doorhanger(3984);

  /**
   * generated from address.update_edit_doorhanger
   */
    struct UpdateEditDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.update#edit_doorhanger.
   */
  constexpr impl::EventMetric<UpdateEditDoorhangerExtra> update_edit_doorhanger(3985);

  /**
   * generated from address.update_update_doorhanger
   */
    struct UpdateUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser address autofill doorhanger. This event was
     * generated to correspond to the Legacy Telemetry event
     * address.update#update_doorhanger.
   */
  constexpr impl::EventMetric<UpdateUpdateDoorhangerExtra> update_update_doorhanger(3986);

}
namespace creditcard {
  /**
   * generated from creditcard.add_manage
   */
    struct AddManageExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for credit card autofill preferences management UI. This
     * event was generated to correspond to the Legacy Telemetry event
     * creditcard.add#manage.
   */
  constexpr impl::EventMetric<AddManageExtra> add_manage(3987);

  /**
   * generated from creditcard.cancel_capture_doorhanger
   */
    struct CancelCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser credit card autofill doorhanger. This event
     * was generated to correspond to the Legacy Telemetry event
     * creditcard.cancel#capture_doorhanger.
   */
  constexpr impl::EventMetric<CancelCaptureDoorhangerExtra> cancel_capture_doorhanger(3988);

  /**
   * generated from creditcard.cancel_update_doorhanger
   */
    struct CancelUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser credit card autofill doorhanger. This event
     * was generated to correspond to the Legacy Telemetry event
     * creditcard.cancel#update_doorhanger.
   */
  constexpr impl::EventMetric<CancelUpdateDoorhangerExtra> cancel_update_doorhanger(3989);

  /**
   * generated from creditcard.cleared_cc_form_v2
   */
    struct ClearedCcFormV2Extra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a form is cleared. Using field_name to record the field that
     * triggers this event.
     * This event was generated to correspond to the Legacy Telemetry event
     * creditcard.cleared#cc_form_v2.
   */
  constexpr impl::EventMetric<ClearedCcFormV2Extra> cleared_cc_form_v2(3990);

  /**
   * generated from creditcard.delete_manage
   */
    struct DeleteManageExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for credit card autofill preferences management UI. This
     * event was generated to correspond to the Legacy Telemetry event
     * creditcard.delete#manage.
   */
  constexpr impl::EventMetric<DeleteManageExtra> delete_manage(3991);

  /**
   * generated from creditcard.detected_cc_form_v2
   */
    struct DetectedCcFormV2Extra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a form is recognized as a credit card form. The possible value of
     * cc_* in extra_keys are "true", "false", or an integer between 0-100. When the
     * value is "true", the field is identified via autocomplete attribute. When the
     * value is "false", the field is not detected in the form. When the value is an
     * integer greater than 0, the value indicates the confidence value from fathom
     * (normalized to 0-100). When the value is an 0, then the field is identified by
     * regexp-based heuristic.
     * This event was generated to correspond to the Legacy Telemetry event
     * creditcard.detected#cc_form_v2.
   */
  constexpr impl::EventMetric<DetectedCcFormV2Extra> detected_cc_form_v2(3992);

  /**
   * generated from creditcard.disable_capture_doorhanger
   */
    struct DisableCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser credit card autofill doorhanger. This event
     * was generated to correspond to the Legacy Telemetry event
     * creditcard.disable#capture_doorhanger.
   */
  constexpr impl::EventMetric<DisableCaptureDoorhangerExtra> disable_capture_doorhanger(3993);

  /**
   * generated from creditcard.disable_update_doorhanger
   */
    struct DisableUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser credit card autofill doorhanger. This event
     * was generated to correspond to the Legacy Telemetry event
     * creditcard.disable#update_doorhanger.
   */
  constexpr impl::EventMetric<DisableUpdateDoorhangerExtra> disable_update_doorhanger(3994);

  /**
   * generated from creditcard.edit_manage
   */
    struct EditManageExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for credit card autofill preferences management UI. This
     * event was generated to correspond to the Legacy Telemetry event
     * creditcard.edit#manage.
   */
  constexpr impl::EventMetric<EditManageExtra> edit_manage(3995);

  /**
   * generated from creditcard.filled_cc_form_v2
   */
    struct FilledCcFormV2Extra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a form is autofiled. Possible values are `filled`, `not_filled`,
     * `user_filled` or `unavailable`.
     * This event was generated to correspond to the Legacy Telemetry event
     * creditcard.filled#cc_form_v2.
   */
  constexpr impl::EventMetric<FilledCcFormV2Extra> filled_cc_form_v2(3996);

  /**
   * generated from creditcard.filled_modified_cc_form_v2
   */
    struct FilledModifiedCcFormV2Extra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a field is autofilled and then modified by the user. Using
     * field_name to record the field that triggers this event.
     * This event was generated to correspond to the Legacy Telemetry event
     * creditcard.filled_modified#cc_form_v2.
   */
  constexpr impl::EventMetric<FilledModifiedCcFormV2Extra> filled_modified_cc_form_v2(3997);

  /**
   * generated from creditcard.popup_shown_cc_form_v2
   */
    struct PopupShownCcFormV2Extra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when autofill popup is shown. Using field_name to record the field
     * that triggers this event.
     * This event was generated to correspond to the Legacy Telemetry event
     * creditcard.popup_shown#cc_form_v2.
   */
  constexpr impl::EventMetric<PopupShownCcFormV2Extra> popup_shown_cc_form_v2(3998);

  /**
   * generated from creditcard.save_capture_doorhanger
   */
    struct SaveCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser credit card autofill doorhanger. This event
     * was generated to correspond to the Legacy Telemetry event
     * creditcard.save#capture_doorhanger.
   */
  constexpr impl::EventMetric<SaveCaptureDoorhangerExtra> save_capture_doorhanger(3999);

  /**
   * generated from creditcard.save_update_doorhanger
   */
    struct SaveUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser credit card autofill doorhanger. This event
     * was generated to correspond to the Legacy Telemetry event
     * creditcard.save#update_doorhanger.
   */
  constexpr impl::EventMetric<SaveUpdateDoorhangerExtra> save_update_doorhanger(4000);

  /**
   * generated from creditcard.show_capture_doorhanger
   */
    struct ShowCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser credit card autofill doorhanger. This event
     * was generated to correspond to the Legacy Telemetry event
     * creditcard.show#capture_doorhanger.
   */
  constexpr impl::EventMetric<ShowCaptureDoorhangerExtra> show_capture_doorhanger(4001);

  /**
   * generated from creditcard.show_entry_manage
   */
    struct ShowEntryManageExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for credit card autofill preferences management UI. This
     * event was generated to correspond to the Legacy Telemetry event
     * creditcard.show_entry#manage.
   */
  constexpr impl::EventMetric<ShowEntryManageExtra> show_entry_manage(4002);

  /**
   * generated from creditcard.show_manage
   */
    struct ShowManageExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for credit card autofill preferences management UI. This
     * event was generated to correspond to the Legacy Telemetry event
     * creditcard.show#manage.
   */
  constexpr impl::EventMetric<ShowManageExtra> show_manage(4003);

  /**
   * generated from creditcard.show_update_doorhanger
   */
    struct ShowUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser credit card autofill doorhanger. This event
     * was generated to correspond to the Legacy Telemetry event
     * creditcard.show#update_doorhanger.
   */
  constexpr impl::EventMetric<ShowUpdateDoorhangerExtra> show_update_doorhanger(4004);

  /**
   * generated from creditcard.submitted_cc_form_v2
   */
    struct SubmittedCcFormV2Extra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a form is submitted. Possible values are `autofilled`,
     * `user_filled` or `unavailable`.
     * This event was generated to correspond to the Legacy Telemetry event
     * creditcard.submitted#cc_form_v2.
   */
  constexpr impl::EventMetric<SubmittedCcFormV2Extra> submitted_cc_form_v2(4005);

  /**
   * generated from creditcard.update_capture_doorhanger
   */
    struct UpdateCaptureDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser credit card autofill doorhanger. This event
     * was generated to correspond to the Legacy Telemetry event
     * creditcard.update#capture_doorhanger.
   */
  constexpr impl::EventMetric<UpdateCaptureDoorhangerExtra> update_capture_doorhanger(4006);

  /**
   * generated from creditcard.update_update_doorhanger
   */
    struct UpdateUpdateDoorhangerExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interactions for the browser credit card autofill doorhanger. This event
     * was generated to correspond to the Legacy Telemetry event
     * creditcard.update#update_doorhanger.
   */
  constexpr impl::EventMetric<UpdateUpdateDoorhangerExtra> update_update_doorhanger(4007);

}
namespace formautofill {
  /**
   * generated from formautofill.availability
   */
  /**
   * A boolean sent once per session to represent whether the formautofill is
     * available in the build This metric was generated to correspond to the Legacy
     * Telemetry scalar formautofill.availability.
   */
  constexpr impl::BooleanMetric availability(4008);

  /**
   * generated from formautofill.form_submission_heuristic
   */
  enum class FormSubmissionHeuristicLabel: uint16_t {
      eFormSubmitEvent = 0,
      eFormRemovalAfterFetch = 1,
      ePageNavigation = 2,
      eIframePagehide = 3,
      e__Other__,
    };
  /**
   * The heuristic that detected the form submission.
   */
  constexpr impl::Labeled<impl::CounterMetric, FormSubmissionHeuristicLabel> form_submission_heuristic(4009);

  /**
   * generated from formautofill.iframe_layout_detection
   */
    struct IframeLayoutDetectionExtra {
      mozilla::Maybe<nsCString> category;
      mozilla::Maybe<nsCString> crossOrigin;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> iframe;
      mozilla::Maybe<uint32_t> iframeCount;
      mozilla::Maybe<nsCString> mainFrame;
      mozilla::Maybe<nsCString> sandboxed;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (category) {
          extraKeys.AppendElement()->AssignASCII("category");
          extraValues.EmplaceBack(category.value());
        }
        if (crossOrigin) {
          extraKeys.AppendElement()->AssignASCII("cross_origin");
          extraValues.EmplaceBack(crossOrigin.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (iframe) {
          extraKeys.AppendElement()->AssignASCII("iframe");
          extraValues.EmplaceBack(iframe.value());
        }
        if (iframeCount) {
          extraKeys.AppendElement()->AssignASCII("iframe_count");
          extraValues.EmplaceBack(nsPrintfCString("%d", iframeCount.value()));
        }
        if (mainFrame) {
          extraKeys.AppendElement()->AssignASCII("main_frame");
          extraValues.EmplaceBack(mainFrame.value());
        }
        if (sandboxed) {
          extraKeys.AppendElement()->AssignASCII("sandboxed");
          extraValues.EmplaceBack(sandboxed.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record the number of iframe in a form and what fields are in an iframe when a
     * form is detected
   */
  constexpr impl::EventMetric<IframeLayoutDetectionExtra> iframe_layout_detection(4010);

}
namespace formautofill_addresses {
  /**
   * generated from formautofill.addresses.autofill_profiles_count
   */
  /**
   * Count at store time how many address autofill profiles user has. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * formautofill.addresses.autofill_profiles_count.
   */
  constexpr impl::QuantityMetric autofill_profiles_count(4011);

}
namespace formautofill_creditcards {
  /**
   * generated from formautofill.creditcards.autofill_profiles_count
   */
  /**
   * Count at store time how many credit card autofill profiles the user has.
   */
  constexpr impl::QuantityMetric autofill_profiles_count(4012);

  /**
   * generated from formautofill.creditcards.form_cleared
   */
    struct FormClearedExtra {
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a credit card form is cleared . The flow id indicates an
     * interaction session with the a form and is shared across cc_form events. The
     * field_name is used to record the field that triggers this event
   */
  constexpr impl::EventMetric<FormClearedExtra> form_cleared(4013);

  /**
   * generated from formautofill.creditcards.form_detected
   */
    struct FormDetectedExtra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<uint32_t> ccNumberMultiParts;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccNumberMultiParts) {
          extraKeys.AppendElement()->AssignASCII("cc_number_multi_parts");
          extraValues.EmplaceBack(nsPrintfCString("%d", ccNumberMultiParts.value()));
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a form is recognized as a credit card form. The possible value of
     * cc_* are "autocomplete", "undetected", "regexp" or an integer between 0-100:
     *   - When the value is "autocomplete", the field is identified via autocomplete
     * attribute
     *   - When the value is "undetected", the field is not detected in the form
     *   - When the value is "regexp", then the field is identified by regexp-based
     * heuristic
     *   - When the value is an integer greater than 0, the value indicates the
     * confidence value from fathom (normalized to 0-100)
     * The flow id points to an interaction session with a credit card form and is
     * shared across cc_form events .
   */
  constexpr impl::EventMetric<FormDetectedExtra> form_detected(4014);

  /**
   * generated from formautofill.creditcards.form_filled
   */
    struct FormFilledExtra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a credit card form is autofilled. The flow id indicates an
     * interaction session with the a form and is shared across cc_form events. The
     * possible value of cc_* are `filled`, `not_filled`, `user_filled` or
     * `unavailable`
   */
  constexpr impl::EventMetric<FormFilledExtra> form_filled(4015);

  /**
   * generated from formautofill.creditcards.form_filled_modified
   */
    struct FormFilledModifiedExtra {
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a field in a credit card form is autofilled and then modified by
     * the user. The flow id indicates an interaction session with the a form and is
     * shared across cc_form events. The field_name is used to record the field that
     * triggers this event.
   */
  constexpr impl::EventMetric<FormFilledModifiedExtra> form_filled_modified(4016);

  /**
   * generated from formautofill.creditcards.form_popup_shown
   */
    struct FormPopupShownExtra {
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when autofill popup is shown for a credit card form. The flow id
     * indicates an interaction session with the a form and is shared across cc_form
     * events. The field_name is used to record the field that triggers this event.
   */
  constexpr impl::EventMetric<FormPopupShownExtra> form_popup_shown(4017);

  /**
   * generated from formautofill.creditcards.form_submitted
   */
    struct FormSubmittedExtra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a credit card form is submitted. The flow id indicates an
     * interaction session with the a form and is shared across cc_form events. The
     * possible value of cc_* are `autofilled`, `user_filled` or `unavailable`
   */
  constexpr impl::EventMetric<FormSubmittedExtra> form_submitted(4018);

}
namespace formautofill_ml {
  /**
   * generated from formautofill.ml.field_infer_result
   */
    struct FieldInferResultExtra {
      mozilla::Maybe<nsCString> fathomInferLabel;
      mozilla::Maybe<nsCString> fathomInferScore;
      mozilla::Maybe<nsCString> inferFieldName;
      mozilla::Maybe<nsCString> inferReason;
      mozilla::Maybe<nsCString> mlInferLabel;
      mozilla::Maybe<nsCString> mlInferScore;
      mozilla::Maybe<nsCString> mlRevision;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fathomInferLabel) {
          extraKeys.AppendElement()->AssignASCII("fathom_infer_label");
          extraValues.EmplaceBack(fathomInferLabel.value());
        }
        if (fathomInferScore) {
          extraKeys.AppendElement()->AssignASCII("fathom_infer_score");
          extraValues.EmplaceBack(fathomInferScore.value());
        }
        if (inferFieldName) {
          extraKeys.AppendElement()->AssignASCII("infer_field_name");
          extraValues.EmplaceBack(inferFieldName.value());
        }
        if (inferReason) {
          extraKeys.AppendElement()->AssignASCII("infer_reason");
          extraValues.EmplaceBack(inferReason.value());
        }
        if (mlInferLabel) {
          extraKeys.AppendElement()->AssignASCII("ml_infer_label");
          extraValues.EmplaceBack(mlInferLabel.value());
        }
        if (mlInferScore) {
          extraKeys.AppendElement()->AssignASCII("ml_infer_score");
          extraValues.EmplaceBack(mlInferScore.value());
        }
        if (mlRevision) {
          extraKeys.AppendElement()->AssignASCII("ml_revision");
          extraValues.EmplaceBack(mlRevision.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Captures the result from both ML-based model and existing heuristics for
     * autofill field classification.
   */
  constexpr impl::EventMetric<FieldInferResultExtra> field_infer_result(4019);

}
namespace fog {
  /**
   * generated from fog.failed_idle_registration
   */
  /**
   * True if we failed to register with the idle service. Absent otherwise.
     * Means IPC probably isn't working well.
     * Child-process data will likely be absent, or incomplete.
   */
  constexpr impl::BooleanMetric failed_idle_registration(4020);

  /**
   * generated from fog.initialization
   */
  /**
   * Time the FOG initialization takes.
   */
  constexpr impl::TimespanMetric initialization(4021);

  /**
   * generated from fog.inits_during_shutdown
   */
  /**
   * Counts the number of times init had to be called during shutdown.
     * Should never have a value for any session long enough to grow idle.
   */
  constexpr impl::CounterMetric inits_during_shutdown(4022);

  /**
   * generated from fog.max_pings_per_minute
   */
  /**
   * Value of the configurable rate limit, in pings per minute, for Glean pings as
     * set at init.
   */
  constexpr impl::QuantityMetric max_pings_per_minute(4023);

}
namespace fog_ipc {
  /**
   * generated from fog.ipc.buffer_sizes
   */
  /**
   * The number and size of the IPC buffers being received over FOG IPC.
   */
  constexpr impl::MemoryDistributionMetric buffer_sizes(4024);

  /**
   * generated from fog.ipc.flush_durations
   */
  /**
   * The length of time between asking the child processes for their
     * IPC buffers and all of them being received by the parent.
   */
  constexpr impl::TimingDistributionMetric flush_durations(4025);

  /**
   * generated from fog.ipc.flush_failures
   */
  /**
   * The number of times we failed to flush all non-parent-process data,
     * throwing even partial results into the trash.
     * If this number is high, we might consider writing custom `MozPromise`-
     * handling code instead of using `MozPromise::All`.
   */
  constexpr impl::CounterMetric flush_failures(4026);

  /**
   * generated from fog.ipc.replay_failures
   */
  /**
   * The number of times the ipc buffer failed to be replayed in the
     * parent process.
   */
  constexpr impl::CounterMetric replay_failures(4027);

  /**
   * generated from fog.ipc.shutdown_registration_failures
   */
  /**
   * The number of times we tried to register shutdown flush routines for
     * content child processes, and failed (probably because there was no main
     * thread).
     * As a result there may be data loss from content child processes.
     * Large or rising number of clients experiencing this indicates we should
     * perhaps refactor content child shutdown in FOG to try harder to register
     * flush operations.
     * Will likely be obsoleted by bug 1641989.
   */
  constexpr impl::CounterMetric shutdown_registration_failures(4028);

}
namespace test_only {
  /**
   * generated from test_only.bad_code
   */
  /**
   * Number of times we encountered bad code.
     * This is a test-only metric.
   */
  constexpr impl::CounterMetric bad_code(4029);


  /**
   * generated from test_only.button_jars
   */
  /**
   * The number of buttons in each button jar.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::QuantityMetric, DynamicLabel> button_jars(4031);

  /**
   * generated from test_only.can_we_flag_it
   */
  /**
   * Test metric for a boolean.
     * This is a test-only metric.
   */
  constexpr impl::BooleanMetric can_we_flag_it(4032);

  /**
   * generated from test_only.can_we_time_it
   */
  /**
   * Test metric for a timespan.
     * This is a test-only metric.
   */
  constexpr impl::TimespanMetric can_we_time_it(4033);

  /**
   * generated from test_only.cheesy_string
   */
  /**
   * Only the cheesiest of strings.
     * This is a test-only metric.
   */
  constexpr impl::StringMetric cheesy_string(4034);

  /**
   * generated from test_only.cheesy_string_list
   */
  /**
   * Only the cheesiest of strings. In list form!
     * This is a test-only metric.
   */
  constexpr impl::StringListMetric cheesy_string_list(4035);


  /**
   * generated from test_only.default_products
   */
  /**
   * A testing uint scalar; not meant to be touched This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.test.default_products.
   */
  constexpr impl::CounterMetric default_products(4037);

  /**
   * generated from test_only.desktop_only
   */
  /**
   * A testing uint scalar; not meant to be touched This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.test.desktop_only.
   */
  constexpr impl::CounterMetric desktop_only(4038);

  /**
   * generated from test_only.do_you_remember
   */
  /**
   * They say it's the second thing to go.
     * This is a test-only metric.
   */
  constexpr impl::MemoryDistributionMetric do_you_remember(4039);

  /**
   * generated from test_only.expired
   */
  /**
   * This mirrors to an expired testing scalar. This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.test.expired.
   */
  constexpr impl::CounterMetric expired(4040);

  /**
   * generated from test_only.impression_id_only
   */
  /**
   * This is a test uint type with only the deletion-request store. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * telemetry.test.impression_id_only.
   */
  constexpr impl::StringMetric impression_id_only(4041);

  /**
   * generated from test_only.keyed_expired
   */
  /**
   * This mirrors to an expired testing scalar. This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.test.keyed_expired.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> keyed_expired(4042);

  /**
   * generated from test_only.keyed_mobile_only
   */
  /**
   * A keyed testing uint scalar; not meant to be touched This metric was generated
     * to correspond to the Legacy Telemetry scalar telemetry.test.keyed_mobile_only.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> keyed_mobile_only(4043);

  /**
   * generated from test_only.keyed_release_optin
   */
  /**
   * A testing scalar; not meant to be touched. This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.test.keyed_release_optin.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> keyed_release_optin(4044);

  /**
   * generated from test_only.keyed_release_optout
   */
  /**
   * A testing scalar; not meant to be touched. This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.test.keyed_release_optout.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> keyed_release_optout(4045);

  /**
   * generated from test_only.mabels_balloon_labels
   */
  enum class MabelsBalloonLabelsLabel: uint16_t {
      eCelebratory = 0,
      eCelebratoryAndSnarky = 1,
      e__Other__,
    };
  /**
   * How does Mabel label her balloons?
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::StringMetric, MabelsBalloonLabelsLabel> mabels_balloon_labels(4046);

  /**
   * generated from test_only.mabels_balloon_strings
   */
  /**
   * What do the labeled Mabel's liked balloons' strings say?
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::StringMetric, DynamicLabel> mabels_balloon_strings(4047);

  /**
   * generated from test_only.mabels_bathroom_counters
   */
  /**
   * Counts Mabels labeled by their bathroom counters.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> mabels_bathroom_counters(4048);

  /**
   * generated from test_only.mabels_custom_label_lengths
   */
  /**
   * Mabel wants to track the length of their new label maker's labels.
   */
  constexpr impl::Labeled<impl::CustomDistributionMetric, DynamicLabel> mabels_custom_label_lengths(4049);

  /**
   * generated from test_only.mabels_kitchen_counters
   */
  /**
   * Counts Mabels labeled by their kitchen counters.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> mabels_kitchen_counters(4050);

  /**
   * generated from test_only.mabels_label_maker
   */
  /**
   * Mabel just got a label maker and wants to party like it's
     * 1999.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::StringMetric, DynamicLabel> mabels_label_maker(4051);

  /**
   * generated from test_only.mabels_labeled_counters
   */
  enum class MabelsLabeledCountersLabel: uint16_t {
      eNextToTheFridge = 0,
      eClean = 1,
      e1stCounter = 2,
      e__Other__,
    };
  /**
   * Counts Mabels labeled by their kitchen counters.
     * Now with static labels.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::CounterMetric, MabelsLabeledCountersLabel> mabels_labeled_counters(4052);

  /**
   * generated from test_only.mabels_like_balloons
   */
  /**
   * Does the labeled Mabel like balloons?
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> mabels_like_balloons(4053);

  /**
   * generated from test_only.mabels_like_labeled_balloons
   */
  enum class MabelsLikeLabeledBalloonsLabel: uint16_t {
      eWater = 0,
      eBirthdayParty = 1,
      e__Other__,
    };
  /**
   * Does the labeled Mabel like balloons?
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::BooleanMetric, MabelsLikeLabeledBalloonsLabel> mabels_like_labeled_balloons(4054);

  /**
   * generated from test_only.main_only
   */
  /**
   * This is a test uint type with only the main store. This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.test.main_only.
   */
  constexpr impl::QuantityMetric main_only(4055);

  /**
   * generated from test_only.meaning_of_life
   */
  /**
   * Measures the one true answer to the Ultimate Question of Life,
     * the Universe, and Everything.
     * Approximately.
     * This is a test-only metric.
   */
  constexpr impl::QuantityMetric meaning_of_life(4056);

  /**
   * generated from test_only.mirror_time
   */
  /**
   * Mirrored metric for a timespan.
     * This is a test-only metric.
   */
  constexpr impl::TimespanMetric mirror_time(4057);

  /**
   * generated from test_only.mirror_time_nanos
   */
  /**
   * Mirrored metric for a timespan.
     * This is a test-only metric.
   */
  constexpr impl::TimespanMetric mirror_time_nanos(4058);

  /**
   * generated from test_only.mirrors_for_labeled_bools
   */
  /**
   * Mirrored metric.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> mirrors_for_labeled_bools(4059);

  /**
   * generated from test_only.mobile_only
   */
  /**
   * A testing uint scalar; not meant to be touched This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.test.mobile_only.
   */
  constexpr impl::CounterMetric mobile_only(4060);

  /**
   * generated from test_only.multiproduct
   */
  /**
   * A testing uint scalar; not meant to be touched This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.test.multiproduct.
   */
  constexpr impl::CounterMetric multiproduct(4061);

  /**
   * generated from test_only.one_ping_one_bool
   */
  /**
   * One bool for one ping only.
     * This is a test-only metric.
   */
  constexpr impl::BooleanMetric one_ping_one_bool(4062);

  /**
   * generated from test_only.release_optin
   */
  /**
   * A testing scalar; not meant to be touched. This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.test.release_optin.
   */
  constexpr impl::CounterMetric release_optin(4063);

  /**
   * generated from test_only.release_optout
   */
  /**
   * A testing scalar; not meant to be touched. This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.test.release_optout.
   */
  constexpr impl::CounterMetric release_optout(4064);

  /**
   * generated from test_only.unexpired
   */
  /**
   * This is an unexpired testing scalar; not meant to be touched. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * telemetry.test.unexpired.
   */
  constexpr impl::CounterMetric unexpired(4065);

  /**
   * generated from test_only.what_a_date
   */
  /**
   * ...To be writing FOG code. This is a test-only metric.
   */
  constexpr impl::DatetimeMetric what_a_date(4066);

  /**
   * generated from test_only.what_do_you_remember
   */
  /**
   * What do they say is the second thing to go?
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::MemoryDistributionMetric, DynamicLabel> what_do_you_remember(4067);

  /**
   * generated from test_only.what_id_it
   */
  /**
   * Just a UUID.
     * This is a test-only metric.
   */
  constexpr impl::UuidMetric what_id_it(4068);

  /**
   * generated from test_only.what_time_is_it
   */
  /**
   * Adheres to at least two of the top ten fallacies programmers believe
     * about time.
     * This is a test-only metric.
   */
  constexpr impl::TimingDistributionMetric what_time_is_it(4069);

  /**
   * generated from test_only.where_has_the_time_gone
   */
  /**
   * Time is different in different places.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, DynamicLabel> where_has_the_time_gone(4070);

}
namespace test_only_ipc {
  /**
   * generated from test_only.ipc.a_bool
   */
  /**
   * This is a test-only metric.
     * Just flagging things.
   */
  constexpr impl::BooleanMetric a_bool(4071);

  /**
   * generated from test_only.ipc.a_counter
   */
  /**
   * This is a test-only metric.
     * Just counting things.
   */
  constexpr impl::CounterMetric a_counter(4072);

  /**
   * generated from test_only.ipc.a_counter_for_hgram
   */
  /**
   * This is a test-only metric.
     * Just counting things.
   */
  constexpr impl::CounterMetric a_counter_for_hgram(4073);

  /**
   * generated from test_only.ipc.a_custom_dist
   */
  /**
   * This is a test-only metric.
     * Just measuring samples.
   */
  constexpr impl::CustomDistributionMetric a_custom_dist(4074);

  /**
   * generated from test_only.ipc.a_date
   */
  /**
   * This is a test-only metric.
     * Just putting things on the calendar.
   */
  constexpr impl::DatetimeMetric a_date(4075);

  /**
   * generated from test_only.ipc.a_labeled_counter
   */
  /**
   * This is a test-only metric.
     * Just counting labeled things.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> a_labeled_counter(4076);

  /**
   * generated from test_only.ipc.a_labeled_counter_for_categorical
   */
  enum class ALabeledCounterForCategoricalLabel: uint16_t {
      eCommonlabel = 0,
      eLabel4 = 1,
      eLabel5 = 2,
      eLabel6 = 3,
      e__Other__,
    };
  /**
   * This is a test-only metric.
     * Just counting things.
   */
  constexpr impl::Labeled<impl::CounterMetric, ALabeledCounterForCategoricalLabel> a_labeled_counter_for_categorical(4077);

  /**
   * generated from test_only.ipc.a_labeled_counter_for_hgram
   */
  enum class ALabeledCounterForHgramLabel: uint16_t {
      eFalse = 0,
      eTrue = 1,
      e__Other__,
    };
  /**
   * This is a test-only metric.
     * Just counting things.
   */
  constexpr impl::Labeled<impl::CounterMetric, ALabeledCounterForHgramLabel> a_labeled_counter_for_hgram(4078);

  /**
   * generated from test_only.ipc.a_labeled_counter_for_keyed_count_hgram
   */
  /**
   * This is a test-only metric.
     * Just counting things.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> a_labeled_counter_for_keyed_count_hgram(4079);

  /**
   * generated from test_only.ipc.a_memory_dist
   */
  /**
   * This is a test-only metric.
     * Just measuring memory.
   */
  constexpr impl::MemoryDistributionMetric a_memory_dist(4080);

  /**
   * generated from test_only.ipc.a_quantity
   */
  /**
   * This is a test-only metric.
     * Just quantifying things.
   */
  constexpr impl::QuantityMetric a_quantity(4081);

  /**
   * generated from test_only.ipc.a_string
   */
  /**
   * This is a test-only metric.
     * Just setting some strings.
   */
  constexpr impl::StringMetric a_string(4082);

  /**
   * generated from test_only.ipc.a_string_list
   */
  /**
   * This is a test-only metric.
     * Just appending some strings.
   */
  constexpr impl::StringListMetric a_string_list(4083);

  /**
   * generated from test_only.ipc.a_text
   */
  /**
   * This is a test-only metric.
     * For holding Text data.
   */
  constexpr impl::TextMetric a_text(4084);

  /**
   * generated from test_only.ipc.a_timing_dist
   */
  /**
   * This is a test-only metric.
     * Just measuring time.
   */
  constexpr impl::TimingDistributionMetric a_timing_dist(4085);

  /**
   * generated from test_only.ipc.a_url
   */
  /**
   * This is a test-only metric.
     * Just setting some Urls.
   */
  constexpr impl::UrlMetric a_url(4086);

  /**
   * generated from test_only.ipc.a_uuid
   */
  /**
   * This is a test-only metric.
     * Just recording some unique identifiers.
   */
  constexpr impl::UuidMetric a_uuid(4087);

  /**
   * generated from test_only.ipc.an_event
   */
    struct AnEventExtra {
      mozilla::Maybe<nsCString> extra1;
      mozilla::Maybe<nsCString> extra2;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (extra1) {
          extraKeys.AppendElement()->AssignASCII("extra1");
          extraValues.EmplaceBack(extra1.value());
        }
        if (extra2) {
          extraKeys.AppendElement()->AssignASCII("extra2");
          extraValues.EmplaceBack(extra2.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is a test-only metric.
     * Just recording some events.
   */
  constexpr impl::EventMetric<AnEventExtra> an_event(4088);

  /**
   * generated from test_only.ipc.an_external_denominator
   */
  /**
   * This is a test-only metric.
     * A denominator not from around here.
   */
  constexpr impl::DenominatorMetric an_external_denominator(4089);

  /**
   * generated from test_only.ipc.an_unordered_bool
   */
  /**
   * This is a test-only metric.
     * Just flagging things unorderedly in child processes.
   */
  constexpr impl::BooleanMetric an_unordered_bool(4090);

  /**
   * generated from test_only.ipc.an_unordered_labeled_boolean
   */
  /**
   * This is a test-only metric.
     * Just flagging labeled things unorderedly in child processes.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> an_unordered_labeled_boolean(4091);

  /**
   * generated from test_only.ipc.another_labeled_counter
   */
  /**
   * This is a test-only metric.
     * Just another metric counting labeled things.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> another_labeled_counter(4092);

  /**
   * generated from test_only.ipc.event_with_extra
   */
    struct EventWithExtraExtra {
      mozilla::Maybe<nsCString> extra1;
      mozilla::Maybe<uint32_t> extra2;
      mozilla::Maybe<bool> extra3LongerName;
      mozilla::Maybe<bool> extra4camelcase;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (extra1) {
          extraKeys.AppendElement()->AssignASCII("extra1");
          extraValues.EmplaceBack(extra1.value());
        }
        if (extra2) {
          extraKeys.AppendElement()->AssignASCII("extra2");
          extraValues.EmplaceBack(nsPrintfCString("%d", extra2.value()));
        }
        if (extra3LongerName) {
          extraKeys.AppendElement()->AssignASCII("extra3_longer_name");
          extraValues.AppendElement()->AssignASCII(extra3LongerName.value() ? "true" : "false");
        }
        if (extra4camelcase) {
          extraKeys.AppendElement()->AssignASCII("extra4CamelCase");
          extraValues.AppendElement()->AssignASCII(extra4camelcase.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is a test-only metric.
     * Just recording some events.
   */
  constexpr impl::EventMetric<EventWithExtraExtra> event_with_extra(4093);

  /**
   * generated from test_only.ipc.irate
   */
  /**
   * This is a test-only metric.
     * A rate that isn't happy about it.
   */
  constexpr impl::RateMetric irate(4094);

  /**
   * generated from test_only.ipc.no_extra_event
   */
  /**
   * This is a test-only metric.
     * Just recording some events without the extra fuss.
   */
  constexpr impl::EventMetric<NoExtraKeys> no_extra_event(4095);

  /**
   * generated from test_only.ipc.rate_with_external_denominator
   */
  /**
   * This is a test-only metric.
     * A rate with a denominator that is Out There.
   */
  constexpr impl::NumeratorMetric rate_with_external_denominator(4096);

}
namespace test_only_jog {
  /**
   * generated from test_only.jog.a_counter
   */
  /**
   * This is a test-only metric.
     * Just counting things.
     * Tied closely to test_jog_name_collision.
   */
  constexpr impl::CounterMetric a_counter(4097);

  /**
   * generated from test_only.jog.an_event
   */
    struct AnEventExtra {
      mozilla::Maybe<nsCString> extra1;
      mozilla::Maybe<nsCString> extra2;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (extra1) {
          extraKeys.AppendElement()->AssignASCII("extra1");
          extraValues.EmplaceBack(extra1.value());
        }
        if (extra2) {
          extraKeys.AppendElement()->AssignASCII("extra2");
          extraValues.EmplaceBack(extra2.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is a test-only metric.
     * Just recording some events.
     * Tied closely to test_jog_name_collision.
   */
  constexpr impl::EventMetric<AnEventExtra> an_event(4098);

}
namespace messaging_experiments {
  /**
   * generated from messaging_experiments.reach_cfr
   */
    struct ReachCfrExtra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#cfr.
   */
  constexpr impl::EventMetric<ReachCfrExtra> reach_cfr(4099);

  /**
   * generated from messaging_experiments.reach_feature_callout
   */
    struct ReachFeatureCalloutExtra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#featureCallout.
   */
  constexpr impl::EventMetric<ReachFeatureCalloutExtra> reach_feature_callout(4100);

  /**
   * generated from messaging_experiments.reach_fxms_bmb_button
   */
    struct ReachFxmsBmbButtonExtra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_bmb_button.
   */
  constexpr impl::EventMetric<ReachFxmsBmbButtonExtra> reach_fxms_bmb_button(4101);

  /**
   * generated from messaging_experiments.reach_fxms_message_1
   */
    struct ReachFxmsMessage1Extra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_message_1.
   */
  constexpr impl::EventMetric<ReachFxmsMessage1Extra> reach_fxms_message_1(4102);

  /**
   * generated from messaging_experiments.reach_fxms_message_10
   */
    struct ReachFxmsMessage10Extra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_message_10.
   */
  constexpr impl::EventMetric<ReachFxmsMessage10Extra> reach_fxms_message_10(4103);

  /**
   * generated from messaging_experiments.reach_fxms_message_11
   */
    struct ReachFxmsMessage11Extra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_message_11.
   */
  constexpr impl::EventMetric<ReachFxmsMessage11Extra> reach_fxms_message_11(4104);

  /**
   * generated from messaging_experiments.reach_fxms_message_2
   */
    struct ReachFxmsMessage2Extra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_message_2.
   */
  constexpr impl::EventMetric<ReachFxmsMessage2Extra> reach_fxms_message_2(4105);

  /**
   * generated from messaging_experiments.reach_fxms_message_3
   */
    struct ReachFxmsMessage3Extra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_message_3.
   */
  constexpr impl::EventMetric<ReachFxmsMessage3Extra> reach_fxms_message_3(4106);

  /**
   * generated from messaging_experiments.reach_fxms_message_4
   */
    struct ReachFxmsMessage4Extra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_message_4.
   */
  constexpr impl::EventMetric<ReachFxmsMessage4Extra> reach_fxms_message_4(4107);

  /**
   * generated from messaging_experiments.reach_fxms_message_5
   */
    struct ReachFxmsMessage5Extra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_message_5.
   */
  constexpr impl::EventMetric<ReachFxmsMessage5Extra> reach_fxms_message_5(4108);

  /**
   * generated from messaging_experiments.reach_fxms_message_6
   */
    struct ReachFxmsMessage6Extra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_message_6.
   */
  constexpr impl::EventMetric<ReachFxmsMessage6Extra> reach_fxms_message_6(4109);

  /**
   * generated from messaging_experiments.reach_fxms_message_7
   */
    struct ReachFxmsMessage7Extra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_message_7.
   */
  constexpr impl::EventMetric<ReachFxmsMessage7Extra> reach_fxms_message_7(4110);

  /**
   * generated from messaging_experiments.reach_fxms_message_8
   */
    struct ReachFxmsMessage8Extra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_message_8.
   */
  constexpr impl::EventMetric<ReachFxmsMessage8Extra> reach_fxms_message_8(4111);

  /**
   * generated from messaging_experiments.reach_fxms_message_9
   */
    struct ReachFxmsMessage9Extra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#fxms_message_9.
   */
  constexpr impl::EventMetric<ReachFxmsMessage9Extra> reach_fxms_message_9(4112);

  /**
   * generated from messaging_experiments.reach_infobar
   */
    struct ReachInfobarExtra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#infobar.
   */
  constexpr impl::EventMetric<ReachInfobarExtra> reach_infobar(4113);

  /**
   * generated from messaging_experiments.reach_moments_page
   */
    struct ReachMomentsPageExtra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#moments_page.
   */
  constexpr impl::EventMetric<ReachMomentsPageExtra> reach_moments_page(4114);

  /**
   * generated from messaging_experiments.reach_spotlight
   */
    struct ReachSpotlightExtra {
      mozilla::Maybe<nsCString> branches;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branches) {
          extraKeys.AppendElement()->AssignASCII("branches");
          extraValues.EmplaceBack(branches.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records whether a branch's targeting is satisfied for Messaging System
     * experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
     * for each active experiment, and the event 'value' will be the experiment ID
     * This event was generated to correspond to the Legacy Telemetry event
     * messaging_experiments.reach#spotlight.
   */
  constexpr impl::EventMetric<ReachSpotlightExtra> reach_spotlight(4115);

  /**
   * generated from messaging_experiments.targeting_attribute_error
   */
    struct TargetingAttributeErrorExtra {
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record generic JEXL errors that result from issues with experiment or message
     * targeting expressions. The value field contains the namespace and attribute
     * name that caused the error. This event was generated to correspond to the
     * Legacy Telemetry event messaging_experiments.targeting#attribute_error.
   */
  constexpr impl::EventMetric<TargetingAttributeErrorExtra> targeting_attribute_error(4116);

  /**
   * generated from messaging_experiments.targeting_attribute_timeout
   */
    struct TargetingAttributeTimeoutExtra {
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record generic JEXL errors that result from issues with experiment or message
     * targeting expressions. The value field contains the namespace and attribute
     * name that caused the error. This event was generated to correspond to the
     * Legacy Telemetry event messaging_experiments.targeting#attribute_timeout.
   */
  constexpr impl::EventMetric<TargetingAttributeTimeoutExtra> targeting_attribute_timeout(4117);

}
namespace nimbus_events {
  /**
   * generated from nimbus_events.enroll_failed
   */
    struct EnrollFailedExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when an enrollment fails, including the reason for the failure.
   */
  constexpr impl::EventMetric<EnrollFailedExtra> enroll_failed(4118);

  /**
   * generated from nimbus_events.enrollment
   */
    struct EnrollmentExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> experimentType;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (experimentType) {
          extraKeys.AppendElement()->AssignASCII("experiment_type");
          extraValues.EmplaceBack(experimentType.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user has met the conditions and is first bucketed into an
     * experiment (i.e. targeting matched and they were randomized into a bucket and
     * branch of the experiment). Expected a maximum of once per experiment per user.
   */
  constexpr impl::EventMetric<EnrollmentExtra> enrollment(4119);

  /**
   * generated from nimbus_events.enrollment_status
   */
    struct EnrollmentStatusExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> conflictSlug;
      mozilla::Maybe<nsCString> errorString;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> slug;
      mozilla::Maybe<nsCString> status;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (conflictSlug) {
          extraKeys.AppendElement()->AssignASCII("conflict_slug");
          extraValues.EmplaceBack(conflictSlug.value());
        }
        if (errorString) {
          extraKeys.AppendElement()->AssignASCII("error_string");
          extraValues.EmplaceBack(errorString.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (slug) {
          extraKeys.AppendElement()->AssignASCII("slug");
          extraValues.EmplaceBack(slug.value());
        }
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.EmplaceBack(status.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded for each enrollment status each time the SDK completes application of
     * pending experiments.
   */
  constexpr impl::EventMetric<EnrollmentStatusExtra> enrollment_status(4120);

  /**
   * generated from nimbus_events.exposure
   */
    struct ExposureExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> featureId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (featureId) {
          extraKeys.AppendElement()->AssignASCII("feature_id");
          extraValues.EmplaceBack(featureId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user actually observes an experimental treatment, or would have
     * observed an experimental treatment if they had been in a branch that would have
     * shown one.
   */
  constexpr impl::EventMetric<ExposureExtra> exposure(4121);

  /**
   * generated from nimbus_events.is_ready
   */
  /**
   * An event sent when Nimbus is ready — sent upon completion of each update of the
     * recipes.
   */
  constexpr impl::EventMetric<NoExtraKeys> is_ready(4122);

  /**
   * generated from nimbus_events.unenroll_failed
   */
    struct UnenrollFailedExtra {
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when an unenrollment fails, including the reason for the failure.
   */
  constexpr impl::EventMetric<UnenrollFailedExtra> unenroll_failed(4123);

  /**
   * generated from nimbus_events.unenrollment
   */
    struct UnenrollmentExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> changedPref;
      mozilla::Maybe<nsCString> conflictingSlug;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> prefName;
      mozilla::Maybe<nsCString> prefType;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (changedPref) {
          extraKeys.AppendElement()->AssignASCII("changed_pref");
          extraValues.EmplaceBack(changedPref.value());
        }
        if (conflictingSlug) {
          extraKeys.AppendElement()->AssignASCII("conflicting_slug");
          extraValues.EmplaceBack(conflictingSlug.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (prefName) {
          extraKeys.AppendElement()->AssignASCII("pref_name");
          extraValues.EmplaceBack(prefName.value());
        }
        if (prefType) {
          extraKeys.AppendElement()->AssignASCII("pref_type");
          extraValues.EmplaceBack(prefType.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when either telemetry is disabled, or the experiment has run for its
     * designed duration (i.e. it is no longer present in the Nimbus Remote Settings
     * collection)
   */
  constexpr impl::EventMetric<UnenrollmentExtra> unenrollment(4124);

  /**
   * generated from nimbus_events.validation_failed
   */
    struct ValidationFailedExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> feature;
      mozilla::Maybe<nsCString> l10nIds;
      mozilla::Maybe<nsCString> locale;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (feature) {
          extraKeys.AppendElement()->AssignASCII("feature");
          extraValues.EmplaceBack(feature.value());
        }
        if (l10nIds) {
          extraKeys.AppendElement()->AssignASCII("l10n_ids");
          extraValues.EmplaceBack(l10nIds.value());
        }
        if (locale) {
          extraKeys.AppendElement()->AssignASCII("locale");
          extraValues.EmplaceBack(locale.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records when validation of a recipe fails.
   */
  constexpr impl::EventMetric<ValidationFailedExtra> validation_failed(4125);

}
namespace nimbus_targeting_context {


  /**
   * generated from nimbus_targeting_context.addresses_saved
   */
  /**
   * The number of addresses the user has saved.
   */
  constexpr impl::QuantityMetric addresses_saved(4128);

  /**
   * generated from nimbus_targeting_context.arch_bits
   */
  /**
   * The architecture of the user's CPU (32-bit or 64-bit)
   */
  constexpr impl::QuantityMetric arch_bits(4129);



  /**
   * generated from nimbus_targeting_context.current_date
   */
  /**
   * The current date, as an ISO-8601 string.
   */
  constexpr impl::StringMetric current_date(4132);


  /**
   * generated from nimbus_targeting_context.distribution_id
   */
  /**
   * The installation's distribution ID.
   */
  constexpr impl::StringMetric distribution_id(4134);

  /**
   * generated from nimbus_targeting_context.does_app_need_pin
   */
  /**
   * Does the app need pinning (i.e., is the app not pinned).
   */
  constexpr impl::BooleanMetric does_app_need_pin(4135);


  /**
   * generated from nimbus_targeting_context.firefox_version
   */
  /**
   * The Firefox major version number.
   */
  constexpr impl::QuantityMetric firefox_version(4137);

  /**
   * generated from nimbus_targeting_context.has_active_enterprise_policies
   */
  /**
   * Whether the profile has any active enterprise policies.
   */
  constexpr impl::BooleanMetric has_active_enterprise_policies(4138);


  /**
   * generated from nimbus_targeting_context.is_default_browser
   */
  /**
   * Whether the current browser is the default browser.
   */
  constexpr impl::BooleanMetric is_default_browser(4140);


  /**
   * generated from nimbus_targeting_context.is_first_startup
   */
  /**
   * Is this the first startup of the browser on this install? (NB: Must have been
     * explicitly launched with the --first-startup commandline flag.)
   */
  constexpr impl::BooleanMetric is_first_startup(4142);

  /**
   * generated from nimbus_targeting_context.is_fx_a_enabled
   */
  /**
   * Whether Firefox Accounts and Sync are enabled.
   */
  constexpr impl::BooleanMetric is_fx_a_enabled(4143);

  /**
   * generated from nimbus_targeting_context.is_msix
   */
  /**
   * Is this copy of Firefox installed from an MSIX installer?
   */
  constexpr impl::BooleanMetric is_msix(4144);

  /**
   * generated from nimbus_targeting_context.memory_mb
   */
  /**
   * The amount of system memory, in mebibytes (MiB).
   */
  constexpr impl::QuantityMetric memory_mb(4145);


  /**
   * generated from nimbus_targeting_context.profile_age_created
   */
  /**
   * The UNIX timestamp of when the profile was created.
   */
  constexpr impl::QuantityMetric profile_age_created(4147);

  /**
   * generated from nimbus_targeting_context.total_bookmarks_count
   */
  /**
   * The number of bookmarks.
   */
  constexpr impl::QuantityMetric total_bookmarks_count(4148);


  /**
   * generated from nimbus_targeting_context.user_prefers_reduced_motion
   */
  /**
   * Whether the user prefers reduced motion.
   */
  constexpr impl::BooleanMetric user_prefers_reduced_motion(4150);

  /**
   * generated from nimbus_targeting_context.uses_firefox_sync
   */
  /**
   * Whether the user uses Firefox Sync.
   */
  constexpr impl::BooleanMetric uses_firefox_sync(4151);

  /**
   * generated from nimbus_targeting_context.version
   */
  /**
   * The full Firefox version string.
   */
  constexpr impl::StringMetric version(4152);

}
namespace nimbus_targeting_environment {
  /**
   * generated from nimbus_targeting_environment.attr_eval_errors
   */
  enum class AttrEvalErrorsLabel: uint16_t {
      eActiveexperiments = 0,
      eActiverollouts = 1,
      eAddressessaved = 2,
      eArchbits = 3,
      eAttributiondata = 4,
      eBrowsersettings = 5,
      eCurrentdate = 6,
      eDefaultpdfhandler = 7,
      eDistributionid = 8,
      eDoesappneedpin = 9,
      eEnrollmentsmap = 10,
      eFirefoxversion = 11,
      eHasactiveenterprisepolicies = 12,
      eHomepagesettings = 13,
      eIsdefaultbrowser = 14,
      eIsdefaulthandler = 15,
      eIsfirststartup = 16,
      eIsfxaenabled = 17,
      eIsmsix = 18,
      eMemorymb = 19,
      eOs = 20,
      eProfileagecreated = 21,
      eTotalbookmarkscount = 22,
      eUsermonthlyactivity = 23,
      eUserprefersreducedmotion = 24,
      eUsesfirefoxsync = 25,
      eVersion = 26,
      e__Other__,
    };
  /**
   * When a metric in `nimbus_targeting_context` cannot be recorded because an
     * exception was thrown during evaluation of the targeting context attribute the
     * name of the attribute is recorded in this metric.
   */
  constexpr impl::Labeled<impl::CounterMetric, AttrEvalErrorsLabel> attr_eval_errors(4153);

  /**
   * generated from nimbus_targeting_environment.pref_type_errors
   */
  enum class PrefTypeErrorsLabel: uint16_t {
      eBrowserNewtabpageActivityStreamAsrouterUserprefsCfrAddons = 0,
      eBrowserNewtabpageActivityStreamAsrouterUserprefsCfrFeatures = 1,
      eBrowserNewtabpageActivityStreamFeedsSectionHighlights = 2,
      eBrowserNewtabpageActivityStreamFeedsSectionTopstories = 3,
      eBrowserNewtabpageActivityStreamFeedsTopsites = 4,
      eBrowserNewtabpageActivityStreamShowsearch = 5,
      eBrowserNewtabpageActivityStreamShowsponsoredtopsites = 6,
      eBrowserNewtabpageEnabled = 7,
      eBrowserShoppingExperience2023Autoactivatecount = 8,
      eBrowserShoppingExperience2023Optedin = 9,
      eBrowserToolbarsBookmarksVisibility = 10,
      eBrowserUrlbarQuicksuggestDatacollectionEnabled = 11,
      eBrowserUrlbarShowsearchsuggestionsfirst = 12,
      eBrowserUrlbarSuggestQuicksuggestSponsored = 13,
      eMediaVideocontrolsPictureInPictureEnabled = 14,
      eMediaVideocontrolsPictureInPictureVideoToggleEnabled = 15,
      eMediaVideocontrolsPictureInPictureVideoToggleHasUsed = 16,
      eMessagingSystemActionTestday = 17,
      eNetworkTrrMode = 18,
      eNimbusQaPref1 = 19,
      eNimbusQaPref2 = 20,
      eSecuritySandboxContentLevel = 21,
      eTrailheadFirstrunDidseeaboutwelcome = 22,
      e__Other__,
    };
  /**
   * When a pref in `nimbus_targeting_environment.pref_values` cannot be recorded
     * because the type in the metric does not match the type of the pref, it is
     * recorded in this metric.
   */
  constexpr impl::Labeled<impl::CounterMetric, PrefTypeErrorsLabel> pref_type_errors(4154);


  /**
   * generated from nimbus_targeting_environment.targeting_context_value
   */
  /**
   * The entirety of the Nimbus targeting context as a stringified JSON object.
     * This is disabled by default and only intended to be enabled via server knobs to
     * debug recording failures in individual nimbus_targeting_context metric values.
   */
  constexpr impl::TextMetric targeting_context_value(4156);


}
namespace normandy {
  /**
   * generated from normandy.expose_nimbus_experiment
   */
    struct ExposeNimbusExperimentExtra {
      mozilla::Maybe<nsCString> branchslug;
      mozilla::Maybe<nsCString> featureid;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branchslug) {
          extraKeys.AppendElement()->AssignASCII("branchSlug");
          extraValues.EmplaceBack(branchslug.value());
        }
        if (featureid) {
          extraKeys.AppendElement()->AssignASCII("featureId");
          extraValues.EmplaceBack(featureid.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records an event at the moment the user is exposed to an experiment
     * treatment. The event is triggered either by the code checking that a certain
     * experiment feature is enabled or when that feature value is used. This is
     * different from enrollment or experiment activation because it registers when a
     * user actually gets exposed to the experiment feature. This event was generated
     * to correspond to the Legacy Telemetry event normandy.expose#nimbus_experiment.
   */
  constexpr impl::EventMetric<ExposeNimbusExperimentExtra> expose_nimbus_experiment(4158);

  /**
   * generated from normandy.enroll_addon_rollout
   */
    struct EnrollAddonRolloutExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experimenttype;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experimenttype) {
          extraKeys.AppendElement()->AssignASCII("experimentType");
          extraValues.EmplaceBack(experimenttype.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a Normandy recipe of the above types has succeeded. This
     * event was generated to correspond to the Legacy Telemetry event
     * normandy.enroll#addon_rollout.
   */
  constexpr impl::EventMetric<EnrollAddonRolloutExtra> enroll_addon_rollout(4159);

  /**
   * generated from normandy.enroll_addon_study
   */
    struct EnrollAddonStudyExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experimenttype;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experimenttype) {
          extraKeys.AppendElement()->AssignASCII("experimentType");
          extraValues.EmplaceBack(experimenttype.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a Normandy recipe of the above types has succeeded. This
     * event was generated to correspond to the Legacy Telemetry event
     * normandy.enroll#addon_study.
   */
  constexpr impl::EventMetric<EnrollAddonStudyExtra> enroll_addon_study(4160);

  /**
   * generated from normandy.enroll_failed_addon_rollout
   */
    struct EnrollFailedAddonRolloutExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> conflictingslug;
      mozilla::Maybe<nsCString> detail;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> prefbranch;
      mozilla::Maybe<nsCString> preference;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (conflictingslug) {
          extraKeys.AppendElement()->AssignASCII("conflictingSlug");
          extraValues.EmplaceBack(conflictingslug.value());
        }
        if (detail) {
          extraKeys.AppendElement()->AssignASCII("detail");
          extraValues.EmplaceBack(detail.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (prefbranch) {
          extraKeys.AppendElement()->AssignASCII("prefBranch");
          extraValues.EmplaceBack(prefbranch.value());
        }
        if (preference) {
          extraKeys.AppendElement()->AssignASCII("preference");
          extraValues.EmplaceBack(preference.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a Normandy recipe of the above types has failed. This event
     * was generated to correspond to the Legacy Telemetry event
     * normandy.enrollFailed#addon_rollout.
   */
  constexpr impl::EventMetric<EnrollFailedAddonRolloutExtra> enroll_failed_addon_rollout(4161);

  /**
   * generated from normandy.enroll_failed_addon_study
   */
    struct EnrollFailedAddonStudyExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> conflictingslug;
      mozilla::Maybe<nsCString> detail;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> prefbranch;
      mozilla::Maybe<nsCString> preference;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (conflictingslug) {
          extraKeys.AppendElement()->AssignASCII("conflictingSlug");
          extraValues.EmplaceBack(conflictingslug.value());
        }
        if (detail) {
          extraKeys.AppendElement()->AssignASCII("detail");
          extraValues.EmplaceBack(detail.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (prefbranch) {
          extraKeys.AppendElement()->AssignASCII("prefBranch");
          extraValues.EmplaceBack(prefbranch.value());
        }
        if (preference) {
          extraKeys.AppendElement()->AssignASCII("preference");
          extraValues.EmplaceBack(preference.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a Normandy recipe of the above types has failed. This event
     * was generated to correspond to the Legacy Telemetry event
     * normandy.enrollFailed#addon_study.
   */
  constexpr impl::EventMetric<EnrollFailedAddonStudyExtra> enroll_failed_addon_study(4162);

  /**
   * generated from normandy.enroll_failed_nimbus_experiment
   */
    struct EnrollFailedNimbusExperimentExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> conflictingslug;
      mozilla::Maybe<nsCString> detail;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> prefbranch;
      mozilla::Maybe<nsCString> preference;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (conflictingslug) {
          extraKeys.AppendElement()->AssignASCII("conflictingSlug");
          extraValues.EmplaceBack(conflictingslug.value());
        }
        if (detail) {
          extraKeys.AppendElement()->AssignASCII("detail");
          extraValues.EmplaceBack(detail.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (prefbranch) {
          extraKeys.AppendElement()->AssignASCII("prefBranch");
          extraValues.EmplaceBack(prefbranch.value());
        }
        if (preference) {
          extraKeys.AppendElement()->AssignASCII("preference");
          extraValues.EmplaceBack(preference.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a Normandy recipe of the above types has failed. This event
     * was generated to correspond to the Legacy Telemetry event
     * normandy.enrollFailed#nimbus_experiment.
   */
  constexpr impl::EventMetric<EnrollFailedNimbusExperimentExtra> enroll_failed_nimbus_experiment(4163);

  /**
   * generated from normandy.enroll_failed_preference_rollout
   */
    struct EnrollFailedPreferenceRolloutExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> conflictingslug;
      mozilla::Maybe<nsCString> detail;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> prefbranch;
      mozilla::Maybe<nsCString> preference;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (conflictingslug) {
          extraKeys.AppendElement()->AssignASCII("conflictingSlug");
          extraValues.EmplaceBack(conflictingslug.value());
        }
        if (detail) {
          extraKeys.AppendElement()->AssignASCII("detail");
          extraValues.EmplaceBack(detail.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (prefbranch) {
          extraKeys.AppendElement()->AssignASCII("prefBranch");
          extraValues.EmplaceBack(prefbranch.value());
        }
        if (preference) {
          extraKeys.AppendElement()->AssignASCII("preference");
          extraValues.EmplaceBack(preference.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a Normandy recipe of the above types has failed. This event
     * was generated to correspond to the Legacy Telemetry event
     * normandy.enrollFailed#preference_rollout.
   */
  constexpr impl::EventMetric<EnrollFailedPreferenceRolloutExtra> enroll_failed_preference_rollout(4164);

  /**
   * generated from normandy.enroll_failed_preference_study
   */
    struct EnrollFailedPreferenceStudyExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> conflictingslug;
      mozilla::Maybe<nsCString> detail;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> prefbranch;
      mozilla::Maybe<nsCString> preference;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (conflictingslug) {
          extraKeys.AppendElement()->AssignASCII("conflictingSlug");
          extraValues.EmplaceBack(conflictingslug.value());
        }
        if (detail) {
          extraKeys.AppendElement()->AssignASCII("detail");
          extraValues.EmplaceBack(detail.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (prefbranch) {
          extraKeys.AppendElement()->AssignASCII("prefBranch");
          extraValues.EmplaceBack(prefbranch.value());
        }
        if (preference) {
          extraKeys.AppendElement()->AssignASCII("preference");
          extraValues.EmplaceBack(preference.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a Normandy recipe of the above types has failed. This event
     * was generated to correspond to the Legacy Telemetry event
     * normandy.enrollFailed#preference_study.
   */
  constexpr impl::EventMetric<EnrollFailedPreferenceStudyExtra> enroll_failed_preference_study(4165);

  /**
   * generated from normandy.enroll_nimbus_experiment
   */
    struct EnrollNimbusExperimentExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experimenttype;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experimenttype) {
          extraKeys.AppendElement()->AssignASCII("experimentType");
          extraValues.EmplaceBack(experimenttype.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a Normandy recipe of the above types has succeeded. This
     * event was generated to correspond to the Legacy Telemetry event
     * normandy.enroll#nimbus_experiment.
   */
  constexpr impl::EventMetric<EnrollNimbusExperimentExtra> enroll_nimbus_experiment(4166);

  /**
   * generated from normandy.enroll_preference_rollout
   */
    struct EnrollPreferenceRolloutExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experimenttype;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experimenttype) {
          extraKeys.AppendElement()->AssignASCII("experimentType");
          extraValues.EmplaceBack(experimenttype.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a Normandy recipe of the above types has succeeded. This
     * event was generated to correspond to the Legacy Telemetry event
     * normandy.enroll#preference_rollout.
   */
  constexpr impl::EventMetric<EnrollPreferenceRolloutExtra> enroll_preference_rollout(4167);

  /**
   * generated from normandy.enroll_preference_study
   */
    struct EnrollPreferenceStudyExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experimenttype;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experimenttype) {
          extraKeys.AppendElement()->AssignASCII("experimentType");
          extraValues.EmplaceBack(experimenttype.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a Normandy recipe of the above types has succeeded. This
     * event was generated to correspond to the Legacy Telemetry event
     * normandy.enroll#preference_study.
   */
  constexpr impl::EventMetric<EnrollPreferenceStudyExtra> enroll_preference_study(4168);

  /**
   * generated from normandy.exp_pref_changed_preference_study
   */
    struct ExpPrefChangedPreferenceStudyExtra {
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> preferencename;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (preferencename) {
          extraKeys.AppendElement()->AssignASCII("preferenceName");
          extraValues.EmplaceBack(preferencename.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records that a preference that was set by an experiment has been changed
     * away from its experimental value. This can be triggered by a user changing a
     * preference at runtime, by the preference being changed on disk when Firefox is
     * not running, or by the preference already having a user-set value when a user
     * has enrolls in a default branch experiment. This event was generated to
     * correspond to the Legacy Telemetry event
     * normandy.expPrefChanged#preference_study.
   */
  constexpr impl::EventMetric<ExpPrefChangedPreferenceStudyExtra> exp_pref_changed_preference_study(4169);

  /**
   * generated from normandy.graduate_preference_rollout
   */
    struct GraduatePreferenceRolloutExtra {
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when a preference rollout ends due to the rolled-out preference becoming a
     * new default. This event was generated to correspond to the Legacy Telemetry
     * event normandy.graduate#preference_rollout.
   */
  constexpr impl::EventMetric<GraduatePreferenceRolloutExtra> graduate_preference_rollout(4170);

  /**
   * generated from normandy.recipe_freshness
   */
  /**
   * For each recipe ID seen by the Normandy client, its last_modified. This metric
     * was generated to correspond to the Legacy Telemetry scalar
     * normandy.recipe_freshness.
   */
  constexpr impl::Labeled<impl::QuantityMetric, DynamicLabel> recipe_freshness(4171);

  /**
   * generated from normandy.unenroll_addon_rollback
   */
    struct UnenrollAddonRollbackExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> changedpref;
      mozilla::Maybe<nsCString> conflictingslug;
      mozilla::Maybe<nsCString> didresetvalue;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> prefname;
      mozilla::Maybe<nsCString> preftype;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (changedpref) {
          extraKeys.AppendElement()->AssignASCII("changedPref");
          extraValues.EmplaceBack(changedpref.value());
        }
        if (conflictingslug) {
          extraKeys.AppendElement()->AssignASCII("conflictingSlug");
          extraValues.EmplaceBack(conflictingslug.value());
        }
        if (didresetvalue) {
          extraKeys.AppendElement()->AssignASCII("didResetValue");
          extraValues.EmplaceBack(didresetvalue.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (prefname) {
          extraKeys.AppendElement()->AssignASCII("prefName");
          extraValues.EmplaceBack(prefname.value());
        }
        if (preftype) {
          extraKeys.AppendElement()->AssignASCII("prefType");
          extraValues.EmplaceBack(preftype.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when a Normandy recipe of certain types "ends".  N.B. For
     * preference_rollback, this is fired when the recipe is fired (the recipe that
     * "ends" is a corresponding preference_rollout). This event was generated to
     * correspond to the Legacy Telemetry event normandy.unenroll#addon_rollback.
   */
  constexpr impl::EventMetric<UnenrollAddonRollbackExtra> unenroll_addon_rollback(4172);

  /**
   * generated from normandy.unenroll_addon_study
   */
    struct UnenrollAddonStudyExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> changedpref;
      mozilla::Maybe<nsCString> conflictingslug;
      mozilla::Maybe<nsCString> didresetvalue;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> prefname;
      mozilla::Maybe<nsCString> preftype;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (changedpref) {
          extraKeys.AppendElement()->AssignASCII("changedPref");
          extraValues.EmplaceBack(changedpref.value());
        }
        if (conflictingslug) {
          extraKeys.AppendElement()->AssignASCII("conflictingSlug");
          extraValues.EmplaceBack(conflictingslug.value());
        }
        if (didresetvalue) {
          extraKeys.AppendElement()->AssignASCII("didResetValue");
          extraValues.EmplaceBack(didresetvalue.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (prefname) {
          extraKeys.AppendElement()->AssignASCII("prefName");
          extraValues.EmplaceBack(prefname.value());
        }
        if (preftype) {
          extraKeys.AppendElement()->AssignASCII("prefType");
          extraValues.EmplaceBack(preftype.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when a Normandy recipe of certain types "ends".  N.B. For
     * preference_rollback, this is fired when the recipe is fired (the recipe that
     * "ends" is a corresponding preference_rollout). This event was generated to
     * correspond to the Legacy Telemetry event normandy.unenroll#addon_study.
   */
  constexpr impl::EventMetric<UnenrollAddonStudyExtra> unenroll_addon_study(4173);

  /**
   * generated from normandy.unenroll_failed_addon_rollback
   */
    struct UnenrollFailedAddonRollbackExtra {
      mozilla::Maybe<nsCString> caller;
      mozilla::Maybe<nsCString> changedpref;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> originalreason;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (caller) {
          extraKeys.AppendElement()->AssignASCII("caller");
          extraValues.EmplaceBack(caller.value());
        }
        if (changedpref) {
          extraKeys.AppendElement()->AssignASCII("changedPref");
          extraValues.EmplaceBack(changedpref.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (originalreason) {
          extraKeys.AppendElement()->AssignASCII("originalReason");
          extraValues.EmplaceBack(originalreason.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when unenrolling a user fails (see the unenroll event). This event was
     * generated to correspond to the Legacy Telemetry event
     * normandy.unenrollFailed#addon_rollback.
   */
  constexpr impl::EventMetric<UnenrollFailedAddonRollbackExtra> unenroll_failed_addon_rollback(4174);

  /**
   * generated from normandy.unenroll_failed_nimbus_experiment
   */
    struct UnenrollFailedNimbusExperimentExtra {
      mozilla::Maybe<nsCString> caller;
      mozilla::Maybe<nsCString> changedpref;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> originalreason;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (caller) {
          extraKeys.AppendElement()->AssignASCII("caller");
          extraValues.EmplaceBack(caller.value());
        }
        if (changedpref) {
          extraKeys.AppendElement()->AssignASCII("changedPref");
          extraValues.EmplaceBack(changedpref.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (originalreason) {
          extraKeys.AppendElement()->AssignASCII("originalReason");
          extraValues.EmplaceBack(originalreason.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when unenrolling a user fails (see the unenroll event). This event was
     * generated to correspond to the Legacy Telemetry event
     * normandy.unenrollFailed#nimbus_experiment.
   */
  constexpr impl::EventMetric<UnenrollFailedNimbusExperimentExtra> unenroll_failed_nimbus_experiment(4175);

  /**
   * generated from normandy.unenroll_failed_preference_rollback
   */
    struct UnenrollFailedPreferenceRollbackExtra {
      mozilla::Maybe<nsCString> caller;
      mozilla::Maybe<nsCString> changedpref;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> originalreason;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (caller) {
          extraKeys.AppendElement()->AssignASCII("caller");
          extraValues.EmplaceBack(caller.value());
        }
        if (changedpref) {
          extraKeys.AppendElement()->AssignASCII("changedPref");
          extraValues.EmplaceBack(changedpref.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (originalreason) {
          extraKeys.AppendElement()->AssignASCII("originalReason");
          extraValues.EmplaceBack(originalreason.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when unenrolling a user fails (see the unenroll event). This event was
     * generated to correspond to the Legacy Telemetry event
     * normandy.unenrollFailed#preference_rollback.
   */
  constexpr impl::EventMetric<UnenrollFailedPreferenceRollbackExtra> unenroll_failed_preference_rollback(4176);

  /**
   * generated from normandy.unenroll_failed_preference_study
   */
    struct UnenrollFailedPreferenceStudyExtra {
      mozilla::Maybe<nsCString> caller;
      mozilla::Maybe<nsCString> changedpref;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> originalreason;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (caller) {
          extraKeys.AppendElement()->AssignASCII("caller");
          extraValues.EmplaceBack(caller.value());
        }
        if (changedpref) {
          extraKeys.AppendElement()->AssignASCII("changedPref");
          extraValues.EmplaceBack(changedpref.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (originalreason) {
          extraKeys.AppendElement()->AssignASCII("originalReason");
          extraValues.EmplaceBack(originalreason.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when unenrolling a user fails (see the unenroll event). This event was
     * generated to correspond to the Legacy Telemetry event
     * normandy.unenrollFailed#preference_study.
   */
  constexpr impl::EventMetric<UnenrollFailedPreferenceStudyExtra> unenroll_failed_preference_study(4177);

  /**
   * generated from normandy.unenroll_nimbus_experiment
   */
    struct UnenrollNimbusExperimentExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> changedpref;
      mozilla::Maybe<nsCString> conflictingslug;
      mozilla::Maybe<nsCString> didresetvalue;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> prefname;
      mozilla::Maybe<nsCString> preftype;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (changedpref) {
          extraKeys.AppendElement()->AssignASCII("changedPref");
          extraValues.EmplaceBack(changedpref.value());
        }
        if (conflictingslug) {
          extraKeys.AppendElement()->AssignASCII("conflictingSlug");
          extraValues.EmplaceBack(conflictingslug.value());
        }
        if (didresetvalue) {
          extraKeys.AppendElement()->AssignASCII("didResetValue");
          extraValues.EmplaceBack(didresetvalue.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (prefname) {
          extraKeys.AppendElement()->AssignASCII("prefName");
          extraValues.EmplaceBack(prefname.value());
        }
        if (preftype) {
          extraKeys.AppendElement()->AssignASCII("prefType");
          extraValues.EmplaceBack(preftype.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when a Normandy recipe of certain types "ends".  N.B. For
     * preference_rollback, this is fired when the recipe is fired (the recipe that
     * "ends" is a corresponding preference_rollout). This event was generated to
     * correspond to the Legacy Telemetry event normandy.unenroll#nimbus_experiment.
   */
  constexpr impl::EventMetric<UnenrollNimbusExperimentExtra> unenroll_nimbus_experiment(4178);

  /**
   * generated from normandy.unenroll_preference_rollback
   */
    struct UnenrollPreferenceRollbackExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> changedpref;
      mozilla::Maybe<nsCString> conflictingslug;
      mozilla::Maybe<nsCString> didresetvalue;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> prefname;
      mozilla::Maybe<nsCString> preftype;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (changedpref) {
          extraKeys.AppendElement()->AssignASCII("changedPref");
          extraValues.EmplaceBack(changedpref.value());
        }
        if (conflictingslug) {
          extraKeys.AppendElement()->AssignASCII("conflictingSlug");
          extraValues.EmplaceBack(conflictingslug.value());
        }
        if (didresetvalue) {
          extraKeys.AppendElement()->AssignASCII("didResetValue");
          extraValues.EmplaceBack(didresetvalue.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (prefname) {
          extraKeys.AppendElement()->AssignASCII("prefName");
          extraValues.EmplaceBack(prefname.value());
        }
        if (preftype) {
          extraKeys.AppendElement()->AssignASCII("prefType");
          extraValues.EmplaceBack(preftype.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when a Normandy recipe of certain types "ends".  N.B. For
     * preference_rollback, this is fired when the recipe is fired (the recipe that
     * "ends" is a corresponding preference_rollout). This event was generated to
     * correspond to the Legacy Telemetry event normandy.unenroll#preference_rollback.
   */
  constexpr impl::EventMetric<UnenrollPreferenceRollbackExtra> unenroll_preference_rollback(4179);

  /**
   * generated from normandy.unenroll_preference_study
   */
    struct UnenrollPreferenceStudyExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> changedpref;
      mozilla::Maybe<nsCString> conflictingslug;
      mozilla::Maybe<nsCString> didresetvalue;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> prefname;
      mozilla::Maybe<nsCString> preftype;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (changedpref) {
          extraKeys.AppendElement()->AssignASCII("changedPref");
          extraValues.EmplaceBack(changedpref.value());
        }
        if (conflictingslug) {
          extraKeys.AppendElement()->AssignASCII("conflictingSlug");
          extraValues.EmplaceBack(conflictingslug.value());
        }
        if (didresetvalue) {
          extraKeys.AppendElement()->AssignASCII("didResetValue");
          extraValues.EmplaceBack(didresetvalue.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (prefname) {
          extraKeys.AppendElement()->AssignASCII("prefName");
          extraValues.EmplaceBack(prefname.value());
        }
        if (preftype) {
          extraKeys.AppendElement()->AssignASCII("prefType");
          extraValues.EmplaceBack(preftype.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when a Normandy recipe of certain types "ends".  N.B. For
     * preference_rollback, this is fired when the recipe is fired (the recipe that
     * "ends" is a corresponding preference_rollout). This event was generated to
     * correspond to the Legacy Telemetry event normandy.unenroll#preference_study.
   */
  constexpr impl::EventMetric<UnenrollPreferenceStudyExtra> unenroll_preference_study(4180);

  /**
   * generated from normandy.update_addon_rollout
   */
    struct UpdateAddonRolloutExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> previousstate;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (previousstate) {
          extraKeys.AppendElement()->AssignASCII("previousState");
          extraValues.EmplaceBack(previousstate.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This event is fired when a client detects that a recipe of the ahove types has
     * changed on the server, and the new version of the recipe is being applied over
     * an existing, older version previously fetched from the server. This event was
     * generated to correspond to the Legacy Telemetry event
     * normandy.update#addon_rollout.
   */
  constexpr impl::EventMetric<UpdateAddonRolloutExtra> update_addon_rollout(4181);

  /**
   * generated from normandy.update_addon_study
   */
    struct UpdateAddonStudyExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> previousstate;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (previousstate) {
          extraKeys.AppendElement()->AssignASCII("previousState");
          extraValues.EmplaceBack(previousstate.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This event is fired when a client detects that a recipe of the ahove types has
     * changed on the server, and the new version of the recipe is being applied over
     * an existing, older version previously fetched from the server. This event was
     * generated to correspond to the Legacy Telemetry event
     * normandy.update#addon_study.
   */
  constexpr impl::EventMetric<UpdateAddonStudyExtra> update_addon_study(4182);

  /**
   * generated from normandy.update_failed_addon_rollout
   */
    struct UpdateFailedAddonRolloutExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> detail;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (detail) {
          extraKeys.AppendElement()->AssignASCII("detail");
          extraValues.EmplaceBack(detail.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a new version of a Normandy recipe of the above types (over
     * an existing, older version previously fetched from the server) has failed. This
     * event was generated to correspond to the Legacy Telemetry event
     * normandy.updateFailed#addon_rollout.
   */
  constexpr impl::EventMetric<UpdateFailedAddonRolloutExtra> update_failed_addon_rollout(4183);

  /**
   * generated from normandy.update_failed_addon_study
   */
    struct UpdateFailedAddonStudyExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> detail;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (detail) {
          extraKeys.AppendElement()->AssignASCII("detail");
          extraValues.EmplaceBack(detail.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when applying a new version of a Normandy recipe of the above types (over
     * an existing, older version previously fetched from the server) has failed. This
     * event was generated to correspond to the Legacy Telemetry event
     * normandy.updateFailed#addon_study.
   */
  constexpr impl::EventMetric<UpdateFailedAddonStudyExtra> update_failed_addon_study(4184);

  /**
   * generated from normandy.update_nimbus_experiment
   */
    struct UpdateNimbusExperimentExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> previousstate;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (previousstate) {
          extraKeys.AppendElement()->AssignASCII("previousState");
          extraValues.EmplaceBack(previousstate.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This event is fired when a client detects that a recipe of the ahove types has
     * changed on the server, and the new version of the recipe is being applied over
     * an existing, older version previously fetched from the server. This event was
     * generated to correspond to the Legacy Telemetry event
     * normandy.update#nimbus_experiment.
   */
  constexpr impl::EventMetric<UpdateNimbusExperimentExtra> update_nimbus_experiment(4185);

  /**
   * generated from normandy.update_preference_rollout
   */
    struct UpdatePreferenceRolloutExtra {
      mozilla::Maybe<nsCString> addonid;
      mozilla::Maybe<nsCString> addonversion;
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> enrollmentid;
      mozilla::Maybe<nsCString> previousstate;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonid) {
          extraKeys.AppendElement()->AssignASCII("addonId");
          extraValues.EmplaceBack(addonid.value());
        }
        if (addonversion) {
          extraKeys.AppendElement()->AssignASCII("addonVersion");
          extraValues.EmplaceBack(addonversion.value());
        }
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (enrollmentid) {
          extraKeys.AppendElement()->AssignASCII("enrollmentId");
          extraValues.EmplaceBack(enrollmentid.value());
        }
        if (previousstate) {
          extraKeys.AppendElement()->AssignASCII("previousState");
          extraValues.EmplaceBack(previousstate.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This event is fired when a client detects that a recipe of the ahove types has
     * changed on the server, and the new version of the recipe is being applied over
     * an existing, older version previously fetched from the server. This event was
     * generated to correspond to the Legacy Telemetry event
     * normandy.update#preference_rollout.
   */
  constexpr impl::EventMetric<UpdatePreferenceRolloutExtra> update_preference_rollout(4186);

  /**
   * generated from normandy.validation_failed_nimbus_experiment
   */
    struct ValidationFailedNimbusExperimentExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> feature;
      mozilla::Maybe<nsCString> l10nIds;
      mozilla::Maybe<nsCString> locale;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (feature) {
          extraKeys.AppendElement()->AssignASCII("feature");
          extraValues.EmplaceBack(feature.value());
        }
        if (l10nIds) {
          extraKeys.AppendElement()->AssignASCII("l10n_ids");
          extraValues.EmplaceBack(l10nIds.value());
        }
        if (locale) {
          extraKeys.AppendElement()->AssignASCII("locale");
          extraValues.EmplaceBack(locale.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records when validation of a recipe fails. This event was generated to
     * correspond to the Legacy Telemetry event
     * normandy.validationFailed#nimbus_experiment.
   */
  constexpr impl::EventMetric<ValidationFailedNimbusExperimentExtra> validation_failed_nimbus_experiment(4187);

}
namespace form_autocomplete {
  /**
   * generated from form_autocomplete.show_logins
   */
    struct ShowLoginsExtra {
      mozilla::Maybe<nsCString> acfieldname;
      mozilla::Maybe<nsCString> fieldtype;
      mozilla::Maybe<nsCString> generatedpasswo;
      mozilla::Maybe<nsCString> hadprevious;
      mozilla::Maybe<nsCString> importablelogin;
      mozilla::Maybe<nsCString> insecurewarning;
      mozilla::Maybe<nsCString> login;
      mozilla::Maybe<nsCString> loginsfooter;
      mozilla::Maybe<nsCString> stringlength;
      mozilla::Maybe<nsCString> typewaspassword;
      mozilla::Maybe<uint32_t> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (acfieldname) {
          extraKeys.AppendElement()->AssignASCII("acFieldName");
          extraValues.EmplaceBack(acfieldname.value());
        }
        if (fieldtype) {
          extraKeys.AppendElement()->AssignASCII("fieldType");
          extraValues.EmplaceBack(fieldtype.value());
        }
        if (generatedpasswo) {
          extraKeys.AppendElement()->AssignASCII("generatedPasswo");
          extraValues.EmplaceBack(generatedpasswo.value());
        }
        if (hadprevious) {
          extraKeys.AppendElement()->AssignASCII("hadPrevious");
          extraValues.EmplaceBack(hadprevious.value());
        }
        if (importablelogin) {
          extraKeys.AppendElement()->AssignASCII("importableLogin");
          extraValues.EmplaceBack(importablelogin.value());
        }
        if (insecurewarning) {
          extraKeys.AppendElement()->AssignASCII("insecureWarning");
          extraValues.EmplaceBack(insecurewarning.value());
        }
        if (login) {
          extraKeys.AppendElement()->AssignASCII("login");
          extraValues.EmplaceBack(login.value());
        }
        if (loginsfooter) {
          extraKeys.AppendElement()->AssignASCII("loginsFooter");
          extraValues.EmplaceBack(loginsfooter.value());
        }
        if (stringlength) {
          extraKeys.AppendElement()->AssignASCII("stringLength");
          extraValues.EmplaceBack(stringlength.value());
        }
        if (typewaspassword) {
          extraKeys.AppendElement()->AssignASCII("typeWasPassword");
          extraValues.EmplaceBack(typewaspassword.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(nsPrintfCString("%d", value.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * An content form autocomplete popup was shown. Details on the timing and context
     * are provided. This event was generated to correspond to the Legacy Telemetry
     * event form_autocomplete.show#logins.
   */
  constexpr impl::EventMetric<ShowLoginsExtra> show_logins(4188);

}
namespace pwmgr {
  /**
   * generated from pwmgr.autocomplete_field_generatedpassword
   */
  /**
   * "autocomplete_field": The first time each unique generated password is used to
     * fill a login field - i.e. the user selects it from from the autocomplete
     * dropdown on a password input "autocomplete_shown": The first time the password
     * generation option is shown in the autocomplete dropdown on a password input for
     * a site per session This event was generated to correspond to the Legacy
     * Telemetry event pwmgr.autocomplete_field#generatedpassword.
   */
  constexpr impl::EventMetric<NoExtraKeys> autocomplete_field_generatedpassword(4189);

  /**
   * generated from pwmgr.autocomplete_shown_generatedpassword
   */
  /**
   * "autocomplete_field": The first time each unique generated password is used to
     * fill a login field - i.e. the user selects it from from the autocomplete
     * dropdown on a password input "autocomplete_shown": The first time the password
     * generation option is shown in the autocomplete dropdown on a password input for
     * a site per session This event was generated to correspond to the Legacy
     * Telemetry event pwmgr.autocomplete_shown#generatedpassword.
   */
  constexpr impl::EventMetric<NoExtraKeys> autocomplete_shown_generatedpassword(4190);

  /**
   * generated from pwmgr.cancel_existing_login
   */
    struct CancelExistingLoginExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event
     * pwmgr.cancel#existing_login.
   */
  constexpr impl::EventMetric<CancelExistingLoginExtra> cancel_existing_login(4191);

  /**
   * generated from pwmgr.cancel_new_login
   */
    struct CancelNewLoginExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event pwmgr.cancel#new_login.
   */
  constexpr impl::EventMetric<CancelNewLoginExtra> cancel_new_login(4192);

  /**
   * generated from pwmgr.copy_password
   */
    struct CopyPasswordExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event pwmgr.copy#password.
   */
  constexpr impl::EventMetric<CopyPasswordExtra> copy_password(4193);

  /**
   * generated from pwmgr.copy_username
   */
    struct CopyUsernameExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event pwmgr.copy#username.
   */
  constexpr impl::EventMetric<CopyUsernameExtra> copy_username(4194);

  /**
   * generated from pwmgr.delete_existing_login
   */
    struct DeleteExistingLoginExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event
     * pwmgr.delete#existing_login.
   */
  constexpr impl::EventMetric<DeleteExistingLoginExtra> delete_existing_login(4195);

  /**
   * generated from pwmgr.delete_new_login
   */
    struct DeleteNewLoginExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event pwmgr.delete#new_login.
   */
  constexpr impl::EventMetric<DeleteNewLoginExtra> delete_new_login(4196);

  /**
   * generated from pwmgr.doorhanger_submitted_save
   */
    struct DoorhangerSubmittedSaveExtra {
      mozilla::Maybe<bool> didEditPw;
      mozilla::Maybe<bool> didEditUn;
      mozilla::Maybe<bool> didSelectPw;
      mozilla::Maybe<bool> didSelectUn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (didEditPw) {
          extraKeys.AppendElement()->AssignASCII("did_edit_pw");
          extraValues.AppendElement()->AssignASCII(didEditPw.value() ? "true" : "false");
        }
        if (didEditUn) {
          extraKeys.AppendElement()->AssignASCII("did_edit_un");
          extraValues.AppendElement()->AssignASCII(didEditUn.value() ? "true" : "false");
        }
        if (didSelectPw) {
          extraKeys.AppendElement()->AssignASCII("did_select_pw");
          extraValues.AppendElement()->AssignASCII(didSelectPw.value() ? "true" : "false");
        }
        if (didSelectUn) {
          extraKeys.AppendElement()->AssignASCII("did_select_un");
          extraValues.AppendElement()->AssignASCII(didSelectUn.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * A login is saved or updated via the capture doorhanger. Carries information
     * about whether the username and password _that were saved/updated by the user_
     * were modified in the doorhanger, selected from the suggestion autocomplete, or
     * neither. `did_edit_X` and `did_select_X` will never both be true in the same
     * event. The `object` describes the type of doorhanger when it was originally
     * created. Note that user updates to the doorhanger may change whether a login is
     * actually saved or updated, but will not impact the sent object. This event was
     * generated to correspond to the Legacy Telemetry event
     * pwmgr.doorhanger_submitted#save.
   */
  constexpr impl::EventMetric<DoorhangerSubmittedSaveExtra> doorhanger_submitted_save(4197);

  /**
   * generated from pwmgr.doorhanger_submitted_update
   */
    struct DoorhangerSubmittedUpdateExtra {
      mozilla::Maybe<bool> didEditPw;
      mozilla::Maybe<bool> didEditUn;
      mozilla::Maybe<bool> didSelectPw;
      mozilla::Maybe<bool> didSelectUn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (didEditPw) {
          extraKeys.AppendElement()->AssignASCII("did_edit_pw");
          extraValues.AppendElement()->AssignASCII(didEditPw.value() ? "true" : "false");
        }
        if (didEditUn) {
          extraKeys.AppendElement()->AssignASCII("did_edit_un");
          extraValues.AppendElement()->AssignASCII(didEditUn.value() ? "true" : "false");
        }
        if (didSelectPw) {
          extraKeys.AppendElement()->AssignASCII("did_select_pw");
          extraValues.AppendElement()->AssignASCII(didSelectPw.value() ? "true" : "false");
        }
        if (didSelectUn) {
          extraKeys.AppendElement()->AssignASCII("did_select_un");
          extraValues.AppendElement()->AssignASCII(didSelectUn.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * A login is saved or updated via the capture doorhanger. Carries information
     * about whether the username and password _that were saved/updated by the user_
     * were modified in the doorhanger, selected from the suggestion autocomplete, or
     * neither. `did_edit_X` and `did_select_X` will never both be true in the same
     * event. The `object` describes the type of doorhanger when it was originally
     * created. Note that user updates to the doorhanger may change whether a login is
     * actually saved or updated, but will not impact the sent object. This event was
     * generated to correspond to the Legacy Telemetry event
     * pwmgr.doorhanger_submitted#update.
   */
  constexpr impl::EventMetric<DoorhangerSubmittedUpdateExtra> doorhanger_submitted_update(4198);

  /**
   * generated from pwmgr.edit_existing_login
   */
    struct EditExistingLoginExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event
     * pwmgr.edit#existing_login.
   */
  constexpr impl::EventMetric<EditExistingLoginExtra> edit_existing_login(4199);

  /**
   * generated from pwmgr.filled_field_edited_generatedpassword
   */
  /**
   * The first time each generated password filled in a website form field is edited
     * by the user in a field it was filled in This event was generated to correspond
     * to the Legacy Telemetry event pwmgr.filled_field_edited#generatedpassword.
   */
  constexpr impl::EventMetric<NoExtraKeys> filled_field_edited_generatedpassword(4200);

  /**
   * generated from pwmgr.filter_list
   */
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event pwmgr.filter#list.
   */
  constexpr impl::EventMetric<NoExtraKeys> filter_list(4201);

  /**
   * generated from pwmgr.form_autofill_result
   */
  enum class FormAutofillResultLabel: uint16_t {
      eFilled = 0,
      eNoPasswordField = 1,
      ePasswordDisabledReadonly = 2,
      eNoLoginsFit = 3,
      eNoSavedLogins = 4,
      eExistingPassword = 5,
      eExistingUsername = 6,
      eMultipleLogins = 7,
      eNoAutofillForms = 8,
      eAutocompleteOff = 9,
      eInsecure = 10,
      ePasswordAutocompleteNewPassword = 11,
      eTypeNoLongerPassword = 12,
      eFormInCrossoriginSubframe = 13,
      eFilledUsernameOnlyForm = 14,
      e__Other__,
    };
  /**
   * The result of auto-filling a login form.
   */
  constexpr impl::Labeled<impl::CounterMetric, FormAutofillResultLabel> form_autofill_result(4202);

  /**
   * generated from pwmgr.hide_password
   */
    struct HidePasswordExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event pwmgr.hide#password.
   */
  constexpr impl::EventMetric<HidePasswordExtra> hide_password(4203);

  /**
   * generated from pwmgr.learn_more_vuln_existing_login
   */
    struct LearnMoreVulnExistingLoginExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event
     * pwmgr.learn_more_vuln#existing_login.
   */
  constexpr impl::EventMetric<LearnMoreVulnExistingLoginExtra> learn_more_vuln_existing_login(4204);

  /**
   * generated from pwmgr.mgmt_menu_item_used_export
   */
  /**
   * Record interactions with the about:logins menu. This event was generated to
     * correspond to the Legacy Telemetry event pwmgr.mgmt_menu_item_used#export.
   */
  constexpr impl::EventMetric<NoExtraKeys> mgmt_menu_item_used_export(4205);

  /**
   * generated from pwmgr.mgmt_menu_item_used_export_complete
   */
  /**
   * Record interactions with the about:logins menu. This event was generated to
     * correspond to the Legacy Telemetry event
     * pwmgr.mgmt_menu_item_used#export_complete.
   */
  constexpr impl::EventMetric<NoExtraKeys> mgmt_menu_item_used_export_complete(4206);

  /**
   * generated from pwmgr.mgmt_menu_item_used_import_csv_complete
   */
  /**
   * Record interactions with the about:logins menu. This event was generated to
     * correspond to the Legacy Telemetry event
     * pwmgr.mgmt_menu_item_used#import_csv_complete.
   */
  constexpr impl::EventMetric<NoExtraKeys> mgmt_menu_item_used_import_csv_complete(4207);

  /**
   * generated from pwmgr.mgmt_menu_item_used_import_from_browser
   */
  /**
   * Record interactions with the about:logins menu. This event was generated to
     * correspond to the Legacy Telemetry event
     * pwmgr.mgmt_menu_item_used#import_from_browser.
   */
  constexpr impl::EventMetric<NoExtraKeys> mgmt_menu_item_used_import_from_browser(4208);

  /**
   * generated from pwmgr.mgmt_menu_item_used_import_from_csv
   */
  /**
   * Record interactions with the about:logins menu. This event was generated to
     * correspond to the Legacy Telemetry event
     * pwmgr.mgmt_menu_item_used#import_from_csv.
   */
  constexpr impl::EventMetric<NoExtraKeys> mgmt_menu_item_used_import_from_csv(4209);

  /**
   * generated from pwmgr.mgmt_menu_item_used_preferences
   */
  /**
   * Record interactions with the about:logins menu. This event was generated to
     * correspond to the Legacy Telemetry event pwmgr.mgmt_menu_item_used#preferences.
   */
  constexpr impl::EventMetric<NoExtraKeys> mgmt_menu_item_used_preferences(4210);

  /**
   * generated from pwmgr.new_new_login
   */
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event pwmgr.new#new_login.
   */
  constexpr impl::EventMetric<NoExtraKeys> new_new_login(4211);

  /**
   * generated from pwmgr.open_management_aboutprotections
   */
  /**
   * Sent when opening the password management UI. This event was generated to
     * correspond to the Legacy Telemetry event
     * pwmgr.open_management#aboutprotections.
   */
  constexpr impl::EventMetric<NoExtraKeys> open_management_aboutprotections(4212);

  /**
   * generated from pwmgr.open_management_autocomplete
   */
  /**
   * Sent when opening the password management UI. This event was generated to
     * correspond to the Legacy Telemetry event pwmgr.open_management#autocomplete.
   */
  constexpr impl::EventMetric<NoExtraKeys> open_management_autocomplete(4213);

  /**
   * generated from pwmgr.open_management_contextmenu
   */
  /**
   * Sent when opening the password management UI. This event was generated to
     * correspond to the Legacy Telemetry event pwmgr.open_management#contextmenu.
   */
  constexpr impl::EventMetric<NoExtraKeys> open_management_contextmenu(4214);

  /**
   * generated from pwmgr.open_management_direct
   */
  /**
   * Sent when opening the password management UI. This event was generated to
     * correspond to the Legacy Telemetry event pwmgr.open_management#direct.
   */
  constexpr impl::EventMetric<NoExtraKeys> open_management_direct(4215);

  /**
   * generated from pwmgr.open_management_mainmenu
   */
  /**
   * Sent when opening the password management UI. This event was generated to
     * correspond to the Legacy Telemetry event pwmgr.open_management#mainmenu.
   */
  constexpr impl::EventMetric<NoExtraKeys> open_management_mainmenu(4216);

  /**
   * generated from pwmgr.open_management_pageinfo
   */
  /**
   * Sent when opening the password management UI. This event was generated to
     * correspond to the Legacy Telemetry event pwmgr.open_management#pageinfo.
   */
  constexpr impl::EventMetric<NoExtraKeys> open_management_pageinfo(4217);

  /**
   * generated from pwmgr.open_management_preferences
   */
  /**
   * Sent when opening the password management UI. This event was generated to
     * correspond to the Legacy Telemetry event pwmgr.open_management#preferences.
   */
  constexpr impl::EventMetric<NoExtraKeys> open_management_preferences(4218);

  /**
   * generated from pwmgr.open_management_snippet
   */
  /**
   * Sent when opening the password management UI. This event was generated to
     * correspond to the Legacy Telemetry event pwmgr.open_management#snippet.
   */
  constexpr impl::EventMetric<NoExtraKeys> open_management_snippet(4219);

  /**
   * generated from pwmgr.open_site_existing_login
   */
    struct OpenSiteExistingLoginExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event
     * pwmgr.open_site#existing_login.
   */
  constexpr impl::EventMetric<OpenSiteExistingLoginExtra> open_site_existing_login(4220);

  /**
   * generated from pwmgr.potentially_breached_passwords
   */
  /**
   * The number of potentially breached passwords, as determined by
     * LoginBreaches.getPotentialBreachesByLoginGUID. This metric was generated to
     * correspond to the Legacy Telemetry scalar pwmgr.potentially_breached_passwords.
   */
  constexpr impl::QuantityMetric potentially_breached_passwords(4221);

  /**
   * generated from pwmgr.reauthenticate_master_password
   */
    struct ReauthenticateMasterPasswordExtra {
      mozilla::Maybe<nsCString> autoAdmin;
      mozilla::Maybe<nsCString> requireSignon;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (autoAdmin) {
          extraKeys.AppendElement()->AssignASCII("auto_admin");
          extraValues.EmplaceBack(autoAdmin.value());
        }
        if (requireSignon) {
          extraKeys.AppendElement()->AssignASCII("require_signon");
          extraValues.EmplaceBack(requireSignon.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Measure how often users are asked to authenticate with their Operating System
     * or Master Password to gain access to stored passwords. Possible values are as
     * follows,
     *   "success" should be used when the user authenticates and provides a password
     * or other authentication factor.
     *   "success_no_prompt" should be used when the feature is enabled but no prompt
     * is given to the user because they have recently authenticated.
     *   "success_disabled" is used when the feature is disabled.
     *   "success_unsupported_platform" should be set when the user attempts to
     * authenticate on an unsupported platform.
     *   "success_no_password" should be used when the user doesn't have an OS
     * password set.
     *   "fail" should be used when the user cancels the authentication prompt or an
     * unexpected exception is encountered. The user may or may not have provided an
     * incorrect password before cancelling.
     * This event was generated to correspond to the Legacy Telemetry event
     * pwmgr.reauthenticate#master_password.
   */
  constexpr impl::EventMetric<ReauthenticateMasterPasswordExtra> reauthenticate_master_password(4222);

  /**
   * generated from pwmgr.reauthenticate_os_auth
   */
    struct ReauthenticateOsAuthExtra {
      mozilla::Maybe<nsCString> autoAdmin;
      mozilla::Maybe<nsCString> requireSignon;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (autoAdmin) {
          extraKeys.AppendElement()->AssignASCII("auto_admin");
          extraValues.EmplaceBack(autoAdmin.value());
        }
        if (requireSignon) {
          extraKeys.AppendElement()->AssignASCII("require_signon");
          extraValues.EmplaceBack(requireSignon.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Measure how often users are asked to authenticate with their Operating System
     * or Master Password to gain access to stored passwords. Possible values are as
     * follows,
     *   "success" should be used when the user authenticates and provides a password
     * or other authentication factor.
     *   "success_no_prompt" should be used when the feature is enabled but no prompt
     * is given to the user because they have recently authenticated.
     *   "success_disabled" is used when the feature is disabled.
     *   "success_unsupported_platform" should be set when the user attempts to
     * authenticate on an unsupported platform.
     *   "success_no_password" should be used when the user doesn't have an OS
     * password set.
     *   "fail" should be used when the user cancels the authentication prompt or an
     * unexpected exception is encountered. The user may or may not have provided an
     * incorrect password before cancelling.
     * This event was generated to correspond to the Legacy Telemetry event
     * pwmgr.reauthenticate#os_auth.
   */
  constexpr impl::EventMetric<ReauthenticateOsAuthExtra> reauthenticate_os_auth(4223);

  /**
   * generated from pwmgr.save_existing_login
   */
    struct SaveExistingLoginExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event
     * pwmgr.save#existing_login.
   */
  constexpr impl::EventMetric<SaveExistingLoginExtra> save_existing_login(4224);

  /**
   * generated from pwmgr.save_new_login
   */
    struct SaveNewLoginExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event pwmgr.save#new_login.
   */
  constexpr impl::EventMetric<SaveNewLoginExtra> save_new_login(4225);

  /**
   * generated from pwmgr.saved_login_used_auth_login
   */
    struct SavedLoginUsedAuthLoginExtra {
      mozilla::Maybe<bool> filled;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (filled) {
          extraKeys.AppendElement()->AssignASCII("filled");
          extraValues.AppendElement()->AssignASCII(filled.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Each time a saved login is used in a form or authentication dialog. This event
     * was generated to correspond to the Legacy Telemetry event
     * pwmgr.saved_login_used#auth_login.
   */
  constexpr impl::EventMetric<SavedLoginUsedAuthLoginExtra> saved_login_used_auth_login(4226);

  /**
   * generated from pwmgr.saved_login_used_form_login
   */
    struct SavedLoginUsedFormLoginExtra {
      mozilla::Maybe<bool> filled;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (filled) {
          extraKeys.AppendElement()->AssignASCII("filled");
          extraValues.AppendElement()->AssignASCII(filled.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Each time a saved login is used in a form or authentication dialog. This event
     * was generated to correspond to the Legacy Telemetry event
     * pwmgr.saved_login_used#form_login.
   */
  constexpr impl::EventMetric<SavedLoginUsedFormLoginExtra> saved_login_used_form_login(4227);

  /**
   * generated from pwmgr.saved_login_used_form_password
   */
    struct SavedLoginUsedFormPasswordExtra {
      mozilla::Maybe<bool> filled;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (filled) {
          extraKeys.AppendElement()->AssignASCII("filled");
          extraValues.AppendElement()->AssignASCII(filled.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Each time a saved login is used in a form or authentication dialog. This event
     * was generated to correspond to the Legacy Telemetry event
     * pwmgr.saved_login_used#form_password.
   */
  constexpr impl::EventMetric<SavedLoginUsedFormPasswordExtra> saved_login_used_form_password(4228);

  /**
   * generated from pwmgr.saved_login_used_prompt_login
   */
    struct SavedLoginUsedPromptLoginExtra {
      mozilla::Maybe<bool> filled;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (filled) {
          extraKeys.AppendElement()->AssignASCII("filled");
          extraValues.AppendElement()->AssignASCII(filled.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Each time a saved login is used in a form or authentication dialog. This event
     * was generated to correspond to the Legacy Telemetry event
     * pwmgr.saved_login_used#prompt_login.
   */
  constexpr impl::EventMetric<SavedLoginUsedPromptLoginExtra> saved_login_used_prompt_login(4229);

  /**
   * generated from pwmgr.select_existing_login
   */
    struct SelectExistingLoginExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event
     * pwmgr.select#existing_login.
   */
  constexpr impl::EventMetric<SelectExistingLoginExtra> select_existing_login(4230);

  /**
   * generated from pwmgr.show_password
   */
    struct ShowPasswordExtra {
      mozilla::Maybe<bool> breached;
      mozilla::Maybe<bool> vulnerable;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (breached) {
          extraKeys.AppendElement()->AssignASCII("breached");
          extraValues.AppendElement()->AssignASCII(breached.value() ? "true" : "false");
        }
        if (vulnerable) {
          extraKeys.AppendElement()->AssignASCII("vulnerable");
          extraValues.AppendElement()->AssignASCII(vulnerable.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event pwmgr.show#password.
   */
  constexpr impl::EventMetric<ShowPasswordExtra> show_password(4231);

  /**
   * generated from pwmgr.sort_list
   */
    struct SortListExtra {
      mozilla::Maybe<nsCString> sortKey;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sortKey) {
          extraKeys.AppendElement()->AssignASCII("sort_key");
          extraValues.EmplaceBack(sortKey.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events record interactions on the about:logins page. This event was
     * generated to correspond to the Legacy Telemetry event pwmgr.sort#list.
   */
  constexpr impl::EventMetric<SortListExtra> sort_list(4232);

}
namespace relay_integration {
  /**
   * generated from relay_integration.clicked_fill_username
   */
    struct ClickedFillUsernameExtra {
      mozilla::Maybe<nsCString> errorCode;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (errorCode) {
          extraKeys.AppendElement()->AssignASCII("error_code");
          extraValues.EmplaceBack(errorCode.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Firefox relay integration autocomplete popup This event was generated to
     * correspond to the Legacy Telemetry event
     * relay_integration.clicked#fill_username.
   */
  constexpr impl::EventMetric<ClickedFillUsernameExtra> clicked_fill_username(4233);

  /**
   * generated from relay_integration.clicked_offer_relay
   */
    struct ClickedOfferRelayExtra {
      mozilla::Maybe<nsCString> scenario;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (scenario) {
          extraKeys.AppendElement()->AssignASCII("scenario");
          extraValues.EmplaceBack(scenario.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Firefox relay integration autocomplete popup This event was generated to
     * correspond to the Legacy Telemetry event relay_integration.clicked#offer_relay.
   */
  constexpr impl::EventMetric<ClickedOfferRelayExtra> clicked_offer_relay(4234);

  /**
   * generated from relay_integration.disabled_opt_in_panel
   */
    struct DisabledOptInPanelExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Panel to opt-in Firefox Relay Integration This event was generated to
     * correspond to the Legacy Telemetry event
     * relay_integration.disabled#opt_in_panel.
   */
  constexpr impl::EventMetric<DisabledOptInPanelExtra> disabled_opt_in_panel(4235);

  /**
   * generated from relay_integration.disabled_pref_change
   */
  /**
   * Checkbox in the settings page to enable/disable relay This event was generated
     * to correspond to the Legacy Telemetry event
     * relay_integration.disabled#pref_change.
   */
  constexpr impl::EventMetric<NoExtraKeys> disabled_pref_change(4236);

  /**
   * generated from relay_integration.enabled_opt_in_panel
   */
    struct EnabledOptInPanelExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Panel to opt-in Firefox Relay Integration This event was generated to
     * correspond to the Legacy Telemetry event
     * relay_integration.enabled#opt_in_panel.
   */
  constexpr impl::EventMetric<EnabledOptInPanelExtra> enabled_opt_in_panel(4237);

  /**
   * generated from relay_integration.enabled_pref_change
   */
  /**
   * Checkbox in the settings page to enable/disable relay This event was generated
     * to correspond to the Legacy Telemetry event
     * relay_integration.enabled#pref_change.
   */
  constexpr impl::EventMetric<NoExtraKeys> enabled_pref_change(4238);

  /**
   * generated from relay_integration.get_unlimited_masks_reuse_panel
   */
    struct GetUnlimitedMasksReusePanelExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Panels to show the state of the email alias generation This event was generated
     * to correspond to the Legacy Telemetry event
     * relay_integration.get_unlimited_masks#reuse_panel.
   */
  constexpr impl::EventMetric<GetUnlimitedMasksReusePanelExtra> get_unlimited_masks_reuse_panel(4239);

  /**
   * generated from relay_integration.postponed_opt_in_panel
   */
    struct PostponedOptInPanelExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Panel to opt-in Firefox Relay Integration This event was generated to
     * correspond to the Legacy Telemetry event
     * relay_integration.postponed#opt_in_panel.
   */
  constexpr impl::EventMetric<PostponedOptInPanelExtra> postponed_opt_in_panel(4240);

  /**
   * generated from relay_integration.reuse_mask_reuse_panel
   */
    struct ReuseMaskReusePanelExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Panels to show the state of the email alias generation This event was generated
     * to correspond to the Legacy Telemetry event
     * relay_integration.reuse_mask#reuse_panel.
   */
  constexpr impl::EventMetric<ReuseMaskReusePanelExtra> reuse_mask_reuse_panel(4241);

  /**
   * generated from relay_integration.shown_fill_username
   */
    struct ShownFillUsernameExtra {
      mozilla::Maybe<nsCString> errorCode;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (errorCode) {
          extraKeys.AppendElement()->AssignASCII("error_code");
          extraValues.EmplaceBack(errorCode.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Firefox relay integration autocomplete popup This event was generated to
     * correspond to the Legacy Telemetry event relay_integration.shown#fill_username.
   */
  constexpr impl::EventMetric<ShownFillUsernameExtra> shown_fill_username(4242);

  /**
   * generated from relay_integration.shown_offer_relay
   */
    struct ShownOfferRelayExtra {
      mozilla::Maybe<nsCString> scenario;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (scenario) {
          extraKeys.AppendElement()->AssignASCII("scenario");
          extraValues.EmplaceBack(scenario.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Firefox relay integration autocomplete popup This event was generated to
     * correspond to the Legacy Telemetry event relay_integration.shown#offer_relay.
   */
  constexpr impl::EventMetric<ShownOfferRelayExtra> shown_offer_relay(4243);

  /**
   * generated from relay_integration.shown_opt_in_panel
   */
    struct ShownOptInPanelExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Panel to opt-in Firefox Relay Integration This event was generated to
     * correspond to the Legacy Telemetry event relay_integration.shown#opt_in_panel.
   */
  constexpr impl::EventMetric<ShownOptInPanelExtra> shown_opt_in_panel(4244);

  /**
   * generated from relay_integration.shown_reuse_panel
   */
    struct ShownReusePanelExtra {
      mozilla::Maybe<nsCString> errorCode;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (errorCode) {
          extraKeys.AppendElement()->AssignASCII("error_code");
          extraValues.EmplaceBack(errorCode.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Panels to show the state of the email alias generation This event was generated
     * to correspond to the Legacy Telemetry event
     * relay_integration.shown#reuse_panel.
   */
  constexpr impl::EventMetric<ShownReusePanelExtra> shown_reuse_panel(4245);

}
namespace pdfjs {
  /**
   * generated from pdfjs.buttons
   */
  enum class ButtonsLabel: uint16_t {
      ePresentationMode = 0,
      ePresentationModeKeyboard = 1,
      eViewBookmark = 2,
      eFirstPage = 3,
      eLastPage = 4,
      ePageRotateCw = 5,
      ePageRotateCcw = 6,
      eCursorSelectTool = 7,
      eCursorHandTool = 8,
      eScrollPage = 9,
      eScrollVertical = 10,
      eScrollHorizontal = 11,
      eScrollWrapped = 12,
      eSpreadNone = 13,
      eSpreadOdd = 14,
      eSpreadEven = 15,
      eDocumentProperties = 16,
      e__Other__,
    };
  /**
   * Counts the number of times some actions are executed in the PDF viewer.
   */
  constexpr impl::Labeled<impl::CounterMetric, ButtonsLabel> buttons(4246);

  /**
   * generated from pdfjs.editing
   */
  enum class EditingLabel: uint16_t {
      eInk = 0,
      eFreetext = 1,
      eStamp = 2,
      eSave = 3,
      ePrint = 4,
      e__Other__,
    };
  /**
   * Counts the number of times some PDF editing features are used.
   */
  constexpr impl::Labeled<impl::CounterMetric, EditingLabel> editing(4247);

  /**
   * generated from pdfjs.geckoview
   */
  enum class GeckoviewLabel: uint16_t {
      eDownloadTapped = 0,
      eOpenInAppTapped = 1,
      eOpenInAppJustOnce = 2,
      eOpenInAppAlways = 3,
      eDownloadFailed = 4,
      eDownloadSucceeded = 5,
      eSaveAsPdfTapped = 6,
      e__Other__,
    };
  /**
   * Counts the number of times some actions are executed in the PDF viewer.
   */
  constexpr impl::Labeled<impl::CounterMetric, GeckoviewLabel> geckoview(4248);

  /**
   * generated from pdfjs.stamp
   */
  enum class StampLabel: uint16_t {
      eInsertedImage = 0,
      eAltTextSave = 1,
      eAltTextCancel = 2,
      eAltTextTooltip = 3,
      eAltTextEdit = 4,
      eAltTextDescription = 5,
      eAltTextDecorative = 6,
      eAltTextKeyboard = 7,
      e__Other__,
    };
  /**
   * Counts the number of times some PDF editing features are used.
   */
  constexpr impl::Labeled<impl::CounterMetric, StampLabel> stamp(4249);

  /**
   * generated from pdfjs.time_to_view
   */
  /**
   * Time spent to display first page in PDF Viewer (ms).
   */
  constexpr impl::CustomDistributionMetric time_to_view(4250);

  /**
   * generated from pdfjs.used
   */
  /**
   * How many times PDF Viewer was used.
   */
  constexpr impl::CounterMetric used(4251);

}
namespace pdfjs_editing_highlight {
  /**
   * generated from pdfjs.editing.highlight.color
   */
  enum class ColorLabel: uint16_t {
      eYellow = 0,
      eGreen = 1,
      eBlue = 2,
      ePink = 3,
      eRed = 4,
      e__Other__,
    };
  /**
   * Counts the number of times a given color is used to highlight.
   */
  constexpr impl::Labeled<impl::CounterMetric, ColorLabel> color(4252);

  /**
   * generated from pdfjs.editing.highlight.color_changed
   */
  /**
   * Counts the number of times the user changes the color of a highlight.
   */
  constexpr impl::CounterMetric color_changed(4253);

  /**
   * generated from pdfjs.editing.highlight.deleted
   */
  /**
   * Counts the number of times the user deletes highlights.
   */
  constexpr impl::CounterMetric deleted(4254);

  /**
   * generated from pdfjs.editing.highlight.edited
   */
  /**
   * Counts the number of times the user edits highlights.
   */
  constexpr impl::CounterMetric edited(4255);

  /**
   * generated from pdfjs.editing.highlight.kind
   */
  enum class KindLabel: uint16_t {
      eFreeHighlight = 0,
      eHighlight = 1,
      e__Other__,
    };
  /**
   * Counts the number of times a given kind is used to highlight.
   */
  constexpr impl::Labeled<impl::CounterMetric, KindLabel> kind(4256);

  /**
   * generated from pdfjs.editing.highlight.method
   */
  enum class MethodLabel: uint16_t {
      eContextMenu = 0,
      eMainToolbar = 1,
      eFloatingButton = 2,
      e__Other__,
    };
  /**
   * Counts the number of times a given method is used to highlight.
   */
  constexpr impl::Labeled<impl::CounterMetric, MethodLabel> method(4257);

  /**
   * generated from pdfjs.editing.highlight.number_of_colors
   */
  enum class NumberOfColorsLabel: uint16_t {
      eOne = 0,
      eTwo = 1,
      eThree = 2,
      eFour = 3,
      eFive = 4,
      e__Other__,
    };
  /**
   * Counts the number of different colors used to highlight.
   */
  constexpr impl::Labeled<impl::CounterMetric, NumberOfColorsLabel> number_of_colors(4258);

  /**
   * generated from pdfjs.editing.highlight.print
   */
  /**
   * Counts the number of times the user prints a PDF with highlights.
   */
  constexpr impl::CounterMetric print(4259);

  /**
   * generated from pdfjs.editing.highlight.save
   */
  /**
   * Counts the number of times the user saves a PDF with highlights.
   */
  constexpr impl::CounterMetric save(4260);

  /**
   * generated from pdfjs.editing.highlight.thickness
   */
  /**
   * The thickness used to draw a free highlight.
   */
  constexpr impl::CustomDistributionMetric thickness(4261);

  /**
   * generated from pdfjs.editing.highlight.thickness_changed
   */
  /**
   * Counts the number of times the user changes the thickness of a free highlight.
   */
  constexpr impl::CounterMetric thickness_changed(4262);

  /**
   * generated from pdfjs.editing.highlight.toggle_visibility
   */
  /**
   * Counts the number of times the user toggles the visibility of highlights.
   */
  constexpr impl::CounterMetric toggle_visibility(4263);

}
namespace pdfjs_image {
  /**
   * generated from pdfjs.image.add_image_click
   */
  /**
   * Recorded when the Add Image label is clicked.
   */
  constexpr impl::EventMetric<NoExtraKeys> add_image_click(4264);

  /**
   * generated from pdfjs.image.added
   */
  enum class AddedLabel: uint16_t {
      eWithAltText = 0,
      eWithoutAltText = 1,
      e__Other__,
    };
  /**
   * Number of images added with/without alt text.
   */
  constexpr impl::Labeled<impl::CounterMetric, AddedLabel> added(4265);

  /**
   * generated from pdfjs.image.alt_text_edit
   */
  enum class AltTextEditLabel: uint16_t {
      eAskToEdit = 0,
      eAiGeneration = 1,
      e__Other__,
    };
  /**
   * Stores alt text modal settings for the user.
   */
  constexpr impl::Labeled<impl::BooleanMetric, AltTextEditLabel> alt_text_edit(4266);

  /**
   * generated from pdfjs.image.icon_click
   */
  /**
   * Recorded when the image toolbar icon is clicked.
   */
  constexpr impl::EventMetric<NoExtraKeys> icon_click(4267);

  /**
   * generated from pdfjs.image.image_added
   */
    struct ImageAddedExtra {
      mozilla::Maybe<bool> altTextModal;
      mozilla::Maybe<nsCString> altTextType;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (altTextModal) {
          extraKeys.AppendElement()->AssignASCII("alt_text_modal");
          extraValues.AppendElement()->AssignASCII(altTextModal.value() ? "true" : "false");
        }
        if (altTextType) {
          extraKeys.AppendElement()->AssignASCII("alt_text_type");
          extraValues.EmplaceBack(altTextType.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded once the image is added to the pdf.
   */
  constexpr impl::EventMetric<ImageAddedExtra> image_added(4268);

  /**
   * generated from pdfjs.image.image_selected
   */
    struct ImageSelectedExtra {
      mozilla::Maybe<bool> altTextModal;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (altTextModal) {
          extraKeys.AppendElement()->AssignASCII("alt_text_modal");
          extraValues.AppendElement()->AssignASCII(altTextModal.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user selects an image file from their computer.
   */
  constexpr impl::EventMetric<ImageSelectedExtra> image_selected(4269);

}
namespace pdfjs_image_alt_text {
  /**
   * generated from pdfjs.image.alt_text.ai_generation_check
   */
    struct AiGenerationCheckExtra {
      mozilla::Maybe<bool> status;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.AppendElement()->AssignASCII(status.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user interacts with the alt text setting in the alt text
     * modal to create alt text with AI.
   */
  constexpr impl::EventMetric<AiGenerationCheckExtra> ai_generation_check(4270);

  /**
   * generated from pdfjs.image.alt_text.callout_dismissed
   */
  /**
   * Recorded when the callout describing automatic alt text generation is
     * dismissed.
   */
  constexpr impl::EventMetric<NoExtraKeys> callout_dismissed(4271);

  /**
   * generated from pdfjs.image.alt_text.callout_displayed
   */
  /**
   * Recorded when the callout describing automatic alt text generation is
     * displayed.
   */
  constexpr impl::EventMetric<NoExtraKeys> callout_displayed(4272);

  /**
   * generated from pdfjs.image.alt_text.dismiss
   */
    struct DismissExtra {
      mozilla::Maybe<nsCString> altTextType;
      mozilla::Maybe<nsCString> flow;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (altTextType) {
          extraKeys.AppendElement()->AssignASCII("alt_text_type");
          extraValues.EmplaceBack(altTextType.value());
        }
        if (flow) {
          extraKeys.AppendElement()->AssignASCII("flow");
          extraValues.EmplaceBack(flow.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user clicks Not now or Cancel on the alt text modal.
   */
  constexpr impl::EventMetric<DismissExtra> dismiss(4273);

  /**
   * generated from pdfjs.image.alt_text.image_status_label_clicked
   */
    struct ImageStatusLabelClickedExtra {
      mozilla::Maybe<nsCString> label;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (label) {
          extraKeys.AppendElement()->AssignASCII("label");
          extraValues.EmplaceBack(label.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user clicks on the alt text status button.
   */
  constexpr impl::EventMetric<ImageStatusLabelClickedExtra> image_status_label_clicked(4274);

  /**
   * generated from pdfjs.image.alt_text.image_status_label_displayed
   */
    struct ImageStatusLabelDisplayedExtra {
      mozilla::Maybe<nsCString> label;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (label) {
          extraKeys.AppendElement()->AssignASCII("label");
          extraValues.EmplaceBack(label.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the alt text status button on an image is shown .
   */
  constexpr impl::EventMetric<ImageStatusLabelDisplayedExtra> image_status_label_displayed(4275);

  /**
   * generated from pdfjs.image.alt_text.info
   */
    struct InfoExtra {
      mozilla::Maybe<nsCString> topic;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (topic) {
          extraKeys.AppendElement()->AssignASCII("topic");
          extraValues.EmplaceBack(topic.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded on the alt text modal when the user clicks on "i" to learn about alt
     * text or "Learn More" to learn about AI generation.
   */
  constexpr impl::EventMetric<InfoExtra> info(4276);

  /**
   * generated from pdfjs.image.alt_text.model_deleted
   */
  /**
   * Recorded when the user clicks to delete the model from the alt text settings.
   */
  constexpr impl::EventMetric<NoExtraKeys> model_deleted(4277);

  /**
   * generated from pdfjs.image.alt_text.model_download_complete
   */
  /**
   * Recorded when download completes for the alt text generation model.
   */
  constexpr impl::EventMetric<NoExtraKeys> model_download_complete(4278);

  /**
   * generated from pdfjs.image.alt_text.model_download_error
   */
    struct ModelDownloadErrorExtra {
      mozilla::Maybe<nsCString> error;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when an error occurs during the download for the alt text generation
     * model.
   */
  constexpr impl::EventMetric<ModelDownloadErrorExtra> model_download_error(4279);

  /**
   * generated from pdfjs.image.alt_text.model_download_start
   */
  /**
   * Recorded when download starts for the alt text generation model.
   */
  constexpr impl::EventMetric<NoExtraKeys> model_download_start(4280);

  /**
   * generated from pdfjs.image.alt_text.model_result
   */
    struct ModelResultExtra {
      mozilla::Maybe<uint32_t> length;
      mozilla::Maybe<uint32_t> time;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (length) {
          extraKeys.AppendElement()->AssignASCII("length");
          extraValues.EmplaceBack(nsPrintfCString("%d", length.value()));
        }
        if (time) {
          extraKeys.AppendElement()->AssignASCII("time");
          extraValues.EmplaceBack(nsPrintfCString("%d", time.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records how long it takes to generate the alt text and what is the length of
     * the result.
   */
  constexpr impl::EventMetric<ModelResultExtra> model_result(4281);

  /**
   * generated from pdfjs.image.alt_text.save
   */
    struct SaveExtra {
      mozilla::Maybe<nsCString> altTextType;
      mozilla::Maybe<nsCString> flow;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (altTextType) {
          extraKeys.AppendElement()->AssignASCII("alt_text_type");
          extraValues.EmplaceBack(altTextType.value());
        }
        if (flow) {
          extraKeys.AppendElement()->AssignASCII("flow");
          extraValues.EmplaceBack(flow.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user clicks Save on the alt text modal.
   */
  constexpr impl::EventMetric<SaveExtra> save(4282);

  /**
   * generated from pdfjs.image.alt_text.settings_ai_generation_check
   */
    struct SettingsAiGenerationCheckExtra {
      mozilla::Maybe<bool> status;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.AppendElement()->AssignASCII(status.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user interacts with the alt text setting to create alt text
     * with AI.
   */
  constexpr impl::EventMetric<SettingsAiGenerationCheckExtra> settings_ai_generation_check(4283);

  /**
   * generated from pdfjs.image.alt_text.settings_displayed
   */
  /**
   * Recorded when alt text settings dialog is displayed to a user.
   */
  constexpr impl::EventMetric<NoExtraKeys> settings_displayed(4284);

  /**
   * generated from pdfjs.image.alt_text.settings_edit_alt_text_check
   */
    struct SettingsEditAltTextCheckExtra {
      mozilla::Maybe<bool> status;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (status) {
          extraKeys.AppendElement()->AssignASCII("status");
          extraValues.AppendElement()->AssignASCII(status.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user interacts with the alt text modal setting to edit alt
     * text on this pdf.
   */
  constexpr impl::EventMetric<SettingsEditAltTextCheckExtra> settings_edit_alt_text_check(4285);

  /**
   * generated from pdfjs.image.alt_text.user_edit
   */
    struct UserEditExtra {
      mozilla::Maybe<uint32_t> totalWords;
      mozilla::Maybe<uint32_t> wordsAdded;
      mozilla::Maybe<uint32_t> wordsRemoved;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (totalWords) {
          extraKeys.AppendElement()->AssignASCII("total_words");
          extraValues.EmplaceBack(nsPrintfCString("%d", totalWords.value()));
        }
        if (wordsAdded) {
          extraKeys.AppendElement()->AssignASCII("words_added");
          extraValues.EmplaceBack(nsPrintfCString("%d", wordsAdded.value()));
        }
        if (wordsRemoved) {
          extraKeys.AppendElement()->AssignASCII("words_removed");
          extraValues.EmplaceBack(nsPrintfCString("%d", wordsRemoved.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded once the alt text is confirmed, when the user makes changes to the alt
     * text generated. By comparing the initially generated text with the final
     * version, quantifies how many words were changed.
   */
  constexpr impl::EventMetric<UserEditExtra> user_edit(4286);

}
namespace pictureinpicture {
  /**
   * generated from pictureinpicture.closed_method_browser_crash
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#browserCrash.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_browser_crash(4287);

  /**
   * generated from pictureinpicture.closed_method_close_button
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#closeButton.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_close_button(4288);

  /**
   * generated from pictureinpicture.closed_method_close_player_shortcut
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#closePlayerShortcut.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_close_player_shortcut(4289);

  /**
   * generated from pictureinpicture.closed_method_context_menu
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#contextMenu.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_context_menu(4290);

  /**
   * generated from pictureinpicture.closed_method_foregrounded
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#foregrounded.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_foregrounded(4291);

  /**
   * generated from pictureinpicture.closed_method_fullscreen
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#fullscreen.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_fullscreen(4292);

  /**
   * generated from pictureinpicture.closed_method_pagehide
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#pagehide.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_pagehide(4293);

  /**
   * generated from pictureinpicture.closed_method_setup_failure
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#setupFailure.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_setup_failure(4294);

  /**
   * generated from pictureinpicture.closed_method_shortcut
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#shortcut.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_shortcut(4295);

  /**
   * generated from pictureinpicture.closed_method_unpip
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#unpip.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_unpip(4296);

  /**
   * generated from pictureinpicture.closed_method_url_bar
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#urlBar.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_url_bar(4297);

  /**
   * generated from pictureinpicture.closed_method_video_el_emptied
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#videoElEmptied.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_video_el_emptied(4298);

  /**
   * generated from pictureinpicture.closed_method_video_el_remove
   */
  /**
   * Records the method for closing the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.closed_method#videoElRemove.
   */
  constexpr impl::EventMetric<NoExtraKeys> closed_method_video_el_remove(4299);

  /**
   * generated from pictureinpicture.create_player
   */
    struct CreatePlayerExtra {
      mozilla::Maybe<bool> ccenabled;
      mozilla::Maybe<uint32_t> height;
      mozilla::Maybe<uint32_t> screenx;
      mozilla::Maybe<uint32_t> screeny;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<bool> webvttsubtitles;
      mozilla::Maybe<uint32_t> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccenabled) {
          extraKeys.AppendElement()->AssignASCII("ccEnabled");
          extraValues.AppendElement()->AssignASCII(ccenabled.value() ? "true" : "false");
        }
        if (height) {
          extraKeys.AppendElement()->AssignASCII("height");
          extraValues.EmplaceBack(nsPrintfCString("%d", height.value()));
        }
        if (screenx) {
          extraKeys.AppendElement()->AssignASCII("screenX");
          extraValues.EmplaceBack(nsPrintfCString("%d", screenx.value()));
        }
        if (screeny) {
          extraKeys.AppendElement()->AssignASCII("screenY");
          extraValues.EmplaceBack(nsPrintfCString("%d", screeny.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (webvttsubtitles) {
          extraKeys.AppendElement()->AssignASCII("webVTTSubtitles");
          extraValues.AppendElement()->AssignASCII(webvttsubtitles.value() ? "true" : "false");
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(nsPrintfCString("%d", width.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the Picture-in-Picture player window is created. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.create#player.
   */
  constexpr impl::EventMetric<CreatePlayerExtra> create_player(4300);

  /**
   * generated from pictureinpicture.disrespect_disable_url_bar
   */
  /**
   * Recorded when the user chooses to enable PiP anyway on a PiP disabled video
     * This event was generated to correspond to the Legacy Telemetry event
     * pictureinpicture.disrespect_disable#urlBar.
   */
  constexpr impl::EventMetric<NoExtraKeys> disrespect_disable_url_bar(4301);

  /**
   * generated from pictureinpicture.fullscreen_player
   */
    struct FullscreenPlayerExtra {
      mozilla::Maybe<bool> enter;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (enter) {
          extraKeys.AppendElement()->AssignASCII("enter");
          extraValues.AppendElement()->AssignASCII(enter.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user clicks the fullscreen button This event was generated to
     * correspond to the Legacy Telemetry event pictureinpicture.fullscreen#player.
   */
  constexpr impl::EventMetric<FullscreenPlayerExtra> fullscreen_player(4302);

  /**
   * generated from pictureinpicture.most_concurrent_players
   */
  /**
   * The most concurrent Picture-in-Picture players the user had open at any one
     * time. This metric was generated to correspond to the Legacy Telemetry scalar
     * pictureinpicture.most_concurrent_players.
   */
  constexpr impl::QuantityMetric most_concurrent_players(4303);

  /**
   * generated from pictureinpicture.opened_method_auto_pip
   */
    struct OpenedMethodAutoPipExtra {
      mozilla::Maybe<bool> callout;
      mozilla::Maybe<bool> disabledialog;
      mozilla::Maybe<bool> firsttimetoggle;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (callout) {
          extraKeys.AppendElement()->AssignASCII("callout");
          extraValues.AppendElement()->AssignASCII(callout.value() ? "true" : "false");
        }
        if (disabledialog) {
          extraKeys.AppendElement()->AssignASCII("disableDialog");
          extraValues.AppendElement()->AssignASCII(disabledialog.value() ? "true" : "false");
        }
        if (firsttimetoggle) {
          extraKeys.AppendElement()->AssignASCII("firstTimeToggle");
          extraValues.AppendElement()->AssignASCII(firsttimetoggle.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records the method for opening the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.opened_method#autoPip.
   */
  constexpr impl::EventMetric<OpenedMethodAutoPipExtra> opened_method_auto_pip(4304);

  /**
   * generated from pictureinpicture.opened_method_context_menu
   */
    struct OpenedMethodContextMenuExtra {
      mozilla::Maybe<bool> callout;
      mozilla::Maybe<bool> disabledialog;
      mozilla::Maybe<bool> firsttimetoggle;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (callout) {
          extraKeys.AppendElement()->AssignASCII("callout");
          extraValues.AppendElement()->AssignASCII(callout.value() ? "true" : "false");
        }
        if (disabledialog) {
          extraKeys.AppendElement()->AssignASCII("disableDialog");
          extraValues.AppendElement()->AssignASCII(disabledialog.value() ? "true" : "false");
        }
        if (firsttimetoggle) {
          extraKeys.AppendElement()->AssignASCII("firstTimeToggle");
          extraValues.AppendElement()->AssignASCII(firsttimetoggle.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records the method for opening the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.opened_method#contextMenu.
   */
  constexpr impl::EventMetric<OpenedMethodContextMenuExtra> opened_method_context_menu(4305);

  /**
   * generated from pictureinpicture.opened_method_shortcut
   */
    struct OpenedMethodShortcutExtra {
      mozilla::Maybe<bool> callout;
      mozilla::Maybe<bool> disabledialog;
      mozilla::Maybe<bool> firsttimetoggle;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (callout) {
          extraKeys.AppendElement()->AssignASCII("callout");
          extraValues.AppendElement()->AssignASCII(callout.value() ? "true" : "false");
        }
        if (disabledialog) {
          extraKeys.AppendElement()->AssignASCII("disableDialog");
          extraValues.AppendElement()->AssignASCII(disabledialog.value() ? "true" : "false");
        }
        if (firsttimetoggle) {
          extraKeys.AppendElement()->AssignASCII("firstTimeToggle");
          extraValues.AppendElement()->AssignASCII(firsttimetoggle.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records the method for opening the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.opened_method#shortcut.
   */
  constexpr impl::EventMetric<OpenedMethodShortcutExtra> opened_method_shortcut(4306);

  /**
   * generated from pictureinpicture.opened_method_toggle
   */
    struct OpenedMethodToggleExtra {
      mozilla::Maybe<bool> callout;
      mozilla::Maybe<bool> disabledialog;
      mozilla::Maybe<bool> firsttimetoggle;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (callout) {
          extraKeys.AppendElement()->AssignASCII("callout");
          extraValues.AppendElement()->AssignASCII(callout.value() ? "true" : "false");
        }
        if (disabledialog) {
          extraKeys.AppendElement()->AssignASCII("disableDialog");
          extraValues.AppendElement()->AssignASCII(disabledialog.value() ? "true" : "false");
        }
        if (firsttimetoggle) {
          extraKeys.AppendElement()->AssignASCII("firstTimeToggle");
          extraValues.AppendElement()->AssignASCII(firsttimetoggle.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records the method for opening the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.opened_method#toggle.
   */
  constexpr impl::EventMetric<OpenedMethodToggleExtra> opened_method_toggle(4307);

  /**
   * generated from pictureinpicture.opened_method_url_bar
   */
    struct OpenedMethodUrlBarExtra {
      mozilla::Maybe<bool> callout;
      mozilla::Maybe<bool> disabledialog;
      mozilla::Maybe<bool> firsttimetoggle;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (callout) {
          extraKeys.AppendElement()->AssignASCII("callout");
          extraValues.AppendElement()->AssignASCII(callout.value() ? "true" : "false");
        }
        if (disabledialog) {
          extraKeys.AppendElement()->AssignASCII("disableDialog");
          extraValues.AppendElement()->AssignASCII(disabledialog.value() ? "true" : "false");
        }
        if (firsttimetoggle) {
          extraKeys.AppendElement()->AssignASCII("firstTimeToggle");
          extraValues.AppendElement()->AssignASCII(firsttimetoggle.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records the method for opening the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.opened_method#urlBar.
   */
  constexpr impl::EventMetric<OpenedMethodUrlBarExtra> opened_method_url_bar(4308);

  /**
   * generated from pictureinpicture.resize_player
   */
    struct ResizePlayerExtra {
      mozilla::Maybe<uint32_t> height;
      mozilla::Maybe<nsCString> value;
      mozilla::Maybe<uint32_t> width;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (height) {
          extraKeys.AppendElement()->AssignASCII("height");
          extraValues.EmplaceBack(nsPrintfCString("%d", height.value()));
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        if (width) {
          extraKeys.AppendElement()->AssignASCII("width");
          extraValues.EmplaceBack(nsPrintfCString("%d", width.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the Picture-in-Picture player window is resized. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.resize#player.
   */
  constexpr impl::EventMetric<ResizePlayerExtra> resize_player(4309);

  /**
   * generated from pictureinpicture.saw_toggle_toggle
   */
    struct SawToggleToggleExtra {
      mozilla::Maybe<bool> firsttime;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firsttime) {
          extraKeys.AppendElement()->AssignASCII("firstTime");
          extraValues.AppendElement()->AssignASCII(firsttime.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the Picture-in-Picture toggle is shown This event was generated
     * to correspond to the Legacy Telemetry event pictureinpicture.saw_toggle#toggle.
   */
  constexpr impl::EventMetric<SawToggleToggleExtra> saw_toggle_toggle(4310);

  /**
   * generated from pictureinpicture.subtitles_shown_subtitles
   */
    struct SubtitlesShownSubtitlesExtra {
      mozilla::Maybe<bool> webvttsubtitles;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (webvttsubtitles) {
          extraKeys.AppendElement()->AssignASCII("webVTTSubtitles");
          extraValues.AppendElement()->AssignASCII(webvttsubtitles.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records if subtitles are shown in the Picture-in-Picture window. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.subtitles_shown#subtitles.
   */
  constexpr impl::EventMetric<SubtitlesShownSubtitlesExtra> subtitles_shown_subtitles(4311);

  /**
   * generated from pictureinpicture.toggle_enabled
   */
  /**
   * Whether the user has Picture-in-Picture enabled. This metric was generated to
     * correspond to the Legacy Telemetry scalar pictureinpicture.toggle_enabled.
   */
  constexpr impl::BooleanMetric toggle_enabled(4312);

}
namespace pictureinpicture_settings {
  /**
   * generated from pictureinpicture.settings.disable_player
   */
  /**
   * Recorded with "settings" object when Picture-in-Picture is disabled via
     * settings Recorded with "player" object when Picture-in-Picture is disabled via
     * PiP context menu This event was generated to correspond to the Legacy Telemetry
     * event pictureinpicture.settings.disable#player.
   */
  constexpr impl::EventMetric<NoExtraKeys> disable_player(4313);

  /**
   * generated from pictureinpicture.settings.disable_settings
   */
  /**
   * Recorded with "settings" object when Picture-in-Picture is disabled via
     * settings Recorded with "player" object when Picture-in-Picture is disabled via
     * PiP context menu This event was generated to correspond to the Legacy Telemetry
     * event pictureinpicture.settings.disable#settings.
   */
  constexpr impl::EventMetric<NoExtraKeys> disable_settings(4314);

  /**
   * generated from pictureinpicture.settings.enable_autotrigger_settings
   */
  /**
   * Recorded when the Picture-in-Picture auto-trigger is enabled. This event was
     * generated to correspond to the Legacy Telemetry event
     * pictureinpicture.settings.enable_autotrigger#settings.
   */
  constexpr impl::EventMetric<NoExtraKeys> enable_autotrigger_settings(4315);

  /**
   * generated from pictureinpicture.settings.enable_settings
   */
  /**
   * Recorded when Picture-in-Picture is enabled. This event was generated to
     * correspond to the Legacy Telemetry event
     * pictureinpicture.settings.enable#settings.
   */
  constexpr impl::EventMetric<NoExtraKeys> enable_settings(4316);

}
namespace page_icon {
  /**
   * generated from page_icon.fit_icon_count
   */
  /**
   * Number of times the page-icon protocol serves an icon equal to or larger than
     * requested.
   */
  constexpr impl::CounterMetric fit_icon_count(4317);

  /**
   * generated from page_icon.small_icon_count
   */
  /**
   * Number of times the page-icon protocol serves an icon smaller than requested.
   */
  constexpr impl::CounterMetric small_icon_count(4318);

}
namespace places {
  /**
   * generated from places.pages_need_frecency_recalculation
   */
  /**
   * Number of pages that need a frecency recalculation. This metric was generated
     * to correspond to the Legacy Telemetry scalar
     * places.pages_need_frecency_recalculation.
   */
  constexpr impl::QuantityMetric pages_need_frecency_recalculation(4319);

  /**
   * generated from places.places_database_corruption_handling_stage
   */
  /**
   * PLACES - stage reached when trying to fix a database corruption, see
     * Places::Database::eCorruptDBReplaceStage.
   */
  constexpr impl::Labeled<impl::StringMetric, DynamicLabel> places_database_corruption_handling_stage(4320);

  /**
   * generated from places.previousday_visits
   */
  /**
   * Number of history entries for the previous day. This metric was generated to
     * correspond to the Legacy Telemetry scalar places.previousday_visits.
   */
  constexpr impl::QuantityMetric previousday_visits(4321);

  /**
   * generated from places.sponsored_visit_no_triggering_url
   */
  /**
   * Number of sponsored visits that could not find their triggering URL in history.
     * We expect this to be a small number just due to the navigation layer
     * manipulating URLs. A large or growing value may be a concern. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * places.sponsored_visit_no_triggering_url.
   */
  constexpr impl::CounterMetric sponsored_visit_no_triggering_url(4322);

}
namespace printing {
  /**
   * generated from printing.dialog_opened_via_preview_tm
   */
  /**
   * A counter incremented every time a user opens the system print dialog from the
     * print preview interface. This metric was generated to correspond to the Legacy
     * Telemetry scalar printing.dialog_opened_via_preview_tm.
   */
  constexpr impl::CounterMetric dialog_opened_via_preview_tm(4323);

  /**
   * generated from printing.dialog_via_preview_cancelled_tm
   */
  /**
   * A counter incremented every time a user cancels a system print dialog that they
     * opened from the print preview interface. This metric was generated to
     * correspond to the Legacy Telemetry scalar
     * printing.dialog_via_preview_cancelled_tm.
   */
  constexpr impl::CounterMetric dialog_via_preview_cancelled_tm(4324);

  /**
   * generated from printing.error
   */
  enum class ErrorLabel: uint16_t {
      eGfxPrinterNoPrinterAvailable = 0,
      eGfxPrinterNameNotFound = 1,
      eGfxPrinterCouldNotOpenFile = 2,
      eGfxPrinterStartdoc = 3,
      eGfxPrinterEnddoc = 4,
      eGfxPrinterStartpage = 5,
      eGfxPrinterDocIsBusy = 6,
      eAbort = 7,
      eNotAvailable = 8,
      eNotImplemented = 9,
      eOutOfMemory = 10,
      eUnexpected = 11,
      eFailure = 12,
      eFallbackPaperList = 13,
      eLastUsedPrinter = 14,
      ePaperMargins = 15,
      ePrintDestinations = 16,
      ePrintPreview = 17,
      ePrinterList = 18,
      ePrinterProperties = 19,
      ePrinterSettings = 20,
      eUnwriteableMargin = 21,
      e__Other__,
    };
  /**
   * A counter incremented every time the user encounters an error printing. The
     * result is split into keys which represent the values of error codes related to
     * printing. Possible values are listed in 'keys'. "FAILURE" is a catch-all code
     * for an error we don't recognize. This metric was generated to correspond to the
     * Legacy Telemetry scalar printing.error.
   */
  constexpr impl::Labeled<impl::CounterMetric, ErrorLabel> error(4325);

  /**
   * generated from printing.preview_cancelled_tm
   */
  /**
   * A counter incremented every time a user exits print preview without printing.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * printing.preview_cancelled_tm.
   */
  constexpr impl::CounterMetric preview_cancelled_tm(4326);

  /**
   * generated from printing.preview_opened_tm
   */
  /**
   * A counter incremented every time a user opens print preview. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * printing.preview_opened_tm.
   */
  constexpr impl::CounterMetric preview_opened_tm(4327);

  /**
   * generated from printing.settings_changed
   */
  /**
   * A count of how many times the user changed a setting in print preview, broken
     * down per setting. This metric was generated to correspond to the Legacy
     * Telemetry scalar printing.settings_changed.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> settings_changed(4328);

  /**
   * generated from printing.silent_print
   */
  /**
   * A counter incremented every time a silent print (a print without a print
     * settings dialog being opened) is initiated.  This happens when extensions
     * invoke ExtensionAPI.tabs.saveAsPDF, for example, or when the
     * print.always_print_silent pref is set. This metric was generated to correspond
     * to the Legacy Telemetry scalar printing.silent_print.
   */
  constexpr impl::CounterMetric silent_print(4329);

  /**
   * generated from printing.target_type
   */
  enum class TargetTypeLabel: uint16_t {
      ePdfFile = 0,
      ePdfUnknown = 1,
      eXpsFile = 2,
      eUnknown = 3,
      e__Other__,
    };
  /**
   * A counter incremented every time the user prints to a certain target type.  The
     * 'pdf_unknown' count is for printers with names that we don't know about/check
     * for, but that have 'pdf' in their name, and is mainly a sanity check that we're
     * not missing significant counts in 'pdf_file'. For the most part, the 'unknown'
     * count will be prints to a physical printer, but we can't know for sure since
     * third party drivers could also be print to file drivers that we don't otherwise
     * catch in the other counts. This metric was generated to correspond to the
     * Legacy Telemetry scalar printing.target_type.
   */
  constexpr impl::Labeled<impl::CounterMetric, TargetTypeLabel> target_type(4330);

}
namespace power {
  /**
   * generated from power.cpu_time_bogus_values
   */
  /**
   * Impossibly large CPU time values that were discarded.
   */
  constexpr impl::CounterMetric cpu_time_bogus_values(4331);

  /**
   * generated from power.cpu_time_per_process_type_ms
   */
  enum class CpuTimePerProcessTypeMsLabel: uint16_t {
      eParentActive = 0,
      eParentActivePlayingAudio = 1,
      eParentActivePlayingVideo = 2,
      eParentInactive = 3,
      eParentInactivePlayingAudio = 4,
      eParentInactivePlayingVideo = 5,
      ePrealloc = 6,
      ePrivilegedabout = 7,
      eRdd = 8,
      eSocket = 9,
      eWebBackground = 10,
      eWebBackgroundPerceivable = 11,
      eWebForeground = 12,
      eExtension = 13,
      eGpu = 14,
      eGmplugin = 15,
      eUtility = 16,
      e__Other__,
    };
  /**
   * CPU time used by each process type in ms.
   */
  constexpr impl::Labeled<impl::CounterMetric, CpuTimePerProcessTypeMsLabel> cpu_time_per_process_type_ms(4332);

  /**
   * generated from power.cpu_time_per_tracker_type_ms
   */
  enum class CpuTimePerTrackerTypeMsLabel: uint16_t {
      eAd = 0,
      eAnalytics = 1,
      eCryptomining = 2,
      eFingerprinting = 3,
      eSocial = 4,
      eUnknown = 5,
      e__Other__,
    };
  /**
   * CPU time used by content processes used only for tracking resources, labeled by
     * the category of the tracker.
   */
  constexpr impl::Labeled<impl::CounterMetric, CpuTimePerTrackerTypeMsLabel> cpu_time_per_tracker_type_ms(4333);

  /**
   * generated from power.energy_per_process_type
   */
  enum class EnergyPerProcessTypeLabel: uint16_t {
      eParentActive = 0,
      eParentActivePlayingAudio = 1,
      eParentActivePlayingVideo = 2,
      eParentInactive = 3,
      eParentInactivePlayingAudio = 4,
      eParentInactivePlayingVideo = 5,
      ePrealloc = 6,
      ePrivilegedabout = 7,
      eRdd = 8,
      eSocket = 9,
      eWebBackground = 10,
      eWebBackgroundPerceivable = 11,
      eWebForeground = 12,
      eExtension = 13,
      eGpu = 14,
      eGmplugin = 15,
      eUtility = 16,
      e__Other__,
    };
  /**
   * How much energy (in µWh) has been used, broken down by process type. Only
     * available on Apple Silicon.
   */
  constexpr impl::Labeled<impl::CounterMetric, EnergyPerProcessTypeLabel> energy_per_process_type(4334);

  /**
   * generated from power.gpu_time_bogus_values
   */
  /**
   * Impossibly large GPU time values that were discarded.
   */
  constexpr impl::CounterMetric gpu_time_bogus_values(4335);

  /**
   * generated from power.gpu_time_per_process_type_ms
   */
  enum class GpuTimePerProcessTypeMsLabel: uint16_t {
      eParentActive = 0,
      eParentActivePlayingAudio = 1,
      eParentActivePlayingVideo = 2,
      eParentInactive = 3,
      eParentInactivePlayingAudio = 4,
      eParentInactivePlayingVideo = 5,
      ePrealloc = 6,
      ePrivilegedabout = 7,
      eRdd = 8,
      eSocket = 9,
      eWebBackground = 10,
      eWebBackgroundPerceivable = 11,
      eWebForeground = 12,
      eExtension = 13,
      eGpu = 14,
      eGmplugin = 15,
      eUtility = 16,
      e__Other__,
    };
  /**
   * GPU time used by each process type in ms.
   */
  constexpr impl::Labeled<impl::CounterMetric, GpuTimePerProcessTypeMsLabel> gpu_time_per_process_type_ms(4336);

  /**
   * generated from power.total_cpu_time_ms
   */
  /**
   * Total CPU time used by all processes in ms.
   */
  constexpr impl::CounterMetric total_cpu_time_ms(4337);

  /**
   * generated from power.total_gpu_time_ms
   */
  /**
   * Total GPU time used by all processes in ms.
   */
  constexpr impl::CounterMetric total_gpu_time_ms(4338);

  /**
   * generated from power.total_thread_wakeups
   */
  /**
   * How many times threads woke up and could have woken up a CPU core.
   */
  constexpr impl::CounterMetric total_thread_wakeups(4339);

  /**
   * generated from power.wakeups_per_process_type
   */
  enum class WakeupsPerProcessTypeLabel: uint16_t {
      eParentActive = 0,
      eParentActivePlayingAudio = 1,
      eParentActivePlayingVideo = 2,
      eParentInactive = 3,
      eParentInactivePlayingAudio = 4,
      eParentInactivePlayingVideo = 5,
      ePrealloc = 6,
      ePrivilegedabout = 7,
      eRdd = 8,
      eSocket = 9,
      eWebBackground = 10,
      eWebBackgroundPerceivable = 11,
      eWebForeground = 12,
      eExtension = 13,
      eGpu = 14,
      eGmplugin = 15,
      eUtility = 16,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, WakeupsPerProcessTypeLabel> wakeups_per_process_type(4340);

}
namespace power_battery {
  /**
   * generated from power.battery.percentage_when_user_active
   */
  /**
   * Records how many percent of battery was available for each period of user
     * activity.
   */
  constexpr impl::CustomDistributionMetric percentage_when_user_active(4341);

}
namespace power_cpu_ms_per_thread {
  /**
   * generated from power.cpu_ms_per_thread.content_background
   */
  enum class ContentBackgroundLabel: uint16_t {
      eAndroidui = 0,
      eAsynclogger = 1,
      eAudioipc = 2,
      eAudioipcCallbackRpc = 3,
      eAudioipcClientCallback = 4,
      eAudioipcClientRpc = 5,
      eAudioipcDevicecollectionRpc = 6,
      eAudioipcServerCallback = 7,
      eAudioipcServerRpc = 8,
      eBackgroundthreadpool = 9,
      eBgiothreadpool = 10,
      eBgreadurls = 11,
      eBhmgrMonitor = 12,
      eBhmgrProcessor = 13,
      eCamerasIpc = 14,
      eCanvasrenderer = 15,
      eCapturethread = 16,
      eClassifierUpdate = 17,
      eComMta = 18,
      eCompositor = 19,
      eConvolverworker = 20,
      eCookie = 21,
      eCubeboperation = 22,
      eDatachannelIo = 23,
      eDnsResolver = 24,
      eDomWorker = 25,
      eDomWorklet = 26,
      eDomcachethread = 27,
      eExtensionprotocolhandler = 28,
      eFontLoader = 29,
      eFontenumthread = 30,
      eFsBroker = 31,
      eGeckomain = 32,
      eGmpthread = 33,
      eGraphrunner = 34,
      eHrtfdatabaseldr = 35,
      eHtml5Parser = 36,
      eImagebridgechld = 37,
      eImageio = 38,
      eIndexeddb = 39,
      eInitfontlist = 40,
      eInotifyeventthread = 41,
      eIndexeddbIo = 42,
      eIpcIOChild = 43,
      eIpcIOParent = 44,
      eIpcLaunch = 45,
      eIpdlBackground = 46,
      eJsWatchdog = 47,
      eJumpList = 48,
      eLibwebrtcmodulethread = 49,
      eLinkMonitor = 50,
      eLsThread = 51,
      eMdnsService = 52,
      eMediacache = 53,
      eMediadecoderstatemachine = 54,
      eMediapdecoder = 55,
      eMediasupervisor = 56,
      eMediatimer = 57,
      eMediatrackgrph = 58,
      eMemorypoller = 59,
      eMozstorage = 60,
      eMtransport = 61,
      eNetlinkMonitor = 62,
      ePacerthread = 63,
      ePermission = 64,
      ePlayeventsound = 65,
      eProcesshangmon = 66,
      eProfilerchild = 67,
      eProxyresolution = 68,
      eQuotamanagerIo = 69,
      eRegisterfonts = 70,
      eRemotebackbuffer = 71,
      eRemotelzystream = 72,
      eRemvidchild = 73,
      eRenderer = 74,
      eSandboxreporter = 75,
      eSavescripts = 76,
      eSocketThread = 77,
      eSoftwarevsyncthread = 78,
      eSqldbContentPrefsSqlite = 79,
      eSqldbCookiesSqlite = 80,
      eSqldbFormhistorySqlite = 81,
      eSslCert = 82,
      eStartupcache = 83,
      eStreamtrans = 84,
      eStylethread = 85,
      eSwcomposite = 86,
      eTaskcontroller = 87,
      eTimer = 88,
      eToastbgthread = 89,
      eTrrBackground = 90,
      eUntrustedModules = 91,
      eUrlClassifier = 92,
      eVideocapture = 93,
      eVsynciothread = 94,
      eWebrtccallthread = 95,
      eWebrtcworker = 96,
      eWincompositor = 97,
      eWindowsvsyncthread = 98,
      eWinwindowocclusioncalc = 99,
      eWifiTickler = 100,
      eWorkerLauncher = 101,
      eWrrenderbackend = 102,
      eWrscenebuilder = 103,
      eWrscenebuilderlp = 104,
      eWrworker = 105,
      eWrworkerlp = 106,
      e__Other__,
    };
  /**
   * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ContentBackgroundLabel> content_background(4342);

  /**
   * generated from power.cpu_ms_per_thread.content_foreground
   */
  enum class ContentForegroundLabel: uint16_t {
      eAndroidui = 0,
      eAsynclogger = 1,
      eAudioipc = 2,
      eAudioipcCallbackRpc = 3,
      eAudioipcClientCallback = 4,
      eAudioipcClientRpc = 5,
      eAudioipcDevicecollectionRpc = 6,
      eAudioipcServerCallback = 7,
      eAudioipcServerRpc = 8,
      eBackgroundthreadpool = 9,
      eBgiothreadpool = 10,
      eBgreadurls = 11,
      eBhmgrMonitor = 12,
      eBhmgrProcessor = 13,
      eCamerasIpc = 14,
      eCanvasrenderer = 15,
      eCapturethread = 16,
      eClassifierUpdate = 17,
      eComMta = 18,
      eCompositor = 19,
      eConvolverworker = 20,
      eCookie = 21,
      eCubeboperation = 22,
      eDatachannelIo = 23,
      eDnsResolver = 24,
      eDomWorker = 25,
      eDomWorklet = 26,
      eDomcachethread = 27,
      eExtensionprotocolhandler = 28,
      eFontLoader = 29,
      eFontenumthread = 30,
      eFsBroker = 31,
      eGeckomain = 32,
      eGmpthread = 33,
      eGraphrunner = 34,
      eHrtfdatabaseldr = 35,
      eHtml5Parser = 36,
      eImagebridgechld = 37,
      eImageio = 38,
      eIndexeddb = 39,
      eInitfontlist = 40,
      eInotifyeventthread = 41,
      eIndexeddbIo = 42,
      eIpcIOChild = 43,
      eIpcIOParent = 44,
      eIpcLaunch = 45,
      eIpdlBackground = 46,
      eJsWatchdog = 47,
      eJumpList = 48,
      eLibwebrtcmodulethread = 49,
      eLinkMonitor = 50,
      eLsThread = 51,
      eMdnsService = 52,
      eMediacache = 53,
      eMediadecoderstatemachine = 54,
      eMediapdecoder = 55,
      eMediasupervisor = 56,
      eMediatimer = 57,
      eMediatrackgrph = 58,
      eMemorypoller = 59,
      eMozstorage = 60,
      eMtransport = 61,
      eNetlinkMonitor = 62,
      ePacerthread = 63,
      ePermission = 64,
      ePlayeventsound = 65,
      eProcesshangmon = 66,
      eProfilerchild = 67,
      eProxyresolution = 68,
      eQuotamanagerIo = 69,
      eRegisterfonts = 70,
      eRemotebackbuffer = 71,
      eRemotelzystream = 72,
      eRemvidchild = 73,
      eRenderer = 74,
      eSandboxreporter = 75,
      eSavescripts = 76,
      eSocketThread = 77,
      eSoftwarevsyncthread = 78,
      eSqldbContentPrefsSqlite = 79,
      eSqldbCookiesSqlite = 80,
      eSqldbFormhistorySqlite = 81,
      eSslCert = 82,
      eStartupcache = 83,
      eStreamtrans = 84,
      eStylethread = 85,
      eSwcomposite = 86,
      eTaskcontroller = 87,
      eTimer = 88,
      eToastbgthread = 89,
      eTrrBackground = 90,
      eUntrustedModules = 91,
      eUrlClassifier = 92,
      eVideocapture = 93,
      eVsynciothread = 94,
      eWebrtccallthread = 95,
      eWebrtcworker = 96,
      eWincompositor = 97,
      eWindowsvsyncthread = 98,
      eWinwindowocclusioncalc = 99,
      eWifiTickler = 100,
      eWorkerLauncher = 101,
      eWrrenderbackend = 102,
      eWrscenebuilder = 103,
      eWrscenebuilderlp = 104,
      eWrworker = 105,
      eWrworkerlp = 106,
      e__Other__,
    };
  /**
   * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ContentForegroundLabel> content_foreground(4343);

  /**
   * generated from power.cpu_ms_per_thread.gpu_process
   */
  enum class GpuProcessLabel: uint16_t {
      eAndroidui = 0,
      eAsynclogger = 1,
      eAudioipc = 2,
      eAudioipcCallbackRpc = 3,
      eAudioipcClientCallback = 4,
      eAudioipcClientRpc = 5,
      eAudioipcDevicecollectionRpc = 6,
      eAudioipcServerCallback = 7,
      eAudioipcServerRpc = 8,
      eBackgroundthreadpool = 9,
      eBgiothreadpool = 10,
      eBgreadurls = 11,
      eBhmgrMonitor = 12,
      eBhmgrProcessor = 13,
      eCamerasIpc = 14,
      eCanvasrenderer = 15,
      eCapturethread = 16,
      eClassifierUpdate = 17,
      eComMta = 18,
      eCompositor = 19,
      eConvolverworker = 20,
      eCookie = 21,
      eCubeboperation = 22,
      eDatachannelIo = 23,
      eDnsResolver = 24,
      eDomWorker = 25,
      eDomWorklet = 26,
      eDomcachethread = 27,
      eExtensionprotocolhandler = 28,
      eFontLoader = 29,
      eFontenumthread = 30,
      eFsBroker = 31,
      eGeckomain = 32,
      eGmpthread = 33,
      eGraphrunner = 34,
      eHrtfdatabaseldr = 35,
      eHtml5Parser = 36,
      eImagebridgechld = 37,
      eImageio = 38,
      eIndexeddb = 39,
      eInitfontlist = 40,
      eInotifyeventthread = 41,
      eIndexeddbIo = 42,
      eIpcIOChild = 43,
      eIpcIOParent = 44,
      eIpcLaunch = 45,
      eIpdlBackground = 46,
      eJsWatchdog = 47,
      eJumpList = 48,
      eLibwebrtcmodulethread = 49,
      eLinkMonitor = 50,
      eLsThread = 51,
      eMdnsService = 52,
      eMediacache = 53,
      eMediadecoderstatemachine = 54,
      eMediapdecoder = 55,
      eMediasupervisor = 56,
      eMediatimer = 57,
      eMediatrackgrph = 58,
      eMemorypoller = 59,
      eMozstorage = 60,
      eMtransport = 61,
      eNetlinkMonitor = 62,
      ePacerthread = 63,
      ePermission = 64,
      ePlayeventsound = 65,
      eProcesshangmon = 66,
      eProfilerchild = 67,
      eProxyresolution = 68,
      eQuotamanagerIo = 69,
      eRegisterfonts = 70,
      eRemotebackbuffer = 71,
      eRemotelzystream = 72,
      eRemvidchild = 73,
      eRenderer = 74,
      eSandboxreporter = 75,
      eSavescripts = 76,
      eSocketThread = 77,
      eSoftwarevsyncthread = 78,
      eSqldbContentPrefsSqlite = 79,
      eSqldbCookiesSqlite = 80,
      eSqldbFormhistorySqlite = 81,
      eSslCert = 82,
      eStartupcache = 83,
      eStreamtrans = 84,
      eStylethread = 85,
      eSwcomposite = 86,
      eTaskcontroller = 87,
      eTimer = 88,
      eToastbgthread = 89,
      eTrrBackground = 90,
      eUntrustedModules = 91,
      eUrlClassifier = 92,
      eVideocapture = 93,
      eVsynciothread = 94,
      eWebrtccallthread = 95,
      eWebrtcworker = 96,
      eWincompositor = 97,
      eWindowsvsyncthread = 98,
      eWinwindowocclusioncalc = 99,
      eWifiTickler = 100,
      eWorkerLauncher = 101,
      eWrrenderbackend = 102,
      eWrscenebuilder = 103,
      eWrscenebuilderlp = 104,
      eWrworker = 105,
      eWrworkerlp = 106,
      e__Other__,
    };
  /**
   * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, GpuProcessLabel> gpu_process(4344);

  /**
   * generated from power.cpu_ms_per_thread.parent_active
   */
  enum class ParentActiveLabel: uint16_t {
      eAndroidui = 0,
      eAsynclogger = 1,
      eAudioipc = 2,
      eAudioipcCallbackRpc = 3,
      eAudioipcClientCallback = 4,
      eAudioipcClientRpc = 5,
      eAudioipcDevicecollectionRpc = 6,
      eAudioipcServerCallback = 7,
      eAudioipcServerRpc = 8,
      eBackgroundthreadpool = 9,
      eBgiothreadpool = 10,
      eBgreadurls = 11,
      eBhmgrMonitor = 12,
      eBhmgrProcessor = 13,
      eCamerasIpc = 14,
      eCanvasrenderer = 15,
      eCapturethread = 16,
      eClassifierUpdate = 17,
      eComMta = 18,
      eCompositor = 19,
      eConvolverworker = 20,
      eCookie = 21,
      eCubeboperation = 22,
      eDatachannelIo = 23,
      eDnsResolver = 24,
      eDomWorker = 25,
      eDomWorklet = 26,
      eDomcachethread = 27,
      eExtensionprotocolhandler = 28,
      eFontLoader = 29,
      eFontenumthread = 30,
      eFsBroker = 31,
      eGeckomain = 32,
      eGmpthread = 33,
      eGraphrunner = 34,
      eHrtfdatabaseldr = 35,
      eHtml5Parser = 36,
      eImagebridgechld = 37,
      eImageio = 38,
      eIndexeddb = 39,
      eInitfontlist = 40,
      eInotifyeventthread = 41,
      eIndexeddbIo = 42,
      eIpcIOChild = 43,
      eIpcIOParent = 44,
      eIpcLaunch = 45,
      eIpdlBackground = 46,
      eJsWatchdog = 47,
      eJumpList = 48,
      eLibwebrtcmodulethread = 49,
      eLinkMonitor = 50,
      eLsThread = 51,
      eMdnsService = 52,
      eMediacache = 53,
      eMediadecoderstatemachine = 54,
      eMediapdecoder = 55,
      eMediasupervisor = 56,
      eMediatimer = 57,
      eMediatrackgrph = 58,
      eMemorypoller = 59,
      eMozstorage = 60,
      eMtransport = 61,
      eNetlinkMonitor = 62,
      ePacerthread = 63,
      ePermission = 64,
      ePlayeventsound = 65,
      eProcesshangmon = 66,
      eProfilerchild = 67,
      eProxyresolution = 68,
      eQuotamanagerIo = 69,
      eRegisterfonts = 70,
      eRemotebackbuffer = 71,
      eRemotelzystream = 72,
      eRemvidchild = 73,
      eRenderer = 74,
      eSandboxreporter = 75,
      eSavescripts = 76,
      eSocketThread = 77,
      eSoftwarevsyncthread = 78,
      eSqldbContentPrefsSqlite = 79,
      eSqldbCookiesSqlite = 80,
      eSqldbFormhistorySqlite = 81,
      eSslCert = 82,
      eStartupcache = 83,
      eStreamtrans = 84,
      eStylethread = 85,
      eSwcomposite = 86,
      eTaskcontroller = 87,
      eTimer = 88,
      eToastbgthread = 89,
      eTrrBackground = 90,
      eUntrustedModules = 91,
      eUrlClassifier = 92,
      eVideocapture = 93,
      eVsynciothread = 94,
      eWebrtccallthread = 95,
      eWebrtcworker = 96,
      eWincompositor = 97,
      eWindowsvsyncthread = 98,
      eWinwindowocclusioncalc = 99,
      eWifiTickler = 100,
      eWorkerLauncher = 101,
      eWrrenderbackend = 102,
      eWrscenebuilder = 103,
      eWrscenebuilderlp = 104,
      eWrworker = 105,
      eWrworkerlp = 106,
      e__Other__,
    };
  /**
   * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ParentActiveLabel> parent_active(4345);

  /**
   * generated from power.cpu_ms_per_thread.parent_inactive
   */
  enum class ParentInactiveLabel: uint16_t {
      eAndroidui = 0,
      eAsynclogger = 1,
      eAudioipc = 2,
      eAudioipcCallbackRpc = 3,
      eAudioipcClientCallback = 4,
      eAudioipcClientRpc = 5,
      eAudioipcDevicecollectionRpc = 6,
      eAudioipcServerCallback = 7,
      eAudioipcServerRpc = 8,
      eBackgroundthreadpool = 9,
      eBgiothreadpool = 10,
      eBgreadurls = 11,
      eBhmgrMonitor = 12,
      eBhmgrProcessor = 13,
      eCamerasIpc = 14,
      eCanvasrenderer = 15,
      eCapturethread = 16,
      eClassifierUpdate = 17,
      eComMta = 18,
      eCompositor = 19,
      eConvolverworker = 20,
      eCookie = 21,
      eCubeboperation = 22,
      eDatachannelIo = 23,
      eDnsResolver = 24,
      eDomWorker = 25,
      eDomWorklet = 26,
      eDomcachethread = 27,
      eExtensionprotocolhandler = 28,
      eFontLoader = 29,
      eFontenumthread = 30,
      eFsBroker = 31,
      eGeckomain = 32,
      eGmpthread = 33,
      eGraphrunner = 34,
      eHrtfdatabaseldr = 35,
      eHtml5Parser = 36,
      eImagebridgechld = 37,
      eImageio = 38,
      eIndexeddb = 39,
      eInitfontlist = 40,
      eInotifyeventthread = 41,
      eIndexeddbIo = 42,
      eIpcIOChild = 43,
      eIpcIOParent = 44,
      eIpcLaunch = 45,
      eIpdlBackground = 46,
      eJsWatchdog = 47,
      eJumpList = 48,
      eLibwebrtcmodulethread = 49,
      eLinkMonitor = 50,
      eLsThread = 51,
      eMdnsService = 52,
      eMediacache = 53,
      eMediadecoderstatemachine = 54,
      eMediapdecoder = 55,
      eMediasupervisor = 56,
      eMediatimer = 57,
      eMediatrackgrph = 58,
      eMemorypoller = 59,
      eMozstorage = 60,
      eMtransport = 61,
      eNetlinkMonitor = 62,
      ePacerthread = 63,
      ePermission = 64,
      ePlayeventsound = 65,
      eProcesshangmon = 66,
      eProfilerchild = 67,
      eProxyresolution = 68,
      eQuotamanagerIo = 69,
      eRegisterfonts = 70,
      eRemotebackbuffer = 71,
      eRemotelzystream = 72,
      eRemvidchild = 73,
      eRenderer = 74,
      eSandboxreporter = 75,
      eSavescripts = 76,
      eSocketThread = 77,
      eSoftwarevsyncthread = 78,
      eSqldbContentPrefsSqlite = 79,
      eSqldbCookiesSqlite = 80,
      eSqldbFormhistorySqlite = 81,
      eSslCert = 82,
      eStartupcache = 83,
      eStreamtrans = 84,
      eStylethread = 85,
      eSwcomposite = 86,
      eTaskcontroller = 87,
      eTimer = 88,
      eToastbgthread = 89,
      eTrrBackground = 90,
      eUntrustedModules = 91,
      eUrlClassifier = 92,
      eVideocapture = 93,
      eVsynciothread = 94,
      eWebrtccallthread = 95,
      eWebrtcworker = 96,
      eWincompositor = 97,
      eWindowsvsyncthread = 98,
      eWinwindowocclusioncalc = 99,
      eWifiTickler = 100,
      eWorkerLauncher = 101,
      eWrrenderbackend = 102,
      eWrscenebuilder = 103,
      eWrscenebuilderlp = 104,
      eWrworker = 105,
      eWrworkerlp = 106,
      e__Other__,
    };
  /**
   * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ParentInactiveLabel> parent_inactive(4346);

}
namespace power_wakeups_per_thread {
  /**
   * generated from power.wakeups_per_thread.content_background
   */
  enum class ContentBackgroundLabel: uint16_t {
      eAndroidui = 0,
      eAsynclogger = 1,
      eAudioipc = 2,
      eAudioipcCallbackRpc = 3,
      eAudioipcClientCallback = 4,
      eAudioipcClientRpc = 5,
      eAudioipcDevicecollectionRpc = 6,
      eAudioipcServerCallback = 7,
      eAudioipcServerRpc = 8,
      eBackgroundthreadpool = 9,
      eBgiothreadpool = 10,
      eBgreadurls = 11,
      eBhmgrMonitor = 12,
      eBhmgrProcessor = 13,
      eCamerasIpc = 14,
      eCanvasrenderer = 15,
      eCapturethread = 16,
      eClassifierUpdate = 17,
      eComMta = 18,
      eCompositor = 19,
      eConvolverworker = 20,
      eCookie = 21,
      eCubeboperation = 22,
      eDatachannelIo = 23,
      eDnsResolver = 24,
      eDomWorker = 25,
      eDomWorklet = 26,
      eDomcachethread = 27,
      eExtensionprotocolhandler = 28,
      eFontLoader = 29,
      eFontenumthread = 30,
      eFsBroker = 31,
      eGeckomain = 32,
      eGmpthread = 33,
      eGraphrunner = 34,
      eHrtfdatabaseldr = 35,
      eHtml5Parser = 36,
      eImagebridgechld = 37,
      eImageio = 38,
      eIndexeddb = 39,
      eInitfontlist = 40,
      eInotifyeventthread = 41,
      eIndexeddbIo = 42,
      eIpcIOChild = 43,
      eIpcIOParent = 44,
      eIpcLaunch = 45,
      eIpdlBackground = 46,
      eJsWatchdog = 47,
      eJumpList = 48,
      eLibwebrtcmodulethread = 49,
      eLinkMonitor = 50,
      eLsThread = 51,
      eMdnsService = 52,
      eMediacache = 53,
      eMediadecoderstatemachine = 54,
      eMediapdecoder = 55,
      eMediasupervisor = 56,
      eMediatimer = 57,
      eMediatrackgrph = 58,
      eMemorypoller = 59,
      eMozstorage = 60,
      eMtransport = 61,
      eNetlinkMonitor = 62,
      ePacerthread = 63,
      ePermission = 64,
      ePlayeventsound = 65,
      eProcesshangmon = 66,
      eProfilerchild = 67,
      eProxyresolution = 68,
      eQuotamanagerIo = 69,
      eRegisterfonts = 70,
      eRemotebackbuffer = 71,
      eRemotelzystream = 72,
      eRemvidchild = 73,
      eRenderer = 74,
      eSandboxreporter = 75,
      eSavescripts = 76,
      eSocketThread = 77,
      eSoftwarevsyncthread = 78,
      eSqldbContentPrefsSqlite = 79,
      eSqldbCookiesSqlite = 80,
      eSqldbFormhistorySqlite = 81,
      eSslCert = 82,
      eStartupcache = 83,
      eStreamtrans = 84,
      eStylethread = 85,
      eSwcomposite = 86,
      eTaskcontroller = 87,
      eTimer = 88,
      eToastbgthread = 89,
      eTrrBackground = 90,
      eUntrustedModules = 91,
      eUrlClassifier = 92,
      eVideocapture = 93,
      eVsynciothread = 94,
      eWebrtccallthread = 95,
      eWebrtcworker = 96,
      eWincompositor = 97,
      eWindowsvsyncthread = 98,
      eWinwindowocclusioncalc = 99,
      eWifiTickler = 100,
      eWorkerLauncher = 101,
      eWrrenderbackend = 102,
      eWrscenebuilder = 103,
      eWrscenebuilderlp = 104,
      eWrworker = 105,
      eWrworkerlp = 106,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ContentBackgroundLabel> content_background(4347);

  /**
   * generated from power.wakeups_per_thread.content_foreground
   */
  enum class ContentForegroundLabel: uint16_t {
      eAndroidui = 0,
      eAsynclogger = 1,
      eAudioipc = 2,
      eAudioipcCallbackRpc = 3,
      eAudioipcClientCallback = 4,
      eAudioipcClientRpc = 5,
      eAudioipcDevicecollectionRpc = 6,
      eAudioipcServerCallback = 7,
      eAudioipcServerRpc = 8,
      eBackgroundthreadpool = 9,
      eBgiothreadpool = 10,
      eBgreadurls = 11,
      eBhmgrMonitor = 12,
      eBhmgrProcessor = 13,
      eCamerasIpc = 14,
      eCanvasrenderer = 15,
      eCapturethread = 16,
      eClassifierUpdate = 17,
      eComMta = 18,
      eCompositor = 19,
      eConvolverworker = 20,
      eCookie = 21,
      eCubeboperation = 22,
      eDatachannelIo = 23,
      eDnsResolver = 24,
      eDomWorker = 25,
      eDomWorklet = 26,
      eDomcachethread = 27,
      eExtensionprotocolhandler = 28,
      eFontLoader = 29,
      eFontenumthread = 30,
      eFsBroker = 31,
      eGeckomain = 32,
      eGmpthread = 33,
      eGraphrunner = 34,
      eHrtfdatabaseldr = 35,
      eHtml5Parser = 36,
      eImagebridgechld = 37,
      eImageio = 38,
      eIndexeddb = 39,
      eInitfontlist = 40,
      eInotifyeventthread = 41,
      eIndexeddbIo = 42,
      eIpcIOChild = 43,
      eIpcIOParent = 44,
      eIpcLaunch = 45,
      eIpdlBackground = 46,
      eJsWatchdog = 47,
      eJumpList = 48,
      eLibwebrtcmodulethread = 49,
      eLinkMonitor = 50,
      eLsThread = 51,
      eMdnsService = 52,
      eMediacache = 53,
      eMediadecoderstatemachine = 54,
      eMediapdecoder = 55,
      eMediasupervisor = 56,
      eMediatimer = 57,
      eMediatrackgrph = 58,
      eMemorypoller = 59,
      eMozstorage = 60,
      eMtransport = 61,
      eNetlinkMonitor = 62,
      ePacerthread = 63,
      ePermission = 64,
      ePlayeventsound = 65,
      eProcesshangmon = 66,
      eProfilerchild = 67,
      eProxyresolution = 68,
      eQuotamanagerIo = 69,
      eRegisterfonts = 70,
      eRemotebackbuffer = 71,
      eRemotelzystream = 72,
      eRemvidchild = 73,
      eRenderer = 74,
      eSandboxreporter = 75,
      eSavescripts = 76,
      eSocketThread = 77,
      eSoftwarevsyncthread = 78,
      eSqldbContentPrefsSqlite = 79,
      eSqldbCookiesSqlite = 80,
      eSqldbFormhistorySqlite = 81,
      eSslCert = 82,
      eStartupcache = 83,
      eStreamtrans = 84,
      eStylethread = 85,
      eSwcomposite = 86,
      eTaskcontroller = 87,
      eTimer = 88,
      eToastbgthread = 89,
      eTrrBackground = 90,
      eUntrustedModules = 91,
      eUrlClassifier = 92,
      eVideocapture = 93,
      eVsynciothread = 94,
      eWebrtccallthread = 95,
      eWebrtcworker = 96,
      eWincompositor = 97,
      eWindowsvsyncthread = 98,
      eWinwindowocclusioncalc = 99,
      eWifiTickler = 100,
      eWorkerLauncher = 101,
      eWrrenderbackend = 102,
      eWrscenebuilder = 103,
      eWrscenebuilderlp = 104,
      eWrworker = 105,
      eWrworkerlp = 106,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ContentForegroundLabel> content_foreground(4348);

  /**
   * generated from power.wakeups_per_thread.gpu_process
   */
  enum class GpuProcessLabel: uint16_t {
      eAndroidui = 0,
      eAsynclogger = 1,
      eAudioipc = 2,
      eAudioipcCallbackRpc = 3,
      eAudioipcClientCallback = 4,
      eAudioipcClientRpc = 5,
      eAudioipcDevicecollectionRpc = 6,
      eAudioipcServerCallback = 7,
      eAudioipcServerRpc = 8,
      eBackgroundthreadpool = 9,
      eBgiothreadpool = 10,
      eBgreadurls = 11,
      eBhmgrMonitor = 12,
      eBhmgrProcessor = 13,
      eCamerasIpc = 14,
      eCanvasrenderer = 15,
      eCapturethread = 16,
      eClassifierUpdate = 17,
      eComMta = 18,
      eCompositor = 19,
      eConvolverworker = 20,
      eCookie = 21,
      eCubeboperation = 22,
      eDatachannelIo = 23,
      eDnsResolver = 24,
      eDomWorker = 25,
      eDomWorklet = 26,
      eDomcachethread = 27,
      eExtensionprotocolhandler = 28,
      eFontLoader = 29,
      eFontenumthread = 30,
      eFsBroker = 31,
      eGeckomain = 32,
      eGmpthread = 33,
      eGraphrunner = 34,
      eHrtfdatabaseldr = 35,
      eHtml5Parser = 36,
      eImagebridgechld = 37,
      eImageio = 38,
      eIndexeddb = 39,
      eInitfontlist = 40,
      eInotifyeventthread = 41,
      eIndexeddbIo = 42,
      eIpcIOChild = 43,
      eIpcIOParent = 44,
      eIpcLaunch = 45,
      eIpdlBackground = 46,
      eJsWatchdog = 47,
      eJumpList = 48,
      eLibwebrtcmodulethread = 49,
      eLinkMonitor = 50,
      eLsThread = 51,
      eMdnsService = 52,
      eMediacache = 53,
      eMediadecoderstatemachine = 54,
      eMediapdecoder = 55,
      eMediasupervisor = 56,
      eMediatimer = 57,
      eMediatrackgrph = 58,
      eMemorypoller = 59,
      eMozstorage = 60,
      eMtransport = 61,
      eNetlinkMonitor = 62,
      ePacerthread = 63,
      ePermission = 64,
      ePlayeventsound = 65,
      eProcesshangmon = 66,
      eProfilerchild = 67,
      eProxyresolution = 68,
      eQuotamanagerIo = 69,
      eRegisterfonts = 70,
      eRemotebackbuffer = 71,
      eRemotelzystream = 72,
      eRemvidchild = 73,
      eRenderer = 74,
      eSandboxreporter = 75,
      eSavescripts = 76,
      eSocketThread = 77,
      eSoftwarevsyncthread = 78,
      eSqldbContentPrefsSqlite = 79,
      eSqldbCookiesSqlite = 80,
      eSqldbFormhistorySqlite = 81,
      eSslCert = 82,
      eStartupcache = 83,
      eStreamtrans = 84,
      eStylethread = 85,
      eSwcomposite = 86,
      eTaskcontroller = 87,
      eTimer = 88,
      eToastbgthread = 89,
      eTrrBackground = 90,
      eUntrustedModules = 91,
      eUrlClassifier = 92,
      eVideocapture = 93,
      eVsynciothread = 94,
      eWebrtccallthread = 95,
      eWebrtcworker = 96,
      eWincompositor = 97,
      eWindowsvsyncthread = 98,
      eWinwindowocclusioncalc = 99,
      eWifiTickler = 100,
      eWorkerLauncher = 101,
      eWrrenderbackend = 102,
      eWrscenebuilder = 103,
      eWrscenebuilderlp = 104,
      eWrworker = 105,
      eWrworkerlp = 106,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, GpuProcessLabel> gpu_process(4349);

  /**
   * generated from power.wakeups_per_thread.parent_active
   */
  enum class ParentActiveLabel: uint16_t {
      eAndroidui = 0,
      eAsynclogger = 1,
      eAudioipc = 2,
      eAudioipcCallbackRpc = 3,
      eAudioipcClientCallback = 4,
      eAudioipcClientRpc = 5,
      eAudioipcDevicecollectionRpc = 6,
      eAudioipcServerCallback = 7,
      eAudioipcServerRpc = 8,
      eBackgroundthreadpool = 9,
      eBgiothreadpool = 10,
      eBgreadurls = 11,
      eBhmgrMonitor = 12,
      eBhmgrProcessor = 13,
      eCamerasIpc = 14,
      eCanvasrenderer = 15,
      eCapturethread = 16,
      eClassifierUpdate = 17,
      eComMta = 18,
      eCompositor = 19,
      eConvolverworker = 20,
      eCookie = 21,
      eCubeboperation = 22,
      eDatachannelIo = 23,
      eDnsResolver = 24,
      eDomWorker = 25,
      eDomWorklet = 26,
      eDomcachethread = 27,
      eExtensionprotocolhandler = 28,
      eFontLoader = 29,
      eFontenumthread = 30,
      eFsBroker = 31,
      eGeckomain = 32,
      eGmpthread = 33,
      eGraphrunner = 34,
      eHrtfdatabaseldr = 35,
      eHtml5Parser = 36,
      eImagebridgechld = 37,
      eImageio = 38,
      eIndexeddb = 39,
      eInitfontlist = 40,
      eInotifyeventthread = 41,
      eIndexeddbIo = 42,
      eIpcIOChild = 43,
      eIpcIOParent = 44,
      eIpcLaunch = 45,
      eIpdlBackground = 46,
      eJsWatchdog = 47,
      eJumpList = 48,
      eLibwebrtcmodulethread = 49,
      eLinkMonitor = 50,
      eLsThread = 51,
      eMdnsService = 52,
      eMediacache = 53,
      eMediadecoderstatemachine = 54,
      eMediapdecoder = 55,
      eMediasupervisor = 56,
      eMediatimer = 57,
      eMediatrackgrph = 58,
      eMemorypoller = 59,
      eMozstorage = 60,
      eMtransport = 61,
      eNetlinkMonitor = 62,
      ePacerthread = 63,
      ePermission = 64,
      ePlayeventsound = 65,
      eProcesshangmon = 66,
      eProfilerchild = 67,
      eProxyresolution = 68,
      eQuotamanagerIo = 69,
      eRegisterfonts = 70,
      eRemotebackbuffer = 71,
      eRemotelzystream = 72,
      eRemvidchild = 73,
      eRenderer = 74,
      eSandboxreporter = 75,
      eSavescripts = 76,
      eSocketThread = 77,
      eSoftwarevsyncthread = 78,
      eSqldbContentPrefsSqlite = 79,
      eSqldbCookiesSqlite = 80,
      eSqldbFormhistorySqlite = 81,
      eSslCert = 82,
      eStartupcache = 83,
      eStreamtrans = 84,
      eStylethread = 85,
      eSwcomposite = 86,
      eTaskcontroller = 87,
      eTimer = 88,
      eToastbgthread = 89,
      eTrrBackground = 90,
      eUntrustedModules = 91,
      eUrlClassifier = 92,
      eVideocapture = 93,
      eVsynciothread = 94,
      eWebrtccallthread = 95,
      eWebrtcworker = 96,
      eWincompositor = 97,
      eWindowsvsyncthread = 98,
      eWinwindowocclusioncalc = 99,
      eWifiTickler = 100,
      eWorkerLauncher = 101,
      eWrrenderbackend = 102,
      eWrscenebuilder = 103,
      eWrscenebuilderlp = 104,
      eWrworker = 105,
      eWrworkerlp = 106,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ParentActiveLabel> parent_active(4350);

  /**
   * generated from power.wakeups_per_thread.parent_inactive
   */
  enum class ParentInactiveLabel: uint16_t {
      eAndroidui = 0,
      eAsynclogger = 1,
      eAudioipc = 2,
      eAudioipcCallbackRpc = 3,
      eAudioipcClientCallback = 4,
      eAudioipcClientRpc = 5,
      eAudioipcDevicecollectionRpc = 6,
      eAudioipcServerCallback = 7,
      eAudioipcServerRpc = 8,
      eBackgroundthreadpool = 9,
      eBgiothreadpool = 10,
      eBgreadurls = 11,
      eBhmgrMonitor = 12,
      eBhmgrProcessor = 13,
      eCamerasIpc = 14,
      eCanvasrenderer = 15,
      eCapturethread = 16,
      eClassifierUpdate = 17,
      eComMta = 18,
      eCompositor = 19,
      eConvolverworker = 20,
      eCookie = 21,
      eCubeboperation = 22,
      eDatachannelIo = 23,
      eDnsResolver = 24,
      eDomWorker = 25,
      eDomWorklet = 26,
      eDomcachethread = 27,
      eExtensionprotocolhandler = 28,
      eFontLoader = 29,
      eFontenumthread = 30,
      eFsBroker = 31,
      eGeckomain = 32,
      eGmpthread = 33,
      eGraphrunner = 34,
      eHrtfdatabaseldr = 35,
      eHtml5Parser = 36,
      eImagebridgechld = 37,
      eImageio = 38,
      eIndexeddb = 39,
      eInitfontlist = 40,
      eInotifyeventthread = 41,
      eIndexeddbIo = 42,
      eIpcIOChild = 43,
      eIpcIOParent = 44,
      eIpcLaunch = 45,
      eIpdlBackground = 46,
      eJsWatchdog = 47,
      eJumpList = 48,
      eLibwebrtcmodulethread = 49,
      eLinkMonitor = 50,
      eLsThread = 51,
      eMdnsService = 52,
      eMediacache = 53,
      eMediadecoderstatemachine = 54,
      eMediapdecoder = 55,
      eMediasupervisor = 56,
      eMediatimer = 57,
      eMediatrackgrph = 58,
      eMemorypoller = 59,
      eMozstorage = 60,
      eMtransport = 61,
      eNetlinkMonitor = 62,
      ePacerthread = 63,
      ePermission = 64,
      ePlayeventsound = 65,
      eProcesshangmon = 66,
      eProfilerchild = 67,
      eProxyresolution = 68,
      eQuotamanagerIo = 69,
      eRegisterfonts = 70,
      eRemotebackbuffer = 71,
      eRemotelzystream = 72,
      eRemvidchild = 73,
      eRenderer = 74,
      eSandboxreporter = 75,
      eSavescripts = 76,
      eSocketThread = 77,
      eSoftwarevsyncthread = 78,
      eSqldbContentPrefsSqlite = 79,
      eSqldbCookiesSqlite = 80,
      eSqldbFormhistorySqlite = 81,
      eSslCert = 82,
      eStartupcache = 83,
      eStreamtrans = 84,
      eStylethread = 85,
      eSwcomposite = 86,
      eTaskcontroller = 87,
      eTimer = 88,
      eToastbgthread = 89,
      eTrrBackground = 90,
      eUntrustedModules = 91,
      eUrlClassifier = 92,
      eVideocapture = 93,
      eVsynciothread = 94,
      eWebrtccallthread = 95,
      eWebrtcworker = 96,
      eWincompositor = 97,
      eWindowsvsyncthread = 98,
      eWinwindowocclusioncalc = 99,
      eWifiTickler = 100,
      eWorkerLauncher = 101,
      eWrrenderbackend = 102,
      eWrscenebuilder = 103,
      eWrscenebuilderlp = 104,
      eWrworker = 105,
      eWrworkerlp = 106,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ParentInactiveLabel> parent_inactive(4351);

}
namespace readermode {
  /**
   * generated from readermode.button_click
   */
    struct ButtonClickExtra {
      mozilla::Maybe<nsCString> label;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (label) {
          extraKeys.AppendElement()->AssignASCII("label");
          extraValues.EmplaceBack(label.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded any time a Reader Mode button is clicked. This event was
     * generated to correspond to the Legacy Telemetry event readermode.button#click.
   */
  constexpr impl::EventMetric<ButtonClickExtra> button_click(4352);

  /**
   * generated from readermode.view_off
   */
    struct ViewOffExtra {
      mozilla::Maybe<nsCString> readerTime;
      mozilla::Maybe<nsCString> scrollPosition;
      mozilla::Maybe<nsCString> subcategory;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (readerTime) {
          extraKeys.AppendElement()->AssignASCII("reader_time");
          extraValues.EmplaceBack(readerTime.value());
        }
        if (scrollPosition) {
          extraKeys.AppendElement()->AssignASCII("scroll_position");
          extraValues.EmplaceBack(scrollPosition.value());
        }
        if (subcategory) {
          extraKeys.AppendElement()->AssignASCII("subcategory");
          extraValues.EmplaceBack(subcategory.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded any time Reader Mode is turned on or off. This event was
     * generated to correspond to the Legacy Telemetry event readermode.view#off.
   */
  constexpr impl::EventMetric<ViewOffExtra> view_off(4353);

  /**
   * generated from readermode.view_on
   */
    struct ViewOnExtra {
      mozilla::Maybe<nsCString> readerTime;
      mozilla::Maybe<nsCString> scrollPosition;
      mozilla::Maybe<nsCString> subcategory;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (readerTime) {
          extraKeys.AppendElement()->AssignASCII("reader_time");
          extraValues.EmplaceBack(readerTime.value());
        }
        if (scrollPosition) {
          extraKeys.AppendElement()->AssignASCII("scroll_position");
          extraValues.EmplaceBack(scrollPosition.value());
        }
        if (subcategory) {
          extraKeys.AppendElement()->AssignASCII("subcategory");
          extraValues.EmplaceBack(subcategory.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is recorded any time Reader Mode is turned on or off. This event was
     * generated to correspond to the Legacy Telemetry event readermode.view#on.
   */
  constexpr impl::EventMetric<ViewOnExtra> view_on(4354);

}
namespace broken_site_report {
  /**
   * generated from broken_site_report.breakage_category
   */
  /**
   * An optional select-box choice (options may eventually change)
   */
  constexpr impl::StringMetric breakage_category(4355);

  /**
   * generated from broken_site_report.description
   */
  /**
   * An optional description of the site issue the user is experiencing. May contain
     * PII.
   */
  constexpr impl::TextMetric description(4356);

  /**
   * generated from broken_site_report.url
   */
  /**
   * The URL of the site being reported. May contain PII.
   */
  constexpr impl::UrlMetric url(4357);

}
namespace broken_site_report_browser_info_app {
  /**
   * generated from broken_site_report.browser_info.app.default_locales
   */
  /**
   * Locale strings, ie `["en-US", "en"]`
   */
  constexpr impl::StringListMetric default_locales(4358);

  /**
   * generated from broken_site_report.browser_info.app.default_useragent_string
   */
  /**
   * The default user-agent string of the browser
   */
  constexpr impl::TextMetric default_useragent_string(4359);

  /**
   * generated from broken_site_report.browser_info.app.fission_enabled
   */
  /**
   * Whether Fission is enabled
   */
  constexpr impl::BooleanMetric fission_enabled(4360);

}
namespace broken_site_report_browser_info_graphics {
  /**
   * generated from broken_site_report.browser_info.graphics.device_pixel_ratio
   */
  /**
   * A decimal number
   */
  constexpr impl::StringMetric device_pixel_ratio(4361);

  /**
   * generated from broken_site_report.browser_info.graphics.devices_json
   */
  /**
   * JSON array of objects with `vendorID` and `deviceID`. For instance,
     * `[{"vendorID":"0x000", "deviceID":"0x001"}]`
   */
  constexpr impl::TextMetric devices_json(4362);

  /**
   * generated from broken_site_report.browser_info.graphics.drivers_json
   */
  /**
   * JSON array of objects with `renderer` and `version`. For instance,
     * `[{"renderer":"demo", "version":"0.2"}]`
   */
  constexpr impl::TextMetric drivers_json(4363);

  /**
   * generated from broken_site_report.browser_info.graphics.features_json
   */
  /**
   * JSON object. For instance,
     * `{"WEBRENDER":"available","WEBRENDER_PARTIAL":"disabled (User disabled via
     * pref)"}`
   */
  constexpr impl::TextMetric features_json(4364);

  /**
   * generated from broken_site_report.browser_info.graphics.has_touch_screen
   */
  /**
   * Whether a touch screen was detected
   */
  constexpr impl::BooleanMetric has_touch_screen(4365);

  /**
   * generated from broken_site_report.browser_info.graphics.monitors_json
   */
  /**
   * JSON array of objects with `screenWidth`, 'screenHeight`, and `scale`. For
     * instance, `[{"screenWidth":3584,"screenHeight":2240,"scale":2}]`
   */
  constexpr impl::TextMetric monitors_json(4366);

}
namespace broken_site_report_browser_info_prefs {
  /**
   * generated from broken_site_report.browser_info.prefs.cookie_behavior
   */
  /**
   * Value of `network.cookie.cookieBehavior`
   */
  constexpr impl::QuantityMetric cookie_behavior(4367);

  /**
   * generated from broken_site_report.browser_info.prefs.forced_accelerated_layers
   */
  /**
   * Value of `layers.acceleration_force.enabled`
   */
  constexpr impl::BooleanMetric forced_accelerated_layers(4368);

  /**
   * generated from broken_site_report.browser_info.prefs.global_privacy_control_enabled
   */
  /**
   * Value of `privacy.globalprivacycontrol.enabled`
   */
  constexpr impl::BooleanMetric global_privacy_control_enabled(4369);

  /**
   * generated from broken_site_report.browser_info.prefs.installtrigger_enabled
   */
  /**
   * Value of `extensions.InstallTrigger.enabled`
   */
  constexpr impl::BooleanMetric installtrigger_enabled(4370);

  /**
   * generated from broken_site_report.browser_info.prefs.opaque_response_blocking
   */
  /**
   * Value of `browser.opaqueResponseBlocking`
   */
  constexpr impl::BooleanMetric opaque_response_blocking(4371);

  /**
   * generated from broken_site_report.browser_info.prefs.resist_fingerprinting_enabled
   */
  /**
   * Value of `privacy.resistFingerprinting`
   */
  constexpr impl::BooleanMetric resist_fingerprinting_enabled(4372);

  /**
   * generated from broken_site_report.browser_info.prefs.software_webrender
   */
  /**
   * Value of `gfx.webrender.software`
   */
  constexpr impl::BooleanMetric software_webrender(4373);

  /**
   * generated from broken_site_report.browser_info.prefs.third_party_cookie_blocking_enabled
   */
  /**
   * Value of `network.cookie.cookieBehavior.optInPartitioning`
   */
  constexpr impl::BooleanMetric third_party_cookie_blocking_enabled(4374);

  /**
   * generated from broken_site_report.browser_info.prefs.third_party_cookie_blocking_enabled_in_pbm
   */
  /**
   * Value of `network.cookie.cookieBehavior.optInPartitioning.pbmode`
   */
  constexpr impl::BooleanMetric third_party_cookie_blocking_enabled_in_pbm(4375);

}
namespace broken_site_report_browser_info_security {
  /**
   * generated from broken_site_report.browser_info.security.antispyware
   */
  /**
   * Which antispyware software was reported on this system.
   */
  constexpr impl::StringListMetric antispyware(4376);

  /**
   * generated from broken_site_report.browser_info.security.antivirus
   */
  /**
   * Which antivirus software was reported on this system.
   */
  constexpr impl::StringListMetric antivirus(4377);

  /**
   * generated from broken_site_report.browser_info.security.firewall
   */
  /**
   * Which firewall software was reported on this system.
   */
  constexpr impl::StringListMetric firewall(4378);

}
namespace broken_site_report_browser_info_system {
  /**
   * generated from broken_site_report.browser_info.system.is_tablet
   */
  /**
   * Whether the device is a tablet
   */
  constexpr impl::BooleanMetric is_tablet(4379);

  /**
   * generated from broken_site_report.browser_info.system.memory
   */
  /**
   * How many mb of RAM is reported for the system
   */
  constexpr impl::QuantityMetric memory(4380);

}
namespace broken_site_report_tab_info {
  /**
   * generated from broken_site_report.tab_info.languages
   */
  /**
   * The languages the site actually sees (may be overridden)
   */
  constexpr impl::StringListMetric languages(4381);

  /**
   * generated from broken_site_report.tab_info.useragent_string
   */
  /**
   * The userAgent the site actually sees (may be overridden)
   */
  constexpr impl::TextMetric useragent_string(4382);

}
namespace broken_site_report_tab_info_antitracking {
  /**
   * generated from broken_site_report.tab_info.antitracking.block_list
   */
  /**
   * Currently either `basic` or `strict`, may change in the future.
   */
  constexpr impl::StringMetric block_list(4383);

  /**
   * generated from broken_site_report.tab_info.antitracking.btp_has_purged_site
   */
  /**
   * Whether the site in the current tab has recently been purged by Bounce Tracking
     * Protection.
   */
  constexpr impl::BooleanMetric btp_has_purged_site(4384);

  /**
   * generated from broken_site_report.tab_info.antitracking.has_mixed_active_content_blocked
   */
  /**
   * Whether the reported tab has any blocked mixed active content
   */
  constexpr impl::BooleanMetric has_mixed_active_content_blocked(4385);

  /**
   * generated from broken_site_report.tab_info.antitracking.has_mixed_display_content_blocked
   */
  /**
   * Whether the reported tab has any blocked mixed display content
   */
  constexpr impl::BooleanMetric has_mixed_display_content_blocked(4386);

  /**
   * generated from broken_site_report.tab_info.antitracking.has_tracking_content_blocked
   */
  /**
   * Whether the reported tab has any blocked tracking content
   */
  constexpr impl::BooleanMetric has_tracking_content_blocked(4387);

  /**
   * generated from broken_site_report.tab_info.antitracking.is_private_browsing
   */
  /**
   * Whether the tab the user was on when reporting is in private browsing mode
   */
  constexpr impl::BooleanMetric is_private_browsing(4388);

}
namespace broken_site_report_tab_info_frameworks {
  /**
   * generated from broken_site_report.tab_info.frameworks.fastclick
   */
  /**
   * Whether the FastClick web library was detected on the original tab.
   */
  constexpr impl::BooleanMetric fastclick(4389);

  /**
   * generated from broken_site_report.tab_info.frameworks.marfeel
   */
  /**
   * Whether the Marfeel web framework was detected on the original tab.
   */
  constexpr impl::BooleanMetric marfeel(4390);

  /**
   * generated from broken_site_report.tab_info.frameworks.mobify
   */
  /**
   * Whether the Mobify web framework was detected on the original tab.
   */
  constexpr impl::BooleanMetric mobify(4391);

}
namespace webcompatreporting {
  /**
   * generated from webcompatreporting.opened
   */
    struct OpenedExtra {
      mozilla::Maybe<nsCString> source;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records the method for opening the webcompat reporting window.
   */
  constexpr impl::EventMetric<OpenedExtra> opened(4392);

  /**
   * generated from webcompatreporting.reason_dropdown
   */
    struct ReasonDropdownExtra {
      mozilla::Maybe<nsCString> setting;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (setting) {
          extraKeys.AppendElement()->AssignASCII("setting");
          extraValues.EmplaceBack(setting.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record whether the user has a dropdown enabled + whether the dropdown menu is
     * optional or mandatory.
   */
  constexpr impl::EventMetric<ReasonDropdownExtra> reason_dropdown(4393);

  /**
   * generated from webcompatreporting.send
   */
  /**
   * Recorded when a user selects the Send button to submit webcompat report data.
   */
  constexpr impl::EventMetric<NoExtraKeys> send(4394);

  /**
   * generated from webcompatreporting.send_more_info
   */
  /**
   * Recorded when a user clicks on the Send More Info link in the reporting UI The
     * user will be redirected to webcompat.com to submit a more comprehensive report.
     * (This is only enabled on beta/nightly/pre-release channels).
   */
  constexpr impl::EventMetric<NoExtraKeys> send_more_info(4395);

}
namespace characteristics {
  /**
   * generated from characteristics.any_pointer_type
   */
  /**
   * Union of pointers available. We apply union to determine if the user have both
     * coarse and fine pointer.
   */
  constexpr impl::QuantityMetric any_pointer_type(4396);

  /**
   * generated from characteristics.audio_channels
   */
  /**
   * Audio sampling rate
   */
  constexpr impl::QuantityMetric audio_channels(4397);

  /**
   * generated from characteristics.audio_fingerprint
   */
  /**
   * Audio fingerprint of the user. A float number multiplied by 10e7.
   */
  constexpr impl::QuantityMetric audio_fingerprint(4398);

  /**
   * generated from characteristics.audio_frames
   */
  /**
   * Audio frames
   */
  constexpr impl::QuantityMetric audio_frames(4399);

  /**
   * generated from characteristics.audio_rate
   */
  /**
   * Audio sampling rate
   */
  constexpr impl::QuantityMetric audio_rate(4400);

  /**
   * generated from characteristics.avail_height
   */
  /**
   * Available height property
   */
  constexpr impl::QuantityMetric avail_height(4401);

  /**
   * generated from characteristics.avail_width
   */
  /**
   * Available width property
   */
  constexpr impl::QuantityMetric avail_width(4402);

  /**
   * generated from characteristics.build_date
   */
  /**
   * Firefox build's build date in unix time
   */
  constexpr impl::QuantityMetric build_date(4403);

  /**
   * generated from characteristics.camera_count
   */
  /**
   * Number of cameras available on the device.
   */
  constexpr impl::QuantityMetric camera_count(4404);

  /**
   * generated from characteristics.canvas_feature_status
   */
  /**
   * Status of and failure id (if failed) of ACCELERATED_CANVAS2D feature
   */
  constexpr impl::StringMetric canvas_feature_status(4405);

  /**
   * generated from characteristics.canvasdata1
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a simple organge
     * box and used as a control image
   */
  constexpr impl::StringMetric canvasdata1(4406);

  /**
   * generated from characteristics.canvasdata10
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a font shipped
     * with Firefox rendered with italics, rotation, and shadow-blur.
   */
  constexpr impl::StringMetric canvasdata10(4407);

  /**
   * generated from characteristics.canvasdata10software
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a font shipped
     * with Firefox rendered with italics, rotation, and shadow-blur.
   */
  constexpr impl::StringMetric canvasdata10software(4408);

  /**
   * generated from characteristics.canvasdata11_webgl
   */
  /**
   * The sha1 hash of an image rendered on a WebGL canvas (instead of Canvas2D). IT
     * is a RGB gradient cube.
   */
  constexpr impl::StringMetric canvasdata11_webgl(4409);

  /**
   * generated from characteristics.canvasdata11_webglsoftware
   */
  /**
   * The sha1 hash of an image rendered on a WebGL canvas (instead of Canvas2D). IT
     * is a RGB gradient cube.
   */
  constexpr impl::StringMetric canvasdata11_webglsoftware(4410);

  /**
   * generated from characteristics.canvasdata12_fingerprintjs1
   */
  /**
   * The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs'
     * text canvas
   */
  constexpr impl::StringMetric canvasdata12_fingerprintjs1(4411);

  /**
   * generated from characteristics.canvasdata12_fingerprintjs1software
   */
  /**
   * The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs'
     * text canvas
   */
  constexpr impl::StringMetric canvasdata12_fingerprintjs1software(4412);

  /**
   * generated from characteristics.canvasdata13_fingerprintjs2
   */
  /**
   * The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs'
     * geometry canvas
   */
  constexpr impl::StringMetric canvasdata13_fingerprintjs2(4413);

  /**
   * generated from characteristics.canvasdata13_fingerprintjs2software
   */
  /**
   * The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs'
     * geometry canvas
   */
  constexpr impl::StringMetric canvasdata13_fingerprintjs2software(4414);

  /**
   * generated from characteristics.canvasdata1software
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a simple organge
     * box and used as a control image
   */
  constexpr impl::StringMetric canvasdata1software(4415);

  /**
   * generated from characteristics.canvasdata2
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a bordered triage,
     * and used to test point interpolation
   */
  constexpr impl::StringMetric canvasdata2(4416);

  /**
   * generated from characteristics.canvasdata2software
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a bordered triage,
     * and used to test point interpolation
   */
  constexpr impl::StringMetric canvasdata2software(4417);

  /**
   * generated from characteristics.canvasdata3
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a stretched
     * photographic image, used to test image operations.
   */
  constexpr impl::StringMetric canvasdata3(4418);

  /**
   * generated from characteristics.canvasdata3software
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a stretched
     * photographic image, used to test image operations.
   */
  constexpr impl::StringMetric canvasdata3software(4419);

  /**
   * generated from characteristics.canvasdata4
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is two rotated, semi-
     * transparenct overlapping squares, used to test transparency and point
     * interpolation.
   */
  constexpr impl::StringMetric canvasdata4(4420);

  /**
   * generated from characteristics.canvasdata4software
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is two rotated, semi-
     * transparenct overlapping squares, used to test transparency and point
     * interpolation.
   */
  constexpr impl::StringMetric canvasdata4software(4421);

  /**
   * generated from characteristics.canvasdata5
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a local font
     * rendered normally.
   */
  constexpr impl::StringMetric canvasdata5(4422);

  /**
   * generated from characteristics.canvasdata5software
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a local font
     * rendered normally.
   */
  constexpr impl::StringMetric canvasdata5software(4423);

  /**
   * generated from characteristics.canvasdata6
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a local font
     * rendered with italics, rotation, and shadow-blur.
   */
  constexpr impl::StringMetric canvasdata6(4424);

  /**
   * generated from characteristics.canvasdata6software
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a local font
     * rendered with italics, rotation, and shadow-blur.
   */
  constexpr impl::StringMetric canvasdata6software(4425);

  /**
   * generated from characteristics.canvasdata7
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a system-ui font
     * rendered normally.
   */
  constexpr impl::StringMetric canvasdata7(4426);

  /**
   * generated from characteristics.canvasdata7software
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a system-ui font
     * rendered normally.
   */
  constexpr impl::StringMetric canvasdata7software(4427);

  /**
   * generated from characteristics.canvasdata8
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a system-ui font
     * rendered with italics, rotation, and shadow-blur.
   */
  constexpr impl::StringMetric canvasdata8(4428);

  /**
   * generated from characteristics.canvasdata8software
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a system-ui font
     * rendered with italics, rotation, and shadow-blur.
   */
  constexpr impl::StringMetric canvasdata8software(4429);

  /**
   * generated from characteristics.canvasdata9
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a font shipped
     * with Firefox rendered normally.
   */
  constexpr impl::StringMetric canvasdata9(4430);

  /**
   * generated from characteristics.canvasdata9software
   */
  /**
   * The sha1 hash of an image rendered on a canvas. The image is a font shipped
     * with Firefox rendered normally.
   */
  constexpr impl::StringMetric canvasdata9software(4431);

  /**
   * generated from characteristics.changed_media_prefs
   */
  /**
   * Changed media prefs and their values.
   */
  constexpr impl::StringMetric changed_media_prefs(4432);

  /**
   * generated from characteristics.channel
   */
  /**
   * Firefox build channel
   */
  constexpr impl::StringMetric channel(4433);

  /**
   * generated from characteristics.client_identifier
   */
  /**
   * A unique identifier for a user, not the same as the normal Telemetry client_id,
     * but needed so we can deduplicate reports and only take the most recent one per
     * user.
   */
  constexpr impl::UuidMetric client_identifier(4434);

  /**
   * generated from characteristics.color_accentcolor
   */
  /**
   * The CSS system-color Accentcolor.
   */
  constexpr impl::QuantityMetric color_accentcolor(4435);

  /**
   * generated from characteristics.color_accentcolortext
   */
  /**
   * The CSS system-color Accentcolortext.
   */
  constexpr impl::QuantityMetric color_accentcolortext(4436);

  /**
   * generated from characteristics.color_canvas
   */
  /**
   * The CSS system-color Canvas.
   */
  constexpr impl::QuantityMetric color_canvas(4437);

  /**
   * generated from characteristics.color_canvastext
   */
  /**
   * The CSS system-color Canvastext.
   */
  constexpr impl::QuantityMetric color_canvastext(4438);

  /**
   * generated from characteristics.color_depth
   */
  /**
   * The Color Depth reported by CSS
   */
  constexpr impl::QuantityMetric color_depth(4439);

  /**
   * generated from characteristics.color_gamut
   */
  /**
   * The Color Gamut reported by CSS
   */
  constexpr impl::QuantityMetric color_gamut(4440);

  /**
   * generated from characteristics.color_highlight
   */
  /**
   * The CSS system-color Highlight.
   */
  constexpr impl::QuantityMetric color_highlight(4441);

  /**
   * generated from characteristics.color_highlighttext
   */
  /**
   * The CSS system-color Highlighttext.
   */
  constexpr impl::QuantityMetric color_highlighttext(4442);

  /**
   * generated from characteristics.color_scheme
   */
  /**
   * The Color Scheme used for Content, from ContentPrefs() Preference Sheet.
   */
  constexpr impl::QuantityMetric color_scheme(4443);

  /**
   * generated from characteristics.color_selecteditem
   */
  /**
   * The CSS system-color Selecteditem.
   */
  constexpr impl::QuantityMetric color_selecteditem(4444);

  /**
   * generated from characteristics.color_selecteditemtext
   */
  /**
   * The CSS system-color Selecteditemtext.
   */
  constexpr impl::QuantityMetric color_selecteditemtext(4445);

  /**
   * generated from characteristics.cpu_model
   */
  /**
   * CPU model of the user's device
   */
  constexpr impl::StringMetric cpu_model(4446);

  /**
   * generated from characteristics.errors
   */
  /**
   * Errors occured on C++ side of data collection
   */
  constexpr impl::TextMetric errors(4447);

  /**
   * generated from characteristics.font_default_default_group
   */
  /**
   * The value of the font.default.<default language group> pref
   */
  constexpr impl::StringMetric font_default_default_group(4448);

  /**
   * generated from characteristics.font_default_modified
   */
  /**
   * The number of other modified font.default prefs.
   */
  constexpr impl::QuantityMetric font_default_modified(4449);

  /**
   * generated from characteristics.font_default_western
   */
  /**
   * The value of the font.default.x-western pref
   */
  constexpr impl::StringMetric font_default_western(4450);

  /**
   * generated from characteristics.font_minimum_size_default_group
   */
  /**
   * The value of the font.minimum-size.<default language group> pref
   */
  constexpr impl::StringMetric font_minimum_size_default_group(4451);

  /**
   * generated from characteristics.font_minimum_size_modified
   */
  /**
   * The number of other modified font.minimum-size prefs.
   */
  constexpr impl::QuantityMetric font_minimum_size_modified(4452);

  /**
   * generated from characteristics.font_minimum_size_western
   */
  /**
   * The value of the font.minimum-size.x-western pref
   */
  constexpr impl::StringMetric font_minimum_size_western(4453);

  /**
   * generated from characteristics.font_name_list_cursive_modified
   */
  /**
   * The number of modified font.name-list.cursive. prefs.
   */
  constexpr impl::QuantityMetric font_name_list_cursive_modified(4454);

  /**
   * generated from characteristics.font_name_list_emoji_modified
   */
  /**
   * Whether the pref font.name-list.emoji was modified.
   */
  constexpr impl::BooleanMetric font_name_list_emoji_modified(4455);

  /**
   * generated from characteristics.font_name_list_monospace_modified
   */
  /**
   * The number of modified font.name-list.monospace. prefs.
   */
  constexpr impl::QuantityMetric font_name_list_monospace_modified(4456);

  /**
   * generated from characteristics.font_name_list_sans_serif_modified
   */
  /**
   * The number of modified font.name-list.sans-serif. prefs.
   */
  constexpr impl::QuantityMetric font_name_list_sans_serif_modified(4457);

  /**
   * generated from characteristics.font_name_list_serif_modified
   */
  /**
   * The number of modified font.name-list.serif. prefs.
   */
  constexpr impl::QuantityMetric font_name_list_serif_modified(4458);

  /**
   * generated from characteristics.font_name_monospace_default_group
   */
  /**
   * The value of the font.name.monospace.<default language group> pref
   */
  constexpr impl::StringMetric font_name_monospace_default_group(4459);

  /**
   * generated from characteristics.font_name_monospace_modified
   */
  /**
   * The number of other modified font.name.monospace prefs.
   */
  constexpr impl::QuantityMetric font_name_monospace_modified(4460);

  /**
   * generated from characteristics.font_name_monospace_western
   */
  /**
   * The value of the font.name.monospace.x-western pref
   */
  constexpr impl::StringMetric font_name_monospace_western(4461);

  /**
   * generated from characteristics.font_name_sans_serif_default_group
   */
  /**
   * The value of the font.name.sans-serif.<default language group> pref
   */
  constexpr impl::StringMetric font_name_sans_serif_default_group(4462);

  /**
   * generated from characteristics.font_name_sans_serif_modified
   */
  /**
   * The number of other modified font.name.sans-serif prefs.
   */
  constexpr impl::QuantityMetric font_name_sans_serif_modified(4463);

  /**
   * generated from characteristics.font_name_sans_serif_western
   */
  /**
   * The value of the font.name.sans-serif.x-western pref
   */
  constexpr impl::StringMetric font_name_sans_serif_western(4464);

  /**
   * generated from characteristics.font_name_serif_default_group
   */
  /**
   * The value of the font.name.serif.<default language group> pref
   */
  constexpr impl::StringMetric font_name_serif_default_group(4465);

  /**
   * generated from characteristics.font_name_serif_modified
   */
  /**
   * The number of other modified font.name.serif prefs.
   */
  constexpr impl::QuantityMetric font_name_serif_modified(4466);

  /**
   * generated from characteristics.font_name_serif_western
   */
  /**
   * The value of the font.name.serif.x-western pref
   */
  constexpr impl::StringMetric font_name_serif_western(4467);

  /**
   * generated from characteristics.font_size_monospace_default_group
   */
  /**
   * The value of the font.size.monospace.<default language group> pref
   */
  constexpr impl::StringMetric font_size_monospace_default_group(4468);

  /**
   * generated from characteristics.font_size_monospace_modified
   */
  /**
   * The number of other modified font.size.monospace prefs.
   */
  constexpr impl::QuantityMetric font_size_monospace_modified(4469);

  /**
   * generated from characteristics.font_size_monospace_western
   */
  /**
   * The value of the font.size.monospace.x-western pref
   */
  constexpr impl::StringMetric font_size_monospace_western(4470);

  /**
   * generated from characteristics.font_size_variable_default_group
   */
  /**
   * The value of the font.size.variable.<default language group> pref
   */
  constexpr impl::StringMetric font_size_variable_default_group(4471);

  /**
   * generated from characteristics.font_size_variable_modified
   */
  /**
   * The number of other modified font.size.variable prefs.
   */
  constexpr impl::QuantityMetric font_size_variable_modified(4472);

  /**
   * generated from characteristics.font_size_variable_western
   */
  /**
   * The value of the font.size.variable.x-western pref
   */
  constexpr impl::StringMetric font_size_variable_western(4473);

  /**
   * generated from characteristics.gamepads
   */
  /**
   * The information of the gamepads inserted on the user device. Each string
     * represents one gamepad. We use a JSON array to describe a gamepad, every value
     * represents one property of the gamepad. Following are the details:
     *   index 0: The ID of the game pad
     *   index 1: Which hand for the gamepad.
     *   index 2: Number of buttons
     *   index 3: Number of axes
     *   index 4: Number of haptics
     *   index 5: Number of lights
     *   index 6: Number of touches
   */
  constexpr impl::StringListMetric gamepads(4474);

  /**
   * generated from characteristics.gl_context_type
   */
  /**
   * The type of the GL context (EGL, GLX, WGL, etc).
   */
  constexpr impl::StringMetric gl_context_type(4475);

  /**
   * generated from characteristics.gl_context_type_software
   */
  /**
   * The type of the GL context (EGL, GLX, WGL, etc).
   */
  constexpr impl::StringMetric gl_context_type_software(4476);

  /**
   * generated from characteristics.gl_extensions
   */
  /**
   * The list of OpenGL extensions supported by the user's system.
   */
  constexpr impl::TextMetric gl_extensions(4477);

  /**
   * generated from characteristics.gl_extensions_raw
   */
  /**
   * The raw list of OpenGL extensions supported by the user's system.
   */
  constexpr impl::TextMetric gl_extensions_raw(4478);

  /**
   * generated from characteristics.gl_extensions_raw_software
   */
  /**
   * The raw list of OpenGL extensions supported by the user's system.
   */
  constexpr impl::TextMetric gl_extensions_raw_software(4479);

  /**
   * generated from characteristics.gl_extensions_software
   */
  /**
   * The list of OpenGL extensions supported by the user's system.
   */
  constexpr impl::TextMetric gl_extensions_software(4480);

  /**
   * generated from characteristics.gl_fragment_shader
   */
  /**
   * Hash of the transformed source of the fragment shader.
   */
  constexpr impl::StringMetric gl_fragment_shader(4481);

  /**
   * generated from characteristics.gl_fragment_shader_software
   */
  /**
   * Hash of the transformed source of the fragment shader.
   */
  constexpr impl::StringMetric gl_fragment_shader_software(4482);

  /**
   * generated from characteristics.gl_minimal_source
   */
  /**
   * Transformed source of the minimal shader.
   */
  constexpr impl::TextMetric gl_minimal_source(4483);

  /**
   * generated from characteristics.gl_minimal_source_software
   */
  /**
   * Transformed source of the minimal shader.
   */
  constexpr impl::TextMetric gl_minimal_source_software(4484);

  /**
   * generated from characteristics.gl_params_extensions
   */
  /**
   * The list of GL parameters of the extensions.
   */
  constexpr impl::TextMetric gl_params_extensions(4485);

  /**
   * generated from characteristics.gl_params_extensions_software
   */
  /**
   * The list of GL parameters of the extensions.
   */
  constexpr impl::TextMetric gl_params_extensions_software(4486);

  /**
   * generated from characteristics.gl_params_v1
   */
  /**
   * The list of GL parameters of GL1.
   */
  constexpr impl::TextMetric gl_params_v1(4487);

  /**
   * generated from characteristics.gl_params_v1_software
   */
  /**
   * The list of GL parameters of GL1.
   */
  constexpr impl::TextMetric gl_params_v1_software(4488);

  /**
   * generated from characteristics.gl_params_v2
   */
  /**
   * The list of GL parameters of GL2.
   */
  constexpr impl::TextMetric gl_params_v2(4489);

  /**
   * generated from characteristics.gl_params_v2_software
   */
  /**
   * The list of GL parameters of GL2.
   */
  constexpr impl::TextMetric gl_params_v2_software(4490);

  /**
   * generated from characteristics.gl_precision_fragment
   */
  /**
   * Precisions of the fragment shader.
   */
  constexpr impl::TextMetric gl_precision_fragment(4491);

  /**
   * generated from characteristics.gl_precision_fragment_software
   */
  /**
   * Precisions of the fragment shader.
   */
  constexpr impl::TextMetric gl_precision_fragment_software(4492);

  /**
   * generated from characteristics.gl_precision_vertex
   */
  /**
   * Precisions of the vertex shader.
   */
  constexpr impl::TextMetric gl_precision_vertex(4493);

  /**
   * generated from characteristics.gl_precision_vertex_software
   */
  /**
   * Precisions of the vertex shader.
   */
  constexpr impl::TextMetric gl_precision_vertex_software(4494);

  /**
   * generated from characteristics.gl_renderer
   */
  /**
   * The OpenGL renderer string.
   */
  constexpr impl::StringMetric gl_renderer(4495);

  /**
   * generated from characteristics.gl_renderer_raw
   */
  /**
   * The raw OpenGL renderer string.
   */
  constexpr impl::StringMetric gl_renderer_raw(4496);

  /**
   * generated from characteristics.gl_renderer_raw_software
   */
  /**
   * The raw OpenGL renderer string.
   */
  constexpr impl::StringMetric gl_renderer_raw_software(4497);

  /**
   * generated from characteristics.gl_renderer_software
   */
  /**
   * The OpenGL renderer string.
   */
  constexpr impl::StringMetric gl_renderer_software(4498);

  /**
   * generated from characteristics.gl_vendor
   */
  /**
   * The OpenGL vendor string.
   */
  constexpr impl::StringMetric gl_vendor(4499);

  /**
   * generated from characteristics.gl_vendor_raw
   */
  /**
   * The raw OpenGL vendor string.
   */
  constexpr impl::StringMetric gl_vendor_raw(4500);

  /**
   * generated from characteristics.gl_vendor_raw_software
   */
  /**
   * The raw OpenGL vendor string.
   */
  constexpr impl::StringMetric gl_vendor_raw_software(4501);

  /**
   * generated from characteristics.gl_vendor_software
   */
  /**
   * The OpenGL vendor string.
   */
  constexpr impl::StringMetric gl_vendor_software(4502);

  /**
   * generated from characteristics.gl_version
   */
  /**
   * The version of OpenGL supported by the user's system.
   */
  constexpr impl::QuantityMetric gl_version(4503);

  /**
   * generated from characteristics.gl_version_raw
   */
  /**
   * The raw OpenGL version string.
   */
  constexpr impl::StringMetric gl_version_raw(4504);

  /**
   * generated from characteristics.gl_version_raw_software
   */
  /**
   * The raw OpenGL version string.
   */
  constexpr impl::StringMetric gl_version_raw_software(4505);

  /**
   * generated from characteristics.gl_version_software
   */
  /**
   * The version of OpenGL supported by the user's system.
   */
  constexpr impl::QuantityMetric gl_version_software(4506);

  /**
   * generated from characteristics.gl_vertex_shader
   */
  /**
   * Hash of the transformed source of the vertex shader.
   */
  constexpr impl::StringMetric gl_vertex_shader(4507);

  /**
   * generated from characteristics.gl_vertex_shader_software
   */
  /**
   * Hash of the transformed source of the vertex shader.
   */
  constexpr impl::StringMetric gl_vertex_shader_software(4508);

  /**
   * generated from characteristics.group_count
   */
  /**
   * Number of device groups reported by the device.
   */
  constexpr impl::QuantityMetric group_count(4509);

  /**
   * generated from characteristics.group_count_wo_speakers
   */
  /**
   * Number of device groups without speakers reported by the device.
   */
  constexpr impl::QuantityMetric group_count_wo_speakers(4510);

  /**
   * generated from characteristics.ice_foundations
   */
  /**
   * Unique ICE foundations occurance count and the standard deviation of latencies
   */
  constexpr impl::TextMetric ice_foundations(4511);

  /**
   * generated from characteristics.ice_order
   */
  /**
   * Unique ICE foundations occurrence count
   */
  constexpr impl::QuantityMetric ice_order(4512);

  /**
   * generated from characteristics.ice_sd
   */
  /**
   * ICE foundation discovery latency standard deviation sum multiplied by 1000
   */
  constexpr impl::QuantityMetric ice_sd(4513);

  /**
   * generated from characteristics.inner_height
   */
  /**
   * Inner height of user's browser.
   */
  constexpr impl::QuantityMetric inner_height(4514);

  /**
   * generated from characteristics.inner_width
   */
  /**
   * Inner width of user's browser.
   */
  constexpr impl::QuantityMetric inner_width(4515);

  /**
   * generated from characteristics.intl_locale
   */
  /**
   * Locale information provided by Intl
   */
  constexpr impl::StringMetric intl_locale(4516);

  /**
   * generated from characteristics.inverted_colors
   */
  /**
   * What LookAndFeel(InvertedColors) reports.
   */
  constexpr impl::BooleanMetric inverted_colors(4517);

  /**
   * generated from characteristics.js_errors
   */
  /**
   * Errors occured on JavaScript side of data collection
   */
  constexpr impl::TextMetric js_errors(4518);

  /**
   * generated from characteristics.keyboard_layout
   */
  /**
   * Name of the current keyboard layout.
   */
  constexpr impl::StringMetric keyboard_layout(4519);

  /**
   * generated from characteristics.languages
   */
  /**
   * Languages the user set. Returns intl.accept_languages pref, if it is empty,
     * returns the first matched OS's language or the default language.
   */
  constexpr impl::StringMetric languages(4520);

  /**
   * generated from characteristics.math_ops
   */
  /**
   * Result of fingerprintable math operations
   */
  constexpr impl::TextMetric math_ops(4521);

  /**
   * generated from characteristics.mathml1
   */
  /**
   * Width of the drawn MathML element
   */
  constexpr impl::QuantityMetric mathml1(4522);

  /**
   * generated from characteristics.mathml10
   */
  /**
   * Width of the drawn MathML element
   */
  constexpr impl::QuantityMetric mathml10(4523);

  /**
   * generated from characteristics.mathml2
   */
  /**
   * Width of the drawn MathML element
   */
  constexpr impl::QuantityMetric mathml2(4524);

  /**
   * generated from characteristics.mathml3
   */
  /**
   * Width of the drawn MathML element
   */
  constexpr impl::QuantityMetric mathml3(4525);

  /**
   * generated from characteristics.mathml4
   */
  /**
   * Width of the drawn MathML element
   */
  constexpr impl::QuantityMetric mathml4(4526);

  /**
   * generated from characteristics.mathml5
   */
  /**
   * Width of the drawn MathML element
   */
  constexpr impl::QuantityMetric mathml5(4527);

  /**
   * generated from characteristics.mathml6
   */
  /**
   * Width of the drawn MathML element
   */
  constexpr impl::QuantityMetric mathml6(4528);

  /**
   * generated from characteristics.mathml7
   */
  /**
   * Width of the drawn MathML element
   */
  constexpr impl::QuantityMetric mathml7(4529);

  /**
   * generated from characteristics.mathml8
   */
  /**
   * Width of the drawn MathML element
   */
  constexpr impl::QuantityMetric mathml8(4530);

  /**
   * generated from characteristics.mathml9
   */
  /**
   * Width of the drawn MathML element
   */
  constexpr impl::QuantityMetric mathml9(4531);

  /**
   * generated from characteristics.max_touch_points
   */
  /**
   * The number of touch points we will report to the web. On Android, this is based
     * on Android's FEATURE_TOUCHSCREEN* constants - Mozilla caps this at 5 as Android
     * stops distinguishing between numbers greater than 5.  On Windows this comes
     * from the SM_MAXIMUMTOUCHES System Metric.
   */
  constexpr impl::QuantityMetric max_touch_points(4532);

  /**
   * generated from characteristics.media_capabilities
   */
  /**
   * Which, if any, media types are not supported, and whether they can be run
     * smoothly and power-efficiently.
   */
  constexpr impl::TextMetric media_capabilities(4533);

  /**
   * generated from characteristics.media_capabilities_h264
   */
  /**
   * Levels of support for H264 codec.
   */
  constexpr impl::TextMetric media_capabilities_h264(4534);

  /**
   * generated from characteristics.media_capabilities_not_efficient
   */
  /**
   * Which, if any, media types are not power efficient.
   */
  constexpr impl::TextMetric media_capabilities_not_efficient(4535);

  /**
   * generated from characteristics.media_capabilities_not_smooth
   */
  /**
   * Which, if any, media types are not smooth.
   */
  constexpr impl::TextMetric media_capabilities_not_smooth(4536);

  /**
   * generated from characteristics.media_capabilities_unsupported
   */
  /**
   * Which, if any, media types are not supported.
   */
  constexpr impl::TextMetric media_capabilities_unsupported(4537);

  /**
   * generated from characteristics.media_devices
   */
  /**
   * A JSON object containing the number of audio input/output, video input and the
     * number of unique group ids.
   */
  constexpr impl::TextMetric media_devices(4538);

  /**
   * generated from characteristics.microphone_count
   */
  /**
   * Number of microphones available on the device.
   */
  constexpr impl::QuantityMetric microphone_count(4539);

  /**
   * generated from characteristics.missing_fonts
   */
  /**
   * If a Font List is available for the user's platform, this string_list contains
     * the fonts that are missing from the user's computer.
   */
  constexpr impl::TextMetric missing_fonts(4540);

  /**
   * generated from characteristics.monochrome
   */
  /**
   * Whether the user's device is monochrome
   */
  constexpr impl::BooleanMetric monochrome(4541);

  /**
   * generated from characteristics.motion_decimals
   */
  /**
   * devicemotion event's decimal places count
   */
  constexpr impl::QuantityMetric motion_decimals(4542);

  /**
   * generated from characteristics.motion_freq
   */
  /**
   * devicemotion event's frequency
   */
  constexpr impl::QuantityMetric motion_freq(4543);

  /**
   * generated from characteristics.orientation_angle
   */
  /**
   * Orientation angle of the screen
   */
  constexpr impl::QuantityMetric orientation_angle(4544);

  /**
   * generated from characteristics.orientation_decimals
   */
  /**
   * deviceorientation event's decimal places count
   */
  constexpr impl::QuantityMetric orientation_decimals(4545);

  /**
   * generated from characteristics.orientation_freq
   */
  /**
   * deviceorientation event's frequency
   */
  constexpr impl::QuantityMetric orientation_freq(4546);

  /**
   * generated from characteristics.orientationabs_decimals
   */
  /**
   * deviceorientationabsolute event's decimal places count
   */
  constexpr impl::QuantityMetric orientationabs_decimals(4547);

  /**
   * generated from characteristics.orientationabs_freq
   */
  /**
   * deviceorientationabsolute event's frequency
   */
  constexpr impl::QuantityMetric orientationabs_freq(4548);

  /**
   * generated from characteristics.os_name
   */
  /**
   * User's OS name
   */
  constexpr impl::StringMetric os_name(4549);

  /**
   * generated from characteristics.os_version
   */
  /**
   * User's OS version
   */
  constexpr impl::StringMetric os_version(4550);

  /**
   * generated from characteristics.oscpu
   */
  /**
   * User's OS CPU reported by the navigator
   */
  constexpr impl::StringMetric oscpu(4551);

  /**
   * generated from characteristics.outer_height
   */
  /**
   * Outer height of user's browser.
   */
  constexpr impl::QuantityMetric outer_height(4552);

  /**
   * generated from characteristics.outer_width
   */
  /**
   * Outer width of user's browser.
   */
  constexpr impl::QuantityMetric outer_width(4553);

  /**
   * generated from characteristics.pdf_viewer
   */
  /**
   * PDF viewer support reported by the navigator
   */
  constexpr impl::BooleanMetric pdf_viewer(4554);

  /**
   * generated from characteristics.pixel_depth
   */
  /**
   * Screen pixel depth property
   */
  constexpr impl::QuantityMetric pixel_depth(4555);

  /**
   * generated from characteristics.pixel_ratio
   */
  /**
   * The value of window.devicePixelRatio multiplied by 100 to include some of the
     * decimal places
   */
  constexpr impl::QuantityMetric pixel_ratio(4556);

  /**
   * generated from characteristics.platform
   */
  /**
   * Platform reported by the navigator
   */
  constexpr impl::StringMetric platform(4557);

  /**
   * generated from characteristics.pointer_height
   */
  /**
   * Height of user's pointer
   */
  constexpr impl::QuantityMetric pointer_height(4558);

  /**
   * generated from characteristics.pointer_pressure
   */
  /**
   * Pressure of user's pointer
   */
  constexpr impl::StringMetric pointer_pressure(4559);

  /**
   * generated from characteristics.pointer_tangentinal_pressure
   */
  /**
   * Tangential Pressure of user's pointer
   */
  constexpr impl::StringMetric pointer_tangentinal_pressure(4560);

  /**
   * generated from characteristics.pointer_tiltx
   */
  /**
   * TiltX of user's pointer
   */
  constexpr impl::QuantityMetric pointer_tiltx(4561);

  /**
   * generated from characteristics.pointer_tilty
   */
  /**
   * TiltY of user's pointer
   */
  constexpr impl::QuantityMetric pointer_tilty(4562);

  /**
   * generated from characteristics.pointer_twist
   */
  /**
   * Twist of user's pointer
   */
  constexpr impl::QuantityMetric pointer_twist(4563);

  /**
   * generated from characteristics.pointer_type
   */
  /**
   * Pointer type of the user's primary pointer device.
   */
  constexpr impl::QuantityMetric pointer_type(4564);

  /**
   * generated from characteristics.pointer_width
   */
  /**
   * Width of user's pointer
   */
  constexpr impl::QuantityMetric pointer_width(4565);

  /**
   * generated from characteristics.posx
   */
  /**
   * window.screen.left value. Provides us the position of the browser and the width
     * of any possible task/menu bar
   */
  constexpr impl::QuantityMetric posx(4566);

  /**
   * generated from characteristics.posy
   */
  /**
   * window.screen.top value. Provides us the position of the browser and the height
     * of any possible task/menu bar
   */
  constexpr impl::QuantityMetric posy(4567);

  /**
   * generated from characteristics.prefers_contrast
   */
  /**
   * What Gecko_MediaFeatures_PrefersContrast reports for a ContentDocument
   */
  constexpr impl::QuantityMetric prefers_contrast(4568);

  /**
   * generated from characteristics.prefers_reduced_motion
   */
  /**
   * What LookAndFeel(PrefersReducedMotion) reports.
   */
  constexpr impl::BooleanMetric prefers_reduced_motion(4569);

  /**
   * generated from characteristics.prefers_reduced_transparency
   */
  /**
   * What LookAndFeel(PrefersReducedTransparency) reports.
   */
  constexpr impl::BooleanMetric prefers_reduced_transparency(4570);

  /**
   * generated from characteristics.prefs_block_popups
   */
  /**
   * Block pop-up windows (The dom.disable_open_during_load pref)
   */
  constexpr impl::BooleanMetric prefs_block_popups(4571);

  /**
   * generated from characteristics.prefs_browser_display_use_document_fonts
   */
  /**
   * Allow pages to choose their own fonts.
   */
  constexpr impl::BooleanMetric prefs_browser_display_use_document_fonts(4572);

  /**
   * generated from characteristics.prefs_general_autoscroll
   */
  /**
   * Use autoscrolling
   */
  constexpr impl::BooleanMetric prefs_general_autoscroll(4573);

  /**
   * generated from characteristics.prefs_general_smoothscroll
   */
  /**
   * Use smooth scrolling
   */
  constexpr impl::BooleanMetric prefs_general_smoothscroll(4574);

  /**
   * generated from characteristics.prefs_intl_accept_languages
   */
  /**
   * Value of the intl.accept_languages pref.
   */
  constexpr impl::StringMetric prefs_intl_accept_languages(4575);

  /**
   * generated from characteristics.prefs_media_eme_enabled
   */
  /**
   * Value of the media.eme.enabled pref.
   */
  constexpr impl::BooleanMetric prefs_media_eme_enabled(4576);

  /**
   * generated from characteristics.prefs_network_cookie_cookiebehavior
   */
  /**
   * Value of the network.cookie.cookieBehavior pref.
   */
  constexpr impl::QuantityMetric prefs_network_cookie_cookiebehavior(4577);

  /**
   * generated from characteristics.prefs_overlay_scrollbars
   */
  /**
   * Use overlay scrollbars (or otherwise "Always show scrollbars")
   */
  constexpr impl::BooleanMetric prefs_overlay_scrollbars(4578);

  /**
   * generated from characteristics.prefs_privacy_donottrackheader_enabled
   */
  /**
   * Sending "do not track" HTTP header
   */
  constexpr impl::BooleanMetric prefs_privacy_donottrackheader_enabled(4579);

  /**
   * generated from characteristics.prefs_privacy_globalprivacycontrol_enabled
   */
  /**
   * Sending "global privacy control" HTTP header
   */
  constexpr impl::BooleanMetric prefs_privacy_globalprivacycontrol_enabled(4580);

  /**
   * generated from characteristics.prefs_zoom_text_only
   */
  /**
   * Text-only zoom enabled (vs. full-zoom)
   */
  constexpr impl::BooleanMetric prefs_zoom_text_only(4581);

  /**
   * generated from characteristics.processor_count
   */
  /**
   * Number of processors.
   */
  constexpr impl::QuantityMetric processor_count(4582);

  /**
   * generated from characteristics.scalings
   */
  /**
   * Screen(s) scaling/zoom level
   */
  constexpr impl::StringMetric scalings(4583);

  /**
   * generated from characteristics.screen_height
   */
  /**
   * Height of the primary screen in pixels.
   */
  constexpr impl::QuantityMetric screen_height(4584);

  /**
   * generated from characteristics.screen_orientation
   */
  /**
   * Orientation of the primary screen.
   */
  constexpr impl::QuantityMetric screen_orientation(4585);

  /**
   * generated from characteristics.screen_width
   */
  /**
   * Width of the primary screen in pixels.
   */
  constexpr impl::QuantityMetric screen_width(4586);

  /**
   * generated from characteristics.size_mode
   */
  /**
   * Whether window is maximized, minimized, normal or fullscreen
   */
  constexpr impl::QuantityMetric size_mode(4587);

  /**
   * generated from characteristics.speaker_count
   */
  /**
   * Number of speakers available on the device.
   */
  constexpr impl::QuantityMetric speaker_count(4588);

  /**
   * generated from characteristics.submission_schema
   */
  /**
   * An incrementing constant that represents the current schema/source of the data
     * present in a ping. By referring to this value in a ping, one can know for
     * certain the provenance of other data present in the ping, and what data may or
     * may not be present.
   */
  constexpr impl::QuantityMetric submission_schema(4589);

  /**
   * generated from characteristics.system_locale
   */
  /**
   * The locale used by the host OS for localization.
   */
  constexpr impl::StringMetric system_locale(4590);

  /**
   * generated from characteristics.target_frame_rate
   */
  /**
   * The target frame rate in frames-per-second.
   */
  constexpr impl::QuantityMetric target_frame_rate(4591);

  /**
   * generated from characteristics.text_anti_aliasing
   */
  /**
   * Font anti aliasing level
   */
  constexpr impl::StringMetric text_anti_aliasing(4592);

  /**
   * generated from characteristics.timezone
   */
  /**
   * The the current timezone of the system
   */
  constexpr impl::StringMetric timezone(4593);

  /**
   * generated from characteristics.touch_rotation_angle
   */
  /**
   * Rotation angle of user's touch
   */
  constexpr impl::StringMetric touch_rotation_angle(4594);

  /**
   * generated from characteristics.use_document_colors
   */
  /**
   * This is the derived PreferenceSheet::Prefs::mUseDocumentColors value.
   */
  constexpr impl::BooleanMetric use_document_colors(4595);

  /**
   * generated from characteristics.using_accelerated_canvas
   */
  /**
   * Whether the user's device is using accelerated canvas
   */
  constexpr impl::BooleanMetric using_accelerated_canvas(4596);

  /**
   * generated from characteristics.version
   */
  /**
   * Firefox build version
   */
  constexpr impl::StringMetric version(4597);

  /**
   * generated from characteristics.video_dynamic_range
   */
  /**
   * What LookAndFeel(VideoDynamicRange) reports. Note that CSSVideoDynamicRange has
     * an additional dependency on Color Depth.
   */
  constexpr impl::BooleanMetric video_dynamic_range(4598);

  /**
   * generated from characteristics.voices
   */
  /**
   * Available speechSynthesis voices.
   */
  constexpr impl::TextMetric voices(4599);

  /**
   * generated from characteristics.voices_all_ssdeep
   */
  /**
   * ssdeep hash of all speechSynthesis voices.
   */
  constexpr impl::StringMetric voices_all_ssdeep(4600);

  /**
   * generated from characteristics.voices_count
   */
  /**
   * Number of speechSynthesis voices available to the user.
   */
  constexpr impl::QuantityMetric voices_count(4601);

  /**
   * generated from characteristics.voices_default
   */
  /**
   * The default speechSynthesis voice.
   */
  constexpr impl::StringMetric voices_default(4602);

  /**
   * generated from characteristics.voices_local_count
   */
  /**
   * Number of local speechSynthesis voices available to the user.
   */
  constexpr impl::QuantityMetric voices_local_count(4603);

  /**
   * generated from characteristics.voices_local_ssdeep
   */
  /**
   * ssdeep hash of local speechSynthesis voices.
   */
  constexpr impl::StringMetric voices_local_ssdeep(4604);

  /**
   * generated from characteristics.voices_nonlocal_ssdeep
   */
  /**
   * ssdeep hash of non-local speechSynthesis voices.
   */
  constexpr impl::StringMetric voices_nonlocal_ssdeep(4605);

  /**
   * generated from characteristics.voices_sample
   */
  /**
   * Names of 5 sample speechSynthesis voices.
   */
  constexpr impl::TextMetric voices_sample(4606);

  /**
   * generated from characteristics.voices_sha1
   */
  /**
   * SHA1 hash of all the voices.
   */
  constexpr impl::TextMetric voices_sha1(4607);

  /**
   * generated from characteristics.webglinfo
   */
  /**
   * A JSON blob that contains information about the graphics hardware exposed by
     * WebGL.
   */
  constexpr impl::TextMetric webglinfo(4608);

  /**
   * generated from characteristics.zoom_count
   */
  /**
   * Number of domains the users has a non-default zoom level.
   */
  constexpr impl::QuantityMetric zoom_count(4609);

}
namespace fingerprinting_protection {
  /**
   * generated from fingerprinting.protection.canvas_noise_calculate_time_2
   */
  /**
   * Counts how long to generate canvas random noises.
   */
  constexpr impl::TimingDistributionMetric canvas_noise_calculate_time_2(4610);

}
namespace browser_searchinit {
  /**
   * generated from browser.searchinit.engine_invalid_webextension
   */
  /**
   * Records the WebExtension ID of a search engine where the WebExtension is not
     * installed (= 1), disabled (= 2), search engine no longer specified (= 4), a
     * different name (= 5), where the submission URL is different between the search
     * engine and the WebExtension (= 6). The value '3' has been replaced by '6' to
     * distinguish newer entries. This metric was generated to correspond to the
     * Legacy Telemetry scalar browser.searchinit.engine_invalid_webextension.
   */
  constexpr impl::Labeled<impl::QuantityMetric, DynamicLabel> engine_invalid_webextension(4611);

  /**
   * generated from browser.searchinit.insecure_opensearch_engine_count
   */
  /**
   * Records the number of insecure (i.e., using http) OpenSearch search engines a
     * given user has installed. This metric was generated to correspond to the Legacy
     * Telemetry scalar browser.searchinit.insecure_opensearch_engine_count.
   */
  constexpr impl::QuantityMetric insecure_opensearch_engine_count(4612);

  /**
   * generated from browser.searchinit.insecure_opensearch_update_count
   */
  /**
   * Records the number of OpenSearch search engines with insecure updates enabled
     * (i.e., using http) a given user has installed. This metric was generated to
     * correspond to the Legacy Telemetry scalar
     * browser.searchinit.insecure_opensearch_update_count.
   */
  constexpr impl::QuantityMetric insecure_opensearch_update_count(4613);

  /**
   * generated from browser.searchinit.secure_opensearch_engine_count
   */
  /**
   * Records the number of secure (i.e., using https) OpenSearch search engines a
     * given user has installed. This metric was generated to correspond to the Legacy
     * Telemetry scalar browser.searchinit.secure_opensearch_engine_count.
   */
  constexpr impl::QuantityMetric secure_opensearch_engine_count(4614);

  /**
   * generated from browser.searchinit.secure_opensearch_update_count
   */
  /**
   * Records the number of OpenSearch search engines with secure updates enabled
     * (i.e., using https) a given user has installed. This metric was generated to
     * correspond to the Legacy Telemetry scalar
     * browser.searchinit.secure_opensearch_update_count.
   */
  constexpr impl::QuantityMetric secure_opensearch_update_count(4615);

}
namespace search_engine_default {
  /**
   * generated from search.engine.default.changed
   */
    struct ChangedExtra {
      mozilla::Maybe<nsCString> changeSource;
      mozilla::Maybe<nsCString> newDisplayName;
      mozilla::Maybe<nsCString> newEngineId;
      mozilla::Maybe<nsCString> newLoadPath;
      mozilla::Maybe<nsCString> newSubmissionUrl;
      mozilla::Maybe<nsCString> previousEngineId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (changeSource) {
          extraKeys.AppendElement()->AssignASCII("change_source");
          extraValues.EmplaceBack(changeSource.value());
        }
        if (newDisplayName) {
          extraKeys.AppendElement()->AssignASCII("new_display_name");
          extraValues.EmplaceBack(newDisplayName.value());
        }
        if (newEngineId) {
          extraKeys.AppendElement()->AssignASCII("new_engine_id");
          extraValues.EmplaceBack(newEngineId.value());
        }
        if (newLoadPath) {
          extraKeys.AppendElement()->AssignASCII("new_load_path");
          extraValues.EmplaceBack(newLoadPath.value());
        }
        if (newSubmissionUrl) {
          extraKeys.AppendElement()->AssignASCII("new_submission_url");
          extraValues.EmplaceBack(newSubmissionUrl.value());
        }
        if (previousEngineId) {
          extraKeys.AppendElement()->AssignASCII("previous_engine_id");
          extraValues.EmplaceBack(previousEngineId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the default search engine is changed.
   */
  constexpr impl::EventMetric<ChangedExtra> changed(4616);

  /**
   * generated from search.engine.default.display_name
   */
  /**
   * The display name of the user's default engine.
   */
  constexpr impl::StringMetric display_name(4617);

  /**
   * generated from search.engine.default.engine_id
   */
  /**
   * The telemetry id of the search engine.
     * For application provided engines, this is either supplied by the
     * configuration or from the first part of the associated WebExtension Id.
     * For other engines, this is `other-<extensionName>`.
   */
  constexpr impl::StringMetric engine_id(4618);

  /**
   * generated from search.engine.default.load_path
   */
  /**
   * A path relating to where the search engine was installed/loaded from.
     * For example:
     *   `[addon]<extension id>` for a WebExtension based
     *   engine.
     *   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
     *   engine.
     * Note: this metric is truncated at 100 characters.
   */
  constexpr impl::StringMetric load_path(4619);

  /**
   * generated from search.engine.default.submission_url
   */
  /**
   * The submission URL of the default engine. This is only reported in the
     * cases where:
     *   The engine is an application provided engine.
     *   The engine has the same name as an application provided engine.
     *   The engine matches one of a specific list of well known search engines.
   */
  constexpr impl::UrlMetric submission_url(4620);

  /**
   * generated from search.engine.default.verified
   */
  /**
   * The verified status of the search engine.
     * For application provided engines, this will always be `default`.
     * For other engines this will either be `verified` or `unverified` depending
     * on if the loadPathHash is valid.
   */
  constexpr impl::StringMetric verified(4621);

}
namespace search_engine_private {
  /**
   * generated from search.engine.private.changed
   */
    struct ChangedExtra {
      mozilla::Maybe<nsCString> changeSource;
      mozilla::Maybe<nsCString> newDisplayName;
      mozilla::Maybe<nsCString> newEngineId;
      mozilla::Maybe<nsCString> newLoadPath;
      mozilla::Maybe<nsCString> newSubmissionUrl;
      mozilla::Maybe<nsCString> previousEngineId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (changeSource) {
          extraKeys.AppendElement()->AssignASCII("change_source");
          extraValues.EmplaceBack(changeSource.value());
        }
        if (newDisplayName) {
          extraKeys.AppendElement()->AssignASCII("new_display_name");
          extraValues.EmplaceBack(newDisplayName.value());
        }
        if (newEngineId) {
          extraKeys.AppendElement()->AssignASCII("new_engine_id");
          extraValues.EmplaceBack(newEngineId.value());
        }
        if (newLoadPath) {
          extraKeys.AppendElement()->AssignASCII("new_load_path");
          extraValues.EmplaceBack(newLoadPath.value());
        }
        if (newSubmissionUrl) {
          extraKeys.AppendElement()->AssignASCII("new_submission_url");
          extraValues.EmplaceBack(newSubmissionUrl.value());
        }
        if (previousEngineId) {
          extraKeys.AppendElement()->AssignASCII("previous_engine_id");
          extraValues.EmplaceBack(previousEngineId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the default search engine is changed
   */
  constexpr impl::EventMetric<ChangedExtra> changed(4622);

  /**
   * generated from search.engine.private.display_name
   */
  /**
   * The display name of the user's default engine.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
   */
  constexpr impl::StringMetric display_name(4623);

  /**
   * generated from search.engine.private.engine_id
   */
  /**
   * The telemetry id of the search engine.
     * For application provided engines, this is either supplied by the
     * configuration or from the first part of the associated WebExtension Id.
     * For other engines, this is `other-<extensionName>`.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
   */
  constexpr impl::StringMetric engine_id(4624);

  /**
   * generated from search.engine.private.load_path
   */
  /**
   * A path relating to where the search engine was installed/loaded from.
     * For example:
     *   `[addon]<extension id>` for a WebExtension based
     *   engine.
     *   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
     *   engine.
     * Note: this metric is truncated at 100 characters.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
   */
  constexpr impl::StringMetric load_path(4625);

  /**
   * generated from search.engine.private.submission_url
   */
  /**
   * The submission URL of the default engine. This is only reported in the
     * cases where:
     *   The engine is an application provided engine.
     *   The engine has the same name as an application provided engine.
     *   The engine matches one of a specific list of well known search engines.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
   */
  constexpr impl::UrlMetric submission_url(4626);

  /**
   * generated from search.engine.private.verified
   */
  /**
   * The verified status of the search engine.
     * For application provided engines, this will always be `default`.
     * For other engines this will either be `verified` or `unverified` depending
     * on if the loadPathHash is valid.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
   */
  constexpr impl::StringMetric verified(4627);

}
namespace search_service {
  /**
   * generated from search.service.initialization_status
   */
  enum class InitializationStatusLabel: uint16_t {
      eFailedsettings = 0,
      eFailedfetchengines = 1,
      eFailedloadengines = 2,
      eFailedloadsettingsaddonmanager = 3,
      eSuccess = 4,
      e__Other__,
    };
  /**
   * Counts the type of initialization statuses on start up.
     * failedSettings - failed loading and migrating the search settings file.
     * failedFetchEngines - failed to load or parse the configuration from remote
     *                      settings.
     * failedLoadEngines - failed to create all the search engines from the
     *                     configuration or user installed engines.
     * failedLoadSettingsAddonManager - the addon manager ready promise was rejected.
     * (from FF135)
     * success - search service successfully initialized.
   */
  constexpr impl::Labeled<impl::CounterMetric, InitializationStatusLabel> initialization_status(4628);

  /**
   * generated from search.service.startup_time
   */
  /**
   * The time duration it takes for the search service to start up.
   */
  constexpr impl::TimingDistributionMetric startup_time(4629);

}
namespace shopping_product {
  /**
   * generated from shopping_product.invalid_ohttp_config
   */
  /**
   * OHTTP was configured for shopping but the config is invalid.
   */
  constexpr impl::EventMetric<NoExtraKeys> invalid_ohttp_config(4630);

  /**
   * generated from shopping_product.invalid_request
   */
  /**
   * An invalid JSON request was sent to the Fakespot API.
   */
  constexpr impl::EventMetric<NoExtraKeys> invalid_request(4631);

  /**
   * generated from shopping_product.invalid_response
   */
  /**
   * An invalid JSON response was received from the Fakespot API.
   */
  constexpr impl::EventMetric<NoExtraKeys> invalid_response(4632);

  /**
   * generated from shopping_product.request_aborted
   */
  /**
   * Request to the Fakespot API was aborted.
   */
  constexpr impl::EventMetric<NoExtraKeys> request_aborted(4633);

  /**
   * generated from shopping_product.request_error
   */
  /**
   * There was an error requesting the Fakespot API.
   */
  constexpr impl::EventMetric<NoExtraKeys> request_error(4634);

  /**
   * generated from shopping_product.request_failure
   */
  /**
   * There was a failure with the request to the Fakespot API.
   */
  constexpr impl::EventMetric<NoExtraKeys> request_failure(4635);

  /**
   * generated from shopping_product.request_retried
   */
  /**
   * Status returned a 500 error when requesting the Fakespot API
     * and will be retried.
   */
  constexpr impl::EventMetric<NoExtraKeys> request_retried(4636);

  /**
   * generated from shopping_product.request_retries_failed
   */
  /**
   * Request still failed after the maxiumn number of
     * retry events.
   */
  constexpr impl::EventMetric<NoExtraKeys> request_retries_failed(4637);

  /**
   * generated from shopping_product.server_failure
   */
  /**
   * There was a Fakespot API server issue that prevented
     * the request from succeeding.
   */
  constexpr impl::EventMetric<NoExtraKeys> server_failure(4638);

}
namespace browser_timings {
  /**
   * generated from browser.timings.last_shutdown
   */
  /**
   * The time, in milliseconds, it took to complete the last shutdown. On successful
     * shutdown, Telemetry saves this to disk into Telemetry.ShutdownTime.txt. On the
     * next startup this is loaded and recorded. This metric was generated to
     * correspond to the Legacy Telemetry scalar browser.timings.last_shutdown.
   */
  constexpr impl::QuantityMetric last_shutdown(4639);

}
namespace legacy_telemetry {
  /**
   * generated from legacy.telemetry.client_id
   */
  /**
   * The client_id according to Telemetry.
     * Might not always have a value due to being too early for it to have
     * loaded.
     * Value may be the canary client id `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
     * in pings near when the data upload pref is disabled (if Telemetry gets
     * to go first), or between when a client_id has been removed and when it
     * has been regenerated.
     * Does not need to be sent in the Glean "deletion-request" ping.
   */
  constexpr impl::UuidMetric client_id(4640);

  /**
   * generated from legacy.telemetry.profile_group_id
   */
  /**
   * The profile_group_id according to Telemetry.
     * Might not always have a value due to being too early for it to have
     * loaded.
     * Does not need to be sent in the Glean "deletion-request" ping.
   */
  constexpr impl::UuidMetric profile_group_id(4641);

}
namespace telemetry {
  /**
   * generated from telemetry.clamping_time_hgrams
   */
  /**
   * How often do which histograms that use `Telemetry::AccumulateTimeDelta` have
     * clamped samples due to underflow?
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> clamping_time_hgrams(4642);

  /**
   * generated from telemetry.data_upload_optin
   */
  /**
   * User opted into sending Telemetry data again. This metric was generated to
     * correspond to the Legacy Telemetry scalar telemetry.data_upload_optin.
   */
  constexpr impl::BooleanMetric data_upload_optin(4643);

}
namespace usage {
  /**
   * generated from usage.profile_id
   */
  /**
   * A UUID uniquely identifying the profile,
     * not shared with other telemetry data.
   */
  constexpr impl::UuidMetric profile_id(4644);

}
namespace telemetry_test {
  /**
   * generated from telemetry.test.test1_object1
   */
    struct Test1Object1Extra {
      mozilla::Maybe<nsCString> key1;
      mozilla::Maybe<nsCString> key2;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (key1) {
          extraKeys.AppendElement()->AssignASCII("key1");
          extraValues.EmplaceBack(key1.value());
        }
        if (key2) {
          extraKeys.AppendElement()->AssignASCII("key2");
          extraValues.EmplaceBack(key2.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is a test entry for Telemetry. This event was generated to correspond to
     * the Legacy Telemetry event telemetry.test.test1#object1.
   */
  constexpr impl::EventMetric<Test1Object1Extra> test1_object1(4645);

  /**
   * generated from telemetry.test.test2_object1
   */
    struct Test2Object1Extra {
      mozilla::Maybe<nsCString> key1;
      mozilla::Maybe<nsCString> key2;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (key1) {
          extraKeys.AppendElement()->AssignASCII("key1");
          extraValues.EmplaceBack(key1.value());
        }
        if (key2) {
          extraKeys.AppendElement()->AssignASCII("key2");
          extraValues.EmplaceBack(key2.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is a test entry for Telemetry. This event was generated to correspond to
     * the Legacy Telemetry event telemetry.test.test2#object1.
   */
  constexpr impl::EventMetric<Test2Object1Extra> test2_object1(4646);

  /**
   * generated from telemetry.test.test2_object2
   */
    struct Test2Object2Extra {
      mozilla::Maybe<nsCString> key1;
      mozilla::Maybe<nsCString> key2;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (key1) {
          extraKeys.AppendElement()->AssignASCII("key1");
          extraValues.EmplaceBack(key1.value());
        }
        if (key2) {
          extraKeys.AppendElement()->AssignASCII("key2");
          extraValues.EmplaceBack(key2.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is a test entry for Telemetry. This event was generated to correspond to
     * the Legacy Telemetry event telemetry.test.test2#object2.
   */
  constexpr impl::EventMetric<Test2Object2Extra> test2_object2(4647);

}
namespace translations {
  /**
   * generated from translations.error
   */
    struct ErrorExtra {
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The specific translations error that caused a full_page translation failure.
   */
  constexpr impl::EventMetric<ErrorExtra> error(4648);

  /**
   * generated from translations.error_rate
   */
  /**
   * The rate of failed translations requests.
   */
  constexpr impl::NumeratorMetric error_rate(4649);

  /**
   * generated from translations.request_count
   */
  enum class RequestCountLabel: uint16_t {
      eFullPage = 0,
      eSelect = 1,
      e__Other__,
    };
  /**
   * The count of translation requests, along with their type.
   */
  constexpr impl::Labeled<impl::CounterMetric, RequestCountLabel> request_count(4650);

  /**
   * generated from translations.requests_count
   */
  /**
   * The count of translation requests.
   */
  constexpr impl::DenominatorMetric requests_count(4651);

  /**
   * generated from translations.restore_page
   */
    struct RestorePageExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the a restore-page event is triggered.
   */
  constexpr impl::EventMetric<RestorePageExtra> restore_page(4652);

  /**
   * generated from translations.translation_request
   */
    struct TranslationRequestExtra {
      mozilla::Maybe<bool> autoTranslate;
      mozilla::Maybe<nsCString> documentLanguage;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> fromLanguage;
      mozilla::Maybe<nsCString> requestTarget;
      mozilla::Maybe<uint32_t> sourceTextCodeUnits;
      mozilla::Maybe<uint32_t> sourceTextWordCount;
      mozilla::Maybe<nsCString> toLanguage;
      mozilla::Maybe<nsCString> topPreferredLanguage;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (autoTranslate) {
          extraKeys.AppendElement()->AssignASCII("auto_translate");
          extraValues.AppendElement()->AssignASCII(autoTranslate.value() ? "true" : "false");
        }
        if (documentLanguage) {
          extraKeys.AppendElement()->AssignASCII("document_language");
          extraValues.EmplaceBack(documentLanguage.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (fromLanguage) {
          extraKeys.AppendElement()->AssignASCII("from_language");
          extraValues.EmplaceBack(fromLanguage.value());
        }
        if (requestTarget) {
          extraKeys.AppendElement()->AssignASCII("request_target");
          extraValues.EmplaceBack(requestTarget.value());
        }
        if (sourceTextCodeUnits) {
          extraKeys.AppendElement()->AssignASCII("source_text_code_units");
          extraValues.EmplaceBack(nsPrintfCString("%d", sourceTextCodeUnits.value()));
        }
        if (sourceTextWordCount) {
          extraKeys.AppendElement()->AssignASCII("source_text_word_count");
          extraValues.EmplaceBack(nsPrintfCString("%d", sourceTextWordCount.value()));
        }
        if (toLanguage) {
          extraKeys.AppendElement()->AssignASCII("to_language");
          extraValues.EmplaceBack(toLanguage.value());
        }
        if (topPreferredLanguage) {
          extraKeys.AppendElement()->AssignASCII("top_preferred_language");
          extraValues.EmplaceBack(topPreferredLanguage.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when a full-page translation request is sent.
   */
  constexpr impl::EventMetric<TranslationRequestExtra> translation_request(4653);

}
namespace translations_about_translations_page {
  /**
   * generated from translations.about_translations_page.open
   */
    struct OpenExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the about-translations page is opened.
   */
  constexpr impl::EventMetric<OpenExtra> open(4654);

}
namespace translations_panel {
  /**
   * generated from translations.panel.about_translations
   */
    struct AboutTranslationsExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the about-translations menuitem is invoked in the full-page
     * translations panel settings.
   */
  constexpr impl::EventMetric<AboutTranslationsExtra> about_translations(4655);

  /**
   * generated from translations.panel.always_offer_translations
   */
    struct AlwaysOfferTranslationsExtra {
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<bool> toggledOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (toggledOn) {
          extraKeys.AppendElement()->AssignASCII("toggled_on");
          extraValues.AppendElement()->AssignASCII(toggledOn.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the always-offer-translations menuitem is invoked in the full-
     * page translations panel seeings.
   */
  constexpr impl::EventMetric<AlwaysOfferTranslationsExtra> always_offer_translations(4656);

  /**
   * generated from translations.panel.always_translate_language
   */
    struct AlwaysTranslateLanguageExtra {
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> language;
      mozilla::Maybe<bool> toggledOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (language) {
          extraKeys.AppendElement()->AssignASCII("language");
          extraValues.EmplaceBack(language.value());
        }
        if (toggledOn) {
          extraKeys.AppendElement()->AssignASCII("toggled_on");
          extraValues.AppendElement()->AssignASCII(toggledOn.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the always-translate-language menuitem is invoked in the full-
     * page translations panel settings.
   */
  constexpr impl::EventMetric<AlwaysTranslateLanguageExtra> always_translate_language(4657);

  /**
   * generated from translations.panel.cancel_button
   */
    struct CancelButtonExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the cancel button is invoked in the full-page translations panel.
   */
  constexpr impl::EventMetric<CancelButtonExtra> cancel_button(4658);

  /**
   * generated from translations.panel.change_from_language
   */
    struct ChangeFromLanguageExtra {
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> language;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (language) {
          extraKeys.AppendElement()->AssignASCII("language");
          extraValues.EmplaceBack(language.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the from-language selected value is changed.
   */
  constexpr impl::EventMetric<ChangeFromLanguageExtra> change_from_language(4659);

  /**
   * generated from translations.panel.change_source_language_button
   */
    struct ChangeSourceLanguageButtonExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the change-source-language button is invoked in the full-page
     * translations panel.
   */
  constexpr impl::EventMetric<ChangeSourceLanguageButtonExtra> change_source_language_button(4660);

  /**
   * generated from translations.panel.change_to_language
   */
    struct ChangeToLanguageExtra {
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> language;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (language) {
          extraKeys.AppendElement()->AssignASCII("language");
          extraValues.EmplaceBack(language.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the to-language selected value is changed.
   */
  constexpr impl::EventMetric<ChangeToLanguageExtra> change_to_language(4661);

  /**
   * generated from translations.panel.close
   */
    struct CloseExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when full-page translations panel is closed.
   */
  constexpr impl::EventMetric<CloseExtra> close(4662);

  /**
   * generated from translations.panel.close_from_language_menu
   */
    struct CloseFromLanguageMenuExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the from-language dropdown is closed in the full-page
     * translations panel.
   */
  constexpr impl::EventMetric<CloseFromLanguageMenuExtra> close_from_language_menu(4663);

  /**
   * generated from translations.panel.close_settings_menu
   */
    struct CloseSettingsMenuExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the settings menu is closed in the full-page translations panel.
   */
  constexpr impl::EventMetric<CloseSettingsMenuExtra> close_settings_menu(4664);

  /**
   * generated from translations.panel.close_to_language_menu
   */
    struct CloseToLanguageMenuExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the from-language dropdown is closed in the full-page
     * translations panel.
   */
  constexpr impl::EventMetric<CloseToLanguageMenuExtra> close_to_language_menu(4665);

  /**
   * generated from translations.panel.dismiss_error_button
   */
    struct DismissErrorButtonExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the dismiss-error button is invoked in the full-page translations
     * panel.
   */
  constexpr impl::EventMetric<DismissErrorButtonExtra> dismiss_error_button(4666);

  /**
   * generated from translations.panel.learn_more
   */
    struct LearnMoreExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the learn-more link is invoked in the full-page translations
     * panel first interaction.
   */
  constexpr impl::EventMetric<LearnMoreExtra> learn_more(4667);

  /**
   * generated from translations.panel.manage_languages
   */
    struct ManageLanguagesExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the manage-languages menuitem is invoked in the full-page
     * translations panel settings.
   */
  constexpr impl::EventMetric<ManageLanguagesExtra> manage_languages(4668);

  /**
   * generated from translations.panel.never_translate_language
   */
    struct NeverTranslateLanguageExtra {
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> language;
      mozilla::Maybe<bool> toggledOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (language) {
          extraKeys.AppendElement()->AssignASCII("language");
          extraValues.EmplaceBack(language.value());
        }
        if (toggledOn) {
          extraKeys.AppendElement()->AssignASCII("toggled_on");
          extraValues.AppendElement()->AssignASCII(toggledOn.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the never-translate-language menuitem is invoked in the full-page
     * translations panel settings.
   */
  constexpr impl::EventMetric<NeverTranslateLanguageExtra> never_translate_language(4669);

  /**
   * generated from translations.panel.never_translate_site
   */
    struct NeverTranslateSiteExtra {
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<bool> toggledOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (toggledOn) {
          extraKeys.AppendElement()->AssignASCII("toggled_on");
          extraValues.AppendElement()->AssignASCII(toggledOn.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the never-translate-site menuitem is invoked in the full-page
     * translations panel settings.
   */
  constexpr impl::EventMetric<NeverTranslateSiteExtra> never_translate_site(4670);

  /**
   * generated from translations.panel.open
   */
    struct OpenExtra {
      mozilla::Maybe<bool> autoShow;
      mozilla::Maybe<nsCString> documentLanguage;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> openedFrom;
      mozilla::Maybe<nsCString> viewName;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (autoShow) {
          extraKeys.AppendElement()->AssignASCII("auto_show");
          extraValues.AppendElement()->AssignASCII(autoShow.value() ? "true" : "false");
        }
        if (documentLanguage) {
          extraKeys.AppendElement()->AssignASCII("document_language");
          extraValues.EmplaceBack(documentLanguage.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (openedFrom) {
          extraKeys.AppendElement()->AssignASCII("opened_from");
          extraValues.EmplaceBack(openedFrom.value());
        }
        if (viewName) {
          extraKeys.AppendElement()->AssignASCII("view_name");
          extraValues.EmplaceBack(viewName.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the full-page translations panel is opened.
   */
  constexpr impl::EventMetric<OpenExtra> open(4671);

  /**
   * generated from translations.panel.open_from_language_menu
   */
    struct OpenFromLanguageMenuExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the from-language dropdown is opened in the full-page
     * translations panel.
   */
  constexpr impl::EventMetric<OpenFromLanguageMenuExtra> open_from_language_menu(4672);

  /**
   * generated from translations.panel.open_settings_menu
   */
    struct OpenSettingsMenuExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the settings menu is opened in the full-page translations panel.
   */
  constexpr impl::EventMetric<OpenSettingsMenuExtra> open_settings_menu(4673);

  /**
   * generated from translations.panel.open_to_language_menu
   */
    struct OpenToLanguageMenuExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the from-language dropdown is opened in the full-page
     * translations panel.
   */
  constexpr impl::EventMetric<OpenToLanguageMenuExtra> open_to_language_menu(4674);

  /**
   * generated from translations.panel.restore_page_button
   */
    struct RestorePageButtonExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the restore-page button is invoked in the full-page translations
     * panel.
   */
  constexpr impl::EventMetric<RestorePageButtonExtra> restore_page_button(4675);

  /**
   * generated from translations.panel.translate_button
   */
    struct TranslateButtonExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the translate button is invoked in the full-page translations
     * panel.
   */
  constexpr impl::EventMetric<TranslateButtonExtra> translate_button(4676);

}
namespace translations_select_translations_panel {
  /**
   * generated from translations.select_translations_panel.about_translations
   */
    struct AboutTranslationsExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the about-translations menuitem is invoked in the select
     * translations panel settings.
   */
  constexpr impl::EventMetric<AboutTranslationsExtra> about_translations(4677);

  /**
   * generated from translations.select_translations_panel.cancel_button
   */
    struct CancelButtonExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the cancel button is invoked in the select translations panel.
   */
  constexpr impl::EventMetric<CancelButtonExtra> cancel_button(4678);

  /**
   * generated from translations.select_translations_panel.change_from_language
   */
    struct ChangeFromLanguageExtra {
      mozilla::Maybe<nsCString> documentLanguage;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> language;
      mozilla::Maybe<nsCString> previousLanguage;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (documentLanguage) {
          extraKeys.AppendElement()->AssignASCII("document_language");
          extraValues.EmplaceBack(documentLanguage.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (language) {
          extraKeys.AppendElement()->AssignASCII("language");
          extraValues.EmplaceBack(language.value());
        }
        if (previousLanguage) {
          extraKeys.AppendElement()->AssignASCII("previous_language");
          extraValues.EmplaceBack(previousLanguage.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the from-language selected value is changed.
   */
  constexpr impl::EventMetric<ChangeFromLanguageExtra> change_from_language(4679);

  /**
   * generated from translations.select_translations_panel.change_to_language
   */
    struct ChangeToLanguageExtra {
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> language;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (language) {
          extraKeys.AppendElement()->AssignASCII("language");
          extraValues.EmplaceBack(language.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the to-language selected value is changed.
   */
  constexpr impl::EventMetric<ChangeToLanguageExtra> change_to_language(4680);

  /**
   * generated from translations.select_translations_panel.close
   */
    struct CloseExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the select translations panel is closed.
   */
  constexpr impl::EventMetric<CloseExtra> close(4681);

  /**
   * generated from translations.select_translations_panel.copy_button
   */
    struct CopyButtonExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the copy button is invoked in the select translations panel.
   */
  constexpr impl::EventMetric<CopyButtonExtra> copy_button(4682);

  /**
   * generated from translations.select_translations_panel.done_button
   */
    struct DoneButtonExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the done button is invoked in the select translations panel.
   */
  constexpr impl::EventMetric<DoneButtonExtra> done_button(4683);

  /**
   * generated from translations.select_translations_panel.initialization_failure_message
   */
    struct InitializationFailureMessageExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the initialization-failure message is shown in the select
     * translations panel.
   */
  constexpr impl::EventMetric<InitializationFailureMessageExtra> initialization_failure_message(4684);

  /**
   * generated from translations.select_translations_panel.open
   */
    struct OpenExtra {
      mozilla::Maybe<nsCString> documentLanguage;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> fromLanguage;
      mozilla::Maybe<nsCString> textSource;
      mozilla::Maybe<nsCString> toLanguage;
      mozilla::Maybe<nsCString> topPreferredLanguage;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (documentLanguage) {
          extraKeys.AppendElement()->AssignASCII("document_language");
          extraValues.EmplaceBack(documentLanguage.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (fromLanguage) {
          extraKeys.AppendElement()->AssignASCII("from_language");
          extraValues.EmplaceBack(fromLanguage.value());
        }
        if (textSource) {
          extraKeys.AppendElement()->AssignASCII("text_source");
          extraValues.EmplaceBack(textSource.value());
        }
        if (toLanguage) {
          extraKeys.AppendElement()->AssignASCII("to_language");
          extraValues.EmplaceBack(toLanguage.value());
        }
        if (topPreferredLanguage) {
          extraKeys.AppendElement()->AssignASCII("top_preferred_language");
          extraValues.EmplaceBack(topPreferredLanguage.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the select translations panel is opened.
   */
  constexpr impl::EventMetric<OpenExtra> open(4685);

  /**
   * generated from translations.select_translations_panel.open_settings_menu
   */
    struct OpenSettingsMenuExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the settings menu is opened in the select translations panel.
   */
  constexpr impl::EventMetric<OpenSettingsMenuExtra> open_settings_menu(4686);

  /**
   * generated from translations.select_translations_panel.translate_button
   */
    struct TranslateButtonExtra {
      mozilla::Maybe<nsCString> detectedLanguage;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> fromLanguage;
      mozilla::Maybe<nsCString> toLanguage;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (detectedLanguage) {
          extraKeys.AppendElement()->AssignASCII("detected_language");
          extraValues.EmplaceBack(detectedLanguage.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (fromLanguage) {
          extraKeys.AppendElement()->AssignASCII("from_language");
          extraValues.EmplaceBack(fromLanguage.value());
        }
        if (toLanguage) {
          extraKeys.AppendElement()->AssignASCII("to_language");
          extraValues.EmplaceBack(toLanguage.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the translate button is invoked in the select translations panel.
   */
  constexpr impl::EventMetric<TranslateButtonExtra> translate_button(4687);

  /**
   * generated from translations.select_translations_panel.translate_full_page_button
   */
    struct TranslateFullPageButtonExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the translate-full-page button is invoked in the select
     * translations panel.
   */
  constexpr impl::EventMetric<TranslateFullPageButtonExtra> translate_full_page_button(4688);

  /**
   * generated from translations.select_translations_panel.translation_failure_message
   */
    struct TranslationFailureMessageExtra {
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> fromLanguage;
      mozilla::Maybe<nsCString> toLanguage;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (fromLanguage) {
          extraKeys.AppendElement()->AssignASCII("from_language");
          extraValues.EmplaceBack(fromLanguage.value());
        }
        if (toLanguage) {
          extraKeys.AppendElement()->AssignASCII("to_language");
          extraValues.EmplaceBack(toLanguage.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the translation-failure message is shown in the select
     * translations panel.
   */
  constexpr impl::EventMetric<TranslationFailureMessageExtra> translation_failure_message(4689);

  /**
   * generated from translations.select_translations_panel.translation_settings
   */
    struct TranslationSettingsExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the translation-settings menuitem is invoked in the select
     * translations panel settings.
   */
  constexpr impl::EventMetric<TranslationSettingsExtra> translation_settings(4690);

  /**
   * generated from translations.select_translations_panel.try_again_button
   */
    struct TryAgainButtonExtra {
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the try-again button is invoked in the select translations panel.
   */
  constexpr impl::EventMetric<TryAgainButtonExtra> try_again_button(4691);

  /**
   * generated from translations.select_translations_panel.unsupported_language_message
   */
    struct UnsupportedLanguageMessageExtra {
      mozilla::Maybe<nsCString> detectedLanguage;
      mozilla::Maybe<nsCString> documentLanguage;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (detectedLanguage) {
          extraKeys.AppendElement()->AssignASCII("detected_language");
          extraValues.EmplaceBack(detectedLanguage.value());
        }
        if (documentLanguage) {
          extraKeys.AppendElement()->AssignASCII("document_language");
          extraValues.EmplaceBack(documentLanguage.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the unsupported-language message is shown in the select
     * translations panel.
   */
  constexpr impl::EventMetric<UnsupportedLanguageMessageExtra> unsupported_language_message(4692);

}
namespace findbar {
  /**
   * generated from findbar.find_next
   */
  /**
   * The count of how many times the find next button was used per session. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * findbar.find_next.
   */
  constexpr impl::CounterMetric find_next(4693);

  /**
   * generated from findbar.find_prev
   */
  /**
   * The count of how many times the find previous button was used per session. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * findbar.find_prev.
   */
  constexpr impl::CounterMetric find_prev(4694);

  /**
   * generated from findbar.highlight_all
   */
  /**
   * The count of how many times the "Highlight All" button was used in find
     * toolbar. This metric was generated to correspond to the Legacy Telemetry scalar
     * findbar.highlight_all.
   */
  constexpr impl::CounterMetric highlight_all(4695);

  /**
   * generated from findbar.match_case
   */
  /**
   * The count of how many times the "Match Case" button was used in find toolbar.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * findbar.match_case.
   */
  constexpr impl::CounterMetric match_case(4696);

  /**
   * generated from findbar.match_diacritics
   */
  /**
   * The count of how many times the "Match Diacritics" button was used in find
     * toolbar. This metric was generated to correspond to the Legacy Telemetry scalar
     * findbar.match_diacritics.
   */
  constexpr impl::CounterMetric match_diacritics(4697);

  /**
   * generated from findbar.shown
   */
  /**
   * The count of how many times the "Find toolbar" was shown per session. This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * findbar.shown.
   */
  constexpr impl::CounterMetric shown(4698);

  /**
   * generated from findbar.whole_words
   */
  /**
   * The count of how many times the "Whole Words" button was used in find toolbar.
     * This metric was generated to correspond to the Legacy Telemetry scalar
     * findbar.whole_words.
   */
  constexpr impl::CounterMetric whole_words(4699);

}
namespace security_doh_neterror {
  /**
   * generated from security.doh.neterror.click_add_exception_button
   */
    struct ClickAddExceptionButtonExtra {
      mozilla::Maybe<nsCString> mode;
      mozilla::Maybe<nsCString> providerKey;
      mozilla::Maybe<nsCString> skipReason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (mode) {
          extraKeys.AppendElement()->AssignASCII("mode");
          extraValues.EmplaceBack(mode.value());
        }
        if (providerKey) {
          extraKeys.AppendElement()->AssignASCII("provider_key");
          extraValues.EmplaceBack(providerKey.value());
        }
        if (skipReason) {
          extraKeys.AppendElement()->AssignASCII("skip_reason");
          extraValues.EmplaceBack(skipReason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click buttons on the DoH warning page. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.doh.neterror.click#add_exception_button.
   */
  constexpr impl::EventMetric<ClickAddExceptionButtonExtra> click_add_exception_button(4700);

  /**
   * generated from security.doh.neterror.click_continue_button
   */
    struct ClickContinueButtonExtra {
      mozilla::Maybe<nsCString> mode;
      mozilla::Maybe<nsCString> providerKey;
      mozilla::Maybe<nsCString> skipReason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (mode) {
          extraKeys.AppendElement()->AssignASCII("mode");
          extraValues.EmplaceBack(mode.value());
        }
        if (providerKey) {
          extraKeys.AppendElement()->AssignASCII("provider_key");
          extraValues.EmplaceBack(providerKey.value());
        }
        if (skipReason) {
          extraKeys.AppendElement()->AssignASCII("skip_reason");
          extraValues.EmplaceBack(skipReason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click buttons on the DoH warning page. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.doh.neterror.click#continue_button.
   */
  constexpr impl::EventMetric<ClickContinueButtonExtra> click_continue_button(4701);

  /**
   * generated from security.doh.neterror.click_disable_warning
   */
    struct ClickDisableWarningExtra {
      mozilla::Maybe<nsCString> mode;
      mozilla::Maybe<nsCString> providerKey;
      mozilla::Maybe<nsCString> skipReason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (mode) {
          extraKeys.AppendElement()->AssignASCII("mode");
          extraValues.EmplaceBack(mode.value());
        }
        if (providerKey) {
          extraKeys.AppendElement()->AssignASCII("provider_key");
          extraValues.EmplaceBack(providerKey.value());
        }
        if (skipReason) {
          extraKeys.AppendElement()->AssignASCII("skip_reason");
          extraValues.EmplaceBack(skipReason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click buttons on the DoH warning page. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.doh.neterror.click#disable_warning.
   */
  constexpr impl::EventMetric<ClickDisableWarningExtra> click_disable_warning(4702);

  /**
   * generated from security.doh.neterror.click_learn_more_link
   */
    struct ClickLearnMoreLinkExtra {
      mozilla::Maybe<nsCString> mode;
      mozilla::Maybe<nsCString> providerKey;
      mozilla::Maybe<nsCString> skipReason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (mode) {
          extraKeys.AppendElement()->AssignASCII("mode");
          extraValues.EmplaceBack(mode.value());
        }
        if (providerKey) {
          extraKeys.AppendElement()->AssignASCII("provider_key");
          extraValues.EmplaceBack(providerKey.value());
        }
        if (skipReason) {
          extraKeys.AppendElement()->AssignASCII("skip_reason");
          extraValues.EmplaceBack(skipReason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click buttons on the DoH warning page. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.doh.neterror.click#learn_more_link.
   */
  constexpr impl::EventMetric<ClickLearnMoreLinkExtra> click_learn_more_link(4703);

  /**
   * generated from security.doh.neterror.click_settings_button
   */
    struct ClickSettingsButtonExtra {
      mozilla::Maybe<nsCString> mode;
      mozilla::Maybe<nsCString> providerKey;
      mozilla::Maybe<nsCString> skipReason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (mode) {
          extraKeys.AppendElement()->AssignASCII("mode");
          extraValues.EmplaceBack(mode.value());
        }
        if (providerKey) {
          extraKeys.AppendElement()->AssignASCII("provider_key");
          extraValues.EmplaceBack(providerKey.value());
        }
        if (skipReason) {
          extraKeys.AppendElement()->AssignASCII("skip_reason");
          extraValues.EmplaceBack(skipReason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click buttons on the DoH warning page. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.doh.neterror.click#settings_button.
   */
  constexpr impl::EventMetric<ClickSettingsButtonExtra> click_settings_button(4704);

  /**
   * generated from security.doh.neterror.click_try_again_button
   */
    struct ClickTryAgainButtonExtra {
      mozilla::Maybe<nsCString> mode;
      mozilla::Maybe<nsCString> providerKey;
      mozilla::Maybe<nsCString> skipReason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (mode) {
          extraKeys.AppendElement()->AssignASCII("mode");
          extraValues.EmplaceBack(mode.value());
        }
        if (providerKey) {
          extraKeys.AppendElement()->AssignASCII("provider_key");
          extraValues.EmplaceBack(providerKey.value());
        }
        if (skipReason) {
          extraKeys.AppendElement()->AssignASCII("skip_reason");
          extraValues.EmplaceBack(skipReason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click buttons on the DoH warning page. This event was
     * generated to correspond to the Legacy Telemetry event
     * security.doh.neterror.click#try_again_button.
   */
  constexpr impl::EventMetric<ClickTryAgainButtonExtra> click_try_again_button(4705);

  /**
   * generated from security.doh.neterror.load_dohwarning
   */
    struct LoadDohwarningExtra {
      mozilla::Maybe<uint32_t> mode;
      mozilla::Maybe<nsCString> providerKey;
      mozilla::Maybe<nsCString> skipReason;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (mode) {
          extraKeys.AppendElement()->AssignASCII("mode");
          extraValues.EmplaceBack(nsPrintfCString("%d", mode.value()));
        }
        if (providerKey) {
          extraKeys.AppendElement()->AssignASCII("provider_key");
          extraValues.EmplaceBack(providerKey.value());
        }
        if (skipReason) {
          extraKeys.AppendElement()->AssignASCII("skip_reason");
          extraValues.EmplaceBack(skipReason.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The DoH warning page is loaded. This event was generated to correspond to the
     * Legacy Telemetry event security.doh.neterror.load#dohwarning.
   */
  constexpr impl::EventMetric<LoadDohwarningExtra> load_dohwarning(4706);

}
namespace security_ui_certerror {
  /**
   * generated from security.ui.certerror.click_advanced_button
   */
    struct ClickAdvancedButtonExtra {
      mozilla::Maybe<bool> hasSts;
      mozilla::Maybe<bool> isFrame;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasSts) {
          extraKeys.AppendElement()->AssignASCII("has_sts");
          extraValues.AppendElement()->AssignASCII(hasSts.value() ? "true" : "false");
        }
        if (isFrame) {
          extraKeys.AppendElement()->AssignASCII("is_frame");
          extraValues.AppendElement()->AssignASCII(isFrame.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the cert error page. Keyed by error code,
     * see https://searchfox.org/mozilla-
     * central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.certerror.click#advanced_button.
   */
  constexpr impl::EventMetric<ClickAdvancedButtonExtra> click_advanced_button(4707);

  /**
   * generated from security.ui.certerror.click_auto_report_cb
   */
    struct ClickAutoReportCbExtra {
      mozilla::Maybe<bool> hasSts;
      mozilla::Maybe<bool> isFrame;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasSts) {
          extraKeys.AppendElement()->AssignASCII("has_sts");
          extraValues.AppendElement()->AssignASCII(hasSts.value() ? "true" : "false");
        }
        if (isFrame) {
          extraKeys.AppendElement()->AssignASCII("is_frame");
          extraValues.AppendElement()->AssignASCII(isFrame.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the cert error page. Keyed by error code,
     * see https://searchfox.org/mozilla-
     * central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.certerror.click#auto_report_cb.
   */
  constexpr impl::EventMetric<ClickAutoReportCbExtra> click_auto_report_cb(4708);

  /**
   * generated from security.ui.certerror.click_clipboard_button_bot
   */
    struct ClickClipboardButtonBotExtra {
      mozilla::Maybe<bool> hasSts;
      mozilla::Maybe<bool> isFrame;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasSts) {
          extraKeys.AppendElement()->AssignASCII("has_sts");
          extraValues.AppendElement()->AssignASCII(hasSts.value() ? "true" : "false");
        }
        if (isFrame) {
          extraKeys.AppendElement()->AssignASCII("is_frame");
          extraValues.AppendElement()->AssignASCII(isFrame.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the cert error page. Keyed by error code,
     * see https://searchfox.org/mozilla-
     * central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.certerror.click#clipboard_button_bot.
   */
  constexpr impl::EventMetric<ClickClipboardButtonBotExtra> click_clipboard_button_bot(4709);

  /**
   * generated from security.ui.certerror.click_clipboard_button_top
   */
    struct ClickClipboardButtonTopExtra {
      mozilla::Maybe<bool> hasSts;
      mozilla::Maybe<bool> isFrame;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasSts) {
          extraKeys.AppendElement()->AssignASCII("has_sts");
          extraValues.AppendElement()->AssignASCII(hasSts.value() ? "true" : "false");
        }
        if (isFrame) {
          extraKeys.AppendElement()->AssignASCII("is_frame");
          extraValues.AppendElement()->AssignASCII(isFrame.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the cert error page. Keyed by error code,
     * see https://searchfox.org/mozilla-
     * central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.certerror.click#clipboard_button_top.
   */
  constexpr impl::EventMetric<ClickClipboardButtonTopExtra> click_clipboard_button_top(4710);

  /**
   * generated from security.ui.certerror.click_error_code_link
   */
    struct ClickErrorCodeLinkExtra {
      mozilla::Maybe<bool> hasSts;
      mozilla::Maybe<bool> isFrame;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasSts) {
          extraKeys.AppendElement()->AssignASCII("has_sts");
          extraValues.AppendElement()->AssignASCII(hasSts.value() ? "true" : "false");
        }
        if (isFrame) {
          extraKeys.AppendElement()->AssignASCII("is_frame");
          extraValues.AppendElement()->AssignASCII(isFrame.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the cert error page. Keyed by error code,
     * see https://searchfox.org/mozilla-
     * central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.certerror.click#error_code_link.
   */
  constexpr impl::EventMetric<ClickErrorCodeLinkExtra> click_error_code_link(4711);

  /**
   * generated from security.ui.certerror.click_exception_button
   */
    struct ClickExceptionButtonExtra {
      mozilla::Maybe<bool> hasSts;
      mozilla::Maybe<bool> isFrame;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasSts) {
          extraKeys.AppendElement()->AssignASCII("has_sts");
          extraValues.AppendElement()->AssignASCII(hasSts.value() ? "true" : "false");
        }
        if (isFrame) {
          extraKeys.AppendElement()->AssignASCII("is_frame");
          extraValues.AppendElement()->AssignASCII(isFrame.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the cert error page. Keyed by error code,
     * see https://searchfox.org/mozilla-
     * central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.certerror.click#exception_button.
   */
  constexpr impl::EventMetric<ClickExceptionButtonExtra> click_exception_button(4712);

  /**
   * generated from security.ui.certerror.click_learn_more_link
   */
    struct ClickLearnMoreLinkExtra {
      mozilla::Maybe<bool> hasSts;
      mozilla::Maybe<bool> isFrame;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasSts) {
          extraKeys.AppendElement()->AssignASCII("has_sts");
          extraValues.AppendElement()->AssignASCII(hasSts.value() ? "true" : "false");
        }
        if (isFrame) {
          extraKeys.AppendElement()->AssignASCII("is_frame");
          extraValues.AppendElement()->AssignASCII(isFrame.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the cert error page. Keyed by error code,
     * see https://searchfox.org/mozilla-
     * central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.certerror.click#learn_more_link.
   */
  constexpr impl::EventMetric<ClickLearnMoreLinkExtra> click_learn_more_link(4713);

  /**
   * generated from security.ui.certerror.click_return_button_adv
   */
    struct ClickReturnButtonAdvExtra {
      mozilla::Maybe<bool> hasSts;
      mozilla::Maybe<bool> isFrame;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasSts) {
          extraKeys.AppendElement()->AssignASCII("has_sts");
          extraValues.AppendElement()->AssignASCII(hasSts.value() ? "true" : "false");
        }
        if (isFrame) {
          extraKeys.AppendElement()->AssignASCII("is_frame");
          extraValues.AppendElement()->AssignASCII(isFrame.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the cert error page. Keyed by error code,
     * see https://searchfox.org/mozilla-
     * central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.certerror.click#return_button_adv.
   */
  constexpr impl::EventMetric<ClickReturnButtonAdvExtra> click_return_button_adv(4714);

  /**
   * generated from security.ui.certerror.click_return_button_top
   */
    struct ClickReturnButtonTopExtra {
      mozilla::Maybe<bool> hasSts;
      mozilla::Maybe<bool> isFrame;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasSts) {
          extraKeys.AppendElement()->AssignASCII("has_sts");
          extraValues.AppendElement()->AssignASCII(hasSts.value() ? "true" : "false");
        }
        if (isFrame) {
          extraKeys.AppendElement()->AssignASCII("is_frame");
          extraValues.AppendElement()->AssignASCII(isFrame.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on the cert error page. Keyed by error code,
     * see https://searchfox.org/mozilla-
     * central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.certerror.click#return_button_top.
   */
  constexpr impl::EventMetric<ClickReturnButtonTopExtra> click_return_button_top(4715);

  /**
   * generated from security.ui.certerror.load_aboutcerterror
   */
    struct LoadAboutcerterrorExtra {
      mozilla::Maybe<uint32_t> channelStatus;
      mozilla::Maybe<bool> hasSts;
      mozilla::Maybe<bool> isFrame;
      mozilla::Maybe<bool> issuedByCca;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (channelStatus) {
          extraKeys.AppendElement()->AssignASCII("channel_status");
          extraValues.EmplaceBack(nsPrintfCString("%d", channelStatus.value()));
        }
        if (hasSts) {
          extraKeys.AppendElement()->AssignASCII("has_sts");
          extraValues.AppendElement()->AssignASCII(hasSts.value() ? "true" : "false");
        }
        if (isFrame) {
          extraKeys.AppendElement()->AssignASCII("is_frame");
          extraValues.AppendElement()->AssignASCII(isFrame.value() ? "true" : "false");
        }
        if (issuedByCca) {
          extraKeys.AppendElement()->AssignASCII("issued_by_cca");
          extraValues.AppendElement()->AssignASCII(issuedByCca.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The about:certerror page is loaded, keyed by error code, see
     * https://searchfox.org/mozilla-
     * central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
     * generated to correspond to the Legacy Telemetry event
     * security.ui.certerror.load#aboutcerterror.
   */
  constexpr impl::EventMetric<LoadAboutcerterrorExtra> load_aboutcerterror(4716);

}
namespace security_ui_tlserror {
  /**
   * generated from security.ui.tlserror.load_abouttlserror
   */
    struct LoadAbouttlserrorExtra {
      mozilla::Maybe<uint32_t> channelStatus;
      mozilla::Maybe<bool> isFrame;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (channelStatus) {
          extraKeys.AppendElement()->AssignASCII("channel_status");
          extraValues.EmplaceBack(nsPrintfCString("%d", channelStatus.value()));
        }
        if (isFrame) {
          extraKeys.AppendElement()->AssignASCII("is_frame");
          extraValues.AppendElement()->AssignASCII(isFrame.value() ? "true" : "false");
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The about:neterror page is loaded with a TLS error or non- overridable
     * certificate error, keyed by error code. This event was generated to correspond
     * to the Legacy Telemetry event security.ui.tlserror.load#abouttlserror.
   */
  constexpr impl::EventMetric<LoadAbouttlserrorExtra> load_abouttlserror(4717);

}
namespace first_startup {
  /**
   * generated from first_startup.delete_tasks_time
   */
  /**
   * Number of milliseconds until TaskScheduler.deleteAllTasks resolved in
     * FirstStartup.
   */
  constexpr impl::QuantityMetric delete_tasks_time(4718);

  /**
   * generated from first_startup.elapsed
   */
  /**
   * Number of milliseconds the FirstStartup service took to run.
   */
  constexpr impl::QuantityMetric elapsed(4719);

  /**
   * generated from first_startup.new_profile
   */
  /**
   * True if FirstStartup was initted after a new profile was just created. If
     * false, this means that FirstStartup was initted with a pre-existing profile,
     * which is a no-op.
   */
  constexpr impl::BooleanMetric new_profile(4720);

  /**
   * generated from first_startup.normandy_init_time
   */
  /**
   * Number of milliseconds until Normandy.init resolved in FirstStartup.
   */
  constexpr impl::QuantityMetric normandy_init_time(4721);

  /**
   * generated from first_startup.status_code
   */
  /**
   * Status of the FirstStartup service, which runs
     * post-install/early-startup in Firefox.
   */
  constexpr impl::QuantityMetric status_code(4722);

}
namespace jsonfile {
  /**
   * generated from jsonfile.load_autofillprofiles
   */
    struct LoadAutofillprofilesExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records when JSONFile.sys.mjs consumers are trying to access a missing or
     * corrupt json file. For example, Login Store trying to access logins.json when
     * it has gone missing or corrupt. This event was generated to correspond to the
     * Legacy Telemetry event jsonfile.load#autofillprofiles.
   */
  constexpr impl::EventMetric<LoadAutofillprofilesExtra> load_autofillprofiles(4723);

  /**
   * generated from jsonfile.load_logins
   */
    struct LoadLoginsExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records when JSONFile.sys.mjs consumers are trying to access a missing or
     * corrupt json file. For example, Login Store trying to access logins.json when
     * it has gone missing or corrupt. This event was generated to correspond to the
     * Legacy Telemetry event jsonfile.load#logins.
   */
  constexpr impl::EventMetric<LoadLoginsExtra> load_logins(4724);

}
namespace mozstorage {
  /**
   * generated from mozstorage.sqlitejsm_transaction_timeout
   */
  /**
   * Collection of javascript modules that created a Sqlite.sys.mjs transaction
     * taking too long and timing out. This can be used to identify and optimize those
     * modules transactions. This metric was generated to correspond to the Legacy
     * Telemetry scalar mozstorage.sqlitejsm_transaction_timeout.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> sqlitejsm_transaction_timeout(4725);

}
namespace service_request {
  /**
   * generated from service_request.bypass_proxy_info
   */
    struct BypassProxyInfoExtra {
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> type;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (type) {
          extraKeys.AppendElement()->AssignASCII("type");
          extraValues.EmplaceBack(type.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This event is recorded by a small set of services when a proxy failure causes a
     * service to re-request with a proxy bypass.  It records some basic information
     * such as the type of proxy configuration, and the source of the proxy
     * configuration.  The value of the event is the name of the service that triggers
     * the event (e.g. telemetry, remote-settings). This event was generated to
     * correspond to the Legacy Telemetry event service_request.bypass#proxy_info.
   */
  constexpr impl::EventMetric<BypassProxyInfoExtra> bypass_proxy_info(4726);

}
namespace defaultagent {
  /**
   * generated from defaultagent.days_since_last_app_launch
   */
  /**
   * Number of days since the app last launched. Once this reaches 90 days, the
     * installation will stop running the default browser agent.
   */
  constexpr impl::QuantityMetric days_since_last_app_launch(4727);

}
namespace notification {
  /**
   * generated from notification.action
   */
  /**
   * The action that the user took in response to the notification. Possible values
     * currently include the following: * “dismissed-by-timeout” * “dismissed-to-
     * action-center” * “dismissed-by-button” * “dismissed-by-application-hidden” *
     * “make-firefox-default-button” * “toast-clicked”
     * Many of the values correspond to buttons on the notification and should be
     * pretty self explanatory, but a few are less so. * “dismissed-to-action-center”
     * will be used if the user clicks the arrow in
     *   the top right corner of the notification to dismiss it to the
     *   action center.
     * * “dismissed-by-application-hidden” is provided because that is a method of
     *   dismissal that the notification API could give but, in practice, should
     *   never be seen.
     * * “dismissed-by-timeout” indicates that the user did not interact with the
     *   notification and it timed out.
   */
  constexpr impl::StringMetric action(4728);

  /**
   * generated from notification.show_success
   */
  /**
   * Whether a notification was shown or not. Possible value include "shown" and
     * "error".
   */
  constexpr impl::BooleanMetric show_success(4729);

}
namespace system {
  /**
   * generated from system.os_version
   */
  /**
   * The current Windows OS version, usually as a dotted quad ("x.y.z.w") with
     * Windows Update Build Revision (UBR), but potentially as a dotted triple
     * ("x.y.z") without UBR.
   */
  constexpr impl::StringMetric os_version(4730);

  /**
   * generated from system.previous_os_version
   */
  /**
   * The Windows OS version before it was changed to the current setting. The
     * possible values are the same as for `system.os_version`.
     * The OS does not keep track of the previous OS version, so the agent records
     * this information itself. That means that it will be inaccurate until the first
     * time the default is changed after the agent task begins running. Before then,
     * the value of `previous_os_version` will be the same as `os_version`.
     * This value is updated every time the Default Agent runs, so when the default
     * browser is first changed the values for `os_version` and `previous_os_version`
     * will be different. But on subsequent executions of the Default Agent, the two
     * values will be the same.
   */
  constexpr impl::StringMetric previous_os_version(4731);

}
namespace system_default {
  /**
   * generated from system_default.browser
   */
  /**
   * Which browser is currently set as the system default web browser. This is
     * simply a string with the name of the browser binned to a fixed set of known
     * browsers.
     * Possible values currently include the following (from
     * [DefaultBrowser.cpp](https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/defaultagent/DefaultBrowser.cpp)): * "error" *
     * "" (unknown) * "firefox" * "chrome" * "edge" * "edge-chrome" * "ie" * "opera" *
     * "brave" * "yandex" * "qq-browser" * "360-browser" * "sogou" * "duckduckgo"
   */
  constexpr impl::StringMetric browser(4732);

  /**
   * generated from system_default.pdf_handler
   */
  /**
   * Which pdf handler is currently set as the system default handler. This is
     * simply a string with the name of the handler binned to a fixed set of known
     * handlers.
     * Possible values currently include the following (from
     * [DefaultPDF.cpp](https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/defaultagent/DefaultPDF.cpp)): * "Error" * ""
     * (unknown) * "Firefox" * "Microsoft Edge" * "Google Chrome" * "Adobe Acrobat" *
     * "WPS" * "Nitro" * "Foxit" * "PDF-XChange" * "Avast" * "Sumatra"
   */
  constexpr impl::StringMetric pdf_handler(4733);

  /**
   * generated from system_default.previous_browser
   */
  /**
   * Which browser was set as the system default before it was changed to the
     * current setting. The possible values are the same as for
     * `system_default.browser`.
     * The OS does not keep track of previous default settings, so the agent records
     * this information itself. That means that it will be inaccurate until the first
     * time the default is changed after the agent task begins running. Before then,
     * the value of `previous_browser` will be the same as `browser`.
     * This value is updated every time the Default Agent runs, so when the default
     * browser is first changed the values for `browser` and `previous_browser` will
     * be different. But on subsequent executions of the Default Agent, the two values
     * will be the same.
   */
  constexpr impl::StringMetric previous_browser(4734);

}
namespace addons_manager {
  /**
   * generated from addons_manager.install
   */
    struct InstallExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> addonType;
      mozilla::Maybe<uint32_t> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installId;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<uint32_t> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> sourceMethod;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (addonType) {
          extraKeys.AppendElement()->AssignASCII("addon_type");
          extraValues.EmplaceBack(addonType.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", downloadTime.value()));
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installId) {
          extraKeys.AppendElement()->AssignASCII("install_id");
          extraValues.EmplaceBack(installId.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(nsPrintfCString("%d", numStrings.value()));
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (sourceMethod) {
          extraKeys.AppendElement()->AssignASCII("source_method");
          extraValues.EmplaceBack(sourceMethod.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for
     * extensions and themes.
   */
  constexpr impl::EventMetric<InstallExtra> install(4735);

  /**
   * generated from addons_manager.install_stats
   */
    struct InstallStatsExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> addonType;
      mozilla::Maybe<nsCString> taarBased;
      mozilla::Maybe<nsCString> utmCampaign;
      mozilla::Maybe<nsCString> utmContent;
      mozilla::Maybe<nsCString> utmMedium;
      mozilla::Maybe<nsCString> utmSource;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (addonType) {
          extraKeys.AppendElement()->AssignASCII("addon_type");
          extraValues.EmplaceBack(addonType.value());
        }
        if (taarBased) {
          extraKeys.AppendElement()->AssignASCII("taar_based");
          extraValues.EmplaceBack(taarBased.value());
        }
        if (utmCampaign) {
          extraKeys.AppendElement()->AssignASCII("utm_campaign");
          extraValues.EmplaceBack(utmCampaign.value());
        }
        if (utmContent) {
          extraKeys.AppendElement()->AssignASCII("utm_content");
          extraValues.EmplaceBack(utmContent.value());
        }
        if (utmMedium) {
          extraKeys.AppendElement()->AssignASCII("utm_medium");
          extraValues.EmplaceBack(utmMedium.value());
        }
        if (utmSource) {
          extraKeys.AppendElement()->AssignASCII("utm_source");
          extraValues.EmplaceBack(utmSource.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded at the end of the install flow, but only
     * when the source that originally triggered the add-on installation
     * is "amo", "rtamo" or "disco".
   */
  constexpr impl::EventMetric<InstallStatsExtra> install_stats(4736);

  /**
   * generated from addons_manager.manage
   */
    struct ManageExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> addonType;
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<uint32_t> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> sourceMethod;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (addonType) {
          extraKeys.AppendElement()->AssignASCII("addon_type");
          extraValues.EmplaceBack(addonType.value());
        }
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(nsPrintfCString("%d", numStrings.value()));
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (sourceMethod) {
          extraKeys.AppendElement()->AssignASCII("source_method");
          extraValues.EmplaceBack(sourceMethod.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled.
   */
  constexpr impl::EventMetric<ManageExtra> manage(4737);

  /**
   * generated from addons_manager.report_suspicious_site
   */
    struct ReportSuspiciousSiteExtra {
      mozilla::Maybe<nsCString> suspiciousSite;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (suspiciousSite) {
          extraKeys.AppendElement()->AssignASCII("suspicious_site");
          extraValues.EmplaceBack(suspiciousSite.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when a user clicks "Report Suspicious Site" on the dropdown
     * menu of the third-party xpinstall doorhanger.
   */
  constexpr impl::EventMetric<ReportSuspiciousSiteExtra> report_suspicious_site(4738);

  /**
   * generated from addons_manager.update
   */
    struct UpdateExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> addonType;
      mozilla::Maybe<uint32_t> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installId;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<uint32_t> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> sourceMethod;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (addonType) {
          extraKeys.AppendElement()->AssignASCII("addon_type");
          extraValues.EmplaceBack(addonType.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", downloadTime.value()));
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installId) {
          extraKeys.AppendElement()->AssignASCII("install_id");
          extraValues.EmplaceBack(installId.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(nsPrintfCString("%d", numStrings.value()));
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (sourceMethod) {
          extraKeys.AppendElement()->AssignASCII("source_method");
          extraValues.EmplaceBack(sourceMethod.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for
     * extensions and themes.
   */
  constexpr impl::EventMetric<UpdateExtra> update(4739);

  /**
   * generated from addons_manager.disable_dictionary
   */
    struct DisableDictionaryExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.disable#dictionary.
   */
  constexpr impl::EventMetric<DisableDictionaryExtra> disable_dictionary(4740);

  /**
   * generated from addons_manager.disable_extension
   */
    struct DisableExtensionExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.disable#extension.
   */
  constexpr impl::EventMetric<DisableExtensionExtra> disable_extension(4741);

  /**
   * generated from addons_manager.disable_locale
   */
    struct DisableLocaleExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.disable#locale.
   */
  constexpr impl::EventMetric<DisableLocaleExtra> disable_locale(4742);

  /**
   * generated from addons_manager.disable_other
   */
    struct DisableOtherExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.disable#other.
   */
  constexpr impl::EventMetric<DisableOtherExtra> disable_other(4743);

  /**
   * generated from addons_manager.disable_siteperm_deprecated
   */
    struct DisableSitepermDeprecatedExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.disable#siteperm_deprecated.
   */
  constexpr impl::EventMetric<DisableSitepermDeprecatedExtra> disable_siteperm_deprecated(4744);

  /**
   * generated from addons_manager.disable_sitepermission
   */
    struct DisableSitepermissionExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.disable#sitepermission.
   */
  constexpr impl::EventMetric<DisableSitepermissionExtra> disable_sitepermission(4745);

  /**
   * generated from addons_manager.disable_theme
   */
    struct DisableThemeExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.disable#theme.
   */
  constexpr impl::EventMetric<DisableThemeExtra> disable_theme(4746);

  /**
   * generated from addons_manager.disable_unknown
   */
    struct DisableUnknownExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.disable#unknown.
   */
  constexpr impl::EventMetric<DisableUnknownExtra> disable_unknown(4747);

  /**
   * generated from addons_manager.enable_dictionary
   */
    struct EnableDictionaryExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.enable#dictionary.
   */
  constexpr impl::EventMetric<EnableDictionaryExtra> enable_dictionary(4748);

  /**
   * generated from addons_manager.enable_extension
   */
    struct EnableExtensionExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.enable#extension.
   */
  constexpr impl::EventMetric<EnableExtensionExtra> enable_extension(4749);

  /**
   * generated from addons_manager.enable_locale
   */
    struct EnableLocaleExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.enable#locale.
   */
  constexpr impl::EventMetric<EnableLocaleExtra> enable_locale(4750);

  /**
   * generated from addons_manager.enable_other
   */
    struct EnableOtherExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.enable#other.
   */
  constexpr impl::EventMetric<EnableOtherExtra> enable_other(4751);

  /**
   * generated from addons_manager.enable_siteperm_deprecated
   */
    struct EnableSitepermDeprecatedExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.enable#siteperm_deprecated.
   */
  constexpr impl::EventMetric<EnableSitepermDeprecatedExtra> enable_siteperm_deprecated(4752);

  /**
   * generated from addons_manager.enable_sitepermission
   */
    struct EnableSitepermissionExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.enable#sitepermission.
   */
  constexpr impl::EventMetric<EnableSitepermissionExtra> enable_sitepermission(4753);

  /**
   * generated from addons_manager.enable_theme
   */
    struct EnableThemeExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.enable#theme.
   */
  constexpr impl::EventMetric<EnableThemeExtra> enable_theme(4754);

  /**
   * generated from addons_manager.enable_unknown
   */
    struct EnableUnknownExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.enable#unknown.
   */
  constexpr impl::EventMetric<EnableUnknownExtra> enable_unknown(4755);

  /**
   * generated from addons_manager.install_dictionary
   */
    struct InstallDictionaryExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.install#dictionary.
   */
  constexpr impl::EventMetric<InstallDictionaryExtra> install_dictionary(4756);

  /**
   * generated from addons_manager.install_extension
   */
    struct InstallExtensionExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.install#extension.
   */
  constexpr impl::EventMetric<InstallExtensionExtra> install_extension(4757);

  /**
   * generated from addons_manager.install_locale
   */
    struct InstallLocaleExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.install#locale.
   */
  constexpr impl::EventMetric<InstallLocaleExtra> install_locale(4758);

  /**
   * generated from addons_manager.install_other
   */
    struct InstallOtherExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.install#other.
   */
  constexpr impl::EventMetric<InstallOtherExtra> install_other(4759);

  /**
   * generated from addons_manager.install_siteperm_deprecated
   */
    struct InstallSitepermDeprecatedExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.install#siteperm_deprecated.
   */
  constexpr impl::EventMetric<InstallSitepermDeprecatedExtra> install_siteperm_deprecated(4760);

  /**
   * generated from addons_manager.install_sitepermission
   */
    struct InstallSitepermissionExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.install#sitepermission.
   */
  constexpr impl::EventMetric<InstallSitepermissionExtra> install_sitepermission(4761);

  /**
   * generated from addons_manager.install_stats_dictionary
   */
    struct InstallStatsDictionaryExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> taarBased;
      mozilla::Maybe<nsCString> utmCampaign;
      mozilla::Maybe<nsCString> utmContent;
      mozilla::Maybe<nsCString> utmMedium;
      mozilla::Maybe<nsCString> utmSource;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (taarBased) {
          extraKeys.AppendElement()->AssignASCII("taar_based");
          extraValues.EmplaceBack(taarBased.value());
        }
        if (utmCampaign) {
          extraKeys.AppendElement()->AssignASCII("utm_campaign");
          extraValues.EmplaceBack(utmCampaign.value());
        }
        if (utmContent) {
          extraKeys.AppendElement()->AssignASCII("utm_content");
          extraValues.EmplaceBack(utmContent.value());
        }
        if (utmMedium) {
          extraKeys.AppendElement()->AssignASCII("utm_medium");
          extraValues.EmplaceBack(utmMedium.value());
        }
        if (utmSource) {
          extraKeys.AppendElement()->AssignASCII("utm_source");
          extraValues.EmplaceBack(utmSource.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded at the end of the install flow, but only when the
     * source that originally triggered the add-on installation is "amo", "rtamo" or
     * "disco". The value of an event is the SHA256 hash of the addon_id. This event
     * was generated to correspond to the Legacy Telemetry event
     * addonsManager.install_stats#dictionary.
   */
  constexpr impl::EventMetric<InstallStatsDictionaryExtra> install_stats_dictionary(4762);

  /**
   * generated from addons_manager.install_stats_extension
   */
    struct InstallStatsExtensionExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> taarBased;
      mozilla::Maybe<nsCString> utmCampaign;
      mozilla::Maybe<nsCString> utmContent;
      mozilla::Maybe<nsCString> utmMedium;
      mozilla::Maybe<nsCString> utmSource;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (taarBased) {
          extraKeys.AppendElement()->AssignASCII("taar_based");
          extraValues.EmplaceBack(taarBased.value());
        }
        if (utmCampaign) {
          extraKeys.AppendElement()->AssignASCII("utm_campaign");
          extraValues.EmplaceBack(utmCampaign.value());
        }
        if (utmContent) {
          extraKeys.AppendElement()->AssignASCII("utm_content");
          extraValues.EmplaceBack(utmContent.value());
        }
        if (utmMedium) {
          extraKeys.AppendElement()->AssignASCII("utm_medium");
          extraValues.EmplaceBack(utmMedium.value());
        }
        if (utmSource) {
          extraKeys.AppendElement()->AssignASCII("utm_source");
          extraValues.EmplaceBack(utmSource.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded at the end of the install flow, but only when the
     * source that originally triggered the add-on installation is "amo", "rtamo" or
     * "disco". The value of an event is the SHA256 hash of the addon_id. This event
     * was generated to correspond to the Legacy Telemetry event
     * addonsManager.install_stats#extension.
   */
  constexpr impl::EventMetric<InstallStatsExtensionExtra> install_stats_extension(4763);

  /**
   * generated from addons_manager.install_stats_locale
   */
    struct InstallStatsLocaleExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> taarBased;
      mozilla::Maybe<nsCString> utmCampaign;
      mozilla::Maybe<nsCString> utmContent;
      mozilla::Maybe<nsCString> utmMedium;
      mozilla::Maybe<nsCString> utmSource;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (taarBased) {
          extraKeys.AppendElement()->AssignASCII("taar_based");
          extraValues.EmplaceBack(taarBased.value());
        }
        if (utmCampaign) {
          extraKeys.AppendElement()->AssignASCII("utm_campaign");
          extraValues.EmplaceBack(utmCampaign.value());
        }
        if (utmContent) {
          extraKeys.AppendElement()->AssignASCII("utm_content");
          extraValues.EmplaceBack(utmContent.value());
        }
        if (utmMedium) {
          extraKeys.AppendElement()->AssignASCII("utm_medium");
          extraValues.EmplaceBack(utmMedium.value());
        }
        if (utmSource) {
          extraKeys.AppendElement()->AssignASCII("utm_source");
          extraValues.EmplaceBack(utmSource.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded at the end of the install flow, but only when the
     * source that originally triggered the add-on installation is "amo", "rtamo" or
     * "disco". The value of an event is the SHA256 hash of the addon_id. This event
     * was generated to correspond to the Legacy Telemetry event
     * addonsManager.install_stats#locale.
   */
  constexpr impl::EventMetric<InstallStatsLocaleExtra> install_stats_locale(4764);

  /**
   * generated from addons_manager.install_stats_other
   */
    struct InstallStatsOtherExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> taarBased;
      mozilla::Maybe<nsCString> utmCampaign;
      mozilla::Maybe<nsCString> utmContent;
      mozilla::Maybe<nsCString> utmMedium;
      mozilla::Maybe<nsCString> utmSource;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (taarBased) {
          extraKeys.AppendElement()->AssignASCII("taar_based");
          extraValues.EmplaceBack(taarBased.value());
        }
        if (utmCampaign) {
          extraKeys.AppendElement()->AssignASCII("utm_campaign");
          extraValues.EmplaceBack(utmCampaign.value());
        }
        if (utmContent) {
          extraKeys.AppendElement()->AssignASCII("utm_content");
          extraValues.EmplaceBack(utmContent.value());
        }
        if (utmMedium) {
          extraKeys.AppendElement()->AssignASCII("utm_medium");
          extraValues.EmplaceBack(utmMedium.value());
        }
        if (utmSource) {
          extraKeys.AppendElement()->AssignASCII("utm_source");
          extraValues.EmplaceBack(utmSource.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded at the end of the install flow, but only when the
     * source that originally triggered the add-on installation is "amo", "rtamo" or
     * "disco". The value of an event is the SHA256 hash of the addon_id. This event
     * was generated to correspond to the Legacy Telemetry event
     * addonsManager.install_stats#other.
   */
  constexpr impl::EventMetric<InstallStatsOtherExtra> install_stats_other(4765);

  /**
   * generated from addons_manager.install_stats_siteperm_deprecated
   */
    struct InstallStatsSitepermDeprecatedExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> taarBased;
      mozilla::Maybe<nsCString> utmCampaign;
      mozilla::Maybe<nsCString> utmContent;
      mozilla::Maybe<nsCString> utmMedium;
      mozilla::Maybe<nsCString> utmSource;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (taarBased) {
          extraKeys.AppendElement()->AssignASCII("taar_based");
          extraValues.EmplaceBack(taarBased.value());
        }
        if (utmCampaign) {
          extraKeys.AppendElement()->AssignASCII("utm_campaign");
          extraValues.EmplaceBack(utmCampaign.value());
        }
        if (utmContent) {
          extraKeys.AppendElement()->AssignASCII("utm_content");
          extraValues.EmplaceBack(utmContent.value());
        }
        if (utmMedium) {
          extraKeys.AppendElement()->AssignASCII("utm_medium");
          extraValues.EmplaceBack(utmMedium.value());
        }
        if (utmSource) {
          extraKeys.AppendElement()->AssignASCII("utm_source");
          extraValues.EmplaceBack(utmSource.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded at the end of the install flow, but only when the
     * source that originally triggered the add-on installation is "amo", "rtamo" or
     * "disco". The value of an event is the SHA256 hash of the addon_id. This event
     * was generated to correspond to the Legacy Telemetry event
     * addonsManager.install_stats#siteperm_deprecated.
   */
  constexpr impl::EventMetric<InstallStatsSitepermDeprecatedExtra> install_stats_siteperm_deprecated(4766);

  /**
   * generated from addons_manager.install_stats_sitepermission
   */
    struct InstallStatsSitepermissionExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> taarBased;
      mozilla::Maybe<nsCString> utmCampaign;
      mozilla::Maybe<nsCString> utmContent;
      mozilla::Maybe<nsCString> utmMedium;
      mozilla::Maybe<nsCString> utmSource;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (taarBased) {
          extraKeys.AppendElement()->AssignASCII("taar_based");
          extraValues.EmplaceBack(taarBased.value());
        }
        if (utmCampaign) {
          extraKeys.AppendElement()->AssignASCII("utm_campaign");
          extraValues.EmplaceBack(utmCampaign.value());
        }
        if (utmContent) {
          extraKeys.AppendElement()->AssignASCII("utm_content");
          extraValues.EmplaceBack(utmContent.value());
        }
        if (utmMedium) {
          extraKeys.AppendElement()->AssignASCII("utm_medium");
          extraValues.EmplaceBack(utmMedium.value());
        }
        if (utmSource) {
          extraKeys.AppendElement()->AssignASCII("utm_source");
          extraValues.EmplaceBack(utmSource.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded at the end of the install flow, but only when the
     * source that originally triggered the add-on installation is "amo", "rtamo" or
     * "disco". The value of an event is the SHA256 hash of the addon_id. This event
     * was generated to correspond to the Legacy Telemetry event
     * addonsManager.install_stats#sitepermission.
   */
  constexpr impl::EventMetric<InstallStatsSitepermissionExtra> install_stats_sitepermission(4767);

  /**
   * generated from addons_manager.install_stats_theme
   */
    struct InstallStatsThemeExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> taarBased;
      mozilla::Maybe<nsCString> utmCampaign;
      mozilla::Maybe<nsCString> utmContent;
      mozilla::Maybe<nsCString> utmMedium;
      mozilla::Maybe<nsCString> utmSource;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (taarBased) {
          extraKeys.AppendElement()->AssignASCII("taar_based");
          extraValues.EmplaceBack(taarBased.value());
        }
        if (utmCampaign) {
          extraKeys.AppendElement()->AssignASCII("utm_campaign");
          extraValues.EmplaceBack(utmCampaign.value());
        }
        if (utmContent) {
          extraKeys.AppendElement()->AssignASCII("utm_content");
          extraValues.EmplaceBack(utmContent.value());
        }
        if (utmMedium) {
          extraKeys.AppendElement()->AssignASCII("utm_medium");
          extraValues.EmplaceBack(utmMedium.value());
        }
        if (utmSource) {
          extraKeys.AppendElement()->AssignASCII("utm_source");
          extraValues.EmplaceBack(utmSource.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded at the end of the install flow, but only when the
     * source that originally triggered the add-on installation is "amo", "rtamo" or
     * "disco". The value of an event is the SHA256 hash of the addon_id. This event
     * was generated to correspond to the Legacy Telemetry event
     * addonsManager.install_stats#theme.
   */
  constexpr impl::EventMetric<InstallStatsThemeExtra> install_stats_theme(4768);

  /**
   * generated from addons_manager.install_stats_unknown
   */
    struct InstallStatsUnknownExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> taarBased;
      mozilla::Maybe<nsCString> utmCampaign;
      mozilla::Maybe<nsCString> utmContent;
      mozilla::Maybe<nsCString> utmMedium;
      mozilla::Maybe<nsCString> utmSource;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (taarBased) {
          extraKeys.AppendElement()->AssignASCII("taar_based");
          extraValues.EmplaceBack(taarBased.value());
        }
        if (utmCampaign) {
          extraKeys.AppendElement()->AssignASCII("utm_campaign");
          extraValues.EmplaceBack(utmCampaign.value());
        }
        if (utmContent) {
          extraKeys.AppendElement()->AssignASCII("utm_content");
          extraValues.EmplaceBack(utmContent.value());
        }
        if (utmMedium) {
          extraKeys.AppendElement()->AssignASCII("utm_medium");
          extraValues.EmplaceBack(utmMedium.value());
        }
        if (utmSource) {
          extraKeys.AppendElement()->AssignASCII("utm_source");
          extraValues.EmplaceBack(utmSource.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded at the end of the install flow, but only when the
     * source that originally triggered the add-on installation is "amo", "rtamo" or
     * "disco". The value of an event is the SHA256 hash of the addon_id. This event
     * was generated to correspond to the Legacy Telemetry event
     * addonsManager.install_stats#unknown.
   */
  constexpr impl::EventMetric<InstallStatsUnknownExtra> install_stats_unknown(4769);

  /**
   * generated from addons_manager.install_theme
   */
    struct InstallThemeExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.install#theme.
   */
  constexpr impl::EventMetric<InstallThemeExtra> install_theme(4770);

  /**
   * generated from addons_manager.install_unknown
   */
    struct InstallUnknownExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.install#unknown.
   */
  constexpr impl::EventMetric<InstallUnknownExtra> install_unknown(4771);

  /**
   * generated from addons_manager.sideload_prompt_dictionary
   */
    struct SideloadPromptDictionaryExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.sideload_prompt#dictionary.
   */
  constexpr impl::EventMetric<SideloadPromptDictionaryExtra> sideload_prompt_dictionary(4772);

  /**
   * generated from addons_manager.sideload_prompt_extension
   */
    struct SideloadPromptExtensionExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.sideload_prompt#extension.
   */
  constexpr impl::EventMetric<SideloadPromptExtensionExtra> sideload_prompt_extension(4773);

  /**
   * generated from addons_manager.sideload_prompt_locale
   */
    struct SideloadPromptLocaleExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.sideload_prompt#locale.
   */
  constexpr impl::EventMetric<SideloadPromptLocaleExtra> sideload_prompt_locale(4774);

  /**
   * generated from addons_manager.sideload_prompt_other
   */
    struct SideloadPromptOtherExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.sideload_prompt#other.
   */
  constexpr impl::EventMetric<SideloadPromptOtherExtra> sideload_prompt_other(4775);

  /**
   * generated from addons_manager.sideload_prompt_siteperm_deprecated
   */
    struct SideloadPromptSitepermDeprecatedExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.sideload_prompt#siteperm_deprecated.
   */
  constexpr impl::EventMetric<SideloadPromptSitepermDeprecatedExtra> sideload_prompt_siteperm_deprecated(4776);

  /**
   * generated from addons_manager.sideload_prompt_sitepermission
   */
    struct SideloadPromptSitepermissionExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.sideload_prompt#sitepermission.
   */
  constexpr impl::EventMetric<SideloadPromptSitepermissionExtra> sideload_prompt_sitepermission(4777);

  /**
   * generated from addons_manager.sideload_prompt_theme
   */
    struct SideloadPromptThemeExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.sideload_prompt#theme.
   */
  constexpr impl::EventMetric<SideloadPromptThemeExtra> sideload_prompt_theme(4778);

  /**
   * generated from addons_manager.sideload_prompt_unknown
   */
    struct SideloadPromptUnknownExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.sideload_prompt#unknown.
   */
  constexpr impl::EventMetric<SideloadPromptUnknownExtra> sideload_prompt_unknown(4779);

  /**
   * generated from addons_manager.uninstall_dictionary
   */
    struct UninstallDictionaryExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.uninstall#dictionary.
   */
  constexpr impl::EventMetric<UninstallDictionaryExtra> uninstall_dictionary(4780);

  /**
   * generated from addons_manager.uninstall_extension
   */
    struct UninstallExtensionExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.uninstall#extension.
   */
  constexpr impl::EventMetric<UninstallExtensionExtra> uninstall_extension(4781);

  /**
   * generated from addons_manager.uninstall_locale
   */
    struct UninstallLocaleExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.uninstall#locale.
   */
  constexpr impl::EventMetric<UninstallLocaleExtra> uninstall_locale(4782);

  /**
   * generated from addons_manager.uninstall_other
   */
    struct UninstallOtherExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.uninstall#other.
   */
  constexpr impl::EventMetric<UninstallOtherExtra> uninstall_other(4783);

  /**
   * generated from addons_manager.uninstall_siteperm_deprecated
   */
    struct UninstallSitepermDeprecatedExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.uninstall#siteperm_deprecated.
   */
  constexpr impl::EventMetric<UninstallSitepermDeprecatedExtra> uninstall_siteperm_deprecated(4784);

  /**
   * generated from addons_manager.uninstall_sitepermission
   */
    struct UninstallSitepermissionExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.uninstall#sitepermission.
   */
  constexpr impl::EventMetric<UninstallSitepermissionExtra> uninstall_sitepermission(4785);

  /**
   * generated from addons_manager.uninstall_theme
   */
    struct UninstallThemeExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.uninstall#theme.
   */
  constexpr impl::EventMetric<UninstallThemeExtra> uninstall_theme(4786);

  /**
   * generated from addons_manager.uninstall_unknown
   */
    struct UninstallUnknownExtra {
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled, the value of the event is the addon_id (which also
     * allow to correlate multiple events related to each other). This event was
     * generated to correspond to the Legacy Telemetry event
     * addonsManager.uninstall#unknown.
   */
  constexpr impl::EventMetric<UninstallUnknownExtra> uninstall_unknown(4787);

  /**
   * generated from addons_manager.update_dictionary
   */
    struct UpdateDictionaryExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.update#dictionary.
   */
  constexpr impl::EventMetric<UpdateDictionaryExtra> update_dictionary(4788);

  /**
   * generated from addons_manager.update_extension
   */
    struct UpdateExtensionExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.update#extension.
   */
  constexpr impl::EventMetric<UpdateExtensionExtra> update_extension(4789);

  /**
   * generated from addons_manager.update_locale
   */
    struct UpdateLocaleExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.update#locale.
   */
  constexpr impl::EventMetric<UpdateLocaleExtra> update_locale(4790);

  /**
   * generated from addons_manager.update_other
   */
    struct UpdateOtherExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.update#other.
   */
  constexpr impl::EventMetric<UpdateOtherExtra> update_other(4791);

  /**
   * generated from addons_manager.update_siteperm_deprecated
   */
    struct UpdateSitepermDeprecatedExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.update#siteperm_deprecated.
   */
  constexpr impl::EventMetric<UpdateSitepermDeprecatedExtra> update_siteperm_deprecated(4792);

  /**
   * generated from addons_manager.update_sitepermission
   */
    struct UpdateSitepermissionExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.update#sitepermission.
   */
  constexpr impl::EventMetric<UpdateSitepermissionExtra> update_sitepermission(4793);

  /**
   * generated from addons_manager.update_theme
   */
    struct UpdateThemeExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.update#theme.
   */
  constexpr impl::EventMetric<UpdateThemeExtra> update_theme(4794);

  /**
   * generated from addons_manager.update_unknown
   */
    struct UpdateUnknownExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<nsCString> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(downloadTime.value());
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(numStrings.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for extensions and
     * themes, the value of the event is an install_id shared by the events related to
     * the same install or update flow. This event was generated to correspond to the
     * Legacy Telemetry event addonsManager.update#unknown.
   */
  constexpr impl::EventMetric<UpdateUnknownExtra> update_unknown(4795);

}
namespace blocklist {
  /**
   * generated from blocklist.addon_block_change
   */
    struct AddonBlockChangeExtra {
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> hoursSince;
      mozilla::Maybe<nsCString> mlbfGeneration;
      mozilla::Maybe<nsCString> mlbfLastTime;
      mozilla::Maybe<nsCString> mlbfSoftblocksGeneration;
      mozilla::Maybe<nsCString> mlbfSoftblocksSource;
      mozilla::Maybe<nsCString> mlbfSource;
      mozilla::Maybe<nsCString> object;
      mozilla::Maybe<nsCString> signedDate;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (hoursSince) {
          extraKeys.AppendElement()->AssignASCII("hours_since");
          extraValues.EmplaceBack(hoursSince.value());
        }
        if (mlbfGeneration) {
          extraKeys.AppendElement()->AssignASCII("mlbf_generation");
          extraValues.EmplaceBack(mlbfGeneration.value());
        }
        if (mlbfLastTime) {
          extraKeys.AppendElement()->AssignASCII("mlbf_last_time");
          extraValues.EmplaceBack(mlbfLastTime.value());
        }
        if (mlbfSoftblocksGeneration) {
          extraKeys.AppendElement()->AssignASCII("mlbf_softblocks_generation");
          extraValues.EmplaceBack(mlbfSoftblocksGeneration.value());
        }
        if (mlbfSoftblocksSource) {
          extraKeys.AppendElement()->AssignASCII("mlbf_softblocks_source");
          extraValues.EmplaceBack(mlbfSoftblocksSource.value());
        }
        if (mlbfSource) {
          extraKeys.AppendElement()->AssignASCII("mlbf_source");
          extraValues.EmplaceBack(mlbfSource.value());
        }
        if (object) {
          extraKeys.AppendElement()->AssignASCII("object");
          extraValues.EmplaceBack(object.value());
        }
        if (signedDate) {
          extraKeys.AppendElement()->AssignASCII("signed_date");
          extraValues.EmplaceBack(signedDate.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * An add-on is blocked, or an installed add-on is unblocked. When an add-on
     * install/update is blocked, its installation is aborted and the add-on is no
     * longer listed in the activeAddons field of TelemetryEnvironment.
   */
  constexpr impl::EventMetric<AddonBlockChangeExtra> addon_block_change(4796);

  /**
   * generated from blocklist.last_modified_rs_addons_mblf
   */
  /**
   * Keep track of the last time the "addons-bloomfilters" remotesetting blocklist
     * has been successfully updated.
   */
  constexpr impl::DatetimeMetric last_modified_rs_addons_mblf(4797);

  /**
   * generated from blocklist.mlbf_generation_time
   */
  /**
   * Keep track of the generation time of the addon blocklist's bloom filter. This
     * marks the point in time until which signed add-ons are recognized by the
     * selected bloom filter from the addons-bloomfilters collection.
   */
  constexpr impl::DatetimeMetric mlbf_generation_time(4798);

  /**
   * generated from blocklist.mlbf_softblocks_generation_time
   */
  /**
   * Keep track of the generation time of the addon blocklist's bloom filter. This
     * marks the point in time until which signed add-ons are recognized by the
     * selected bloom filter from the addons-bloomfilters collection.
   */
  constexpr impl::DatetimeMetric mlbf_softblocks_generation_time(4799);

  /**
   * generated from blocklist.mlbf_softblocks_source
   */
  /**
   * The source of the RemoteSettings attachment that holds the bloom filter.
     * Possible values are "dump_match", "cache_match",
     * "remote_match","dump_fallback", "cache_fallback", "unknown". "dump_match",
     * "cache_match" and "remote_match" are expected known-good values, and means that
     * the loaded bloomfilter matches the blocklist record in the RemoteSettings
     * collection. The prefix denotes the immediate source of the loaded data: "dump"
     * means packaged with the application, "remote" means a freshly downloaded
     * bloomfilter, "cache" means a previously downloaded bloomfilter. "dump_fallback"
     * and "cache_fallback" means that the last known bloomfilter was used, despite it
     * not matching the latest record in the RemoteSettings collection. In this case
     * the outdated bloomfilter is used as a fallback (e.g. because the latest version
     * cannot be downloaded). "unknown"  means that the bloomfilter cannot be loaded
     * at all. This can happen if the blocklist is disabled via preferences or
     * enterprise policies.
   */
  constexpr impl::StringMetric mlbf_softblocks_source(4800);

  /**
   * generated from blocklist.mlbf_source
   */
  /**
   * The source of the RemoteSettings attachment that holds the bloom filter.
     * Possible values are "dump_match", "cache_match",
     * "remote_match","dump_fallback", "cache_fallback", "unknown". "dump_match",
     * "cache_match" and "remote_match" are expected known-good values, and means that
     * the loaded bloomfilter matches the blocklist record in the RemoteSettings
     * collection. The prefix denotes the immediate source of the loaded data: "dump"
     * means packaged with the application, "remote" means a freshly downloaded
     * bloomfilter, "cache" means a previously downloaded bloomfilter. "dump_fallback"
     * and "cache_fallback" means that the last known bloomfilter was used, despite it
     * not matching the latest record in the RemoteSettings collection. In this case
     * the outdated bloomfilter is used as a fallback (e.g. because the latest version
     * cannot be downloaded). "unknown"  means that the bloomfilter cannot be loaded
     * at all. This can happen if the blocklist is disabled via preferences or
     * enterprise policies.
   */
  constexpr impl::StringMetric mlbf_source(4801);

  /**
   * generated from blocklist.mlbf_stash_time_newest
   */
  /**
   * Keep track of the timestamp of the most recent stash of the addons blocklist.
   */
  constexpr impl::DatetimeMetric mlbf_stash_time_newest(4802);

  /**
   * generated from blocklist.mlbf_stash_time_oldest
   */
  /**
   * Keep track of the timestamp of the oldest stash of the addons blocklist.
   */
  constexpr impl::DatetimeMetric mlbf_stash_time_oldest(4803);

}
namespace update {
  /**
   * generated from update.auto_download
   */
  /**
   * Per-installation preference "app.update.auto": whether to fetch and install
     * updates without user intervention.
   */
  constexpr impl::BooleanMetric auto_download(4804);

  /**
   * generated from update.background_update
   */
  /**
   * Per-installation preference "app.update.background.enabled": whether to fetch
     * and install updates in the background when Firefox is not running.
   */
  constexpr impl::BooleanMetric background_update(4805);

  /**
   * generated from update.bitshresult
   */
  /**
   * If a BITS download fails on the Windows side (that is to say, BITS ecounters an
     * error rather than Firefox failing to interact with BITS), it will likely give
     * an hresult error indicating what happened. This probe reports those error codes
     * to allow us to see if BITS is commonly failing on some systems. This probe is
     * keyed on the type of update download, either "PARTIAL" or "COMPLETE". This
     * metric was generated to correspond to the Legacy Telemetry scalar
     * update.bitshresult.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> bitshresult(4806);

  /**
   * generated from update.can_usually_apply_updates
   */
  /**
   * Whether or not the Update Service can usually download and install updates. See
     * `canUsuallyApplyUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
   */
  constexpr impl::BooleanMetric can_usually_apply_updates(4807);

  /**
   * generated from update.can_usually_check_for_updates
   */
  /**
   * Whether or not the Update Service can usually check for updates. See
     * `canUsuallyCheckForUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
   */
  constexpr impl::BooleanMetric can_usually_check_for_updates(4808);

  /**
   * generated from update.can_usually_stage_updates
   */
  /**
   * Whether the Update Service is usually able to stage updates. See
     * `canUsuallyStageUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
   */
  constexpr impl::BooleanMetric can_usually_stage_updates(4809);

  /**
   * generated from update.can_usually_use_bits
   */
  /**
   * On Windows, whether the Update Service can usually use BITS. See
     * `canUsuallyUseBits` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
   */
  constexpr impl::BooleanMetric can_usually_use_bits(4810);

  /**
   * generated from update.channel
   */
  /**
   * The update channel.
   */
  constexpr impl::StringMetric channel(4811);

  /**
   * generated from update.enabled
   */
  /**
   * True when policies are disabled or when the "DisableAppUpdate" is not in
     * effect.
   */
  constexpr impl::BooleanMetric enabled(4812);

  /**
   * generated from update.move_result
   */
  /**
   * Firefox keeps downloading updates in a different place from updates that are
     * ready to install. Once the download completes, the resulting file has to be
     * moved from the downloading update directory to the ready update directory. This
     * probe counts the results that we get when attempting to perform this file move.
     * Valid values for the keys for this probe are stored in the MOVE_RESULT_* values
     * in UpdateTelemetry.sys.mjs. This metric was generated to correspond to the
     * Legacy Telemetry scalar update.move_result.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> move_result(4813);

  /**
   * generated from update.no_window_auto_restarts
   */
  /**
   * On macOS, all browser windows can be closed without exiting Firefox. If there
     * is an update pending in that case, and we can install it silently, we restart
     * automatically in order to do so. This probe counts the number of times the
     * browser restarts to silently install a pending update. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * update.no_window_auto_restarts.
   */
  constexpr impl::CounterMetric no_window_auto_restarts(4814);

  /**
   * generated from update.service_enabled
   */
  /**
   * Preference "app.update.service.enabled": whether the Mozilla Maintenance
     * Service is enabled.
   */
  constexpr impl::BooleanMetric service_enabled(4815);

  /**
   * generated from update.skip_startup_update_reason
   */
  enum class SkipStartupUpdateReasonLabel: uint16_t {
      eNone = 0,
      eDevtoolslaunching = 1,
      eNotanupdatingtask = 2,
      eOtherinstancerunning = 3,
      eFirststartup = 4,
      eMultisessioninstalllockout = 5,
      e__Other__,
    };
  /**
   * We usually install pending updates at startup, but there are a couple of
     * reasons we might not. This value will be set to "none" if there was no reason
     * not to install updates. If the value is "DevToolsLaunching", that means that we
     * skipped applying updates because the application startup was actually a startup
     * of the Browser Toolbox, not the browser itself. If the value is
     * "NotAnUpdatingTask", that means that the browser launch is a background task
     * other than the background update task, (which have update capabilities
     * disabled). If the value is "OtherInstanceRunning", that means that the
     * background update task was launched, but it didn't install an update in order
     * to avoid interfering with other application instances. If the value is
     * "FirstStartup", we didn't install any updates because the browser was launched
     * by the installer. If the value is "MultiSessionInstallLockout", there are other
     * browser instances running and the Multi Session Install Lockout timeout has not
     * expired yet. Note that, for updates to be installed, the browser launches, sees
     * the update, runs the updater, and exits. The updater then relaunches the
     * browser when it completes. Naturally, the first launch is what decides if the
     * update should be installed. But, if we are installing an update, the browser
     * exits too early to send telemetry so it isn't sent until the second launch. It
     * may be technically possible (though very unlikely) for the value sent on the
     * second launch to not be "none".
   */
  constexpr impl::Labeled<impl::CounterMetric, SkipStartupUpdateReasonLabel> skip_startup_update_reason(4816);

  /**
   * generated from update.suppress_prompts
   */
  /**
   * When an update is available and app.update.auto is disabled, a popup is opened
     * prompting the user to download and install the update. The pref
     * app.update.suppressPrompts causes Firefox Nightly to wait up to 7 days before
     * showing the prompt, instead showing a badge and banner in the meantime. It also
     * prevents Nightly from showing update restart prompts, instead showing a badge
     * and banner immediately. This value is set for the users who set this pref to
     * true. This metric was generated to correspond to the Legacy Telemetry scalar
     * update.suppress_prompts.
   */
  constexpr impl::BooleanMetric suppress_prompts(4817);

  /**
   * generated from update.version_pin
   */
  /**
   * The AppUpdatePin Enterprise Policy controls the maximum version that the
     * browser can update to. If the policy is set, this probe will report the
     * policy's value. The possible policy values are "X." and "X.Y.", where X is the
     * pinned major version and Y is the pinned minor version. This metric was
     * generated to correspond to the Legacy Telemetry scalar update.version_pin.
   */
  constexpr impl::StringMetric version_pin(4818);

}
namespace gecko {
  /**
   * generated from gecko.build_id
   */
  /**
   * The Buildid of the Gecko engine, example: 20200205124310 (Migrated from the
     * geckoview metric of the same name).
   */
  constexpr impl::StringMetric build_id(4819);

  /**
   * generated from gecko.version
   */
  /**
   * The version of the Gecko engine, example: 74.0a1 (Migrated from the geckoview
     * metric of the same name).
   */
  constexpr impl::StringMetric version(4820);

}
namespace widget {
  /**
   * generated from widget.ime_name_on_mac
   */
  /**
   * Name of IME which was selected by users on macOS.  The value is Input Source ID
     * if non-Japanese IME was open.  Otherwise, if Japanese IME was open, the value
     * is Bundle ID.  Input Source ID includes input mode, but Bundle ID does not
     * include input mode. This metric was generated to correspond to the Legacy
     * Telemetry scalar widget.ime_name_on_mac.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> ime_name_on_mac(4821);

  /**
   * generated from widget.gtk_version
   */
  /**
   * The version of Gtk 3 in use. This metric was generated to correspond to the
     * Legacy Telemetry scalar widget.gtk_version.
   */
  constexpr impl::StringMetric gtk_version(4822);

  /**
   * generated from widget.ime_name_on_linux
   */
  /**
   * Name of active IM (e.g., xim, fcitx, ibus, etc) which was actually set by env
     * on Linux.  Different from Windows and macOS, this value includes non-IME users
     * even though this is recoded when first compositionstart event because dead key
     * is also implemented by IME on Linux. This metric was generated to correspond to
     * the Legacy Telemetry scalar widget.ime_name_on_linux.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> ime_name_on_linux(4823);

  /**
   * generated from widget.dark_mode
   */
  /**
   * Whether the OS theme is dark. This metric was generated to correspond to the
     * Legacy Telemetry scalar widget.dark_mode.
   */
  constexpr impl::BooleanMetric dark_mode(4824);

  /**
   * generated from widget.pointing_devices
   */
  enum class PointingDevicesLabel: uint16_t {
      eMouse = 0,
      eTouch = 1,
      ePen = 2,
      e__Other__,
    };
  /**
   * Whether the system has any matching pointing device for each label.
   */
  constexpr impl::Labeled<impl::BooleanMetric, PointingDevicesLabel> pointing_devices(4825);

  /**
   * generated from widget.ime_name_on_windows
   */
  /**
   * Locale ID and name of IME which was selected by users on Windows. This does NOT
     * collect legacy IMM-IME names since we cannot get readable names and we do not
     * support IMM-IME so aggressively because IME vendors should've already released
     * TIP for TSF for supporting Windows 8 or later completely. This metric was
     * generated to correspond to the Legacy Telemetry scalar
     * widget.ime_name_on_windows.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> ime_name_on_windows(4826);

  /**
   * generated from widget.ime_name_on_windows_inserted_crlf
   */
  /**
   * Same data as ime_name_on_windows, but only collecting IME names which inserted
     * CRLF to check whether the feature works. This metric was generated to
     * correspond to the Legacy Telemetry scalar
     * widget.ime_name_on_windows_inserted_crlf.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> ime_name_on_windows_inserted_crlf(4827);

}
namespace memory_watcher {
  /**
   * generated from memory_watcher.on_high_memory_stats
   */
    struct OnHighMemoryStatsExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This event is recorded when the memory situation is no longer low. The "stats"
     * object consists of three numbers comma-delimited: 1) how many times a tab was
     * unloaded 2) how many memory-pressure events were dispatched 3) how long we were
     * in the low-memory situation in seconds This event was generated to correspond
     * to the Legacy Telemetry event memory_watcher.on_high_memory#stats.
   */
  constexpr impl::EventMetric<OnHighMemoryStatsExtra> on_high_memory_stats(4828);

}
namespace timer_thread {
  /**
   * generated from timer_thread.timers_fired_per_wakeup
   */
  /**
   * How many timers were processed in a single wake-up of the Timer Thread.
   */
  constexpr impl::CustomDistributionMetric timers_fired_per_wakeup(4829);

}

} // namespace mozilla::glean

#endif // mozilla_Metrics_h
